/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/base/common/async","vs/base/common/path","vs/base/common/errors","vs/base/common/arrays","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/platform/log/common/log","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/platform","vs/base/common/map","vs/base/common/objects","vs/base/common/resources","vs/base/common/buffer","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/extpath","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/json","vs/base/common/linkedList","vs/base/common/process","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/uint","vs/base/common/htmlContent","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/mime","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/commands/common/commands","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/theme/common/iconRegistry","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/views","vs/workbench/api/common/apiCommands","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(X){for(var e=[],p=0,R=X.length;p<R;p++)e[p]=be[X[p]];return e};define(be[42],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,D){if(!R)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(be[52],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function R(i){const I=[];for(let d in i)p.call(i,d)&&I.push(i[d]);return I}e.values=R;function D(i,I){for(let d in i)if(p.call(i,d)&&I({key:d,value:i[d]},function(){delete i[d]})===!1)return}e.forEach=D;function T(i,I){const d=Object.create(null);for(const g of i){const o=I(g);let a=d[o];a||(a=d[o]=[]),a.push(g)}return d}e.groupBy=T;function _(i){const I=Object.create(null);return i&&i.forEach((d,g)=>{I[g]=d}),I}e.fromMap=_;function S(i,I){const d=[],g=[];for(let o of i)I.has(o)||d.push(o);for(let o of I)i.has(o)||g.push(o);return{removed:d,added:g}}e.diffSets=S;function E(i,I){const d=[],g=[];for(let[o,a]of i)I.has(o)||d.push(a);for(let[o,a]of I)i.has(o)||g.push(a);return{removed:d,added:g}}e.diffMaps=E;class k{constructor(){this.map=new Map}add(I,d){let g=this.map.get(I);g||(g=new Set,this.map.set(I,g)),g.add(d)}delete(I,d){const g=this.map.get(I);!g||(g.delete(d),g.size===0&&this.map.delete(I))}forEach(I,d){const g=this.map.get(I);!g||g.forEach(d)}}e.SetMap=k}),define(be[53],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(_){return(S,E,k)=>{let i=null,I=null;if(typeof k.value=="function"?(i="value",I=k.value):typeof k.get=="function"&&(i="get",I=k.get),!I)throw new Error("not supported");k[i]=_(I,E)}}e.createDecorator=p;function R(_,S,E){let k=null,i=null;if(typeof E.value=="function"?(k="value",i=E.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(k="get",i=E.get),!i)throw new Error("not supported");const I=`$memoize$${S}`;E[k]=function(...d){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,d)}),this[I]}}e.memoize=R;function D(_,S,E){return p((k,i)=>{const I=`$debounce$${i}`,d=`$debounce$result$${i}`;return function(...g){this[d]||(this[d]=E?E():void 0),clearTimeout(this[I]),S&&(this[d]=S(this[d],...g),g=[this[d]]),this[I]=setTimeout(()=>{k.apply(this,g),this[d]=E?E():void 0},_)}})}e.debounce=D;function T(_,S,E){return p((k,i)=>{const I=`$throttle$timer$${i}`,d=`$throttle$result$${i}`,g=`$throttle$lastRun$${i}`,o=`$throttle$pending$${i}`;return function(...a){if(this[d]||(this[d]=E?E():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),S&&(this[d]=S(this[d],...a)),this[o])return;const w=this[g]+_;w<=Date.now()?(this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=E?E():void 0):(this[o]=!0,this[I]=setTimeout(()=>{this[o]=!1,this[g]=Date.now(),k.apply(this,[this[d]]),this[d]=E?E():void 0},w-Date.now()))}})}e.throttle=T}),define(be[13],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(n=>{n(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function R(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=R;function D(h){E(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=D;function T(h){E(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=T;function _(h){if(h instanceof Error){let{name:t,message:n}=h;const r=h.stacktrace||h.stack;return{$isError:!0,name:t,message:n,stack:r}}return h}e.transformErrorForSerialization=_;const S="Canceled";function E(h){return h instanceof Error&&h.name===S&&h.message===S}e.isPromiseCanceledError=E;class k extends Error{constructor(){super(S);this.name=this.message}}e.CancellationError=k;function i(){const h=new Error(S);return h.name=h.message,h}e.canceled=i;function I(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=I;function d(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=d;function g(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function o(h){const t=new Error(`${h} has been disposed`);return t.name="DISPOSED",t}e.disposed=o;function a(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=a;class w extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=w;class f extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=f;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function l(h){const t=h;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function m(h,t=Object.create(null)){const n=new Error(h);return t.actions&&(n.actions=t.actions),n}e.createErrorWithActions=m}),define(be[14],_e([0,1,13]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(x,A=0){return x[x.length-(1+A)]}e.tail=R;function D(x){if(x.length===0)throw new Error("Invalid tail call");return[x.slice(0,x.length-1),x[x.length-1]]}e.tail2=D;function T(x,A,U=(M,$)=>M===$){if(x===A)return!0;if(!x||!A||x.length!==A.length)return!1;for(let M=0,$=x.length;M<$;M++)if(!U(x[M],A[M]))return!1;return!0}e.equals=T;function _(x,A,U){let M=0,$=x.length-1;for(;M<=$;){const K=(M+$)/2|0,j=U(x[K],A);if(j<0)M=K+1;else if(j>0)$=K-1;else return K}return-(M+1)}e.binarySearch=_;function S(x,A){let U=0,M=x.length;if(M===0)return 0;for(;U<M;){const $=Math.floor((U+M)/2);A(x[$])?M=$:U=$+1}return U}e.findFirstInSorted=S;function E(x,A,U){if(x=x|0,x>=A.length)throw new TypeError("invalid index");let M=A[Math.floor(A.length*Math.random())],$=[],K=[],j=[];for(let ae of A){const we=U(ae,M);we<0?$.push(ae):we>0?K.push(ae):j.push(ae)}return x<$.length?E(x,$,U):x<$.length+j.length?j[0]:E(x-($.length+j.length),K,U)}e.quickSelect=E;function k(x,A){const U=[];let M;for(const $ of x.slice(0).sort(A))!M||A(M[0],$)!==0?(M=[$],U.push(M)):M.push($);return U}e.groupBy=k;function i(x,A,U){const M=[];function $(ae,we,Re){if(we===0&&Re.length===0)return;const xe=M[M.length-1];xe&&xe.start+xe.deleteCount===ae?(xe.deleteCount+=we,xe.toInsert.push(...Re)):M.push({start:ae,deleteCount:we,toInsert:Re})}let K=0,j=0;for(;;){if(K===x.length){$(K,0,A.slice(j));break}if(j===A.length){$(K,x.length-K,[]);break}const ae=x[K],we=A[j],Re=U(ae,we);Re===0?(K+=1,j+=1):Re<0?($(K,1,[]),K+=1):Re>0&&($(K,0,[we]),j+=1)}return M}e.sortedDiff=i;function I(x,A,U){const M=i(x,A,U),$=[],K=[];for(const j of M)$.push(...x.slice(j.start,j.start+j.deleteCount)),K.push(...j.toInsert);return{removed:$,added:K}}e.delta=I;function d(x,A,U){if(U===0)return[];const M=x.slice(0,U).sort(A);return o(x,A,M,U,x.length),M}e.top=d;function g(x,A,U,M,$){return U===0?Promise.resolve([]):new Promise((K,j)=>{(async()=>{const ae=x.length,we=x.slice(0,U).sort(A);for(let Re=U,xe=Math.min(U+M,ae);Re<ae;Re=xe,xe=Math.min(xe+M,ae)){if(Re>U&&await new Promise(Le=>setTimeout(Le)),$&&$.isCancellationRequested)throw(0,p.canceled)();o(x,A,we,Re,xe)}return we})().then(K,j)})}e.topAsync=g;function o(x,A,U,M,$){for(const K=U.length;M<$;M++){const j=x[M];if(A(j,U[K-1])<0){U.pop();const ae=S(U,we=>A(j,we)<0);U.splice(ae,0,j)}}}function a(x){return x.filter(A=>!!A)}e.coalesce=a;function w(x){let A=0;for(let U=0;U<x.length;U++)x[U]&&(x[A]=x[U],A+=1);x.length=A}e.coalesceInPlace=w;function f(x,A,U){x.splice(U,0,x.splice(A,1)[0])}e.move=f;function y(x){return!Array.isArray(x)||x.length===0}e.isFalsyOrEmpty=y;function l(x){return Array.isArray(x)&&x.length>0}e.isNonEmptyArray=l;function m(x,A){if(!A)return x.filter((M,$)=>x.indexOf(M)===$);const U=Object.create(null);return x.filter(M=>{const $=A(M);return U[$]?!1:(U[$]=!0,!0)})}e.distinct=m;function h(x){const A=new Set;return x.filter(U=>A.has(U)?!1:(A.add(U),!0))}e.distinctES6=h;function t(x){const A=Object.create(null);return U=>{const M=x(U);return A[M]?!1:(A[M]=!0,!0)}}e.uniqueFilter=t;function n(x,A){for(let U=x.length-1;U>=0;U--){const M=x[U];if(A(M))return U}return-1}e.lastIndex=n;function r(x,A){return x.length>0?x[0]:A}e.firstOrDefault=r;function s(x,A,U=(M,$)=>M===$){let M=0;for(let $=0,K=Math.min(x.length,A.length);$<K&&U(x[$],A[$]);$++)M++;return M}e.commonPrefixLength=s;function u(x){return[].concat(...x)}e.flatten=u;function v(x,A){let U=typeof A=="number"?x:0;typeof A=="number"?U=x:(U=0,A=x);const M=[];if(U<=A)for(let $=U;$<A;$++)M.push($);else for(let $=U;$>A;$--)M.push($);return M}e.range=v;function b(x,A,U){return x.reduce((M,$)=>(M[A($)]=U?U($):$,M),Object.create(null))}e.index=b;function P(x,A){return x.push(A),()=>C(x,A)}e.insert=P;function C(x,A){const U=x.indexOf(A);if(U>-1)return x.splice(U,1),A}e.remove=C;function c(x,A,U){const M=x.slice(0,A),$=x.slice(A);return M.concat(U,$)}e.arrayInsert=c;function F(x,A){let U;if(typeof A=="number"){let M=A;U=()=>{const $=Math.sin(M++)*179426549;return $-Math.floor($)}}else U=Math.random;for(let M=x.length-1;M>0;M-=1){const $=Math.floor(U()*(M+1)),K=x[M];x[M]=x[$],x[$]=K}}e.shuffle=F;function N(x,A){const U=x.indexOf(A);U>-1&&(x.splice(U,1),x.unshift(A))}e.pushToStart=N;function z(x,A){const U=x.indexOf(A);U>-1&&(x.splice(U,1),x.push(A))}e.pushToEnd=z;function he(x,A){return Array.isArray(x)?x.map(A):A(x)}e.mapArrayOrNot=he;function me(x){return Array.isArray(x)?x:[x]}e.asArray=me;function Q(x){return x[Math.floor(Math.random()*x.length)]}e.getRandomElement=Q;function W(x,A){for(const U of x){const M=A(U);if(M!==void 0)return M}}e.mapFind=W}),define(be[54],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const D=this;let T=!1,_;return function(){return T||(T=!0,_=R.apply(D,arguments)),_}}e.once=p}),define(be[55],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(D){this._prefix=D,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(be[43],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function D(h){return h&&typeof h=="object"&&typeof h[Symbol.iterator]=="function"}R.is=D;const T=Object.freeze([]);function _(){return T}R.empty=_;function*S(h){yield h}R.single=S;function E(h){return h||T}R.from=E;function k(h){return!h||h[Symbol.iterator]().next().done===!0}R.isEmpty=k;function i(h){return h[Symbol.iterator]().next().value}R.first=i;function I(h,t){for(const n of h)if(t(n))return!0;return!1}R.some=I;function d(h,t){for(const n of h)if(t(n))return n}R.find=d;function*g(h,t){for(const n of h)t(n)&&(yield n)}R.filter=g;function*o(h,t){let n=0;for(const r of h)yield t(r,n++)}R.map=o;function*a(...h){for(const t of h)for(const n of t)yield n}R.concat=a;function*w(h){for(const t of h)for(const n of t)yield n}R.concatNested=w;function f(h,t,n){let r=n;for(const s of h)r=t(r,s);return r}R.reduce=f;function*y(h,t,n=h.length){for(t<0&&(t+=h.length),n<0?n+=h.length:n>h.length&&(n=h.length);t<n;t++)yield h[t]}R.slice=y;function l(h,t=Number.POSITIVE_INFINITY){const n=[];if(t===0)return[n,h];const r=h[Symbol.iterator]();for(let s=0;s<t;s++){const u=r.next();if(u.done)return[n,R.empty()];n.push(u.value)}return[n,{[Symbol.iterator](){return r}}]}R.consume=l;function m(h,t,n=(r,s)=>r===s){const r=h[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=r.next(),v=s.next();if(u.done!==v.done)return!1;if(u.done)return!0;if(!n(u.value,v.value))return!1}}R.equals=m})(p=e.Iterable||(e.Iterable={}))}),define(be[44],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(t){t.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function _(t,n=!1){let r=0,s=t.length,u="",v=0,b=16,P=0;function C(Q){let W=0,x=0;for(;W<Q;){const A=t.charCodeAt(r);if(A>=48&&A<=57)x=x*16+A-48;else if(A>=65&&A<=70)x=x*16+A-65+10;else if(A>=97&&A<=102)x=x*16+A-97+10;else break;r++,W++}return W<Q&&(x=-1),x}function c(Q){r=Q,u="",v=0,b=16,P=0}function F(){const Q=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&k(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&k(t.charCodeAt(r)))for(r++;r<t.length&&k(t.charCodeAt(r));)r++;else return P=3,t.substring(Q,r);let W=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&k(t.charCodeAt(r))){for(r++;r<t.length&&k(t.charCodeAt(r));)r++;W=r}else P=3;return t.substring(Q,W)}function N(){let Q="",W=r;for(;;){if(r>=s){Q+=t.substring(W,r),P=2;break}const x=t.charCodeAt(r);if(x===34){Q+=t.substring(W,r),r++;break}if(x===92){if(Q+=t.substring(W,r),r++,r>=s){P=2;break}switch(t.charCodeAt(r++)){case 34:Q+='"';break;case 92:Q+="\\";break;case 47:Q+="/";break;case 98:Q+="\b";break;case 102:Q+="\f";break;case 110:Q+=`
`;break;case 114:Q+="\r";break;case 116:Q+="	";break;case 117:const U=C(4);U>=0?Q+=String.fromCharCode(U):P=4;break;default:P=5}W=r;continue}if(x>=0&&x<=31)if(E(x)){Q+=t.substring(W,r),P=2;break}else P=6;r++}return Q}function z(){if(u="",P=0,v=r,r>=s)return v=s,b=17;let Q=t.charCodeAt(r);if(S(Q)){do r++,u+=String.fromCharCode(Q),Q=t.charCodeAt(r);while(S(Q));return b=15}if(E(Q))return r++,u+=String.fromCharCode(Q),Q===13&&t.charCodeAt(r)===10&&(r++,u+=`
`),b=14;switch(Q){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,u=N(),b=10;case 47:const W=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<s&&!E(t.charCodeAt(r));)r++;return u=t.substring(W,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const x=s-1;let A=!1;for(;r<x;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,A=!0;break}r++}return A||(r++,P=1),u=t.substring(W,r),b=13}return u+=String.fromCharCode(Q),r++,b=16;case 45:if(u+=String.fromCharCode(Q),r++,r===s||!k(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=F(),b=11;default:for(;r<s&&he(Q);)r++,Q=t.charCodeAt(r);if(v!==r){switch(u=t.substring(v,r),u){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return u+=String.fromCharCode(Q),r++,b=16}}function he(Q){if(S(Q)||E(Q))return!1;switch(Q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function me(){let Q;do Q=z();while(Q>=12&&Q<=15);return Q}return{setPosition:c,getPosition:()=>r,scan:n?me:z,getToken:()=>b,getTokenValue:()=>u,getTokenOffset:()=>v,getTokenLength:()=>r-v,getTokenError:()=>P}}e.createScanner=_;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function E(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var i;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(i||(i={}));function I(t,n){const r=[],s=new Object;let u;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function P(C,c,F,N){v.value=C,v.offset=c,v.length=F,v.type=N,v.colonOffset=void 0,u=v}try{l(t,{onObjectBegin:(C,c)=>{if(n<=C)throw s;u=void 0,b=n>C,r.push("")},onObjectProperty:(C,c,F)=>{if(n<c||(P(C,c,F,"property"),r[r.length-1]=C,n<=c+F))throw s},onObjectEnd:(C,c)=>{if(n<=C)throw s;u=void 0,r.pop()},onArrayBegin:(C,c)=>{if(n<=C)throw s;u=void 0,r.push(0)},onArrayEnd:(C,c)=>{if(n<=C)throw s;u=void 0,r.pop()},onLiteralValue:(C,c,F)=>{if(n<c||(P(C,c,F,h(C)),n<=c+F))throw s},onSeparator:(C,c,F)=>{if(n<=c)throw s;if(C===":"&&u&&u.type==="property")u.colonOffset=c,b=!1,u=void 0;else if(C===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(b=!0,r[r.length-1]=""),u=void 0}}})}catch(C){if(C!==s)throw C}return{path:r,previousNode:u,isAtPropertyKey:b,matches:C=>{let c=0;for(let F=0;c<C.length&&F<r.length;F++)if(C[c]===r[F]||C[c]==="*")c++;else if(C[c]!=="**")return!1;return c===C.length}}}e.getLocation=I;function d(t,n=[],r=T.DEFAULT){let s=null,u=[];const v=[];function b(C){Array.isArray(u)?u.push(C):s!==null&&(u[s]=C)}return l(t,{onObjectBegin:()=>{const C={};b(C),v.push(u),u=C,s=null},onObjectProperty:C=>{s=C},onObjectEnd:()=>{u=v.pop()},onArrayBegin:()=>{const C=[];b(C),v.push(u),u=C,s=null},onArrayEnd:()=>{u=v.pop()},onLiteralValue:b,onError:(C,c,F)=>{n.push({error:C,offset:c,length:F})}},r),u[0]}e.parse=d;function g(t,n=[],r=T.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(C){s.type==="property"&&(s.length=C-s.offset,s=s.parent)}function v(C){return s.children.push(C),C}l(t,{onObjectBegin:C=>{s=v({type:"object",offset:C,length:-1,parent:s,children:[]})},onObjectProperty:(C,c,F)=>{s=v({type:"property",offset:c,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:C,offset:c,length:F,parent:s})},onObjectEnd:(C,c)=>{s.length=C+c-s.offset,s=s.parent,u(C+c)},onArrayBegin:(C,c)=>{s=v({type:"array",offset:C,length:-1,parent:s,children:[]})},onArrayEnd:(C,c)=>{s.length=C+c-s.offset,s=s.parent,u(C+c)},onLiteralValue:(C,c,F)=>{v({type:h(C),offset:c,length:F,parent:s,value:C}),u(c+F)},onSeparator:(C,c,F)=>{s.type==="property"&&(C===":"?s.colonOffset=c:C===","&&u(c))},onError:(C,c,F)=>{n.push({error:C,offset:c,length:F})}},r);const P=s.children[0];return P&&delete P.parent,P}e.parseTree=g;function o(t,n){if(!t)return;let r=t;for(let s of n)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const v of r.children)if(Array.isArray(v.children)&&v.children[0].value===s){r=v.children[1],u=!0;break}if(!u)return}else{const u=s;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=o;function a(t){if(!t.parent||!t.parent.children)return[];const n=a(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;n.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&n.push(r)}return n}e.getNodePath=a;function w(t){switch(t.type){case"array":return t.children.map(w);case"object":const n=Object.create(null);for(let r of t.children){const s=r.children[1];s&&(n[r.children[0].value]=w(s))}return n;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=w;function f(t,n,r=!1){return n>=t.offset&&n<t.offset+t.length||r&&n===t.offset+t.length}e.contains=f;function y(t,n,r=!1){if(f(t,n,r)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=n;u++){const v=y(s[u],n,r);if(v)return v}return t}}e.findNodeAtOffset=y;function l(t,n,r=T.DEFAULT){const s=_(t,!1);function u(we){return we?()=>we(s.getTokenOffset(),s.getTokenLength()):()=>!0}function v(we){return we?Re=>we(Re,s.getTokenOffset(),s.getTokenLength()):()=>!0}const b=u(n.onObjectBegin),P=v(n.onObjectProperty),C=u(n.onObjectEnd),c=u(n.onArrayBegin),F=u(n.onArrayEnd),N=v(n.onLiteralValue),z=v(n.onSeparator),he=u(n.onComment),me=v(n.onError),Q=r&&r.disallowComments,W=r&&r.allowTrailingComma;function x(){for(;;){const we=s.scan();switch(s.getTokenError()){case 4:A(14);break;case 5:A(15);break;case 3:A(13);break;case 1:Q||A(11);break;case 2:A(12);break;case 6:A(16);break}switch(we){case 12:case 13:Q?A(10):he();break;case 16:A(1);break;case 15:case 14:break;default:return we}}}function A(we,Re=[],xe=[]){if(me(we),Re.length+xe.length>0){let Le=s.getToken();for(;Le!==17;){if(Re.indexOf(Le)!==-1){x();break}else if(xe.indexOf(Le)!==-1)break;Le=x()}}}function U(we){const Re=s.getTokenValue();return we?N(Re):P(Re),x(),!0}function M(){switch(s.getToken()){case 11:let we=0;try{we=JSON.parse(s.getTokenValue()),typeof we!="number"&&(A(2),we=0)}catch(Re){A(2)}N(we);break;case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return x(),!0}function $(){return s.getToken()!==10?(A(3,[],[2,5]),!1):(U(!1),s.getToken()===6?(z(":"),x(),ae()||A(4,[],[2,5])):A(5,[],[2,5]),!0)}function K(){b(),x();let we=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(we||A(4,[],[]),z(","),x(),s.getToken()===2&&W)break}else we&&A(6,[],[]);$()||A(4,[],[2,5]),we=!0}return C(),s.getToken()!==2?A(7,[2],[]):x(),!0}function j(){c(),x();let we=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(we||A(4,[],[]),z(","),x(),s.getToken()===4&&W)break}else we&&A(6,[],[]);ae()||A(4,[],[4,5]),we=!0}return F(),s.getToken()!==4?A(8,[4],[]):x(),!0}function ae(){switch(s.getToken()){case 3:return j();case 1:return K();case 10:return U(!0);default:return M()}}return x(),s.getToken()===17?r.allowEmptyContent?!0:(A(4,[],[]),!1):ae()?(s.getToken()!==17&&A(9,[],[]),!0):(A(4,[],[]),!1)}e.visit=l;function m(t,n){let r=_(t),s=[],u,v=0,b;do switch(b=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:v!==b&&s.push(t.substring(v,b)),n!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,n)),v=r.getPosition();break}while(u!==17);return s.join("")}e.stripComments=m;function h(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(be[108],_e([0,1,44]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(E,k,i){let I,d,g,o,a;if(k){for(o=k.offset,a=o+k.length,g=o;g>0&&!S(E,g-1);)g--;let v=a;for(;v<E.length&&!S(E,v);)v++;d=E.substring(g,v),I=T(d,i)}else d=E,I=0,g=0,o=0,a=E.length;const w=_(i,E);let f=!1,y=0,l;i.insertSpaces?l=D(" ",i.tabSize||4):l="	";const m=(0,p.createScanner)(d,!1);let h=!1;function t(){return w+D(l,I+y)}function n(){let v=m.scan();for(f=!1;v===15||v===14;)f=f||v===14,v=m.scan();return h=v===16||m.getTokenError()!==0,v}const r=[];function s(v,b,P){!h&&b<a&&P>o&&E.substring(b,P)!==v&&r.push({offset:b,length:P-b,content:v})}let u=n();if(u!==17){const v=m.getTokenOffset()+g,b=D(l,I);s(b,g,v)}for(;u!==17;){let v=m.getTokenOffset()+m.getTokenLength()+g,b=n(),P="";for(;!f&&(b===12||b===13);){const c=m.getTokenOffset()+g;s(" ",v,c),v=m.getTokenOffset()+m.getTokenLength()+g,P=b===12?t():"",b=n()}if(b===2)u!==1&&(y--,P=t());else if(b===4)u!==3&&(y--,P=t());else{switch(u){case 3:case 1:y++,P=t();break;case 5:case 12:P=t();break;case 13:f?P=t():P=" ";break;case 6:P=" ";break;case 10:if(b===6){P="";break}case 7:case 8:case 9:case 11:case 2:case 4:b===12||b===13?P=" ":b!==5&&b!==17&&(h=!0);break;case 16:h=!0;break}f&&(b===12||b===13)&&(P=t())}const C=m.getTokenOffset()+g;s(P,v,C),u=b}return r}e.format=R;function D(E,k){let i="";for(let I=0;I<k;I++)i+=E;return i}function T(E,k){let i=0,I=0;const d=k.tabSize||4;for(;i<E.length;){const g=E.charAt(i);if(g===" ")I++;else if(g==="	")I+=d;else break;i++}return Math.floor(I/d)}function _(E,k){for(let i=0;i<k.length;i++){const I=k.charAt(i);if(I==="\r")return i+1<k.length&&k.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return E&&E.eol||`
`}e.getEOL=_;function S(E,k){return`\r
`.indexOf(E.charAt(k))!==-1}e.isEOL=S}),define(be[109],_e([0,1,44,108]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(k,i,I){return T(k,i,void 0,I)}e.removeProperty=D;function T(k,i,I,d,g){const o=i.slice(),a=[],w=(0,p.parseTree)(k,a);let f,y;for(;o.length>0&&(y=o.pop(),f=(0,p.findNodeAtLocation)(w,o),f===void 0&&I!==void 0);)typeof y=="string"?I={[y]:I}:I=[I];if(f)if(f.type==="object"&&typeof y=="string"&&Array.isArray(f.children)){const l=(0,p.findNodeAtLocation)(f,[y]);if(l!==void 0)if(I===void 0){if(!l.parent)throw new Error("Malformed AST");const m=f.children.indexOf(l.parent);let h,t=l.parent.offset+l.parent.length;if(m>0){const n=f.children[m-1];h=n.offset+n.length}else h=f.offset+1,f.children.length>1&&(t=f.children[1].offset);return _(k,{offset:h,length:t-h,content:""},d)}else return _(k,{offset:l.offset,length:l.length,content:JSON.stringify(I)},d);else{if(I===void 0)return[];const m=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,h=g?g(f.children.map(n=>n.children[0].value)):f.children.length;let t;if(h>0){const n=f.children[h-1];t={offset:n.offset+n.length,length:0,content:","+m}}else f.children.length===0?t={offset:f.offset+1,length:0,content:m}:t={offset:f.offset+1,length:0,content:m+","};return _(k,t,d)}}else if(f.type==="array"&&typeof y=="number"&&Array.isArray(f.children))if(I!==void 0){const l=`${JSON.stringify(I)}`;let m;if(f.children.length===0||y===0)m={offset:f.offset+1,length:0,content:f.children.length===0?l:l+","};else{const h=y===-1||y>f.children.length?f.children.length:y,t=f.children[h-1];m={offset:t.offset+t.length,length:0,content:","+l}}return _(k,m,d)}else{const l=y,m=f.children[l];let h;if(f.children.length===1)h={offset:f.offset+1,length:f.length-2,content:""};else if(f.children.length-1===l){const t=f.children[l-1],n=t.offset+t.length,r=f.offset+f.length;h={offset:n,length:r-2-n,content:""}}else h={offset:m.offset,length:f.children[l+1].offset-m.offset,content:""};return _(k,h,d)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${f.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return _(k,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(I)},d)}}e.setProperty=T;function _(k,i,I){let d=S(k,i),g=i.offset,o=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;g>0&&!(0,R.isEOL)(d,g-1);)g--;for(;o<d.length&&!(0,R.isEOL)(d,o);)o++}const a=(0,R.format)(d,{offset:g,length:o-g},I);for(let f=a.length-1;f>=0;f--){const y=a[f];d=S(d,y),g=Math.min(g,y.offset),o=Math.max(o,y.offset+y.length),o+=y.content.length-y.length}const w=k.length-(d.length-o)-g;return[{offset:g,length:w,content:d.substring(g,o)}]}e.withFormatting=_;function S(k,i){return k.substring(0,i.offset)+i.content+k.substring(i.offset+i.length)}e.applyEdit=S;function E(k,i){let I=i.slice(0).sort((g,o)=>{const a=g.offset-o.offset;return a===0?g.length-o.length:a}),d=k.length;for(let g=I.length-1;g>=0;g--){let o=I[g];if(o.offset+o.length<=d)k=S(k,o);else throw new Error("Overlapping edit");d=o.offset}return k}e.applyEdits=E}),define(be[110],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new p(()=>D(this.getValue()))}}e.Lazy=p}),define(be[6],_e([0,1,54,43]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const D=!1;let T=null;function _(l){T=l}if(e.setDisposableTracker=_,D){const l="__is_disposable_tracked__";T=new class{trackDisposable(m){const h=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[l]||console.log(h)},3e3)}markTracked(m){if(m&&m!==a.None)try{m[l]=!0}catch(h){}}}}function S(l){!T||T.markTracked(l)}function E(l){return T&&T.trackDisposable(l),l}e.trackDisposable=E;class k extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}e.MultiDisposeError=k;function i(l){return typeof l.dispose=="function"&&l.dispose.length===0}e.isDisposable=i;function I(l){if(R.Iterable.is(l)){let m=[];for(const h of l)if(h){S(h);try{h.dispose()}catch(t){m.push(t)}}if(m.length===1)throw m[0];if(m.length>1)throw new k(m);return Array.isArray(l)?[]:l}else if(l)return S(l),l.dispose(),l}e.dispose=I;function d(...l){return l.forEach(S),g(()=>I(l))}e.combinedDisposable=d;function g(l){const m=E({dispose:()=>{S(m),l()}});return m}e.toDisposable=g;class o{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(S(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return S(m),this._isDisposed?o.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}e.DisposableStore=o,o.DISABLE_DISPOSED_WARNING=!1;class a{constructor(){this._store=new o,E(this)}dispose(){S(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=a,a.None=Object.freeze({dispose(){}});class w{constructor(){this._isDisposed=!1,E(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){var h;this._isDisposed||m===this._value||((h=this._value)===null||h===void 0||h.dispose(),m&&S(m),this._value=m)}clear(){this.value=void 0}dispose(){var m;this._isDisposed=!0,S(this),(m=this._value)===null||m===void 0||m.dispose(),this._value=void 0}}e.MutableDisposable=w;class f{constructor(){this.references=new Map}acquire(m,...h){let t=this.references.get(m);t||(t={counter:0,object:this.createReferencedObject(m,...h)},this.references.set(m,t));const{object:n}=t,r=(0,p.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(m,t.object),this.references.delete(m))});return t.counter++,{object:n,dispose:r}}}e.ReferenceCollection=f;class y{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=y}),define(be[45],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(T){this.element=T,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let T=this._first;for(;T!==p.Undefined;){const _=T.next;T.prev=p.Undefined,T.next=p.Undefined,T=_}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,_){const S=new p(T);if(this._first===p.Undefined)this._first=S,this._last=S;else if(_){const k=this._last;this._last=S,S.prev=k,k.next=S}else{const k=this._first;this._first=S,S.next=k,k.prev=S}this._size+=1;let E=!1;return()=>{E||(E=!0,this._remove(S))}}shift(){if(this._first!==p.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==p.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==p.Undefined&&T.next!==p.Undefined){const _=T.prev;_.next=T.next,T.next.prev=_}else T.prev===p.Undefined&&T.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):T.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):T.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==p.Undefined;)yield T.element,T=T.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(Se,ye){for(var De=0;De<ye.length;De++){var ie=ye[De];ie.enumerable=ie.enumerable||!1,ie.configurable=!0,"value"in ie&&(ie.writable=!0),Object.defineProperty(Se,ie.key,ie)}}function e(Se,ye,De){return ye&&X(Se.prototype,ye),De&&X(Se,De),Se}function p(Se,ye){if(!!Se){if(typeof Se=="string")return R(Se,ye);var De=Object.prototype.toString.call(Se).slice(8,-1);if(De==="Object"&&Se.constructor&&(De=Se.constructor.name),De==="Map"||De==="Set")return Array.from(Se);if(De==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(De))return R(Se,ye)}}function R(Se,ye){(ye==null||ye>Se.length)&&(ye=Se.length);for(var De=0,ie=new Array(ye);De<ye;De++)ie[De]=Se[De];return ie}function D(Se,ye){var De;if(typeof Symbol=="undefined"||Se[Symbol.iterator]==null){if(Array.isArray(Se)||(De=p(Se))||ye&&Se&&typeof Se.length=="number"){De&&(Se=De);var ie=0;return function(){return ie>=Se.length?{done:!0}:{done:!1,value:Se[ie++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return De=Se[Symbol.iterator](),De.next.bind(De)}function T(Se){var ye={exports:{}};return Se(ye,ye.exports),ye.exports}var _=T(function(Se){function ye(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function De(ie){Se.exports.defaults=ie}Se.exports={defaults:ye(),getDefaults:ye,changeDefaults:De}}),S=/[&<>"']/,E=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,i=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ye){return I[ye]};function g(Se,ye){if(ye){if(S.test(Se))return Se.replace(E,d)}else if(k.test(Se))return Se.replace(i,d);return Se}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function a(Se){return Se.replace(o,function(ye,De){return De=De.toLowerCase(),De==="colon"?":":De.charAt(0)==="#"?De.charAt(1)==="x"?String.fromCharCode(parseInt(De.substring(2),16)):String.fromCharCode(+De.substring(1)):""})}var w=/(^|[^\[])\^/g;function f(Se,ye){Se=Se.source||Se,ye=ye||"";var De={replace:function(ue,O){return O=O.source||O,O=O.replace(w,"$1"),Se=Se.replace(ue,O),De},getRegex:function(){return new RegExp(Se,ye)}};return De}var y=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function m(Se,ye,De){if(Se){var ie;try{ie=decodeURIComponent(a(De)).replace(y,"").toLowerCase()}catch(ue){return null}if(ie.indexOf("javascript:")===0||ie.indexOf("vbscript:")===0||ie.indexOf("data:")===0)return null}ye&&!l.test(De)&&(De=s(ye,De));try{De=encodeURI(De).replace(/%25/g,"%")}catch(ue){return null}return De}var h={},t=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(Se,ye){h[" "+Se]||(t.test(Se)?h[" "+Se]=Se+"/":h[" "+Se]=P(Se,"/",!0)),Se=h[" "+Se];var De=Se.indexOf(":")===-1;return ye.substring(0,2)==="//"?De?ye:Se.replace(n,"$1")+ye:ye.charAt(0)==="/"?De?ye:Se.replace(r,"$1")+ye:Se+ye}var u={exec:function(){}};function v(Se){for(var ye=1,De,ie;ye<arguments.length;ye++){De=arguments[ye];for(ie in De)Object.prototype.hasOwnProperty.call(De,ie)&&(Se[ie]=De[ie])}return Se}function b(Se,ye){var De=Se.replace(/\|/g,function(O,J,oe){for(var Ce=!1,ke=J;--ke>=0&&oe[ke]==="\\";)Ce=!Ce;return Ce?"|":" |"}),ie=De.split(/ \|/),ue=0;if(ie.length>ye)ie.splice(ye);else for(;ie.length<ye;)ie.push("");for(;ue<ie.length;ue++)ie[ue]=ie[ue].trim().replace(/\\\|/g,"|");return ie}function P(Se,ye,De){var ie=Se.length;if(ie===0)return"";for(var ue=0;ue<ie;){var O=Se.charAt(ie-ue-1);if(O===ye&&!De)ue++;else if(O!==ye&&De)ue++;else break}return Se.substr(0,ie-ue)}function C(Se,ye){if(Se.indexOf(ye[1])===-1)return-1;for(var De=Se.length,ie=0,ue=0;ue<De;ue++)if(Se[ue]==="\\")ue++;else if(Se[ue]===ye[0])ie++;else if(Se[ue]===ye[1]&&(ie--,ie<0))return ue;return-1}function c(Se){Se&&Se.sanitize&&!Se.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(Se,ye){if(ye<1)return"";for(var De="";ye>1;)ye&1&&(De+=Se),ye>>=1,Se+=Se;return De+Se}var N={escape:g,unescape:a,edit:f,cleanUrl:m,resolveUrl:s,noopTest:u,merge:v,splitCells:b,rtrim:P,findClosingBracket:C,checkSanitizeDeprecation:c,repeatString:F},z=_.defaults,he=N.rtrim,me=N.splitCells,Q=N.escape,W=N.findClosingBracket;function x(Se,ye,De){var ie=ye.href,ue=ye.title?Q(ye.title):null,O=Se[1].replace(/\\([\[\]])/g,"$1");return Se[0].charAt(0)!=="!"?{type:"link",raw:De,href:ie,title:ue,text:O}:{type:"image",raw:De,href:ie,title:ue,text:Q(O)}}function A(Se,ye){var De=Se.match(/^(\s+)(?:```)/);if(De===null)return ye;var ie=De[1];return ye.split(`
`).map(function(ue){var O=ue.match(/^\s+/);if(O===null)return ue;var J=O[0];return J.length>=ie.length?ue.slice(ie.length):ue}).join(`
`)}var U=function(){function Se(De){this.options=De||z}var ye=Se.prototype;return ye.space=function(ie){var ue=this.rules.block.newline.exec(ie);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(ie){var ue=this.rules.block.code.exec(ie);if(ue){var O=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?O:he(O,`
`)}}},ye.fences=function(ie){var ue=this.rules.block.fences.exec(ie);if(ue){var O=ue[0],J=A(O,ue[3]||"");return{type:"code",raw:O,lang:ue[2]?ue[2].trim():ue[2],text:J}}},ye.heading=function(ie){var ue=this.rules.block.heading.exec(ie);if(ue){var O=ue[2].trim();if(/#$/.test(O)){var J=he(O,"#");(this.options.pedantic||!J||/ $/.test(J))&&(O=J.trim())}return{type:"heading",raw:ue[0],depth:ue[1].length,text:O}}},ye.nptable=function(ie){var ue=this.rules.block.nptable.exec(ie);if(ue){var O={type:"table",header:me(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[],raw:ue[0]};if(O.header.length===O.align.length){var J=O.align.length,oe;for(oe=0;oe<J;oe++)/^ *-+: *$/.test(O.align[oe])?O.align[oe]="right":/^ *:-+: *$/.test(O.align[oe])?O.align[oe]="center":/^ *:-+ *$/.test(O.align[oe])?O.align[oe]="left":O.align[oe]=null;for(J=O.cells.length,oe=0;oe<J;oe++)O.cells[oe]=me(O.cells[oe],O.header.length);return O}}},ye.hr=function(ie){var ue=this.rules.block.hr.exec(ie);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(ie){var ue=this.rules.block.blockquote.exec(ie);if(ue){var O=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],text:O}}},ye.list=function(ie){var ue=this.rules.block.list.exec(ie);if(ue){var O=ue[0],J=ue[2],oe=J.length>1,Ce={type:"list",raw:O,ordered:oe,start:oe?+J.slice(0,-1):"",loose:!1,items:[]},ke=ue[0].match(this.rules.block.item),Ne=!1,Oe,qe,rt,tt,Je,ot,_t,bt,ve=ke.length;rt=this.rules.block.listItemStart.exec(ke[0]);for(var ce=0;ce<ve;ce++){if(Oe=ke[ce],O=Oe,ce!==ve-1){if(tt=this.rules.block.listItemStart.exec(ke[ce+1]),this.options.pedantic?tt[1].length>rt[1].length:tt[1].length>rt[0].length||tt[1].length>3){ke.splice(ce,2,ke[ce]+`
`+ke[ce+1]),ce--,ve--;continue}else(!this.options.pedantic||this.options.smartLists?tt[2][tt[2].length-1]!==J[J.length-1]:oe===(tt[2].length===1))&&(Je=ke.slice(ce+1).join(`
`),Ce.raw=Ce.raw.substring(0,Ce.raw.length-Je.length),ce=ve-1);rt=tt}qe=Oe.length,Oe=Oe.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Oe.indexOf(`
 `)&&(qe-=Oe.length,Oe=this.options.pedantic?Oe.replace(/^ {1,4}/gm,""):Oe.replace(new RegExp("^ {1,"+qe+"}","gm"),"")),ot=Ne||/\n\n(?!\s*$)/.test(Oe),ce!==ve-1&&(Ne=Oe.charAt(Oe.length-1)===`
`,ot||(ot=Ne)),ot&&(Ce.loose=!0),this.options.gfm&&(_t=/^\[[ xX]\] /.test(Oe),bt=void 0,_t&&(bt=Oe[1]!==" ",Oe=Oe.replace(/^\[[ xX]\] +/,""))),Ce.items.push({type:"list_item",raw:O,task:_t,checked:bt,loose:ot,text:Oe})}return Ce}},ye.html=function(ie){var ue=this.rules.block.html.exec(ie);if(ue)return{type:this.options.sanitize?"paragraph":"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):Q(ue[0]):ue[0]}},ye.def=function(ie){var ue=this.rules.block.def.exec(ie);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var O=ue[1].toLowerCase().replace(/\s+/g," ");return{tag:O,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(ie){var ue=this.rules.block.table.exec(ie);if(ue){var O={type:"table",header:me(ue[1].replace(/^ *| *\| *$/g,"")),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(O.header.length===O.align.length){O.raw=ue[0];var J=O.align.length,oe;for(oe=0;oe<J;oe++)/^ *-+: *$/.test(O.align[oe])?O.align[oe]="right":/^ *:-+: *$/.test(O.align[oe])?O.align[oe]="center":/^ *:-+ *$/.test(O.align[oe])?O.align[oe]="left":O.align[oe]=null;for(J=O.cells.length,oe=0;oe<J;oe++)O.cells[oe]=me(O.cells[oe].replace(/^ *\| *| *\| *$/g,""),O.header.length);return O}}},ye.lheading=function(ie){var ue=this.rules.block.lheading.exec(ie);if(ue)return{type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1]}},ye.paragraph=function(ie){var ue=this.rules.block.paragraph.exec(ie);if(ue)return{type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1]}},ye.text=function(ie){var ue=this.rules.block.text.exec(ie);if(ue)return{type:"text",raw:ue[0],text:ue[0]}},ye.escape=function(ie){var ue=this.rules.inline.escape.exec(ie);if(ue)return{type:"escape",raw:ue[0],text:Q(ue[1])}},ye.tag=function(ie,ue,O){var J=this.rules.inline.tag.exec(ie);if(J)return!ue&&/^<a /i.test(J[0])?ue=!0:ue&&/^<\/a>/i.test(J[0])&&(ue=!1),!O&&/^<(pre|code|kbd|script)(\s|>)/i.test(J[0])?O=!0:O&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(J[0])&&(O=!1),{type:this.options.sanitize?"text":"html",raw:J[0],inLink:ue,inRawBlock:O,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):Q(J[0]):J[0]}},ye.link=function(ie){var ue=this.rules.inline.link.exec(ie);if(ue){var O=ue[2].trim();if(!this.options.pedantic&&/^</.test(O)){if(!/>$/.test(O))return;var J=he(O.slice(0,-1),"\\");if((O.length-J.length)%2==0)return}else{var oe=W(ue[2],"()");if(oe>-1){var Ce=ue[0].indexOf("!")===0?5:4,ke=Ce+ue[1].length+oe;ue[2]=ue[2].substring(0,oe),ue[0]=ue[0].substring(0,ke).trim(),ue[3]=""}}var Ne=ue[2],Oe="";if(this.options.pedantic){var qe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);qe&&(Ne=qe[1],Oe=qe[3])}else Oe=ue[3]?ue[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(O)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),x(ue,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:Oe&&Oe.replace(this.rules.inline._escapes,"$1")},ue[0])}},ye.reflink=function(ie,ue){var O;if((O=this.rules.inline.reflink.exec(ie))||(O=this.rules.inline.nolink.exec(ie))){var J=(O[2]||O[1]).replace(/\s+/g," ");if(J=ue[J.toLowerCase()],!J||!J.href){var oe=O[0].charAt(0);return{type:"text",raw:oe,text:oe}}return x(O,J,O[0])}},ye.emStrong=function(ie,ue,O){O===void 0&&(O="");var J=this.rules.inline.emStrong.lDelim.exec(ie);if(!!J&&!(J[3]&&O.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var oe=J[1]||J[2]||"";if(!oe||oe&&(O===""||this.rules.inline.punctuation.exec(O))){var Ce=J[0].length-1,ke,Ne,Oe=Ce,qe=0,rt=J[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,ue=ue.slice(-1*ie.length+Ce);(J=rt.exec(ue))!=null;)if(ke=J[1]||J[2]||J[3]||J[4]||J[5]||J[6],!!ke){if(Ne=ke.length,J[3]||J[4]){Oe+=Ne;continue}else if((J[5]||J[6])&&Ce%3&&!((Ce+Ne)%3)){qe+=Ne;continue}if(Oe-=Ne,!(Oe>0)){if(Oe+qe-Ne<=0&&!ue.slice(rt.lastIndex).match(rt)&&(Ne=Math.min(Ne,Ne+Oe+qe)),Math.min(Ce,Ne)%2)return{type:"em",raw:ie.slice(0,Ce+J.index+Ne+1),text:ie.slice(1,Ce+J.index+Ne)};if(Math.min(Ce,Ne)%2==0)return{type:"strong",raw:ie.slice(0,Ce+J.index+Ne+1),text:ie.slice(2,Ce+J.index+Ne-1)}}}}}},ye.codespan=function(ie){var ue=this.rules.inline.code.exec(ie);if(ue){var O=ue[2].replace(/\n/g," "),J=/[^ ]/.test(O),oe=/^ /.test(O)&&/ $/.test(O);return J&&oe&&(O=O.substring(1,O.length-1)),O=Q(O,!0),{type:"codespan",raw:ue[0],text:O}}},ye.br=function(ie){var ue=this.rules.inline.br.exec(ie);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(ie){var ue=this.rules.inline.del.exec(ie);if(ue)return{type:"del",raw:ue[0],text:ue[2]}},ye.autolink=function(ie,ue){var O=this.rules.inline.autolink.exec(ie);if(O){var J,oe;return O[2]==="@"?(J=Q(this.options.mangle?ue(O[1]):O[1]),oe="mailto:"+J):(J=Q(O[1]),oe=J),{type:"link",raw:O[0],text:J,href:oe,tokens:[{type:"text",raw:J,text:J}]}}},ye.url=function(ie,ue){var O;if(O=this.rules.inline.url.exec(ie)){var J,oe;if(O[2]==="@")J=Q(this.options.mangle?ue(O[0]):O[0]),oe="mailto:"+J;else{var Ce;do Ce=O[0],O[0]=this.rules.inline._backpedal.exec(O[0])[0];while(Ce!==O[0]);J=Q(O[0]),O[1]==="www."?oe="http://"+J:oe=J}return{type:"link",raw:O[0],text:J,href:oe,tokens:[{type:"text",raw:J,text:J}]}}},ye.inlineText=function(ie,ue,O){var J=this.rules.inline.text.exec(ie);if(J){var oe;return ue?oe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(J[0]):Q(J[0]):J[0]:oe=Q(this.options.smartypants?O(J[0]):J[0]),{type:"text",raw:J[0],text:oe}}},Se}(),M=N.noopTest,$=N.edit,K=N.merge,j={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:M,table:M,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};j._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,j._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,j.def=$(j.def).replace("label",j._label).replace("title",j._title).getRegex(),j.bullet=/(?:[*+-]|\d{1,9}[.)])/,j.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,j.item=$(j.item,"gm").replace(/bull/g,j.bullet).getRegex(),j.listItemStart=$(/^( *)(bull)/).replace("bull",j.bullet).getRegex(),j.list=$(j.list).replace(/bull/g,j.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+j.def.source+")").getRegex(),j._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",j._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,j.html=$(j.html,"i").replace("comment",j._comment).replace("tag",j._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),j.paragraph=$(j._paragraph).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.blockquote=$(j.blockquote).replace("paragraph",j.paragraph).getRegex(),j.normal=K({},j),j.gfm=K({},j.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),j.gfm.nptable=$(j.gfm.nptable).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.gfm.table=$(j.gfm.table).replace("hr",j.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",j._tag).getRegex(),j.pedantic=K({},j.normal,{html:$(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",j._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:M,paragraph:$(j.normal._paragraph).replace("hr",j.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",j.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:M,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:M,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=$(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=$(j._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=$(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=$(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=$(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=$(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=$(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=$(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=$(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=$(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=K({},ae),ae.pedantic=K({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:$(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:$(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=K({},ae.normal,{escape:$(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),ae.gfm.url=$(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=K({},ae.gfm,{br:$(ae.br).replace("{2,}","*").getRegex(),text:$(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var we={block:j,inline:ae},Re=_.defaults,xe=we.block,Le=we.inline,Ve=N.repeatString;function Qe(Se){return Se.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ke(Se){var ye="",De,ie,ue=Se.length;for(De=0;De<ue;De++)ie=Se.charCodeAt(De),Math.random()>.5&&(ie="x"+ie.toString(16)),ye+="&#"+ie+";";return ye}var Ge=function(){function Se(De){this.tokens=[],this.tokens.links=Object.create(null),this.options=De||Re,this.options.tokenizer=this.options.tokenizer||new U,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ie={block:xe.normal,inline:Le.normal};this.options.pedantic?(ie.block=xe.pedantic,ie.inline=Le.pedantic):this.options.gfm&&(ie.block=xe.gfm,this.options.breaks?ie.inline=Le.breaks:ie.inline=Le.gfm),this.tokenizer.rules=ie}Se.lex=function(ie,ue){var O=new Se(ue);return O.lex(ie)},Se.lexInline=function(ie,ue){var O=new Se(ue);return O.inlineTokens(ie)};var ye=Se.prototype;return ye.lex=function(ie){return ie=ie.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ie,this.tokens,!0),this.inline(this.tokens),this.tokens},ye.blockTokens=function(ie,ue,O){ue===void 0&&(ue=[]),O===void 0&&(O=!0),this.options.pedantic&&(ie=ie.replace(/^ +$/gm,""));for(var J,oe,Ce,ke;ie;){if(J=this.tokenizer.space(ie)){ie=ie.substring(J.raw.length),J.type&&ue.push(J);continue}if(J=this.tokenizer.code(ie)){ie=ie.substring(J.raw.length),ke=ue[ue.length-1],ke&&ke.type==="paragraph"?(ke.raw+=`
`+J.raw,ke.text+=`
`+J.text):ue.push(J);continue}if(J=this.tokenizer.fences(ie)){ie=ie.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.heading(ie)){ie=ie.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.nptable(ie)){ie=ie.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.hr(ie)){ie=ie.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.blockquote(ie)){ie=ie.substring(J.raw.length),J.tokens=this.blockTokens(J.text,[],O),ue.push(J);continue}if(J=this.tokenizer.list(ie)){for(ie=ie.substring(J.raw.length),Ce=J.items.length,oe=0;oe<Ce;oe++)J.items[oe].tokens=this.blockTokens(J.items[oe].text,[],!1);ue.push(J);continue}if(J=this.tokenizer.html(ie)){ie=ie.substring(J.raw.length),ue.push(J);continue}if(O&&(J=this.tokenizer.def(ie))){ie=ie.substring(J.raw.length),this.tokens.links[J.tag]||(this.tokens.links[J.tag]={href:J.href,title:J.title});continue}if(J=this.tokenizer.table(ie)){ie=ie.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.lheading(ie)){ie=ie.substring(J.raw.length),ue.push(J);continue}if(O&&(J=this.tokenizer.paragraph(ie))){ie=ie.substring(J.raw.length),ue.push(J);continue}if(J=this.tokenizer.text(ie)){ie=ie.substring(J.raw.length),ke=ue[ue.length-1],ke&&ke.type==="text"?(ke.raw+=`
`+J.raw,ke.text+=`
`+J.text):ue.push(J);continue}if(ie){var Ne="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return ue},ye.inline=function(ie){var ue,O,J,oe,Ce,ke,Ne=ie.length;for(ue=0;ue<Ne;ue++)switch(ke=ie[ue],ke.type){case"paragraph":case"text":case"heading":{ke.tokens=[],this.inlineTokens(ke.text,ke.tokens);break}case"table":{for(ke.tokens={header:[],cells:[]},oe=ke.header.length,O=0;O<oe;O++)ke.tokens.header[O]=[],this.inlineTokens(ke.header[O],ke.tokens.header[O]);for(oe=ke.cells.length,O=0;O<oe;O++)for(Ce=ke.cells[O],ke.tokens.cells[O]=[],J=0;J<Ce.length;J++)ke.tokens.cells[O][J]=[],this.inlineTokens(Ce[J],ke.tokens.cells[O][J]);break}case"blockquote":{this.inline(ke.tokens);break}case"list":{for(oe=ke.items.length,O=0;O<oe;O++)this.inline(ke.items[O].tokens);break}}return ie},ye.inlineTokens=function(ie,ue,O,J){ue===void 0&&(ue=[]),O===void 0&&(O=!1),J===void 0&&(J=!1);var oe,Ce,ke=ie,Ne,Oe,qe;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(ke))!=null;)rt.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(ke=ke.slice(0,Ne.index)+"["+Ve("a",Ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(ke))!=null;)ke=ke.slice(0,Ne.index)+"["+Ve("a",Ne[0].length-2)+"]"+ke.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(ke))!=null;)ke=ke.slice(0,Ne.index)+"++"+ke.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ie;){if(Oe||(qe=""),Oe=!1,oe=this.tokenizer.escape(ie)){ie=ie.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.tag(ie,O,J)){ie=ie.substring(oe.raw.length),O=oe.inLink,J=oe.inRawBlock;var tt=ue[ue.length-1];tt&&oe.type==="text"&&tt.type==="text"?(tt.raw+=oe.raw,tt.text+=oe.text):ue.push(oe);continue}if(oe=this.tokenizer.link(ie)){ie=ie.substring(oe.raw.length),oe.type==="link"&&(oe.tokens=this.inlineTokens(oe.text,[],!0,J)),ue.push(oe);continue}if(oe=this.tokenizer.reflink(ie,this.tokens.links)){ie=ie.substring(oe.raw.length);var Je=ue[ue.length-1];oe.type==="link"?(oe.tokens=this.inlineTokens(oe.text,[],!0,J),ue.push(oe)):Je&&oe.type==="text"&&Je.type==="text"?(Je.raw+=oe.raw,Je.text+=oe.text):ue.push(oe);continue}if(oe=this.tokenizer.emStrong(ie,ke,qe)){ie=ie.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],O,J),ue.push(oe);continue}if(oe=this.tokenizer.codespan(ie)){ie=ie.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.br(ie)){ie=ie.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.del(ie)){ie=ie.substring(oe.raw.length),oe.tokens=this.inlineTokens(oe.text,[],O,J),ue.push(oe);continue}if(oe=this.tokenizer.autolink(ie,Ke)){ie=ie.substring(oe.raw.length),ue.push(oe);continue}if(!O&&(oe=this.tokenizer.url(ie,Ke))){ie=ie.substring(oe.raw.length),ue.push(oe);continue}if(oe=this.tokenizer.inlineText(ie,J,Qe)){ie=ie.substring(oe.raw.length),oe.raw.slice(-1)!=="_"&&(qe=oe.raw.slice(-1)),Oe=!0,Ce=ue[ue.length-1],Ce&&Ce.type==="text"?(Ce.raw+=oe.raw,Ce.text+=oe.text):ue.push(oe);continue}if(ie){var ot="Infinite loop on byte: "+ie.charCodeAt(0);if(this.options.silent){console.error(ot);break}else throw new Error(ot)}}return ue},e(Se,null,[{key:"rules",get:function(){return{block:xe,inline:Le}}}]),Se}(),H=_.defaults,Y=N.cleanUrl,ne=N.escape,re=function(){function Se(De){this.options=De||H}var ye=Se.prototype;return ye.code=function(ie,ue,O){var J=(ue||"").match(/\S*/)[0];if(this.options.highlight){var oe=this.options.highlight(ie,J);oe!=null&&oe!==ie&&(O=!0,ie=oe)}return ie=ie.replace(/\n$/,"")+`
`,J?'<pre><code class="'+this.options.langPrefix+ne(J,!0)+'">'+(O?ie:ne(ie,!0))+`</code></pre>
`:"<pre><code>"+(O?ie:ne(ie,!0))+`</code></pre>
`},ye.blockquote=function(ie){return`<blockquote>
`+ie+`</blockquote>
`},ye.html=function(ie){return ie},ye.heading=function(ie,ue,O,J){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+J.slug(O)+'">'+ie+"</h"+ue+`>
`:"<h"+ue+">"+ie+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(ie,ue,O){var J=ue?"ol":"ul",oe=ue&&O!==1?' start="'+O+'"':"";return"<"+J+oe+`>
`+ie+"</"+J+`>
`},ye.listitem=function(ie){return"<li>"+ie+`</li>
`},ye.checkbox=function(ie){return"<input "+(ie?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(ie){return"<p>"+ie+`</p>
`},ye.table=function(ie,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+ie+`</thead>
`+ue+`</table>
`},ye.tablerow=function(ie){return`<tr>
`+ie+`</tr>
`},ye.tablecell=function(ie,ue){var O=ue.header?"th":"td",J=ue.align?"<"+O+' align="'+ue.align+'">':"<"+O+">";return J+ie+"</"+O+`>
`},ye.strong=function(ie){return"<strong>"+ie+"</strong>"},ye.em=function(ie){return"<em>"+ie+"</em>"},ye.codespan=function(ie){return"<code>"+ie+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(ie){return"<del>"+ie+"</del>"},ye.link=function(ie,ue,O){if(ie=Y(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var J='<a href="'+ne(ie)+'"';return ue&&(J+=' title="'+ue+'"'),J+=">"+O+"</a>",J},ye.image=function(ie,ue,O){if(ie=Y(this.options.sanitize,this.options.baseUrl,ie),ie===null)return O;var J='<img src="'+ie+'" alt="'+O+'"';return ue&&(J+=' title="'+ue+'"'),J+=this.options.xhtml?"/>":">",J},ye.text=function(ie){return ie},Se}(),G=function(){function Se(){}var ye=Se.prototype;return ye.strong=function(ie){return ie},ye.em=function(ie){return ie},ye.codespan=function(ie){return ie},ye.del=function(ie){return ie},ye.html=function(ie){return ie},ye.text=function(ie){return ie},ye.link=function(ie,ue,O){return""+O},ye.image=function(ie,ue,O){return""+O},ye.br=function(){return""},Se}(),se=function(){function Se(){this.seen={}}var ye=Se.prototype;return ye.serialize=function(ie){return ie.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(ie,ue){var O=ie,J=0;if(this.seen.hasOwnProperty(O)){J=this.seen[ie];do J++,O=ie+"-"+J;while(this.seen.hasOwnProperty(O))}return ue||(this.seen[ie]=J,this.seen[O]=0),O},ye.slug=function(ie,ue){ue===void 0&&(ue={});var O=this.serialize(ie);return this.getNextSafeSlug(O,ue.dryrun)},Se}(),fe=_.defaults,Ae=N.unescape,ge=function(){function Se(De){this.options=De||fe,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new G,this.slugger=new se}Se.parse=function(ie,ue){var O=new Se(ue);return O.parse(ie)},Se.parseInline=function(ie,ue){var O=new Se(ue);return O.parseInline(ie)};var ye=Se.prototype;return ye.parse=function(ie,ue){ue===void 0&&(ue=!0);var O="",J,oe,Ce,ke,Ne,Oe,qe,rt,tt,Je,ot,_t,bt,ve,ce,le,q,Fe,Pe=ie.length;for(J=0;J<Pe;J++)switch(Je=ie[J],Je.type){case"space":continue;case"hr":{O+=this.renderer.hr();continue}case"heading":{O+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Ae(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{O+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(rt="",qe="",ke=Je.header.length,oe=0;oe<ke;oe++)qe+=this.renderer.tablecell(this.parseInline(Je.tokens.header[oe]),{header:!0,align:Je.align[oe]});for(rt+=this.renderer.tablerow(qe),tt="",ke=Je.cells.length,oe=0;oe<ke;oe++){for(Oe=Je.tokens.cells[oe],qe="",Ne=Oe.length,Ce=0;Ce<Ne;Ce++)qe+=this.renderer.tablecell(this.parseInline(Oe[Ce]),{header:!1,align:Je.align[Ce]});tt+=this.renderer.tablerow(qe)}O+=this.renderer.table(rt,tt);continue}case"blockquote":{tt=this.parse(Je.tokens),O+=this.renderer.blockquote(tt);continue}case"list":{for(ot=Je.ordered,_t=Je.start,bt=Je.loose,ke=Je.items.length,tt="",oe=0;oe<ke;oe++)ce=Je.items[oe],le=ce.checked,q=ce.task,ve="",ce.task&&(Fe=this.renderer.checkbox(le),bt?ce.tokens.length>0&&ce.tokens[0].type==="text"?(ce.tokens[0].text=Fe+" "+ce.tokens[0].text,ce.tokens[0].tokens&&ce.tokens[0].tokens.length>0&&ce.tokens[0].tokens[0].type==="text"&&(ce.tokens[0].tokens[0].text=Fe+" "+ce.tokens[0].tokens[0].text)):ce.tokens.unshift({type:"text",text:Fe}):ve+=Fe),ve+=this.parse(ce.tokens,bt),tt+=this.renderer.listitem(ve,q,le);O+=this.renderer.list(tt,ot,_t);continue}case"html":{O+=this.renderer.html(Je.text);continue}case"paragraph":{O+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(tt=Je.tokens?this.parseInline(Je.tokens):Je.text;J+1<Pe&&ie[J+1].type==="text";)Je=ie[++J],tt+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);O+=ue?this.renderer.paragraph(tt):tt;continue}default:{var Ze='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(Ze);return}else throw new Error(Ze)}}return O},ye.parseInline=function(ie,ue){ue=ue||this.renderer;var O="",J,oe,Ce=ie.length;for(J=0;J<Ce;J++)switch(oe=ie[J],oe.type){case"escape":{O+=ue.text(oe.text);break}case"html":{O+=ue.html(oe.text);break}case"link":{O+=ue.link(oe.href,oe.title,this.parseInline(oe.tokens,ue));break}case"image":{O+=ue.image(oe.href,oe.title,oe.text);break}case"strong":{O+=ue.strong(this.parseInline(oe.tokens,ue));break}case"em":{O+=ue.em(this.parseInline(oe.tokens,ue));break}case"codespan":{O+=ue.codespan(oe.text);break}case"br":{O+=ue.br();break}case"del":{O+=ue.del(this.parseInline(oe.tokens,ue));break}case"text":{O+=ue.text(oe.text);break}default:{var ke='Token with "'+oe.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}return O},Se}(),We=N.merge,V=N.checkSanitizeDeprecation,te=N.escape,pe=_.getDefaults,Me=_.changeDefaults,$e=_.defaults;function Be(Se,ye,De){if(typeof Se=="undefined"||Se===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");if(typeof ye=="function"&&(De=ye,ye=null),ye=We({},Be.defaults,ye||{}),V(ye),De){var ie=ye.highlight,ue;try{ue=Ge.lex(Se,ye)}catch(Ce){return De(Ce)}var O=function(ke){var Ne;if(!ke)try{Ne=ge.parse(ue,ye)}catch(Oe){ke=Oe}return ye.highlight=ie,ke?De(ke):De(null,Ne)};if(!ie||ie.length<3||(delete ye.highlight,!ue.length))return O();var J=0;Be.walkTokens(ue,function(Ce){Ce.type==="code"&&(J++,setTimeout(function(){ie(Ce.text,Ce.lang,function(ke,Ne){if(ke)return O(ke);Ne!=null&&Ne!==Ce.text&&(Ce.text=Ne,Ce.escaped=!0),J--,J===0&&O()})},0))}),J===0&&O();return}try{var oe=Ge.lex(Se,ye);return ye.walkTokens&&Be.walkTokens(oe,ye.walkTokens),ge.parse(oe,ye)}catch(Ce){if(Ce.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(Ce.message+"",!0)+"</pre>";throw Ce}}Be.options=Be.setOptions=function(Se){return We(Be.defaults,Se),Me(Be.defaults),Be},Be.getDefaults=pe,Be.defaults=$e,Be.use=function(Se){var ye=We({},Se);if(Se.renderer&&function(){var ie=Be.defaults.renderer||new re,ue=function(oe){var Ce=ie[oe];ie[oe]=function(){for(var ke=arguments.length,Ne=new Array(ke),Oe=0;Oe<ke;Oe++)Ne[Oe]=arguments[Oe];var qe=Se.renderer[oe].apply(ie,Ne);return qe===!1&&(qe=Ce.apply(ie,Ne)),qe}};for(var O in Se.renderer)ue(O);ye.renderer=ie}(),Se.tokenizer&&function(){var ie=Be.defaults.tokenizer||new U,ue=function(oe){var Ce=ie[oe];ie[oe]=function(){for(var ke=arguments.length,Ne=new Array(ke),Oe=0;Oe<ke;Oe++)Ne[Oe]=arguments[Oe];var qe=Se.tokenizer[oe].apply(ie,Ne);return qe===!1&&(qe=Ce.apply(ie,Ne)),qe}};for(var O in Se.tokenizer)ue(O);ye.tokenizer=ie}(),Se.walkTokens){var De=Be.defaults.walkTokens;ye.walkTokens=function(ie){Se.walkTokens(ie),De&&De(ie)}}Be.setOptions(ye)},Be.walkTokens=function(Se,ye){for(var De=D(Se),ie;!(ie=De()).done;){var ue=ie.value;switch(ye(ue),ue.type){case"table":{for(var O=D(ue.tokens.header),J;!(J=O()).done;){var oe=J.value;Be.walkTokens(oe,ye)}for(var Ce=D(ue.tokens.cells),ke;!(ke=Ce()).done;)for(var Ne=ke.value,Oe=D(Ne),qe;!(qe=Oe()).done;){var rt=qe.value;Be.walkTokens(rt,ye)}break}case"list":{Be.walkTokens(ue.items,ye);break}default:ue.tokens&&Be.walkTokens(ue.tokens,ye)}}},Be.parseInline=function(Se,ye){if(typeof Se=="undefined"||Se===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Se!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Se)+", string expected");ye=We({},Be.defaults,ye||{}),V(ye);try{var De=Ge.lexInline(Se,ye);return ye.walkTokens&&Be.walkTokens(De,ye.walkTokens),ge.parseInline(De,ye)}catch(ie){if(ie.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+te(ie.message+"",!0)+"</pre>";throw ie}},Be.Parser=ge,Be.parser=ge.parse,Be.Renderer=re,Be.TextRenderer=G,Be.Lexer=Ge,Be.lexer=Ge.lex,Be.Tokenizer=U,Be.Slugger=se,Be.parse=Be;var Ye=Be;return Ye}),define(be[81],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(_,S,E){return Math.min(Math.max(_,S),E)}e.clamp=p;function R(_,S){return(S+_%S)%S}e.rot=R;class D{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=D;class T{constructor(){this._n=1,this._val=0}update(S){return this._val=this._val+(S-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=T}),function(){function X(D){const T=[];typeof D=="number"&&T.push("code/timeOrigin",D);function _(E){T.push(E,Date.now())}function S(){const E=[];for(let k=0;k<T.length;k+=2)E.push({name:T[k],startTime:T[k+1]});return E}return{mark:_,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const _ of performance.getEntriesByType("mark"))T.push({name:_.name,startTime:Math.round(D+_.startTime)});return T}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))}(),define(be[21],_e([0,1]),function(X,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let D=!1,T=!1,_=!1,S=!1,E=!1,k=!1,i=!1,I,d=R,g,o;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let a;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?a=e.globals.vscode.process:typeof process!="undefined"&&(a=process);const w=typeof((p=a==null?void 0:a.versions)===null||p===void 0?void 0:p.electron)=="string"&&a.type==="renderer";if(e.isElectronSandboxed=w&&(a==null?void 0:a.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=a==null?void 0:a.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!w)o=navigator.userAgent,D=o.indexOf("Windows")>=0,T=o.indexOf("Macintosh")>=0,i=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=o.indexOf("Linux")>=0,k=!0,I=navigator.language,d=I;else if(typeof a=="object"){D=a.platform==="win32",T=a.platform==="darwin",_=a.platform==="linux",S=_&&!!a.env.SNAP&&!!a.env.SNAP_REVISION,I=R,d=R;const s=a.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),v=u.availableLanguages["*"];I=u.locale,d=v||R,g=u._translationsConfigFile}catch(u){}E=!0}else console.error("Unable to resolve platform.");var f;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function y(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=y;let l=0;T?l=1:D?l=3:_&&(l=2),e.isWindows=D,e.isMacintosh=T,e.isLinux=_,e.isLinuxSnap=S,e.isNative=E,e.isWeb=k,e.isIOS=i,e.platform=l,e.userAgent=o,e.language=d;var m;(function(s){function u(){return e.language}s.value=u;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=v;function b(){return e.language==="en"}s.isDefault=b})(m=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=g,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let v=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let C=0,c=v.length;C<c;C++){const F=v[C];if(F.id===P.data.vscodeSetImmediateId){v.splice(C,1),F.callback();return}}});let b=0;return P=>{const C=++b;v.push({id:C,callback:P}),e.globals.postMessage({vscodeSetImmediateId:C},"*")}}if(typeof(a==null?void 0:a.nextTick)=="function")return a.nextTick.bind(a);const u=Promise.resolve();return v=>u.then(v)}();var h;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(h=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||i?2:D?1:3;let t=!0,n=!1;function r(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(be[46],_e([0,1,21]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;R={get platform(){return D.platform},get env(){return D.env},cwd(){return D.cwd()},nextTick(T){return(0,p.setImmediate)(T)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(D){return(0,p.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(be[12],_e([0,1,46]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,D=97,T=90,_=122,S=46,E=47,k=92,i=58,I=63;class d extends Error{constructor(m,h,t){let n;typeof h=="string"&&h.indexOf("not ")===0?(n="must not be",h=h.replace(/^not /,"")):n="must be";const r=m.indexOf(".")!==-1?"property":"argument";let s=`The "${m}" ${r} ${n} of type ${h}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function g(l,m){if(typeof l!="string")throw new d(m,"string",l)}function o(l){return l===E||l===k}function a(l){return l===E}function w(l){return l>=R&&l<=T||l>=D&&l<=_}function f(l,m,h,t){let n="",r=0,s=-1,u=0,v=0;for(let b=0;b<=l.length;++b){if(b<l.length)v=l.charCodeAt(b);else{if(t(v))break;v=E}if(t(v)){if(!(s===b-1||u===1))if(u===2){if(n.length<2||r!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const P=n.lastIndexOf(h);P===-1?(n="",r=0):(n=n.slice(0,P),r=n.length-1-n.lastIndexOf(h)),s=b,u=0;continue}else if(n.length!==0){n="",r=0,s=b,u=0;continue}}m&&(n+=n.length>0?`${h}..`:"..",r=2)}else n.length>0?n+=`${h}${l.slice(s+1,b)}`:n=l.slice(s+1,b),r=b-s-1;s=b,u=0}else v===S&&u!==-1?++u:u=-1}return n}function y(l,m){if(m===null||typeof m!="object")throw new d("pathObject","Object",m);const h=m.dir||m.root,t=m.base||`${m.name||""}${m.ext||""}`;return h?h===m.root?`${h}${t}`:`${h}${l}${t}`:t}e.win32={resolve(...l){let m="",h="",t=!1;for(let n=l.length-1;n>=-1;n--){let r;if(n>=0){if(r=l[n],g(r,"path"),r.length===0)continue}else m.length===0?r=p.cwd():(r=p.env[`=${m}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==m.toLowerCase()&&r.charCodeAt(2)===k)&&(r=`${m}\\`));const s=r.length;let u=0,v="",b=!1;const P=r.charCodeAt(0);if(s===1)o(P)&&(u=1,b=!0);else if(o(P))if(b=!0,o(r.charCodeAt(1))){let C=2,c=C;for(;C<s&&!o(r.charCodeAt(C));)C++;if(C<s&&C!==c){const F=r.slice(c,C);for(c=C;C<s&&o(r.charCodeAt(C));)C++;if(C<s&&C!==c){for(c=C;C<s&&!o(r.charCodeAt(C));)C++;(C===s||C!==c)&&(v=`\\\\${F}\\${r.slice(c,C)}`,u=C)}}}else u=1;else w(P)&&r.charCodeAt(1)===i&&(v=r.slice(0,2),u=2,s>2&&o(r.charCodeAt(2))&&(b=!0,u=3));if(v.length>0)if(m.length>0){if(v.toLowerCase()!==m.toLowerCase())continue}else m=v;if(t){if(m.length>0)break}else if(h=`${r.slice(u)}\\${h}`,t=b,b&&m.length>0)break}return h=f(h,!t,"\\",o),t?`${m}\\${h}`:`${m}${h}`||"."},normalize(l){g(l,"path");const m=l.length;if(m===0)return".";let h=0,t,n=!1;const r=l.charCodeAt(0);if(m===1)return a(r)?"\\":l;if(o(r))if(n=!0,o(l.charCodeAt(1))){let u=2,v=u;for(;u<m&&!o(l.charCodeAt(u));)u++;if(u<m&&u!==v){const b=l.slice(v,u);for(v=u;u<m&&o(l.charCodeAt(u));)u++;if(u<m&&u!==v){for(v=u;u<m&&!o(l.charCodeAt(u));)u++;if(u===m)return`\\\\${b}\\${l.slice(v)}\\`;u!==v&&(t=`\\\\${b}\\${l.slice(v,u)}`,h=u)}}}else h=1;else w(r)&&l.charCodeAt(1)===i&&(t=l.slice(0,2),h=2,m>2&&o(l.charCodeAt(2))&&(n=!0,h=3));let s=h<m?f(l.slice(h),!n,"\\",o):"";return s.length===0&&!n&&(s="."),s.length>0&&o(l.charCodeAt(m-1))&&(s+="\\"),t===void 0?n?`\\${s}`:s:n?`${t}\\${s}`:`${t}${s}`},isAbsolute(l){g(l,"path");const m=l.length;if(m===0)return!1;const h=l.charCodeAt(0);return o(h)||m>2&&w(h)&&l.charCodeAt(1)===i&&o(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let m,h;for(let r=0;r<l.length;++r){const s=l[r];g(s,"path"),s.length>0&&(m===void 0?m=h=s:m+=`\\${s}`)}if(m===void 0)return".";let t=!0,n=0;if(typeof h=="string"&&o(h.charCodeAt(0))){++n;const r=h.length;r>1&&o(h.charCodeAt(1))&&(++n,r>2&&(o(h.charCodeAt(2))?++n:t=!1))}if(t){for(;n<m.length&&o(m.charCodeAt(n));)n++;n>=2&&(m=`\\${m.slice(n)}`)}return e.win32.normalize(m)},relative(l,m){if(g(l,"from"),g(m,"to"),l===m)return"";const h=e.win32.resolve(l),t=e.win32.resolve(m);if(h===t||(l=h.toLowerCase(),m=t.toLowerCase(),l===m))return"";let n=0;for(;n<l.length&&l.charCodeAt(n)===k;)n++;let r=l.length;for(;r-1>n&&l.charCodeAt(r-1)===k;)r--;const s=r-n;let u=0;for(;u<m.length&&m.charCodeAt(u)===k;)u++;let v=m.length;for(;v-1>u&&m.charCodeAt(v-1)===k;)v--;const b=v-u,P=s<b?s:b;let C=-1,c=0;for(;c<P;c++){const N=l.charCodeAt(n+c);if(N!==m.charCodeAt(u+c))break;N===k&&(C=c)}if(c!==P){if(C===-1)return t}else{if(b>P){if(m.charCodeAt(u+c)===k)return t.slice(u+c+1);if(c===2)return t.slice(u+c)}s>P&&(l.charCodeAt(n+c)===k?C=c:c===2&&(C=3)),C===-1&&(C=0)}let F="";for(c=n+C+1;c<=r;++c)(c===r||l.charCodeAt(c)===k)&&(F+=F.length===0?"..":"\\..");return u+=C,F.length>0?`${F}${t.slice(u,v)}`:(t.charCodeAt(u)===k&&++u,t.slice(u,v))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const m=e.win32.resolve(l);if(m.length<=2)return l;if(m.charCodeAt(0)===k){if(m.charCodeAt(1)===k){const h=m.charCodeAt(2);if(h!==I&&h!==S)return`\\\\?\\UNC\\${m.slice(2)}`}}else if(w(m.charCodeAt(0))&&m.charCodeAt(1)===i&&m.charCodeAt(2)===k)return`\\\\?\\${m}`;return l},dirname(l){g(l,"path");const m=l.length;if(m===0)return".";let h=-1,t=0;const n=l.charCodeAt(0);if(m===1)return o(n)?l:".";if(o(n)){if(h=t=1,o(l.charCodeAt(1))){let u=2,v=u;for(;u<m&&!o(l.charCodeAt(u));)u++;if(u<m&&u!==v){for(v=u;u<m&&o(l.charCodeAt(u));)u++;if(u<m&&u!==v){for(v=u;u<m&&!o(l.charCodeAt(u));)u++;if(u===m)return l;u!==v&&(h=t=u+1)}}}}else w(n)&&l.charCodeAt(1)===i&&(h=m>2&&o(l.charCodeAt(2))?3:2,t=h);let r=-1,s=!0;for(let u=m-1;u>=t;--u)if(o(l.charCodeAt(u))){if(!s){r=u;break}}else s=!1;if(r===-1){if(h===-1)return".";r=h}return l.slice(0,r)},basename(l,m){m!==void 0&&g(m,"ext"),g(l,"path");let h=0,t=-1,n=!0,r;if(l.length>=2&&w(l.charCodeAt(0))&&l.charCodeAt(1)===i&&(h=2),m!==void 0&&m.length>0&&m.length<=l.length){if(m===l)return"";let s=m.length-1,u=-1;for(r=l.length-1;r>=h;--r){const v=l.charCodeAt(r);if(o(v)){if(!n){h=r+1;break}}else u===-1&&(n=!1,u=r+1),s>=0&&(v===m.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=u))}return h===t?t=u:t===-1&&(t=l.length),l.slice(h,t)}for(r=l.length-1;r>=h;--r)if(o(l.charCodeAt(r))){if(!n){h=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":l.slice(h,t)},extname(l){g(l,"path");let m=0,h=-1,t=0,n=-1,r=!0,s=0;l.length>=2&&l.charCodeAt(1)===i&&w(l.charCodeAt(0))&&(m=t=2);for(let u=l.length-1;u>=m;--u){const v=l.charCodeAt(u);if(o(v)){if(!r){t=u+1;break}continue}n===-1&&(r=!1,n=u+1),v===S?h===-1?h=u:s!==1&&(s=1):h!==-1&&(s=-1)}return h===-1||n===-1||s===0||s===1&&h===n-1&&h===t+1?"":l.slice(h,n)},format:y.bind(null,"\\"),parse(l){g(l,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return m;const h=l.length;let t=0,n=l.charCodeAt(0);if(h===1)return o(n)?(m.root=m.dir=l,m):(m.base=m.name=l,m);if(o(n)){if(t=1,o(l.charCodeAt(1))){let C=2,c=C;for(;C<h&&!o(l.charCodeAt(C));)C++;if(C<h&&C!==c){for(c=C;C<h&&o(l.charCodeAt(C));)C++;if(C<h&&C!==c){for(c=C;C<h&&!o(l.charCodeAt(C));)C++;C===h?t=C:C!==c&&(t=C+1)}}}}else if(w(n)&&l.charCodeAt(1)===i){if(h<=2)return m.root=m.dir=l,m;if(t=2,o(l.charCodeAt(2))){if(h===3)return m.root=m.dir=l,m;t=3}}t>0&&(m.root=l.slice(0,t));let r=-1,s=t,u=-1,v=!0,b=l.length-1,P=0;for(;b>=t;--b){if(n=l.charCodeAt(b),o(n)){if(!v){s=b+1;break}continue}u===-1&&(v=!1,u=b+1),n===S?r===-1?r=b:P!==1&&(P=1):r!==-1&&(P=-1)}return u!==-1&&(r===-1||P===0||P===1&&r===u-1&&r===s+1?m.base=m.name=l.slice(s,u):(m.name=l.slice(s,r),m.base=l.slice(s,u),m.ext=l.slice(r,u))),s>0&&s!==t?m.dir=l.slice(0,s-1):m.dir=m.root,m},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let m="",h=!1;for(let t=l.length-1;t>=-1&&!h;t--){const n=t>=0?l[t]:p.cwd();g(n,"path"),n.length!==0&&(m=`${n}/${m}`,h=n.charCodeAt(0)===E)}return m=f(m,!h,"/",a),h?`/${m}`:m.length>0?m:"."},normalize(l){if(g(l,"path"),l.length===0)return".";const m=l.charCodeAt(0)===E,h=l.charCodeAt(l.length-1)===E;return l=f(l,!m,"/",a),l.length===0?m?"/":h?"./":".":(h&&(l+="/"),m?`/${l}`:l)},isAbsolute(l){return g(l,"path"),l.length>0&&l.charCodeAt(0)===E},join(...l){if(l.length===0)return".";let m;for(let h=0;h<l.length;++h){const t=l[h];g(t,"path"),t.length>0&&(m===void 0?m=t:m+=`/${t}`)}return m===void 0?".":e.posix.normalize(m)},relative(l,m){if(g(l,"from"),g(m,"to"),l===m||(l=e.posix.resolve(l),m=e.posix.resolve(m),l===m))return"";const h=1,t=l.length,n=t-h,r=1,s=m.length-r,u=n<s?n:s;let v=-1,b=0;for(;b<u;b++){const C=l.charCodeAt(h+b);if(C!==m.charCodeAt(r+b))break;C===E&&(v=b)}if(b===u)if(s>u){if(m.charCodeAt(r+b)===E)return m.slice(r+b+1);if(b===0)return m.slice(r+b)}else n>u&&(l.charCodeAt(h+b)===E?v=b:b===0&&(v=0));let P="";for(b=h+v+1;b<=t;++b)(b===t||l.charCodeAt(b)===E)&&(P+=P.length===0?"..":"/..");return`${P}${m.slice(r+v)}`},toNamespacedPath(l){return l},dirname(l){if(g(l,"path"),l.length===0)return".";const m=l.charCodeAt(0)===E;let h=-1,t=!0;for(let n=l.length-1;n>=1;--n)if(l.charCodeAt(n)===E){if(!t){h=n;break}}else t=!1;return h===-1?m?"/":".":m&&h===1?"//":l.slice(0,h)},basename(l,m){m!==void 0&&g(m,"ext"),g(l,"path");let h=0,t=-1,n=!0,r;if(m!==void 0&&m.length>0&&m.length<=l.length){if(m===l)return"";let s=m.length-1,u=-1;for(r=l.length-1;r>=0;--r){const v=l.charCodeAt(r);if(v===E){if(!n){h=r+1;break}}else u===-1&&(n=!1,u=r+1),s>=0&&(v===m.charCodeAt(s)?--s==-1&&(t=r):(s=-1,t=u))}return h===t?t=u:t===-1&&(t=l.length),l.slice(h,t)}for(r=l.length-1;r>=0;--r)if(l.charCodeAt(r)===E){if(!n){h=r+1;break}}else t===-1&&(n=!1,t=r+1);return t===-1?"":l.slice(h,t)},extname(l){g(l,"path");let m=-1,h=0,t=-1,n=!0,r=0;for(let s=l.length-1;s>=0;--s){const u=l.charCodeAt(s);if(u===E){if(!n){h=s+1;break}continue}t===-1&&(n=!1,t=s+1),u===S?m===-1?m=s:r!==1&&(r=1):m!==-1&&(r=-1)}return m===-1||t===-1||r===0||r===1&&m===t-1&&m===h+1?"":l.slice(m,t)},format:y.bind(null,"/"),parse(l){g(l,"path");const m={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return m;const h=l.charCodeAt(0)===E;let t;h?(m.root="/",t=1):t=0;let n=-1,r=0,s=-1,u=!0,v=l.length-1,b=0;for(;v>=t;--v){const P=l.charCodeAt(v);if(P===E){if(!u){r=v+1;break}continue}s===-1&&(u=!1,s=v+1),P===S?n===-1?n=v:b!==1&&(b=1):n!==-1&&(b=-1)}if(s!==-1){const P=r===0&&h?1:r;n===-1||b===0||b===1&&n===s-1&&n===r+1?m.base=m.name=l.slice(P,s):(m.name=l.slice(P,n),m.base=l.slice(P,s),m.ext=l.slice(n,s))}return r>0?m.dir=l.slice(0,r-1):h&&(m.dir="/"),m},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(be[56],_e([0,1,21]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(_){this._highResolution=R&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new D(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(be[3],_e([0,1,13,54,6,45,56]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var S;(function(f){f.None=()=>D.Disposable.None;function y(Q){return(W,x=null,A)=>{let U=!1,M;return M=Q($=>{if(!U)return M?M.dispose():U=!0,W.call(x,$)},null,A),U&&M.dispose(),M}}f.once=y;function l(Q,W){return s((x,A=null,U)=>Q(M=>x.call(A,W(M)),null,U))}f.map=l;function m(Q,W){return s((x,A=null,U)=>Q(M=>{W(M),x.call(A,M)},null,U))}f.forEach=m;function h(Q,W){return s((x,A=null,U)=>Q(M=>W(M)&&x.call(A,M),null,U))}f.filter=h;function t(Q){return Q}f.signal=t;function n(...Q){return(W,x=null,A)=>(0,D.combinedDisposable)(...Q.map(U=>U(M=>W.call(x,M),null,A)))}f.any=n;function r(Q,W,x){let A=x;return l(Q,U=>(A=W(A,U),A))}f.reduce=r;function s(Q){let W;const x=new d({onFirstListenerAdd(){W=Q(x.fire,x)},onLastListenerRemove(){W.dispose()}});return x.event}f.snapshot=s;function u(Q,W,x=100,A=!1,U){let M,$,K,j=0;const ae=new d({leakWarningThreshold:U,onFirstListenerAdd(){M=Q(we=>{j++,$=W($,we),A&&!K&&(ae.fire($),$=void 0),clearTimeout(K),K=setTimeout(()=>{const Re=$;$=void 0,K=void 0,(!A||j>1)&&ae.fire(Re),j=0},x)})},onLastListenerRemove(){M.dispose()}});return ae.event}f.debounce=u;function v(Q){const W=new Date().getTime();return l(y(Q),x=>new Date().getTime()-W)}f.stopwatch=v;function b(Q,W=(x,A)=>x===A){let x=!0,A;return h(Q,U=>{const M=x||!W(U,A);return x=!1,A=U,M})}f.latch=b;function P(Q,W){return[f.filter(Q,W),f.filter(Q,x=>!W(x))]}f.split=P;function C(Q,W=!1,x=[]){let A=x.slice(),U=Q(K=>{A?A.push(K):$.fire(K)});const M=()=>{A&&A.forEach(K=>$.fire(K)),A=null},$=new d({onFirstListenerAdd(){U||(U=Q(K=>$.fire(K)))},onFirstListenerDidAdd(){A&&(W?setTimeout(M):M())},onLastListenerRemove(){U&&U.dispose(),U=null}});return $.event}f.buffer=C;class c{constructor(W){this.event=W}map(W){return new c(l(this.event,W))}forEach(W){return new c(m(this.event,W))}filter(W){return new c(h(this.event,W))}reduce(W,x){return new c(r(this.event,W,x))}latch(){return new c(b(this.event))}debounce(W,x=100,A=!1,U){return new c(u(this.event,W,x,A,U))}on(W,x,A){return this.event(W,x,A)}once(W,x,A){return y(this.event)(W,x,A)}}function F(Q){return new c(Q)}f.chain=F;function N(Q,W,x=A=>A){const A=(...K)=>$.fire(x(...K)),U=()=>Q.on(W,A),M=()=>Q.removeListener(W,A),$=new d({onFirstListenerAdd:U,onLastListenerRemove:M});return $.event}f.fromNodeEventEmitter=N;function z(Q,W,x=A=>A){const A=(...K)=>$.fire(x(...K)),U=()=>Q.addEventListener(W,A),M=()=>Q.removeEventListener(W,A),$=new d({onFirstListenerAdd:U,onLastListenerRemove:M});return $.event}f.fromDOMEventEmitter=z;function he(Q){const W=new d;let x=!1;return Q.then(void 0,()=>null).then(()=>{x?W.fire(void 0):setTimeout(()=>W.fire(void 0),0)}),x=!0,W.event}f.fromPromise=he;function me(Q){return new Promise(W=>y(Q)(W))}f.toPromise=me})(S=e.Event||(e.Event={}));class E{constructor(y){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${y}_${E._idPool++}`}start(y){this._stopWatch=new _.StopWatch(!0),this._listenerCount=y}stop(){if(this._stopWatch){const y=this._stopWatch.elapsed();this._elapsedOverall+=y,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${y.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let k=-1;function i(f){const y=k;return k=f,{dispose(){k=y}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(y,l=Math.random().toString(18).slice(2,5)){this.customThreshold=y,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(y){let l=k;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||y<l)return;this._stacks||(this._stacks=new Map);const m=new Error().stack.split(`
`).slice(3).join(`
`),h=this._stacks.get(m)||0;if(this._stacks.set(m,h+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,n=0;for(const[r,s]of this._stacks)(!t||n<s)&&(t=r,n=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${n}):`),console.warn(t)}return()=>{const t=this._stacks.get(m)||0;this._stacks.set(m,t-1)}}}class d{constructor(y){var l;this._disposed=!1,this._options=y,this._leakageMon=k>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new E(this._options._profName):void 0}get event(){return this._event||(this._event=(y,l,m)=>{var h;this._listeners||(this._listeners=new T.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const n=this._listeners.push(l?[y,l]:y);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,y,l);const r=(h=this._leakageMon)===null||h===void 0?void 0:h.check(this._listeners.size);let s;return s={dispose:()=>{r&&r(),s.dispose=d._noop,this._disposed||(n(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},m instanceof D.DisposableStore?m.add(s):Array.isArray(m)&&m.push(s),s}),this._event}fire(y){var l,m;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new T.LinkedList);for(let h of this._listeners)this._deliveryQueue.push([h,y]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[h,t]=this._deliveryQueue.shift();try{typeof h=="function"?h.call(void 0,t):h[0].call(h[1],t)}catch(n){(0,p.onUnexpectedError)(n)}}(m=this._perfMon)===null||m===void 0||m.stop()}}dispose(){var y,l,m,h,t;this._disposed||(this._disposed=!0,(y=this._listeners)===null||y===void 0||y.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(h=(m=this._options)===null||m===void 0?void 0:m.onLastListenerRemove)===null||h===void 0||h.call(m),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=d,d._noop=function(){};class g extends d{constructor(y){super(y);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=y==null?void 0:y.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const y=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(y))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(y){this._listeners&&(this._isPaused!==0?this._eventQueue.push(y):super.fire(y))}}e.PauseableEmitter=g;class o{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(y){const l={event:y,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const m=()=>{this.hasListeners&&this.unhook(l);const h=this.events.indexOf(l);this.events.splice(h,1)};return(0,D.toDisposable)((0,R.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(y=>this.hook(y))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(y=>this.unhook(y))}hook(y){y.listener=y.event(l=>this.emitter.fire(l))}unhook(y){y.listener&&y.listener.dispose(),y.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=o;class a{constructor(){this.buffers=[]}wrapEvent(y){return(l,m,h)=>y(t=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>l.call(m,t)):l.call(m,t)},void 0,h)}bufferEvents(y){const l=[];this.buffers.push(l);const m=y();return this.buffers.pop(),l.forEach(h=>h()),m}}e.EventBufferer=a;class w{constructor(){this.listening=!1,this.inputEvent=S.None,this.inputEventListener=D.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(y){this.inputEvent=y,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=y(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=w}),define(be[20],_e([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(S,E){const k=setTimeout(S.bind(E),0);return{dispose(){clearTimeout(k)}}});var D;(function(S){function E(k){return k===S.None||k===S.Cancelled||k instanceof T?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}S.isCancellationToken=E,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(D=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(E){this._token=void 0,this._parentListener=void 0,this._parentListener=E&&E.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=D.Cancelled}dispose(E=!1){E&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=_}),define(be[35],_e([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(I){const d=this._icons.get(I.id);d?I.description?d.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new R;e.iconRegistry=D;function T(i,I){return new S(i,I)}e.registerCodicon=T;function _(i){return i?i.replace(/\$\((.*?)\)/g,(I,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=_;class S{constructor(I,d,g){this.id=I,this.definition=d,this.description=g,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=S;function E(i,I){const d=["codicon","codicon-"+i];return I&&d.push("codicon-modifier-"+I),d}e.getClassNamesArray=E;var k;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function d(a){if(a instanceof S)return["codicon","codicon-"+a.id];const w=I.exec(a.id);if(!w)return d(S.error);let[,f,y]=w;const l=["codicon","codicon-"+f];return y&&l.push("codicon-modifier-"+y.substr(1)),l}i.asClassNameArray=d;function g(a){return d(a).join(" ")}i.asClassName=g;function o(a){return"."+d(a).join(".")}i.asCSSSelector=o})(k=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",{fontCharacter:"\\ea60"}),i.gistNew=new i("gist-new",{fontCharacter:"\\ea60"}),i.repoCreate=new i("repo-create",{fontCharacter:"\\ea60"}),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eb0a"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition)}(S=e.Codicon||(e.Codicon={}))}),define(be[111],_e([0,1,13,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(l){const m=l;return m?[m.on,m.pause,m.resume,m.destroy].every(h=>typeof h=="function"):!1}e.isReadableStream=D;function T(l){const m=l;return m?D(m.stream)&&Array.isArray(m.buffer)&&typeof m.ended=="boolean":!1}e.isReadableBufferedStream=T;function _(l,m){return new S(l,m)}e.newWriteableStream=_;class S{constructor(m,h){this.reducer=m,this.options=h,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(m){var h;if(!this.state.destroyed){if(this.state.flowing)this.emitData(m);else if(this.buffer.data.push(m),typeof((h=this.options)===null||h===void 0?void 0:h.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(m){this.state.destroyed||(this.state.flowing?this.emitError(m):this.buffer.error.push(m))}end(m){this.state.destroyed||(typeof m!="undefined"&&this.write(m),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(m){this.listeners.data.slice(0).forEach(h=>h(m))}emitError(m){this.listeners.error.length===0?(0,p.onUnexpectedError)(m):this.listeners.error.slice(0).forEach(h=>h(m))}emitEnd(){this.listeners.end.slice(0).forEach(m=>m())}on(m,h){if(!this.state.destroyed)switch(m){case"data":this.listeners.data.push(h),this.resume();break;case"end":this.listeners.end.push(h),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(h),this.state.flowing&&this.flowErrors();break}}removeListener(m,h){if(this.state.destroyed)return;let t;switch(m){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const n=t.indexOf(h);n>=0&&t.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const m=this.reducer(this.buffer.data);this.emitData(m),this.buffer.data.length=0;const h=[...this.pendingWritePromises];this.pendingWritePromises.length=0,h.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const m of this.buffer.error)this.emitError(m);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function E(l,m){const h=[];let t;for(;(t=l.read())!==null;)h.push(t);return m(h)}e.consumeReadable=E;function k(l,m,h){const t=[];let n;for(;(n=l.read())!==null&&t.length<h;)t.push(n);return n===null&&t.length>0?m(t):{read:()=>{if(t.length>0)return t.shift();if(typeof n!="undefined"){const r=n;return n=void 0,r}return l.read()}}}e.peekReadable=k;function i(l,m){return new Promise((h,t)=>{const n=[];I(l,{onData:r=>{m&&n.push(r)},onError:r=>{m?t(r):h(void 0)},onEnd:()=>{h(m?m(n):void 0)}})})}e.consumeStream=i;function I(l,m){l.on("error",h=>m.onError(h)),l.on("end",()=>m.onEnd()),l.on("data",h=>m.onData(h))}e.listenStream=I;function d(l,m){return new Promise((h,t)=>{const n=new R.DisposableStore,r=[],s=b=>{if(r.push(b),r.length>m)return n.dispose(),l.pause(),h({stream:l,buffer:r,ended:!1})},u=b=>t(b),v=()=>h({stream:l,buffer:r,ended:!0});n.add((0,R.toDisposable)(()=>l.removeListener("error",u))),l.on("error",u),n.add((0,R.toDisposable)(()=>l.removeListener("end",v))),l.on("end",v),n.add((0,R.toDisposable)(()=>l.removeListener("data",s))),l.on("data",s)})}e.peekStream=d;function g(l,m){const h=_(m);return h.end(l),h}e.toStream=g;function o(){const l=_(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=o;function a(l){let m=!1;return{read:()=>m?null:(m=!0,l)}}e.toReadable=a;function w(l,m,h){const t=_(h);return I(l,{onData:n=>t.write(m.data(n)),onError:n=>t.error(m.error?m.error(n):n),onEnd:()=>t.end()}),t}e.transform=w;function f(l,m,h){let t=!1;return{read:()=>{const n=m.read();return t?n:(t=!0,n!==null?h([l,n]):l)}}}e.prefixedReadable=f;function y(l,m,h){let t=!1;const n=_(h);return I(m,{onData:r=>t?n.write(r):(t=!0,n.write(h([l,r]))),onError:r=>n.error(r),onEnd:()=>{t||(t=!0,n.write(l)),n.end()}}),n}e.prefixedStream=y}),define(be[8],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(O){return!O||typeof O!="string"?!0:O.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function D(O,...J){return J.length===0?O:O.replace(R,function(oe,Ce){const ke=parseInt(Ce,10);return isNaN(ke)||ke<0||ke>=J.length?oe:J[ke]})}e.format=D;function T(O){return O.replace(/[<>&]/g,function(J){switch(J){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return J}})}e.escape=T;function _(O){return O.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=_;function S(O,J){let oe=0;const Ce=J.charCodeAt(0);for(let ke=O.length-1;ke>=0;ke--)O.charCodeAt(ke)===Ce&&oe++;return oe}e.count=S;function E(O,J,oe="\u2026"){return O.length<=J?O:`${O.substr(0,J)}${oe}`}e.truncate=E;function k(O,J=" "){const oe=i(O,J);return I(oe,J)}e.trim=k;function i(O,J){if(!O||!J)return O;const oe=J.length;if(oe===0||O.length===0)return O;let Ce=0;for(;O.indexOf(J,Ce)===Ce;)Ce=Ce+oe;return O.substring(Ce)}e.ltrim=i;function I(O,J){if(!O||!J)return O;const oe=J.length,Ce=O.length;if(oe===0||Ce===0)return O;let ke=Ce,Ne=-1;for(;Ne=O.lastIndexOf(J,ke-1),!(Ne===-1||Ne+oe!==ke);){if(Ne===0)return"";ke=Ne}return O.substring(0,ke)}e.rtrim=I;function d(O){return O.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function g(O){return O.replace(/\*/g,"")}e.stripWildcards=g;function o(O,J,oe={}){if(!O)throw new Error("Cannot create regex from empty string");J||(O=_(O)),oe.wholeWord&&(/\B/.test(O.charAt(0))||(O="\\b"+O),/\B/.test(O.charAt(O.length-1))||(O=O+"\\b"));let Ce="";return oe.global&&(Ce+="g"),oe.matchCase||(Ce+="i"),oe.multiline&&(Ce+="m"),oe.unicode&&(Ce+="u"),new RegExp(O,Ce)}e.createRegExp=o;function a(O){return O.source==="^"||O.source==="^$"||O.source==="$"||O.source==="^\\s*$"?!1:!!(O.exec("")&&O.lastIndex===0)}e.regExpLeadsToEndlessLoop=a;function w(O){return!!O.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=w;function f(O){return(O.global?"g":"")+(O.ignoreCase?"i":"")+(O.multiline?"m":"")+(O.unicode?"u":"")}e.regExpFlags=f;function y(O){return O.split(/\r\n|\r|\n/)}e.splitLines=y;function l(O){for(let J=0,oe=O.length;J<oe;J++){const Ce=O.charCodeAt(J);if(Ce!==32&&Ce!==9)return J}return-1}e.firstNonWhitespaceIndex=l;function m(O,J=0,oe=O.length){for(let Ce=J;Ce<oe;Ce++){const ke=O.charCodeAt(Ce);if(ke!==32&&ke!==9)return O.substring(J,Ce)}return O.substring(J,oe)}e.getLeadingWhitespace=m;function h(O,J=O.length-1){for(let oe=J;oe>=0;oe--){const Ce=O.charCodeAt(oe);if(Ce!==32&&Ce!==9)return oe}return-1}e.lastNonWhitespaceIndex=h;function t(O,J){return O<J?-1:O>J?1:0}e.compare=t;function n(O,J,oe=0,Ce=O.length,ke=0,Ne=J.length){for(;oe<Ce&&ke<Ne;oe++,ke++){let rt=O.charCodeAt(oe),tt=J.charCodeAt(ke);if(rt<tt)return-1;if(rt>tt)return 1}const Oe=Ce-oe,qe=Ne-ke;return Oe<qe?-1:Oe>qe?1:0}e.compareSubstring=n;function r(O,J){return s(O,J,0,O.length,0,J.length)}e.compareIgnoreCase=r;function s(O,J,oe=0,Ce=O.length,ke=0,Ne=J.length){for(;oe<Ce&&ke<Ne;oe++,ke++){let rt=O.charCodeAt(oe),tt=J.charCodeAt(ke);if(rt===tt)continue;const Je=rt-tt;if(!(Je===32&&v(tt))&&!(Je===-32&&v(rt)))return u(rt)&&u(tt)?Je:n(O.toLowerCase(),J.toLowerCase(),oe,Ce,ke,Ne)}const Oe=Ce-oe,qe=Ne-ke;return Oe<qe?-1:Oe>qe?1:0}e.compareSubstringIgnoreCase=s;function u(O){return O>=97&&O<=122}e.isLowerAsciiLetter=u;function v(O){return O>=65&&O<=90}e.isUpperAsciiLetter=v;function b(O){return u(O)||v(O)}function P(O,J){return O.length===J.length&&C(O,J)}e.equalsIgnoreCase=P;function C(O,J,oe=O.length){for(let Ce=0;Ce<oe;Ce++){const ke=O.charCodeAt(Ce),Ne=J.charCodeAt(Ce);if(ke!==Ne){if(b(ke)&&b(Ne)){const Oe=Math.abs(ke-Ne);if(Oe!==0&&Oe!==32)return!1}else if(String.fromCharCode(ke).toLowerCase()!==String.fromCharCode(Ne).toLowerCase())return!1}}return!0}function c(O,J){const oe=J.length;return J.length>O.length?!1:C(O,J,oe)}e.startsWithIgnoreCase=c;function F(O,J){let oe,Ce=Math.min(O.length,J.length);for(oe=0;oe<Ce;oe++)if(O.charCodeAt(oe)!==J.charCodeAt(oe))return oe;return Ce}e.commonPrefixLength=F;function N(O,J){let oe,Ce=Math.min(O.length,J.length);const ke=O.length-1,Ne=J.length-1;for(oe=0;oe<Ce;oe++)if(O.charCodeAt(ke-oe)!==J.charCodeAt(Ne-oe))return oe;return Ce}e.commonSuffixLength=N;function z(O){return 55296<=O&&O<=56319}e.isHighSurrogate=z;function he(O){return 56320<=O&&O<=57343}e.isLowSurrogate=he;function me(O,J){return(O-55296<<10)+(J-56320)+65536}e.computeCodePoint=me;function Q(O,J,oe){const Ce=O.charCodeAt(oe);if(z(Ce)&&oe+1<J){const ke=O.charCodeAt(oe+1);if(he(ke))return me(Ce,ke)}return Ce}e.getNextCodePoint=Q;function W(O,J){const oe=O.charCodeAt(J-1);if(he(oe)&&J>1){const Ce=O.charCodeAt(J-2);if(z(Ce))return me(Ce,oe)}return oe}function x(O,J){const oe=Be.getInstance(),Ce=J,ke=O.length,Ne=Q(O,ke,J);J+=Ne>=65536?2:1;let Oe=oe.getGraphemeBreakType(Ne);for(;J<ke;){const qe=Q(O,ke,J),rt=oe.getGraphemeBreakType(qe);if(Me(Oe,rt))break;J+=qe>=65536?2:1,Oe=rt}return J-Ce}e.nextCharLength=x;function A(O,J){const oe=Be.getInstance(),Ce=J,ke=W(O,J);J-=ke>=65536?2:1;let Ne=oe.getGraphemeBreakType(ke);for(;J>0;){const Oe=W(O,J),qe=oe.getGraphemeBreakType(Oe);if(Me(qe,Ne))break;J-=Oe>=65536?2:1,Ne=qe}return Ce-J}e.prevCharLength=A;function U(O,J){const oe=Be.getInstance(),Ce=O.length,ke=J,Ne=Q(O,Ce,J),Oe=oe.getGraphemeBreakType(Ne);J+=Ne>=65536?2:1;let qe=Oe;for(;J<Ce;){const tt=Q(O,Ce,J),Je=oe.getGraphemeBreakType(tt);if(Me(qe,Je))break;J+=tt>=65536?2:1,qe=Je}const rt=J;for(J=ke,qe=Oe;J>0;){const tt=W(O,J),Je=oe.getGraphemeBreakType(tt);if(Me(Je,qe))break;J-=tt>=65536?2:1,qe=Je}return[J,rt]}function M(O,J){return J>0&&he(O.charCodeAt(J))?U(O,J-1):U(O,J)}e.getCharContainingOffset=M;function $(O){const J=O.length;let oe=0,Ce=0;for(;Ce<J;){const Oe=Q(O,J,Ce);Ce+=Oe>=65536?2:1,Oe<128?oe+=1:Oe<2048?oe+=2:Oe<65536?oe+=3:oe+=4}const ke=new Uint8Array(oe);Ce=0;let Ne=0;for(;Ce<J;){const Oe=Q(O,J,Ce);Ce+=Oe>=65536?2:1,Oe<128?ke[Ne++]=Oe:Oe<2048?(ke[Ne++]=192|(Oe&1984)>>>6,ke[Ne++]=128|(Oe&63)>>>0):Oe<65536?(ke[Ne++]=224|(Oe&61440)>>>12,ke[Ne++]=128|(Oe&4032)>>>6,ke[Ne++]=128|(Oe&63)>>>0):(ke[Ne++]=240|(Oe&1835008)>>>18,ke[Ne++]=128|(Oe&258048)>>>12,ke[Ne++]=128|(Oe&4032)>>>6,ke[Ne++]=128|(Oe&63)>>>0)}return ke}e.encodeUTF8=$;function K(O){const J=O.byteLength,oe=[];let Ce=0;for(;Ce<J;){const ke=O[Ce];let Ne;if(ke>=240&&Ce+3<J?Ne=(O[Ce++]&7)<<18>>>0|(O[Ce++]&63)<<12>>>0|(O[Ce++]&63)<<6>>>0|(O[Ce++]&63)<<0>>>0:ke>=224&&Ce+2<J?Ne=(O[Ce++]&15)<<12>>>0|(O[Ce++]&63)<<6>>>0|(O[Ce++]&63)<<0>>>0:ke>=192&&Ce+1<J?Ne=(O[Ce++]&31)<<6>>>0|(O[Ce++]&63)<<0>>>0:Ne=O[Ce++],Ne>=0&&Ne<=55295||Ne>=57344&&Ne<=65535)oe.push(String.fromCharCode(Ne));else if(Ne>=65536&&Ne<=1114111){const Oe=Ne-65536,qe=55296+((Oe&1047552)>>>10),rt=56320+((Oe&1023)>>>0);oe.push(String.fromCharCode(qe)),oe.push(String.fromCharCode(rt))}else oe.push(String.fromCharCode(65533))}return oe.join("")}e.decodeUTF8=K;const j=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function ae(O){return j.test(O)}e.containsRTL=ae;const we=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function Re(O){return we.test(O)}e.containsEmoji=Re;const xe=/^[\t\n\r\x20-\x7E]*$/;function Le(O){return xe.test(O)}e.isBasicASCII=Le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Ve(O){return e.UNUSUAL_LINE_TERMINATORS.test(O)}e.containsUnusualLineTerminators=Ve;function Qe(O){for(let J=0,oe=O.length;J<oe;J++)if(Ke(O.charCodeAt(J)))return!0;return!1}e.containsFullWidthCharacter=Qe;function Ke(O){return O=+O,O>=11904&&O<=55215||O>=63744&&O<=64255||O>=65281&&O<=65374}e.isFullWidthCharacter=Ke;function Ge(O){return O>=127462&&O<=127487||O===8986||O===8987||O===9200||O===9203||O>=9728&&O<=10175||O===11088||O===11093||O>=127744&&O<=128591||O>=128640&&O<=128764||O>=128992&&O<=129003||O>=129280&&O<=129535||O>=129648&&O<=129750}e.isEmojiImprecise=Ge;function H(O,J){if(O.length<J)return O;const oe=/\b/g;let Ce=0;for(;oe.test(O)&&!(O.length-oe.lastIndex<J);)Ce=oe.lastIndex,oe.lastIndex+=1;return O.substring(Ce).replace(/^\s/,"")}e.lcut=H;const Y=/\x1B\x5B[12]?K/g,ne=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function G(O){return O&&(O=O.replace(Y,""),O=O.replace(ne,""),O=O.replace(re,"")),O}e.removeAnsiEscapeCodes=G,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function se(O){return!!(O&&O.length>0&&O.charCodeAt(0)===65279)}e.startsWithUTF8BOM=se;function fe(O){return se(O)?O.substr(1):O}e.stripUTF8BOM=fe;function Ae(O,J){if(!O||!J||O.length<J.length)return!1;const oe=J.length,Ce=O.toLowerCase();let ke=0,Ne=-1;for(;ke<oe;){const Oe=Ce.indexOf(J[ke],Ne+1);if(Oe<0)return!1;Ne=Oe,ke++}return!0}e.fuzzyContains=Ae;function ge(O,J=!1){return O?(J&&(O=O.replace(/\\./g,"")),O.toLowerCase()!==O):!1}e.containsUppercaseCharacter=ge;function We(O){return O.charAt(0).toUpperCase()+O.slice(1)}e.uppercaseFirstLetter=We;function V(O,J=1){if(J===0)return"";let oe=-1;do oe=O.indexOf(`
`,oe+1),J--;while(J>0&&oe>=0);return oe===-1?O:(O[oe-1]==="\r"&&oe--,O.substr(0,oe))}e.getNLines=V;function te(O){const J=90-65+1;return O=O%(2*J),O<J?String.fromCharCode(97+O):String.fromCharCode(65+O-J)}e.singleLetterHash=te;function pe(O){return Be.getInstance().getGraphemeBreakType(O)}e.getGraphemeBreakType=pe;function Me(O,J){return O===0?J!==5&&J!==7:O===2&&J===3?!1:O===4||O===2||O===3||J===4||J===2||J===3?!0:!(O===8&&(J===8||J===9||J===11||J===12)||(O===11||O===9)&&(J===9||J===10)||(O===12||O===10)&&J===10||J===5||J===13||J===7||O===1||O===13&&J===14||O===6&&J===6)}e.breakBetweenGraphemeBreakType=Me;var $e;(function(O){O[O.Other=0]="Other",O[O.Prepend=1]="Prepend",O[O.CR=2]="CR",O[O.LF=3]="LF",O[O.Control=4]="Control",O[O.Extend=5]="Extend",O[O.Regional_Indicator=6]="Regional_Indicator",O[O.SpacingMark=7]="SpacingMark",O[O.L=8]="L",O[O.V=9]="V",O[O.T=10]="T",O[O.LV=11]="LV",O[O.LVT=12]="LVT",O[O.ZWJ=13]="ZWJ",O[O.Extended_Pictographic=14]="Extended_Pictographic"})($e=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Be{constructor(){this._data=Ye()}static getInstance(){return Be._INSTANCE||(Be._INSTANCE=new Be),Be._INSTANCE}getGraphemeBreakType(J){if(J<32)return J===10?3:J===13?2:4;if(J<127)return 0;const oe=this._data,Ce=oe.length/3;let ke=1;for(;ke<=Ce;)if(J<oe[3*ke])ke=2*ke;else if(J>oe[3*ke+1])ke=2*ke+1;else return oe[3*ke+2];return 0}}Be._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(O,J){if(O===0)return 0;const oe=ye(O,J);if(oe!==void 0)return oe;const Ce=W(J,O);return O-=De(Ce),O}e.getLeftDeleteOffset=Se;function ye(O,J){let oe=W(J,O);for(O-=De(oe);ie(oe)||oe===65039||oe===8419;){if(O===0)return;oe=W(J,O),O-=De(oe)}if(!!Ge(oe)){if(O>=0){const Ce=W(J,O);Ce===8205&&(O-=De(Ce))}return O}}function De(O){return O>=65536?2:1}function ie(O){return 127995<=O&&O<=127999}var ue;(function(O){O[O.zwj=8205]="zwj",O[O.emojiVariantSelector=65039]="emojiVariantSelector",O[O.enclosingKeyCap=8419]="enclosingKeyCap"})(ue||(ue={}))}),define(be[25],_e([0,1,8,111]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const D=typeof Buffer!="undefined",T=typeof TextEncoder!="undefined",_=typeof TextDecoder!="undefined";let S,E;class k{constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}static alloc(b){return D?new k(Buffer.allocUnsafe(b)):new k(new Uint8Array(b))}static wrap(b){return D&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new k(b)}static fromString(b,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&D?new k(Buffer.from(b)):T?(S||(S=new TextEncoder),new k(S.encode(b))):new k(p.encodeUTF8(b))}static concat(b,P){if(typeof P=="undefined"){P=0;for(let F=0,N=b.length;F<N;F++)P+=b[F].byteLength}const C=k.alloc(P);let c=0;for(let F=0,N=b.length;F<N;F++){const z=b[F];C.set(z,c),c+=z.byteLength}return C}toString(){return D?this.buffer.toString():_?(E||(E=new TextDecoder),E.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(b,P){return new k(this.buffer.subarray(b,P))}set(b,P){b instanceof k?this.buffer.set(b.buffer,P):this.buffer.set(b,P)}readUInt32BE(b){return d(this.buffer,b)}writeUInt32BE(b,P){g(this.buffer,b,P)}readUInt32LE(b){return o(this.buffer,b)}writeUInt32LE(b,P){a(this.buffer,b,P)}readUInt8(b){return w(this.buffer,b)}writeUInt8(b,P){f(this.buffer,b,P)}}e.VSBuffer=k;function i(v,b){return v[b+0]<<0>>>0|v[b+1]<<8>>>0}e.readUInt16LE=i;function I(v,b,P){v[P+0]=b&255,b=b>>>8,v[P+1]=b&255}e.writeUInt16LE=I;function d(v,b){return v[b]*2**24+v[b+1]*2**16+v[b+2]*2**8+v[b+3]}e.readUInt32BE=d;function g(v,b,P){v[P+3]=b,b=b>>>8,v[P+2]=b,b=b>>>8,v[P+1]=b,b=b>>>8,v[P]=b}e.writeUInt32BE=g;function o(v,b){return v[b+0]<<0>>>0|v[b+1]<<8>>>0|v[b+2]<<16>>>0|v[b+3]<<24>>>0}e.readUInt32LE=o;function a(v,b,P){v[P+0]=b&255,b=b>>>8,v[P+1]=b&255,b=b>>>8,v[P+2]=b&255,b=b>>>8,v[P+3]=b&255}e.writeUInt32LE=a;function w(v,b){return v[b]}e.readUInt8=w;function f(v,b,P){v[P]=b}e.writeUInt8=f;function y(v){return R.consumeReadable(v,b=>k.concat(b))}e.readableToBuffer=y;function l(v){return R.toReadable(v)}e.bufferToReadable=l;function m(v){return R.consumeStream(v,b=>k.concat(b))}e.streamToBuffer=m;async function h(v){return v.ended?k.concat(v.buffer):k.concat([...v.buffer,await m(v.stream)])}e.bufferedStreamToBuffer=h;function t(v){return R.toStream(v,b=>k.concat(b))}e.bufferToStream=t;function n(v){return R.transform(v,{data:b=>typeof b=="string"?k.fromString(b):k.wrap(b)},b=>k.concat(b))}e.streamToBufferReadableStream=n;function r(v){return R.newWriteableStream(b=>k.concat(b),v)}e.newWriteableBufferStream=r;function s(v,b){return R.prefixedReadable(v,b,P=>k.concat(P))}e.prefixedBufferReadable=s;function u(v,b){return R.prefixedStream(v,b,P=>k.concat(P))}e.prefixedBufferStream=u}),define(be[57],_e([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(f){return D(f,0)}e.hash=R;function D(f,y){switch(typeof f){case"object":return f===null?T(349,y):Array.isArray(f)?E(f,y):k(f,y);case"string":return S(f,y);case"boolean":return _(f,y);case"number":return T(f,y);case"undefined":return T(937,y);default:return T(617,y)}}e.doHash=D;function T(f,y){return(y<<5)-y+f|0}function _(f,y){return T(f?433:863,y)}function S(f,y){y=T(149417,y);for(let l=0,m=f.length;l<m;l++)y=T(f.charCodeAt(l),y);return y}e.stringHash=S;function E(f,y){return y=T(104579,y),f.reduce((l,m)=>D(m,l),y)}function k(f,y){return y=T(181387,y),Object.keys(f).sort().reduce((l,m)=>(l=S(m,l),D(f[m],l)),y)}class i{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=D(y,this._value),this._value}}e.Hasher=i;var I;(function(f){f[f.BLOCK_SIZE=64]="BLOCK_SIZE",f[f.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function d(f,y,l=32){const m=l-y,h=~((1<<m)-1);return(f<<y|(h&f)>>>m)>>>0}function g(f,y=0,l=f.byteLength,m=0){for(let h=0;h<l;h++)f[y+h]=m}function o(f,y,l="0"){for(;f.length<y;)f=l+f;return f}function a(f,y=32){return f instanceof ArrayBuffer?Array.from(new Uint8Array(f)).map(l=>l.toString(16).padStart(2,"0")).join(""):o((f>>>0).toString(16),y/4)}e.toHexString=a;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const l=y.length;if(l===0)return;const m=this._buff;let h=this._buffLen,t=this._leftoverHighSurrogate,n,r;for(t!==0?(n=t,r=-1,t=0):(n=y.charCodeAt(0),r=0);;){let s=n;if(p.isHighSurrogate(n))if(r+1<l){const u=y.charCodeAt(r+1);p.isLowSurrogate(u)?(r++,s=p.computeCodePoint(n,u)):s=65533}else{t=n;break}else p.isLowSurrogate(n)&&(s=65533);if(h=this._push(m,h,s),r++,r<l)n=y.charCodeAt(r);else break}this._buffLen=h,this._leftoverHighSurrogate=t}_push(y,l,m){return m<128?y[l++]=m:m<2048?(y[l++]=192|(m&1984)>>>6,y[l++]=128|(m&63)>>>0):m<65536?(y[l++]=224|(m&61440)>>>12,y[l++]=128|(m&4032)>>>6,y[l++]=128|(m&63)>>>0):(y[l++]=240|(m&1835008)>>>18,y[l++]=128|(m&258048)>>>12,y[l++]=128|(m&4032)>>>6,y[l++]=128|(m&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),a(this._h0)+a(this._h1)+a(this._h2)+a(this._h3)+a(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,g(this._buff,this._buffLen),this._buffLen>56&&(this._step(),g(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=w._bigBlock32,l=this._buffDV;for(let b=0;b<64;b+=4)y.setUint32(b,l.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)y.setUint32(b,d(y.getUint32(b-12,!1)^y.getUint32(b-32,!1)^y.getUint32(b-56,!1)^y.getUint32(b-64,!1),1),!1);let m=this._h0,h=this._h1,t=this._h2,n=this._h3,r=this._h4,s,u,v;for(let b=0;b<80;b++)b<20?(s=h&t|~h&n,u=1518500249):b<40?(s=h^t^n,u=1859775393):b<60?(s=h&t|h&n|t&n,u=2400959708):(s=h^t^n,u=3395469782),v=d(m,5)+s+r+u+y.getUint32(b*4,!1)&4294967295,r=n,n=t,t=d(h,30),h=m,m=v;this._h0=this._h0+m&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+r&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(be[47],_e([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(R||(R={})),function(D){const T="error",_="warning",S="warn",E="info",k="ignore";function i(d){return d?p.equalsIgnoreCase(T,d)?D.Error:p.equalsIgnoreCase(_,d)||p.equalsIgnoreCase(S,d)?D.Warning:p.equalsIgnoreCase(E,d)?D.Info:D.Ignore:D.Ignore}D.fromValue=i;function I(d){switch(d){case D.Error:return T;case D.Warning:return _;case D.Info:return E;default:return k}}D.toString=I}(R||(R={})),e.default=R}),define(be[9],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(b){return Array.isArray(b)}e.isArray=p;function R(b){return typeof b=="string"}e.isString=R;function D(b){return Array.isArray(b)&&b.every(P=>R(P))}e.isStringArray=D;function T(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}e.isObject=T;function _(b){return typeof b=="number"&&!isNaN(b)}e.isNumber=_;function S(b){return!!b&&typeof b[Symbol.iterator]=="function"}e.isIterable=S;function E(b){return b===!0||b===!1}e.isBoolean=E;function k(b){return typeof b=="undefined"}e.isUndefined=k;function i(b){return!I(b)}e.isDefined=i;function I(b){return k(b)||b===null}e.isUndefinedOrNull=I;function d(b,P){if(!b)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=d;function g(b){if(I(b))throw new Error("Assertion Failed: argument is undefined or null");return b}e.assertIsDefined=g;function o(...b){const P=[];for(let C=0;C<b.length;C++){const c=b[C];if(I(c))throw new Error(`Assertion Failed: argument at index ${C} is undefined or null`);P.push(c)}return P}e.assertAllDefined=o;const a=Object.prototype.hasOwnProperty;function w(b){if(!T(b))return!1;for(let P in b)if(a.call(b,P))return!1;return!0}e.isEmptyObject=w;function f(b){return typeof b=="function"}e.isFunction=f;function y(...b){return b.length>0&&b.every(f)}e.areFunctions=y;function l(b,P){const C=Math.min(b.length,P.length);for(let c=0;c<C;c++)m(b[c],P[c])}e.validateConstraints=l;function m(b,P){if(R(P)){if(typeof b!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(f(P)){try{if(b instanceof P)return}catch(C){}if(!I(b)&&b.constructor===P||P.length===1&&P.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=m;function h(b){let P=[],C=Object.getPrototypeOf(b);for(;Object.prototype!==C;)P=P.concat(Object.getOwnPropertyNames(C)),C=Object.getPrototypeOf(C);return P}e.getAllPropertyNames=h;function t(b){const P=[];for(const C of h(b))typeof b[C]=="function"&&P.push(C);return P}e.getAllMethodNames=t;function n(b,P){const C=F=>function(){const N=Array.prototype.slice.call(arguments,0);return P(F,N)};let c={};for(const F of b)c[F]=C(F);return c}e.createProxyObject=n;function r(b){return b===null?void 0:b}e.withNullAsUndefined=r;function s(b){return typeof b=="undefined"?null:b}e.withUndefinedAsNull=s;function u(b){return class{constructor(){return new Proxy({},{get(P,C){if(P[C])return P[C];throw new Error(`Not Implemented: ${b}->${String(C)}`)}})}}}e.NotImplementedProxy=u;function v(b){throw new Error("Unreachable")}e.assertNever=v}),define(be[36],_e([0,1,21,8,12,9]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function _(r){return r===47||r===92}e.isPathSeparator=_;function S(r){return r.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=S;function E(r){return r.indexOf("/")===-1&&(r=S(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function k(r,s=D.posix.sep){if(!r)return"";const u=r.length,v=r.charCodeAt(0);if(_(v)){if(_(r.charCodeAt(1))&&!_(r.charCodeAt(2))){let P=3;const C=P;for(;P<u&&!_(r.charCodeAt(P));P++);if(C!==P&&!_(r.charCodeAt(P+1))){for(P+=1;P<u;P++)if(_(r.charCodeAt(P)))return r.slice(0,P+1).replace(/[\\/]/g,s)}}return s}else if(f(v)&&r.charCodeAt(1)===58)return _(r.charCodeAt(2))?r.slice(0,2)+s:r.slice(0,2);let b=r.indexOf("://");if(b!==-1){for(b+=3;b<u;b++)if(_(r.charCodeAt(b)))return r.slice(0,b+1)}return""}e.getRoot=k;function i(r){if(!p.isWindows||!r||r.length<5)return!1;let s=r.charCodeAt(0);if(s!==92||(s=r.charCodeAt(1),s!==92))return!1;let u=2;const v=u;for(;u<r.length&&(s=r.charCodeAt(u),s!==92);u++);return!(v===u||(s=r.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function o(r,s=p.isWindows){const u=s?I:d;return!(!r||r.length===0||/^\s+$/.test(r)||(u.lastIndex=0,u.test(r))||s&&g.test(r)||r==="."||r===".."||s&&r[r.length-1]==="."||s&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=o;function a(r,s,u){const v=r===s;return!u||v?v:!r||!s?!1:(0,R.equalsIgnoreCase)(r,s)}e.isEqual=a;function w(r,s,u,v=D.sep){if(r===s)return!0;if(!r||!s||s.length>r.length)return!1;if(u){if(!(0,R.startsWithIgnoreCase)(r,s))return!1;if(s.length===r.length)return!0;let P=s.length;return s.charAt(s.length-1)===v&&P--,r.charAt(P)===v}return s.charAt(s.length-1)!==v&&(s+=v),r.indexOf(s)===0}e.isEqualOrParent=w;function f(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=f;function y(r,s){return p.isWindows&&r.endsWith(":")&&(r+=D.sep),(0,D.isAbsolute)(r)||(r=(0,D.join)(s,r)),r=(0,D.normalize)(r),p.isWindows?(r=(0,R.rtrim)(r,D.sep),r.endsWith(":")&&(r+=D.sep)):(r=(0,R.rtrim)(r,D.sep),r||(r=D.sep)),r}e.sanitizeFilePath=y;function l(r){const s=(0,D.normalize)(r);return p.isWindows?r.length>3?!1:m(s)&&(r.length===2||s.charCodeAt(2)===92):s===D.posix.sep}e.isRootOrDriveLetter=l;function m(r){return p.isWindows?f(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=m;function h(r){return m(r)?r[0]:void 0}e.getDriveLetter=h;function t(r,s,u){return s.length>r.length?-1:r===s?0:(u&&(r=r.toLowerCase(),s=s.toLowerCase()),r.indexOf(s))}e.indexOfPath=t;function n(r){const s=r.split(":");let u,v,b;if(s.forEach(P=>{const C=Number(P);(0,T.isNumber)(C)?v===void 0?v=C:b===void 0&&(b=C):u=u?[u,P].join(":"):P}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:v!==void 0?v:void 0,column:b!==void 0?b:v!==void 0?1:void 0}}e.parseLineAndColumnAware=n}),define(be[23],_e([0,1,9]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(a){if(!a||typeof a!="object"||a instanceof RegExp)return a;const w=Array.isArray(a)?[]:{};return Object.keys(a).forEach(f=>{a[f]&&typeof a[f]=="object"?w[f]=R(a[f]):w[f]=a[f]}),w}e.deepClone=R;function D(a){if(!a||typeof a!="object")return a;const w=[a];for(;w.length>0;){const f=w.shift();Object.freeze(f);for(const y in f)if(T.call(f,y)){const l=f[y];typeof l=="object"&&!Object.isFrozen(l)&&w.push(l)}}return a}e.deepFreeze=D;const T=Object.prototype.hasOwnProperty;function _(a,w){return S(a,w,new Set)}e.cloneAndChange=_;function S(a,w,f){if((0,p.isUndefinedOrNull)(a))return a;const y=w(a);if(typeof y!="undefined")return y;if((0,p.isArray)(a)){const l=[];for(const m of a)l.push(S(m,w,f));return l}if((0,p.isObject)(a)){if(f.has(a))throw new Error("Cannot clone recursive data-structure");f.add(a);const l={};for(let m in a)T.call(a,m)&&(l[m]=S(a[m],w,f));return f.delete(a),l}return a}function E(a,w,f=!0){return(0,p.isObject)(a)?((0,p.isObject)(w)&&Object.keys(w).forEach(y=>{y in a?f&&((0,p.isObject)(a[y])&&(0,p.isObject)(w[y])?E(a[y],w[y],f):a[y]=w[y]):a[y]=w[y]}),a):w}e.mixin=E;function k(a,w){if(a===w)return!0;if(a==null||w===null||w===void 0||typeof a!=typeof w||typeof a!="object"||Array.isArray(a)!==Array.isArray(w))return!1;let f,y;if(Array.isArray(a)){if(a.length!==w.length)return!1;for(f=0;f<a.length;f++)if(!k(a[f],w[f]))return!1}else{const l=[];for(y in a)l.push(y);l.sort();const m=[];for(y in w)m.push(y);if(m.sort(),!k(l,m))return!1;for(f=0;f<l.length;f++)if(!k(a[l[f]],w[l[f]]))return!1}return!0}e.equals=k;function i(a){const w=new Set;return JSON.stringify(a,(f,y)=>{if((0,p.isObject)(y)||Array.isArray(y)){if(w.has(y))return"[Circular]";w.add(y)}return y})}e.safeStringify=i;function I(a,w,f){const y=w(a);return typeof y=="undefined"?f:y}e.getOrDefault=I;function d(a,w){const f=Object.create(null);return!a||!w||Object.keys(w).forEach(l=>{const m=a[l],h=w[l];k(m,h)||(f[l]=h)}),f}e.distinct=d;function g(a,w){const f=w.toLowerCase(),y=Object.keys(a).find(l=>l.toLowerCase()===f);return y?a[y]:a[w]}e.getCaseInsensitive=g;function o(a,w){const f=Object.create(null);for(const y of Object.keys(a))w(y,a[y])&&(f[y]=a[y]);return f}e.filter=o}),define(be[82],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(T){T[T.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",T[T.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",T[T.MAX_UINT_8=255]="MAX_UINT_8",T[T.MAX_UINT_16=65535]="MAX_UINT_16",T[T.MAX_UINT_32=4294967295]="MAX_UINT_32",T[T.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function R(T){return T<0?0:T>255?255:T|0}e.toUint8=R;function D(T){return T<0?0:T>4294967295?4294967295:T|0}e.toUint32=D}),define(be[2],_e([0,1,21,12]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,T=/^\//,_=/^\/\//;function S(r,s){if(!r.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!D.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!T.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function E(r,s){return!r&&!s?"file":r}function k(r,s){switch(r){case"https":case"http":case"file":s?s[0]!==I&&(s=I+s):s=I;break}return s}const i="",I="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(s,u,v,b,P,C=!1){typeof s=="object"?(this.scheme=s.scheme||i,this.authority=s.authority||i,this.path=s.path||i,this.query=s.query||i,this.fragment=s.fragment||i):(this.scheme=E(s,C),this.authority=u||i,this.path=k(this.scheme,v||i),this.query=b||i,this.fragment=P||i,S(this,C))}static isUri(s){return s instanceof g?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return l(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:v,path:b,query:P,fragment:C}=s;return u===void 0?u=this.scheme:u===null&&(u=i),v===void 0?v=this.authority:v===null&&(v=i),b===void 0?b=this.path:b===null&&(b=i),P===void 0?P=this.query:P===null&&(P=i),C===void 0?C=this.fragment:C===null&&(C=i),u===this.scheme&&v===this.authority&&b===this.path&&P===this.query&&C===this.fragment?this:new a(u,v,b,P,C)}static parse(s,u=!1){const v=d.exec(s);return v?new a(v[2]||i,n(v[4]||i),n(v[5]||i),n(v[7]||i),n(v[9]||i),u):new a(i,i,i,i,i)}static file(s){let u=i;if(p.isWindows&&(s=s.replace(/\\/g,I)),s[0]===I&&s[1]===I){const v=s.indexOf(I,2);v===-1?(u=s.substring(2),s=I):(u=s.substring(2,v),s=s.substring(v)||I)}return new a("file",u,s,i,i)}static from(s){const u=new a(s.scheme,s.authority,s.path,s.query,s.fragment);return S(u,!0),u}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return p.isWindows&&s.scheme==="file"?v=g.file(R.win32.join(l(s,!0),...u)).path:v=R.posix.join(s.path,...u),s.with({path:v})}toString(s=!1){return m(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof g)return s;{const u=new a(s);return u._formatted=s.external,u._fsPath=s._sep===o?s.fsPath:null,u}}else return s}}e.URI=g;const o=p.isWindows?1:void 0;class a extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(s=!1){return s?m(this,!0):(this._formatted||(this._formatted=m(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=o),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(r,s){let u,v=-1;for(let b=0;b<r.length;b++){const P=r.charCodeAt(b);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||s&&P===47)v!==-1&&(u+=encodeURIComponent(r.substring(v,b)),v=-1),u!==void 0&&(u+=r.charAt(b));else{u===void 0&&(u=r.substr(0,b));const C=w[P];C!==void 0?(v!==-1&&(u+=encodeURIComponent(r.substring(v,b)),v=-1),u+=C):v===-1&&(v=b)}}return v!==-1&&(u+=encodeURIComponent(r.substring(v))),u!==void 0?u:r}function y(r){let s;for(let u=0;u<r.length;u++){const v=r.charCodeAt(u);v===35||v===63?(s===void 0&&(s=r.substr(0,u)),s+=w[v]):s!==void 0&&(s+=r[u])}return s!==void 0?s:r}function l(r,s){let u;return r.authority&&r.path.length>1&&r.scheme==="file"?u=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?s?u=r.path.substr(1):u=r.path[1].toLowerCase()+r.path.substr(2):u=r.path,p.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=l;function m(r,s){const u=s?y:f;let v="",{scheme:b,authority:P,path:C,query:c,fragment:F}=r;if(b&&(v+=b,v+=":"),(P||b==="file")&&(v+=I,v+=I),P){let N=P.indexOf("@");if(N!==-1){const z=P.substr(0,N);P=P.substr(N+1),N=z.indexOf(":"),N===-1?v+=u(z,!1):(v+=u(z.substr(0,N),!1),v+=":",v+=u(z.substr(N+1),!1)),v+="@"}P=P.toLowerCase(),N=P.indexOf(":"),N===-1?v+=u(P,!1):(v+=u(P.substr(0,N),!1),v+=P.substr(N))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const N=C.charCodeAt(1);N>=65&&N<=90&&(C=`/${String.fromCharCode(N+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const N=C.charCodeAt(0);N>=65&&N<=90&&(C=`${String.fromCharCode(N+32)}:${C.substr(2)}`)}v+=u(C,!0)}return c&&(v+="?",v+=u(c,!1)),F&&(v+="#",v+=s?F:f(F,!1)),v}function h(r){try{return decodeURIComponent(r)}catch(s){return r.length>3?r.substr(0,3)+h(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(r){return r.match(t)?r.replace(t,s=>h(s)):r}});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[22],_e([0,1,2,8]),function(X,e,p,R){"use strict";var D,T,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function S(t,n,r){let s=t.get(n);return s===void 0&&(s=r,t.set(n,s)),s}e.getOrSet=S;function E(t){const n=[];return t.forEach((r,s)=>{n.push(`${s} => ${r}`)}),`Map(${t.size}) {${n.join(", ")}}`}e.mapToString=E;function k(t){const n=[];return t.forEach(r=>{n.push(r)}),`Set(${t.size}) {${n.join(", ")}}`}e.setToString=k;class i{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const r=n.charCodeAt(0),s=this._value.charCodeAt(this._pos);return r-s}value(){return this._value[this._pos]}}e.StringIterator=i;class I{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class d{constructor(n=!0,r=!0){this._splitOnBackslash=n,this._caseSensitive=r}reset(n){return this._value=n.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,R.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,R.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class o{constructor(n){this._ignorePathCasing=n,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,R.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,R.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,R.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,R.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=o;class a{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class w{constructor(n){this._iter=n}static forUris(n=()=>!1){return new w(new o(n))}static forPaths(){return new w(new d)}static forStrings(){return new w(new i)}static forConfigKeys(){return new w(new I)}clear(){this._root=void 0}set(n,r){const s=this._iter.reset(n);let u;for(this._root||(this._root=new a,this._root.segment=s.value()),u=this._root;;){const b=s.cmp(u.segment);if(b>0)u.left||(u.left=new a,u.left.segment=s.value()),u=u.left;else if(b<0)u.right||(u.right=new a,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new a,u.mid.segment=s.value()),u=u.mid;else break}const v=u.value;return u.value=r,u.key=n,v}get(n){var r;return(r=this._getNode(n))===null||r===void 0?void 0:r.value}_getNode(n){const r=this._iter.reset(n);let s=this._root;for(;s;){const u=r.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else break}return s}has(n){const r=this._getNode(n);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,r){const s=this._iter.reset(n),u=[];let v=this._root;for(;v;){const b=s.cmp(v.segment);if(b>0)u.push([1,v]),v=v.left;else if(b<0)u.push([-1,v]),v=v.right;else if(s.hasNext())s.next(),u.push([0,v]),v=v.mid;else{for(r?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;u.length>0&&v.isEmpty();){let[P,C]=u.pop();switch(P){case 1:C.left=void 0;break;case 0:C.mid=void 0;break;case-1:C.right=void 0;break}v=C}break}}}findSubstr(n){const r=this._iter.reset(n);let s=this._root,u;for(;s;){const v=r.cmp(s.segment);if(v>0)s=s.left;else if(v<0)s=s.right;else if(r.hasNext())r.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(n){const r=this._iter.reset(n);let s=this._root;for(;s;){const u=r.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(r.hasNext())r.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(n){for(const[r,s]of this)n(s,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(n){n&&(yield*this._entries(n.left),n.value&&(yield[n.key,n.value]),yield*this._entries(n.mid),yield*this._entries(n.right))}}e.TernarySearchTree=w;class f{constructor(n,r){this[D]="ResourceMap",n instanceof f?(this.map=new Map(n.map),this.toKey=r??f.defaultToKey):(this.map=new Map,this.toKey=n??f.defaultToKey)}set(n,r){return this.map.set(this.toKey(n),r),this}get(n){return this.map.get(this.toKey(n))}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,r){typeof r!="undefined"&&(n=n.bind(r));for(let[s,u]of this.map)n(u,p.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let n of this.map.keys())yield p.URI.parse(n)}*entries(){for(let n of this.map.entries())yield[p.URI.parse(n[0]),n[1]]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(let n of this.map)yield[p.URI.parse(n[0]),n[1]]}}e.ResourceMap=f,f.defaultToKey=t=>t.toString();var y;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(y=e.Touch||(e.Touch={}));class l{constructor(){this[T]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var n;return(n=this._head)===null||n===void 0?void 0:n.value}get last(){var n;return(n=this._tail)===null||n===void 0?void 0:n.value}has(n){return this._map.has(n)}get(n,r=0){const s=this._map.get(n);if(!!s)return r!==0&&this.touch(s,r),s.value}set(n,r,s=0){let u=this._map.get(n);if(u)u.value=r,s!==0&&this.touch(u,s);else{switch(u={key:n,value:r,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(n,u),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const r=this._map.get(n);if(!!r)return this._map.delete(n),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,r){const s=this._state;let u=this._head;for(;u;){if(r?n.bind(r)(u.value,u.key,this):n(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const n=this,r=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.key,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return u}values(){const n=this,r=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:s.value,done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return u}entries(){const n=this,r=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(n._state!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const v={value:[s.key,s.value],done:!1};return s=s.next,v}else return{value:void 0,done:!0}}};return u}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let r=this._head,s=this.size;for(;r&&s>n;)this._map.delete(r.key),r=r.next,s--;this._head=r,this._size=s,r&&(r.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const r=n.next,s=n.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}n.next=void 0,n.previous=void 0,this._state++}touch(n,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(n===this._head)return;const s=n.next,u=n.previous;n===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(r===2){if(n===this._tail)return;const s=n.next,u=n.previous;n===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((r,s)=>{n.push([s,r])}),n}fromJSON(n){this.clear();for(const[r,s]of n)this.set(r,s)}}e.LinkedMap=l;class m extends l{constructor(n,r=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,r=2){return super.get(n,r)}peek(n){return super.get(n,0)}set(n,r){return super.set(n,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=m;class h{constructor(n){_.set(this,void 0),nt(this,_,n,"f")}get size(){return Ue(this,_,"f").size}forEach(n,r){Ue(this,_,"f").forEach(n,r)}get(n){return Ue(this,_,"f").get(n)}has(n){return Ue(this,_,"f").has(n)}entries(){return Ue(this,_,"f").entries()}keys(){return Ue(this,_,"f").keys()}values(){return Ue(this,_,"f").values()}[(_=new WeakMap,Symbol.iterator)](){return Ue(this,_,"f").entries()}}e.ReadonlyMapView=h}),define(be[112],_e([0,1,22,8]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function D(...G){return function(se,fe){for(let Ae=0,ge=G.length;Ae<ge;Ae++){const We=G[Ae](se,fe);if(We)return We}return null}}e.or=D,e.matchesStrictPrefix=T.bind(void 0,!1),e.matchesPrefix=T.bind(void 0,!0);function T(G,se,fe){if(!fe||fe.length<se.length)return null;let Ae;return G?Ae=R.startsWithIgnoreCase(fe,se):Ae=fe.indexOf(se)===0,Ae?se.length>0?[{start:0,end:se.length}]:[]:null}function _(G,se){const fe=se.toLowerCase().indexOf(G.toLowerCase());return fe===-1?null:[{start:fe,end:fe+G.length}]}e.matchesContiguousSubString=_;function S(G,se){return E(G.toLowerCase(),se.toLowerCase(),0,0)}e.matchesSubString=S;function E(G,se,fe,Ae){if(fe===G.length)return[];if(Ae===se.length)return null;if(G[fe]===se[Ae]){let ge=null;return(ge=E(G,se,fe+1,Ae+1))?f({start:Ae,end:Ae+1},ge):null}return E(G,se,fe,Ae+1)}function k(G){return 97<=G&&G<=122}function i(G){return 65<=G&&G<=90}e.isUpper=i;function I(G){return 48<=G&&G<=57}function d(G){return G===32||G===9||G===10||G===13}const g=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(G=>g.add(G.charCodeAt(0)));function o(G){return d(G)||g.has(G)}function a(G,se){return G===se||o(G)&&o(se)}function w(G){return k(G)||i(G)||I(G)}function f(G,se){return se.length===0?se=[G]:G.end===se[0].start?se[0].start=G.start:se.unshift(G),se}function y(G,se){for(let fe=se;fe<G.length;fe++){const Ae=G.charCodeAt(fe);if(i(Ae)||I(Ae)||fe>0&&!w(G.charCodeAt(fe-1)))return fe}return G.length}function l(G,se,fe,Ae){if(fe===G.length)return[];if(Ae===se.length)return null;if(G[fe]!==se[Ae].toLowerCase())return null;{let ge=null,We=Ae+1;for(ge=l(G,se,fe+1,Ae+1);!ge&&(We=y(se,We))<se.length;)ge=l(G,se,fe+1,We),We++;return ge===null?null:f({start:Ae,end:Ae+1},ge)}}function m(G){let se=0,fe=0,Ae=0,ge=0,We=0;for(let $e=0;$e<G.length;$e++)We=G.charCodeAt($e),i(We)&&se++,k(We)&&fe++,w(We)&&Ae++,I(We)&&ge++;const V=se/G.length,te=fe/G.length,pe=Ae/G.length,Me=ge/G.length;return{upperPercent:V,lowerPercent:te,alphaPercent:pe,numericPercent:Me}}function h(G){const{upperPercent:se,lowerPercent:fe}=G;return fe===0&&se>.6}function t(G){const{upperPercent:se,lowerPercent:fe,alphaPercent:Ae,numericPercent:ge}=G;return fe>.2&&se<.8&&Ae>.6&&ge<.2}function n(G){let se=0,fe=0,Ae=0,ge=0;for(let We=0;We<G.length;We++)Ae=G.charCodeAt(We),i(Ae)&&se++,k(Ae)&&fe++,d(Ae)&&ge++;return(se===0||fe===0)&&ge===0?G.length<=30:se<=5}function r(G,se){if(!se||(se=se.trim(),se.length===0)||!n(G)||se.length>60)return null;const fe=m(se);if(!t(fe)){if(!h(fe))return null;se=se.toLowerCase()}let Ae=null,ge=0;for(G=G.toLowerCase();ge<se.length&&(Ae=l(G,se,0,ge))===null;)ge=y(se,ge+1);return Ae}e.matchesCamelCase=r;function s(G,se,fe=!1){if(!se||se.length===0)return null;let Ae=null,ge=0;for(G=G.toLowerCase(),se=se.toLowerCase();ge<se.length&&(Ae=u(G,se,0,ge,fe))===null;)ge=v(se,ge+1);return Ae}e.matchesWords=s;function u(G,se,fe,Ae,ge){if(fe===G.length)return[];if(Ae===se.length)return null;if(a(G.charCodeAt(fe),se.charCodeAt(Ae))){let We=null,V=Ae+1;if(We=u(G,se,fe+1,Ae+1,ge),!ge)for(;!We&&(V=v(se,V))<se.length;)We=u(G,se,fe+1,V,ge),V++;return We===null?null:f({start:Ae,end:Ae+1},We)}else return null}function v(G,se){for(let fe=se;fe<G.length;fe++)if(o(G.charCodeAt(fe))||fe>0&&o(G.charCodeAt(fe-1)))return fe;return G.length}const b=D(e.matchesPrefix,r,_),P=D(e.matchesPrefix,r,S),C=new p.LRUCache(1e4);function c(G,se,fe=!1){if(typeof G!="string"||typeof se!="string")return null;let Ae=C.get(G);Ae||(Ae=new RegExp(R.convertSimple2RegExpPattern(G),"i"),C.set(G,Ae));const ge=Ae.exec(se);return ge?[{start:ge.index,end:ge.index+ge[0].length}]:fe?P(G,se):b(G,se)}e.matchesFuzzy=c;function F(G,se){const fe=Qe(G,G.toLowerCase(),0,se,se.toLowerCase(),0,!0);return fe?z(fe):null}e.matchesFuzzy2=F;function N(G,se,fe,Ae,ge,We){const V=Math.min(13,G.length);for(;fe<V;fe++){const te=Qe(G,se,fe,Ae,ge,We,!1);if(te)return te}return[0,We]}e.anyScore=N;function z(G){if(typeof G=="undefined")return[];const se=[],fe=G[1];for(let Ae=G.length-1;Ae>1;Ae--){const ge=G[Ae]+fe,We=se[se.length-1];We&&We.end===ge?We.end=ge+1:se.push({start:ge,end:ge+1})}return se}e.createMatches=z;const he=128;function me(){const G=[],se=[];for(let fe=0;fe<=he;fe++)se[fe]=0;for(let fe=0;fe<=he;fe++)G.push(se.slice(0));return G}function Q(G){const se=[];for(let fe=0;fe<=G;fe++)se[fe]=0;return se}const W=Q(2*he),x=Q(2*he),A=me(),U=me(),M=me(),$=!1;function K(G,se,fe,Ae,ge){function We(te,pe,Me=" "){for(;te.length<pe;)te=Me+te;return te}let V=` |   |${Ae.split("").map(te=>We(te,3)).join("|")}
`;for(let te=0;te<=fe;te++)te===0?V+=" |":V+=`${se[te-1]}|`,V+=G[te].slice(0,ge+1).map(pe=>We(pe.toString(),3)).join("|")+`
`;return V}function j(G,se,fe,Ae){G=G.substr(se),fe=fe.substr(Ae),console.log(K(U,G,G.length,fe,fe.length)),console.log(K(M,G,G.length,fe,fe.length)),console.log(K(A,G,G.length,fe,fe.length))}function ae(G,se){if(se<0||se>=G.length)return!1;const fe=G.codePointAt(se);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(fe)}}function we(G,se){if(se<0||se>=G.length)return!1;switch(G.charCodeAt(se)){case 32:case 9:return!0;default:return!1}}function Re(G,se,fe){return se[G]!==fe[G]}function xe(G,se,fe,Ae,ge,We,V=!1){for(;se<fe&&ge<We;)G[se]===Ae[ge]&&(V&&(W[se]=ge),se+=1),ge+=1;return se===fe}e.isPatternInWord=xe;var Le;(function(G){G[G.Diag=1]="Diag",G[G.Left=2]="Left",G[G.LeftLeft=3]="LeftLeft"})(Le||(Le={}));var Ve;(function(G){G.Default=[-100,0];function se(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}G.isDefault=se})(Ve=e.FuzzyScore||(e.FuzzyScore={}));function Qe(G,se,fe,Ae,ge,We,V){const te=G.length>he?he:G.length,pe=Ae.length>he?he:Ae.length;if(fe>=te||We>=pe||te-fe>pe-We||!xe(se,fe,te,ge,We,pe,!0))return;Ke(te,pe,fe,We,se,ge);let Me=1,$e=1,Be=fe,Ye=We;const Se=[!1];for(Me=1,Be=fe;Be<te;Me++,Be++){const O=W[Be],J=x[Be],oe=Be+1<te?x[Be+1]:pe;for($e=O-We+1,Ye=O;Ye<oe;$e++,Ye++){let Ce=Number.MIN_SAFE_INTEGER,ke=!1;Ye<=J&&(Ce=Ge(G,se,Be,fe,Ae,ge,Ye,pe,We,A[Me-1][$e-1]===0,Se));let Ne=0;Ce!==Number.MAX_SAFE_INTEGER&&(ke=!0,Ne=Ce+U[Me-1][$e-1]);const Oe=Ye>O,qe=Oe?U[Me][$e-1]+(A[Me][$e-1]>0?-5:0):0,rt=Ye>O+1&&A[Me][$e-1]>0,tt=rt?U[Me][$e-2]+(A[Me][$e-2]>0?-5:0):0;if(rt&&(!Oe||tt>=qe)&&(!ke||tt>=Ne))U[Me][$e]=tt,M[Me][$e]=3,A[Me][$e]=0;else if(Oe&&(!ke||qe>=Ne))U[Me][$e]=qe,M[Me][$e]=2,A[Me][$e]=0;else if(ke)U[Me][$e]=Ne,M[Me][$e]=1,A[Me][$e]=A[Me-1][$e-1]+1;else throw new Error("not possible")}}if($&&j(G,fe,Ae,We),!Se[0]&&!V)return;Me--,$e--;const ye=[U[Me][$e],We];let De=0,ie=0;for(;Me>=1;){let O=$e;do{const J=M[Me][O];if(J===3)O=O-2;else if(J===2)O=O-1;else break}while(O>=1);De>1&&se[fe+Me-1]===ge[We+$e-1]&&!Re(O+We-1,Ae,ge)&&De+1>A[Me][O]&&(O=$e),O===$e?De++:De=1,ie||(ie=O),Me--,$e=O-1,ye.push($e)}pe===te&&(ye[0]+=2);const ue=ie-te;return ye[0]-=ue,ye}e.fuzzyScore=Qe;function Ke(G,se,fe,Ae,ge,We){let V=G-1,te=se-1;for(;V>=fe&&te>=Ae;)ge[V]===We[te]&&(x[V]=te,V--),te--}function Ge(G,se,fe,Ae,ge,We,V,te,pe,Me,$e){if(se[fe]!==We[V])return Number.MIN_SAFE_INTEGER;let Be=1,Ye=!1;return V===fe-Ae?Be=G[fe]===ge[V]?7:5:Re(V,ge,We)&&(V===0||!Re(V-1,ge,We))?(Be=G[fe]===ge[V]?7:5,Ye=!0):ae(We,V)&&(V===0||!ae(We,V-1))?Be=5:(ae(We,V-1)||we(We,V-1))&&(Be=5,Ye=!0),Be>1&&fe===Ae&&($e[0]=!0),Ye||(Ye=Re(V,ge,We)||ae(We,V-1)||we(We,V-1)),fe===Ae?V>pe&&(Be-=Ye?3:5):Me?Be+=Ye?2:0:Be+=Ye?0:1,V+1===te&&(Be-=Ye?3:5),Be}function H(G,se,fe,Ae,ge,We,V){return ne(G,se,fe,Ae,ge,We,!0,V)}e.fuzzyScoreGracefulAggressive=H;function Y(G,se,fe,Ae,ge,We,V){return ne(G,se,fe,Ae,ge,We,!1,V)}e.fuzzyScoreGraceful=Y;function ne(G,se,fe,Ae,ge,We,V,te){let pe=Qe(G,se,fe,Ae,ge,We,te);if(pe&&!V)return pe;if(G.length>=3){const Me=Math.min(7,G.length-1);for(let $e=fe+1;$e<Me;$e++){const Be=re(G,$e);if(Be){const Ye=Qe(Be,Be.toLowerCase(),fe,Ae,ge,We,te);Ye&&(Ye[0]-=3,(!pe||Ye[0]>pe[0])&&(pe=Ye))}}}return pe}function re(G,se){if(se+1>=G.length)return;const fe=G[se],Ae=G[se+1];if(fe!==Ae)return G.slice(0,se)+Ae+fe+G.slice(se+2)}}),define(be[113],_e([0,1,35,112,8]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const T=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(`(\\\\)?${T.source}`,"g");function S(a){return a.replace(_,(w,f)=>f?w:`\\${w}`)}e.escapeIcons=S;const E=new RegExp(`\\\\${T.source}`,"g");function k(a){return a.replace(E,w=>`\\${w}`)}e.markdownEscapeEscapedIcons=k;const i=new RegExp(`(\\s)?(\\\\)?${T.source}(\\s)?`,"g");function I(a){return a.indexOf(e.iconStartMarker)===-1?a:a.replace(i,(w,f,y,l)=>y?w:f||l||"")}e.stripIcons=I;function d(a){const w=a.indexOf(e.iconStartMarker);return w===-1?{text:a}:g(a,w)}e.parseLabelWithIcons=d;function g(a,w){const f=[];let y="";function l(v){if(v){y+=v;for(const b of v)f.push(t)}}let m=-1,h="",t=0,n,r,s=w;const u=a.length;for(l(a.substr(0,w));s<u;)n=a[s],r=a[s+1],n===e.iconStartMarker[0]&&r===e.iconStartMarker[1]?(m=s,l(h),h=e.iconStartMarker,s++):n===")"&&m!==-1?(t+=s-m+1,m=-1,h=""):m!==-1?/^[a-z0-9\-]$/i.test(n)?h+=n:(l(h),m=-1,h=""):l(n),s++;return l(h),{text:y,iconOffsets:f}}function o(a,w,f=!1){const{text:y,iconOffsets:l}=w;if(!l||l.length===0)return(0,R.matchesFuzzy)(a,y,f);const m=(0,D.ltrim)(y," "),h=y.length-m.length,t=(0,R.matchesFuzzy)(a,m,f);if(t)for(const n of t){const r=l[n.start+h]+h;n.start+=r,n.end+=r}return t}e.matchesFuzzyIconAware=o}),define(be[83],_e([0,1,14,113,13]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markedStringsEquals=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class _{constructor(a="",w=!1){var f,y;if(this.value=a,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof w=="boolean"?(this.isTrusted=w,this.supportThemeIcons=!1):(this.isTrusted=(f=w.isTrusted)!==null&&f!==void 0?f:void 0,this.supportThemeIcons=(y=w.supportThemeIcons)!==null&&y!==void 0?y:!1)}appendText(a,w=0){return this.value+=I(this.supportThemeIcons?(0,R.escapeIcons)(a):a).replace(/([ \t]+)/g,(f,y)=>"&nbsp;".repeat(y.length)).replace(/^>/gm,"\\>").replace(/\n/g,w===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,w){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=w,this.value+="\n```\n",this}}e.MarkdownString=_;function S(o){return E(o)?!o.value:Array.isArray(o)?o.every(S):!0}e.isEmptyMarkdownString=S;function E(o){return o instanceof _?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=E;function k(o,a){return!o&&!a?!0:!o||!a?!1:Array.isArray(o)&&Array.isArray(a)?(0,p.equals)(o,a,i):E(o)&&E(a)?i(o,a):!1}e.markedStringsEquals=k;function i(o,a){return o===a?!0:!o||!a?!1:o.value===a.value&&o.isTrusted===a.isTrusted&&o.supportThemeIcons===a.supportThemeIcons}function I(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=I;function d(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=d;function g(o){const a=[],w=o.split("|").map(y=>y.trim());o=w[0];const f=w[1];if(f){const y=/height=(\d+)/.exec(f),l=/width=(\d+)/.exec(f),m=y?y[1]:"",h=l?l[1]:"",t=isFinite(parseInt(h)),n=isFinite(parseInt(m));t&&a.push(`width="${h}"`),n&&a.push(`height="${m}"`)}return{href:o,dimensions:a}}e.parseHrefAndDimensions=g}),define(be[58],_e([0,1,25,8,2]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(k){return JSON.stringify(k,S)}e.stringify=T;function _(k){let i=JSON.parse(k);return i=E(i),i}e.parse=_;function S(k,i){return i instanceof RegExp?{$mid:2,source:i.source,flags:(0,R.regExpFlags)(i)}:i}function E(k,i=0){if(!k||i>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return D.URI.revive(k);case 2:return new RegExp(k.source,k.flags)}if(k instanceof p.VSBuffer||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let I=0;I<k.length;++I)k[I]=E(k[I],i+1);else for(const I in k)Object.hasOwnProperty.call(k,I)&&(k[I]=E(k[I],i+1))}return k}e.revive=E}),define(be[15],_e([0,1,2,21]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(S){S.inMemory="inmemory",S.vscode="vscode",S.internal="private",S.walkThrough="walkThrough",S.walkThroughSnippet="walkThroughSnippet",S.http="http",S.https="https",S.file="file",S.mailto="mailto",S.untitled="untitled",S.data="data",S.command="command",S.vscodeRemote="vscode-remote",S.vscodeRemoteResource="vscode-remote-resource",S.userData="vscode-userdata",S.vscodeCustomEditor="vscode-custom-editor",S.vscodeNotebook="vscode-notebook",S.vscodeNotebookCell="vscode-notebook-cell",S.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",S.vscodeNotebookCellOutput="vscode-notebook-cell-output",S.vscodeSettings="vscode-settings",S.vscodeWorkspaceTrust="vscode-workspace-trust",S.vscodeTerminal="vscode-terminal",S.webviewPanel="webview-panel",S.vscodeWebview="vscode-webview",S.extension="extension",S.vscodeFileResource="vscode-file",S.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}set(E,k,i){this._hosts[E]=k,this._ports[E]=i}setConnectionToken(E,k){this._connectionTokens[E]=k}rewrite(E){if(this._delegate)return this._delegate(E);const k=E.authority;let i=this._hosts[k];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[k],d=this._connectionTokens[k];let g=`path=${encodeURIComponent(E.path)}`;return typeof d=="string"&&(g+=`&tkn=${encodeURIComponent(d)}`),p.URI.from({scheme:R.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new T;class _{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(E,k,i){const I=this.toUri(E,k);return I.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(I):R.isNative&&(i||R.isPreferringBrowserCodeLoad)&&I.scheme===D.file?I.with({scheme:D.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(E,k){const i=this.toUri(E,k);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==this.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(E,k){return p.URI.isUri(E)?E:p.URI.parse(k.toUrl(E))}}e.FileAccess=new _}),define(be[24],_e([0,1,36,12,2,8,15,21]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(g){return(0,D.uriToFsPath)(g,!0)}e.originalFSPath=E;class k{constructor(o){this._ignorePathCasing=o}compare(o,a,w=!1){return o===a?0:(0,T.compare)(this.getComparisonKey(o,w),this.getComparisonKey(a,w))}isEqual(o,a,w=!1){return o===a?!0:!o||!a?!1:this.getComparisonKey(o,w)===this.getComparisonKey(a,w)}getComparisonKey(o,a=!1){return o.with({path:this._ignorePathCasing(o)?o.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(o){return this._ignorePathCasing(o)}isEqualOrParent(o,a,w=!1){if(o.scheme===a.scheme){if(o.scheme===_.Schemas.file)return p.isEqualOrParent(E(o),E(a),this._ignorePathCasing(o))&&o.query===a.query&&(w||o.fragment===a.fragment);if((0,e.isEqualAuthority)(o.authority,a.authority))return p.isEqualOrParent(o.path,a.path,this._ignorePathCasing(o),"/")&&o.query===a.query&&(w||o.fragment===a.fragment)}return!1}joinPath(o,...a){return D.URI.joinPath(o,...a)}basenameOrAuthority(o){return(0,e.basename)(o)||o.authority}basename(o){return R.posix.basename(o.path)}extname(o){return R.posix.extname(o.path)}dirname(o){if(o.path.length===0)return o;let a;return o.scheme===_.Schemas.file?a=D.URI.file(R.dirname(E(o))).path:(a=R.posix.dirname(o.path),o.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${o.toString})) resulted in a relative path`),a="/")),o.with({path:a})}normalizePath(o){if(!o.path.length)return o;let a;return o.scheme===_.Schemas.file?a=D.URI.file(R.normalize(E(o))).path:a=R.posix.normalize(o.path),o.with({path:a})}relativePath(o,a){if(o.scheme!==a.scheme||!(0,e.isEqualAuthority)(o.authority,a.authority))return;if(o.scheme===_.Schemas.file){const y=R.relative(E(o),E(a));return S.isWindows?p.toSlashes(y):y}let w=o.path||"/",f=a.path||"/";if(this._ignorePathCasing(o)){let y=0;for(const l=Math.min(w.length,f.length);y<l&&!(w.charCodeAt(y)!==f.charCodeAt(y)&&w.charAt(y).toLowerCase()!==f.charAt(y).toLowerCase());y++);w=f.substr(0,y)+w.substr(y)}return R.posix.relative(w,f)}resolvePath(o,a){if(o.scheme===_.Schemas.file){const w=D.URI.file(R.resolve(E(o),a));return o.with({authority:w.authority,path:w.path})}return a=p.toPosixPath(a),o.with({path:R.posix.resolve(o.path,a)})}isAbsolutePath(o){return!!o.path&&o.path[0]==="/"}isEqualAuthority(o,a){return o===a||(0,T.equalsIgnoreCase)(o,a)}hasTrailingPathSeparator(o,a=R.sep){if(o.scheme===_.Schemas.file){const w=E(o);return w.length>p.getRoot(w).length&&w[w.length-1]===a}else{const w=o.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(o.fsPath)}}removeTrailingPathSeparator(o,a=R.sep){return(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path.substr(0,o.path.length-1)}):o}addTrailingPathSeparator(o,a=R.sep){let w=!1;if(o.scheme===_.Schemas.file){const f=E(o);w=f!==void 0&&f.length===p.getRoot(f).length&&f[f.length-1]===a}else{a="/";const f=o.path;w=f.length===1&&f.charCodeAt(f.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(o,a)?o.with({path:o.path+"/"}):o}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(g=>g.scheme===_.Schemas.file?!S.isLinux:!0),e.extUriIgnorePathCase=new k(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(g,o){const a=[];for(let w=0;w<g.length;w++){const f=o(g[w]);g.some((y,l)=>l===w?!1:(0,e.isEqualOrParent)(f,o(y)))||a.push(g[w])}return a}e.distinctParents=i;var I;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function o(a){const w=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(l=>{const[m,h]=l.split(":");m&&h&&w.set(m,h)});const y=a.path.substring(0,a.path.indexOf(";"));return y&&w.set(g.META_DATA_MIME,y),w}g.parseMetaData=o})(I=e.DataUri||(e.DataUri={}));function d(g,o,a){if(o){let w=g.path;return w&&w[0]!==R.posix.sep&&(w=R.posix.sep+w),g.with({scheme:a,authority:o,path:w})}return g.with({scheme:a})}e.toLocalResource=d}),define(be[11],_e([0,1,20,13,3,6,45,24]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(U){return!!U&&typeof U.then=="function"}e.isThenable=E;function k(U){const M=new p.CancellationTokenSource,$=U(M.token),K=new Promise((j,ae)=>{M.token.onCancellationRequested(()=>{ae((0,R.canceled)())}),Promise.resolve($).then(we=>{M.dispose(),j(we)},we=>{M.dispose(),ae(we)})});return new class{cancel(){M.cancel()}then(j,ae){return K.then(j,ae)}catch(j){return this.then(void 0,j)}finally(j){return K.finally(j)}}}e.createCancelablePromise=k;function i(U,M,$){return Promise.race([U,new Promise(K=>M.onCancellationRequested(()=>K($)))])}e.raceCancellation=i;async function I(U){let M=-1;const $=U.map((j,ae)=>j.then(we=>(M=ae,we))),K=await Promise.race($);return U.forEach((j,ae)=>{ae!==M&&j.cancel()}),K}e.raceCancellablePromises=I;function d(U,M,$){let K;const j=setTimeout(()=>{K==null||K(void 0),$==null||$()},M);return Promise.race([U.finally(()=>clearTimeout(j)),new Promise(ae=>K=ae)])}e.raceTimeout=d;function g(U){return new Promise((M,$)=>{const K=U();E(K)?K.then(M,$):M(K)})}e.asPromise=g;class o{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(M){if(this.activePromise){if(this.queuedPromiseFactory=M,!this.queuedPromise){const $=()=>{this.queuedPromise=null;const K=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,K};this.queuedPromise=new Promise(K=>{this.activePromise.then($,$).then(K)})}return new Promise(($,K)=>{this.queuedPromise.then($,K)})}return this.activePromise=M(),new Promise(($,K)=>{this.activePromise.then(j=>{this.activePromise=null,$(j)},j=>{this.activePromise=null,K(j)})})}}e.Throttler=o;class a{constructor(){this.current=Promise.resolve(null)}queue(M){return this.current=this.current.then(()=>M(),()=>M())}}e.Sequencer=a;class w{constructor(){this.promiseMap=new Map}queue(M,$){var K;const ae=((K=this.promiseMap.get(M))!==null&&K!==void 0?K:Promise.resolve()).catch(()=>{}).then($).finally(()=>{this.promiseMap.get(M)===ae&&this.promiseMap.delete(M)});return this.promiseMap.set(M,ae),ae}}e.SequencerByKey=w;class f{constructor(M){this.defaultDelay=M,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(M,$=this.defaultDelay){return this.task=M,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((K,j)=>{this.doResolve=K,this.doReject=j}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const K=this.task;return this.task=null,K()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},$),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,R.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=f;class y{constructor(M){this.delayer=new f(M),this.throttler=new o}trigger(M,$){return this.delayer.trigger(()=>this.throttler.queue(M),$)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=y;class l{constructor(){this._isOpen=!1,this._promise=new Promise((M,$)=>{this._completePromise=M})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class m extends l{constructor(M){super();this._timeout=setTimeout(()=>this.open(),M)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=m;function h(U,M){return M?new Promise(($,K)=>{const j=setTimeout($,U);M.onCancellationRequested(()=>{clearTimeout(j),K((0,R.canceled)())})}):k($=>h(U,$))}e.timeout=h;function t(U,M=0){const $=setTimeout(U,M);return(0,T.toDisposable)(()=>clearTimeout($))}e.disposableTimeout=t;function n(U){return U.then(void 0,M=>{})}e.ignoreErrors=n;function r(U){const M=[];let $=0;const K=U.length;function j(){return $<K?U[$++]():null}function ae(we){we!=null&&M.push(we);const Re=j();return Re?Re.then(ae):Promise.resolve(M)}return Promise.resolve(null).then(ae)}e.sequence=r;function s(U,M=K=>!!K,$=null){let K=0;const j=U.length,ae=()=>{if(K>=j)return Promise.resolve($);const we=U[K++];return Promise.resolve(we()).then(xe=>M(xe)?Promise.resolve(xe):ae())};return ae()}e.first=s;function u(U,M=K=>!!K,$=null){if(U.length===0)return Promise.resolve($);let K=U.length;const j=()=>{var ae,we;K=-1;for(const Re of U)(we=(ae=Re).cancel)===null||we===void 0||we.call(ae)};return new Promise((ae,we)=>{for(const Re of U)Re.then(xe=>{--K>=0&&M(xe)?(j(),ae(xe)):K===0&&ae($)}).catch(xe=>{--K>=0&&(j(),we(xe))})})}e.firstParallel=u;class v{constructor(M){this._size=0,this.maxDegreeOfParalellism=M,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(M){return this._size++,new Promise(($,K)=>{this.outstandingPromises.push({factory:M,c:$,e:K}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const M=this.outstandingPromises.shift();this.runningPromises++;const $=M.factory();$.then(M.c,M.e),$.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class b extends v{constructor(){super(1)}}e.Queue=b;class P{constructor(){this.queues=new Map}queueFor(M,$=S.extUri){const K=$.getComparisonKey(M);let j=this.queues.get(K);return j||(j=new b,D.Event.once(j.onFinished)(()=>{j==null||j.dispose(),this.queues.delete(K)}),this.queues.set(K,j)),j}dispose(){this.queues.forEach(M=>M.dispose()),this.queues.clear()}}e.ResourceQueue=P;class C{constructor(M,$){this._token=-1,typeof M=="function"&&typeof $=="number"&&this.setIfNotSet(M,$)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setTimeout(()=>{this._token=-1,M()},$)}setIfNotSet(M,$){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,M()},$))}}e.TimeoutTimer=C;class c{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(M,$){this.cancel(),this._token=setInterval(()=>{M()},$)}}e.IntervalTimer=c;class F{constructor(M,$){this.timeoutToken=-1,this.runner=M,this.timeout=$,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(M=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,M)}get delay(){return this.timeout}set delay(M){this.timeout=M}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class N extends F{constructor(M,$){super(M,$);this.units=[]}work(M){this.units.push(M),this.isScheduled()||this.schedule()}doRun(){const M=this.units;this.units=[],this.runner&&this.runner(M)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const U=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=M=>{const $=setTimeout(()=>M(U));let K=!1;return{dispose(){K||(K=!0,clearTimeout($))}}}}else e.runWhenIdle=(U,M)=>{const $=requestIdleCallback(U,typeof M=="number"?{timeout:M}:void 0);let K=!1;return{dispose(){K||(K=!0,cancelIdleCallback($))}}}}();class z{constructor(M){this._didRun=!1,this._executor=()=>{try{this._value=M()}catch($){this._error=$}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function he(U,M,$){let K;for(let j=0;j<$;j++)try{return await U()}catch(ae){K=ae,await h(M)}throw K}e.retry=he;class me{hasPending(M){return this._pending?typeof M=="number"?this._pending.taskId===M:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var M;(M=this._pending)===null||M===void 0||M.cancel()}setPending(M,$,K){return this._pending={taskId:M,cancel:()=>K==null?void 0:K(),promise:$},$.then(()=>this.donePending(M),()=>this.donePending(M)),$}donePending(M){this._pending&&M===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const M=this._next;this._next=void 0,M.run().then(M.promiseResolve,M.promiseReject)}}setNext(M){if(this._next)this._next.run=M;else{let $,K;const j=new Promise((ae,we)=>{$=ae,K=we});this._next={run:M,promise:j,promiseResolve:$,promiseReject:K}}return this._next.promise}}e.TaskSequentializer=me;class Q{constructor(M){this.interval=M,this.lastIncrementTime=0,this.value=0}increment(){const M=Date.now();return M-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=M,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class W{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((M,$)=>{this.completeCallback=M,this.errorCallback=$})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(M){return new Promise($=>{this.completeCallback(M),this.resolved=!0,$()})}error(M){return new Promise($=>{this.errorCallback(M),this.rejected=!0,$()})}cancel(){new Promise(M=>{this.errorCallback((0,R.canceled)()),this.rejected=!0,M()})}}e.DeferredPromise=W;class x extends D.Emitter{async fireAsync(M,$,K){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new _.LinkedList);for(const j of this._listeners)this._asyncDeliveryQueue.push([j,M]);for(;this._asyncDeliveryQueue.size>0&&!$.isCancellationRequested;){const[j,ae]=this._asyncDeliveryQueue.shift(),we=[],Re=Object.assign(Object.assign({},ae),{waitUntil:xe=>{if(Object.isFrozen(we))throw new Error("waitUntil can NOT be called asynchronous");K&&(xe=K(xe,typeof j=="function"?j:j[0])),we.push(xe)}});try{typeof j=="function"?j.call(void 0,Re):j[0].call(j[1],Re)}catch(xe){(0,R.onUnexpectedError)(xe);continue}Object.freeze(we),await A.settled(we).catch(xe=>(0,R.onUnexpectedError)(xe))}}}}e.AsyncEmitter=x;var A;(function(U){async function M(ae){return typeof Promise.allSettled=="function"?$(ae):K(ae)}U.allSettled=M;async function $(ae){return Promise.allSettled(ae)}async function K(ae){return Promise.all(ae.map(we=>we.then(Re=>({status:"fulfilled",value:Re}),Re=>({status:"rejected",reason:Re}))))}async function j(ae){let we;const Re=await Promise.all(ae.map(xe=>xe.then(Le=>Le,Le=>{we||(we=Le)})));if(typeof we!="undefined")throw we;return Re}U.settled=j})(A=e.Promises||(e.Promises={}))}),define(be[114],_e([0,1,12,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const D=new R.IdleValue(()=>{const C=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:C,collatorIsNumeric:C.resolvedOptions().numeric}}),T=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),_=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function S(C,c,F=!1){const N=C||"",z=c||"",he=D.value.collator.compare(N,z);return D.value.collatorIsNumeric&&he===0&&N!==z?N<z?-1:1:he}e.compareFileNames=S;function E(C,c){const F=T.value.collator;return C=C||"",c=c||"",h(F,C,c)}e.compareFileNamesDefault=E;function k(C,c){const F=T.value.collator;return C=C||"",c=c||"",s(C,c)||h(F,C,c)}e.compareFileNamesUpper=k;function i(C,c){const F=T.value.collator;return C=C||"",c=c||"",r(C,c)||h(F,C,c)}e.compareFileNamesLower=i;function I(C,c){return C=C||"",c=c||"",C===c?0:C<c?-1:1}e.compareFileNamesUnicode=I;function d(C,c,F=!1){F||(C=C&&C.toLowerCase(),c=c&&c.toLowerCase());const[N,z]=l(C),[he,me]=l(c);return N!==he?N<he?-1:1:z===me?0:z<me?-1:1}e.noIntlCompareFileNames=d;function g(C,c){const[F,N]=l(C),[z,he]=l(c);let me=D.value.collator.compare(N,he);if(me===0){if(D.value.collatorIsNumeric&&N!==he)return N<he?-1:1;if(me=D.value.collator.compare(F,z),D.value.collatorIsNumeric&&me===0&&F!==z)return F<z?-1:1}return me}e.compareFileExtensions=g;function o(C,c){C=C||"",c=c||"";const F=m(C),N=m(c),z=T.value.collator,he=_.value.collator;return h(he,F,N)||h(z,C,c)}e.compareFileExtensionsDefault=o;function a(C,c){C=C||"",c=c||"";const F=m(C),N=m(c),z=T.value.collator,he=_.value.collator;return h(he,F,N)||s(C,c)||h(z,C,c)}e.compareFileExtensionsUpper=a;function w(C,c){C=C||"",c=c||"";const F=m(C),N=m(c),z=T.value.collator,he=_.value.collator;return h(he,F,N)||r(C,c)||h(z,C,c)}e.compareFileExtensionsLower=w;function f(C,c){C=C||"",c=c||"";const F=m(C).toLowerCase(),N=m(c).toLowerCase();return F!==N?F<N?-1:1:C!==c?C<c?-1:1:0}e.compareFileExtensionsUnicode=f;const y=/^(.*?)(\.([^.]*))?$/;function l(C,c=!1){const F=C?y.exec(C):[];let N=[F&&F[1]||"",F&&F[3]||""];return c&&(!N[0]&&N[1]||N[0]&&N[0].charAt(0)===".")&&(N=[N[0]+"."+N[1],""]),N}function m(C){const c=C?y.exec(C):[];return c&&c[1]&&c[1].charAt(0)!=="."&&c[3]||""}function h(C,c,F){let N=C.compare(c,F);return N!==0?N:c.length!==F.length?c.length<F.length?-1:1:0}function t(C){const c=C.charAt(0);return c.toLocaleUpperCase()!==c}function n(C){const c=C.charAt(0);return c.toLocaleLowerCase()!==c}function r(C,c){return t(C)&&n(c)?-1:n(C)&&t(c)?1:0}function s(C,c){return n(C)&&t(c)?-1:t(C)&&n(c)?1:0}function u(C,c,F=!1){return F||(C=C&&C.toLowerCase(),c=c&&c.toLowerCase()),C===c?0:C<c?-1:1}function v(C,c,F=!1){const N=C.split(p.sep),z=c.split(p.sep),he=N.length-1,me=z.length-1;let Q,W;for(let x=0;;x++){if(Q=he===x,W=me===x,Q&&W)return S(N[x],z[x],F);if(Q)return-1;if(W)return 1;const A=u(N[x],z[x],F);if(A!==0)return A}}e.comparePaths=v;function b(C,c,F){const N=C.toLowerCase(),z=c.toLowerCase(),he=P(C,c,F);if(he)return he;const me=N.endsWith(F),Q=z.endsWith(F);if(me!==Q)return me?-1:1;const W=S(N,z);return W!==0?W:N.localeCompare(z)}e.compareAnything=b;function P(C,c,F){const N=C.toLowerCase(),z=c.toLowerCase(),he=N.startsWith(F),me=z.startsWith(F);if(he!==me)return he?-1:1;if(he&&me){if(N.length<z.length)return-1;if(N.length>z.length)return 1}return 0}e.compareByPrefix=P}),define(be[27],_e([0,1,8,36,12,22,11]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function S(){return Object.create(null)}e.getEmptyExpression=S;const E="**",k="/",i="[/\\\\]",I="[^/\\\\]",d=/\//g;function g($){switch($){case 0:return"";case 1:return`${I}*?`;default:return`(?:${i}|${I}+${i}|${i}${I}+)*?`}}function o($,K){if(!$)return[];const j=[];let ae=!1,we=!1,Re="";for(const xe of $){switch(xe){case K:if(!ae&&!we){j.push(Re),Re="";continue}break;case"{":ae=!0;break;case"}":ae=!1;break;case"[":we=!0;break;case"]":we=!1;break}Re+=xe}return Re&&j.push(Re),j}e.splitGlobAware=o;function a($){if(!$)return"";let K="";const j=o($,k);if(j.every(ae=>ae===E))K=".*";else{let ae=!1;j.forEach((we,Re)=>{if(we===E){ae||(K+=g(2),ae=!0);return}let xe=!1,Le="",Ve=!1,Qe="";for(const Ke of we){if(Ke!=="}"&&xe){Le+=Ke;continue}if(Ve&&(Ke!=="]"||!Qe)){let Ge;Ke==="-"?Ge=Ke:(Ke==="^"||Ke==="!")&&!Qe?Ge="^":Ke===k?Ge="":Ge=p.escapeRegExpCharacters(Ke),Qe+=Ge;continue}switch(Ke){case"{":xe=!0;continue;case"[":Ve=!0;continue;case"}":K+=`(?:${o(Le,",").map(Y=>a(Y)).join("|")})`,xe=!1,Le="";break;case"]":K+="["+Qe+"]",Ve=!1,Qe="";break;case"?":K+=I;continue;case"*":K+=g(1);continue;default:K+=p.escapeRegExpCharacters(Ke)}}Re<j.length-1&&(j[Re+1]!==E||Re+2<j.length)&&(K+=i),ae=!1})}return K}const w=/^\*\*\/\*\.[\w\.-]+$/,f=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new T.LRUCache(1e4),n=function(){return!1},r=function(){return null};function s($,K){if(!$)return r;let j;typeof $!="string"?j=$.pattern:j=$,j=j.trim();const ae=`${j}_${!!K.trimForExclusions}`;let we=t.get(ae);if(we)return u(we,$);let Re;if(w.test(j)){const xe=j.substr(4);we=function(Le,Ve){return typeof Le=="string"&&Le.endsWith(xe)?j:null}}else(Re=f.exec(v(j,K)))?we=b(Re[1],j):(K.trimForExclusions?l:y).test(j)?we=P(j,K):(Re=m.exec(v(j,K)))?we=C(Re[1].substr(1),j,!0):(Re=h.exec(v(j,K)))?we=C(Re[1],j,!1):we=c(j);return t.set(ae,we),u(we,$)}function u($,K){return typeof K=="string"?$:function(j,ae){return R.isEqualOrParent(j,K.base)?$(D.relative(K.base,j),ae):null}}function v($,K){return K.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function b($,K){const j=`/${$}`,ae=`\\${$}`,we=function(xe,Le){return typeof xe!="string"?null:Le?Le===$?K:null:xe===$||xe.endsWith(j)||xe.endsWith(ae)?K:null},Re=[$];return we.basenames=Re,we.patterns=[K],we.allBasenames=Re,we}function P($,K){const j=M($.slice(1,-1).split(",").map(Le=>s(Le,K)).filter(Le=>Le!==r),$),ae=j.length;if(!ae)return r;if(ae===1)return j[0];const we=function(Le,Ve){for(let Qe=0,Ke=j.length;Qe<Ke;Qe++)if(j[Qe](Le,Ve))return $;return null},Re=j.find(Le=>!!Le.allBasenames);Re&&(we.allBasenames=Re.allBasenames);const xe=j.reduce((Le,Ve)=>Ve.allPaths?Le.concat(Ve.allPaths):Le,[]);return xe.length&&(we.allPaths=xe),we}function C($,K,j){const ae=D.sep===D.posix.sep,we=ae?$:$.replace(d,D.sep),Re=D.sep+we,xe=D.posix.sep+$,Le=j?function(Ve,Qe){return typeof Ve=="string"&&(Ve===we||Ve.endsWith(Re)||!ae&&(Ve===$||Ve.endsWith(xe)))?K:null}:function(Ve,Qe){return typeof Ve=="string"&&(Ve===we||!ae&&Ve===$)?K:null};return Le.allPaths=[(j?"*/":"./")+$],Le}function c($){try{const K=new RegExp(`^${a($)}$`);return function(j){return K.lastIndex=0,typeof j=="string"&&K.test(j)?$:null}}catch(K){return r}}function F($,K,j){return!$||typeof K!="string"?!1:N($)(K,void 0,j)}e.match=F;function N($,K={}){if(!$)return n;if(typeof $=="string"||Q($)){const j=s($,K);if(j===r)return n;const ae=function(we,Re){return!!j(we,Re)};return j.allBasenames&&(ae.allBasenames=j.allBasenames),j.allPaths&&(ae.allPaths=j.allPaths),ae}return A($,K)}e.parse=N;function z($){if(!$)return;let K;return j=>(K||(K=($()||Promise.resolve([])).then(ae=>ae?me(ae):{})),K.then(ae=>!!ae[j]))}e.hasSiblingPromiseFn=z;function he($){if(!$)return;let K;return j=>{if(!K){const ae=$();K=ae?me(ae):{}}return!!K[j]}}e.hasSiblingFn=he;function me($){const K={};for(const j of $)K[j]=!0;return K}function Q($){const K=$;return K&&typeof K.base=="string"&&typeof K.pattern=="string"}e.isRelativePattern=Q;function W($){return $.allBasenames||[]}e.getBasenameTerms=W;function x($){return $.allPaths||[]}e.getPathTerms=x;function A($,K){const j=M(Object.getOwnPropertyNames($).map(Le=>U(Le,$[Le],K)).filter(Le=>Le!==r)),ae=j.length;if(!ae)return r;if(!j.some(Le=>!!Le.requiresSiblings)){if(ae===1)return j[0];const Le=function(Ke,Ge){for(let H=0,Y=j.length;H<Y;H++){const ne=j[H](Ke,Ge);if(ne)return ne}return null},Ve=j.find(Ke=>!!Ke.allBasenames);Ve&&(Le.allBasenames=Ve.allBasenames);const Qe=j.reduce((Ke,Ge)=>Ge.allPaths?Ke.concat(Ge.allPaths):Ke,[]);return Qe.length&&(Le.allPaths=Qe),Le}const we=function(Le,Ve,Qe){let Ke;for(let Ge=0,H=j.length;Ge<H;Ge++){const Y=j[Ge];Y.requiresSiblings&&Qe&&(Ve||(Ve=D.basename(Le)),Ke||(Ke=Ve.substr(0,Ve.length-D.extname(Le).length)));const ne=Y(Le,Ve,Ke,Qe);if(ne)return ne}return null},Re=j.find(Le=>!!Le.allBasenames);Re&&(we.allBasenames=Re.allBasenames);const xe=j.reduce((Le,Ve)=>Ve.allPaths?Le.concat(Ve.allPaths):Le,[]);return xe.length&&(we.allPaths=xe),we}function U($,K,j){if(K===!1)return r;const ae=s($,j);if(ae===r)return r;if(typeof K=="boolean")return ae;if(K){const we=K.when;if(typeof we=="string"){const Re=(xe,Le,Ve,Qe)=>{if(!Qe||!ae(xe,Le))return null;const Ke=we.replace("$(basename)",Ve),Ge=Qe(Ke);return(0,_.isThenable)(Ge)?Ge.then(H=>H?$:null):Ge?$:null};return Re.requiresSiblings=!0,Re}}return ae}function M($,K){const j=$.filter(Le=>!!Le.basenames);if(j.length<2)return $;const ae=j.reduce((Le,Ve)=>{const Qe=Ve.basenames;return Qe?Le.concat(Qe):Le},[]);let we;if(K){we=[];for(let Le=0,Ve=ae.length;Le<Ve;Le++)we.push(K)}else we=j.reduce((Le,Ve)=>{const Qe=Ve.patterns;return Qe?Le.concat(Qe):Le},[]);const Re=function(Le,Ve){if(typeof Le!="string")return null;if(!Ve){let Ke;for(Ke=Le.length;Ke>0;Ke--){const Ge=Le.charCodeAt(Ke-1);if(Ge===47||Ge===92)break}Ve=Le.substr(Ke)}const Qe=ae.indexOf(Ve);return Qe!==-1?we[Qe]:null};Re.basenames=ae,Re.patterns=we,Re.allBasenames=ae;const xe=$.filter(Le=>!Le.basenames);return xe.push(Re),xe}}),define(be[59],_e([0,1,2,12,8,15,21,24,36]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(s,u,v){if(typeof s=="string"&&(s=p.URI.file(s)),v){const P=v.getWorkspaceFolder(s);if(P){const C=v.getWorkspace().folders.length>1;let c;if((0,S.isEqual)(P.uri,s)?c="":c=(0,S.relativePath)(P.uri,s),C){const F=P.name?P.name:(0,S.basename)(P.uri);c=c?F+" \u2022 "+c:F}return c}}if(s.scheme!==T.Schemas.file&&s.scheme!==T.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if((0,E.hasDriveLetter)(s.fsPath))return(0,R.normalize)(I(s.fsPath));let b=(0,R.normalize)(s.fsPath);return!_.isWindows&&(u==null?void 0:u.userHome)&&(b=g(b,u.userHome.fsPath)),b}e.getPathLabel=k;function i(s){if(!s)return;typeof s=="string"&&(s=p.URI.file(s));const u=(0,S.basename)(s)||(s.scheme===T.Schemas.file?s.fsPath:s.path);return _.isWindows&&(0,E.isRootOrDriveLetter)(u)?I(u):u}e.getBaseLabel=i;function I(s){return(0,E.hasDriveLetter)(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=I;let d=Object.create(null);function g(s,u){if(_.isWindows||!s||!u)return s;let v=d.original===u?d.normalized:void 0;return v||(v=`${(0,D.rtrim)(u,R.posix.sep)}${R.posix.sep}`,d={original:u,normalized:v}),(_.isLinux?s.startsWith(v):(0,D.startsWithIgnoreCase)(s,v))&&(s=`~/${s.substr(v.length)}`),s}e.tildify=g;function o(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=o;const a="\u2026",w="\\\\",f="~";function y(s,u=R.sep){const v=new Array(s.length);let b=!1;for(let P=0;P<s.length;P++){let C=s[P];if(C===""){v[P]=`.${u}`;continue}if(!C){v[P]=C;continue}b=!0;let c="";C.indexOf(w)===0?(c=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(u)===0?(c=C.substr(0,C.indexOf(u)+u.length),C=C.substr(C.indexOf(u)+u.length)):C.indexOf(f)===0&&(c=C.substr(0,C.indexOf(f)+f.length),C=C.substr(C.indexOf(f)+f.length));const F=C.split(u);for(let N=1;b&&N<=F.length;N++)for(let z=F.length-N;b&&z>=0;z--){b=!1;let he=F.slice(z,z+N).join(u);for(let me=0;!b&&me<s.length;me++)if(me!==P&&s[me]&&s[me].indexOf(he)>-1){const Q=z+N===F.length,W=z>0&&s[me].indexOf(u)>-1?u+he:he,x=s[me].endsWith(W);b=!Q||x}if(!b){let me="";(F[0].endsWith(":")||c!=="")&&(z===1&&(z=0,N++,he=F[0]+u+he),z>0&&(me=F[0]+u),me=c+me),z>0&&(me=me+a+u),me=me+he,z+N<F.length&&(me=me+u+a),v[P]=me}}b&&(v[P]=C)}return v}e.shorten=y;var l;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function m(s,u=Object.create(null)){const v=[];let b=!1,P="";for(const C of s)if(C==="$"||b&&C==="{")P&&v.push({value:P,type:l.TEXT}),P="",b=!0;else if(C==="}"&&b){const c=u[P];if(typeof c=="string")c.length&&v.push({value:c,type:l.VARIABLE});else if(c){const F=v[v.length-1];(!F||F.type!==l.SEPARATOR)&&v.push({value:c.label,type:l.SEPARATOR})}P="",b=!1}else P+=C;return P&&!b&&v.push({value:P,type:l.TEXT}),v.filter((C,c)=>{if(C.type===l.SEPARATOR){const F=v[c-1],N=v[c+1];return[F,N].every(z=>z&&(z.type===l.VARIABLE||z.type===l.TEXT)&&z.value.length>0)}return!0}).map(C=>C.value).join("")}e.template=m;function h(s,u){return _.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,_.isMacintosh?"&":"&&"):s.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function t(s,u){return _.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):_.isWindows?s.replace(/&&|&/g,v=>v==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function n(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=n;function r(s){const u=s.indexOf("/")!==-1?R.posix:R.win32,v=u.basename(s),b=u.dirname(s);return v.length?{name:v,parentPath:b}:{name:b,parentPath:""}}e.splitName=r}),define(be[115],_e([0,1,12,8,27,15,24]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let S=[],E=[],k=[];function i(t,n=!1){const r=I(t);S.push(r),r.userConfigured?k.push(r):E.push(r),n&&!r.userConfigured&&S.forEach(s=>{s.mime===r.mime||s.userConfigured||(r.extension&&s.extension===r.extension&&console.warn(`Overwriting extension <<${r.extension}>> to now point to mime <<${r.mime}>>`),r.filename&&s.filename===r.filename&&console.warn(`Overwriting filename <<${r.filename}>> to now point to mime <<${r.mime}>>`),r.filepattern&&s.filepattern===r.filepattern&&console.warn(`Overwriting filepattern <<${r.filepattern}>> to now point to mime <<${r.mime}>>`),r.firstline&&s.firstline===r.firstline&&console.warn(`Overwriting firstline <<${r.firstline}>> to now point to mime <<${r.mime}>>`))})}e.registerTextMime=i;function I(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(p.posix.sep)>=0:!1}}function d(t){t?(S=S.filter(n=>!n.userConfigured),k=[]):(S=[],E=[],k=[])}e.clearTextMimes=d;function g(t,n){let r;if(t)switch(t.scheme){case T.Schemas.file:r=t.fsPath;break;case T.Schemas.data:r=_.DataUri.parseMetaData(t).get(_.DataUri.META_DATA_LABEL);break;default:r=t.path}if(!r)return[e.MIME_UNKNOWN];r=r.toLowerCase();const s=(0,p.basename)(r),u=o(r,s,k);if(u)return[u,e.MIME_TEXT];const v=o(r,s,E);if(v)return[v,e.MIME_TEXT];if(n){const b=a(n);if(b)return[b,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=g;function o(t,n,r){let s=null,u=null,v=null;for(let b=r.length-1;b>=0;b--){const P=r[b];if(n===P.filenameLowercase){s=P;break}if(P.filepattern&&(!u||P.filepattern.length>u.filepattern.length)){const C=P.filepatternOnPath?t:n;(0,D.match)(P.filepatternLowercase,C)&&(u=P)}P.extension&&(!v||P.extension.length>v.extension.length)&&n.endsWith(P.extensionLowercase)&&(v=P)}return s?s.mime:u?u.mime:v?v.mime:null}function a(t){if((0,R.startsWithUTF8BOM)(t)&&(t=t.substr(1)),t.length>0)for(let n=S.length-1;n>=0;n--){const r=S[n];if(!r.firstline)continue;const s=t.match(r.firstline);if(s&&s.length>0)return r.mime}return null}function w(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&w(t[0]):!0}e.isUnspecific=w;const f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function y(t){const n=(0,p.extname)(t);return f[n.toLowerCase()]}e.getMediaMime=y;function l(t){for(const n in f)if(f[n]===t)return n}e.getExtensionForMimeType=l;const m=/^(.+)\/(.+?)(;.+)?$/;function h(t,n){var r;const s=m.exec(t);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${(r=s[3])!==null&&r!==void 0?r:""}`:n?void 0:t}e.normalizeMimeType=h}),define(be[116],_e([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(i){return i.toJSON()}class D{constructor(I){this._uriTransformer=I}transformIncoming(I){const d=this._uriTransformer.transformIncoming(I);return d===I?I:R(p.URI.from(d))}transformOutgoing(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:R(p.URI.from(d))}transformOutgoingURI(I){const d=this._uriTransformer.transformOutgoing(I);return d===I?I:p.URI.from(d)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(i){return i}transformOutgoing(i){return i}transformOutgoingURI(i){return i}transformOutgoingScheme(i){return i}};function T(i,I,d){if(!i||d>200)return null;if(typeof i=="object"){if(i instanceof p.URI)return I.transformOutgoing(i);for(let g in i)if(Object.hasOwnProperty.call(i,g)){const o=T(i[g],I,d+1);o!==null&&(i[g]=o)}}return null}function _(i,I){const d=T(i,I,0);return d===null?i:d}e.transformOutgoingURIs=_;function S(i,I,d,g){if(!i||g>200)return null;if(typeof i=="object"){if(i.$mid===1)return d?p.URI.revive(I.transformIncoming(i)):I.transformIncoming(i);for(let o in i)if(Object.hasOwnProperty.call(i,o)){const a=S(i[o],I,d,g+1);a!==null&&(i[o]=a)}}return null}function E(i,I){const d=S(i,I,!1,0);return d===null?i:d}e.transformIncomingURIs=E;function k(i,I){const d=S(i,I,!0,0);return d===null?i:d}e.transformAndReviveIncomingURIs=k}),define(be[37],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(E){return p.test(E)}e.isUUID=R;const D=new Uint8Array(16),T=[];for(let E=0;E<256;E++)T.push(E.toString(16).padStart(2,"0"));let _;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?_=crypto.getRandomValues.bind(crypto):_=function(E){for(let k=0;k<E.length;k++)E[k]=Math.floor(Math.random()*256);return E};function S(){_(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let E=0,k="";return k+=T[D[E++]],k+=T[D[E++]],k+=T[D[E++]],k+=T[D[E++]],k+="-",k+=T[D[E++]],k+=T[D[E++]],k+="-",k+=T[D[E++]],k+=T[D[E++]],k+="-",k+=T[D[E++]],k+=T[D[E++]],k+="-",k+=T[D[E++]],k+=T[D[E++]],k+=T[D[E++]],k+=T[D[E++]],k+=T[D[E++]],k+=T[D[E++]],k}e.generateUuid=S}),define(be[84],_e([0,1,82]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(S){let E=(0,p.toUint8)(S);this._defaultValue=E,this._asciiMap=R._createAsciiMap(E),this._map=new Map}static _createAsciiMap(S){let E=new Uint8Array(256);for(let k=0;k<256;k++)E[k]=S;return E}set(S,E){let k=(0,p.toUint8)(E);S>=0&&S<256?this._asciiMap[S]=k:this._map.set(S,k)}get(S){return S>=0&&S<256?this._asciiMap[S]:this._map.get(S)||this._defaultValue}}e.CharacterClassifier=R;var D;(function(_){_[_.False=0]="False",_[_.True=1]="True"})(D||(D={}));class T{constructor(){this._actual=new R(0)}add(S){this._actual.set(S,1)}has(S){return this._actual.get(S)===1}}e.CharacterSet=T}),define(be[117],_e([0,1,84]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(_){_[_.Regular=0]="Regular",_[_.Whitespace=1]="Whitespace",_[_.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class D extends p.CharacterClassifier{constructor(S){super(0);for(let E=0,k=S.length;E<k;E++)this.set(S.charCodeAt(E),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=D;function T(_){let S={};return E=>(S.hasOwnProperty(E)||(S[E]=_(E)),S[E])}e.getMapForWordSeparators=T(_=>new D(_))}),define(be[38],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(D,T){this.lineNumber=D,this.column=T}with(D=this.lineNumber,T=this.column){return D===this.lineNumber&&T===this.column?this:new p(D,T)}delta(D=0,T=0){return this.with(this.lineNumber+D,this.column+T)}equals(D){return p.equals(this,D)}static equals(D,T){return!D&&!T?!0:!!D&&!!T&&D.lineNumber===T.lineNumber&&D.column===T.column}isBefore(D){return p.isBefore(this,D)}static isBefore(D,T){return D.lineNumber<T.lineNumber?!0:T.lineNumber<D.lineNumber?!1:D.column<T.column}isBeforeOrEqual(D){return p.isBeforeOrEqual(this,D)}static isBeforeOrEqual(D,T){return D.lineNumber<T.lineNumber?!0:T.lineNumber<D.lineNumber?!1:D.column<=T.column}static compare(D,T){let _=D.lineNumber|0,S=T.lineNumber|0;if(_===S){let E=D.column|0,k=T.column|0;return E-k}return _-S}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(D){return new p(D.lineNumber,D.column)}static isIPosition(D){return D&&typeof D.lineNumber=="number"&&typeof D.column=="number"}}e.Position=p}),define(be[31],_e([0,1,38]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(T,_,S,E){T>S||T===S&&_>E?(this.startLineNumber=S,this.startColumn=E,this.endLineNumber=T,this.endColumn=_):(this.startLineNumber=T,this.startColumn=_,this.endLineNumber=S,this.endColumn=E)}isEmpty(){return R.isEmpty(this)}static isEmpty(T){return T.startLineNumber===T.endLineNumber&&T.startColumn===T.endColumn}containsPosition(T){return R.containsPosition(this,T)}static containsPosition(T,_){return!(_.lineNumber<T.startLineNumber||_.lineNumber>T.endLineNumber||_.lineNumber===T.startLineNumber&&_.column<T.startColumn||_.lineNumber===T.endLineNumber&&_.column>T.endColumn)}containsRange(T){return R.containsRange(this,T)}static containsRange(T,_){return!(_.startLineNumber<T.startLineNumber||_.endLineNumber<T.startLineNumber||_.startLineNumber>T.endLineNumber||_.endLineNumber>T.endLineNumber||_.startLineNumber===T.startLineNumber&&_.startColumn<T.startColumn||_.endLineNumber===T.endLineNumber&&_.endColumn>T.endColumn)}strictContainsRange(T){return R.strictContainsRange(this,T)}static strictContainsRange(T,_){return!(_.startLineNumber<T.startLineNumber||_.endLineNumber<T.startLineNumber||_.startLineNumber>T.endLineNumber||_.endLineNumber>T.endLineNumber||_.startLineNumber===T.startLineNumber&&_.startColumn<=T.startColumn||_.endLineNumber===T.endLineNumber&&_.endColumn>=T.endColumn)}plusRange(T){return R.plusRange(this,T)}static plusRange(T,_){let S,E,k,i;return _.startLineNumber<T.startLineNumber?(S=_.startLineNumber,E=_.startColumn):_.startLineNumber===T.startLineNumber?(S=_.startLineNumber,E=Math.min(_.startColumn,T.startColumn)):(S=T.startLineNumber,E=T.startColumn),_.endLineNumber>T.endLineNumber?(k=_.endLineNumber,i=_.endColumn):_.endLineNumber===T.endLineNumber?(k=_.endLineNumber,i=Math.max(_.endColumn,T.endColumn)):(k=T.endLineNumber,i=T.endColumn),new R(S,E,k,i)}intersectRanges(T){return R.intersectRanges(this,T)}static intersectRanges(T,_){let S=T.startLineNumber,E=T.startColumn,k=T.endLineNumber,i=T.endColumn,I=_.startLineNumber,d=_.startColumn,g=_.endLineNumber,o=_.endColumn;return S<I?(S=I,E=d):S===I&&(E=Math.max(E,d)),k>g?(k=g,i=o):k===g&&(i=Math.min(i,o)),S>k||S===k&&E>i?null:new R(S,E,k,i)}equalsRange(T){return R.equalsRange(this,T)}static equalsRange(T,_){return!!T&&!!_&&T.startLineNumber===_.startLineNumber&&T.startColumn===_.startColumn&&T.endLineNumber===_.endLineNumber&&T.endColumn===_.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(T){return new p.Position(T.endLineNumber,T.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(T){return new p.Position(T.startLineNumber,T.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(T,_){return new R(this.startLineNumber,this.startColumn,T,_)}setStartPosition(T,_){return new R(T,_,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(T){return new R(T.startLineNumber,T.startColumn,T.startLineNumber,T.startColumn)}static fromPositions(T,_=T){return new R(T.lineNumber,T.column,_.lineNumber,_.column)}static lift(T){return T?new R(T.startLineNumber,T.startColumn,T.endLineNumber,T.endColumn):null}static isIRange(T){return T&&typeof T.startLineNumber=="number"&&typeof T.startColumn=="number"&&typeof T.endLineNumber=="number"&&typeof T.endColumn=="number"}static areIntersectingOrTouching(T,_){return!(T.endLineNumber<_.startLineNumber||T.endLineNumber===_.startLineNumber&&T.endColumn<_.startColumn||_.endLineNumber<T.startLineNumber||_.endLineNumber===T.startLineNumber&&_.endColumn<T.startColumn)}static areIntersecting(T,_){return!(T.endLineNumber<_.startLineNumber||T.endLineNumber===_.startLineNumber&&T.endColumn<=_.startColumn||_.endLineNumber<T.startLineNumber||_.endLineNumber===T.startLineNumber&&_.endColumn<=T.startColumn)}static compareRangesUsingStarts(T,_){if(T&&_){const k=T.startLineNumber|0,i=_.startLineNumber|0;if(k===i){const I=T.startColumn|0,d=_.startColumn|0;if(I===d){const g=T.endLineNumber|0,o=_.endLineNumber|0;if(g===o){const a=T.endColumn|0,w=_.endColumn|0;return a-w}return g-o}return I-d}return k-i}return(T?1:0)-(_?1:0)}static compareRangesUsingEnds(T,_){return T.endLineNumber===_.endLineNumber?T.endColumn===_.endColumn?T.startLineNumber===_.startLineNumber?T.startColumn-_.startColumn:T.startLineNumber-_.startLineNumber:T.endColumn-_.endColumn:T.endLineNumber-_.endLineNumber}static spansMultipleLines(T){return T.endLineNumber>T.startLineNumber}}e.Range=R}),define(be[118],_e([0,1,38,31]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var D;(function(_){_[_.LTR=0]="LTR",_[_.RTL=1]="RTL"})(D=e.SelectionDirection||(e.SelectionDirection={}));class T extends R.Range{constructor(S,E,k,i){super(S,E,k,i);this.selectionStartLineNumber=S,this.selectionStartColumn=E,this.positionLineNumber=k,this.positionColumn=i}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(S){return T.selectionsEqual(this,S)}static selectionsEqual(S,E){return S.selectionStartLineNumber===E.selectionStartLineNumber&&S.selectionStartColumn===E.selectionStartColumn&&S.positionLineNumber===E.positionLineNumber&&S.positionColumn===E.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(S,E){return this.getDirection()===0?new T(this.startLineNumber,this.startColumn,S,E):new T(S,E,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(S,E){return this.getDirection()===0?new T(S,E,this.endLineNumber,this.endColumn):new T(this.endLineNumber,this.endColumn,S,E)}static fromPositions(S,E=S){return new T(S.lineNumber,S.column,E.lineNumber,E.column)}static liftSelection(S){return new T(S.selectionStartLineNumber,S.selectionStartColumn,S.positionLineNumber,S.positionColumn)}static selectionsArrEqual(S,E){if(S&&!E||!S&&E)return!1;if(!S&&!E)return!0;if(S.length!==E.length)return!1;for(let k=0,i=S.length;k<i;k++)if(!this.selectionsEqual(S[k],E[k]))return!1;return!0}static isISelection(S){return S&&typeof S.selectionStartLineNumber=="number"&&typeof S.selectionStartColumn=="number"&&typeof S.positionLineNumber=="number"&&typeof S.positionColumn=="number"}static createWithDirection(S,E,k,i,I){return I===0?new T(S,E,k,i):new T(k,i,S,E)}}e.Selection=T}),define(be[85],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(o){o[o.Left=1]="Left",o[o.Center=2]="Center",o[o.Right=4]="Right",o[o.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(o){o[o.Inline=1]="Inline",o[o.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var D;(function(o){o[o.TextDefined=0]="TextDefined",o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(D=e.EndOfLinePreference||(e.EndOfLinePreference={}));var T;(function(o){o[o.LF=1]="LF",o[o.CRLF=2]="CRLF"})(T=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var _;(function(o){o[o.LF=0]="LF",o[o.CRLF=1]="CRLF"})(_=e.EndOfLineSequence||(e.EndOfLineSequence={}));class S{constructor(a){this.tabSize=Math.max(1,a.tabSize|0),this.indentSize=a.tabSize|0,this.insertSpaces=Boolean(a.insertSpaces),this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=Boolean(a.trimAutoWhitespace)}equals(a){return this.tabSize===a.tabSize&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.TextModelResolvedOptions=S;class E{constructor(a,w){this.range=a,this.matches=w}}e.FindMatch=E;var k;(function(o){o[o.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",o[o.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",o[o.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",o[o.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(k=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var i;(function(o){o[o.Left=0]="Left",o[o.Right=1]="Right"})(i=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(o){o[o.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class d{constructor(a,w,f,y,l,m){this.identifier=a,this.range=w,this.text=f,this.forceMoveMarkers=y,this.isAutoWhitespaceEdit=l,this._isTracked=m}}e.ValidAnnotatedEditOperation=d;class g{constructor(a,w,f){this.reverseEdits=a,this.changes=w,this.trimAutoWhitespaceLineNumbers=f}}e.ApplyEditsResult=g}),define(be[119],_e([0,1,8,117,38,31,85]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const S=999;class E{constructor(l,m,h,t){this.searchString=l,this.isRegex=m,this.matchCase=h,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=k(this.searchString):l=this.searchString.indexOf(`
`)>=0;let m=null;try{m=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!m)return null;let h=!this.isRegex&&!l;return h&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(h=this.matchCase),new i(m,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,h?this.searchString:null)}}e.SearchParams=E;function k(y){if(!y||y.length===0)return!1;for(let l=0,m=y.length;l<m;l++)if(y.charCodeAt(l)===92){if(l++,l>=m)break;const t=y.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=k;class i{constructor(l,m,h){this.regex=l,this.wordSeparators=m,this.simpleSearch=h}}e.SearchData=i;function I(y,l,m){if(!m)return new _.FindMatch(y,null);let h=[];for(let t=0,n=l.length;t<n;t++)h[t]=l[t];return new _.FindMatch(y,h)}e.createFindMatch=I;class d{constructor(l){let m=[],h=0;for(let t=0,n=l.length;t<n;t++)l.charCodeAt(t)===10&&(m[h++]=t);this._lineFeedsOffsets=m}findLineFeedCountBeforeOffset(l){const m=this._lineFeedsOffsets;let h=0,t=m.length-1;if(t===-1||l<=m[0])return 0;for(;h<t;){const n=h+((t-h)/2>>0);m[n]>=l?t=n-1:m[n+1]>=l?(h=n,t=n):h=n+1}return h+1}}class g{static findMatches(l,m,h,t,n){const r=m.parseSearchRequest();return r?r.regex.multiline?this._doFindMatchesMultiline(l,h,new f(r.wordSeparators,r.regex),t,n):this._doFindMatchesLineByLine(l,h,r,t,n):[]}static _getMultilineMatchRange(l,m,h,t,n,r){let s,u=0;t?(u=t.findLineFeedCountBeforeOffset(n),s=m+n+u):s=m+n;let v;if(t){let c=t.findLineFeedCountBeforeOffset(n+r.length)-u;v=s+r.length+c}else v=s+r.length;const b=l.getPositionAt(s),P=l.getPositionAt(v);return new T.Range(b.lineNumber,b.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(l,m,h,t,n){const r=l.getOffsetAt(m.getStartPosition()),s=l.getValueInRange(m,1),u=l.getEOL()===`\r
`?new d(s):null,v=[];let b=0,P;for(h.reset(0);P=h.next(s);)if(v[b++]=I(this._getMultilineMatchRange(l,r,s,u,P.index,P[0]),P,t),b>=n)return v;return v}static _doFindMatchesLineByLine(l,m,h,t,n){const r=[];let s=0;if(m.startLineNumber===m.endLineNumber){const v=l.getLineContent(m.startLineNumber).substring(m.startColumn-1,m.endColumn-1);return s=this._findMatchesInLine(h,v,m.startLineNumber,m.startColumn-1,s,r,t,n),r}const u=l.getLineContent(m.startLineNumber).substring(m.startColumn-1);s=this._findMatchesInLine(h,u,m.startLineNumber,m.startColumn-1,s,r,t,n);for(let v=m.startLineNumber+1;v<m.endLineNumber&&s<n;v++)s=this._findMatchesInLine(h,l.getLineContent(v),v,0,s,r,t,n);if(s<n){const v=l.getLineContent(m.endLineNumber).substring(0,m.endColumn-1);s=this._findMatchesInLine(h,v,m.endLineNumber,0,s,r,t,n)}return r}static _findMatchesInLine(l,m,h,t,n,r,s,u){const v=l.wordSeparators;if(!s&&l.simpleSearch){const C=l.simpleSearch,c=C.length,F=m.length;let N=-c;for(;(N=m.indexOf(C,N+c))!==-1;)if((!v||w(v,m,F,N,c))&&(r[n++]=new _.FindMatch(new T.Range(h,N+1+t,h,N+1+c+t),null),n>=u))return n;return n}const b=new f(l.wordSeparators,l.regex);let P;b.reset(0);do if(P=b.next(m),P&&(r[n++]=I(new T.Range(h,P.index+1+t,h,P.index+1+P[0].length+t),P,s),n>=u))return n;while(P);return n}static findNextMatch(l,m,h,t){const n=m.parseSearchRequest();if(!n)return null;const r=new f(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindNextMatchMultiline(l,h,r,t):this._doFindNextMatchLineByLine(l,h,r,t)}static _doFindNextMatchMultiline(l,m,h,t){const n=new D.Position(m.lineNumber,1),r=l.getOffsetAt(n),s=l.getLineCount(),u=l.getValueInRange(new T.Range(n.lineNumber,n.column,s,l.getLineMaxColumn(s)),1),v=l.getEOL()===`\r
`?new d(u):null;h.reset(m.column-1);let b=h.next(u);return b?I(this._getMultilineMatchRange(l,r,u,v,b.index,b[0]),b,t):m.lineNumber!==1||m.column!==1?this._doFindNextMatchMultiline(l,new D.Position(1,1),h,t):null}static _doFindNextMatchLineByLine(l,m,h,t){const n=l.getLineCount(),r=m.lineNumber,s=l.getLineContent(r),u=this._findFirstMatchInLine(h,s,r,m.column,t);if(u)return u;for(let v=1;v<=n;v++){const b=(r+v-1)%n,P=l.getLineContent(b+1),C=this._findFirstMatchInLine(h,P,b+1,1,t);if(C)return C}return null}static _findFirstMatchInLine(l,m,h,t,n){l.reset(t-1);const r=l.next(m);return r?I(new T.Range(h,r.index+1,h,r.index+1+r[0].length),r,n):null}static findPreviousMatch(l,m,h,t){const n=m.parseSearchRequest();if(!n)return null;const r=new f(n.wordSeparators,n.regex);return n.regex.multiline?this._doFindPreviousMatchMultiline(l,h,r,t):this._doFindPreviousMatchLineByLine(l,h,r,t)}static _doFindPreviousMatchMultiline(l,m,h,t){const n=this._doFindMatchesMultiline(l,new T.Range(1,1,m.lineNumber,m.column),h,t,10*S);if(n.length>0)return n[n.length-1];const r=l.getLineCount();return m.lineNumber!==r||m.column!==l.getLineMaxColumn(r)?this._doFindPreviousMatchMultiline(l,new D.Position(r,l.getLineMaxColumn(r)),h,t):null}static _doFindPreviousMatchLineByLine(l,m,h,t){const n=l.getLineCount(),r=m.lineNumber,s=l.getLineContent(r).substring(0,m.column-1),u=this._findLastMatchInLine(h,s,r,t);if(u)return u;for(let v=1;v<=n;v++){const b=(n+r-v-1)%n,P=l.getLineContent(b+1),C=this._findLastMatchInLine(h,P,b+1,t);if(C)return C}return null}static _findLastMatchInLine(l,m,h,t){let n=null,r;for(l.reset(0);r=l.next(m);)n=I(new T.Range(h,r.index+1,h,r.index+1+r[0].length),r,t);return n}}e.TextModelSearch=g;function o(y,l,m,h,t){if(h===0)return!0;const n=l.charCodeAt(h-1);if(y.get(n)!==0||n===13||n===10)return!0;if(t>0){const r=l.charCodeAt(h);if(y.get(r)!==0)return!0}return!1}function a(y,l,m,h,t){if(h+t===m)return!0;const n=l.charCodeAt(h+t);if(y.get(n)!==0||n===13||n===10)return!0;if(t>0){const r=l.charCodeAt(h+t-1);if(y.get(r)!==0)return!0}return!1}function w(y,l,m,h,t){return o(y,l,m,h,t)&&a(y,l,m,h,t)}e.isValidMatch=w;class f{constructor(l,m){this._wordSeparators=l,this._searchRegex=m,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const m=l.length;let h;do{if(this._prevMatchStartIndex+this._prevMatchLength===m||(h=this._searchRegex.exec(l),!h))return null;const t=h.index,n=h[0].length;if(t===this._prevMatchStartIndex&&n===this._prevMatchLength){if(n===0){p.getNextCodePoint(l,m,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=n,!this._wordSeparators||w(this._wordSeparators,l,m,t,n))return h}while(h);return null}}e.Searcher=f}),define(be[86],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(S=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)S.indexOf(k)>=0||(E+="\\"+k);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=p();function R(S){let E=e.DEFAULT_WORD_REGEXP;if(S&&S instanceof RegExp)if(S.global)E=S;else{let k="g";S.ignoreCase&&(k+="i"),S.multiline&&(k+="m"),S.unicode&&(k+="u"),E=new RegExp(S.source,k)}return E.lastIndex=0,E}e.ensureValidWordDefinition=R;const D={maxLen:1e3,windowSize:15,timeBudget:150};function T(S,E,k,i,I=D){if(k.length>I.maxLen){let w=S-I.maxLen/2;return w<0?w=0:i+=w,k=k.substring(w,S+I.maxLen/2),T(S,E,k,i,I)}const d=Date.now(),g=S-1-i;let o=-1,a=null;for(let w=1;!(Date.now()-d>=I.timeBudget);w++){const f=g-I.windowSize*w;E.lastIndex=Math.max(0,f);const y=_(E,k,g,o);if(!y&&a||(a=y,f<=0))break;o=f}if(a){let w={word:a[0],startColumn:i+1+a.index,endColumn:i+1+a.index+a[0].length};return E.lastIndex=0,w}return null}e.getWordAtText=T;function _(S,E,k,i){let I;for(;I=S.exec(E);){const d=I.index||0;if(d<=k&&S.lastIndex>=k)return I;if(i>0&&d>i)return null}return null}}),define(be[120],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(_){_[_.None=0]="None",_[_.Indent=1]="Indent",_[_.IndentOutdent=2]="IndentOutdent",_[_.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class R{constructor(S){if(this.open=S.open,this.close=S.close,this._standardTokenMask=0,Array.isArray(S.notIn))for(let E=0,k=S.notIn.length;E<k;E++)switch(S.notIn[E]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(S){return(this._standardTokenMask&S)==0}}e.StandardAutoClosingPairConditional=R;class D{constructor(S){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of S)T(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),T(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),T(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),T(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&T(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=D;function T(_,S,E){_.has(S)?_.get(S).push(E):_.set(S,[E])}}),define(be[60],_e([0,1,27,12]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function D(T,_,S,E){if(Array.isArray(T)){let k=0;for(const i of T){const I=D(i,_,S,E);if(I===10)return I;I>k&&(k=I)}return k}else{if(typeof T=="string")return E?T==="*"?5:T===S?10:0:0;if(T){const{language:k,pattern:i,scheme:I,hasAccessToAllModels:d}=T;if(!E&&!d)return 0;let g=0;if(I)if(I===_.scheme)g=10;else if(I==="*")g=5;else return 0;if(k)if(k===S)g=10;else if(k==="*")g=Math.max(g,5);else return 0;if(i){let o;if(typeof i=="string"?o=i:o=Object.assign(Object.assign({},i),{base:(0,R.normalize)(i.base)}),o===_.fsPath||(0,p.match)(o,_.fsPath))g=10;else return 0}return g}else return 0}}e.score=D}),define(be[121],_e([0,1,84]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(g){g[g.Invalid=0]="Invalid",g[g.Start=1]="Start",g[g.H=2]="H",g[g.HT=3]="HT",g[g.HTT=4]="HTT",g[g.HTTP=5]="HTTP",g[g.F=6]="F",g[g.FI=7]="FI",g[g.FIL=8]="FIL",g[g.BeforeColon=9]="BeforeColon",g[g.AfterColon=10]="AfterColon",g[g.AlmostThere=11]="AlmostThere",g[g.End=12]="End",g[g.Accept=13]="Accept",g[g.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class D{constructor(o,a,w){const f=new Uint8Array(o*a);for(let y=0,l=o*a;y<l;y++)f[y]=w;this._data=f,this.rows=o,this.cols=a}get(o,a){return this._data[o*this.cols+a]}set(o,a,w){this._data[o*this.cols+a]=w}}e.Uint8Matrix=D;class T{constructor(o){let a=0,w=0;for(let y=0,l=o.length;y<l;y++){let[m,h,t]=o[y];h>a&&(a=h),m>w&&(w=m),t>w&&(w=t)}a++,w++;let f=new D(w,a,0);for(let y=0,l=o.length;y<l;y++){let[m,h,t]=o[y];f.set(m,h,t)}this._states=f,this._maxCharCode=a}nextState(o,a){return a<0||a>=this._maxCharCode?0:this._states.get(o,a)}}e.StateMachine=T;let _=null;function S(){return _===null&&(_=new T([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),_}var E;(function(g){g[g.None=0]="None",g[g.ForceTermination=1]="ForceTermination",g[g.CannotEndIn=2]="CannotEndIn"})(E||(E={}));let k=null;function i(){if(k===null){k=new p.CharacterClassifier(0);const g=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let a=0;a<g.length;a++)k.set(g.charCodeAt(a),1);const o=".,;";for(let a=0;a<o.length;a++)k.set(o.charCodeAt(a),2)}return k}class I{static _createLink(o,a,w,f,y){let l=y-1;do{const m=a.charCodeAt(l);if(o.get(m)!==2)break;l--}while(l>f);if(f>0){const m=a.charCodeAt(f-1),h=a.charCodeAt(l);(m===40&&h===41||m===91&&h===93||m===123&&h===125)&&l--}return{range:{startLineNumber:w,startColumn:f+1,endLineNumber:w,endColumn:l+2},url:a.substring(f,l+1)}}static computeLinks(o,a=S()){const w=i();let f=[];for(let y=1,l=o.getLineCount();y<=l;y++){const m=o.getLineContent(y),h=m.length;let t=0,n=0,r=0,s=1,u=!1,v=!1,b=!1,P=!1;for(;t<h;){let C=!1;const c=m.charCodeAt(t);if(s===13){let F;switch(c){case 40:u=!0,F=0;break;case 41:F=u?0:1;break;case 91:b=!0,v=!0,F=0;break;case 93:b=!1,F=v?0:1;break;case 123:P=!0,F=0;break;case 125:F=P?0:1;break;case 39:F=r===34||r===96?0:1;break;case 34:F=r===39||r===96?0:1;break;case 96:F=r===39||r===34?0:1;break;case 42:F=r===42?1:0;break;case 124:F=r===124?1:0;break;case 32:F=b?0:1;break;default:F=w.get(c)}F===1&&(f.push(I._createLink(w,m,y,n,t)),C=!0)}else if(s===12){let F;c===91?(v=!0,F=0):F=w.get(c),F===1?C=!0:s=13}else s=a.nextState(s,c),s===0&&(C=!0);C&&(s=1,u=!1,v=!1,P=!1,n=t+1,r=c),t++}s===13&&f.push(I._createLink(w,m,y,n,h))}return f}}e.LinkComputer=I;function d(g){return!g||typeof g.getLineCount!="function"||typeof g.getLineContent!="function"?[]:I.computeLinks(g)}e.computeLinks=d}),define(be[122],_e([0,1,3,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class D{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(_){this._onDidChange.fire({changedLanguages:_,changedColorMap:!1})}register(_,S){return this._map.set(_,S),this.fire([_]),(0,R.toDisposable)(()=>{this._map.get(_)===S&&(this._map.delete(_),this.fire([_]))})}registerPromise(_,S){let E=null,k=!1;return this._promises.set(_,S.then(i=>{this._promises.delete(_),!(k||!i)&&(E=this.register(_,i))})),(0,R.toDisposable)(()=>{k=!0,E&&E.dispose()})}getPromise(_){const S=this.get(_);if(S)return Promise.resolve(S);const E=this._promises.get(_);return E?E.then(k=>this.get(_)):null}get(_){return this._map.get(_)||null}setColorMap(_){this._colorMap=_,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=D}),define(be[87],_e([0,1,25,21]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var D;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(D||(D={}));function T(I){for(let d=0,g=I.length;d<g;d+=4){const o=I[d+0],a=I[d+1],w=I[d+2],f=I[d+3];I[d+0]=f,I[d+1]=w,I[d+2]=a,I[d+3]=o}}function _(I){const d=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return R.isLittleEndian()||T(d),p.VSBuffer.wrap(d)}function S(I){const d=I.buffer;if(R.isLittleEndian()||T(d),d.byteOffset%4==0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const g=new Uint8Array(d.byteLength);return g.set(d),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function E(I){const d=new Uint32Array(k(I));let g=0;if(d[g++]=I.id,I.type==="full")d[g++]=1,d[g++]=I.data.length,d.set(I.data,g),g+=I.data.length;else{d[g++]=2,d[g++]=I.deltas.length;for(const o of I.deltas)d[g++]=o.start,d[g++]=o.deleteCount,o.data?(d[g++]=o.data.length,d.set(o.data,g),g+=o.data.length):d[g++]=0}return _(d)}e.encodeSemanticTokensDto=E;function k(I){let d=0;if(d+=1+1,I.type==="full")d+=1+I.data.length;else{d+=1,d+=(1+1+1)*I.deltas.length;for(const g of I.deltas)g.data&&(d+=g.data.length)}return d}function i(I){const d=S(I);let g=0;const o=d[g++];if(d[g++]===1){const y=d[g++],l=d.subarray(g,g+y);return g+=y,{id:o,type:"full",data:l}}const w=d[g++];let f=[];for(let y=0;y<w;y++){const l=d[g++],m=d[g++],h=d[g++];let t;h>0&&(t=d.subarray(g,g+h),g+=h),f[y]={start:l,deleteCount:m,data:t}}return{id:o,type:"delta",deltas:f}}e.decodeSemanticTokensDto=i}),define(be[88],_e([0,1,82]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(_,S){this.index=_,this.remainder=S}}e.PrefixSumIndexOfResult=R;class D{constructor(_){this.values=_,this.prefixSum=new Uint32Array(_.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(_,S){_=(0,p.toUint32)(_);const E=this.values,k=this.prefixSum,i=S.length;return i===0?!1:(this.values=new Uint32Array(E.length+i),this.values.set(E.subarray(0,_),0),this.values.set(E.subarray(_),_+i),this.values.set(S,_),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(_,S){return _=(0,p.toUint32)(_),S=(0,p.toUint32)(S),this.values[_]===S?!1:(this.values[_]=S,_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),!0)}removeValues(_,S){_=(0,p.toUint32)(_),S=(0,p.toUint32)(S);const E=this.values,k=this.prefixSum;if(_>=E.length)return!1;let i=E.length-_;return S>=i&&(S=i),S===0?!1:(this.values=new Uint32Array(E.length-S),this.values.set(E.subarray(0,_),0),this.values.set(E.subarray(_+S),_),this.prefixSum=new Uint32Array(this.values.length),_-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=_-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(k.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return this.values.length===0?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(_){return _<0?0:(_=(0,p.toUint32)(_),this._getAccumulatedValue(_))}_getAccumulatedValue(_){if(_<=this.prefixSumValidIndex[0])return this.prefixSum[_];let S=this.prefixSumValidIndex[0]+1;S===0&&(this.prefixSum[0]=this.values[0],S++),_>=this.values.length&&(_=this.values.length-1);for(let E=S;E<=_;E++)this.prefixSum[E]=this.prefixSum[E-1]+this.values[E];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],_),this.prefixSum[_]}getIndexOf(_){_=Math.floor(_),this.getTotalValue();let S=0,E=this.values.length-1,k=0,i=0,I=0;for(;S<=E;)if(k=S+(E-S)/2|0,i=this.prefixSum[k],I=i-this.values[k],_<I)E=k-1;else if(_>=i)S=k+1;else break;return new R(k,_-I)}}e.PrefixSumComputer=D}),define(be[123],_e([0,1,8,38,88]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class T{constructor(S,E,k,i){this._uri=S,this._lines=E,this._eol=k,this._versionId=i,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(S){S.eol&&S.eol!==this._eol&&(this._eol=S.eol,this._lineStarts=null);const E=S.changes;for(const k of E)this._acceptDeleteRange(k.range),this._acceptInsertText(new R.Position(k.range.startLineNumber,k.range.startColumn),k.text);this._versionId=S.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const S=this._eol.length,E=this._lines.length,k=new Uint32Array(E);for(let i=0;i<E;i++)k[i]=this._lines[i].length+S;this._lineStarts=new D.PrefixSumComputer(k)}}_setLineText(S,E){this._lines[S]=E,this._lineStarts&&this._lineStarts.changeValue(S,this._lines[S].length+this._eol.length)}_acceptDeleteRange(S){if(S.startLineNumber===S.endLineNumber){if(S.startColumn===S.endColumn)return;this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.startLineNumber-1].substring(S.endColumn-1));return}this._setLineText(S.startLineNumber-1,this._lines[S.startLineNumber-1].substring(0,S.startColumn-1)+this._lines[S.endLineNumber-1].substring(S.endColumn-1)),this._lines.splice(S.startLineNumber,S.endLineNumber-S.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(S.startLineNumber,S.endLineNumber-S.startLineNumber)}_acceptInsertText(S,E){if(E.length===0)return;let k=(0,p.splitLines)(E);if(k.length===1){this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+k[0]+this._lines[S.lineNumber-1].substring(S.column-1));return}k[k.length-1]+=this._lines[S.lineNumber-1].substring(S.column-1),this._setLineText(S.lineNumber-1,this._lines[S.lineNumber-1].substring(0,S.column-1)+k[0]);let i=new Uint32Array(k.length-1);for(let I=1;I<k.length;I++)this._lines.splice(S.lineNumber+I-1,0,k[I]),i[I-1]=k[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(S.lineNumber,i)}}e.MirrorTextModel=T}),define(be[124],_e([18,19]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(be[61],_e([0,1,124,9,14]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function T(k,i){return i&&(k.stack||k.stacktrace)?p.localize(0,null,S(k),_(k.stack)||_(k.stacktrace)):S(k)}function _(k){return Array.isArray(k)?k.join(`
`):k}function S(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?p.localize(1,null,k.message):k.message||p.localize(2,null)}function E(k=null,i=!1){if(!k)return p.localize(3,null);if(Array.isArray(k)){const I=D.coalesce(k),d=E(I[0],i);return I.length>1?p.localize(4,null,d,I.length):d}if(R.isString(k))return k;if(k.detail){const I=k.detail;if(I.error)return T(I.error,i);if(I.exception)return T(I.exception,i)}return k.stack?T(k,i):k.message?k.message:p.localize(5,null)}e.toErrorMessage=E}),define(be[125],_e([18,19]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(be[126],_e([0,1,125,21,86]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var T;(function(V){V[V.None=0]="None",V[V.Keep=1]="Keep",V[V.Brackets=2]="Brackets",V[V.Advanced=3]="Advanced",V[V.Full=4]="Full"})(T=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class _{constructor(te){this._values=te}hasChanged(te){return this._values[te]}}e.ConfigurationChangedEvent=_;class S{constructor(){this._values=[]}_read(te){return this._values[te]}get(te){return this._values[te]}_write(te,pe){this._values[te]=pe}}e.ValidatedEditorOptions=S;class E{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=E;class k{constructor(te,pe,Me,$e){this.id=te,this.name=pe,this.defaultValue=Me,this.schema=$e}compute(te,pe,Me){return Me}}class i{constructor(te,pe=null){this.schema=void 0,this.id=te,this.name="_never_",this.defaultValue=void 0,this.deps=pe}validate(te){return this.defaultValue}}class I{constructor(te,pe,Me,$e){this.id=te,this.name=pe,this.defaultValue=Me,this.schema=$e}validate(te){return typeof te=="undefined"?this.defaultValue:te}compute(te,pe,Me){return Me}}function d(V,te){return typeof V=="undefined"?te:V==="false"?!1:Boolean(V)}e.boolean=d;class g extends I{constructor(te,pe,Me,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Me),super(te,pe,Me,$e)}validate(te){return d(te,this.defaultValue)}}class o extends I{constructor(te,pe,Me,$e,Be,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="integer",Ye.default=Me,Ye.minimum=$e,Ye.maximum=Be),super(te,pe,Me,Ye),this.minimum=$e,this.maximum=Be}static clampedInt(te,pe,Me,$e){if(typeof te=="undefined")return pe;let Be=parseInt(te,10);return isNaN(Be)?pe:(Be=Math.max(Me,Be),Be=Math.min($e,Be),Be|0)}validate(te){return o.clampedInt(te,this.defaultValue,this.minimum,this.maximum)}}class a extends I{constructor(te,pe,Me,$e,Be){typeof Be!="undefined"&&(Be.type="number",Be.default=Me),super(te,pe,Me,Be),this.validationFn=$e}static clamp(te,pe,Me){return te<pe?pe:te>Me?Me:te}static float(te,pe){if(typeof te=="number")return te;if(typeof te=="undefined")return pe;const Me=parseFloat(te);return isNaN(Me)?pe:Me}validate(te){return this.validationFn(a.float(te,this.defaultValue))}}class w extends I{static string(te,pe){return typeof te!="string"?pe:te}constructor(te,pe,Me,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Me),super(te,pe,Me,$e)}validate(te){return w.string(te,this.defaultValue)}}function f(V,te,pe){return typeof V!="string"||pe.indexOf(V)===-1?te:V}e.stringSet=f;class y extends I{constructor(te,pe,Me,$e,Be=void 0){typeof Be!="undefined"&&(Be.type="string",Be.enum=$e,Be.default=Me),super(te,pe,Me,Be),this._allowedValues=$e}validate(te){return f(te,this.defaultValue,this._allowedValues)}}class l extends k{constructor(te,pe,Me,$e,Be,Ye,Se=void 0){typeof Se!="undefined"&&(Se.type="string",Se.enum=Be,Se.default=$e),super(te,pe,Me,Se),this._allowedValues=Be,this._convert=Ye}validate(te){return typeof te!="string"?this.defaultValue:this._allowedValues.indexOf(te)===-1?this.defaultValue:this._convert(te)}}function m(V){switch(V){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class h extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(te){switch(te){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(te,pe,Me){return Me===0?te.accessibilitySupport:Me}}class t extends k{constructor(){const te={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",te,{"editor.comments.insertSpace":{type:"boolean",default:te.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:te.ignoreEmptyLines,description:p.localize(5,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertSpace:d(pe.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(pe.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function(V){V[V.Hidden=0]="Hidden",V[V.Blink=1]="Blink",V[V.Smooth=2]="Smooth",V[V.Phase=3]="Phase",V[V.Expand=4]="Expand",V[V.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function r(V){switch(V){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var s;(function(V){V[V.Line=1]="Line",V[V.Block=2]="Block",V[V.Underline=3]="Underline",V[V.LineThin=4]="LineThin",V[V.BlockOutline=5]="BlockOutline",V[V.UnderlineThin=6]="UnderlineThin"})(s=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(V){switch(V){case s.Line:return"line";case s.Block:return"block";case s.Underline:return"underline";case s.LineThin:return"line-thin";case s.BlockOutline:return"block-outline";case s.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function v(V){switch(V){case"line":return s.Line;case"block":return s.Block;case"underline":return s.Underline;case"line-thin":return s.LineThin;case"block-outline":return s.BlockOutline;case"underline-thin":return s.UnderlineThin}}class b extends i{constructor(){super(124,[62,31])}compute(te,pe,Me){const $e=["monaco-editor"];return pe.get(31)&&$e.push(pe.get(31)),te.extraEditorClassName&&$e.push(te.extraEditorClassName),pe.get(62)==="default"?$e.push("mouse-default"):pe.get(62)==="copy"&&$e.push("mouse-copy"),pe.get(97)&&$e.push("showUnused"),pe.get(122)&&$e.push("showDeprecated"),$e.join(" ")}}class P extends g{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(te,pe,Me){return Me&&te.emptySelectionClipboard}}class C extends k{constructor(){const te={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",te,{"editor.find.cursorMoveOnType":{type:"boolean",default:te.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:te.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:te.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:te.globalFindClipboard,description:p.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:te.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:te.loop,description:p.localize(15,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{cursorMoveOnType:d(pe.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:d(pe.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof te.autoFindInSelection=="boolean"?te.autoFindInSelection?"always":"never":f(pe.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(pe.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(pe.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(pe.loop,this.defaultValue.loop)}}}class c extends k{constructor(){super(41,"fontLigatures",c.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(te){return typeof te=="undefined"?this.defaultValue:typeof te=="string"?te==="false"?c.OFF:te==="true"?c.ON:te:Boolean(te)?c.ON:c.OFF}}e.EditorFontLigatures=c,c.OFF='"liga" off, "calt" off',c.ON='"liga" on, "calt" on';class F extends i{constructor(){super(40)}compute(te,pe,Me){return te.fontInfo}}class N extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(te){let pe=a.float(te,this.defaultValue);return pe===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(pe,6,100)}compute(te,pe,Me){return te.fontInfo.fontSize}}class z extends k{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:z.MINIMUM_VALUE,maximum:z.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:z.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(te){return te==="normal"||te==="bold"?te:String(o.clampedInt(te,e.EDITOR_FONT_DEFAULTS.fontWeight,z.MINIMUM_VALUE,z.MAXIMUM_VALUE))}}z.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],z.MINIMUM_VALUE=1,z.MAXIMUM_VALUE=1e3;class he extends k{constructor(){const te={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},pe={type:"string",enum:["peek","gotoAndPeek","goto"],default:te.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},Me=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",te,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:p.localize(26,null)},pe),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:p.localize(27,null)},pe),"editor.gotoLocation.multipleDeclarations":Object.assign({description:p.localize(28,null)},pe),"editor.gotoLocation.multipleImplementations":Object.assign({description:p.localize(29,null)},pe),"editor.gotoLocation.multipleReferences":Object.assign({description:p.localize(30,null)},pe),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:te.alternativeDefinitionCommand,enum:Me,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:te.alternativeTypeDefinitionCommand,enum:Me,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:te.alternativeDeclarationCommand,enum:Me,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:te.alternativeImplementationCommand,enum:Me,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:te.alternativeReferenceCommand,enum:Me,description:p.localize(35,null)}})}validate(te){var pe,Me,$e,Be,Ye;if(!te||typeof te!="object")return this.defaultValue;const Se=te;return{multiple:f(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(pe=Se.multipleDefinitions)!==null&&pe!==void 0?pe:f(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Me=Se.multipleTypeDefinitions)!==null&&Me!==void 0?Me:f(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:($e=Se.multipleDeclarations)!==null&&$e!==void 0?$e:f(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Be=Se.multipleImplementations)!==null&&Be!==void 0?Be:f(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ye=Se.multipleReferences)!==null&&Ye!==void 0?Ye:f(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:w.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:w.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:w.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:w.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:w.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class me extends k{constructor(){const te={enabled:!0,delay:300,sticky:!0};super(50,"hover",te,{"editor.hover.enabled":{type:"boolean",default:te.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:te.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:te.sticky,description:p.localize(38,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:d(pe.enabled,this.defaultValue.enabled),delay:o.clampedInt(pe.delay,this.defaultValue.delay,0,1e4),sticky:d(pe.sticky,this.defaultValue.sticky)}}}var Q;(function(V){V[V.None=0]="None",V[V.Text=1]="Text",V[V.Blocks=2]="Blocks"})(Q=e.RenderMinimap||(e.RenderMinimap={}));class W extends i{constructor(){super(127,[46,54,35,61,89,56,57,91,114,117,118,119,2])}compute(te,pe,Me){return W.computeLayout(pe,{memory:te.memory,outerWidth:te.outerWidth,outerHeight:te.outerHeight,isDominatedByLongLines:te.isDominatedByLongLines,lineHeight:te.fontInfo.lineHeight,viewLineCount:te.viewLineCount,lineNumbersDigitCount:te.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:te.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:te.fontInfo.maxDigitWidth,pixelRatio:te.pixelRatio})}static computeContainedMinimapLineCount(te){const pe=te.height/te.lineHeight,Me=te.scrollBeyondLastLine?pe-1:0,$e=(te.viewLineCount+Me)/(te.pixelRatio*te.height),Be=Math.floor(te.viewLineCount/$e);return{typicalViewportLineCount:pe,extraLinesBeyondLastLine:Me,desiredRatio:$e,minimapLineCount:Be}}static _computeMinimapLayout(te,pe){const Me=te.outerWidth,$e=te.outerHeight,Be=te.pixelRatio;if(!te.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Be*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Ye=pe.stableMinimapLayoutInput,Se=Ye&&te.outerHeight===Ye.outerHeight&&te.lineHeight===Ye.lineHeight&&te.typicalHalfwidthCharacterWidth===Ye.typicalHalfwidthCharacterWidth&&te.pixelRatio===Ye.pixelRatio&&te.scrollBeyondLastLine===Ye.scrollBeyondLastLine&&te.minimap.enabled===Ye.minimap.enabled&&te.minimap.side===Ye.minimap.side&&te.minimap.size===Ye.minimap.size&&te.minimap.showSlider===Ye.minimap.showSlider&&te.minimap.renderCharacters===Ye.minimap.renderCharacters&&te.minimap.maxColumn===Ye.minimap.maxColumn&&te.minimap.scale===Ye.minimap.scale&&te.verticalScrollbarWidth===Ye.verticalScrollbarWidth&&te.isViewportWrapping===Ye.isViewportWrapping,ye=te.lineHeight,De=te.typicalHalfwidthCharacterWidth,ie=te.scrollBeyondLastLine,ue=te.minimap.renderCharacters;let O=Be>=2?Math.round(te.minimap.scale*2):te.minimap.scale;const J=te.minimap.maxColumn,oe=te.minimap.size,Ce=te.minimap.side,ke=te.verticalScrollbarWidth,Ne=te.viewLineCount,Oe=te.remainingWidth,qe=te.isViewportWrapping,rt=ue?2:3;let tt=Math.floor(Be*$e);const Je=tt/Be;let ot=!1,_t=!1,bt=rt*O,ve=O/Be,ce=1;if(oe==="fill"||oe==="fit"){const{typicalViewportLineCount:ft,extraLinesBeyondLastLine:ut,desiredRatio:it,minimapLineCount:vt}=W.computeContainedMinimapLineCount({viewLineCount:Ne,scrollBeyondLastLine:ie,height:$e,lineHeight:ye,pixelRatio:Be});if(Ne/vt>1)ot=!0,_t=!0,O=1,bt=1,ve=O/Be;else{let lt=!1,mt=O+1;if(oe==="fit"){const Pt=Math.ceil((Ne+ut)*bt);qe&&Se&&Oe<=pe.stableFitRemainingWidth?(lt=!0,mt=pe.stableFitMaxMinimapScale):(lt=Pt>tt,qe&&lt?(pe.stableMinimapLayoutInput=te,pe.stableFitRemainingWidth=Oe):(pe.stableMinimapLayoutInput=null,pe.stableFitRemainingWidth=0))}if(oe==="fill"||lt){ot=!0;const Pt=O;bt=Math.min(ye*Be,Math.max(1,Math.floor(1/it))),O=Math.min(mt,Math.max(1,Math.floor(bt/rt))),O>Pt&&(ce=Math.min(2,O/Pt)),ve=O/Be/ce,tt=Math.ceil(Math.max(ft,Ne+ut)*bt),qe&&lt&&(pe.stableFitMaxMinimapScale=O)}}}const le=Math.floor(J*ve),q=Math.min(le,Math.max(0,Math.floor((Oe-ke-2)*ve/(De+ve)))+e.MINIMAP_GUTTER_WIDTH);let Fe=Math.floor(Be*q);const Pe=Fe/Be;Fe=Math.floor(Fe*ce);const Ze=ue?1:2,et=Ce==="left"?0:Me-q-ke;return{renderMinimap:Ze,minimapLeft:et,minimapWidth:q,minimapHeightIsEditorHeight:ot,minimapIsSampling:_t,minimapScale:O,minimapLineHeight:bt,minimapCanvasInnerWidth:Fe,minimapCanvasInnerHeight:tt,minimapCanvasOuterWidth:Pe,minimapCanvasOuterHeight:Je}}static computeLayout(te,pe){const Me=pe.outerWidth|0,$e=pe.outerHeight|0,Be=pe.lineHeight|0,Ye=pe.lineNumbersDigitCount|0,Se=pe.typicalHalfwidthCharacterWidth,ye=pe.maxDigitWidth,De=pe.pixelRatio,ie=pe.viewLineCount,ue=te.get(119),O=ue==="inherit"?te.get(118):ue,J=O==="inherit"?te.get(114):O,oe=te.get(117),Ce=te.get(2),ke=pe.isDominatedByLongLines,Ne=te.get(46),Oe=te.get(56).renderType!==0,qe=te.get(57),rt=te.get(91),tt=te.get(61),Je=te.get(89),ot=Je.verticalScrollbarSize,_t=Je.verticalHasArrows,bt=Je.arrowSize,ve=Je.horizontalScrollbarSize,ce=te.get(54),le=te.get(35);let q;if(typeof ce=="string"&&/^\d+(\.\d+)?ch$/.test(ce)){const Rt=parseFloat(ce.substr(0,ce.length-2));q=o.clampedInt(Rt*Se,0,0,1e3)}else q=o.clampedInt(ce,0,0,1e3);le&&(q+=16);let Fe=0;if(Oe){const Rt=Math.max(Ye,qe);Fe=Math.round(Rt*ye)}let Pe=0;Ne&&(Pe=Be);let Ze=0,et=Ze+Pe,ft=et+Fe,ut=ft+q;const it=Me-Pe-Fe-q;let vt=!1,ht=!1,lt=-1;Ce!==2&&(O==="inherit"&&ke?(vt=!0,ht=!0):J==="on"||J==="bounded"?ht=!0:J==="wordWrapColumn"&&(lt=oe));const mt=W._computeMinimapLayout({outerWidth:Me,outerHeight:$e,lineHeight:Be,typicalHalfwidthCharacterWidth:Se,pixelRatio:De,scrollBeyondLastLine:rt,minimap:tt,verticalScrollbarWidth:ot,viewLineCount:ie,remainingWidth:it,isViewportWrapping:ht},pe.memory||new E);mt.renderMinimap!==0&&mt.minimapLeft===0&&(Ze+=mt.minimapWidth,et+=mt.minimapWidth,ft+=mt.minimapWidth,ut+=mt.minimapWidth);const Pt=it-mt.minimapWidth,Ct=Math.max(1,Math.floor((Pt-ot-2)/Se)),At=_t?bt:0;return ht&&(lt=Math.max(1,Ct),J==="bounded"&&(lt=Math.min(lt,oe))),{width:Me,height:$e,glyphMarginLeft:Ze,glyphMarginWidth:Pe,lineNumbersLeft:et,lineNumbersWidth:Fe,decorationsLeft:ft,decorationsWidth:q,contentLeft:ut,contentWidth:Pt,minimap:mt,viewportColumn:Ct,isWordWrapMinified:vt,isViewportWrapping:ht,wrappingColumn:lt,verticalScrollbarWidth:ot,horizontalScrollbarHeight:ve,overviewRuler:{top:At,width:ot,height:$e-2*At,right:0}}}}e.EditorLayoutInfoComputer=W;class x extends k{constructor(){const te={enabled:!0};super(53,"lightbulb",te,{"editor.lightbulb.enabled":{type:"boolean",default:te.enabled,description:p.localize(39,null)}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{enabled:d(te.enabled,this.defaultValue.enabled)}}}class A extends k{constructor(){const te={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(123,"inlayHints",te,{"editor.inlayHints.enabled":{type:"boolean",default:te.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:te.fontSize,description:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:te.fontFamily,description:p.localize(42,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:d(pe.enabled,this.defaultValue.enabled),fontSize:o.clampedInt(pe.fontSize,this.defaultValue.fontSize,0,100),fontFamily:w.string(pe.fontFamily,this.defaultValue.fontFamily)}}}class U extends o{constructor(){super(55,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:p.localize(43,null)})}compute(te,pe,Me){return te.fontInfo.lineHeight}}class M extends k{constructor(){const te={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(61,"minimap",te,{"editor.minimap.enabled":{type:"boolean",default:te.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:te.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:te.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:te.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:te.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:te.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:te.maxColumn,description:p.localize(53,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:d(pe.enabled,this.defaultValue.enabled),size:f(pe.size,this.defaultValue.size,["proportional","fill","fit"]),side:f(pe.side,this.defaultValue.side,["right","left"]),showSlider:f(pe.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(pe.renderCharacters,this.defaultValue.renderCharacters),scale:o.clampedInt(pe.scale,1,1,3),maxColumn:o.clampedInt(pe.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function $(V){return V==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class K extends k{constructor(){super(71,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{top:o.clampedInt(pe.top,0,0,1e3),bottom:o.clampedInt(pe.bottom,0,0,1e3)}}}class j extends k{constructor(){const te={enabled:!0,cycle:!1};super(72,"parameterHints",te,{"editor.parameterHints.enabled":{type:"boolean",default:te.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:te.cycle,description:p.localize(57,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{enabled:d(pe.enabled,this.defaultValue.enabled),cycle:d(pe.cycle,this.defaultValue.cycle)}}}class ae extends i{constructor(){super(125)}compute(te,pe,Me){return te.pixelRatio}}class we extends k{constructor(){const te={other:!0,comments:!1,strings:!1};super(75,"quickSuggestions",te,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:te.strings,description:p.localize(58,null)},comments:{type:"boolean",default:te.comments,description:p.localize(59,null)},other:{type:"boolean",default:te.other,description:p.localize(60,null)}}}],default:te,description:p.localize(61,null)});this.defaultValue=te}validate(te){if(typeof te=="boolean")return te;if(te&&typeof te=="object"){const pe=te,Me={other:d(pe.other,this.defaultValue.other),comments:d(pe.comments,this.defaultValue.comments),strings:d(pe.strings,this.defaultValue.strings)};return Me.other&&Me.comments&&Me.strings?!0:!Me.other&&!Me.comments&&!Me.strings?!1:Me}return this.defaultValue}}var Re;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative",V[V.Interval=3]="Interval",V[V.Custom=4]="Custom"})(Re=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class xe extends k{constructor(){super(56,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(te){let pe=this.defaultValue.renderType,Me=this.defaultValue.renderFn;return typeof te!="undefined"&&(typeof te=="function"?(pe=4,Me=te):te==="interval"?pe=3:te==="relative"?pe=2:te==="on"?pe=1:pe=0),{renderType:pe,renderFn:Me}}}function Le(V){const te=V.get(84);return te==="editable"?V.get(77):te!=="on"}e.filterValidationDecorations=Le;class Ve extends k{constructor(){const te=[],pe={type:"number",description:p.localize(67,null)};super(88,"rulers",te,{type:"array",items:{anyOf:[pe,{type:["object"],properties:{column:pe,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:te,description:p.localize(69,null)})}validate(te){if(Array.isArray(te)){let pe=[];for(let Me of te)if(typeof Me=="number")pe.push({column:o.clampedInt(Me,0,0,1e4),color:null});else if(Me&&typeof Me=="object"){const $e=Me;pe.push({column:o.clampedInt($e.column,0,0,1e4),color:$e.color})}return pe.sort((Me,$e)=>Me.column-$e.column),pe}return this.defaultValue}}function Qe(V,te){if(typeof V!="string")return te;switch(V){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ke extends k{constructor(){super(89,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te,Me=o.clampedInt(pe.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=o.clampedInt(pe.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:o.clampedInt(pe.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(pe.vertical,this.defaultValue.vertical),horizontal:Qe(pe.horizontal,this.defaultValue.horizontal),useShadows:d(pe.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(pe.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(pe.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(pe.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(pe.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Me,horizontalSliderSize:o.clampedInt(pe.horizontalSliderSize,Me,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:o.clampedInt(pe.verticalSliderSize,$e,0,1e3),scrollByPage:d(pe.scrollByPage,this.defaultValue.scrollByPage)}}}class Ge extends k{constructor(){const te={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,showSuggestionPreview:!1,suggestionPreviewExpanded:!0,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(103,"suggest",te,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(70,null),p.localize(71,null)],default:te.insertMode,description:p.localize(72,null)},"editor.suggest.filterGraceful":{type:"boolean",default:te.filterGraceful,description:p.localize(73,null)},"editor.suggest.localityBonus":{type:"boolean",default:te.localityBonus,description:p.localize(74,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:te.shareSuggestSelections,markdownDescription:p.localize(75,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:te.snippetsPreventQuickSuggestions,description:p.localize(76,null)},"editor.suggest.showIcons":{type:"boolean",default:te.showIcons,description:p.localize(77,null)},"editor.suggest.showStatusBar":{type:"boolean",default:te.showStatusBar,description:p.localize(78,null)},"editor.suggest.showSuggestionPreview":{type:"boolean",default:te.showSuggestionPreview,description:p.localize(79,null)},"editor.suggest.suggestionPreviewExpanded":{type:"boolean",default:te.suggestionPreviewExpanded,description:p.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:te.showInlineDetails,description:p.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)}})}validate(te){if(!te||typeof te!="object")return this.defaultValue;const pe=te;return{insertMode:f(pe.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(pe.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(pe.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(pe.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(pe.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(pe.showIcons,this.defaultValue.showIcons),showStatusBar:d(pe.showStatusBar,this.defaultValue.showStatusBar),showSuggestionPreview:d(pe.showSuggestionPreview,this.defaultValue.showSuggestionPreview),suggestionPreviewExpanded:d(pe.suggestionPreviewExpanded,this.defaultValue.suggestionPreviewExpanded),showInlineDetails:d(pe.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(pe.showMethods,this.defaultValue.showMethods),showFunctions:d(pe.showFunctions,this.defaultValue.showFunctions),showConstructors:d(pe.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(pe.showDeprecated,this.defaultValue.showDeprecated),showFields:d(pe.showFields,this.defaultValue.showFields),showVariables:d(pe.showVariables,this.defaultValue.showVariables),showClasses:d(pe.showClasses,this.defaultValue.showClasses),showStructs:d(pe.showStructs,this.defaultValue.showStructs),showInterfaces:d(pe.showInterfaces,this.defaultValue.showInterfaces),showModules:d(pe.showModules,this.defaultValue.showModules),showProperties:d(pe.showProperties,this.defaultValue.showProperties),showEvents:d(pe.showEvents,this.defaultValue.showEvents),showOperators:d(pe.showOperators,this.defaultValue.showOperators),showUnits:d(pe.showUnits,this.defaultValue.showUnits),showValues:d(pe.showValues,this.defaultValue.showValues),showConstants:d(pe.showConstants,this.defaultValue.showConstants),showEnums:d(pe.showEnums,this.defaultValue.showEnums),showEnumMembers:d(pe.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(pe.showKeywords,this.defaultValue.showKeywords),showWords:d(pe.showWords,this.defaultValue.showWords),showColors:d(pe.showColors,this.defaultValue.showColors),showFiles:d(pe.showFiles,this.defaultValue.showFiles),showReferences:d(pe.showReferences,this.defaultValue.showReferences),showFolders:d(pe.showFolders,this.defaultValue.showFolders),showTypeParameters:d(pe.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(pe.showSnippets,this.defaultValue.showSnippets),showUsers:d(pe.showUsers,this.defaultValue.showUsers),showIssues:d(pe.showIssues,this.defaultValue.showIssues)}}}class H extends k{constructor(){super(99,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(113,null),default:!0,type:"boolean"}})}validate(te){return!te||typeof te!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(te.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Y extends i{constructor(){super(126,[77])}compute(te,pe,Me){return pe.get(77)?!0:te.tabFocusMode}}var ne;(function(V){V[V.None=0]="None",V[V.Same=1]="Same",V[V.Indent=2]="Indent",V[V.DeepIndent=3]="DeepIndent"})(ne=e.WrappingIndent||(e.WrappingIndent={}));function re(V){switch(V){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class G extends i{constructor(){super(128,[127])}compute(te,pe,Me){const $e=pe.get(127);return{isDominatedByLongLines:te.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const se="Consolas, 'Courier New', monospace",fe="Menlo, Monaco, 'Courier New', monospace",Ae="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?fe:R.isLinux?Ae:se,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function ge(V){return e.editorOptionsRegistry[V.id]=V,V}var We;(function(V){V[V.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",V[V.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",V[V.accessibilitySupport=2]="accessibilitySupport",V[V.accessibilityPageSize=3]="accessibilityPageSize",V[V.ariaLabel=4]="ariaLabel",V[V.autoClosingBrackets=5]="autoClosingBrackets",V[V.autoClosingDelete=6]="autoClosingDelete",V[V.autoClosingOvertype=7]="autoClosingOvertype",V[V.autoClosingQuotes=8]="autoClosingQuotes",V[V.autoIndent=9]="autoIndent",V[V.automaticLayout=10]="automaticLayout",V[V.autoSurround=11]="autoSurround",V[V.codeLens=12]="codeLens",V[V.codeLensFontFamily=13]="codeLensFontFamily",V[V.codeLensFontSize=14]="codeLensFontSize",V[V.colorDecorators=15]="colorDecorators",V[V.columnSelection=16]="columnSelection",V[V.comments=17]="comments",V[V.contextmenu=18]="contextmenu",V[V.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",V[V.cursorBlinking=20]="cursorBlinking",V[V.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",V[V.cursorStyle=22]="cursorStyle",V[V.cursorSurroundingLines=23]="cursorSurroundingLines",V[V.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",V[V.cursorWidth=25]="cursorWidth",V[V.disableLayerHinting=26]="disableLayerHinting",V[V.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",V[V.domReadOnly=28]="domReadOnly",V[V.dragAndDrop=29]="dragAndDrop",V[V.emptySelectionClipboard=30]="emptySelectionClipboard",V[V.extraEditorClassName=31]="extraEditorClassName",V[V.fastScrollSensitivity=32]="fastScrollSensitivity",V[V.find=33]="find",V[V.fixedOverflowWidgets=34]="fixedOverflowWidgets",V[V.folding=35]="folding",V[V.foldingStrategy=36]="foldingStrategy",V[V.foldingHighlight=37]="foldingHighlight",V[V.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",V[V.fontFamily=39]="fontFamily",V[V.fontInfo=40]="fontInfo",V[V.fontLigatures=41]="fontLigatures",V[V.fontSize=42]="fontSize",V[V.fontWeight=43]="fontWeight",V[V.formatOnPaste=44]="formatOnPaste",V[V.formatOnType=45]="formatOnType",V[V.glyphMargin=46]="glyphMargin",V[V.gotoLocation=47]="gotoLocation",V[V.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",V[V.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",V[V.hover=50]="hover",V[V.inDiffEditor=51]="inDiffEditor",V[V.letterSpacing=52]="letterSpacing",V[V.lightbulb=53]="lightbulb",V[V.lineDecorationsWidth=54]="lineDecorationsWidth",V[V.lineHeight=55]="lineHeight",V[V.lineNumbers=56]="lineNumbers",V[V.lineNumbersMinChars=57]="lineNumbersMinChars",V[V.linkedEditing=58]="linkedEditing",V[V.links=59]="links",V[V.matchBrackets=60]="matchBrackets",V[V.minimap=61]="minimap",V[V.mouseStyle=62]="mouseStyle",V[V.mouseWheelScrollSensitivity=63]="mouseWheelScrollSensitivity",V[V.mouseWheelZoom=64]="mouseWheelZoom",V[V.multiCursorMergeOverlapping=65]="multiCursorMergeOverlapping",V[V.multiCursorModifier=66]="multiCursorModifier",V[V.multiCursorPaste=67]="multiCursorPaste",V[V.occurrencesHighlight=68]="occurrencesHighlight",V[V.overviewRulerBorder=69]="overviewRulerBorder",V[V.overviewRulerLanes=70]="overviewRulerLanes",V[V.padding=71]="padding",V[V.parameterHints=72]="parameterHints",V[V.peekWidgetDefaultFocus=73]="peekWidgetDefaultFocus",V[V.definitionLinkOpensInPeek=74]="definitionLinkOpensInPeek",V[V.quickSuggestions=75]="quickSuggestions",V[V.quickSuggestionsDelay=76]="quickSuggestionsDelay",V[V.readOnly=77]="readOnly",V[V.renameOnType=78]="renameOnType",V[V.renderControlCharacters=79]="renderControlCharacters",V[V.renderIndentGuides=80]="renderIndentGuides",V[V.renderFinalNewline=81]="renderFinalNewline",V[V.renderLineHighlight=82]="renderLineHighlight",V[V.renderLineHighlightOnlyWhenFocus=83]="renderLineHighlightOnlyWhenFocus",V[V.renderValidationDecorations=84]="renderValidationDecorations",V[V.renderWhitespace=85]="renderWhitespace",V[V.revealHorizontalRightPadding=86]="revealHorizontalRightPadding",V[V.roundedSelection=87]="roundedSelection",V[V.rulers=88]="rulers",V[V.scrollbar=89]="scrollbar",V[V.scrollBeyondLastColumn=90]="scrollBeyondLastColumn",V[V.scrollBeyondLastLine=91]="scrollBeyondLastLine",V[V.scrollPredominantAxis=92]="scrollPredominantAxis",V[V.selectionClipboard=93]="selectionClipboard",V[V.selectionHighlight=94]="selectionHighlight",V[V.selectOnLineNumbers=95]="selectOnLineNumbers",V[V.showFoldingControls=96]="showFoldingControls",V[V.showUnused=97]="showUnused",V[V.snippetSuggestions=98]="snippetSuggestions",V[V.smartSelect=99]="smartSelect",V[V.smoothScrolling=100]="smoothScrolling",V[V.stickyTabStops=101]="stickyTabStops",V[V.stopRenderingLineAfter=102]="stopRenderingLineAfter",V[V.suggest=103]="suggest",V[V.suggestFontSize=104]="suggestFontSize",V[V.suggestLineHeight=105]="suggestLineHeight",V[V.suggestOnTriggerCharacters=106]="suggestOnTriggerCharacters",V[V.suggestSelection=107]="suggestSelection",V[V.tabCompletion=108]="tabCompletion",V[V.tabIndex=109]="tabIndex",V[V.unusualLineTerminators=110]="unusualLineTerminators",V[V.useShadowDOM=111]="useShadowDOM",V[V.useTabStops=112]="useTabStops",V[V.wordSeparators=113]="wordSeparators",V[V.wordWrap=114]="wordWrap",V[V.wordWrapBreakAfterCharacters=115]="wordWrapBreakAfterCharacters",V[V.wordWrapBreakBeforeCharacters=116]="wordWrapBreakBeforeCharacters",V[V.wordWrapColumn=117]="wordWrapColumn",V[V.wordWrapOverride1=118]="wordWrapOverride1",V[V.wordWrapOverride2=119]="wordWrapOverride2",V[V.wrappingIndent=120]="wrappingIndent",V[V.wrappingStrategy=121]="wrappingStrategy",V[V.showDeprecated=122]="showDeprecated",V[V.inlayHints=123]="inlayHints",V[V.editorClassName=124]="editorClassName",V[V.pixelRatio=125]="pixelRatio",V[V.tabFocusMode=126]="tabFocusMode",V[V.layoutInfo=127]="layoutInfo",V[V.wrappingInfo=128]="wrappingInfo"})(We=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ge(new g(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(114,null)})),acceptSuggestionOnEnter:ge(new y(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(115,null),""],markdownDescription:p.localize(116,null)})),accessibilitySupport:ge(new h),accessibilityPageSize:ge(new o(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(117,null)})),ariaLabel:ge(new w(4,"ariaLabel",p.localize(118,null))),autoClosingBrackets:ge(new y(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(119,null),p.localize(120,null),""],description:p.localize(121,null)})),autoClosingDelete:ge(new y(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(122,null),""],description:p.localize(123,null)})),autoClosingOvertype:ge(new y(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(124,null),""],description:p.localize(125,null)})),autoClosingQuotes:ge(new y(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(126,null),p.localize(127,null),""],description:p.localize(128,null)})),autoIndent:ge(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],m,{enumDescriptions:[p.localize(129,null),p.localize(130,null),p.localize(131,null),p.localize(132,null),p.localize(133,null)],description:p.localize(134,null)})),automaticLayout:ge(new g(10,"automaticLayout",!1)),autoSurround:ge(new y(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null),""],description:p.localize(138,null)})),stickyTabStops:ge(new g(101,"stickyTabStops",!1,{description:p.localize(139,null)})),codeLens:ge(new g(12,"codeLens",!0,{description:p.localize(140,null)})),codeLensFontFamily:ge(new w(13,"codeLensFontFamily","",{description:p.localize(141,null)})),codeLensFontSize:ge(new o(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,description:p.localize(142,null)})),colorDecorators:ge(new g(15,"colorDecorators",!0,{description:p.localize(143,null)})),columnSelection:ge(new g(16,"columnSelection",!1,{description:p.localize(144,null)})),comments:ge(new t),contextmenu:ge(new g(18,"contextmenu",!0)),copyWithSyntaxHighlighting:ge(new g(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(145,null)})),cursorBlinking:ge(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],r,{description:p.localize(146,null)})),cursorSmoothCaretAnimation:ge(new g(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(147,null)})),cursorStyle:ge(new l(22,"cursorStyle",s.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:p.localize(148,null)})),cursorSurroundingLines:ge(new o(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(149,null)})),cursorSurroundingLinesStyle:ge(new y(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(150,null),p.localize(151,null)],description:p.localize(152,null)})),cursorWidth:ge(new o(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(153,null)})),disableLayerHinting:ge(new g(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:ge(new g(27,"disableMonospaceOptimizations",!1)),domReadOnly:ge(new g(28,"domReadOnly",!1)),dragAndDrop:ge(new g(29,"dragAndDrop",!0,{description:p.localize(154,null)})),emptySelectionClipboard:ge(new P),extraEditorClassName:ge(new w(31,"extraEditorClassName","")),fastScrollSensitivity:ge(new a(32,"fastScrollSensitivity",5,V=>V<=0?5:V,{markdownDescription:p.localize(155,null)})),find:ge(new C),fixedOverflowWidgets:ge(new g(34,"fixedOverflowWidgets",!1)),folding:ge(new g(35,"folding",!0,{description:p.localize(156,null)})),foldingStrategy:ge(new y(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(157,null),p.localize(158,null)],description:p.localize(159,null)})),foldingHighlight:ge(new g(37,"foldingHighlight",!0,{description:p.localize(160,null)})),unfoldOnClickAfterEndOfLine:ge(new g(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(161,null)})),fontFamily:ge(new w(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(162,null)})),fontInfo:ge(new F),fontLigatures2:ge(new c),fontSize:ge(new N),fontWeight:ge(new z),formatOnPaste:ge(new g(44,"formatOnPaste",!1,{description:p.localize(163,null)})),formatOnType:ge(new g(45,"formatOnType",!1,{description:p.localize(164,null)})),glyphMargin:ge(new g(46,"glyphMargin",!0,{description:p.localize(165,null)})),gotoLocation:ge(new he),hideCursorInOverviewRuler:ge(new g(48,"hideCursorInOverviewRuler",!1,{description:p.localize(166,null)})),highlightActiveIndentGuide:ge(new g(49,"highlightActiveIndentGuide",!0,{description:p.localize(167,null)})),hover:ge(new me),inDiffEditor:ge(new g(51,"inDiffEditor",!1)),letterSpacing:ge(new a(52,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,V=>a.clamp(V,-5,20),{description:p.localize(168,null)})),lightbulb:ge(new x),lineDecorationsWidth:ge(new I(54,"lineDecorationsWidth",10)),lineHeight:ge(new U),lineNumbers:ge(new xe),lineNumbersMinChars:ge(new o(57,"lineNumbersMinChars",5,1,300)),linkedEditing:ge(new g(58,"linkedEditing",!1,{description:p.localize(169,null)})),links:ge(new g(59,"links",!0,{description:p.localize(170,null)})),matchBrackets:ge(new y(60,"matchBrackets","always",["always","near","never"],{description:p.localize(171,null)})),minimap:ge(new M),mouseStyle:ge(new y(62,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ge(new a(63,"mouseWheelScrollSensitivity",1,V=>V===0?1:V,{markdownDescription:p.localize(172,null)})),mouseWheelZoom:ge(new g(64,"mouseWheelZoom",!1,{markdownDescription:p.localize(173,null)})),multiCursorMergeOverlapping:ge(new g(65,"multiCursorMergeOverlapping",!0,{description:p.localize(174,null)})),multiCursorModifier:ge(new l(66,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],$,{markdownEnumDescriptions:[p.localize(175,null),p.localize(176,null)],markdownDescription:p.localize(177,null)})),multiCursorPaste:ge(new y(67,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(178,null),p.localize(179,null)],markdownDescription:p.localize(180,null)})),occurrencesHighlight:ge(new g(68,"occurrencesHighlight",!0,{description:p.localize(181,null)})),overviewRulerBorder:ge(new g(69,"overviewRulerBorder",!0,{description:p.localize(182,null)})),overviewRulerLanes:ge(new o(70,"overviewRulerLanes",3,0,3)),padding:ge(new K),parameterHints:ge(new j),peekWidgetDefaultFocus:ge(new y(73,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(183,null),p.localize(184,null)],description:p.localize(185,null)})),definitionLinkOpensInPeek:ge(new g(74,"definitionLinkOpensInPeek",!1,{description:p.localize(186,null)})),quickSuggestions:ge(new we),quickSuggestionsDelay:ge(new o(76,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(187,null)})),readOnly:ge(new g(77,"readOnly",!1)),renameOnType:ge(new g(78,"renameOnType",!1,{description:p.localize(188,null),markdownDeprecationMessage:p.localize(189,null)})),renderControlCharacters:ge(new g(79,"renderControlCharacters",!1,{description:p.localize(190,null)})),renderIndentGuides:ge(new g(80,"renderIndentGuides",!0,{description:p.localize(191,null)})),renderFinalNewline:ge(new g(81,"renderFinalNewline",!0,{description:p.localize(192,null)})),renderLineHighlight:ge(new y(82,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(193,null)],description:p.localize(194,null)})),renderLineHighlightOnlyWhenFocus:ge(new g(83,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(195,null)})),renderValidationDecorations:ge(new y(84,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ge(new y(85,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(196,null),p.localize(197,null),p.localize(198,null),""],description:p.localize(199,null)})),revealHorizontalRightPadding:ge(new o(86,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ge(new g(87,"roundedSelection",!0,{description:p.localize(200,null)})),rulers:ge(new Ve),scrollbar:ge(new Ke),scrollBeyondLastColumn:ge(new o(90,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(201,null)})),scrollBeyondLastLine:ge(new g(91,"scrollBeyondLastLine",!0,{description:p.localize(202,null)})),scrollPredominantAxis:ge(new g(92,"scrollPredominantAxis",!0,{description:p.localize(203,null)})),selectionClipboard:ge(new g(93,"selectionClipboard",!0,{description:p.localize(204,null),included:R.isLinux})),selectionHighlight:ge(new g(94,"selectionHighlight",!0,{description:p.localize(205,null)})),selectOnLineNumbers:ge(new g(95,"selectOnLineNumbers",!0)),showFoldingControls:ge(new y(96,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(206,null),p.localize(207,null)],description:p.localize(208,null)})),showUnused:ge(new g(97,"showUnused",!0,{description:p.localize(209,null)})),showDeprecated:ge(new g(122,"showDeprecated",!0,{description:p.localize(210,null)})),inlayHints:ge(new A),snippetSuggestions:ge(new y(98,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(211,null),p.localize(212,null),p.localize(213,null),p.localize(214,null)],description:p.localize(215,null)})),smartSelect:ge(new H),smoothScrolling:ge(new g(100,"smoothScrolling",!1,{description:p.localize(216,null)})),stopRenderingLineAfter:ge(new o(102,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ge(new Ge),suggestFontSize:ge(new o(104,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(217,null)})),suggestLineHeight:ge(new o(105,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(218,null)})),suggestOnTriggerCharacters:ge(new g(106,"suggestOnTriggerCharacters",!0,{description:p.localize(219,null)})),suggestSelection:ge(new y(107,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(220,null),p.localize(221,null),p.localize(222,null)],description:p.localize(223,null)})),tabCompletion:ge(new y(108,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(224,null),p.localize(225,null),p.localize(226,null)],description:p.localize(227,null)})),tabIndex:ge(new o(109,"tabIndex",0,-1,1073741824)),unusualLineTerminators:ge(new y(110,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(228,null),p.localize(229,null),p.localize(230,null)],description:p.localize(231,null)})),useShadowDOM:ge(new g(111,"useShadowDOM",!0)),useTabStops:ge(new g(112,"useTabStops",!0,{description:p.localize(232,null)})),wordSeparators:ge(new w(113,"wordSeparators",D.USUAL_WORD_SEPARATORS,{description:p.localize(233,null)})),wordWrap:ge(new y(114,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),wordWrapBreakAfterCharacters:ge(new w(115,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ge(new w(116,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ge(new o(117,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(239,null)})),wordWrapOverride1:ge(new y(118,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ge(new y(119,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ge(new l(120,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],re,{enumDescriptions:[p.localize(240,null),p.localize(241,null),p.localize(242,null),p.localize(243,null)],description:p.localize(244,null)})),wrappingStrategy:ge(new y(121,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(245,null),p.localize(246,null)],description:p.localize(247,null)})),editorClassName:ge(new b),pixelRatio:ge(new ae),tabFocusMode:ge(new Y),layoutInfo:ge(new W),wrappingInfo:ge(new G)}}),define(be[127],_e([18,19]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[128],_e([18,19]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[129],_e([18,19]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(be[130],_e([18,19]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(be[131],_e([18,19]),function(X,e){return X.create("vs/platform/theme/common/iconRegistry",e)}),define(be[132],_e([18,19]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(be[133],_e([18,19]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[134],_e([18,19]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[135],_e([18,19]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(be[136],_e([18,19]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[137],_e([18,19]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[138],_e([18,19]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[139],_e([18,19]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[140],_e([18,19]),function(X,e){return X.create("vs/workbench/common/views",e)}),define(be[141],_e([18,19]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[142],_e([18,19]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[143],_e([18,19]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[144],_e([18,19]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[145],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var p;(function(_){_[_.ACTIVATE=0]="ACTIVATE",_[_.RESTORE=1]="RESTORE",_[_.PRESERVE=2]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var R;(function(_){_[_.PICK=1]="PICK",_[_.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var D;(function(_){_[_.API=0]="API",_[_.USER=1]="USER"})(D=e.EditorOpenContext||(e.EditorOpenContext={}));var T;(function(_){_[_.Center=0]="Center",_[_.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",_[_.NearTop=2]="NearTop",_[_.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(T=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[146],_e([0,1,128]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function T(d){return d=d.trim(),d==="*"||R.test(d)}e.isValidVersionStr=T;function _(d){if(!T(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=d.match(R);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=_;function S(d){if(!d)return null;let g=d.majorBase,o=d.majorMustEqual,a=d.minorBase,w=d.minorMustEqual,f=d.patchBase,y=d.patchMustEqual;d.hasCaret&&(g===0||(w=!1),y=!1);let l=0;if(d.preRelease){const m=D.exec(d.preRelease);if(m){const[,h,t,n]=m;l=Date.UTC(Number(h),Number(t)-1,Number(n))}}return{majorBase:g,majorMustEqual:o,minorBase:a,minorMustEqual:w,patchBase:f,patchMustEqual:y,isMinimum:d.hasGreaterEquals,notBefore:l}}e.normalizeVersion=S;function E(d,g,o){let a;typeof d=="string"?a=S(_(d)):a=d;let w;g instanceof Date?w=g.getTime():typeof g=="string"&&(w=new Date(g).getTime());let f;if(typeof o=="string"?f=S(_(o)):f=o,!a||!f)return!1;let y=a.majorBase,l=a.minorBase,m=a.patchBase,h=f.majorBase,t=f.minorBase,n=f.patchBase,r=f.notBefore,s=f.majorMustEqual,u=f.minorMustEqual,v=f.patchMustEqual;return f.isMinimum?y>h?!0:y<h?!1:l>t?!0:l<t||w&&w<r?!1:m>=n:(y===1&&h===0&&(!s||!u||!v)&&(h=1,t=0,n=0,s=!0,u=!1,v=!1),y<h?!1:y>h?!s:l<t?!1:l>t?!u:m<n?!1:m>n?!v:!(w&&w<r))}e.isValidVersion=E;function k(d,g,o,a){return o.isBuiltin||typeof o.main=="undefined"?!0:I(d,g,o.engines.vscode,a)}e.isValidExtensionVersion=k;function i(d,g,o){return d==="*"||I(g,o,d)}e.isEngineValid=i;function I(d,g,o,a=[]){let w=S(_(o));if(!w)return a.push(p.localize(0,null,o)),!1;if(w.majorBase===0){if(!w.majorMustEqual||!w.minorMustEqual)return a.push(p.localize(1,null,o)),!1}else if(!w.majorMustEqual)return a.push(p.localize(2,null,o)),!1;return E(d,g,w)?!0:(a.push(p.localize(3,null,d,o)),!1)}}),define(be[89],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(T,_=[],S=!1){this.ctor=T,this.staticArguments=_,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=p;const R=(D,...T)=>new p(D,T);e.createSyncDescriptor=R}),define(be[62],_e([0,1,89]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function D(_,S,E){S instanceof p.SyncDescriptor||(S=new p.SyncDescriptor(S,[],E)),R.push([_,S])}e.registerSingleton=D;function T(){return R}e.getSingletonServiceDescriptors=T}),define(be[147],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=p;class R{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(let _ of this._nodes.values())_.outgoing.size===0&&T.push(_);return T}insertEdge(T,_){const S=this.lookupOrInsertNode(T),E=this.lookupOrInsertNode(_);S.outgoing.set(this._hashFn(_),E),E.incoming.set(this._hashFn(T),S)}removeNode(T){const _=this._hashFn(T);this._nodes.delete(_);for(let S of this._nodes.values())S.outgoing.delete(_),S.incoming.delete(_)}lookupOrInsertNode(T){const _=this._hashFn(T);let S=this._nodes.get(_);return S||(S=new p(T),this._nodes.set(_,S)),S}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){let T=[];for(let[_,S]of this._nodes)T.push(`${_}, (incoming)[${[...S.incoming.keys()].join(", ")}], (outgoing)[${[...S.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(let[T,_]of this._nodes){const S=new Set([T]),E=this._findCycle(_,S);if(E)return E}}_findCycle(T,_){for(let[S,E]of T.outgoing){if(_.has(S))return[..._,S].join(" -> ");_.add(S);const k=this._findCycle(E,_);if(k)return k;_.delete(S)}}}e.Graph=R}),define(be[4],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function E(k){return k[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=E})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function R(S,E,k,i){E[p.DI_TARGET]===E?E[p.DI_DEPENDENCIES].push({id:S,index:k,optional:i}):(E[p.DI_DEPENDENCIES]=[{id:S,index:k,optional:i}],E[p.DI_TARGET]=E)}function D(S){if(p.serviceIds.has(S))return p.serviceIds.get(S);const E=function(k,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(E,k,I,!1)};return E.toString=()=>S,p.serviceIds.set(S,E),E}e.createDecorator=D;function T(S){return S}e.refineServiceDecorator=T;function _(S){return function(E,k,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(S,E,i,!0)}}e.optional=_}),define(be[148],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,p.createDecorator)("modelService");function R(D){return!D.isTooLargeForSyncing()&&!D.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(be[149],_e([0,1,3,57,6,22,81,60,148]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(k):!!d.exclusive}class i{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(g,o){let a={selector:g,provider:o,_score:-1,_time:this._clock++};return this._entries.push(a),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,D.toDisposable)(()=>{if(a){let w=this._entries.indexOf(a);w>=0&&(this._entries.splice(w,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),a=void 0)}})}has(g){return this.all(g).length>0}all(g){if(!g)return[];this._updateScores(g);const o=[];for(let a of this._entries)a._score>0&&o.push(a.provider);return o}ordered(g){const o=[];return this._orderedForEach(g,a=>o.push(a.provider)),o}orderedGroups(g){const o=[];let a,w;return this._orderedForEach(g,f=>{a&&w===f._score?a.push(f.provider):(w=f._score,a=[f.provider],o.push(a))}),o}_orderedForEach(g,o){if(!!g){this._updateScores(g);for(const a of this._entries)a._score>0&&o(a)}}_updateScores(g){let o={uri:g.uri.toString(),language:g.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===o.language&&this._lastCandidate.uri===o.uri)){this._lastCandidate=o;for(let a of this._entries)if(a._score=(0,S.score)(a.selector,g.uri,g.getLanguageIdentifier().language,(0,E.shouldSynchronizeModel)(g)),k(a.selector)&&a._score>0){for(let w of this._entries)w._score=0;a._score=1e3;break}this._entries.sort(i._compareByScoreAndTime)}}static _compareByScoreAndTime(g,o){return g._score<o._score?1:g._score>o._score?-1:g._time<o._time?1:g._time>o._time?-1:0}}e.LanguageFeatureRegistry=i;class I{constructor(g,o,a=Number.MAX_SAFE_INTEGER){this._registry=g,this.min=o,this.max=a,this._cache=new T.LRUCache(50,.7)}_key(g){return g.id+(0,R.hash)(this._registry.all(g))}_clamp(g){return g===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(g*1.3)))}get(g){const o=this._key(g),a=this._cache.get(o);return this._clamp(a==null?void 0:a.value)}update(g,o){const a=this._key(g);let w=this._cache.get(a);return w||(w=new _.MovingAverage,this._cache.set(a,w)),w.update(o),this.get(g)}}e.LanguageFeatureRequestDelays=I}),define(be[63],_e([0,1,2,31,149,122,35]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var S;(function(c){c[c.Null=0]="Null",c[c.PlainText=1]="PlainText"})(S=e.LanguageId||(e.LanguageId={}));class E{constructor(F,N){this.language=F,this.id=N}}e.LanguageIdentifier=E;var k;(function(c){c[c.NotSet=-1]="NotSet",c[c.None=0]="None",c[c.Italic=1]="Italic",c[c.Bold=2]="Bold",c[c.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var i;(function(c){c[c.None=0]="None",c[c.DefaultForeground=1]="DefaultForeground",c[c.DefaultBackground=2]="DefaultBackground"})(i=e.ColorId||(e.ColorId={}));var I;(function(c){c[c.Other=0]="Other",c[c.Comment=1]="Comment",c[c.String=2]="String",c[c.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(c){c[c.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",c[c.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",c[c.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",c[c.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",c[c.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",c[c.ITALIC_MASK=2048]="ITALIC_MASK",c[c.BOLD_MASK=4096]="BOLD_MASK",c[c.UNDERLINE_MASK=8192]="UNDERLINE_MASK",c[c.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",c[c.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",c[c.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",c[c.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",c[c.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",c[c.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",c[c.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",c[c.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",c[c.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",c[c.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class g{static getLanguageId(F){return(F&255)>>>0}static getTokenType(F){return(F&1792)>>>8}static getFontStyle(F){return(F&14336)>>>11}static getForeground(F){return(F&8372224)>>>14}static getBackground(F){return(F&4286578688)>>>23}static getClassNameFromMetadata(F){let N=this.getForeground(F),z="mtk"+N,he=this.getFontStyle(F);return he&1&&(z+=" mtki"),he&2&&(z+=" mtkb"),he&4&&(z+=" mtku"),z}static getInlineStyleFromMetadata(F,N){const z=this.getForeground(F),he=this.getFontStyle(F);let me=`color: ${N[z]};`;return he&1&&(me+="font-style: italic;"),he&2&&(me+="font-weight: bold;"),he&4&&(me+="text-decoration: underline;"),me}}e.TokenMetadata=g;var o;(function(c){c[c.Method=0]="Method",c[c.Function=1]="Function",c[c.Constructor=2]="Constructor",c[c.Field=3]="Field",c[c.Variable=4]="Variable",c[c.Class=5]="Class",c[c.Struct=6]="Struct",c[c.Interface=7]="Interface",c[c.Module=8]="Module",c[c.Property=9]="Property",c[c.Event=10]="Event",c[c.Operator=11]="Operator",c[c.Unit=12]="Unit",c[c.Value=13]="Value",c[c.Constant=14]="Constant",c[c.Enum=15]="Enum",c[c.EnumMember=16]="EnumMember",c[c.Keyword=17]="Keyword",c[c.Text=18]="Text",c[c.Color=19]="Color",c[c.File=20]="File",c[c.Reference=21]="Reference",c[c.Customcolor=22]="Customcolor",c[c.Folder=23]="Folder",c[c.TypeParameter=24]="TypeParameter",c[c.User=25]="User",c[c.Issue=26]="Issue",c[c.Snippet=27]="Snippet"})(o=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let c=Object.create(null);return c[0]="symbol-method",c[1]="symbol-function",c[2]="symbol-constructor",c[3]="symbol-field",c[4]="symbol-variable",c[5]="symbol-class",c[6]="symbol-struct",c[7]="symbol-interface",c[8]="symbol-module",c[9]="symbol-property",c[10]="symbol-event",c[11]="symbol-operator",c[12]="symbol-unit",c[13]="symbol-value",c[14]="symbol-constant",c[15]="symbol-enum",c[16]="symbol-enum-member",c[17]="symbol-keyword",c[27]="symbol-snippet",c[18]="symbol-text",c[19]="symbol-color",c[20]="symbol-file",c[21]="symbol-reference",c[22]="symbol-customcolor",c[23]="symbol-folder",c[24]="symbol-type-parameter",c[25]="account",c[26]="issues",function(F){const N=c[F];let z=N&&_.iconRegistry.get(N);return z||(console.info("No codicon found for CompletionItemKind "+F),z=_.Codicon.symbolProperty),z.classNames}}(),e.completionKindFromString=function(){let c=Object.create(null);return c.method=0,c.function=1,c.constructor=2,c.field=3,c.variable=4,c.class=5,c.struct=6,c.interface=7,c.module=8,c.property=9,c.event=10,c.operator=11,c.unit=12,c.value=13,c.constant=14,c.enum=15,c["enum-member"]=16,c.enumMember=16,c.keyword=17,c.snippet=27,c.text=18,c.color=19,c.file=20,c.reference=21,c.customcolor=22,c.folder=23,c["type-parameter"]=24,c.typeParameter=24,c.account=25,c.issue=26,function(F,N){let z=c[F];return typeof z=="undefined"&&!N&&(z=9),z}}();var a;(function(c){c[c.Deprecated=1]="Deprecated"})(a=e.CompletionItemTag||(e.CompletionItemTag={}));var w;(function(c){c[c.KeepWhitespace=1]="KeepWhitespace",c[c.InsertAsSnippet=4]="InsertAsSnippet"})(w=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var f;(function(c){c[c.Invoke=0]="Invoke",c[c.TriggerCharacter=1]="TriggerCharacter",c[c.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(f=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var y;(function(c){c[c.Automatic=0]="Automatic",c[c.Explicit=1]="Explicit"})(y=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(c){c[c.Invoke=1]="Invoke",c[c.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var m;(function(c){c[c.Invoke=1]="Invoke",c[c.TriggerCharacter=2]="TriggerCharacter",c[c.ContentChange=3]="ContentChange"})(m=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(c){c[c.Text=0]="Text",c[c.Read=1]="Read",c[c.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(c){return c&&p.URI.isUri(c.uri)&&R.Range.isIRange(c.range)&&(R.Range.isIRange(c.originSelectionRange)||R.Range.isIRange(c.targetSelectionRange))}e.isLocationLink=t;var n;(function(c){c[c.File=0]="File",c[c.Module=1]="Module",c[c.Namespace=2]="Namespace",c[c.Package=3]="Package",c[c.Class=4]="Class",c[c.Method=5]="Method",c[c.Property=6]="Property",c[c.Field=7]="Field",c[c.Constructor=8]="Constructor",c[c.Enum=9]="Enum",c[c.Interface=10]="Interface",c[c.Function=11]="Function",c[c.Variable=12]="Variable",c[c.Constant=13]="Constant",c[c.String=14]="String",c[c.Number=15]="Number",c[c.Boolean=16]="Boolean",c[c.Array=17]="Array",c[c.Object=18]="Object",c[c.Key=19]="Key",c[c.Null=20]="Null",c[c.EnumMember=21]="EnumMember",c[c.Struct=22]="Struct",c[c.Event=23]="Event",c[c.Operator=24]="Operator",c[c.TypeParameter=25]="TypeParameter"})(n=e.SymbolKind||(e.SymbolKind={}));var r;(function(c){c[c.Deprecated=1]="Deprecated"})(r=e.SymbolTag||(e.SymbolTag={}));var s;(function(c){const F=new Map;F.set("file",0),F.set("module",1),F.set("namespace",2),F.set("package",3),F.set("class",4),F.set("method",5),F.set("property",6),F.set("field",7),F.set("constructor",8),F.set("enum",9),F.set("interface",10),F.set("function",11),F.set("variable",12),F.set("constant",13),F.set("string",14),F.set("number",15),F.set("boolean",16),F.set("array",17),F.set("object",18),F.set("key",19),F.set("null",20),F.set("enum-member",21),F.set("struct",22),F.set("event",23),F.set("operator",24),F.set("type-parameter",25);const N=new Map;N.set(0,"file"),N.set(1,"module"),N.set(2,"namespace"),N.set(3,"package"),N.set(4,"class"),N.set(5,"method"),N.set(6,"property"),N.set(7,"field"),N.set(8,"constructor"),N.set(9,"enum"),N.set(10,"interface"),N.set(11,"function"),N.set(12,"variable"),N.set(13,"constant"),N.set(14,"string"),N.set(15,"number"),N.set(16,"boolean"),N.set(17,"array"),N.set(18,"object"),N.set(19,"key"),N.set(20,"null"),N.set(21,"enum-member"),N.set(22,"struct"),N.set(23,"event"),N.set(24,"operator"),N.set(25,"type-parameter");function z(Q){return F.get(Q)}c.fromString=z;function he(Q){return N.get(Q)}c.toString=he;function me(Q,W){const x=N.get(Q);let A=x&&_.iconRegistry.get("symbol-"+x);return A||(console.info("No codicon found for SymbolKind "+Q),A=_.Codicon.symbolProperty),`${W?"inline":"block"} ${A.classNames}`}c.toCssClassName=me})(s=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(F){this.value=F}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var v;(function(c){c[c.Collapsed=0]="Collapsed",c[c.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var b;(function(c){c[c.Editing=0]="Editing",c[c.Preview=1]="Preview"})(b=e.CommentMode||(e.CommentMode={}));var P;(function(c){c[c.Other=0]="Other",c[c.Type=1]="Type",c[c.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new D.LanguageFeatureRegistry,e.RenameProviderRegistry=new D.LanguageFeatureRegistry,e.CompletionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new D.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new D.LanguageFeatureRegistry,e.HoverProviderRegistry=new D.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new D.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new D.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new D.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new D.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new D.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new D.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new D.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new D.LanguageFeatureRegistry,e.LinkProviderRegistry=new D.LanguageFeatureRegistry,e.ColorProviderRegistry=new D.LanguageFeatureRegistry,e.SelectionRangeRegistry=new D.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new D.LanguageFeatureRegistry,e.TokenizationRegistry=new T.TokenizationRegistryImpl;var C;(function(c){c[c.None=0]="None",c[c.Option=1]="Option",c[c.Default=2]="Default",c[c.Preferred=3]="Preferred"})(C=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[150],_e([0,1,6,9,4,3,45,43]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullCommandService=e.CommandsRegistry=e.ICommandService=void 0,e.ICommandService=(0,D.createDecorator)("commandService"),e.CommandsRegistry=new class{constructor(){this._commands=new Map,this._onDidRegisterCommand=new T.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(E,k){if(!E)throw new Error("invalid command");if(typeof E=="string"){if(!k)throw new Error("invalid command");return this.registerCommand({id:E,handler:k})}if(E.description){const o=[];for(let w of E.description.args)o.push(w.constraint);const a=E.handler;E.handler=function(w,...f){return(0,R.validateConstraints)(f,o),a(w,...f)}}const{id:i}=E;let I=this._commands.get(i);I||(I=new _.LinkedList,this._commands.set(i,I));let d=I.unshift(E),g=(0,p.toDisposable)(()=>{d();const o=this._commands.get(i);(o==null?void 0:o.isEmpty())&&this._commands.delete(i)});return this._onDidRegisterCommand.fire(i),g}registerCommandAlias(E,k){return e.CommandsRegistry.registerCommand(E,(i,...I)=>i.get(e.ICommandService).executeCommand(k,...I))}getCommand(E){const k=this._commands.get(E);if(!(!k||k.isEmpty()))return S.Iterable.first(k)}getCommands(){const E=new Map;for(const k of this._commands.keys()){const i=this.getCommand(k);i&&E.set(k,i)}return E}},e.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>p.Disposable.None,onDidExecuteCommand:()=>p.Disposable.None,executeCommand(){return Promise.resolve(void 0)}},e.CommandsRegistry.registerCommand("noop",()=>{})}),define(be[64],_e([0,1,8,4,21]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let T=D.userAgent||"";const _=new Map;_.set("false",!1),_.set("true",!0),_.set("isMac",D.isMacintosh),_.set("isLinux",D.isLinux),_.set("isWindows",D.isWindows),_.set("isWeb",D.isWeb),_.set("isMacNative",D.isMacintosh&&!D.isWeb),_.set("isEdge",T.indexOf("Edg/")>=0),_.set("isFirefox",T.indexOf("Firefox")>=0),_.set("isChrome",T.indexOf("Chrome")>=0),_.set("isSafari",T.indexOf("Safari")>=0);const S=Object.prototype.hasOwnProperty;var E;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(E=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return I.INSTANCE}static true(){return d.INSTANCE}static has(c){return g.create(c)}static equals(c,F){return o.create(c,F)}static notEquals(c,F){return f.create(c,F)}static regex(c,F){return n.create(c,F)}static in(c,F){return a.create(c,F)}static not(c){return y.create(c)}static and(...c){return s.create(c)}static or(...c){return u.create(c)}static greater(c,F){return l.create(c,F)}static less(c,F){return h.create(c,F)}static deserialize(c,F=!1){if(!!c)return this._deserializeOrExpression(c,F)}static _deserializeOrExpression(c,F){let N=c.split("||");return u.create(N.map(z=>this._deserializeAndExpression(z,F)))}static _deserializeAndExpression(c,F){let N=c.split("&&");return s.create(N.map(z=>this._deserializeOne(z,F)))}static _deserializeOne(c,F){if(c=c.trim(),c.indexOf("!=")>=0){let N=c.split("!=");return f.create(N[0].trim(),this._deserializeValue(N[1],F))}if(c.indexOf("==")>=0){let N=c.split("==");return o.create(N[0].trim(),this._deserializeValue(N[1],F))}if(c.indexOf("=~")>=0){let N=c.split("=~");return n.create(N[0].trim(),this._deserializeRegexValue(N[1],F))}if(c.indexOf(" in ")>=0){let N=c.split(" in ");return a.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(c)){const N=c.split(">=");return m.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(c)){const N=c.split(">");return l.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(c)){const N=c.split("<=");return t.create(N[0].trim(),N[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(c)){const N=c.split("<");return h.create(N[0].trim(),N[1].trim())}return/^\!\s*/.test(c)?y.create(c.substr(1).trim()):g.create(c)}static _deserializeValue(c,F){if(c=c.trim(),c==="true")return!0;if(c==="false")return!1;let N=/^'([^']*)'$/.exec(c);return N?N[1].trim():c}static _deserializeRegexValue(c,F){if((0,p.isFalsyOrWhitespace)(c)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let N=c.indexOf("/"),z=c.lastIndexOf("/");if(N===z||N<0){if(F)throw new Error(`bad regexp-value '${c}', missing /-enclosure`);return console.warn(`bad regexp-value '${c}', missing /-enclosure`),null}let he=c.slice(N+1,z),me=c[z+1]==="i"?"i":"";try{return new RegExp(he,me)}catch(Q){if(F)throw new Error(`bad regexp-value '${c}', parse error: ${Q}`);return console.warn(`bad regexp-value '${c}', parse error: ${Q}`),null}}}e.ContextKeyExpr=k;function i(C,c){return C.cmp(c)}class I{constructor(){this.type=0}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}evaluate(c){return!1}serialize(){return"false"}keys(){return[]}map(c){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class d{constructor(){this.type=1}cmp(c){return this.type-c.type}equals(c){return c.type===this.type}evaluate(c){return!0}serialize(){return"true"}keys(){return[]}map(c){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class g{constructor(c){this.key=c,this.type=2}static create(c){const F=_.get(c);return typeof F=="boolean"?F?d.INSTANCE:I.INSTANCE:new g(c)}cmp(c){return c.type!==this.type?this.type-c.type:b(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}evaluate(c){return!!c.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(c){return c.mapDefined(this.key)}negate(){return y.create(this.key)}}e.ContextKeyDefinedExpr=g;class o{constructor(c,F){this.key=c,this.value=F,this.type=4}static create(c,F){if(typeof F=="boolean")return F?g.create(c):y.create(c);const N=_.get(c);return typeof N=="boolean"?F===(N?"true":"false")?d.INSTANCE:I.INSTANCE:new o(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:P(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return c.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(c){return c.mapEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyEqualsExpr=o;class a{constructor(c,F){this.key=c,this.valueKey=F,this.type=10}static create(c,F){return new a(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:P(this.key,this.valueKey,c.key,c.valueKey)}equals(c){return c.type===this.type?this.key===c.key&&this.valueKey===c.valueKey:!1}evaluate(c){const F=c.getValue(this.valueKey),N=c.getValue(this.key);return Array.isArray(F)?F.indexOf(N)>=0:typeof N=="string"&&typeof F=="object"&&F!==null?S.call(F,N):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(c){return c.mapIn(this.key,this.valueKey)}negate(){return w.create(this)}}e.ContextKeyInExpr=a;class w{constructor(c){this._actual=c,this.type=11}static create(c){return new w(c)}cmp(c){return c.type!==this.type?this.type-c.type:this._actual.cmp(c._actual)}equals(c){return c.type===this.type?this._actual.equals(c._actual):!1}evaluate(c){return!this._actual.evaluate(c)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(c){return new w(this._actual.map(c))}negate(){return this._actual}}e.ContextKeyNotInExpr=w;class f{constructor(c,F){this.key=c,this.value=F,this.type=5}static create(c,F){if(typeof F=="boolean")return F?y.create(c):g.create(c);const N=_.get(c);return typeof N=="boolean"?F===(N?"true":"false")?I.INSTANCE:d.INSTANCE:new f(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:P(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return c.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(c){return c.mapNotEquals(this.key,this.value)}negate(){return o.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=f;class y{constructor(c){this.key=c,this.type=3}static create(c){const F=_.get(c);return typeof F=="boolean"?F?I.INSTANCE:d.INSTANCE:new y(c)}cmp(c){return c.type!==this.type?this.type-c.type:b(this.key,c.key)}equals(c){return c.type===this.type?this.key===c.key:!1}evaluate(c){return!c.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(c){return c.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=y;class l{constructor(c,F){this.key=c,this.value=F,this.type=12}static create(c,F){return new l(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:P(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class m{constructor(c,F){this.key=c,this.value=F,this.type=13}static create(c,F){return new m(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:P(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(c){return c.mapGreaterEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=m;class h{constructor(c,F){this.key=c,this.value=F,this.type=14}static create(c,F){return new h(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:P(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmaller(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeySmallerExpr=h;class t{constructor(c,F){this.key=c,this.value=F,this.type=15}static create(c,F){return new t(c,F)}cmp(c){return c.type!==this.type?this.type-c.type:P(this.key,this.value,c.key,c.value)}equals(c){return c.type===this.type?this.key===c.key&&this.value===c.value:!1}evaluate(c){return parseFloat(c.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(c){return c.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class n{constructor(c,F){this.key=c,this.regexp=F,this.type=7}static create(c,F){return new n(c,F)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.key<c.key)return-1;if(this.key>c.key)return 1;const F=this.regexp?this.regexp.source:"",N=c.regexp?c.regexp.source:"";return F<N?-1:F>N?1:0}equals(c){if(c.type===this.type){const F=this.regexp?this.regexp.source:"",N=c.regexp?c.regexp.source:"";return this.key===c.key&&F===N}return!1}evaluate(c){let F=c.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const c=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${c}`}keys(){return[this.key]}map(c){return c.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=n;class r{constructor(c){this._actual=c,this.type=8}static create(c){return new r(c)}cmp(c){return c.type!==this.type?this.type-c.type:this._actual.cmp(c._actual)}equals(c){return c.type===this.type?this._actual.equals(c._actual):!1}evaluate(c){return!this._actual.evaluate(c)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(c){return new r(this._actual.map(c))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class s{constructor(c){this.expr=c,this.type=6}static create(c){return s._normalizeArr(c)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=i(this.expr[F],c.expr[F]);if(z!==0)return z}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(c.expr[F]))return!1;return!0}return!1}evaluate(c){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(c))return!1;return!0}static _normalizeArr(c){const F=[];let N=!1;for(const z of c)if(!!z){if(z.type===1){N=!0;continue}if(z.type===0)return I.INSTANCE;if(z.type===6){F.push(...z.expr);continue}F.push(z)}if(F.length===0&&N)return d.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(i);F.length>1;){const z=F[F.length-1];if(z.type!==9)break;F.pop();const he=F.pop(),me=u.create(z.expr.map(Q=>s.create([Q,he])));me&&(F.push(me),F.sort(i))}return F.length===1?F[0]:new s(F)}}serialize(){return this.expr.map(c=>c.serialize()).join(" && ")}keys(){const c=[];for(let F of this.expr)c.push(...F.keys());return c}map(c){return new s(this.expr.map(F=>F.map(c)))}negate(){let c=[];for(let F of this.expr)c.push(F.negate());return u.create(c)}}e.ContextKeyAndExpr=s;class u{constructor(c){this.expr=c,this.type=9}static create(c){const F=u._normalizeArr(c);if(F.length!==0)return F.length===1?F[0]:new u(F)}cmp(c){if(c.type!==this.type)return this.type-c.type;if(this.expr.length<c.expr.length)return-1;if(this.expr.length>c.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const z=i(this.expr[F],c.expr[F]);if(z!==0)return z}return 0}equals(c){if(c.type===this.type){if(this.expr.length!==c.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(c.expr[F]))return!1;return!0}return!1}evaluate(c){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(c))return!0;return!1}static _normalizeArr(c){let F=[],N=!1;if(c){for(let z=0,he=c.length;z<he;z++){const me=c[z];if(!!me){if(me.type===0){N=!0;continue}if(me.type===1)return[d.INSTANCE];if(me.type===9){F=F.concat(me.expr);continue}F.push(me)}}if(F.length===0&&N)return[I.INSTANCE];F.sort(i)}return F}serialize(){return this.expr.map(c=>c.serialize()).join(" || ")}keys(){const c=[];for(let F of this.expr)c.push(...F.keys());return c}map(c){return new u(this.expr.map(F=>F.map(c)))}negate(){let c=[];for(let N of this.expr)c.push(N.negate());const F=N=>N.type===9?N.expr:[N];for(;c.length>1;){const N=c.shift(),z=c.shift(),he=[];for(const me of F(N))for(const Q of F(z))he.push(k.and(me,Q));c.unshift(k.or(...he))}return c[0]}}e.ContextKeyOrExpr=u;class v extends g{constructor(c,F,N){super(c);this._defaultValue=F,typeof N=="object"?v._info.push(Object.assign(Object.assign({},N),{key:c})):N!==!0&&v._info.push({key:c,description:N,type:F!=null?typeof F:void 0})}static all(){return v._info.values()}bindTo(c){return c.createKey(this.key,this._defaultValue)}getValue(c){return c.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(c){return k.equals(this.key,c)}notEqualsTo(c){return k.notEquals(this.key,c)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=(0,R.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function b(C,c){return C<c?-1:C>c?1:0}function P(C,c,F,N){return C<F?-1:C>F?1:c<N?-1:c>N?1:0}}),define(be[151],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(be[26],_e([0,1,8,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function D(i){if(typeof i=="object"&&i!==null&&i.supported!==!0)return i.description}e.getWorkpaceSupportTypeMessage=D;function T(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(!i.uuid||typeof i.uuid=="string")}e.isIExtensionIdentifier=T,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var _;(function(i){i[i.System=0]="System",i[i.User=1]="User"})(_=e.ExtensionType||(e.ExtensionType={}));class S{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,d){if(typeof I=="undefined"||I===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof I=="string"||typeof d=="string"){let g=typeof I=="string"?I:I.value,o=typeof d=="string"?d:d.value;return p.equalsIgnoreCase(g,o)}return I._lower===d._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=S;function E(i){return i.contributes&&i.contributes.localizations?i.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function k(i){return i.contributes&&i.contributes.authentication?i.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[152],_e([0,1,8,26]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(g,o){return g.uuid&&o.uuid?g.uuid===o.uuid:g.id===o.id?!0:(0,p.compareIgnoreCase)(g.id,o.id)===0}e.areSameExtensions=D;class T{constructor(o,a){this.version=a,this.id=o.id,this.uuid=o.uuid}key(){return`${this.id}-${this.version}`}equals(o){return o instanceof T?D(this,o)&&this.version===o.version:!1}}e.ExtensionIdentifierWithVersion=T;function _(g,o){return`${g}.${o}`}e.getExtensionId=_;function S(g){return g.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function E(g,o){return S(_(g,o))}e.getGalleryExtensionId=E;function k(g,o){const a=[],w=f=>{for(const y of a)if(y.some(l=>D(o(l),o(f))))return y;return null};for(const f of g){const y=w(f);y?y.push(f):a.push([f])}return a}e.groupByExtension=k;function i(g){return{id:g.identifier.id,name:g.manifest.name,galleryId:null,publisherId:g.publisherId,publisherName:g.manifest.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:g.manifest.extensionDependencies&&g.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(g){return Object.assign({id:g.identifier.id,name:g.name,galleryId:g.identifier.uuid,publisherId:g.publisherId,publisherName:g.publisher,publisherDisplayName:g.publisherDisplayName,dependencies:!!(g.properties.dependencies&&g.properties.dependencies.length>0)},g.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function d(g){const o=new Set;for(const a of g)a.malicious&&o.add(a.id.id);return o}e.getMaliciousExtensionsSet=d}),define(be[65],_e([0,1,129,12,2,4,8,9,22]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,T.createDecorator)("fileService");function k(W){return W.create===!0}e.isFileOpenForWriteOptions=k;var i;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(W){W[W.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var d;(function(W){W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(W){return!!(W.capabilities&2)}e.hasReadWriteCapability=g;function o(W){return!!(W.capabilities&8)}e.hasFileFolderCopyCapability=o;function a(W){return!!(W.capabilities&4)}e.hasOpenReadWriteCloseCapability=a;function w(W){return!!(W.capabilities&16)}e.hasFileReadStreamCapability=w;var f;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(f=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(x,A){super(x);this.code=A}}e.FileSystemProviderError=y;function l(W,x){const A=new y(W.toString(),x);return h(A,x),A}e.createFileSystemProviderError=l;function m(W){return W||l((0,p.localize)(0,null),f.Unknown)}e.ensureFileSystemProviderError=m;function h(W,x){return W.name=x?`${x} (FileSystemError)`:"FileSystemError",W}e.markAsFileSystemProviderError=h;function t(W){if(!W)return f.Unknown;if(W instanceof y)return W.code;const x=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!x)return f.Unknown;switch(x[1]){case f.FileExists:return f.FileExists;case f.FileIsADirectory:return f.FileIsADirectory;case f.FileNotADirectory:return f.FileNotADirectory;case f.FileNotFound:return f.FileNotFound;case f.FileExceedsMemoryLimit:return f.FileExceedsMemoryLimit;case f.FileTooLarge:return f.FileTooLarge;case f.FileWriteLocked:return f.FileWriteLocked;case f.NoPermissions:return f.NoPermissions;case f.Unavailable:return f.Unavailable}return f.Unknown}e.toFileSystemProviderErrorCode=t;function n(W){if(W instanceof P)return W.fileOperationResult;switch(t(W)){case f.FileNotFound:return 1;case f.FileIsADirectory:return 0;case f.FileNotADirectory:return 10;case f.FileWriteLocked:return 5;case f.NoPermissions:return 6;case f.FileExists:return 4;case f.FileExceedsMemoryLimit:return 9;case f.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=n;var r;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class s{constructor(x,A,U){this.resource=x,this.operation=A,this.target=U}isOperation(x){return this.operation===x}}e.FileOperationEvent=s;var u;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class v{constructor(x,A){this.ignorePathCasing=A,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=x;for(const U of x)switch(U.type){case 1:this.added||(this.added=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(U.resource,U);break;case 0:this.updated||(this.updated=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(U.resource,U);break;case 2:this.deleted||(this.deleted=E.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(U.resource,U);break}}contains(x,...A){return this.doContains(x,{includeChildren:!1},...A)}affects(x,...A){return this.doContains(x,{includeChildren:!0},...A)}doContains(x,A,...U){var M,$,K,j,ae,we;if(!x)return!1;const Re=U.length>0;return!!((!Re||U.includes(1))&&(((M=this.added)===null||M===void 0?void 0:M.get(x))||A.includeChildren&&(($=this.added)===null||$===void 0?void 0:$.findSuperstr(x)))||(!Re||U.includes(0))&&(((K=this.updated)===null||K===void 0?void 0:K.get(x))||A.includeChildren&&((j=this.updated)===null||j===void 0?void 0:j.findSuperstr(x)))||(!Re||U.includes(2))&&(((ae=this.deleted)===null||ae===void 0?void 0:ae.findSubstr(x))||A.includeChildren&&((we=this.deleted)===null||we===void 0?void 0:we.findSuperstr(x))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(x){const A=[],U=x===1?this.added:x===0?this.updated:this.deleted;if(U)for(const[,M]of U)A.push(M);return A}filter(x){return new v(this.changes.filter(A=>x(A)),this.ignorePathCasing)}}e.FileChangesEvent=v;function b(W,x,A){return!W||!x||W===x||x.length>W.length?!1:(x.charAt(x.length-1)!==R.sep&&(x+=R.sep),A?(0,_.startsWithIgnoreCase)(W,x):W.indexOf(x)===0)}e.isParent=b;class P extends Error{constructor(x,A,U){super(x);this.fileOperationResult=A,this.options=U}}e.FileOperationError=P;class C extends P{constructor(x,A,U){super(x,2,U);this.stat=A}}e.NotModifiedSinceFileOperationError=C;var c;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",W[W.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(c=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function N(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}e.etag=N;async function z(W,x){if(!x.canHandleResource(D.URI.from({scheme:W.scheme})))return new Promise(A=>{const U=x.onDidChangeFileSystemProviderRegistrations(M=>{M.scheme===W.scheme&&M.added&&(U.dispose(),A())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class he{static formatSize(x){return(0,S.isNumber)(x)||(x=0),x<he.KB?(0,p.localize)(1,null,x.toFixed(0)):x<he.MB?(0,p.localize)(2,null,(x/he.KB).toFixed(2)):x<he.GB?(0,p.localize)(3,null,(x/he.MB).toFixed(2)):x<he.TB?(0,p.localize)(4,null,(x/he.GB).toFixed(2)):(0,p.localize)(5,null,(x/he.TB).toFixed(2))}}e.ByteSize=he,he.KB=1024,he.MB=he.KB*he.KB,he.GB=he.MB*he.KB,he.TB=he.GB*he.KB;var me;(function(W){W[W.IA32=0]="IA32",W[W.OTHER=1]="OTHER"})(me=e.Arch||(e.Arch={}));function Q(W){return{maxFileSize:W===0?300*he.MB:16*he.GB,maxHeapSize:W===0?700*he.MB:2*700*he.MB}}e.getPlatformLimits=Q}),define(be[66],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[T,_]of D)this.set(T,_)}set(D,T){const _=this._entries.get(D);return this._entries.set(D,T),_}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(be[153],_e([0,1,13,147,89,4,66,11]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const E=!1;class k extends Error{constructor(o){var a;super("cyclic dependency between services");this.message=(a=o.findCycleSlow())!==null&&a!==void 0?a:`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class i{constructor(o=new _.ServiceCollection,a=!1,w){this._activeInstantiations=new Set,this._services=o,this._strict=a,this._parent=w,this._services.set(T.IInstantiationService,this)}createChild(o){return new i(o,this._strict,this)}invokeFunction(o,...a){let w=d.traceInvocation(o),f=!1;try{return o({get:(l,m)=>{if(f)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(l,w);if(!h&&m!==T.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return h}},...a)}finally{f=!0,w.stop()}}createInstance(o,...a){let w,f;return o instanceof D.SyncDescriptor?(w=d.traceCreation(o.ctor),f=this._createInstance(o.ctor,o.staticArguments.concat(a),w)):(w=d.traceCreation(o),f=this._createInstance(o,a,w)),w.stop(),f}_createInstance(o,a=[],w){let f=T._util.getServiceDependencies(o).sort((m,h)=>m.index-h.index),y=[];for(const m of f){let h=this._getOrCreateServiceInstance(m.id,w);if(!h&&this._strict&&!m.optional)throw new Error(`[createInstance] ${o.name} depends on UNKNOWN service ${m.id}.`);y.push(h)}let l=f.length>0?f[0].index:a.length;if(a.length!==l){console.warn(`[createInstance] First service dependency of ${o.name} at position ${l+1} conflicts with ${a.length} static arguments`);let m=l-a.length;m>0?a=a.concat(new Array(m)):a=a.slice(0,l)}return new o(...[...a,...y])}_setServiceInstance(o,a){if(this._services.get(o)instanceof D.SyncDescriptor)this._services.set(o,a);else if(this._parent)this._parent._setServiceInstance(o,a);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(o){let a=this._services.get(o);return!a&&this._parent?this._parent._getServiceInstanceOrDescriptor(o):a}_getOrCreateServiceInstance(o,a){let w=this._getServiceInstanceOrDescriptor(o);return w instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(o,w,a.branch(o,!0)):(a.branch(o,!1),w)}_safeCreateAndCacheServiceInstance(o,a,w){if(this._activeInstantiations.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this._activeInstantiations.add(o);try{return this._createAndCacheServiceInstance(o,a,w)}finally{this._activeInstantiations.delete(o)}}_createAndCacheServiceInstance(o,a,w){const f=new R.Graph(m=>m.id.toString());let y=0;const l=[{id:o,desc:a,_trace:w}];for(;l.length;){const m=l.pop();if(f.lookupOrInsertNode(m),y++>1e3)throw new k(f);for(let h of T._util.getServiceDependencies(m.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(h.id);if(!t&&!h.optional&&console.warn(`[createInstance] ${o} depends on ${h.id} which is NOT registered.`),t instanceof D.SyncDescriptor){const n={id:h.id,desc:t,_trace:m._trace.branch(h.id,!0)};f.insertEdge(m,n),l.push(n)}}}for(;;){const m=f.roots();if(m.length===0){if(!f.isEmpty())throw new k(f);break}for(const{data:h}of m){if(this._getServiceInstanceOrDescriptor(h.id)instanceof D.SyncDescriptor){const n=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,n)}f.removeNode(h)}}return this._getServiceInstanceOrDescriptor(o)}_createServiceInstanceWithOwner(o,a,w=[],f,y){if(this._services.get(o)instanceof D.SyncDescriptor)return this._createServiceInstance(a,w,f,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(o,a,w,f,y);throw new Error(`illegalState - creating UNKNOWN service instance ${a.name}`)}_createServiceInstance(o,a=[],w,f){if(w){const y=new S.IdleValue(()=>this._createInstance(o,a,f));return new Proxy(Object.create(null),{get(l,m){if(m in l)return l[m];let h=y.value,t=h[m];return typeof t!="function"||(t=t.bind(h),l[m]=t),t},set(l,m,h){return y.value[m]=h,!0}})}else return this._createInstance(o,a,f)}}e.InstantiationService=i;var I;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(I||(I={}));class d{constructor(o,a){this.type=o,this.name=a,this._start=Date.now(),this._dep=[]}static traceInvocation(o){return E?new d(1,o.name||o.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(o){return E?new d(0,o.name):d._None}branch(o,a){let w=new d(2,o.toString());return this._dep.push([o,a,w]),w}stop(){let o=Date.now()-this._start;d._totals+=o;let a=!1;function w(y,l){let m=[],h=new Array(y+1).join("	");for(const[t,n,r]of l._dep)if(n&&r){a=!0,m.push(`${h}CREATES -> ${t}`);let s=w(y+1,r);s&&m.push(s)}else m.push(`${h}uses -> ${t}`);return m.join(`
`)}let f=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(o>2||a)&&console.log(f.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(be[17],_e([0,1,4,6,21,3,61]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function S(){return new Date().toISOString()}var E;(function(h){h[h.Trace=0]="Trace",h[h.Debug=1]="Debug",h[h.Info=2]="Info",h[h.Warning=3]="Warning",h[h.Error=4]="Error",h[h.Critical=5]="Critical",h[h.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;class k extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new T.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class i extends k{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...n){this.checkLogLevel(E.Trace)&&this.log(E.Trace,this.format([t,...n]))}debug(t,...n){this.checkLogLevel(E.Debug)&&this.log(E.Debug,this.format([t,...n]))}info(t,...n){this.checkLogLevel(E.Info)&&this.log(E.Info,this.format([t,...n]))}warn(t,...n){this.checkLogLevel(E.Warning)&&this.log(E.Warning,this.format([t,...n]))}error(t,...n){if(this.checkLogLevel(E.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(E.Error,this.format(r))}else this.log(E.Error,this.format([t,...n]))}critical(t,...n){this.checkLogLevel(E.Critical)&&this.log(E.Critical,this.format([t,...n]))}flush(){}format(t){let n="";for(let r=0;r<t.length;r++){let s=t[r];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}n+=(r>0?" ":"")+s}return n}}e.AbstractMessageLogger=i;class I extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!D.isWindows}trace(t,...n){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...n):console.log(`[main ${S()}]`,t,...n))}debug(t,...n){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...n):console.log(`[main ${S()}]`,t,...n))}info(t,...n){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${S()}][0m`,t,...n):console.log(`[main ${S()}]`,t,...n))}warn(t,...n){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${S()}][0m`,t,...n):console.warn(`[main ${S()}]`,t,...n))}error(t,...n){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${S()}][0m`,t,...n):console.error(`[main ${S()}]`,t,...n))}critical(t,...n){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${S()}][0m`,t,...n):console.error(`[main ${S()}]`,t,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class d extends k{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...n){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",t,...n)}debug(t,...n){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...n)}info(t,...n){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",t,...n)}warn(t,...n){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",t,...n)}error(t,...n){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",t,...n)}critical(t,...n){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...n)}dispose(){}flush(){}}e.ConsoleLogger=d;class g extends k{constructor(t,n=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(n)}trace(t,...n){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(t),...n])}debug(t,...n){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(t),...n])}info(t,...n){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(t),...n])}warn(t,...n){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(t),...n])}error(t,...n){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(t),...n])}critical(t,...n){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(t),...n])}extractMessage(t){return typeof t=="string"?t:(0,_.toErrorMessage)(t,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class o extends k{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const n of this.logServices)n.setLevel(t);super.setLevel(t)}trace(t,...n){for(const r of this.logServices)r.trace(t,...n)}debug(t,...n){for(const r of this.logServices)r.debug(t,...n)}info(t,...n){for(const r of this.logServices)r.info(t,...n)}warn(t,...n){for(const r of this.logServices)r.warn(t,...n)}error(t,...n){for(const r of this.logServices)r.error(t,...n)}critical(t,...n){for(const r of this.logServices)r.critical(t,...n)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=o;class a extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...n){this.logger.trace(t,...n)}debug(t,...n){this.logger.debug(t,...n)}info(t,...n){this.logger.info(t,...n)}warn(t,...n){this.logger.warn(t,...n)}error(t,...n){this.logger.error(t,...n)}critical(t,...n){this.logger.critical(t,...n)}flush(){this.logger.flush()}}e.LogService=a;class w extends R.Disposable{constructor(t,n){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(r))}))}createLogger(t,n){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,(n==null?void 0:n.always)?E.Trace:this.logLevel,n),this.loggers.set(t.toString(),r),(n==null?void 0:n.always)||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=w;class f{constructor(){this.onDidChangeLogLevel=new T.Emitter().event}setLevel(t){}getLevel(){return E.Info}trace(t,...n){}debug(t,...n){}info(t,...n){}warn(t,...n){}error(t,...n){}critical(t,...n){}dispose(){}flush(){}}e.NullLogService=f;function y(h){if(h.verbose)return E.Trace;if(typeof h.logLevel=="string"){const t=l(h.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function l(h){switch(h){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=l;function m(h){switch(h){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=m}),define(be[90],_e([0,1,4,130,47]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(T=e.MarkerTag||(e.MarkerTag={}));var _;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(_=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function k(o,a){return a-o}E.compare=k;const i=Object.create(null);i[E.Error]=(0,R.localize)(0,null),i[E.Warning]=(0,R.localize)(1,null),i[E.Info]=(0,R.localize)(2,null);function I(o){return i[o]||""}E.toString=I;function d(o){switch(o){case D.default.Error:return E.Error;case D.default.Warning:return E.Warning;case D.default.Info:return E.Info;case D.default.Ignore:return E.Hint}}E.fromSeverity=d;function g(o){switch(o){case E.Error:return D.default.Error;case E.Warning:return D.default.Warning;case E.Info:return D.default.Info;case E.Hint:return D.default.Ignore}}E.toSeverity=g}(_=e.MarkerSeverity||(e.MarkerSeverity={}));var S;(function(E){const k="";function i(d){return I(d,!0)}E.makeKey=i;function I(d,g){let o=[k];return d.source?o.push(d.source.replace("\xA6","\\\xA6")):o.push(k),d.code?typeof d.code=="string"?o.push(d.code.replace("\xA6","\\\xA6")):o.push(d.code.value.replace("\xA6","\\\xA6")):o.push(k),d.severity!==void 0&&d.severity!==null?o.push(_.toString(d.severity)):o.push(k),d.message&&g?o.push(d.message.replace("\xA6","\\\xA6")):o.push(k),d.startLineNumber!==void 0&&d.startLineNumber!==null?o.push(d.startLineNumber.toString()):o.push(k),d.startColumn!==void 0&&d.startColumn!==null?o.push(d.startColumn.toString()):o.push(k),d.endLineNumber!==void 0&&d.endLineNumber!==null?o.push(d.endLineNumber.toString()):o.push(k),d.endColumn!==void 0&&d.endColumn!==null?o.push(d.endColumn.toString()):o.push(k),o.push(k),o.join("\xA6")}E.makeKeyOptionalMessage=I})(S=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,p.createDecorator)("markerService")}),define(be[154],_e([0,1,47,4,3]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,R.createDecorator)("notificationService");var T;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(T=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var _;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(_=e.NotificationsFilter||(e.NotificationsFilter={}));class S{constructor(){this.progress=new E,this.onDidClose=D.Event.None,this.onDidChangeVisibility=D.Event.None}updateSeverity(i){}updateMessage(i){}updateActions(i){}close(){}}e.NoOpNotification=S;class E{infinite(){}done(){}total(i){}worked(i){}}e.NoOpProgress=E}),define(be[155],_e([0,1,6,8,2,4]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,T.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(S){return{resolved:S,dispose(){}}}});function _(S,E){return D.URI.isUri(S)?(0,R.equalsIgnoreCase)(S.scheme,E):(0,R.startsWithIgnoreCase)(S,E+":")}e.matchesScheme=_});var ze=this&&this.__decorate||function(X,e,p,R){var D=arguments.length,T=D<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(X,e,p,R);else for(var S=X.length-1;S>=0;S--)(_=X[S])&&(T=(D<3?_(T):D>3?_(e,p,T):_(e,p))||T);return D>3&&T&&Object.defineProperty(e,p,T),T},je=this&&this.__param||function(X,e){return function(p,R){e(p,R,X)}};define(be[156],_e([0,1,4,20,6,11]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,p.createDecorator)("progressService");var _;(function(i){i[i.Explorer=1]="Explorer",i[i.Scm=3]="Scm",i[i.Extensions=5]="Extensions",i[i.Window=10]="Window",i[i.Notification=15]="Notification",i[i.Dialog=20]="Dialog"})(_=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class S{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=S,S.None=Object.freeze({report(){}});let E=class extends D.Disposable{constructor(I,d){super();this.deferred=new T.DeferredPromise,d.withProgress(I,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,D.toDisposable)(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};E=ze([je(1,e.IProgressService)],E),e.UnmanagedProgress=E;class k extends D.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new D.DisposableStore)}start(I){this.stop();const d=++this.currentOperationId,g=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{d===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add((0,D.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,D.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,D.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:d,token:g.token,stop:()=>this.doStop(d),isCurrent:()=>this.currentOperationId===d}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,p.createDecorator)("editorProgressService")}),define(be[29],_e([0,1,9,42]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(_,S){R.ok(p.isString(_)),R.ok(p.isObject(S)),R.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,S)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}e.Registry=new D}),define(be[91],_e([0,1,29,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,k){this.schemasById[D(E)]=k,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new T;p.Registry.add(e.Extensions.JSONContribution,_)}),define(be[67],_e([0,1,127,3,29,9,91]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var S;(function(w){w[w.APPLICATION=1]="APPLICATION",w[w.MACHINE=2]="MACHINE",w[w.WINDOW=3]="WINDOW",w[w.RESOURCE=4]="RESOURCE",w[w.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",w[w.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(S=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=D.Registry.as(_.Extensions.JSONContribution);class k{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(f,y=!0){this.registerConfigurations([f],y)}registerConfigurations(f,y=!0){const l=[];f.forEach(m=>{l.push(...this.validateAndRegisterProperties(m,y,m.extensionInfo)),this.configurationContributors.push(m),this.registerJSONConfiguration(m)}),E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(f){const y=[],l=m=>{if(m.properties)for(const h in m.properties)y.push(h),delete this.configurationProperties[h],this.removeFromSchema(h,m.properties[h]);m.allOf&&m.allOf.forEach(h=>l(h))};for(const m of f){l(m);const h=this.configurationContributors.indexOf(m);h!==-1&&this.configurationContributors.splice(h,1)}E.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}registerDefaultConfigurations(f){const y=[],l=[];for(const m of f)for(const h in m)if(y.push(h),e.OVERRIDE_PROPERTY_PATTERN.test(h)){this.defaultValues[h]=Object.assign(Object.assign({},this.defaultValues[h]||{}),m[h]);const t={type:"object",default:this.defaultValues[h],description:p.localize(1,null,h),$ref:e.resourceLanguageSettingsSchemaId};l.push(I(h)),this.configurationProperties[h]=t,this.defaultLanguageConfigurationOverridesNode.properties[h]=t}else{this.defaultValues[h]=m[h];const t=this.configurationProperties[h];t&&(this.updatePropertyDefaultValue(h,t),this.updateSchema(h,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}deregisterDefaultConfigurations(f){const y=[];for(const l of f)for(const m in l)if(y.push(m),delete this.defaultValues[m],e.OVERRIDE_PROPERTY_PATTERN.test(m))delete this.configurationProperties[m],delete this.defaultLanguageConfigurationOverridesNode.properties[m];else{const h=this.configurationProperties[m];h&&(this.updatePropertyDefaultValue(m,h),this.updateSchema(m,h))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(y)}notifyConfigurationSchemaUpdated(...f){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(f){for(const y of f)this.overrideIdentifiers.add(y);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(f,y=!0,l,m=3){var h;m=T.isUndefinedOrNull(f.scope)?m:f.scope;let t=[],n=f.properties;if(n)for(let s in n){if(y&&o(s)){delete n[s];continue}const u=n[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=T.isUndefinedOrNull(u.scope)?m:u.scope,u.restricted=T.isUndefinedOrNull(u.restricted)?!!((h=l==null?void 0:l.restrictedConfigurations)===null||h===void 0?void 0:h.includes(s)):u.restricted),n[s].hasOwnProperty("included")&&!n[s].included){this.excludedConfigurationProperties[s]=n[s],delete n[s];continue}else this.configurationProperties[s]=n[s];!n[s].deprecationMessage&&n[s].markdownDeprecationMessage&&(n[s].deprecationMessage=n[s].markdownDeprecationMessage),t.push(s)}let r=f.allOf;if(r)for(let s of r)t.push(...this.validateAndRegisterProperties(s,y,l,m));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(f){const y=l=>{let m=l.properties;if(m)for(const t in m)this.updateSchema(t,m[t]);let h=l.allOf;h&&h.forEach(y)};y(f)}updateSchema(f,y){switch(e.allSettings.properties[f]=y,y.scope){case 1:e.applicationSettings.properties[f]=y;break;case 2:e.machineSettings.properties[f]=y;break;case 6:e.machineOverridableSettings.properties[f]=y;break;case 3:e.windowSettings.properties[f]=y;break;case 4:e.resourceSettings.properties[f]=y;break;case 5:e.resourceSettings.properties[f]=y,this.resourceLanguageSettingsSchema.properties[f]=y;break}}removeFromSchema(f,y){switch(delete e.allSettings.properties[f],y.scope){case 1:delete e.applicationSettings.properties[f];break;case 2:delete e.machineSettings.properties[f];break;case 6:delete e.machineOverridableSettings.properties[f];break;case 3:delete e.windowSettings.properties[f];break;case 4:case 5:delete e.resourceSettings.properties[f];break}}updateOverridePropertyPatternKey(){for(const f of this.overrideIdentifiers.values()){const y=`[${f}]`,l={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(y,l),e.allSettings.properties[y]=l,e.applicationSettings.properties[y]=l,e.machineSettings.properties[y]=l,e.machineOverridableSettings.properties[y]=l,e.windowSettings.properties[y]=l,e.resourceSettings.properties[y]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(f,y){let l=this.defaultValues[f];T.isUndefined(l)&&(l=y.default),T.isUndefined(l)&&(l=d(y.type)),y.default=l}}const i="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(i);function I(w){return w.substring(1,w.length-1)}e.overrideIdentifierFromKey=I;function d(w){switch(Array.isArray(w)?w[0]:w){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new k;D.Registry.add(e.Extensions.Configuration,g);function o(w){return w.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(w)?p.localize(5,null,w):g.getConfigurationProperties()[w]!==void 0?p.localize(6,null,w):null:p.localize(4,null)}e.validateProperty=o;function a(){const w=[],f=g.getConfigurationProperties();for(const y of Object.keys(f))w.push([y,f[y].scope]);return w.push(["launch",4]),w.push(["task",4]),w}e.getScopes=a}),define(be[92],_e([0,1,23,9,2,29,4,67]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,_.createDecorator)("configurationService");function E(n){return n&&typeof n=="object"&&(!n.overrideIdentifier||typeof n.overrideIdentifier=="string")&&(!n.resource||n.resource instanceof D.URI)}e.isConfigurationOverrides=E;var k;(function(n){n[n.USER=1]="USER",n[n.USER_LOCAL=2]="USER_LOCAL",n[n.USER_REMOTE=3]="USER_REMOTE",n[n.WORKSPACE=4]="WORKSPACE",n[n.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",n[n.DEFAULT=6]="DEFAULT",n[n.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(n){switch(n){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(n,r){const s=r?n?r.keys.filter(F=>n.keys.indexOf(F)===-1):[...r.keys]:[],u=n?r?n.keys.filter(F=>r.keys.indexOf(F)===-1):[...n.keys]:[],v=[];if(r&&n){for(const F of n.keys)if(r.keys.indexOf(F)!==-1){const N=f(n.contents,F),z=f(r.contents,F);p.equals(N,z)||v.push(F)}}const b=[],P=F=>{const N={};for(const z of F)for(const he of z.identifiers)N[h(he)]=z;return N},C=r?P(r.overrides):{},c=n?P(n.overrides):{};if(Object.keys(C).length)for(const F of s){const N=C[F];N&&b.push([(0,S.overrideIdentifierFromKey)(F),N.keys])}if(Object.keys(c).length)for(const F of u){const N=c[F];N&&b.push([(0,S.overrideIdentifierFromKey)(F),N.keys])}if(Object.keys(C).length&&Object.keys(c).length)for(const F of v){const N=c[F],z=C[F];if(N&&z){const he=I({contents:N.contents,keys:N.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});b.push([(0,S.overrideIdentifierFromKey)(F),[...he.added,...he.removed,...he.updated]])}}return{added:s,removed:u,updated:v,overrides:b}}e.compare=I;function d(n,r){const s=[];for(const u of Object.keys(n))if(S.OVERRIDE_PROPERTY_PATTERN.test(u)){const v={};for(const b in n[u])v[b]=n[u][b];s.push({identifiers:[(0,S.overrideIdentifierFromKey)(u).trim()],keys:Object.keys(v),contents:g(v,r)})}return s}e.toOverrides=d;function g(n,r){const s=Object.create(null);for(let u in n)o(s,u,n[u],r);return s}e.toValuesTree=g;function o(n,r,s,u){const v=r.split("."),b=v.pop();let P=n;for(let C=0;C<v.length;C++){let c=v[C],F=P[c];switch(typeof F){case"undefined":F=P[c]=Object.create(null);break;case"object":break;default:u(`Ignoring ${r} as ${v.slice(0,C+1).join(".")} is ${JSON.stringify(F)}`);return}P=F}if(typeof P=="object"&&P!==null)try{P[b]=s}catch(C){u(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(P)}`)}else u(`Ignoring ${r} as ${v.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=o;function a(n,r){const s=r.split(".");w(n,s)}e.removeFromValueTree=a;function w(n,r){const s=r.shift();if(r.length===0){delete n[s];return}if(Object.keys(n).indexOf(s)!==-1){const u=n[s];typeof u=="object"&&!Array.isArray(u)&&(w(u,r),Object.keys(u).length===0&&delete n[s])}}function f(n,r,s){function u(P,C){let c=P;for(const F of C){if(typeof c!="object"||c===null)return;c=c[F]}return c}const v=r.split("."),b=u(n,v);return typeof b=="undefined"?s:b}e.getConfigurationValue=f;function y(n,r,s){Object.keys(r).forEach(u=>{u!=="__proto__"&&(u in n?R.isObject(n[u])&&R.isObject(r[u])?y(n[u],r[u],s):s&&(n[u]=r[u]):n[u]=r[u])})}e.merge=y;function l(){const n=T.Registry.as(S.Extensions.Configuration).getConfigurationProperties();return Object.keys(n)}e.getConfigurationKeys=l;function m(){const n=Object.create(null),r=T.Registry.as(S.Extensions.Configuration).getConfigurationProperties();for(let s in r){let u=r[s].default;o(n,s,u,v=>console.error(`Conflict in default settings: ${v}`))}return n}e.getDefaultValues=m;function h(n){return`[${n}]`}e.keyFromOverrideIdentifier=h;function t(n,r,s){const u=n.inspect(r),v=n.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:u.defaultValue}e.getMigratedSettingValue=t}),define(be[157],_e([0,1,44,22,14,9,23,2,67,92,29,6,3]),function(X,e,p,R,D,T,_,S,E,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},n=[],r=[]){this._contents=t,this._keys=n,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,k.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,n){const r=this.getContentsForOverrideIdentifer(n);return r?t?(0,k.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.keys;return[]}override(t){const n=this.getContentsForOverrideIdentifer(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const s of D.distinct([...Object.keys(this.contents),...Object.keys(n)])){let u=this.contents[s],v=n[s];v&&(typeof u=="object"&&typeof v=="object"?(u=_.deepClone(u),this.mergeContents(u,v)):u=v),r[s]=u}return new g(r,this.keys,this.overrides)}merge(...t){const n=_.deepClone(this.contents),r=_.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(n,u.contents);for(const v of u.overrides){const[b]=r.filter(P=>D.equals(P.identifiers,v.identifiers));b?this.mergeContents(b.contents,v.contents):r.push(_.deepClone(v))}for(const v of u.keys)s.indexOf(v)===-1&&s.push(v)}return new g(n,s,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,n){for(const r of Object.keys(n)){if(r in t&&T.isObject(t[r])&&T.isObject(n[r])){this.mergeContents(t[r],n[r]);continue}t[r]=_.deepClone(n[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?_.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const n of this.overrides)if(n.identifiers.indexOf(t)!==-1)return n.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,n){this.addKey(t),(0,k.addToValueTree)(this.contents,t,n,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,k.removeFromValueTree)(this.contents,t)}addKey(t){let n=this.keys.length;for(let r=0;r<n;r++)t.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,t)}removeKey(t){let n=this.keys.indexOf(t);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=g;class o extends g{constructor(){const t=(0,k.getDefaultValues)(),n=(0,k.getConfigurationKeys)(),r=[];for(const s of Object.keys(t))E.OVERRIDE_PROPERTY_PATTERN.test(s)&&r.push({identifiers:[(0,E.overrideIdentifierFromKey)(s).trim()],keys:Object.keys(t[s]),contents:(0,k.toValuesTree)(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,n,r)}}e.DefaultConfigurationModel=o;class a{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,n){if(!T.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,n)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,n){this._raw=t;const{contents:r,keys:s,overrides:u,restricted:v}=this.doParseRaw(t,n);this._configurationModel=new g(r,s,u),this._restrictedConfigurations=v||[]}doParseContent(t){let n={},r=null,s=[],u=[],v=[];function b(C){Array.isArray(s)?s.push(C):r&&(s[r]=C)}let P={onObjectBegin:()=>{let C={};b(C),u.push(s),s=C,r=null},onObjectProperty:C=>{r=C},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let C=[];b(C),u.push(s),s=C,r=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:b,onError:(C,c,F)=>{v.push({error:C,offset:c,length:F})}};if(t)try{p.visit(t,P),n=s[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return n}doParseRaw(t,n){const r=i.Registry.as(E.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,r,!0,n);t=s.raw;const u=(0,k.toValuesTree)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),v=Object.keys(t),b=(0,k.toOverrides)(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:u,keys:v,overrides:b,restricted:s.restricted}}filter(t,n,r,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const u={},v=[];for(let b in t)if(E.OVERRIDE_PROPERTY_PATTERN.test(b)&&r){const P=this.filter(t[b],n,!1,s);u[b]=P.raw,v.push(...P.restricted)}else{const P=n[b],C=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&v.push(b),(C===void 0||s.scopes===void 0||s.scopes.includes(C))&&(s.skipRestricted&&(P==null?void 0:P.restricted)||(u[b]=t[b]))}return{raw:u,restricted:v}}}e.ConfigurationModelParser=a;class w extends I.Disposable{constructor(t,n,r,s){super();this.userSettingsResource=t,this.scopes=n,this.fileService=s,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new a(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=w;class f{constructor(t,n,r=new g,s=new g,u=new R.ResourceMap,v=new g,b=new R.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=v,this._memoryConfigurationByResource=b,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(t)}updateValue(t,n,r={}){let s;r.resource?(s=this._memoryConfigurationByResource.get(r.resource),s||(s=new g,this._memoryConfigurationByResource.set(r.resource,s))):s=this._memoryConfiguration,n===void 0?s.removeValue(t):s.setValue(t,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,n,r){const s=this.getConsolidateConfigurationModel(n,r),u=this.getFolderConfigurationModelForResource(n.resource,r),v=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,b=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),C=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),c=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,N=u?n.overrideIdentifier?u.freeze().override(n.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=n.overrideIdentifier?v.override(n.overrideIdentifier).getValue(t):v.getValue(t),he=s.getValue(t),me=D.distinct(D.flatten(s.overrides.map(Q=>Q.identifiers))).filter(Q=>s.getOverrideValue(t,Q)!==void 0);return{defaultValue:b,userValue:P,userLocalValue:C,userRemoteValue:c,workspaceValue:F,workspaceFolderValue:N,memoryValue:z,value:he,default:b!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userLocal:C!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,userRemote:c!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:n.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:v.getValue(t),override:n.overrideIdentifier?v.getOverrideValue(t,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:me.length?me:void 0}}keys(t){const n=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,n){this._folderConfigurations.set(t,n),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const r=n.filter(s=>E.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=(0,E.overrideIdentifierFromKey)(s),v=this._defaultConfiguration.getKeysForOverrideIdentifier(u),b=t.getKeysForOverrideIdentifier(u),P=[...b.filter(C=>v.indexOf(C)===-1),...v.filter(C=>b.indexOf(C)===-1),...v.filter(C=>!_.equals(this._defaultConfiguration.override(u).getValue(C),t.override(u).getValue(C)))];return[u,P]});return this.updateDefaultConfiguration(t),{keys:n,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:r,removed:s,overrides:u}=(0,k.compare)(this.localUserConfiguration,t),v=[...n,...r,...s];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:r,removed:s,overrides:u}=(0,k.compare)(this.remoteUserConfiguration,t);let v=[...n,...r,...s];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:r,removed:s,overrides:u}=(0,k.compare)(this.workspaceConfiguration,t);let v=[...n,...r,...s];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:u}}compareAndUpdateFolderConfiguration(t,n){const r=this.folderConfigurations.get(t),{added:s,updated:u,removed:v,overrides:b}=(0,k.compare)(r,n);let P=[...s,...u,...v];return(P.length||!r)&&this.updateFolderConfiguration(t,n),{keys:P,overrides:b}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:s,removed:u,overrides:v}=(0,k.compare)(n,void 0);return{keys:[...r,...s,...u],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,n){let r=this.getConsolidatedConfigurationModelForResource(t,n);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&t){const s=n.getFolder(t);s&&(r=this.getFolderConsolidatedConfiguration(s.uri)||r);const u=this._memoryConfigurationByResource.get(t);u&&(r=r.merge(u))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let n=this._foldersConsolidatedConfigurations.get(t);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(n=r.merge(s),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(t,n)):n=r}return n}getFolderConfigurationModelForResource(t,n){if(n&&t){const r=n.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,n)=>{const{contents:r,overrides:s,keys:u}=this._folderConfigurations.get(n);return t.push([n,{contents:r,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>t.add(n)),this.userConfiguration.freeze().keys.forEach(n=>t.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>t.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s))),[...n.values()]}static parse(t){const n=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((v,b)=>(v.set(S.URI.revive(b[0]),this.parseConfigurationModel(b[1])),v),new R.ResourceMap);return new f(n,r,new g,s,u,new g,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=f;function y(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const t=new Set,n=new Map;for(const s of h)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,v])=>{const b=(0,R.getOrSet)(n,u,new Set);v.forEach(P=>b.add(P))});const r=[];return n.forEach((s,u)=>r.push([u,[...s.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=y;class l{constructor(t,n,r,s){this.change=t,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(b=>u.add(b)),t.overrides.forEach(([,b])=>b.forEach(P=>u.add(P))),this.affectedKeys=[...u.values()];const v=new g;this.affectedKeys.forEach(b=>v.setValue(b,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=f.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,n){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(n){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,n,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,u=this.currentConfiguraiton.getValue(t,n,this.currentWorkspace);return!_.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(t,n){let r=(0,k.toValuesTree)({[n]:!0},()=>{}),s;for(;typeof r=="object"&&(s=Object.keys(r)[0]);){if(t=t[s],!t)return!1;r=r[s]}return!0}}e.ConfigurationChangeEvent=l;class m extends l{constructor(t,n,r,s){super({keys:t.allKeys(),overrides:[]},void 0,t,n);this.source=r,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=m}),define(be[93],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var R;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(_,S=R.Unknown,E){super(_);this._message=_,this._code=S,this._detail=E,this.isHandled=S===R.NotAvailable&&E===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(_){return _ instanceof D&&_._code===R.TemporarilyNotAvailable}static isNoResolverFound(_){return _ instanceof D&&_._code===R.NoResolverFound}static isHandled(_){return _ instanceof D&&_.isHandled}}e.RemoteAuthorityResolverError=D}),define(be[94],_e([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.getRemoteName=e.getRemoteAuthority=void 0;function R(k){return k.scheme===p.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=R;function D(k){if(!k)return;const i=k.indexOf("+");return i<0?k:k.substr(0,i)}e.getRemoteName=D;function T(k){return k.scheme!==p.Schemas.file&&k.scheme!==p.Schemas.vscodeRemote}function _(k){if(k.folders.length)return k.folders.every(i=>T(i.uri))?k.folders[0].uri:void 0;if(k.configuration&&T(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=_;function S(k){var i;return(i=_(k))===null||i===void 0?void 0:i.scheme}e.getVirtualWorkspaceScheme=S;function E(k){return _(k)!==void 0}e.isVirtualWorkspace=E}),define(be[158],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(D){this._callback=D,this._terminalBufferMap=new Map}dispose(){for(const D of this._terminalBufferMap.values())D.dispose()}startBuffering(D,T,_=5){let S;return S=T(E=>{const k=typeof E=="string"?E:E.data;let i=this._terminalBufferMap.get(D);if(i){i.data.push(k);return}const I=setTimeout(()=>this.flushBuffer(D),_);i={data:[k],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(D),S.dispose()}},this._terminalBufferMap.set(D,i)}),S}stopBuffering(D){const T=this._terminalBufferMap.get(D);T&&T.dispose()}flushBuffer(D){const T=this._terminalBufferMap.get(D);T&&(this._terminalBufferMap.delete(D),this._callback(D,T.data.join("")))}}e.TerminalDataBufferer=p}),define(be[159],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(be[160],_e([0,1,4,6,29,3,159,35]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var E;(function(w){function f(y){return y&&typeof y=="object"&&typeof y.id=="string"}w.isThemeColor=f})(E=e.ThemeColor||(e.ThemeColor={}));function k(w){return{id:w}}e.themeColorFromId=k;var i;(function(w){function f(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||E.isThemeColor(n.color))}w.isThemeIcon=f;const y=new RegExp(`^\\$\\((${S.CSSIcon.iconNameExpression}(?:${S.CSSIcon.iconModifierExpression})?)\\)$`);function l(n){const r=y.exec(n);if(!r)return;let[,s]=r;return{id:s}}w.fromString=l;function m(n,r){let s=n.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),r&&(s=`${s}~${r}`),{id:s}}w.modify=m;function h(n,r){var s,u;return n.id===r.id&&((s=n.color)===null||s===void 0?void 0:s.id)===((u=r.color)===null||u===void 0?void 0:u.id)}w.isEqual=h;function t(n){return{id:n.id}}w.asThemeIcon=t,w.asClassNameArray=S.CSSIcon.asClassNameArray,w.asClassName=S.CSSIcon.asClassName,w.asCSSSelector=S.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=S.Codicon.file,e.FolderThemeIcon=S.Codicon.folder;function I(w){switch(w){case _.ColorScheme.DARK:return"vs-dark";case _.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new T.Emitter}onColorThemeChange(f){return this.themingParticipants.push(f),this.onThemingParticipantAddedEmitter.fire(f),(0,R.toDisposable)(()=>{const y=this.themingParticipants.indexOf(f);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new d;D.Registry.add(e.Extensions.ThemingContribution,g);function o(w){return g.onColorThemeChange(w)}e.registerThemingParticipant=o;class a extends R.Disposable{constructor(f){super();this.themeService=f,this.theme=f.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(f){this.theme=f,this.updateStyles()}updateStyles(){}getColor(f,y){let l=this.theme.getColor(f);return l&&y&&(l=y(l,this.theme)),l?l.toString():null}}e.Themable=a}),define(be[161],_e([0,1,29,160,3,131,91,11,35]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,T.localize)(0,null)},fontCharacter:{type:"string",description:(0,T.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${E.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(f,y,l,m){const h=this.iconsById[f];if(h){if(l&&!h.description){h.description=l,this.iconSchema.properties[f].markdownDescription=`${l} $(${f})`;const r=this.iconReferenceSchema.enum.indexOf(f);r!==-1&&(this.iconReferenceSchema.enumDescriptions[r]=l),this._onDidChange.fire()}return h}let t={id:f,description:l,defaults:y,deprecationMessage:m};this.iconsById[f]=t;let n={$ref:"#/definitions/icons"};return m&&(n.deprecationMessage=m),l&&(n.markdownDescription=`${l}: $(${f})`),this.iconSchema.properties[f]=n,this.iconReferenceSchema.enum.push(f),this.iconReferenceSchema.enumDescriptions.push(l||""),this._onDidChange.fire(),{id:f}}deregisterIcon(f){delete this.iconsById[f],delete this.iconSchema.properties[f];const y=this.iconReferenceSchema.enum.indexOf(f);y!==-1&&(this.iconReferenceSchema.enum.splice(y,1),this.iconReferenceSchema.enumDescriptions.splice(y,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(f=>this.iconsById[f])}getIcon(f){return this.iconsById[f]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(f,y){const l=this.iconFontsById[f];if(l)return l;let m={id:f,definition:y};return this.iconFontsById[f]=m,this._onDidChange.fire(),m}deregisterIconFont(f){delete this.iconFontsById[f]}getIconFonts(){return Object.keys(this.iconFontsById).map(f=>this.iconFontsById[f])}getIconFont(f){return this.iconFontsById[f]}toString(){const f=(h,t)=>h.id.localeCompare(t.id),y=h=>{for(;R.ThemeIcon.isThemeIcon(h.defaults);)h=this.iconsById[h.defaults.id];return`codicon codicon-${h?h.id:""}`};let l=[];l.push("| preview     | identifier                        | default codicon ID                | description"),l.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const m=Object.keys(this.iconsById).map(h=>this.iconsById[h]);for(const h of m.filter(t=>!!t.description).sort(f))l.push(`|<i class="${y(h)}"></i>|${h.id}|${R.ThemeIcon.isThemeIcon(h.defaults)?h.defaults.id:h.id}|${h.description||""}|`);l.push("| preview     | identifier                        "),l.push("| ----------- | --------------------------------- |");for(const h of m.filter(t=>!R.ThemeIcon.isThemeIcon(t.defaults)).sort(f))l.push(`|<i class="${y(h)}"></i>|${h.id}|`);return l.join(`
`)}}const i=new k;p.Registry.add(e.Extensions.IconContribution,i);function I(w,f,y,l){return i.registerIcon(w,f,y,l)}e.registerIcon=I;function d(){return i}e.getIconRegistry=d;function g(){for(const w of E.iconRegistry.all)i.registerIcon(w.id,w.definition,w.description);E.iconRegistry.onDidRegister(w=>i.registerIcon(w.id,w.definition,w.description))}g(),e.iconsSchemaId="vscode://schemas/icons";let o=p.Registry.as(_.Extensions.JSONContribution);o.registerSchema(e.iconsSchemaId,i.getIconSchema());const a=new S.RunOnceScheduler(()=>o.notifySchemaChanged(e.iconsSchemaId),200);i.onDidChange(()=>{a.isScheduled()||a.schedule()}),e.widgetClose=I("widget-close",E.Codicon.close,(0,T.localize)(2,null)),e.gotoPreviousLocation=I("goto-previous-location",E.Codicon.arrowUp,(0,T.localize)(3,null)),e.gotoNextLocation=I("goto-next-location",E.Codicon.arrowDown,(0,T.localize)(4,null)),e.syncing=R.ThemeIcon.modify(E.Codicon.sync,"spin")}),define(be[48],_e([0,1,2,24,4,22]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,D.createDecorator)("contextService");var _;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(_=e.WorkbenchState||(e.WorkbenchState={}));function S(d){const g=d;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}e.isWorkspace=S;function E(d){const g=d;return!!(g&&typeof g=="object"&&p.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}e.isWorkspaceFolder=E;class k{constructor(g,o,a,w){this._id=g,this._configuration=a,this._ignorePathCasing=w,this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=o}update(g){this._id=g.id,this._configuration=g.configuration,this._ignorePathCasing=g._ignorePathCasing,this.folders=g.folders}get folders(){return this._folders}set folders(g){this._folders=g,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(g){this._configuration=g}getFolder(g){return g&&this._foldersMap.findSubstr(g.with({scheme:g.scheme,authority:g.authority,path:g.path}))||null}updateFoldersMap(){this._foldersMap=T.TernarySearchTree.forUris(this._ignorePathCasing);for(const g of this.folders)this._foldersMap.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class i{constructor(g,o){this.raw=o,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,R.joinPath)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(d){return new i({uri:d,index:0,name:(0,R.basenameOrAuthority)(d)},{uri:d.toString()})}e.toWorkspaceFolder=I}),define(be[162],_e([0,1,4,132,48,2,21,12,24,109,44,15,59,36,94]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const a=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(W){return(typeof W=="string"?(0,S.extname)(W):(0,E.extname)(W))===a}e.hasWorkspaceFileExtension=w,e.IWorkspacesService=(0,p.createDecorator)("workspacesService");function f(W){return W.hasOwnProperty("workspace")}e.isRecentWorkspace=f;function y(W){return W.hasOwnProperty("folderUri")}e.isRecentFolder=y;function l(W){return W.hasOwnProperty("fileUri")}e.isRecentFile=l;function m(W){const x=W;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.uri)}e.isSingleFolderWorkspaceIdentifier=m;function h(W){if(W.configuration)return{id:W.id,configPath:W.configuration};if(W.folders.length===1)return{id:W.id,uri:W.folders[0].uri}}e.toWorkspaceIdentifier=h;function t(W){const x=W;return typeof(x==null?void 0:x.id)=="string"&&T.URI.isUri(x.configPath)}e.isWorkspaceIdentifier=t;function n(W){const x=W;if(x==null?void 0:x.uri)return{id:x.id,uri:T.URI.revive(x.uri)};const A=W;if(A==null?void 0:A.configPath)return{id:A.id,configPath:T.URI.revive(A.configPath)};if(W==null?void 0:W.id)return{id:W.id}}e.reviveIdentifier=n;function r(W,x){return E.extUriBiasedIgnorePathCase.isEqualOrParent(W,x.untitledWorkspacesHome)}e.isUntitledWorkspace=r;function s(W){return u(W)||v(W)}e.isStoredWorkspaceFolder=s;function u(W){const x=W;return typeof(x==null?void 0:x.path)=="string"&&(!x.name||typeof x.name=="string")}e.isRawFileWorkspaceFolder=u;function v(W){const x=W;return typeof(x==null?void 0:x.uri)=="string"&&(!x.name||typeof x.name=="string")}e.isRawUriWorkspaceFolder=v;function b(W,x,A,U,M=!_.isWindows,$){if(W.scheme!==U.scheme)return{name:A,uri:W.toString(!0)};let K=x?void 0:$.relativePath(U,W);if(K!==void 0)K.length===0?K=".":_.isWindows&&W.scheme===I.Schemas.file&&!M&&(K=K.replace(/\//g,"\\"));else if(W.scheme===I.Schemas.file)K=W.fsPath,_.isWindows&&(K=(0,d.normalizeDriveLetter)(K),M&&(K=(0,g.toSlashes)(K)));else{if(!$.isEqualAuthority(W.authority,U.authority))return{name:A,uri:W.toString(!0)};K=W.path}return{name:A,path:K}}e.getStoredWorkspaceFolder=b;function P(W,x,A){let U=[],M=new Set;const $=A.dirname(x);for(let K of W){let j;if(u(K))K.path&&(j=A.resolvePath($,K.path));else if(v(K))try{j=T.URI.parse(K.uri),j.path[0]!=="/"&&(j=j.with({path:"/"+j.path}))}catch(ae){console.warn(ae)}if(j){let ae=A.getComparisonKey(j);if(!M.has(ae)){M.add(ae);const we=K.name||A.basenameOrAuthority(j);U.push(new D.WorkspaceFolder({uri:j,name:we,index:U.length},K))}}}return U}e.toWorkspaceFolders=P;function C(W,x,A,U,M){let $=c(x,W);const K=M.dirname(x),j=M.dirname(U),ae=[],we=F($.folders);for(const Ve of $.folders){const Qe=u(Ve)?M.resolvePath(K,Ve.path):T.URI.parse(Ve.uri);let Ke;A?Ke=!1:Ke=!u(Ve)||(0,S.isAbsolute)(Ve.path),ae.push(b(Qe,Ke,Ve.name,j,we,M))}const Re={insertSpaces:!1,tabSize:4,eol:_.isLinux||_.isMacintosh?`
`:`\r
`},xe=k.setProperty(W,["folders"],ae,Re);let Le=k.applyEdits(W,xe);return $.remoteAuthority===(0,o.getRemoteAuthority)(U)&&(Le=k.applyEdits(Le,k.removeProperty(Le,["remoteAuthority"],Re))),Le}e.rewriteWorkspaceFileForNewLocation=C;function c(W,x){let A=i.parse(x);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(U=>s(U));else throw new Error(`${W} looks like an invalid workspace file.`);return A}function F(W){return _.isWindows?W.some(x=>u(x)&&x.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function N(W){return W.workspace&&typeof W.workspace=="object"&&typeof W.workspace.id=="string"&&typeof W.workspace.configPath=="string"}function z(W){return typeof W.folderUri=="string"}function he(W){return typeof W.fileUri=="string"}function me(W,x){const A={workspaces:[],files:[]};if(W){const U=function($,K){for(let j=0;j<$.length;j++)try{K($[j],j)}catch(ae){x.warn(`Error restoring recent entry ${JSON.stringify($[j])}: ${ae.toString()}. Skip entry.`)}},M=W;if(Array.isArray(M.entries))U(M.entries,$=>{const K=$.label,j=$.remoteAuthority;N($)?A.workspaces.push({label:K,remoteAuthority:j,workspace:{id:$.workspace.id,configPath:T.URI.parse($.workspace.configPath)}}):z($)?A.workspaces.push({label:K,remoteAuthority:j,folderUri:T.URI.parse($.folderUri)}):he($)&&A.files.push({label:K,remoteAuthority:j,fileUri:T.URI.parse($.fileUri)})});else{const $=W;Array.isArray($.workspaces3)&&U($.workspaces3,(K,j)=>{const ae=Array.isArray($.workspaceLabels)&&$.workspaceLabels[j]||void 0;typeof K=="object"&&typeof K.id=="string"&&typeof K.configURIPath=="string"?A.workspaces.push({label:ae,workspace:{id:K.id,configPath:T.URI.parse(K.configURIPath)}}):typeof K=="string"&&A.workspaces.push({label:ae,folderUri:T.URI.parse(K)})}),Array.isArray($.files2)&&U($.files2,(K,j)=>{const ae=Array.isArray($.fileLabels)&&$.fileLabels[j]||void 0;typeof K=="string"&&A.files.push({label:ae,fileUri:T.URI.parse(K)})})}}return A}e.restoreRecentlyOpened=me;function Q(W){const x={entries:[]};for(const A of W.workspaces)y(A)?x.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):x.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of W.files)x.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return x}e.toStoreData=Q}),define(be[68],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(D){this.id=D,this._data=new Map,this._idPool=1}add(D){const T=this._idPool++;return this._data.set(T,D),this.logDebugInfo(),T}get(D,T){return this._data.has(D)?this._data.get(D)[T]:void 0}delete(D){this._data.delete(D),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(be[69],_e([0,1,2,3,4]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class T{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(S){this._tabs=S.map(E=>({name:E.name,group:E.group,resource:p.URI.revive(E.resource),isActive:E.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=T}),define(be[49],_e([0,1,15,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class D{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(_,S){S===null?this._providerInfo.delete(_):this._providerInfo.set(_,S)}isFreeScheme(_){return!this._providerInfo.has(_)&&!this._systemSchemes.has(_)}getCapabilities(_){return this._providerInfo.get(_)}}e.ExtHostFileSystemInfo=D,e.IExtHostFileSystemInfo=(0,R.createDecorator)("IExtHostFileSystemInfo")}),define(be[28],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,p.createDecorator)("IExtHostInitDataService")}),define(be[163],_e([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(_,S,E){this._deferredPromises=new Map,this._id=_,this._shared=S,this._storage=E,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const i of k.values())i.complete()}catch(i){for(const I of k.values())I.error(i)}})()},0)}get keys(){var _;return Object.entries((_=this._value)!==null&&_!==void 0?_:{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this._init}get(_,S){let E=this._value[_];return typeof E=="undefined"&&(E=S),E}update(_,S){this._value[_]=S;let E=this._deferredPromises.get(_);if(E!==void 0)return E.p;const k=new p.DeferredPromise;return this._deferredPromises.set(_,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class D extends R{constructor(_,S){super(_.identifier.value,!0,S);this._extension=_}setKeysForSync(_){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},_)}}e.ExtensionGlobalMemento=D}),define(be[16],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,p.createDecorator)("IExtHostRpcService");class R{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.ExtHostRpcService=R});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[164],_e([0,1,26,3]),function(X,e,p,R){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class T{constructor(S,E){D.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(S.identifier),nt(this,D,E,"f"),Ue(this,D,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(S){return Ue(this,D,"f").get(this._id,S)}store(S,E){return Ue(this,D,"f").store(this._id,S,E)}delete(S){return Ue(this,D,"f").delete(this._id,S)}}e.ExtensionSecrets=T,D=new WeakMap}),define(be[95],_e([0,1,4,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class D{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(_){this._enabled=_}$onDidChangeTelemetryEnabled(_){this._enabled=_,this._onDidChangeTelemetryEnabled.fire(_)}}e.ExtHostTelemetry=D,e.IExtHostTelemetry=(0,p.createDecorator)("IExtHostTelemetry")}),define(be[70],_e([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(_){_[_.NewChild=0]="NewChild",_[_.Disposed=1]="Disposed",_[_.Invalidated=2]="Invalidated",_[_.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const D=new WeakMap,T=_=>{let S=D.get(_);return S||(S={children:new Map,bus:new p.Emitter},D.set(_,S)),S};e.getPrivateApiFor=T}),define(be[71],_e([0,1,4,3,16]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var T;(function(S){function E(i){return{remoteAddress:i.remoteAddress,localAddress:i.localAddress,public:!!i.public}}S.fromApiTunnel=E;function k(i){return{remoteAddress:{host:i.tunnelRemoteHost,port:i.tunnelRemotePort},localAddress:i.localAddress,public:i.public}}S.fromServiceTunnel=k})(T=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,p.createDecorator)("IExtHostTunnelService");let _=class{constructor(E){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(E){return E}async openTunnel(E,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(E){return{dispose:()=>{}}}registerPortsAttributesProvider(E,k){return{dispose:()=>{}}}async $providePortAttributes(E,k,i,I,d){return[]}async $forwardPort(E,k){}async $closeTunnel(E){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};_=ze([je(0,D.IExtHostRpcService)],_),e.ExtHostTunnelService=_});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)},Kt=this&&this.__rest||function(X,e){var p={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(p[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,R=Object.getOwnPropertySymbols(X);D<R.length;D++)e.indexOf(R[D])<0&&Object.prototype.propertyIsEnumerable.call(X,R[D])&&(p[R[D]]=X[R[D]]);return p};define(be[7],_e([0,1,14,13,83,22,115,9,2,37,65,93,70]),function(X,e,p,R,D,T,_,S,E,k,i,I,d){"use strict";var g,o,a,w,f,y,l,m,h,t,n,r,s,u,v,b,P,C;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function c(B){function L(){return Reflect.construct(B,arguments,this.constructor)}return Object.defineProperty(L,"name",Object.getOwnPropertyDescriptor(B,"name")),Object.setPrototypeOf(L,B),Object.setPrototypeOf(L.prototype,B.prototype),L}let F=f=class{constructor(L){g.set(this,void 0),nt(this,g,L,"f")}static from(...L){let ee=L;return new f(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}dispose(){typeof Ue(this,g,"f")=="function"&&(Ue(this,g,"f").call(this),nt(this,g,void 0,"f"))}};g=new WeakMap,F=f=ze([c],F),e.Disposable=F;let N=y=class{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("line must be non-negative");if(ee<0)throw(0,R.illegalArgument)("character must be non-negative");this._line=L,this._character=ee}static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isBefore(ee)&&(ee=He)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const He=L[Ee];He.isAfter(ee)&&(ee=He)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof y)return!0;let{line:ee,character:Ee}=L;return typeof ee=="number"&&typeof Ee=="number"}get line(){return this._line}get character(){return this._character}isBefore(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<L._character}isBeforeOrEqual(L){return this._line<L._line?!0:L._line<this._line?!1:this._character<=L._character}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this._line===L._line&&this._character===L._character}compareTo(L){return this._line<L._line?-1:this._line>L.line?1:this._character<L._character?-1:this._character>L._character?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,R.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&ee===0?this:new y(this.line+Ee,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,R.illegalArgument)();let Ee;return typeof L=="undefined"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),Ee===this.line&&ee===this.character?this:new y(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};N=y=ze([c],N),e.Position=N;let z=l=class{constructor(L,ee,Ee,He){let Xe,at;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"?(Xe=new N(L,ee),at=new N(Ee,He)):L instanceof N&&ee instanceof N&&(Xe=L,at=ee),!Xe||!at)throw new Error("Invalid arguments");Xe.isBefore(at)?(this._start=Xe,this._end=at):(this._start=at,this._end=Xe)}static isRange(L){return L instanceof l?!0:L?N.isPosition(L.start)&&N.isPosition(L.end):!1}get start(){return this._start}get end(){return this._end}contains(L){return L instanceof l?this.contains(L._start)&&this.contains(L._end):L instanceof N?!(L.isBefore(this._start)||this._end.isBefore(L)):!1}isEqual(L){return this._start.isEqual(L._start)&&this._end.isEqual(L._end)}intersection(L){const ee=N.Max(L.start,this._start),Ee=N.Min(L.end,this._end);if(!ee.isAfter(Ee))return new l(ee,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=N.Min(L.start,this._start),Ee=N.Max(L.end,this.end);return new l(ee,Ee)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,R.illegalArgument)();let Ee;return L?N.isPosition(L)?Ee=L:(Ee=L.start||this.start,ee=L.end||this.end):Ee=this.start,Ee.isEqual(this._start)&&ee.isEqual(this.end)?this:new l(Ee,ee)}toJSON(){return[this.start,this.end]}};z=l=ze([c],z),e.Range=z;let he=m=class extends z{constructor(L,ee,Ee,He){let Xe,at;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"?(Xe=new N(L,ee),at=new N(Ee,He)):L instanceof N&&ee instanceof N&&(Xe=L,at=ee),!Xe||!at)throw new Error("Invalid arguments");super(Xe,at);this._anchor=Xe,this._active=at}static isSelection(L){return L instanceof m?!0:L?z.isRange(L)&&N.isPosition(L.anchor)&&N.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};he=m=ze([c],he),e.Selection=he;class me{constructor(L,ee,Ee){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,R.illegalArgument)("port");if(typeof Ee!="undefined"&&(typeof Ee!="string"||Ee.length===0||!/^[0-9A-Za-z\-]+$/.test(Ee)))throw(0,R.illegalArgument)("connectionToken");this.host=L,this.port=Math.round(ee),this.connectionToken=Ee}}e.ResolvedAuthority=me;class Q extends Error{constructor(L,ee=I.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L);this._message=L,this._code=ee,this._detail=Ee,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,Q.prototype)}static NotAvailable(L,ee){return new Q(L,I.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new Q(L,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=Q;var W;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var x;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(x=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let A=h=class{constructor(L,ee){this._range=L,this._newText=ee}static isTextEdit(L){return L instanceof h?!0:L?z.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new h(L,ee)}static insert(L,ee){return h.replace(new z(L,L),ee)}static delete(L){return h.replace(L,"")}static setEndOfLine(L){const ee=new h(new z(new N(0,0),new N(0,0)),"");return ee.newEol=L,ee}get range(){return this._range}set range(L){if(L&&!z.isRange(L))throw(0,R.illegalArgument)("range");this._range=L}get newText(){return this._newText||""}set newText(L){if(L&&typeof L!="string")throw(0,R.illegalArgument)("newText");this._newText=L}get newEol(){return this._newEol}set newEol(L){if(L&&typeof L!="number")throw(0,R.illegalArgument)("newEol");this._newEol=L}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};A=h=ze([c],A),e.TextEdit=A;var U;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellOutput=4]="CellOutput",B[B.CellReplace=5]="CellReplace",B[B.CellOutputItem=6]="CellOutputItem"})(U=e.FileEditType||(e.FileEditType={}));let M=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(L,ee,Ee,He){this._edits.push({_type:1,from:L,to:ee,options:Ee,metadata:He})}createFile(L,ee,Ee){this._edits.push({_type:1,from:void 0,to:L,options:ee,metadata:Ee})}deleteFile(L,ee,Ee){this._edits.push({_type:1,from:L,to:void 0,options:ee,metadata:Ee})}replaceNotebookMetadata(L,ee,Ee){this._edits.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(L,ee,Ee,He,Xe){let at,dt,St=[],kt;if(xt.isNotebookRange(ee)&&Te.isNotebookCellDataArray(Ee)&&!Te.isNotebookCellDataArray(He)?(at=ee.start,dt=ee.end,St=Ee,kt=He):typeof ee=="number"&&typeof Ee=="number"&&Te.isNotebookCellDataArray(He)&&(at=ee,dt=Ee,St=He,kt=Xe),at===void 0||dt===void 0)throw new Error("Invalid arguments");(at!==dt||St.length>0)&&this._edits.push({_type:5,uri:L,index:at,count:dt-at,cells:St,metadata:kt})}replaceNotebookCellMetadata(L,ee,Ee,He){this._edits.push({_type:3,metadata:He,uri:L,edit:{editType:8,index:ee,metadata:Ee}})}replace(L,ee,Ee,He){this._edits.push({_type:2,uri:L,edit:new A(ee,Ee),metadata:He})}insert(L,ee,Ee,He){this.replace(L,new z(ee,ee),Ee,He)}delete(L,ee,Ee){this.replace(L,ee,"",Ee)}has(L){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const Ee of ee)Ee&&this._edits.push({_type:2,uri:L,edit:Ee});else{for(let Ee=0;Ee<this._edits.length;Ee++){const He=this._edits[Ee];He._type===2&&He.uri.toString()===L.toString()&&(this._edits[Ee]=void 0)}(0,p.coalesceInPlace)(this._edits)}}get(L){const ee=[];for(let Ee of this._edits)Ee._type===2&&Ee.uri.toString()===L.toString()&&ee.push(Ee.edit);return ee}entries(){const L=new T.ResourceMap;for(let ee of this._edits)if(ee._type===2){let Ee=L.get(ee.uri);Ee||(Ee=[ee.uri,[]],L.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};M=ze([c],M),e.WorkspaceEdit=M;let $=t=class{constructor(L){this._tabstop=1,this.value=L||""}static isSnippetString(L){return L instanceof t?!0:L?typeof L.value=="string":!1}static _escape(L){return L.replace(/\$|}|\\/g,"\\$&")}appendText(L){return this.value+=t._escape(L),this}appendTabstop(L=this._tabstop++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this._tabstop++){if(typeof L=="function"){const Ee=new t;Ee._tabstop=this._tabstop,L(Ee),this._tabstop=Ee._tabstop,L=Ee.value}else L=t._escape(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this._tabstop++){const Ee=L.map(He=>He.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const Ee=new t;Ee._tabstop=this._tabstop,ee(Ee),this._tabstop=Ee._tabstop,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};$=t=ze([c],$),e.SnippetString=$;var K;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(K=e.DiagnosticTag||(e.DiagnosticTag={}));var j;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(j=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=n=class{constructor(L,ee){if(this.uri=L,ee)if(ee instanceof z)this.range=ee;else if(ee instanceof N)this.range=new z(ee,ee);else throw new Error("Illegal argument")}static isLocation(L){return L instanceof n?!0:L?z.isRange(L.range)&&E.URI.isUri(L.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ae=n=ze([c],ae),e.Location=ae;let we=class{constructor(L,ee){this.location=L,this.message=ee}static is(L){return L?typeof L.message=="string"&&L.location&&z.isRange(L.location.range)&&E.URI.isUri(L.location.uri):!1}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};we=ze([c],we),e.DiagnosticRelatedInformation=we;let Re=class{constructor(L,ee,Ee=j.Error){if(!z.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=Ee}toJSON(){return{severity:j[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,p.equals)(L.tags,ee.tags)&&(0,p.equals)(L.relatedInformation,ee.relatedInformation,we.isEqual)}};Re=ze([c],Re),e.Diagnostic=Re;let xe=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:(0,D.isMarkdownString)(L)?this.contents=[L]:this.contents=[L],this.range=ee}};xe=ze([c],xe),e.Hover=xe;var Le;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(Le=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Ve=class{constructor(L,ee=Le.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Le[this.kind]}}};Ve=ze([c],Ve),e.DocumentHighlight=Ve;var Qe;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(Qe=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(B){B[B.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let Ge=r=class{constructor(L,ee,Ee,He,Xe){this.name=L,this.kind=ee,this.containerName=Xe,typeof Ee=="string"&&(this.containerName=Ee),He instanceof ae?this.location=He:Ee instanceof z&&(this.location=new ae(He,Ee)),r.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Qe[this.kind],location:this.location,containerName:this.containerName}}};Ge=r=ze([c],Ge),e.SymbolInformation=Ge;let H=s=class{constructor(L,ee,Ee,He,Xe){this.name=L,this.detail=ee,this.kind=Ee,this.range=He,this.selectionRange=Xe,this.children=[],s.validate(this)}static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children&&L.children.forEach(s.validate)}};H=s=ze([c],H),e.DocumentSymbol=H;var Y;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Y=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ne=class{constructor(L,ee){this.title=L,this.kind=ee}};ne=ze([c],ne),e.CodeAction=ne;let re=u=class{constructor(L){this.value=L}append(L){return new u(this.value?this.value+u.sep+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+u.sep)}};re.sep=".",re=u=ze([c],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let G=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};G=ze([c],G),e.SelectionRange=G;class se{constructor(L,ee,Ee,He,Xe,at){this.kind=L,this.name=ee,this.detail=Ee,this.uri=He,this.range=Xe,this.selectionRange=at}}e.CallHierarchyItem=se;class fe{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.CallHierarchyIncomingCall=fe;class Ae{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.CallHierarchyOutgoingCall=Ae;let ge=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};ge=ze([c],ge),e.CodeLens=ge;let We=v=class{constructor(L,ee=!1){o.set(this,void 0),nt(this,o,new D.MarkdownString(L,{supportThemeIcons:ee}),"f")}static isMarkdownString(L){return L instanceof v?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}get value(){return Ue(this,o,"f").value}set value(L){Ue(this,o,"f").value=L}get isTrusted(){return Ue(this,o,"f").isTrusted}set isTrusted(L){Ue(this,o,"f").isTrusted=L}get supportThemeIcons(){return Ue(this,o,"f").supportThemeIcons}appendText(L){return Ue(this,o,"f").appendText(L),this}appendMarkdown(L){return Ue(this,o,"f").appendMarkdown(L),this}appendCodeblock(L,ee){return Ue(this,o,"f").appendCodeblock(ee??"",L),this}};o=new WeakMap,We=v=ze([c],We),e.MarkdownString=We;let V=class{constructor(L,ee){this.label=L,this.documentation=ee}};V=ze([c],V),e.ParameterInformation=V;let te=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};te=ze([c],te),e.SignatureInformation=te;let pe=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};pe=ze([c],pe),e.SignatureHelp=pe;var Me;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(Me=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var $e;(function(B){B[B.Other=0]="Other",B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})($e=e.InlayHintKind||(e.InlayHintKind={}));let Be=class{constructor(L,ee,Ee){this.text=L,this.position=ee,this.kind=Ee}};Be=ze([c],Be),e.InlayHint=Be;var Ye;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Se;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(Se=e.CompletionItemKind||(e.CompletionItemKind={}));var ye;(function(B){B[B.Deprecated=1]="Deprecated"})(ye=e.CompletionItemTag||(e.CompletionItemTag={}));let De=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Se[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};De=ze([c],De),e.CompletionItem=De;let ie=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};ie=ze([c],ie),e.CompletionList=ie;let ue=class{constructor(L,ee,Ee){this.text=L,this.range=ee,this.command=Ee}};ue=ze([c],ue),e.InlineSuggestion=ue;let O=class{constructor(L){this.items=L}};O=ze([c],O),e.InlineSuggestions=O;var J;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(J=e.ViewColumn||(e.ViewColumn={}));var oe;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(oe=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ce;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative"})(Ce=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var ke;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(ke=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ne;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ne=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Oe;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(Oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var qe;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(qe=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(B){function L(ee){switch(ee){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=L}(Oe=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(L,ee){if(ee&&!E.URI.isUri(ee))throw(0,R.illegalArgument)("target");if(!z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.target=ee}};rt=ze([c],rt),e.DocumentLink=rt;let tt=class{constructor(L,ee,Ee,He){this.red=L,this.green=ee,this.blue=Ee,this.alpha=He}};tt=ze([c],tt),e.Color=tt;let Je=class{constructor(L,ee){if(ee&&!(ee instanceof tt))throw(0,R.illegalArgument)("color");if(!z.isRange(L)||L.isEmpty)throw(0,R.illegalArgument)("range");this.range=L,this.color=ee}};Je=ze([c],Je),e.ColorInformation=Je;let ot=class{constructor(L){if(!L||typeof L!="string")throw(0,R.illegalArgument)("label");this.label=L}};ot=ze([c],ot),e.ColorPresentation=ot;var _t;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(_t=e.ColorFormat||(e.ColorFormat={}));var bt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(bt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var ve;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(ve=e.TaskRevealKind||(e.TaskRevealKind={}));var ce;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ce=e.TaskPanelKind||(e.TaskPanelKind={}));let le=b=class{constructor(L,ee){if(typeof L!="string"||typeof ee!="string")throw(0,R.illegalArgument)("name");this._id=L}static from(L){switch(L){case"clean":return b.Clean;case"build":return b.Build;case"rebuild":return b.Rebuild;case"test":return b.Test;default:return}}get id(){return this._id}};le.Clean=new b("clean","Clean"),le.Build=new b("build","Build"),le.Rebuild=new b("rebuild","Rebuild"),le.Test=new b("test","Test"),le=b=ze([c],le),e.TaskGroup=le;function q(B){let L="";for(let ee=0;ee<B.length;ee++)L+=B[ee].replace(/,/g,",,")+",";return L}let Fe=class{constructor(L,ee,Ee){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._args=[],this._process=L,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=Ee):this._options=ee)}get process(){return this._process}set process(L){if(typeof L!="string")throw(0,R.illegalArgument)("process");this._process=L}get args(){return this._args}set args(L){Array.isArray(L)||(L=[]),this._args=L}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("process"),this._process!==void 0&&L.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)L.push(ee);return q(L)}};Fe=ze([c],Fe),e.ProcessExecution=Fe;let Pe=class{constructor(L,ee,Ee){if(this._args=[],Array.isArray(ee)){if(!L)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L,this._args=ee,this._options=Ee}else{if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(L){if(typeof L!="string")throw(0,R.illegalArgument)("commandLine");this._commandLine=L}get command(){return this._command?this._command:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,R.illegalArgument)("command");this._command=L}get args(){return this._args}set args(L){this._args=L||[]}get options(){return this._options}set options(L){this._options=L}computeId(){const L=[];if(L.push("shell"),this._commandLine!==void 0&&L.push(this._commandLine),this._command!==void 0&&L.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)L.push(typeof ee=="string"?ee:ee.value);return q(L)}};Pe=ze([c],Pe),e.ShellExecution=Pe;var Ze;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(Ze=e.ShellQuoting||(e.ShellQuoting={}));var et;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(et=e.TaskScope||(e.TaskScope={}));class ft{constructor(L){this._callback=L}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(L){this._callback=L}get callback(){return this._callback}}e.CustomExecution=ft;let ut=P=class{constructor(L,ee,Ee,He,Xe,at){this.__deprecated=!1,this._definition=this.definition=L;let dt;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=Ee,this.execution=He,dt=Xe,this.__deprecated=!0):ee===et.Global||ee===et.Workspace?(this.target=ee,this._name=this.name=Ee,this._source=this.source=He,this.execution=Xe,dt=at):(this.target=ee,this._name=this.name=Ee,this._source=this.source=He,this.execution=Xe,dt=at),typeof dt=="string"?(this._problemMatchers=[dt],this._hasDefinedMatchers=!0):Array.isArray(dt)?(this._problemMatchers=dt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(L){this.__id=L}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Fe?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof Pe?this._definition={type:P.ShellType,id:this._execution.computeId()}:this._execution instanceof ft?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(L){if(L==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=L}get scope(){return this._scope}set target(L){this.clear(),this._scope=L}get name(){return this._name}set name(L){if(typeof L!="string")throw(0,R.illegalArgument)("name");this.clear(),this._name=L}get execution(){return this._execution}set execution(L){L===null&&(L=void 0),this.clear(),this._execution=L;const ee=this._definition.type;(P.EmptyType===ee||P.ProcessType===ee||P.ShellType===ee||P.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(L){if(Array.isArray(L))this.clear(),this._problemMatchers=L,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.clear(),this._isBackground=L}get source(){return this._source}set source(L){if(typeof L!="string"||L.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=L}get group(){return this._group}set group(L){L===null&&(L=void 0),this.clear(),this._group=L}get detail(){return this._detail}set detail(L){L===null&&(L=void 0),this._detail=L}get presentationOptions(){return this._presentationOptions}set presentationOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._presentationOptions=L}get runOptions(){return this._runOptions}set runOptions(L){L==null&&(L=Object.create(null)),this.clear(),this._runOptions=L}};ut.ExtensionCallbackType="customExecution",ut.ProcessType="process",ut.ShellType="shell",ut.EmptyType="$empty",ut=P=ze([c],ut),e.Task=ut;var it;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(it=e.ProgressLocation||(e.ProgressLocation={}));let vt=class{constructor(L,ee=ht.None){this.collapsibleState=ee,E.URI.isUri(L)?this.resourceUri=L:this.label=L}};vt=ze([c],vt),e.TreeItem=vt;var ht;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(ht=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let lt=class{constructor(L,ee){this.id=L,this.color=ee}};lt=ze([c],lt),e.ThemeIcon=lt,lt.File=new lt("file"),lt.Folder=new lt("folder");let mt=class{constructor(L){this.id=L}};mt=ze([c],mt),e.ThemeColor=mt;var Pt;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(Pt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ct=class{constructor(L,ee){if(typeof L!="string"&&(!L||!E.URI.isUri(L)&&!E.URI.isUri(L.uri)))throw(0,R.illegalArgument)("base");if(typeof ee!="string")throw(0,R.illegalArgument)("pattern");typeof L=="string"?(this.baseFolder=E.URI.file(L),this.base=L):E.URI.isUri(L)?(this.baseFolder=L,this.base=L.fsPath):(this.baseFolder=L.uri,this.base=L.uri.fsPath),this.pattern=ee}};Ct=ze([c],Ct),e.RelativePattern=Ct;let At=class{constructor(L,ee,Ee,He){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof He=="string"&&(this.logMessage=He)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};At=ze([c],At),e.Breakpoint=At;let Rt=class extends At{constructor(L,ee,Ee,He,Xe){super(ee,Ee,He,Xe);if(L===null)throw(0,R.illegalArgument)("location");this.location=L}};Rt=ze([c],Rt),e.SourceBreakpoint=Rt;let yt=class extends At{constructor(L,ee,Ee,He,Xe){super(ee,Ee,He,Xe);this.functionName=L}};yt=ze([c],yt),e.FunctionBreakpoint=yt;let Gt=class extends At{constructor(L,ee,Ee,He,Xe,at,dt){super(He,Xe,at,dt);if(!ee)throw(0,R.illegalArgument)("dataId");this.label=L,this.dataId=ee,this.canPersist=Ee}};Gt=ze([c],Gt),e.DataBreakpoint=Gt;let Qt=class{constructor(L,ee,Ee){this.command=L,this.args=ee||[],this.options=Ee}};Qt=ze([c],Qt),e.DebugAdapterExecutable=Qt;let gt=class{constructor(L,ee){this.port=L,this.host=ee}};gt=ze([c],gt),e.DebugAdapterServer=gt;let Yt=class{constructor(L){this.path=L}};Yt=ze([c],Yt),e.DebugAdapterNamedPipeServer=Yt;let Jt=class{constructor(L){this.implementation=L}};Jt=ze([c],Jt),e.DebugAdapterInlineImplementation=Jt;let Dt=class{constructor(L,ee){this.range=L,this.expression=ee}};Dt=ze([c],Dt),e.EvaluatableExpression=Dt;var cn;(function(B){B[B.Automatic=0]="Automatic",B[B.Explicit=1]="Explicit"})(cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Xt=class{constructor(L,ee){this.range=L,this.text=ee}};Xt=ze([c],Xt),e.InlineValueText=Xt;let $t=class{constructor(L,ee,Ee=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=Ee}};$t=ze([c],$t),e.InlineValueVariableLookup=$t;let ct=class{constructor(L,ee){this.range=L,this.expression=ee}};ct=ze([c],ct),e.InlineValueEvaluatableExpression=ct;let Zt=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};Zt=ze([c],Zt),e.InlineValueContext=Zt;var Mt;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Mt=e.FileChangeType||(e.FileChangeType={}));let Lt=C=class extends Error{constructor(L,ee=i.FileSystemProviderErrorCode.Unknown,Ee){var He;super(E.URI.isUri(L)?L.toString(!0):L);this.code=(He=Ee==null?void 0:Ee.name)!==null&&He!==void 0?He:"Unknown",(0,i.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}static FileExists(L){return new C(L,i.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(L){return new C(L,i.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(L){return new C(L,i.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(L){return new C(L,i.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(L){return new C(L,i.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(L){return new C(L,i.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Lt=C=ze([c],Lt),e.FileSystemError=Lt;let Vt=class{constructor(L,ee,Ee){this.start=L,this.end=ee,this.kind=Ee}};Vt=ze([c],Vt),e.FoldingRange=Vt;var vn;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(vn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var dn;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(dn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var wn;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(wn=e.CommentMode||(e.CommentMode={}));class hn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.SemanticTokensLegend=hn;function Bt(B){return typeof B=="undefined"||(0,S.isStringArray)(B)}class en{constructor(L){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,L){this._hasLegend=!0;for(let ee=0,Ee=L.tokenTypes.length;ee<Ee;ee++)this._tokenTypeStrToInt.set(L.tokenTypes[ee],ee);for(let ee=0,Ee=L.tokenModifiers.length;ee<Ee;ee++)this._tokenModifierStrToInt.set(L.tokenModifiers[ee],ee)}}push(L,ee,Ee,He,Xe){if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof He=="number"&&(typeof Xe=="number"||typeof Xe=="undefined"))return typeof Xe=="undefined"&&(Xe=0),this._pushEncoded(L,ee,Ee,He,Xe);if(z.isRange(L)&&typeof ee=="string"&&Bt(Ee))return this._push(L,ee,Ee);throw(0,R.illegalArgument)()}_push(L,ee,Ee){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const He=L.start.line,Xe=L.start.character,at=L.end.character-L.start.character,dt=this._tokenTypeStrToInt.get(ee);let St=0;if(Ee)for(const kt of Ee){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const Tt=this._tokenModifierStrToInt.get(kt);St|=1<<Tt>>>0}this._pushEncoded(He,Xe,at,dt,St)}_pushEncoded(L,ee,Ee,He,Xe){if(this._dataIsSortedAndDeltaEncoded&&(L<this._prevLine||L===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let kt=0,Tt=0;for(let Ft=0;Ft<St;Ft++){let Ot=this._data[5*Ft],ln=this._data[5*Ft+1];Ot===0?(Ot=kt,ln+=Tt):Ot+=kt,this._data[5*Ft]=Ot,this._data[5*Ft+1]=ln,kt=Ot,Tt=ln}}let at=L,dt=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(dt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=dt,this._data[this._dataLen++]=Ee,this._data[this._dataLen++]=He,this._data[this._dataLen++]=Xe,this._prevLine=L,this._prevChar=ee}static _sortAndDeltaEncode(L){let ee=[];const Ee=L.length/5|0;for(let dt=0;dt<Ee;dt++)ee[dt]=dt;ee.sort((dt,St)=>{const kt=L[5*dt],Tt=L[5*St];if(kt===Tt){const Ft=L[5*dt+1],Ot=L[5*St+1];return Ft-Ot}return kt-Tt});const He=new Uint32Array(L.length);let Xe=0,at=0;for(let dt=0;dt<Ee;dt++){const St=5*ee[dt],kt=L[St+0],Tt=L[St+1],Ft=L[St+2],Ot=L[St+3],ln=L[St+4],Mn=kt-Xe,xn=Mn===0?Tt-at:Tt,un=5*dt;He[un+0]=Mn,He[un+1]=xn,He[un+2]=Ft,He[un+3]=Ot,He[un+4]=ln,Xe=kt,at=Tt}return He}build(L){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),L):new Ht(en._sortAndDeltaEncode(this._data),L)}}e.SemanticTokensBuilder=en;class Ht{constructor(L,ee){this.resultId=ee,this.data=L}}e.SemanticTokens=Ht;class tn{constructor(L,ee,Ee){this.start=L,this.deleteCount=ee,this.data=Ee}}e.SemanticTokensEdit=tn;class bn{constructor(L,ee){this.resultId=ee,this.edits=L}}e.SemanticTokensEdits=bn;var _n;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(_n=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Nt;(function(B){B[B.Initial=1]="Initial",B[B.Dynamic=2]="Dynamic"})(Nt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let jt=class{constructor(){}};jt.Back={iconPath:new lt("arrow-left")},jt=ze([c],jt),e.QuickInputButtons=jt;var En;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(En=e.ExtensionKind||(e.ExtensionKind={}));class yn{constructor(L,ee,Ee){this.badge=L,this.tooltip=ee,this.color=Ee}static validate(L){if(L.badge&&L.badge.length!==1&&L.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=yn;let nn=class{constructor(L){this.kind=L}};nn=ze([c],nn),e.ColorTheme=nn;var rn;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast"})(rn=e.ColorThemeKind||(e.ColorThemeKind={}));class xt{constructor(L,ee){if(L<0)throw(0,R.illegalArgument)("start must be positive");if(ee<0)throw(0,R.illegalArgument)("end must be positive");L<=ee?(this._start=L,this._end=ee):(this._start=ee,this._end=L)}static isNotebookRange(L){return L instanceof xt?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(L){let ee=this._start,Ee=this._end;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(Ee=L.end),ee===this._start&&Ee===this._end?this:new xt(ee,Ee)}}e.NotebookRange=xt;class qt{constructor(L,ee){typeof L=="object"?Object.assign(this,L):(this.inputCollapsed=L,this.outputCollapsed=ee)}with(L){let{inputCollapsed:ee,outputCollapsed:Ee}=L,He=Kt(L,["inputCollapsed","outputCollapsed"]);return ee===void 0?ee=this.inputCollapsed:ee===null&&(ee=void 0),Ee===void 0?Ee=this.outputCollapsed:Ee===null&&(Ee=void 0),ee===this.inputCollapsed&&Ee===this.outputCollapsed&&Object.keys(He).length===0?this:new qt(Object.assign({inputCollapsed:ee,outputCollapsed:Ee},He))}}e.NotebookCellMetadata=qt;class Wt{constructor(L={}){Object.assign(this,L)}with(L){return new Wt(L)}}e.NotebookDocumentMetadata=Wt;class Te{constructor(L,ee,Ee,He,Xe,at){this.kind=L,this.value=ee,this.languageId=Ee,this.outputs=He??[],this.metadata=Xe,this.executionSummary=at,Te.validate(this)}static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>Te.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}}e.NotebookCellData=Te;class sn{constructor(L,ee){this.cells=L,this.metadata=ee??new Wt}}e.NotebookData=sn;class It{constructor(L,ee,Ee){this.data=L,this.mime=ee,this.metadata=Ee;const He=(0,_.normalizeMimeType)(ee,!0);if(!He)throw new Error("INVALID mime type, must not be empty or falsy: "+ee);this.mime=He}static isNotebookCellOutputItem(L){return L instanceof It?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L,ee){const Ee={name:L.name,message:L.message,stack:L.stack};return It.json(Ee,"application/vnd.code.notebook.error",ee)}static stdout(L,ee){return It.text(L,"application/vnd.code.notebook.stdout",ee)}static stderr(L,ee){return It.text(L,"application/vnd.code.notebook.stderr",ee)}static bytes(L,ee="application/octet-stream",Ee){return new It(L,ee,Ee)}static text(L,ee="text/plain",Ee){const He=Ue(It,a,"f",w).encode(String(L));return new It(He,ee,Ee)}static json(L,ee="application/json",Ee){const He=JSON.stringify(L,void 0,"	");return It.text(He,ee,Ee)}}e.NotebookCellOutputItem=It,a=It,w={value:new TextEncoder};class pt{constructor(L,ee,Ee){this.outputs=pt.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=(0,k.generateUuid)(),this.metadata=ee??Ee)}static ensureUniqueMimeTypes(L,ee=!1){const Ee=new Set,He=new Set;for(let Xe=0;Xe<L.length;Xe++){const at=L[Xe],dt=(0,_.normalizeMimeType)(at.mime);if(!Ee.has(dt)){Ee.add(dt);continue}He.add(Xe),ee&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return He.size===0?L:L.filter((Xe,at)=>!He.has(at))}}e.NotebookCellOutput=pt;var Sn;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(Sn=e.NotebookCellKind||(e.NotebookCellKind={}));var Dn;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Dn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var fn;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(fn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var mn;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(mn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class on{constructor(L,ee,Ee,He,Xe,at){this.text=L,this.alignment=ee,this.command=Ee,this.tooltip=He,this.priority=Xe,this.accessibilityInformation=at}}e.NotebookCellStatusBarItem=on;var Cn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Cn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class kn{constructor(L,ee=[]){this.uri=L,this.provides=(0,p.asArray)(ee)}}e.NotebookRendererScript=kn;let an=class{constructor(L,ee){this.label=L,this.timestamp=ee}};an=ze([c],an),e.TimelineItem=an;var gn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(gn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class An{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.LinkedEditingRanges=An;class Tn{constructor(L,ee){this._port=L,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Tn;var Rn;(function(B){B[B.Unset=0]="Unset",B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(Rn=e.TestResultState||(e.TestResultState={}));var Z;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information",B[B.Hint=3]="Hint"})(Z=e.TestMessageSeverity||(e.TestMessageSeverity={}));var de;(function(B){B[B.Pending=0]="Pending",B[B.Resolved=1]="Resolved"})(de=e.TestItemStatus||(e.TestItemStatus={}));const Ie=(B,L,ee,Ee)=>{let He=ee;return{enumerable:!0,configurable:!1,get(){return He},set(Xe){Ee(He,Xe)||(He=Xe,B.bus.fire([3,L,Xe]))}}},st=(B,L)=>B===L,wt=(B,L)=>B===L?!0:!B||!L?!1:B.isEqual(L);class Et{constructor(L,ee,Ee,He){this.label=ee,this.data=He;const Xe=(0,d.getPrivateApiFor)(this);Object.defineProperties(this,{id:{value:L,enumerable:!0,writable:!1},uri:{value:Ee,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>Xe.parent},children:{value:new T.ReadonlyMapView(Xe.children),enumerable:!0,writable:!1},range:Ie(Xe,"range",void 0,wt),description:Ie(Xe,"description",void 0,st),runnable:Ie(Xe,"runnable",!0,st),debuggable:Ie(Xe,"debuggable",!1,st),status:Ie(Xe,"status",de.Resolved,st),error:Ie(Xe,"error",void 0,st)})}invalidate(){(0,d.getPrivateApiFor)(this).bus.fire([2])}dispose(){const L=(0,d.getPrivateApiFor)(this);L.parent&&(0,d.getPrivateApiFor)(L.parent).children.delete(this.id),L.bus.fire([1])}addChild(L){if(!(L instanceof Et))throw new Error("Test child must be created through vscode.test.createTestItem()");const ee=(0,d.getPrivateApiFor)(this);if(ee.children.has(L.id))throw new Error(`Attempted to insert a duplicate test item ID ${L.id}`);ee.children.set(L.id,L),ee.bus.fire([0,L])}}e.TestItemImpl=Et;class Fn{constructor(L){this.message=L,this.severity=Z.Error}static diff(L,ee,Ee){const He=new Fn(L);return He.expectedOutput=ee,He.actualOutput=Ee,He}}e.TestMessage=Fn;var Un;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(Un=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var $n;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})($n=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Bn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore"})(Bn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(be[96],_e([0,1,42,15,8,123,86,7,14]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function i(o,a){a?k.set(o,a):k.delete(o)}e.setWordDefinitionFor=i;function I(o){return k.get(o)}e.getWordDefinitionFor=I;class d extends T.MirrorTextModel{constructor(a,w,f,y,l,m,h,t){super(w,f,y,l);this._proxy=a,this._languageId=m,this._isDirty=h,this._notebook=t,this._isDisposed=!1}dispose(){(0,p.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(a){return(0,E.equals)(this._lines,a)}get document(){if(!this._document){const a=this;this._document={get uri(){return a._uri},get fileName(){return a._uri.fsPath},get isUntitled(){return a._uri.scheme===R.Schemas.untitled},get languageId(){return a._languageId},get version(){return a._versionId},get isClosed(){return a._isDisposed},get isDirty(){return a._isDirty},get notebook(){return a._notebook},save(){return a._save()},getText(w){return w?a._getTextInRange(w):a.getText()},get eol(){return a._eol===`
`?S.EndOfLine.LF:S.EndOfLine.CRLF},get lineCount(){return a._lines.length},lineAt(w){return a._lineAt(w)},offsetAt(w){return a._offsetAt(w)},positionAt(w){return a._positionAt(w)},validateRange(w){return a._validateRange(w)},validatePosition(w){return a._validatePosition(w)},getWordRangeAtPosition(w,f){return a._getWordRangeAtPosition(w,f)}}}return Object.freeze(this._document)}_acceptLanguageId(a){(0,p.ok)(!this._isDisposed),this._languageId=a}_acceptIsDirty(a){(0,p.ok)(!this._isDisposed),this._isDirty=a}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(a){const w=this._validateRange(a);if(w.isEmpty)return"";if(w.isSingleLine)return this._lines[w.start.line].substring(w.start.character,w.end.character);const f=this._eol,y=w.start.line,l=w.end.line,m=[];m.push(this._lines[y].substring(w.start.character));for(let h=y+1;h<l;h++)m.push(this._lines[h]);return m.push(this._lines[l].substring(0,w.end.character)),m.join(f)}_lineAt(a){let w;if(a instanceof S.Position?w=a.line:typeof a=="number"&&(w=a),typeof w!="number"||w<0||w>=this._lines.length||Math.floor(w)!==w)throw new Error("Illegal value for `line`");return new g(w,this._lines[w],w===this._lines.length-1)}_offsetAt(a){return a=this._validatePosition(a),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(a.line-1)+a.character}_positionAt(a){a=Math.floor(a),a=Math.max(0,a),this._ensureLineStarts();const w=this._lineStarts.getIndexOf(a),f=this._lines[w.index].length;return new S.Position(w.index,Math.min(w.remainder,f))}_validateRange(a){if(!(a instanceof S.Range))throw new Error("Invalid argument");const w=this._validatePosition(a.start),f=this._validatePosition(a.end);return w===a.start&&f===a.end?a:new S.Range(w.line,w.character,f.line,f.character)}_validatePosition(a){if(!(a instanceof S.Position))throw new Error("Invalid argument");if(this._lines.length===0)return a.with(0,0);let{line:w,character:f}=a,y=!1;if(w<0)w=0,f=0,y=!0;else if(w>=this._lines.length)w=this._lines.length-1,f=this._lines[w].length,y=!0;else{const l=this._lines[w].length;f<0?(f=0,y=!0):f>l&&(f=l,y=!0)}return y?new S.Position(w,f):a}_getWordRangeAtPosition(a,w){const f=this._validatePosition(a);if(!w)w=I(this._languageId);else if((0,D.regExpLeadsToEndlessLoop)(w))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${w.source}' because it matches the empty string.`);const y=(0,_.getWordAtText)(f.character+1,(0,_.ensureValidWordDefinition)(w),this._lines[f.line],0);if(y)return new S.Range(f.line,y.startColumn-1,f.line,y.endColumn-1)}}e.ExtHostDocumentData=d;class g{constructor(a,w,f){this._line=a,this._text=w,this._isLastLine=f}get lineNumber(){return this._line}get text(){return this._text}get range(){return new S.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new S.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(be[165],_e([0,1,7,3,88,6,60,22,2,37]),function(X,e,p,R,D,T,_,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class i{constructor(d,g,o,a){this._notebook=o,this._selector=a,this._disposables=new T.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=E.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(f=>{const y=this._cellUris.get(f.document.uri);y!==void 0&&(this._cellLengths.changeValue(y,this._cells[y].document.getText().length+1),this._cellLines.changeValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const w=f=>{f===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(d.onDidChangeNotebookCells(f=>w(f.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new S.ResourceMap;const d=[],g=[];for(const o of this._notebook.getCells())o.kind===p.NotebookCellKind.Code&&(!this._selector||(0,_.score)(this._selector,o.document.uri,o.document.languageId,!0))&&(this._cellUris.set(o.document.uri,this._cells.length),this._cells.push(o),d.push(o.document.getText().length+1),g.push(o.document.lineCount));this._cellLengths=new D.PrefixSumComputer(new Uint32Array(d)),this._cellLines=new D.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(d){var g,o;if(!d){let l="";for(const m of this._cells)l+=m.document.getText()+`
`;return l=l.slice(0,-1),l}if(d.isEmpty)return"";const a=this.locationAt(d.start),w=this.locationAt(d.end),f=this._cells[(g=this._cellUris.get(a.uri))!==null&&g!==void 0?g:-1],y=this._cells[(o=this._cellUris.get(w.uri))!==null&&o!==void 0?o:-1];if(!f||!y)return"";if(f===y)return f.document.getText(new p.Range(a.range.start,w.range.end));{const l=f.document.getText(new p.Range(a.range.start,new p.Position(f.document.lineCount,0))),m=y.document.getText(new p.Range(new p.Position(0,0),w.range.end));return l+`
`+m}}offsetAt(d){const g=this._cellLines.getIndexOf(d.line),o=this._cellLengths.getAccumulatedValue(g.index-1),a=this._cells[g.index].document.offsetAt(d.with(g.remainder));return o+a}positionAt(d){if(typeof d=="number"){const o=this._cellLengths.getIndexOf(d),a=this._cellLines.getAccumulatedValue(o.index-1);return this._cells[o.index].document.positionAt(o.remainder).translate(a)}const g=this._cellUris.get(d.uri);if(g!==void 0){const o=this._cellLines.getAccumulatedValue(g-1);return new p.Position(o+d.range.start.line,d.range.start.character)}return new p.Position(0,0)}locationAt(d){p.Range.isRange(d)||(d=new p.Range(d,d));const g=this._cellLines.getIndexOf(d.start.line);let o=g;d.isEmpty||(o=this._cellLines.getIndexOf(d.end.line));const a=new p.Position(g.remainder,d.start.character),w=new p.Position(o.remainder,d.end.character),f=new p.Range(a,w),y=this._cells[g.index];return new p.Location(y.document.uri,y.document.validateRange(f))}contains(d){return this._cellUris.has(d)}validateRange(d){const g=this.validatePosition(d.start),o=this.validatePosition(d.end);return d.with(g,o)}validatePosition(d){const g=this._cellLines.getIndexOf(d.line),o=new p.Position(g.remainder,d.character),a=this._cells[g.index].document.validatePosition(o),w=this._cellLines.getAccumulatedValue(g.index-1);return new p.Position(w+a.line,a.character)}}e.ExtHostNotebookConcatDocument=i}),define(be[166],_e([0,1,7,16,3]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let T=class{constructor(S){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new D.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(S){let E=S==="light"?p.ColorThemeKind.Light:S==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};T=ze([je(0,R.IExtHostRpcService)],T),e.ExtHostTheming=T}),define(be[72],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,p.createDecorator)("IURITransformerService");class R{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=_=>_,this.transformOutgoing=_=>_,this.transformOutgoingURI=_=>_,this.transformOutgoingScheme=_=>_)}}e.URITransformerService=R}),define(be[167],_e([0,1,25]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(E){let k=this.buffers.indexOf(E);return k<0&&(k=this.buffers.length,this.buffers.push(E)),k}}function D(S,E){if(E.serializeBuffersForPostMessage){const k=new R,i=(g,o)=>{if(o instanceof ArrayBuffer){const a=k.add(o);return{$$vscode_array_buffer_reference$$:!0,index:a}}else if(ArrayBuffer.isView(o)){const a=T(o);if(a){const w=k.add(o.buffer);return{$$vscode_array_buffer_reference$$:!0,index:w,view:{type:a,byteLength:o.byteLength,byteOffset:o.byteOffset}}}}return o},I=JSON.stringify(S,i),d=k.buffers.map(g=>{const o=new Uint8Array(g);return p.VSBuffer.wrap(o)});return{message:I,buffers:d}}else return{message:JSON.stringify(S),buffers:[]}}e.serializeWebviewMessage=D;function T(S){switch(S.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function _(S,E){const k=E.map(d=>{const g=new ArrayBuffer(d.byteLength);return new Uint8Array(g).set(d.buffer),g}),i=E.length?(d,g)=>{if(typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const o=g,{index:a}=o,w=k[a];if(o.view)switch(o.view.type){case 1:return new Int8Array(w,o.view.byteOffset,o.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(w,o.view.byteOffset,o.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(w,o.view.byteOffset,o.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(w,o.view.byteOffset,o.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(w,o.view.byteOffset,o.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(w,o.view.byteOffset,o.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(w,o.view.byteOffset,o.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(w,o.view.byteOffset,o.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(w,o.view.byteOffset,o.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(w,o.view.byteOffset,o.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(w,o.view.byteOffset,o.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return w}return g}:void 0;return{message:JSON.parse(S,i),arrayBuffers:k}}e.deserializeWebviewMessage=_}),define(be[73],_e([0,1,15,2]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function D(T,_){return T.scheme===p.Schemas.http||T.scheme===p.Schemas.https?T:(_&&_.authority&&_.isRemote&&T.scheme===p.Schemas.file&&(T=R.URI.from({scheme:p.Schemas.vscodeRemote,authority:_.authority,path:T.path})),R.URI.from({scheme:p.Schemas.https,authority:`${T.scheme}+${T.authority}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=D}),define(be[168],_e([0,1,3,6,73]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class T{constructor(S,E,k){this._proxy=S,this._editors=E,this._initData=k,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const i=E.getVisibleTextEditors();for(const I of this._insets.values())i.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(S=>S.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(S,E,k,i,I){let d;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===S){d=l;break}if(!d)throw new Error("not a visible editor");const g=this,o=this._handlePool++,a=new p.Emitter,w=new p.Emitter,f=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return(0,D.asWebviewUri)(l,g._initData.remote)}get cspSource(){return D.webviewGenericCspSource}set options(l){this._options=l,g._proxy.$setOptions(o,l)}get options(){return this._options}set html(l){this._html=l,g._proxy.$setHtml(o,l)}get html(){return this._html}get onDidReceiveMessage(){return a.event}postMessage(l){return g._proxy.$postMessage(o,l)}},y=new class{constructor(){this.editor=S,this.line=E,this.height=k,this.webview=f,this.onDidDispose=w.event}dispose(){g._insets.has(o)&&(g._insets.delete(o),g._proxy.$disposeEditorInset(o),w.fire(),w.dispose(),a.dispose())}};return this._proxy.$createEditorInset(o,d.id,d.value.document.uri,E+1,k,i||{},I.identifier,I.extensionLocation),this._insets.set(o,{editor:S,inset:y,onDidReceiveMessage:a}),y}$onDidDispose(S){const E=this._insets.get(S);E&&E.inset.dispose()}$onDidReceiveMessage(S,E){const k=this._insets.get(S);k&&k.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=T}),define(be[169],_e([0,1,3,64,140,4,6,22,29,14,52,23,35,161]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",d.Codicon.window,(0,D.localize)(0,null));var o;(function(u){u.ViewContainersRegistry="workbench.registry.view.containers",u.ViewsRegistry="workbench.registry.view"})(o=e.Extensions||(e.Extensions={}));var a;(function(u){u[u.Sidebar=0]="Sidebar",u[u.Panel=1]="Panel"})(a=e.ViewContainerLocation||(e.ViewContainerLocation={}));function w(u){switch(u){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=w;function f(u){return`viewContainer.${u}.enabled`}e.getEnabledViewContainerContextKey=f;class y extends _.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new p.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new p.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(v,b,P){var C;const c=this.get(v.id);if(c)return c;const F=v;return F.openCommandActionDescriptor=(P==null?void 0:P.donotRegisterOpenCommand)?void 0:(C=F.openCommandActionDescriptor)!==null&&C!==void 0?C:{id:F.id},(0,S.getOrSet)(this.viewContainers,b,[]).push(F),(P==null?void 0:P.isDefault)&&this.defaultViewContainers.push(F),this._onDidRegister.fire({viewContainer:F,viewContainerLocation:b}),F}deregisterViewContainer(v){for(const b of this.viewContainers.keys()){const P=this.viewContainers.get(b),C=P==null?void 0:P.indexOf(v);if(C!==-1){P==null||P.splice(C,1),P.length===0&&this.viewContainers.delete(b),this._onDidDeregister.fire({viewContainer:v,viewContainerLocation:b});return}}}get(v){return this.all.filter(b=>b.id===v)[0]}getViewContainers(v){return[...this.viewContainers.get(v)||[]]}getViewContainerLocation(v){return[...this.viewContainers.keys()].filter(b=>this.getViewContainers(b).filter(P=>(P==null?void 0:P.id)===v.id).length>0)[0]}getDefaultViewContainer(v){return this.defaultViewContainers.find(b=>this.getViewContainerLocation(b)===v)}}E.Registry.add(o.ViewContainersRegistry,new y);var l;(function(u){u.Open="2_open",u.Debug="4_debug",u.SCM="5_scm",u.More="9_more"})(l=e.ViewContentGroups||(e.ViewContentGroups={}));function m(u,v){var b,P,C,c;const F=(b=u.group)!==null&&b!==void 0?b:l.More,N=(P=v.group)!==null&&P!==void 0?P:l.More;return F!==N?F.localeCompare(N):((C=u.order)!==null&&C!==void 0?C:5)-((c=v.order)!==null&&c!==void 0?c:5)}class h extends _.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new p.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new p.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new p.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new p.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new i.SetMap}registerViews(v,b){this.registerViews2([{views:v,viewContainer:b}])}registerViews2(v){v.forEach(({views:b,viewContainer:P})=>this.addViews(b,P)),this._onViewsRegistered.fire(v)}deregisterViews(v,b){const P=this.removeViews(v,b);P.length&&this._onViewsDeregistered.fire({views:P,viewContainer:b})}moveViews(v,b){for(const P of this._views.keys())if(P!==b){const C=this.removeViews(v,P);C.length&&(this.addViews(C,b),this._onDidChangeContainer.fire({views:C,from:P,to:b}))}}getViews(v){return this._views.get(v)||[]}getView(v){for(const b of this._viewContainers){const P=(this._views.get(b)||[]).filter(C=>C.id===v)[0];if(P)return P}return null}getViewContainer(v){for(const b of this._viewContainers)if((this._views.get(b)||[]).filter(C=>C.id===v)[0])return b;return null}registerViewWelcomeContent(v,b){return this._viewWelcomeContents.add(v,b),this._onDidChangeViewWelcomeContent.fire(v),(0,_.toDisposable)(()=>{this._viewWelcomeContents.delete(v,b),this._onDidChangeViewWelcomeContent.fire(v)})}registerViewWelcomeContent2(v,b){const P=new Map;for(const[C,c]of b)this._viewWelcomeContents.add(v,c),P.set(C,(0,_.toDisposable)(()=>{this._viewWelcomeContents.delete(v,c),this._onDidChangeViewWelcomeContent.fire(v)}));return this._onDidChangeViewWelcomeContent.fire(v),P}getViewWelcomeContent(v){const b=[];return this._viewWelcomeContents.forEach(v,P=>b.push(P)),b.sort(m)}addViews(v,b){let P=this._views.get(b);P||(P=[],this._views.set(b,P),this._viewContainers.push(b));for(const C of v){if(this.getView(C.id)!==null)throw new Error((0,D.localize)(1,null,C.id));P.push(C)}}removeViews(v,b){const P=this._views.get(b);if(!P)return[];const C=[],c=[];for(const F of P)v.includes(F)?C.push(F):c.push(F);return C.length&&(c.length?this._views.set(b,c):(this._views.delete(b),this._viewContainers.splice(this._viewContainers.indexOf(b),1))),C}}E.Registry.add(o.ViewsRegistry,new h),e.IViewsService=(0,T.createDecorator)("viewsService"),e.FocusedViewContext=new R.RawContextKey("focusedView","",(0,D.localize)(2,null));function t(u){return`view.${u}.visible`}e.getVisbileViewContextKey=t,e.IViewDescriptorService=(0,T.createDecorator)("viewDescriptorService");var n;(function(u){u[u.Default=0]="Default",u[u.Expand=1]="Expand"})(n=e.ViewVisibilityState||(e.ViewVisibilityState={}));var r;(function(u){u[u.None=0]="None",u[u.Collapsed=1]="Collapsed",u[u.Expanded=2]="Expanded"})(r=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class s{constructor(v,b){this.resolved=!1,this._hasResolve=!1,(0,I.mixin)(this,v),this._hasResolve=!!b,this.resolve=async P=>{var C,c;if(b&&!this.resolved){const F=await b(P);F&&(this.tooltip=(C=this.tooltip)!==null&&C!==void 0?C:F.tooltip,this.command=(c=this.command)!==null&&c!==void 0?c:F.command)}P.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=s}),define(be[170],_e([0,1,2,150,162,17,151,169]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MoveViewsAPICommand=e.RemoveFromRecentlyOpenedAPICommand=e.NewWindowAPICommand=void 0;function E(o){return(a,...w)=>o(a.get(R.ICommandService),...w)}class k{static execute(a,w){const f={forceReuseWindow:w&&w.reuseWindow,remoteAuthority:w&&w.remoteAuthority};return a.executeCommand("_files.newWindow",f)}}e.NewWindowAPICommand=k,k.ID="vscode.newWindow",R.CommandsRegistry.registerCommand({id:k.ID,handler:E(k.execute),description:{description:"Opens an new window",args:[]}}),R.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",function(o,a){return o.get(D.IWorkspacesService).removeRecentlyOpened([a])});class i{static execute(a,w){return typeof w=="string"?w=w.match(/^[^:/?#]+:\/\//)?p.URI.parse(w):p.URI.file(w):w=p.URI.revive(w),a.executeCommand("_workbench.removeFromRecentlyOpened",w)}}e.RemoveFromRecentlyOpenedAPICommand=i,i.ID="vscode.removeFromRecentlyOpened",R.CommandsRegistry.registerCommand(i.ID,E(i.execute)),R.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",async function(o,a){const w=o.get(D.IWorkspacesService);let f;const y=a.uri,l=a.label,m=a.remoteAuthority;return a.type==="workspace"?f={workspace:await w.getWorkspaceIdentifier(y),label:l,remoteAuthority:m}:a.type==="folder"?f={folderUri:y,label:l,remoteAuthority:m}:f={fileUri:y,label:l,remoteAuthority:m},w.addRecentlyOpened([f])}),R.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",async function(o){return o.get(D.IWorkspacesService).getRecentlyOpened()}),R.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",function(o,a){const w=o.get(T.ILogService),f=o.get(_.IEnvironmentService);f.isExtensionDevelopment&&!!f.extensionTestsLocationURI&&w.setLevel(a)}),R.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",function(o){return o.get(T.ILogService).getLevel()}),R.CommandsRegistry.registerCommand("_workbench.action.moveViews",async function(o,a){const w=o.get(S.IViewDescriptorService),f=w.getViewContainerById(a.destinationId);if(!!f){for(const y of a.viewIds){const l=w.getViewDescriptorById(y);(l==null?void 0:l.canMoveView)&&w.moveViewsToContainer([l],f,S.ViewVisibilityState.Default)}await o.get(S.IViewsService).openViewContainer(f.id,!0)}});class I{static execute(a,w){return!Array.isArray(w==null?void 0:w.viewIds)||typeof(w==null?void 0:w.destinationId)!="string"?Promise.reject("Invalid arguments"):a.executeCommand("_workbench.action.moveViews",w)}}e.MoveViewsAPICommand=I,I.ID="vscode.moveViews",R.CommandsRegistry.registerCommand({id:I.ID,handler:E(I.execute),description:{description:"Move Views",args:[]}});class d{static execute(a,w){return a.executeCommand("_workbench.open",w)}}d.ID="vscode.open",R.CommandsRegistry.registerCommand(d.ID,E(d.execute));class g{static execute(a,w,f,y,l){return a.executeCommand("_workbench.diff",[w,f,y])}}g.ID="vscode.diff",R.CommandsRegistry.registerCommand(g.ID,E(g.execute))}),define(be[171],_e([0,1,3,11,141]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class T{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(S){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=S}onEvent(S){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=S}onRequest(S){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=S}sendResponse(S){S.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${S.command}`)):this.internalSend("response",S)}sendRequest(S,E,k,i){const I={command:S};if(E&&Object.keys(E).length>0&&(I.arguments=E),this.internalSend("request",I),typeof i=="number"){const d=setTimeout(()=>{clearTimeout(d);const g=this.pendingRequests.get(I.seq);if(g){this.pendingRequests.delete(I.seq);const o={type:"response",seq:0,request_seq:I.seq,success:!1,command:S,message:(0,D.localize)(0,null,i,S)};g(o)}},i)}return k&&this.pendingRequests.set(I.seq,k),I.seq}acceptMessage(S){this.messageCallback?this.messageCallback(S):(this.queue.push(S),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(S,E){return S.type!=="event"||E.type!=="event"}async processQueue(){let S;for(;this.queue.length;){if((!S||this.needsTaskBoundaryBetween(this.queue[0],S))&&await(0,R.timeout)(0),S=this.queue.shift(),!S)return;switch(S.type){case"event":this.eventCallback&&this.eventCallback(S);break;case"request":this.requestCallback&&this.requestCallback(S);break;case"response":const E=S,k=this.pendingRequests.get(E.request_seq);k&&(this.pendingRequests.delete(E.request_seq),k(E));break}}}internalSend(S,E){E.type=S,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const S=new Map;this.pendingRequests.forEach((E,k)=>S.set(k,E)),await(0,R.timeout)(500),S.forEach((E,k)=>{E({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=T}),define(be[172],_e([0,1,8,2,12,23,15]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const S=/{([^}]+)}/g;function E(n,r,s){return n.replace(S,function(u,v){return r&&v.length>0&&v[0]!=="_"?u:s&&s.hasOwnProperty(v)?s[v]:u})}e.formatPII=E;function k(n){const r={};for(const s of Object.keys(n))s.startsWith("!")||(r[s]=n[s]);return r}e.filterExceptionsFromTelemetry=k;function i(n){return n.configuration.request==="attach"&&!I(n)}e.isSessionAttach=i;function I(n){let r=n.configuration.type;if(!!r)return r==="vslsShare"&&(r=n.configuration.adapterProxy.configuration.type),(0,p.equalsIgnoreCase)(r,"extensionhost")||(0,p.equalsIgnoreCase)(r,"pwa-extensionhost")?n:n.parentSession?I(n.parentSession):void 0}e.getExtensionHostDebugSession=I;function d(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=d;function g(n,r,s){let u,v=0,b=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=b.exec(n);){let C=P.index+1,c=C+P[0].length;if(C<=r&&c>=s){u=P[0],v=C;break}}if(u){let C=/\w+/g,c=null;for(;(c=C.exec(u))&&!(c.index+1+v+c[0].length>=s););c&&(u=u.substring(0,C.lastIndex))}return u?{start:v,end:v+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const o=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function a(n){return!!(n&&n.match(o))}e.isUri=a;function w(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(a(n.path))return R.URI.parse(n.path);if((0,D.isAbsolute)(n.path))return R.URI.file(n.path)}return n.path}function f(n){if(typeof n.path=="object"){const r=R.URI.revive(n.path);if(r)return r.scheme===_.Schemas.file?r.fsPath:r.toString()}return n.path}function y(n,r){const s=r?w:f,u=(0,T.deepClone)(n);return m(u,(v,b)=>{v&&b&&(b.path=s(b))}),u}e.convertToDAPaths=y;function l(n,r){const s=r?w:f,u=(0,T.deepClone)(n);return m(u,(v,b)=>{!v&&b&&(b.path=s(b))}),u}e.convertToVSCPaths=l;function m(n,r){switch(n.type){case"event":const s=n;switch(s.event){case"output":r(!1,s.body.source);break;case"loadedSource":r(!1,s.body.source);break;case"breakpoint":r(!1,s.body.breakpoint.source);break;default:break}break;case"request":const u=n;switch(u.command){case"setBreakpoints":r(!0,u.arguments.source);break;case"breakpointLocations":r(!0,u.arguments.source);break;case"source":r(!0,u.arguments.source);break;case"gotoTargets":r(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(b=>r(!1,b));break;default:break}break;case"response":const v=n;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(b=>r(!1,b.source));break;case"loadedSources":v.body.sources.forEach(b=>r(!1,b));break;case"scopes":v.body.scopes.forEach(b=>r(!1,b.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(b=>r(!1,b.source));break;case"setBreakpoints":v.body.breakpoints.forEach(b=>r(!1,b.source));break;default:break}break}}function h(n){return n.filter(r=>{var s;return!((s=r.presentation)===null||s===void 0?void 0:s.hidden)}).sort((r,s)=>r.presentation?s.presentation?r.presentation.group?s.presentation.group?r.presentation.group!==s.presentation.group?r.presentation.group.localeCompare(s.presentation.group):t(r.presentation.order,s.presentation.order):-1:s.presentation.group?1:t(r.presentation.order,s.presentation.order):-1:s.presentation?1:0)}e.getVisibleAndSorted=h;function t(n,r){return typeof n!="number"?typeof r!="number"?0:1:typeof r!="number"?-1:n-r}}),define(be[50],_e([0,1,27,15,12,21,64]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarPosition=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBarAfterExecuteKey=e.ShowCellStatusBarKey=e.CellToolbarVisibility=e.CellToolbarLocKey=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var S;(function(C){C[C.Markup=1]="Markup",C[C.Code=2]="Code"})(S=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var E;(function(C){C[C.Running=1]="Running",C[C.Idle=2]="Idle"})(E=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var k;(function(C){C[C.Pending=2]="Pending",C[C.Executing=3]="Executing"})(k=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var i;(function(C){C[C.WithHardKernelDependency=0]="WithHardKernelDependency",C[C.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",C[C.Pure=2]="Pure",C[C.Never=3]="Never"})(i=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var I;(function(C){C[C.ModelChange=1]="ModelChange",C[C.Move=2]="Move",C[C.CellClearOutput=3]="CellClearOutput",C[C.CellsClearOutput=4]="CellsClearOutput",C[C.ChangeLanguage=5]="ChangeLanguage",C[C.Initialize=6]="Initialize",C[C.ChangeCellMetadata=7]="ChangeCellMetadata",C[C.Output=8]="Output",C[C.OutputItem=9]="OutputItem",C[C.ChangeCellContent=10]="ChangeCellContent",C[C.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",C[C.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",C[C.Unknown=100]="Unknown"})(I=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(C){C[C.Handle=0]="Handle",C[C.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var g;(function(C){C[C.Replace=1]="Replace",C[C.Output=2]="Output",C[C.Metadata=3]="Metadata",C[C.CellLanguage=4]="CellLanguage",C[C.DocumentMetadata=5]="DocumentMetadata",C[C.Move=6]="Move",C[C.OutputItems=7]="OutputItems",C[C.PartialMetadata=8]="PartialMetadata",C[C.PartialInternalMetadata=9]="PartialInternalMetadata"})(g=e.CellEditType||(e.CellEditType={}));function o(C,c){if(c)return C.toString();const F=a.parse(C);return F?F.notebook.toString():C.toString()}e.getCellUndoRedoComparisonKey=o;var a;(function(C){C.scheme=R.Schemas.vscodeNotebookCell;const c=/^ch(\d{7,})/;function F(Q,W){return Q.with({scheme:C.scheme,fragment:`ch${W.toString().padStart(7,"0")}${Q.scheme!==R.Schemas.file?Q.scheme:""}`})}C.generate=F;function N(Q){if(Q.scheme!==C.scheme)return;const W=c.exec(Q.fragment);return W?{handle:Number(W[1]),notebook:Q.with({scheme:Q.fragment.substr(W[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parse=N;function z(Q){if(Q.scheme!==R.Schemas.vscodeNotebookCellMetadata)return;const W=c.exec(Q.fragment);return W?{handle:Number(W[1]),notebook:Q.with({scheme:Q.fragment.substr(W[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parseCellMetadataUri=z;function he(Q,W,x){return Q.with({scheme:x,fragment:`ch${W.toString().padStart(7,"0")}${Q.scheme!==R.Schemas.file?Q.scheme:""}`})}C.generateCellUri=he;function me(Q,W){if(Q.scheme!==W)return;const x=c.exec(Q.fragment);return x?{handle:Number(x[1]),notebook:Q.with({scheme:Q.fragment.substr(x[0].length)||R.Schemas.file,fragment:null})}:void 0}C.parseCellUri=me})(a=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function f(C){var c,F;return(F=(c=w.get(C))===null||c===void 0?void 0:c.alwaysSecure)!==null&&F!==void 0?F:!1}e.mimeTypeIsAlwaysSecure=f;function y(C){var c,F;return(F=(c=w.get(C))===null||c===void 0?void 0:c.supportedByCore)!==null&&F!==void 0?F:!1}e.mimeTypeSupportedByCore=y;function l(C){var c,F;return(F=(c=w.get(C))===null||c===void 0?void 0:c.mergeable)!==null&&F!==void 0?F:!1}e.mimeTypeIsMergeable=l;function m(C,c){return T.isWindows&&(C=C.replace(/\//g,"\\"),c=c.replace(/\//g,"\\")),p.match(C,c)}function h(C,c,F){let N=0;for(let z=0;z<c.length;z++){if(m(c[z],C))return N;N++}for(let z=0;z<F.length;z++){if(m(F[z],C))return N;N++}return N}function t(C,c,F){return C.sort((N,z)=>h(N,c,F)-h(z,c,F))}e.sortMimeTypes=t;function n(C,c,F,N=(z,he)=>z===he){const z=[];function he(W,x,A){if(x===0&&A.length===0)return;const U=z[z.length-1];U&&U.start+U.deleteCount===W?(U.deleteCount+=x,U.toInsert.push(...A)):z.push({start:W,deleteCount:x,toInsert:A})}let me=0,Q=0;for(;;){if(me===C.length){he(me,0,c.slice(Q));break}if(Q===c.length){he(me,C.length-me,[]);break}const W=C[me],x=c[Q];if(N(W,x)){me+=1,Q+=1;continue}F(x)?(he(me,1,[]),me+=1):(he(me,0,[x]),Q+=1)}return z}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new _.RawContextKey("notebookEditorCursorAtBoundary","none");var r;(function(C){C.default="default",C.option="option"})(r=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(C){const c=C;return!!((typeof c.include=="string"||p.isRelativePattern(c.include))&&(typeof c.exclude=="string"||p.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=s;function u(C,c,F){if(Array.isArray(C.viewType)&&C.viewType.indexOf(c)>=0||C.viewType===c)return!0;if(C.filenamePattern){let N=s(C.filenamePattern)?C.filenamePattern.include:C.filenamePattern,z=s(C.filenamePattern)?C.filenamePattern.exclude:void 0;if(p.match(N,(0,D.basename)(F.fsPath).toLowerCase()))return!(z&&p.match(z,(0,D.basename)(F.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=u;class v{constructor(c){this.textModel=c}getElements(){const c=new Int32Array(this.textModel.cells.length);for(let F=0;F<this.textModel.cells.length;F++)c[F]=this.textModel.cells[F].getHashValue();return c}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocKey="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBarKey="notebook.showCellStatusBar",e.ShowCellStatusBarAfterExecuteKey="notebook.showCellStatusBarAfterExecute",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarPosition="notebook.insertToolbarPosition",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations";var b;(function(C){C[C.Left=1]="Left",C[C.Right=2]="Right"})(b=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(c){return`${P._prefix}${c}`}static parse(c){if(c.startsWith(P._prefix))return c.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(be[173],_e([0,1,143,4,64]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new D.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new D.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new D.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=(0,R.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[174],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=p;function R(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=R}),define(be[97],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var p;(function(E){E[E.NotExpandable=0]="NotExpandable",E[E.Expandable=1]="Expandable",E[E.BusyExpanding=2]="BusyExpanding",E[E.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(E,k)=>{k.expand!==void 0&&(E.expand=k.expand),k.item!==void 0&&(E.item=E.item?Object.assign(E.item,k.item):k.item)};e.applyTestItemUpdate=R;var D;(function(E){E[E.Add=0]="Add",E[E.Update=1]="Update",E[E.Remove=2]="Remove",E[E.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",E[E.Retire=4]="Retire"})(D=e.TestDiffOpType||(e.TestDiffOpType={}));const T=(E,k)=>`${E}:${k.toString()}`;e.getTestSubscriptionKey=T;class _{add(k){}update(k){}remove(k,i){}complete(){}}e.IncrementalChangeCollector=_;class S{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(k){const i=this.createChangeCollector();for(const I of k)switch(I[0]){case 0:{const d=I[1];if(d.parent){if(this.items.has(d.parent)){const g=this.items.get(d.parent);g.children.add(d.item.extId);const o=this.createItem(d,g);this.items.set(d.item.extId,o),i.add(o)}}else{this.roots.add(d.item.extId);const g=this.createItem(d);this.items.set(d.item.extId,g),i.add(g)}d.expand===2&&this.busyControllerCount++;break}case 1:{const d=I[1],g=this.items.get(d.extId);if(!g)break;d.expand!==void 0&&(g.expand===2&&this.busyControllerCount--,d.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(g,d),i.update(g);break}case 2:{const d=this.items.get(I[1]);if(!d)break;d.parent?this.items.get(d.parent).children.delete(d.item.extId):this.roots.delete(d.item.extId);const g=[[I[1]]];for(;g.length;)for(const o of g.pop()){const a=this.items.get(o);a&&(g.push(a.children),this.items.delete(o),i.remove(a,a!==d),a.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}i.complete()}retireTest(k){}updatePendingRoots(k){this.pendingRootCount+=k}createChangeCollector(){return new _}}e.AbstractIncrementalTestCollection=S}),define(be[175],_e([0,1,12,46,9,23,21,59,144]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(I,d,g){this._contributedVariables=new Map,this._context=I,this._labelService=d,g&&(this._envVariablesPromise=g.then(o=>this.prepareEnv(o)))}prepareEnv(I){if(_.isWindows){const d=Object.create(null);return Object.keys(I).forEach(g=>{d[g.toLowerCase()]=I[g]}),d}return I}resolveWithEnvironment(I,d,g){return this.recursiveResolve(this.prepareEnv(I),d?d.uri:void 0,g)}async resolveAsync(I,d){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,d)}async resolveAnyBase(I,d,g,o){const a=T.deepClone(d);return _.isWindows&&a.windows?Object.keys(a.windows).forEach(w=>a[w]=a.windows[w]):_.isMacintosh&&a.osx?Object.keys(a.osx).forEach(w=>a[w]=a.osx[w]):_.isLinux&&a.linux&&Object.keys(a.linux).forEach(w=>a[w]=a.linux[w]),delete a.windows,delete a.osx,delete a.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,a,g,o)}async resolveAnyAsync(I,d,g){return this.resolveAnyBase(I,d,g)}async resolveAnyMap(I,d,g){const o=new Map;return{newConfig:await this.resolveAnyBase(I,d,g,o),resolvedVariables:o}}resolveWithInteractionReplace(I,d,g,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,d,g,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,d){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,d)}recursiveResolve(I,d,g,o,a){if(D.isString(g))return this.resolveString(I,d,g,o,a);if(D.isArray(g))return g.map(w=>this.recursiveResolve(I,d,w,o,a));if(D.isObject(g)){let w=Object.create(null);return Object.keys(g).forEach(f=>{const y=this.resolveString(I,d,f,o,a);w[y]=this.recursiveResolve(I,d,g[f],o,a)}),w}return g}resolveString(I,d,g,o,a){return g.replace(k.VARIABLE_REGEXP,(f,y)=>{if(y.includes(k.VARIABLE_LHS))return f;let l=this.evaluateSingleVariable(I,f,y,d,o);return a&&a.set(y,l),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,d,g,o,a){let w;const f=g.split(":");f.length>1&&(g=f[0],w=f[1]);const y=()=>{const h=this._context.getFilePath();if(h)return h;throw new Error((0,E.localize)(0,null,d))},l=()=>{const h=y();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error((0,E.localize)(1,null,d,p.basename(h)))},m=()=>{if(w){const h=this._context.getFolderUri(w);if(h)return h;throw new Error((0,E.localize)(2,null,d,w))}if(o)return o;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,d)):new Error((0,E.localize)(4,null,d))};switch(g){case"env":if(w){if(I){const h=I[_.isWindows?w.toLowerCase():w];if(D.isString(h))return h}return""}throw new Error((0,E.localize)(5,null,d));case"config":if(w){const h=this._context.getConfigurationValue(o,w);if(D.isUndefinedOrNull(h))throw new Error((0,E.localize)(6,null,d,w));if(D.isObject(h))throw new Error((0,E.localize)(7,null,d,w));return h}throw new Error((0,E.localize)(8,null,d));case"command":return this.resolveFromMap(d,w,a,"command");case"input":return this.resolveFromMap(d,w,a,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,S.normalizeDriveLetter)(this.fsPath(m()));case"cwd":return o||w?(0,S.normalizeDriveLetter)(this.fsPath(m())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(m()));case"lineNumber":const h=this._context.getLineNumber();if(h)return h;throw new Error((0,E.localize)(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error((0,E.localize)(10,null,d));case"file":return y();case"fileWorkspaceFolder":return l();case"relativeFile":return o||w?p.relative(this.fsPath(m()),y()):y();case"relativeFileDirname":const n=p.dirname(y());if(o||w){const v=p.relative(this.fsPath(m()),n);return v.length===0?".":v}return n;case"fileDirname":return p.dirname(y());case"fileExtname":return p.extname(y());case"fileBasename":return p.basename(y());case"fileBasenameNoExtension":const r=p.basename(y());return r.slice(0,r.length-p.extname(r).length);case"fileDirnameBasename":return p.basename(p.dirname(y()));case"execPath":const s=this._context.getExecPath();return s||d;case"execInstallFolder":const u=this._context.getAppRoot();return u||d;case"pathSeparator":return p.sep;default:try{const v=w?`${g}:${w}`:g;return this.resolveFromMap(d,v,a,void 0)}catch(v){return d}}}}resolveFromMap(I,d,g,o){if(d&&g){const a=o===void 0?g[d]:g[o+":"+d];if(typeof a=="string")return a;throw new Error((0,E.localize)(11,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[176],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,p.createDecorator)("editorGroupsService");var R;(function(d){d[d.UP=0]="UP",d[d.DOWN=1]="DOWN",d[d.LEFT=2]="LEFT",d[d.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var D;(function(d){d[d.HORIZONTAL=0]="HORIZONTAL",d[d.VERTICAL=1]="VERTICAL"})(D=e.GroupOrientation||(e.GroupOrientation={}));var T;(function(d){d[d.FIRST=0]="FIRST",d[d.LAST=1]="LAST",d[d.NEXT=2]="NEXT",d[d.PREVIOUS=3]="PREVIOUS"})(T=e.GroupLocation||(e.GroupLocation={}));var _;(function(d){d[d.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",d[d.EVEN=1]="EVEN",d[d.TOGGLE=2]="TOGGLE"})(_=e.GroupsArrangement||(e.GroupsArrangement={}));var S;(function(d){d[d.COPY_EDITORS=0]="COPY_EDITORS",d[d.MOVE_EDITORS=1]="MOVE_EDITORS"})(S=e.MergeGroupMode||(e.MergeGroupMode={}));var E;(function(d){d[d.CREATION_TIME=0]="CREATION_TIME",d[d.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",d[d.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(E=e.GroupsOrder||(e.GroupsOrder={}));var k;(function(d){d[d.GROUP_ACTIVE=0]="GROUP_ACTIVE",d[d.GROUP_INDEX=1]="GROUP_INDEX",d[d.EDITOR_OPEN=2]="EDITOR_OPEN",d[d.EDITOR_CLOSE=3]="EDITOR_CLOSE",d[d.EDITOR_MOVE=4]="EDITOR_MOVE",d[d.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",d[d.EDITOR_LABEL=6]="EDITOR_LABEL",d[d.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",d[d.EDITOR_PIN=8]="EDITOR_PIN",d[d.EDITOR_STICKY=9]="EDITOR_STICKY",d[d.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(k=e.GroupChangeKind||(e.GroupChangeKind={}));var i;(function(d){d[d.NEW_EDITOR=1]="NEW_EDITOR",d[d.MOVE_EDITOR=2]="MOVE_EDITOR",d[d.COPY_EDITOR=3]="COPY_EDITOR"})(i=e.OpenEditorContext||(e.OpenEditorContext={}));function I(d){return d.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(be[177],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,p.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(be[10],_e([0,1,14,83,231,58,23,9,2,31,63,145,90,50,177,7]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookDocumentMetadata=e.NotebookCellMetadata=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var w;(function(ve){function ce(q){const{selectionStartLineNumber:Fe,selectionStartColumn:Pe,positionLineNumber:Ze,positionColumn:et}=q,ft=new a.Position(Fe-1,Pe-1),ut=new a.Position(Ze-1,et-1);return new a.Selection(ft,ut)}ve.to=ce;function le(q){const{anchor:Fe,active:Pe}=q;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Pe.line+1,positionColumn:Pe.character+1}}ve.from=le})(w=e.Selection||(e.Selection={}));var f;(function(ve){function ce(q){if(!q)return;const{start:Fe,end:Pe}=q;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Pe.line+1,endColumn:Pe.character+1}}ve.from=ce;function le(q){if(!q)return;const{startLineNumber:Fe,startColumn:Pe,endLineNumber:Ze,endColumn:et}=q;return new a.Range(Fe-1,Pe-1,Ze-1,et-1)}ve.to=le})(f=e.Range||(e.Range={}));var y;(function(ve){function ce(le){switch(le){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 4:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}ve.to=ce})(y=e.TokenType||(e.TokenType={}));var l;(function(ve){function ce(q){return new a.Position(q.lineNumber-1,q.column-1)}ve.to=ce;function le(q){return{lineNumber:q.line+1,column:q.character+1}}ve.from=le})(l=e.Position||(e.Position={}));var m;(function(ve){function ce(q){switch(q){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}ve.from=ce;function le(q){switch(q){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}ve.to=le})(m=e.DiagnosticTag||(e.DiagnosticTag={}));var h;(function(ve){function ce(q){let Fe;return q.code&&((0,S.isString)(q.code)||(0,S.isNumber)(q.code)?Fe=String(q.code):Fe={value:String(q.code.value),target:q.code.target}),Object.assign(Object.assign({},f.from(q.range)),{message:q.message,source:q.source,code:Fe,severity:n.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(t.from),tags:Array.isArray(q.tags)?(0,p.coalesce)(q.tags.map(m.from)):void 0})}ve.from=ce;function le(q){var Fe;const Pe=new a.Diagnostic(f.to(q),q.message,n.to(q.severity));return Pe.source=q.source,Pe.code=(0,S.isString)(q.code)?q.code:(Fe=q.code)===null||Fe===void 0?void 0:Fe.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(t.to),Pe.tags=q.tags&&(0,p.coalesce)(q.tags.map(m.to)),Pe}ve.to=le})(h=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function ce(q){return Object.assign(Object.assign({},f.from(q.location.range)),{message:q.message,resource:q.location.uri})}ve.from=ce;function le(q){return new a.DiagnosticRelatedInformation(new a.Location(q.resource,f.to(q)),q.message)}ve.to=le})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var n;(function(ve){function ce(q){switch(q){case a.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}ve.from=ce;function le(q){switch(q){case d.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}ve.to=le})(n=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var r;(function(ve){function ce(q){return typeof q=="number"&&q>=a.ViewColumn.One?q-1:q===a.ViewColumn.Beside?o.SIDE_GROUP:o.ACTIVE_GROUP}ve.from=ce;function le(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=le})(r=e.ViewColumn||(e.ViewColumn={}));function s(ve){return typeof ve.range!="undefined"}function u(ve){return ve.length===0?!0:!!s(ve[0])}e.isDecorationOptionsArr=u;var v;(function(ve){function ce(et){return et.map(ve.from)}ve.fromMany=ce;function le(et){return et&&typeof et=="object"&&typeof et.language=="string"&&typeof et.value=="string"}function q(et){let ft;if(le(et)){const{language:ht,value:lt}=et;ft={value:"```"+ht+`
`+lt+"\n```\n"}}else a.MarkdownString.isMarkdownString(et)?ft={value:et.value,isTrusted:et.isTrusted,supportThemeIcons:et.supportThemeIcons}:typeof et=="string"?ft={value:et}:ft={value:""};const ut=Object.create(null);ft.uris=ut;const it=ht=>{try{let lt=E.URI.parse(ht,!0);lt=lt.with({query:Fe(lt.query,ut)}),ut[ht]=lt}catch(lt){}return""},vt=new D.Renderer;return vt.link=it,vt.image=ht=>it(R.parseHrefAndDimensions(ht).href),D(ft.value,{renderer:vt}),ft}ve.from=q;function Fe(et,ft){if(!et)return et;let ut;try{ut=(0,T.parse)(et)}catch(vt){}if(!ut)return et;let it=!1;return ut=(0,_.cloneAndChange)(ut,vt=>{if(E.URI.isUri(vt)){const ht=`__uri_${Math.random().toString(16).slice(2,8)}`;return ft[ht]=vt,it=!0,ht}else return}),it?JSON.stringify(ut):et}function Pe(et){const ft=new a.MarkdownString(et.value,et.supportThemeIcons);return ft.isTrusted=et.isTrusted,ft}ve.to=Pe;function Ze(et){if(!!et)return typeof et=="string"?et:ve.from(et)}ve.fromStrict=Ze})(v=e.MarkdownString||(e.MarkdownString={}));function b(ve){return u(ve)?ve.map(ce=>({range:f.from(ce.range),hoverMessage:Array.isArray(ce.hoverMessage)?v.fromMany(ce.hoverMessage):ce.hoverMessage?v.from(ce.hoverMessage):void 0,renderOptions:ce.renderOptions})):ve.map(ce=>({range:f.from(ce)}))}e.fromRangeOrRangeWithMessage=b;function P(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?E.URI.file(ve):ve}e.pathOrURIToURI=P;var C;(function(ve){function ce(le){return typeof le=="undefined"?le:{contentText:le.contentText,contentIconPath:le.contentIconPath?P(le.contentIconPath):void 0,border:le.border,borderColor:le.borderColor,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,color:le.color,backgroundColor:le.backgroundColor,margin:le.margin,width:le.width,height:le.height}}ve.from=ce})(C=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var c;(function(ve){function ce(le){return typeof le=="undefined"?le:{backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?P(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?C.from(le.before):void 0,after:le.after?C.from(le.after):void 0}}ve.from=ce})(c=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(ve){function ce(le){if(typeof le=="undefined")return le;switch(le){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=ce})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var N;(function(ve){function ce(le){return{isWholeLine:le.isWholeLine,rangeBehavior:le.rangeBehavior?F.from(le.rangeBehavior):void 0,overviewRulerLane:le.overviewRulerLane,light:le.light?c.from(le.light):void 0,dark:le.dark?c.from(le.dark):void 0,backgroundColor:le.backgroundColor,outline:le.outline,outlineColor:le.outlineColor,outlineStyle:le.outlineStyle,outlineWidth:le.outlineWidth,border:le.border,borderColor:le.borderColor,borderRadius:le.borderRadius,borderSpacing:le.borderSpacing,borderStyle:le.borderStyle,borderWidth:le.borderWidth,fontStyle:le.fontStyle,fontWeight:le.fontWeight,textDecoration:le.textDecoration,cursor:le.cursor,color:le.color,opacity:le.opacity,letterSpacing:le.letterSpacing,gutterIconPath:le.gutterIconPath?P(le.gutterIconPath):void 0,gutterIconSize:le.gutterIconSize,overviewRulerColor:le.overviewRulerColor,before:le.before?C.from(le.before):void 0,after:le.after?C.from(le.after):void 0}}ve.from=ce})(N=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var z;(function(ve){function ce(q){return{text:q.newText,eol:q.newEol&&te.from(q.newEol),range:f.from(q.range)}}ve.from=ce;function le(q){const Fe=new a.TextEdit(f.to(q.range),q.text);return Fe.newEol=typeof q.eol=="undefined"?void 0:te.to(q.eol),Fe}ve.to=le})(z=e.TextEdit||(e.TextEdit={}));var he;(function(ve){function ce(q,Fe,Pe){var Ze,et,ft;const ut={edits:[]};if(q instanceof a.WorkspaceEdit)for(let it of q._allEntries())if(it._type===1)ut.edits.push({_type:1,oldUri:it.from,newUri:it.to,options:it.options,metadata:it.metadata});else if(it._type===2){const vt=Fe==null?void 0:Fe.getDocument(it.uri);ut.edits.push({_type:2,resource:it.uri,edit:z.from(it.edit),modelVersionId:vt==null?void 0:vt.version,metadata:it.metadata})}else it._type===3?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:it.edit,notebookMetadata:it.notebookMetadata,notebookVersionId:(Ze=Pe==null?void 0:Pe.getNotebookDocument(it.uri,!0))===null||Ze===void 0?void 0:Ze.apiNotebook.version}):it._type===4?(it.newOutputs&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:2,index:it.index,append:it.append,outputs:it.newOutputs.map(ke.from)}}),it.newMetadata&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:8,index:it.index,metadata:it.newMetadata}})):it._type===5?ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,notebookVersionId:(et=Pe==null?void 0:Pe.getNotebookDocument(it.uri,!0))===null||et===void 0?void 0:et.apiNotebook.version,edit:{editType:1,index:it.index,count:it.count,cells:it.cells.map(oe.from)}}):it._type===6&&ut.edits.push({_type:3,metadata:it.metadata,resource:it.uri,edit:{editType:7,outputId:it.outputId,items:((ft=it.newOutputItems)===null||ft===void 0?void 0:ft.map(Ce.from))||[],append:it.append}});return ut}ve.from=ce;function le(q){const Fe=new a.WorkspaceEdit;for(const Pe of q.edits)Pe.edit?Fe.replace(E.URI.revive(Pe.resource),f.to(Pe.edit.range),Pe.edit.text):Fe.renameFile(E.URI.revive(Pe.oldUri),E.URI.revive(Pe.newUri),Pe.options);return Fe}ve.to=le})(he=e.WorkspaceEdit||(e.WorkspaceEdit={}));var me;(function(ve){const ce=Object.create(null);ce[a.SymbolKind.File]=0,ce[a.SymbolKind.Module]=1,ce[a.SymbolKind.Namespace]=2,ce[a.SymbolKind.Package]=3,ce[a.SymbolKind.Class]=4,ce[a.SymbolKind.Method]=5,ce[a.SymbolKind.Property]=6,ce[a.SymbolKind.Field]=7,ce[a.SymbolKind.Constructor]=8,ce[a.SymbolKind.Enum]=9,ce[a.SymbolKind.Interface]=10,ce[a.SymbolKind.Function]=11,ce[a.SymbolKind.Variable]=12,ce[a.SymbolKind.Constant]=13,ce[a.SymbolKind.String]=14,ce[a.SymbolKind.Number]=15,ce[a.SymbolKind.Boolean]=16,ce[a.SymbolKind.Array]=17,ce[a.SymbolKind.Object]=18,ce[a.SymbolKind.Key]=19,ce[a.SymbolKind.Null]=20,ce[a.SymbolKind.EnumMember]=21,ce[a.SymbolKind.Struct]=22,ce[a.SymbolKind.Event]=23,ce[a.SymbolKind.Operator]=24,ce[a.SymbolKind.TypeParameter]=25;function le(Fe){return typeof ce[Fe]=="number"?ce[Fe]:6}ve.from=le;function q(Fe){for(const Pe in ce)if(ce[Pe]===Fe)return Number(Pe);return a.SymbolKind.Property}ve.to=q})(me=e.SymbolKind||(e.SymbolKind={}));var Q;(function(ve){function ce(q){switch(q){case a.SymbolTag.Deprecated:return 1}}ve.from=ce;function le(q){switch(q){case 1:return a.SymbolTag.Deprecated}}ve.to=le})(Q=e.SymbolTag||(e.SymbolTag={}));var W;(function(ve){function ce(q){return{name:q.name,kind:me.from(q.kind),tags:q.tags&&q.tags.map(Q.from),containerName:q.containerName,location:$.from(q.location)}}ve.from=ce;function le(q){const Fe=new a.SymbolInformation(q.name,me.to(q.kind),q.containerName,$.to(q.location));return Fe.tags=q.tags&&q.tags.map(Q.to),Fe}ve.to=le})(W=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var x;(function(ve){function ce(q){var Fe,Pe;const Ze={name:q.name||"!!MISSING: name!!",detail:q.detail,range:f.from(q.range),selectionRange:f.from(q.selectionRange),kind:me.from(q.kind),tags:(Pe=(Fe=q.tags)===null||Fe===void 0?void 0:Fe.map(Q.from))!==null&&Pe!==void 0?Pe:[]};return q.children&&(Ze.children=q.children.map(ce)),Ze}ve.from=ce;function le(q){const Fe=new a.DocumentSymbol(q.name,q.detail,me.to(q.kind),f.to(q.range),f.to(q.selectionRange));return(0,p.isNonEmptyArray)(q.tags)&&(Fe.tags=q.tags.map(Q.to)),q.children&&(Fe.children=q.children.map(le)),Fe}ve.to=le})(x=e.DocumentSymbol||(e.DocumentSymbol={}));var A;(function(ve){function ce(le){const q=new a.CallHierarchyItem(me.to(le.kind),le.name,le.detail||"",E.URI.revive(le.uri),f.to(le.range),f.to(le.selectionRange));return q._sessionId=le._sessionId,q._itemId=le._itemId,q}ve.to=ce})(A=e.CallHierarchyItem||(e.CallHierarchyItem={}));var U;(function(ve){function ce(le){return new a.CallHierarchyIncomingCall(A.to(le.from),le.fromRanges.map(q=>f.to(q)))}ve.to=ce})(U=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var M;(function(ve){function ce(le){return new a.CallHierarchyOutgoingCall(A.to(le.to),le.fromRanges.map(q=>f.to(q)))}ve.to=ce})(M=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var $;(function(ve){function ce(q){return{range:q.range&&f.from(q.range),uri:q.uri}}ve.from=ce;function le(q){return new a.Location(E.URI.revive(q.uri),f.to(q.range))}ve.to=le})($=e.location||(e.location={}));var K;(function(ve){function ce(q){const Fe=q,Pe=q;return{originSelectionRange:Fe.originSelectionRange?f.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Pe.uri,range:f.from(Fe.targetRange?Fe.targetRange:Pe.range),targetSelectionRange:Fe.targetSelectionRange?f.from(Fe.targetSelectionRange):void 0}}ve.from=ce;function le(q){return{targetUri:E.URI.revive(q.uri),targetRange:f.to(q.range),targetSelectionRange:q.targetSelectionRange?f.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?f.to(q.originSelectionRange):void 0}}ve.to=le})(K=e.DefinitionLink||(e.DefinitionLink={}));var j;(function(ve){function ce(q){return{range:f.from(q.range),contents:v.fromMany(q.contents)}}ve.from=ce;function le(q){return new a.Hover(q.contents.map(v.to),f.to(q.range))}ve.to=le})(j=e.Hover||(e.Hover={}));var ae;(function(ve){function ce(q){return{range:f.from(q.range),expression:q.expression}}ve.from=ce;function le(q){return new a.EvaluatableExpression(f.to(q.range),q.expression)}ve.to=le})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var we;(function(ve){function ce(q){if(q instanceof a.InlineValueText)return{type:"text",range:f.from(q.range),text:q.text};if(q instanceof a.InlineValueVariableLookup)return{type:"variable",range:f.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:f.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=ce;function le(q){switch(q.type){case"text":return{range:f.to(q.range),text:q.text};case"variable":return{range:f.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:f.to(q.range),expression:q.expression}}}ve.to=le})(we=e.InlineValue||(e.InlineValue={}));var Re;(function(ve){function ce(q){return{frameId:q.frameId,stoppedLocation:f.from(q.stoppedLocation)}}ve.from=ce;function le(q){return new a.InlineValueContext(q.frameId,f.to(q.stoppedLocation))}ve.to=le})(Re=e.InlineValueContext||(e.InlineValueContext={}));var xe;(function(ve){function ce(q){return{range:f.from(q.range),kind:q.kind}}ve.from=ce;function le(q){return new a.DocumentHighlight(f.to(q.range),q.kind)}ve.to=le})(xe=e.DocumentHighlight||(e.DocumentHighlight={}));var Le;(function(ve){function ce(le){switch(le){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}ve.to=ce})(Le=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ve;(function(ve){function ce(le){return{triggerKind:Le.to(le.triggerKind),triggerCharacter:le.triggerCharacter}}ve.to=ce})(Ve=e.CompletionContext||(e.CompletionContext={}));var Qe;(function(ve){function ce(q){switch(q){case a.CompletionItemTag.Deprecated:return 1}}ve.from=ce;function le(q){switch(q){case 1:return a.CompletionItemTag.Deprecated}}ve.to=le})(Qe=e.CompletionItemTag||(e.CompletionItemTag={}));var Ke;(function(ve){const ce=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function le(Pe){var Ze;return(Ze=ce.get(Pe))!==null&&Ze!==void 0?Ze:9}ve.from=le;const q=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(Pe){var Ze;return(Ze=q.get(Pe))!==null&&Ze!==void 0?Ze:a.CompletionItemKind.Property}ve.to=Fe})(Ke=e.CompletionItemKind||(e.CompletionItemKind={}));var Ge;(function(ve){function ce(le,q){var Fe;const Pe=new a.CompletionItem(typeof le.label=="string"?le.label:le.label.name);return typeof le.label!="string"&&(Pe.label2=le.label),Pe.insertText=le.insertText,Pe.kind=Ke.to(le.kind),Pe.tags=(Fe=le.tags)===null||Fe===void 0?void 0:Fe.map(Qe.to),Pe.detail=le.detail,Pe.documentation=R.isMarkdownString(le.documentation)?v.to(le.documentation):le.documentation,Pe.sortText=le.sortText,Pe.filterText=le.filterText,Pe.preselect=le.preselect,Pe.commitCharacters=le.commitCharacters,k.Range.isIRange(le.range)?Pe.range=f.to(le.range):typeof le.range=="object"&&(Pe.range={inserting:f.to(le.range.insert),replacing:f.to(le.range.replace)}),Pe.keepWhitespace=typeof le.insertTextRules=="undefined"?!1:Boolean(le.insertTextRules&1),typeof le.insertTextRules!="undefined"&&le.insertTextRules&4?Pe.insertText=new a.SnippetString(le.insertText):(Pe.insertText=le.insertText,Pe.textEdit=Pe.range instanceof a.Range?new a.TextEdit(Pe.range,Pe.insertText):void 0),le.additionalTextEdits&&le.additionalTextEdits.length>0&&(Pe.additionalTextEdits=le.additionalTextEdits.map(Ze=>z.to(Ze))),Pe.command=q&&le.command?q.fromInternal(le.command):void 0,Pe}ve.to=ce})(Ge=e.CompletionItem||(e.CompletionItem={}));var H;(function(ve){function ce(q){return{label:q.label,documentation:q.documentation?v.fromStrict(q.documentation):void 0}}ve.from=ce;function le(q){return{label:q.label,documentation:R.isMarkdownString(q.documentation)?v.to(q.documentation):q.documentation}}ve.to=le})(H=e.ParameterInformation||(e.ParameterInformation={}));var Y;(function(ve){function ce(q){return{label:q.label,documentation:q.documentation?v.fromStrict(q.documentation):void 0,parameters:Array.isArray(q.parameters)?q.parameters.map(H.from):[],activeParameter:q.activeParameter}}ve.from=ce;function le(q){return{label:q.label,documentation:R.isMarkdownString(q.documentation)?v.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(H.to):[],activeParameter:q.activeParameter}}ve.to=le})(Y=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(ve){function ce(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.from):[]}}ve.from=ce;function le(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(Y.to):[]}}ve.to=le})(ne=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(ve){function ce(q){var Fe;return{text:q.text,position:l.from(q.position),kind:G.from((Fe=q.kind)!==null&&Fe!==void 0?Fe:a.InlayHintKind.Other),whitespaceBefore:q.whitespaceBefore,whitespaceAfter:q.whitespaceAfter}}ve.from=ce;function le(q){const Fe=new a.InlayHint(q.text,l.to(q.position),G.to(q.kind));return Fe.whitespaceAfter=q.whitespaceAfter,Fe.whitespaceBefore=q.whitespaceBefore,Fe}ve.to=le})(re=e.InlayHint||(e.InlayHint={}));var G;(function(ve){function ce(q){return q}ve.from=ce;function le(q){return q}ve.to=le})(G=e.InlayHintKind||(e.InlayHintKind={}));var se;(function(ve){function ce(q){return{range:f.from(q.range),url:q.target,tooltip:q.tooltip}}ve.from=ce;function le(q){let Fe;if(q.url)try{Fe=typeof q.url=="string"?E.URI.parse(q.url,!0):E.URI.revive(q.url)}catch(Pe){}return new a.DocumentLink(f.to(q.range),Fe)}ve.to=le})(se=e.DocumentLink||(e.DocumentLink={}));var fe;(function(ve){function ce(q){const Fe=new a.ColorPresentation(q.label);return q.textEdit&&(Fe.textEdit=z.to(q.textEdit)),q.additionalTextEdits&&(Fe.additionalTextEdits=q.additionalTextEdits.map(Pe=>z.to(Pe))),Fe}ve.to=ce;function le(q){return{label:q.label,textEdit:q.textEdit?z.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Fe=>z.from(Fe)):void 0}}ve.from=le})(fe=e.ColorPresentation||(e.ColorPresentation={}));var Ae;(function(ve){function ce(q){return new a.Color(q[0],q[1],q[2],q[3])}ve.to=ce;function le(q){return[q.red,q.green,q.blue,q.alpha]}ve.from=le})(Ae=e.Color||(e.Color={}));var ge;(function(ve){function ce(q){return{range:f.from(q.range)}}ve.from=ce;function le(q){return new a.SelectionRange(f.to(q.range))}ve.to=le})(ge=e.SelectionRange||(e.SelectionRange={}));var We;(function(ve){function ce(le){switch(le){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}ve.to=ce})(We=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var V;(function(ve){function ce(q){switch(q){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=ce;function le(q){switch(q){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}ve.to=le})(V=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var te;(function(ve){function ce(q){if(q===a.EndOfLine.CRLF)return 1;if(q===a.EndOfLine.LF)return 0}ve.from=ce;function le(q){if(q===1)return a.EndOfLine.CRLF;if(q===0)return a.EndOfLine.LF}ve.to=le})(te=e.EndOfLine||(e.EndOfLine={}));var pe;(function(ve){function ce(le){if(typeof le=="object")return le.viewId;switch(le){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=ce})(pe=e.ProgressLocation||(e.ProgressLocation={}));var Me;(function(ve){function ce(le){const q={start:le.start+1,end:le.end+1};return le.kind&&(q.kind=$e.from(le.kind)),q}ve.from=ce})(Me=e.FoldingRange||(e.FoldingRange={}));var $e;(function(ve){function ce(le){if(le)switch(le){case a.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}ve.from=ce})($e=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Be;(function(ve){function ce(le){if(le)return{pinned:typeof le.preview=="boolean"?!le.preview:void 0,inactive:le.background,preserveFocus:le.preserveFocus,selection:typeof le.selection=="object"?f.from(le.selection):void 0,override:typeof le.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ve.from=ce})(Be=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(ve){function ce(q){return q instanceof a.RelativePattern||typeof q=="string"?q:le(q)?new a.RelativePattern(q.base,q.pattern):q}ve.from=ce;function le(q){const Fe=q;return Fe&&typeof Fe.base=="string"&&typeof Fe.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var Se;(function(ve){function ce(le){if(le){if(Array.isArray(le))return le.map(ce);if(typeof le=="string")return le;{const q=le;return{language:q.language,scheme:q.scheme,pattern:typeof q.pattern=="undefined"?void 0:Ye.from(q.pattern),exclusive:q.exclusive}}}else return}ve.from=ce})(Se=e.LanguageSelector||(e.LanguageSelector={}));var ye;(function(ve){function ce(q){return{start:q.start,end:q.end}}ve.from=ce;function le(q){return new a.NotebookRange(q.start,q.end)}ve.to=le})(ye=e.NotebookRange||(e.NotebookRange={}));var De;(function(ve){function ce(le){return new a.NotebookCellMetadata().with(Object.assign(Object.assign({},le),{executionOrder:null,lastRunSuccess:null,runState:null,runStartTime:null,runStartTimeAdjustment:null,runEndTime:null}))}ve.to=ce})(De=e.NotebookCellMetadata||(e.NotebookCellMetadata={}));var ie;(function(ve){function ce(q){return q}ve.from=ce;function le(q){return new a.NotebookDocumentMetadata().with(q)}ve.to=le})(ie=e.NotebookDocumentMetadata||(e.NotebookDocumentMetadata={}));var ue;(function(ve){function ce(q){return{startTime:q.runStartTime,endTime:q.runEndTime,executionOrder:q.executionOrder,success:q.lastRunSuccess}}ve.to=ce;function le(q){return{lastRunSuccess:q.success,runStartTime:q.startTime,runEndTime:q.endTime,executionOrder:q.executionOrder}}ve.from=le})(ue=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var O;(function(ve){function ce(q){switch(q){case a.NotebookCellKind.Markup:return g.CellKind.Markup;case a.NotebookCellKind.Code:default:return g.CellKind.Code}}ve.from=ce;function le(q){switch(q){case g.CellKind.Markup:return a.NotebookCellKind.Markup;case g.CellKind.Code:default:return a.NotebookCellKind.Code}}ve.to=le})(O=e.NotebookCellKind||(e.NotebookCellKind={}));var J;(function(ve){function ce(q){const Fe={metadata:ie.from(q.metadata),cells:[]};for(let Pe of q.cells)a.NotebookCellData.validate(Pe),Fe.cells.push(oe.from(Pe));return Fe}ve.from=ce;function le(q){return{metadata:ie.to(q.metadata),cells:q.cells.map(oe.to)}}ve.to=le})(J=e.NotebookData||(e.NotebookData={}));var oe;(function(ve){function ce(q){var Fe;return{cellKind:O.from(q.kind),language:q.languageId,source:q.value,metadata:q.metadata,internalMetadata:ue.from((Fe=q.executionSummary)!==null&&Fe!==void 0?Fe:{}),outputs:q.outputs?q.outputs.map(ke.from):[]}}ve.from=ce;function le(q){return new a.NotebookCellData(O.to(q.cellKind),q.source,q.language,q.outputs?q.outputs.map(ke.to):void 0,q.metadata?De.to(q.metadata):void 0,q.internalMetadata?ue.to(q.internalMetadata):void 0)}ve.to=le})(oe=e.NotebookCellData||(e.NotebookCellData={}));var Ce;(function(ve){function ce(q){return{metadata:q.metadata,mime:q.mime,valueBytes:Array.from(q.data)}}ve.from=ce;function le(q){return new a.NotebookCellOutputItem(new Uint8Array(q.valueBytes),q.mime,q.metadata)}ve.to=le})(Ce=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var ke;(function(ve){function ce(q){return{outputId:q.id,outputs:q.outputs.map(Ce.from),metadata:q.metadata}}ve.from=ce;function le(q){const Fe=q.outputs.map(Ce.to);return new a.NotebookCellOutput(Fe,q.outputId,q.metadata)}ve.to=le})(ke=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ne;(function(ve){function ce(Pe){if(Pe!=null){if(Pe instanceof a.RelativePattern||typeof Pe=="string")return Pe;if(Fe(Pe))return new a.RelativePattern(Pe.base,Pe.pattern);if(q(Pe))return{include:Ye.from(Pe.include)||void 0,exclude:Ye.from(Pe.exclude)||void 0}}}ve.from=ce;function le(Pe){return typeof Pe=="string"?Pe:Fe(Pe)?{base:Pe.base,pattern:Pe.pattern}:{include:Pe.include,exclude:Pe.exclude}}ve.to=le;function q(Pe){const Ze=Pe,et=Ye.from(Ze.include);if(!(et&&et instanceof a.RelativePattern||typeof et=="string"))return!1;const ft=Ye.from(Ze.exclude);return!!(ft&&ft instanceof a.RelativePattern||typeof ft=="string")}function Fe(Pe){const Ze=Pe;return Ze&&typeof Ze.base=="string"&&typeof Ze.pattern=="string"}})(Ne=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Oe;(function(ve){function ce(le){return{backgroundColor:le.backgroundColor,borderColor:le.borderColor,top:le.top?C.from(le.top):void 0}}ve.from=ce})(Oe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var qe;(function(ve){function ce(le,q,Fe){const Pe=typeof le.command=="string"?{title:"",command:le.command}:le.command;return{alignment:le.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Pe,Fe),text:le.text,tooltip:le.tooltip,accessibilityInformation:le.accessibilityInformation,priority:le.priority}}ve.from=ce})(qe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var rt;(function(ve){function ce(le){var q,Fe,Pe;return{transientOutputs:(q=le==null?void 0:le.transientOutputs)!==null&&q!==void 0?q:!1,transientCellMetadata:(Fe=le==null?void 0:le.transientCellMetadata)!==null&&Fe!==void 0?Fe:{},transientDocumentMetadata:(Pe=le==null?void 0:le.transientDocumentMetadata)!==null&&Pe!==void 0?Pe:{}}}ve.from=ce})(rt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var tt;(function(ve){function ce(q){return{uri:q.uri,provides:q.provides}}ve.from=ce;function le(q){return new a.NotebookRendererScript(E.URI.revive(q.uri),q.provides)}ve.to=le})(tt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Je;(function(ve){function ce(q){return{message:v.fromStrict(q.message)||"",severity:q.severity,expectedOutput:q.expectedOutput,actualOutput:q.actualOutput,location:q.location?$.from(q.location):void 0}}ve.from=ce;function le(q){const Fe=new a.TestMessage(typeof q.message=="string"?q.message:v.to(q.message));return Fe.severity=q.severity,Fe.actualOutput=q.actualOutput,Fe.expectedOutput=q.expectedOutput,Fe}ve.to=le})(Je=e.TestMessage||(e.TestMessage={}));var ot;(function(ve){function ce(Pe){var Ze,et;return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:f.from(Pe.range)||null,debuggable:(Ze=Pe.debuggable)!==null&&Ze!==void 0?Ze:!1,description:Pe.description||null,runnable:(et=Pe.runnable)!==null&&et!==void 0?et:!0,error:Pe.error&&v.fromStrict(Pe.error)||null}}ve.from=ce;function le(Pe){return{extId:Pe.id,label:Pe.label,uri:Pe.uri,range:f.from(Pe.range)||null,debuggable:!1,description:Pe.description||null,error:null,runnable:!0}}ve.fromResultSnapshot=le;function q(Pe){return{id:Pe.extId,label:Pe.label,uri:E.URI.revive(Pe.uri),range:f.to(Pe.range||void 0),addChild:()=>{},dispose:()=>{},status:a.TestItemStatus.Pending,data:void 0,debuggable:Pe.debuggable,description:Pe.description||void 0,runnable:Pe.runnable}}ve.toPlain=q;function Fe(Pe){const Ze=new a.TestItemImpl(Pe.extId,Pe.label,E.URI.revive(Pe.uri),void 0);return Ze.range=f.to(Pe.range||void 0),Ze.debuggable=Pe.debuggable,Ze.description=Pe.description||void 0,Ze.runnable=Pe.runnable,Ze}ve.to=Fe})(ot=e.TestItem||(e.TestItem={}));var _t;(function(ve){const ce=(q,Fe)=>Object.assign(Object.assign({},ot.toPlain(q.item)),{taskStates:q.tasks.map(Pe=>({state:Pe.state,duration:Pe.duration,messages:Pe.messages.map(Je.to)})),children:q.children.map(Pe=>Fe.get(Pe)).filter(S.isDefined).map(Pe=>ce(Pe,Fe))});function le(q){const Fe=[],Pe=new Map;for(const Ze of q.items)Pe.set(Ze.item.extId,Ze),Ze.direct&&Fe.push(Ze);return{completedAt:q.completedAt,results:Fe.map(Ze=>ce(Ze,Pe))}}ve.to=le})(_t=e.TestResults||(e.TestResults={}));var bt;(function(ve){function ce(le){switch(le){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}ve.to=ce})(bt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(be[178],_e([0,1,2,13,7,10,45]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class S{constructor(k,i,I,d={timeout:1500,errors:3}){this._logService=k,this._documents=i,this._mainThreadBulkEdits=I,this._thresholds=d,this._callbacks=new _.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(i,I,d)=>{const o={dispose:this._callbacks.push([i,I,k])};return Array.isArray(d)&&d.push(o),o}}async $participateInSave(k,i){const I=p.URI.revive(k);let d=!1;const g=setTimeout(()=>d=!0,this._thresholds.timeout),o=[];try{for(let a of[...this._callbacks]){if(d)break;const w=this._documents.getDocument(I),f=await this._deliverEventAsyncAndBlameBadListeners(a,{document:w,reason:T.TextDocumentSaveReason.to(i)});o.push(f)}}finally{clearTimeout(g)}return o}_deliverEventAsyncAndBlameBadListeners([k,i,I],d){const g=this._badListeners.get(k);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,k,i,d).then(()=>!0,o=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const a=this._badListeners.get(k);this._badListeners.set(k,a?a+1:1),typeof a=="number"&&a>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,i,I,d){const g=[],o=Date.now(),{document:a,reason:w}=d,{version:f}=a,y=Object.freeze({document:a,reason:w,waitUntil(l){if(Object.isFrozen(g))throw(0,R.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(l))}});try{i.apply(I,[y])}catch(l){return Promise.reject(l)}return Object.freeze(g),new Promise((l,m)=>{const h=setTimeout(()=>m(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(h),l(t)}).catch(t=>{clearTimeout(h),m(t)})}).then(l=>{const m={edits:[]};for(const h of l)if(Array.isArray(h)&&h.every(t=>t instanceof D.TextEdit))for(const{newText:t,newEol:n,range:r}of h)m.edits.push({_type:2,resource:a.uri,edit:{range:r&&T.Range.from(r),text:t,eol:n&&T.EndOfLine.from(n)}});if(m.edits.length!==0)return f===a.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(m):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=S}),define(be[179],_e([0,1,3,11,27,2,10,7]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class E{constructor(I,d,g,o,a){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,g&&(this._config+=1),o&&(this._config+=2),a&&(this._config+=4);const w=(0,D.parse)(d),f=I(y=>{if(!g)for(let l of y.created){const m=T.URI.revive(l);w(m.fsPath)&&this._onDidCreate.fire(m)}if(!o)for(let l of y.changed){const m=T.URI.revive(l);w(m.fsPath)&&this._onDidChange.fire(m)}if(!a)for(let l of y.deleted){const m=T.URI.revive(l);w(m.fsPath)&&this._onDidDelete.fire(m)}});this._disposable=S.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,f)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class k{constructor(I,d,g){this._logService=d,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,d,g,o){return new E(this._onFileSystemEvent.event,I,d,g,o)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,d){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:d.map(g=>({oldUri:T.URI.revive(g.source),newUri:T.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:d.map(g=>T.URI.revive(g.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:d.map(g=>T.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,d){return(g,o,a)=>{const w=function(y){g.call(o,y)};return w.extension=I,d.event(w,void 0,a)}}async $onWillRunFileOperation(I,d,g,o){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:d.map(a=>({oldUri:T.URI.revive(a.source),newUri:T.URI.revive(a.target)}))},g,o);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:d.map(a=>T.URI.revive(a.target))},g,o);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:d.map(a=>T.URI.revive(a.target))},g,o)}}async _fireWillEvent(I,d,g,o){const a=new Set,w=[];if(await I.fireAsync(d,o,async(y,l)=>{var m;const h=Date.now(),t=await Promise.resolve(y);t instanceof S.WorkspaceEdit&&(w.push(t),a.add((m=l.extension.displayName)!==null&&m!==void 0?m:l.extension.identifier.value)),Date.now()-h>g&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),o.isCancellationRequested||w.length===0)return;const f={edits:[]};for(let y of w){let{edits:l}=_.WorkspaceEdit.from(y,this._extHostDocumentsAndEditors);f.edits=f.edits.concat(l)}return{edit:f,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=k}),define(be[180],_e([0,1,15,23,2,10,7,50]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class E{constructor(d,g,o,a){this.start=d,this.deletedCount=g,this.deletedItems=o,this.items=a}static asApiEvents(d){return d.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(o=>o.apiCell)}))}}class k{constructor(d,g,o){var a,w,f;this.notebook=d,this._extHostDocument=g,this._cellData=o,this.handle=o.handle,this.uri=D.URI.revive(o.uri),this.cellKind=o.cellKind,this._outputs=o.outputs.map(T.NotebookCellOutput.to),this._internalMetadata=(a=o.internalMetadata)!==null&&a!==void 0?a:{},this._metadata=T.NotebookCellMetadata.to((w=o.metadata)!==null&&w!==void 0?w:{}),this._previousResult=T.NotebookCellExecutionSummary.to((f=o.internalMetadata)!==null&&f!==void 0?f:{})}static asModelAddData(d,g){return{EOL:g.eol,lines:g.source,modeId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:d}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const d=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return d.notebook.getCellIndex(d)},notebook:d.notebook.apiNotebook,kind:T.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get outputs(){return d._outputs.slice(0)},get metadata(){return d._metadata},get executionSummary(){return d._previousResult}})}return this._apiCell}setOutputs(d){this._outputs=d.map(T.NotebookCellOutput.to)}setOutputItems(d,g,o){const a=o.map(T.NotebookCellOutputItem.to),w=this._outputs.find(f=>f.id===d);w&&(g||(w.outputs.length=0),w.outputs.push(...a))}setMetadata(d){this._metadata=T.NotebookCellMetadata.to(d)}setInternalMetadata(d){this._internalMetadata=d,this._previousResult=T.NotebookCellExecutionSummary.to(d)}}e.ExtHostCell=k;class i{constructor(d,g,o,a,w,f,y){this._proxy=d,this._textDocumentsAndEditors=g,this._textDocuments=o,this._emitter=a,this._viewType=w,this._metadata=f,this.uri=y,this.handle=i._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const d=this;this._notebook={get uri(){return d.uri},get version(){return d._versionId},get viewType(){return d._viewType},get isDirty(){return d._isDirty},get isUntitled(){return d.uri.scheme===p.Schemas.untitled},get isClosed(){return d._disposed},get metadata(){return d._metadata},get cellCount(){return d._cells.length},cellAt(g){return g=d._validateIndex(g),d._cells[g].apiCell},getCells(g){return(g?d._getCells(g):d._cells).map(a=>a.apiCell)},save(){return d._save()}}}return this._notebook}updateBackup(d){var g;(g=this._backup)===null||g===void 0||g.delete(),this._backup=d}disposeBackup(){var d;(d=this._backup)===null||d===void 0||d.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(d){d.metadata&&(this._metadata=this._metadata.with(d.metadata))}acceptModelChanged(d,g){this._versionId=d.versionId,this._isDirty=g;for(const o of d.rawEvents)o.kind===S.NotebookCellsChangeType.Initialize&&this._spliceNotebookCells(o.changes,!0),o.kind===S.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(o.changes,!1):o.kind===S.NotebookCellsChangeType.Move?this._moveCell(o.index,o.newIdx):o.kind===S.NotebookCellsChangeType.Output?this._setCellOutputs(o.index,o.outputs):o.kind===S.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(o.index,o.outputId,o.append,o.outputItems):o.kind===S.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(o.index,o.language):o.kind===S.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(o.index,o.metadata):o.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(o.index,o.internalMetadata)}_validateIndex(d){return d=d|0,d<0?0:d>=this._cells.length?this._cells.length-1:d}_validateRange(d){let g=d.start|0,o=d.end|0;return g<0&&(g=0),o>this._cells.length&&(o=this._cells.length),d.with({start:g,end:o})}_getCells(d){d=this._validateRange(d);const g=[];for(let o=d.start;o<d.end;o++)g.push(this._cells[o]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(d,g){if(this._disposed)return;const o=[],a=[],w=[];d.reverse().forEach(f=>{const l=f[2].map(t=>{const n=new k(this,this._textDocumentsAndEditors,t);return g||a.push(k.asModelAddData(this.apiNotebook,t)),n}),m=new E(f[0],f[1],[],l),h=this._cells.splice(f[0],f[1],...l);for(const t of h)w.push(t.uri),m.deletedItems.push(t.apiCell);o.push(m)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:a,removedDocuments:w}),g||this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(o)}))}_moveCell(d,g){const o=this._cells.splice(d,1);this._cells.splice(g,0,...o);const a=[new E(d,1,o.map(w=>w.apiCell),[]),new E(g,0,[],o)];this._emitter.emitModelChange((0,R.deepFreeze)({document:this.apiNotebook,changes:E.asApiEvents(a)}))}_setCellOutputs(d,g){const o=this._cells[d];o.setOutputs(g),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[o.apiCell]}))}_setCellOutputItems(d,g,o,a){const w=this._cells[d];w.setOutputItems(g,o,a),this._emitter.emitCellOutputsChange((0,R.deepFreeze)({document:this.apiNotebook,cells:[w.apiCell]}))}_changeCellLanguage(d,g){const o=this._cells[d];o.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelModeChanged(o.uri,g)}_changeCellMetadata(d,g){const o=this._cells[d],a=o.apiCell.metadata;o.setMetadata(g);const w=o.apiCell.metadata;(0,R.equals)(a,w)||this._emitter.emitCellMetadataChange((0,R.deepFreeze)({document:this.apiNotebook,cell:o.apiCell}))}_changeCellInternalMetadata(d,g){var o;const a=this._cells[d],w=a.internalMetadata;if(a.setInternalMetadata(g),w.runState!==g.runState){const f=(o=g.runState)!==null&&o!==void 0?o:_.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,R.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,executionState:f}))}}getCellFromApiCell(d){return this._cells.find(g=>g.apiCell===d)}getCellFromIndex(d){return this._cells[d]}getCell(d){return this._cells.find(g=>g.handle===d)}getCellIndex(d){return this._cells.indexOf(d)}}e.ExtHostNotebookDocument=i,i._handlePool=0}),define(be[98],_e([0,1,7,10]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class D{constructor(S){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=S}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(S){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:S})}replaceCellMetadata(S,E){this._throwIfFinalized(),this._collectedEdits.push({editType:3,index:S,metadata:E})}replaceCells(S,E,k){this._throwIfFinalized(),!(S===E&&k.length===0)&&this._collectedEdits.push({editType:1,index:S,count:E-S,cells:k.map(R.NotebookCellData.from)})}}class T{constructor(S,E,k,i,I,d){this.id=S,this._proxy=E,this.notebookData=k,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._visibleRanges=i,this._viewColumn=d}get apiEditor(){if(!this._editor){const S=this;this._editor={get document(){return S.notebookData.apiNotebook},get selections(){return S._selections},get visibleRanges(){return S._visibleRanges},revealRange(E,k){S._proxy.$tryRevealRange(S.id,R.NotebookRange.from(E),k??p.NotebookEditorRevealType.Default)},get viewColumn(){return S._viewColumn},edit(E){const k=new D(this.document.version);return E(k),S._applyEdit(k.finalize())},setDecorations(E,k){return S.setDecorations(E,k)}},T.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(S){this._visible=S}_acceptVisibleRanges(S){this._visibleRanges=S}_acceptSelections(S){this._selections=S}_acceptViewColumn(S){this._viewColumn=S}_applyEdit(S){if(S.cellEdits.length===0)return Promise.resolve(!0);const E=[];let k=-1;for(let i=0;i<S.cellEdits.length;i++){if(k<0){E.push(S.cellEdits[i]),k++;continue}const d=E[k],g=S.cellEdits[i];if(d.editType===1&&g.editType===1&&d.index===g.index){d.cells.push(...S.cellEdits[i].cells),d.count+=S.cellEdits[i].count;continue}E.push(S.cellEdits[i]),k++}return this._proxy.$tryApplyEdits(this.id,S.documentVersionId,E)}setDecorations(S,E){if(!(E.isEmpty&&!this._hasDecorationsForKey.has(S.key)))return E.isEmpty?this._hasDecorationsForKey.delete(S.key):this._hasDecorationsForKey.add(S.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(E),S.key)}}e.ExtHostNotebookEditor=T,T.apiEditorsToExtHost=new WeakMap}),define(be[181],_e([0,1,10,156,135,20,53]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class S{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,d,g){const o=this._handles++,{title:a,location:w,cancellable:f}=d,y={label:(0,D.localize)(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(o,{location:p.ProgressLocation.from(w),title:a,source:y,cancellable:f},I),this._withProgress(o,g,!!f)}_withProgress(I,d,g){let o;g&&(o=new T.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,o));const a=f=>{this._proxy.$progressEnd(f),this._mapHandleToCancellationSource.delete(f),o&&o.dispose()};let w;try{w=d(new k(this._proxy,I),g&&o?o.token:T.CancellationToken.None)}catch(f){throw a(I),f}return w.then(f=>a(I),f=>a(I)),w}$acceptProgressCanceled(I){const d=this._mapHandleToCancellationSource.get(I);d&&(d.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=S;function E(i,I){return i.message=I.message,typeof I.increment=="number"&&(typeof i.increment=="number"?i.increment+=I.increment:i.increment=I.increment),i}class k extends R.Progress{constructor(I,d){super(g=>this.throttledReport(g));this._proxy=I,this._handle=d}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}ze([(0,_.throttle)(100,(i,I)=>E(i,I),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[99],_e([0,1,42,13,55,10,7]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class S{constructor(d,g,o){const a=S._Keys.nextId();d.$registerTextEditorDecorationType(g.identifier,a,T.DecorationRenderOptions.from(o)),this.value=Object.freeze({key:a,dispose(){d.$removeTextEditorDecorationType(a)}})}}e.TextEditorDecorationType=S,S._Keys=new D.IdGenerator("TextEditorDecorationType");class E{constructor(d,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=d,this._documentVersionId=d.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(d,g){this._throwIfFinalized();let o=null;if(d instanceof _.Position)o=new _.Range(d,d);else if(d instanceof _.Range)o=d;else throw new Error("Unrecognized location");this._pushEdit(o,g,!1)}insert(d,g){this._throwIfFinalized(),this._pushEdit(new _.Range(d,d),g,!0)}delete(d){this._throwIfFinalized();let g=null;if(d instanceof _.Range)g=d;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(d,g,o){const a=this._document.validateRange(d);this._collectedEdits.push({range:a,text:g,forceMoveMarkers:o})}setEndOfLine(d){if(this._throwIfFinalized(),d!==_.EndOfLine.LF&&d!==_.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this._setEndOfLine=d}}e.TextEditorEdit=E;class k{constructor(d,g,o,a){this._proxy=d,this._id=g,this._accept(o),this._logService=a;const w=this;this.value={get tabSize(){return w._tabSize},set tabSize(f){w._setTabSize(f)},get insertSpaces(){return w._insertSpaces},set insertSpaces(f){w._setInsertSpaces(f)},get cursorStyle(){return w._cursorStyle},set cursorStyle(f){w._setCursorStyle(f)},get lineNumbers(){return w._lineNumbers},set lineNumbers(f){w._setLineNumbers(f)}}}_accept(d){this._tabSize=d.tabSize,this._insertSpaces=d.insertSpaces,this._cursorStyle=d.cursorStyle,this._lineNumbers=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}_validateTabSize(d){if(d==="auto")return"auto";if(typeof d=="number"){const g=Math.floor(d);return g>0?g:null}if(typeof d=="string"){const g=parseInt(d,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(d){const g=this._validateTabSize(d);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(d){return d==="auto"?"auto":d==="false"?!1:Boolean(d)}_setInsertSpaces(d){const g=this._validateInsertSpaces(d);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(d){this._cursorStyle!==d&&(this._cursorStyle=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:d})))}_setLineNumbers(d){this._lineNumbers!==d&&(this._lineNumbers=d,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const g={};let o=!1;if(typeof d.tabSize!="undefined"){const a=this._validateTabSize(d.tabSize);a==="auto"?(o=!0,g.tabSize=a):typeof a=="number"&&this._tabSize!==a&&(this._tabSize=a,o=!0,g.tabSize=a)}if(typeof d.insertSpaces!="undefined"){const a=this._validateInsertSpaces(d.insertSpaces);a==="auto"?(o=!0,g.insertSpaces=a):this._insertSpaces!==a&&(this._insertSpaces=a,o=!0,g.insertSpaces=a)}typeof d.cursorStyle!="undefined"&&this._cursorStyle!==d.cursorStyle&&(this._cursorStyle=d.cursorStyle,o=!0,g.cursorStyle=d.cursorStyle),typeof d.lineNumbers!="undefined"&&this._lineNumbers!==d.lineNumbers&&(this._lineNumbers=d.lineNumbers,o=!0,g.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),o&&this._warnOnError(this._proxy.$trySetOptions(this._id,g))}_warnOnError(d){d.catch(g=>this._logService.warn(g))}}e.ExtHostTextEditorOptions=k;class i{constructor(d,g,o,a,w,f,y,l){this.id=d,this._proxy=g,this._logService=o,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=w,this._options=new k(this._proxy,this.id,f,o),this._visibleRanges=y,this._viewColumn=l;const m=this;this.value=Object.freeze({get document(){return a.getValue()},set document(h){throw(0,R.readonly)("document")},get selection(){return m._selections&&m._selections[0]},set selection(h){if(!(h instanceof _.Selection))throw(0,R.illegalArgument)("selection");m._selections=[h],m._trySetSelection()},get selections(){return m._selections},set selections(h){if(!Array.isArray(h)||h.some(t=>!(t instanceof _.Selection)))throw(0,R.illegalArgument)("selections");m._selections=h,m._trySetSelection()},get visibleRanges(){return m._visibleRanges},set visibleRanges(h){throw(0,R.readonly)("visibleRanges")},get options(){return m._options.value},set options(h){m._disposed||m._options.assign(h)},get viewColumn(){return m._viewColumn},set viewColumn(h){throw(0,R.readonly)("viewColumn")},edit(h,t={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const n=new E(a.getValue(),t);return h(n),m._applyEdit(n)},insertSnippet(h,t,n={undoStopBefore:!0,undoStopAfter:!0}){if(m._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=m._selections.map(s=>T.Range.from(s));else if(t instanceof _.Position){const{lineNumber:s,column:u}=T.Position.from(t);r=[{startLineNumber:s,startColumn:u,endLineNumber:s,endColumn:u}]}else if(t instanceof _.Range)r=[T.Range.from(t)];else{r=[];for(const s of t)if(s instanceof _.Range)r.push(T.Range.from(s));else{const{lineNumber:u,column:v}=T.Position.from(s);r.push({startLineNumber:u,startColumn:v,endLineNumber:u,endColumn:v})}}return g.$tryInsertSnippet(d,h.value,r,n)},setDecorations(h,t){const n=t.length===0;n&&!m._hasDecorationsForKey.has(h.key)||(n?m._hasDecorationsForKey.delete(h.key):m._hasDecorationsForKey.add(h.key),m._runOnProxy(()=>{if(T.isDecorationOptionsArr(t))return g.$trySetDecorations(d,h.key,T.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let s=0,u=t.length;s<u;s++){const v=t[s];r[4*s]=v.start.line+1,r[4*s+1]=v.start.character+1,r[4*s+2]=v.end.line+1,r[4*s+3]=v.end.character+1}return g.$trySetDecorationsFast(d,h.key,r)}}))},revealRange(h,t){m._runOnProxy(()=>g.$tryRevealRange(d,T.Range.from(h),t||_.TextEditorRevealType.Default))},show(h){g.$tryShowEditor(d,T.ViewColumn.from(h))},hide(){g.$tryHideEditor(d)}})}dispose(){(0,p.ok)(!this._disposed),this._disposed=!0}_acceptOptions(d){(0,p.ok)(!this._disposed),this._options._accept(d)}_acceptVisibleRanges(d){(0,p.ok)(!this._disposed),this._visibleRanges=d}_acceptViewColumn(d){(0,p.ok)(!this._disposed),this._viewColumn=d}_acceptSelections(d){(0,p.ok)(!this._disposed),this._selections=d}async _trySetSelection(){const d=this._selections.map(T.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,d)),this.value}_applyEdit(d){const g=d.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const o=g.edits.map(w=>w.range);o.sort((w,f)=>w.end.line===f.end.line?w.end.character===f.end.character?w.start.line===f.start.line?w.start.character-f.start.character:w.start.line-f.start.line:w.end.character-f.end.character:w.end.line-f.end.line);for(let w=0,f=o.length-1;w<f;w++){const y=o[w].end;if(o[w+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const a=g.edits.map(w=>({range:T.Range.from(w.range),text:w.text,forceMoveMarkers:w.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,a,{setEndOfLine:typeof g.setEndOfLine=="number"?T.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(d){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=i}),define(be[182],_e([0,1,138,24,2,3,6,11,7,9,14,10,20]),function(X,e,p,R,D,T,_,S,E,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function g(w,f){if((0,k.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let y;return Array.isArray(w.highlights)&&(y=w.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),y=y.length?y:void 0),{label:w.label,highlights:y}}}class o{constructor(f,y,l){this._proxy=f,this.commands=y,this.logService=l,this.treeViews=new Map;function m(h){return h&&h.$treeViewId&&h.$treeItemHandle}y.registerArgumentProcessor({processArgument:h=>m(h)?this.convertArgument(h):Array.isArray(h)&&h.length>0?h.map(t=>m(t)?this.convertArgument(t):t):h})}registerTreeDataProvider(f,y,l){const m=this.createTreeView(f,{treeDataProvider:y},l);return{dispose:()=>m.dispose()}}createTreeView(f,y,l){if(!y||!y.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const m=y.dragAndDropController!==void 0,h=this._proxy.$registerTreeViewDataProvider(f,{showCollapseAll:!!y.showCollapseAll,canSelectMany:!!y.canSelectMany,canDragAndDrop:m}),t=this.createExtHostTreeView(f,y,l);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(n){t.message=n},get title(){return t.title},set title(n){t.title=n},get description(){return t.description},set description(n){t.description=n},reveal:(n,r)=>t.reveal(n,r),dispose:async()=>{await h,this.treeViews.delete(f),t.dispose()}}}$getChildren(f,y){const l=this.treeViews.get(f);return l?l.getChildren(y):Promise.reject(new Error((0,p.localize)(0,null,f)))}$onDrop(f,y,l){const m=this.treeViews.get(f);return m?m.onDrop(y,l):Promise.reject(new Error((0,p.localize)(1,null,f)))}async $hasResolve(f){const y=this.treeViews.get(f);if(!y)throw new Error((0,p.localize)(2,null,f));return y.hasResolve}$resolve(f,y,l){const m=this.treeViews.get(f);if(!m)throw new Error((0,p.localize)(3,null,f));return m.resolveTreeItem(y,l)}$setExpanded(f,y,l){const m=this.treeViews.get(f);if(!m)throw new Error((0,p.localize)(4,null,f));m.setExpanded(y,l)}$setSelection(f,y){const l=this.treeViews.get(f);if(!l)throw new Error((0,p.localize)(5,null,f));l.setSelection(y)}$setVisible(f,y){const l=this.treeViews.get(f);if(!l)throw new Error((0,p.localize)(6,null,f));l.setVisible(y)}createExtHostTreeView(f,y,l){const m=new a(f,y,this._proxy,this.commands.converter,this.logService,l);return this.treeViews.set(f,m),m}convertArgument(f){const y=this.treeViews.get(f.$treeViewId);return y?y.getExtensionElement(f.$treeItemHandle):null}}e.ExtHostTreeViews=o;class a extends _.Disposable{constructor(f,y,l,m,h,t){super();if(this.viewId=f,this.proxy=l,this.commands=m,this.logService=h,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new T.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new T.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new T.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new T.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new T.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,t.contributes&&t.contributes.views)for(const s in t.contributes.views)for(const u of t.contributes.views[s])u.id===f&&(this._title=u.name);this.dataProvider=y.treeDataProvider,this.dndController=y.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(s=>this._onDidChangeData.fire({message:!1,element:s})));let n,r;this._register(T.Event.debounce(this._onDidChangeData.event,(s,u)=>(s||(s={message:!1,elements:[]}),u.element!==!1&&(n||(n=new Promise(v=>r=v),this.refreshPromise=this.refreshPromise.then(()=>n)),s.elements.push(u.element)),u.message&&(s.message=!0),s),200,!0)(({message:s,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=r;return n=null,this.refresh(u).then(()=>v())})),s&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(f=>this.getExtensionElement(f)).filter(f=>!(0,k.isUndefinedOrNull)(f))}getChildren(f){const y=f?this.getExtensionElement(f):void 0;if(f&&!y)return this.logService.error(`No tree item with id '${f}' found.`),Promise.resolve([]);const l=this.getChildrenNodes(f);return(l?Promise.resolve(l):this.fetchChildrenNodes(y)).then(m=>m.map(h=>h.item))}getExtensionElement(f){return this.elements.get(f)}reveal(f,y){y=y||{select:!0,focus:!1};const l=(0,k.isUndefinedOrNull)(y.select)?!0:y.select,m=(0,k.isUndefinedOrNull)(y.focus)?!1:y.focus,h=(0,k.isUndefinedOrNull)(y.expand)?!1:y.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):f?this.refreshPromise.then(()=>this.resolveUnknownParentChain(f)).then(t=>this.resolveTreeNode(f,t[t.length-1]).then(n=>this.proxy.$reveal(this.viewId,{item:n.item,parentChain:t.map(r=>r.item)},{select:l,focus:m,expand:h})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:l,focus:m,expand:h})}get message(){return this._message}set message(f){this._message=f,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(f){this._title=f,this.proxy.$setTitle(this.viewId,f,this._description)}get description(){return this._description}set description(f){this._description=f,this.proxy.$setTitle(this.viewId,this._title,f)}setExpanded(f,y){const l=this.getExtensionElement(f);l&&(y?this._onDidExpandElement.fire(Object.freeze({element:l})):this._onDidCollapseElement.fire(Object.freeze({element:l})))}setSelection(f){(0,i.equals)(this._selectedHandles,f)||(this._selectedHandles=f,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(f){f!==this._visible&&(this._visible=f,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(f,y){const l=f.map(h=>this.getExtensionElement(h)).filter(h=>!(0,k.isUndefinedOrNull)(h)),m=this.getExtensionElement(y);return l&&m?(0,S.asPromise)(()=>{var h;return(h=this.dndController)===null||h===void 0?void 0:h.onDrop(l,m)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(f,y){var l;if(!this.dataProvider.resolveTreeItem)return;const m=this.elements.get(f);if(m){const h=this.nodes.get(m);if(h){const t=(l=await this.dataProvider.resolveTreeItem(h.extensionItem,m,y))!==null&&l!==void 0?l:h.extensionItem;return h.item.tooltip=this.getTooltip(t.tooltip),h.item.command=this.getCommand(h.disposableStore,t.command),h.item}}}resolveUnknownParentChain(f){return this.resolveParent(f).then(y=>y?this.resolveUnknownParentChain(y).then(l=>this.resolveTreeNode(y,l[l.length-1]).then(m=>(l.push(m),l))):Promise.resolve([]))}resolveParent(f){const y=this.nodes.get(f);return y?Promise.resolve(y.parent?this.elements.get(y.parent.item.handle):void 0):(0,S.asPromise)(()=>this.dataProvider.getParent(f))}resolveTreeNode(f,y){const l=this.nodes.get(f);return l?Promise.resolve(l):(0,S.asPromise)(()=>this.dataProvider.getTreeItem(f)).then(m=>this.createHandle(f,m,y,!0)).then(m=>this.getChildren(y?y.item.handle:void 0).then(()=>{const h=this.getExtensionElement(m);if(h){const t=this.nodes.get(h);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${m}`)}))}getChildrenNodes(f){if(f){let y;if(typeof f=="string"){const l=this.getExtensionElement(f);y=l?this.nodes.get(l):void 0}else y=f;return y&&y.children||null}return this.roots}async fetchChildrenNodes(f){this.clearChildren(f);const y=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const l=f?this.nodes.get(f):void 0,m=await this.dataProvider.getChildren(f);if(y.token.isCancellationRequested)return[];const h=await Promise.all((0,i.coalesce)(m||[]).map(async t=>{const n=await this.dataProvider.getTreeItem(t);return n&&!y.token.isCancellationRequested?this.createAndRegisterTreeNode(t,n,l):null}));return y.token.isCancellationRequested?[]:(0,i.coalesce)(h)}finally{y.dispose()}}refresh(f){if(f.some(l=>!l))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const l=this.getHandlesToRefresh(f);if(l.length)return this.refreshHandles(l)}return Promise.resolve(void 0)}getHandlesToRefresh(f){const y=new Set,l=f.map(h=>this.nodes.get(h));for(const h of l)if(h&&!y.has(h.item.handle)){let t=h;for(;t&&t.parent&&l.findIndex(n=>t&&t.parent&&n&&n.item.handle===t.parent.item.handle)===-1;){const n=this.elements.get(t.parent.item.handle);t=n?this.nodes.get(n):void 0}t&&!t.parent&&y.add(h.item.handle)}const m=[];return y.forEach(h=>{const t=this.elements.get(h);if(t){const n=this.nodes.get(t);n&&(!n.parent||!y.has(n.parent.item.handle))&&m.push(h)}}),m}refreshHandles(f){const y={};return Promise.all(f.map(l=>this.refreshNode(l).then(m=>{m&&(y[l]=m.item)}))).then(()=>Object.keys(y).length?this.proxy.$refresh(this.viewId,y):void 0)}refreshNode(f){const y=this.getExtensionElement(f);if(y){const l=this.nodes.get(y);if(l)return this.clearChildren(y),(0,S.asPromise)(()=>this.dataProvider.getTreeItem(y)).then(m=>{if(m){const h=this.createTreeNode(y,m,l.parent);return this.updateNodeCache(y,h,l,l.parent),l.dispose(),h}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(f,y,l){const m=this.createTreeNode(f,y,l);if(y.id&&this.elements.has(m.item.handle))throw new Error((0,p.localize)(7,null,y.id));return this.addNodeToCache(f,m),this.addNodeToParentCache(m,l),m}getTooltip(f){return E.MarkdownString.isMarkdownString(f)?I.MarkdownString.from(f):f}getCommand(f,y){return y?this.commands.toInternal(y,f):void 0}createTreeNode(f,y,l){const m=new _.DisposableStore,h=this.createHandle(f,y,l),t=this.getLightIconPath(y);return{item:{handle:h,parentHandle:l?l.item.handle:void 0,label:g(y.label,this.extension),description:y.description,resourceUri:y.resourceUri,tooltip:this.getTooltip(y.tooltip),command:this.getCommand(m,y.command),contextValue:y.contextValue,icon:t,iconDark:this.getDarkIconPath(y)||t,themeIcon:this.getThemeIcon(y),collapsibleState:(0,k.isUndefinedOrNull)(y.collapsibleState)?E.TreeItemCollapsibleState.None:y.collapsibleState,accessibilityInformation:y.accessibilityInformation},extensionItem:y,parent:l,children:void 0,disposableStore:m,dispose(){m.dispose()}}}getThemeIcon(f){return f.iconPath instanceof E.ThemeIcon?f.iconPath:void 0}createHandle(f,{id:y,label:l,resourceUri:m},h,t){if(y)return`${a.ID_HANDLE_PREFIX}/${y}`;const n=g(l,this.extension),r=h?h.item.handle:a.LABEL_HANDLE_PREFIX;let s=n?n.label:m?(0,R.basename)(m):"";s=s.indexOf("/")!==-1?s.replace("/","//"):s;const u=this.nodes.has(f)?this.nodes.get(f).item.handle:void 0,v=this.getChildrenNodes(h)||[];let b,P=0;do{if(b=`${r}/${P}:${s}`,t||!this.elements.has(b)||u===b)break;P++}while(P<=v.length);return b}getLightIconPath(f){if(f.iconPath&&!(f.iconPath instanceof E.ThemeIcon))return typeof f.iconPath=="string"||D.URI.isUri(f.iconPath)?this.getIconPath(f.iconPath):this.getIconPath(f.iconPath.light)}getDarkIconPath(f){if(f.iconPath&&!(f.iconPath instanceof E.ThemeIcon)&&f.iconPath.dark)return this.getIconPath(f.iconPath.dark)}getIconPath(f){return D.URI.isUri(f)?f:D.URI.file(f)}addNodeToCache(f,y){this.elements.set(y.item.handle,f),this.nodes.set(f,y)}updateNodeCache(f,y,l,m){this.elements.delete(y.item.handle),this.nodes.delete(f),y.item.handle!==l.item.handle&&this.elements.delete(l.item.handle),this.addNodeToCache(f,y);const h=this.getChildrenNodes(m)||[],t=h.filter(n=>n.item.handle===l.item.handle)[0];t&&h.splice(h.indexOf(t),1,y)}addNodeToParentCache(f,y){y?(y.children||(y.children=[]),y.children.push(f)):(this.roots||(this.roots=[]),this.roots.push(f))}clearChildren(f){if(f){const y=this.nodes.get(f);if(y){if(y.children)for(const l of y.children){const m=this.elements.get(l.item.handle);m&&this.clear(m)}y.children=void 0}}else this.clearAll()}clear(f){const y=this.nodes.get(f);if(y){if(y.children)for(const l of y.children){const m=this.elements.get(l.item.handle);m&&this.clear(m)}this.nodes.delete(f),this.elements.delete(y.item.handle),y.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(f=>f.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}a.LABEL_HANDLE_PREFIX="0",a.ID_HANDLE_PREFIX="1"}),define(be[183],_e([0,1,14,11,20,9,70,10,7,97]),function(X,e,p,R,D,T,_,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class i{constructor(){this.testIdsToInternal=new Map}getTestById(w,f){if(f!==void 0){const y=this.testIdsToInternal.get(f),l=y==null?void 0:y.get(w);if(l)return[y,l]}return(0,p.mapFind)(this.testIdsToInternal.values(),y=>{const l=y.get(w);return l&&[y,l]})}createForHierarchy(w=()=>{}){return new o(this.createIdMap(d++),w)}createIdMap(w){const f=new g(w);return this.testIdsToInternal.set(f.id,f),{object:f,dispose:()=>this.testIdsToInternal.delete(f.id)}}}e.OwnedTestCollection=i;var I;(function(a){a[a.Disconnected=0]="Disconnected",a[a.IsChild=1]="IsChild",a[a.IsParent=2]="IsParent",a[a.IsSame=3]="IsSame"})(I=e.TestPosition||(e.TestPosition={}));let d=0;class g{constructor(w){this.id=w,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(w){if(this.map.has(w.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${w.item.extId}`);this.map.set(w.item.extId,w),w.parent||this._roots.add(w)}has(w){return this.map.has(w)}delete(w){const f=this.map.get(w);return f?(this.map.delete(w),this._roots.delete(f),!0):!1}get(w){return this.map.get(w)}comparePositions(w,f){const y=typeof w=="string"?this.map.get(w):w,l=typeof f=="string"?this.map.get(f):f;if(!y||!l)return 0;if(y===l)return 3;for(let m=this.map.get(l.parent);m;m=this.map.get(m.parent))if(m===y)return 1;for(let m=this.map.get(y.parent);m;m=this.map.get(m.parent))if(m===l)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=g;class o{constructor(w,f){this.testIdToInternal=w,this.publishDiff=f,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200)}get treeId(){return this.testIdToInternal.object.id}addRoot(w,f){this.addItem(w,f,null)}getTestByReference(w){return this.testItemToInternal.get(w)}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){const f=this.diff[this.diff.length-1];if(f&&w[0]===1){if(f[0]===1&&f[1].extId===w[1].extId){(0,k.applyTestItemUpdate)(f[1],w[1]);return}if(f[0]===0&&f[1].item.extId===w[1].extId){(0,k.applyTestItemUpdate)(f[1],w[1]);return}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,f){var y;const l=this.testIdToInternal.object.get(w);if(!!l){if((l.expandLevels===void 0||f>l.expandLevels)&&(l.expandLevels=f),l.expand===1){const m=this.refreshChildren(l);return m.isSettled?this.expandChildren(l,f-1):m.p.then(()=>this.expandChildren(l,f-1))}else if(l.expand===3)return((y=l.initialExpand)===null||y===void 0?void 0:y.isSettled)===!1?l.initialExpand.p.then(()=>this.expandChildren(l,f-1)):this.expandChildren(l,f-1)}}dispose(){var w;for(const f of this.testItemToInternal.values())(w=f.discoverCts)===null||w===void 0||w.dispose(!0),(0,_.getPrivateApiFor)(f.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(w,f){const y=w==null?void 0:w.actual.id;switch(f[0]){case 2:this.pushDiff([4,y]);break;case 1:this.removeItem(w);break;case 0:this.addItem(f[1],w.src.controller,w);break;case 3:const[l,m,h]=f;switch(m){case"status":this.updateExpandability(w);break;case"range":this.pushDiff([1,{extId:y,item:{range:S.Range.from(h)}}]);break;case"error":this.pushDiff([1,{extId:y,item:{error:S.MarkdownString.fromStrict(h)||null}}]);break;default:this.pushDiff([1,{extId:y,item:{[m]:h??null}}]);break}break;default:(0,T.assertNever)(f[0])}}addItem(w,f,y){if(!(w instanceof E.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${w.id} did not`);if(this.testItemToInternal.has(w))throw new Error(`Attempted to add a single TestItem ${w.id} multiple times to the tree`);if(this.testIdToInternal.object.has(w.id))throw new Error(`Attempted to insert a duplicate test item ID ${w.id}`);const l=y?y.item.extId:null,m=w.resolveHandler?1:0,h=y?y.expandLevels:1,t={controller:f,tree:this.testIdToInternal.object.id},n={actual:w,parent:l,item:S.TestItem.from(w),expandLevels:h?h-1:void 0,expand:0,src:t};this.testIdToInternal.object.add(n),this.testItemToInternal.set(w,n),this.pushDiff([0,{parent:l,src:t,expand:m,item:n.item}]);const r=(0,_.getPrivateApiFor)(w);r.parent=y==null?void 0:y.actual,r.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const s of r.children.values())this.testItemToInternal.has(s)||this.addItem(s,f,n)}updateExpandability(w){var f;let y;w.actual.resolveHandler?w.actual.status===E.TestItemStatus.Pending?y=w.discoverCts?2:1:((f=w.initialExpand)===null||f===void 0||f.complete(),y=3):y=0,y!==w.expand&&(w.expand=y,this.pushDiff([1,{extId:w.actual.id,expand:y}]),y===1&&w.expandLevels!==void 0&&this.refreshChildren(w))}expandChildren(w,f){if(f<0)return;const y=[...w.actual.children.values()].map(l=>this.expand(l.id,f)).filter(R.isThenable);if(y.length)return Promise.all(y).then(()=>{})}refreshChildren(w){if(w.discoverCts&&w.discoverCts.dispose(!0),!w.actual.resolveHandler){const f=new R.DeferredPromise;return f.complete(),f}return w.expand=2,w.discoverCts=new D.CancellationTokenSource,this.pushExpandStateUpdate(w),w.initialExpand=new R.DeferredPromise,w.actual.resolveHandler(w.discoverCts.token),w.initialExpand}pushExpandStateUpdate(w){this.pushDiff([1,{extId:w.actual.id,expand:w.expand}])}removeItem(w){var f;this.pushDiff([2,w.actual.id]);const y=[w];for(;y.length;){const l=y.pop();if(!!l){(f=l.discoverCts)===null||f===void 0||f.dispose(!0),this.testIdToInternal.object.delete(l.item.extId),this.testItemToInternal.delete(l.actual);for(const m of l.actual.children.values())y.push(this.testIdToInternal.object.get(m.id))}}}flushDiff(){const w=this.collectDiff();w.length&&this.publishDiff(w)}}e.SingleUseTestCollection=o}),define(be[184],_e([0,1,26,3,12]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class T{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=T;class _{constructor(i){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=i,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const i of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(i.identifier))){console.error("Extension `"+i.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(i.identifier),i),this._extensionsArr.push(i),Array.isArray(i.activationEvents))for(let I of i.activationEvents)I==="onUri"&&(I=`onUri:${p.ExtensionIdentifier.toKey(i.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(i)}}keepOnly(i){const I=new Set;i.forEach(d=>I.add(p.ExtensionIdentifier.toKey(d))),this._extensionDescriptions=this._extensionDescriptions.filter(d=>I.has(p.ExtensionIdentifier.toKey(d.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(i,I){i.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(i));const d=_._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(d.map(g=>g.identifier)),I.length>0){const g=new Set;I.forEach(o=>g.add(p.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>!g.has(p.ExtensionIdentifier.toKey(o.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new T(d)}static _findLoopingExtensions(i){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(w){this._nodesSet.has(w)||(this._nodesSet.add(w),this._nodesArr.push(w))}addArc(w,f){this.addNode(w),this.addNode(f),this._arcs.has(w)?this._arcs.get(w).push(f):this._arcs.set(w,[f])}getArcs(w){return this._arcs.has(w)?this._arcs.get(w):[]}hasOnlyGoodArcs(w,f){const y=I.getArcs(w);for(let l=0;l<y.length;l++)if(!f.has(y[l]))return!1;return!0}getNodes(){return this._nodesArr}};let d=new Map;for(let w of i){const f=p.ExtensionIdentifier.toKey(w.identifier);if(d.set(f,w),w.extensionDependencies)for(let y of w.extensionDependencies){const l=p.ExtensionIdentifier.toKey(y);I.addArc(f,l)}}let g=new Set;I.getNodes().filter(w=>I.getArcs(w).length===0).forEach(w=>g.add(w));let o=I.getNodes().filter(w=>!g.has(w)),a;do{a=!1;for(let w=0;w<o.length;w++){const f=o[w];I.hasOnlyGoodArcs(f,g)&&(o.splice(w,1),w--,g.add(f),a=!0)}}while(a);return o.map(w=>d.get(w))}containsActivationEvent(i){return this._activationMap.has(i)}containsExtension(i){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(i))}getExtensionDescriptionsForActivationEvent(i){const I=this._activationMap.get(i);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(i){const I=this._extensionsMap.get(p.ExtensionIdentifier.toKey(i));return I||void 0}}e.ExtensionDescriptionRegistry=_;var S;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(S||(S={}));function E(k,i){const I=k.isBuiltin?0:k.isUnderDevelopment?2:1,d=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(I!==d)return I-d;const g=D.posix.basename(k.extensionLocation.path),o=D.posix.basename(i.extensionLocation.path);return g<o?-1:g>o?1:0}}),define(be[185],_e([0,1,25]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(S){S[S.VersionMismatch=55]="VersionMismatch",S[S.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var D;(function(S){S[S.Initialized=0]="Initialized",S[S.Ready=1]="Ready",S[S.Terminate=2]="Terminate"})(D=e.MessageType||(e.MessageType={}));function T(S){const E=p.VSBuffer.alloc(1);switch(S){case 0:E.writeUInt8(1,0);break;case 1:E.writeUInt8(2,0);break;case 2:E.writeUInt8(3,0);break}return E}e.createMessageOfType=T;function _(S,E){if(S.byteLength!==1)return!1;switch(S.readUInt8(0)){case 1:return E===0;case 2:return E===1;case 3:return E===2;default:return!1}}e.isMessageOfType=_}),define(be[32],_e([0,1,3,2,4,26,152]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new T.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,D.createDecorator)("extensionService");class S{constructor(y){this.dependency=y}}e.MissingExtensionDependency=S;var E;(function(f){f[f.LocalProcess=0]="LocalProcess",f[f.LocalWebWorker=1]="LocalWebWorker",f[f.Remote=2]="Remote"})(E=e.ExtensionHostKind||(e.ExtensionHostKind={}));class k{constructor(y,l,m,h){this.codeLoadingTime=y,this.activateCallTime=l,this.activateResolvedTime=m,this.activationReason=h}}e.ActivationTimes=k;class i{constructor(y,l){this.description=y,this.value=l}}e.ExtensionPointContribution=i,e.ExtensionHostLogFileName="exthost";var I;(function(f){f[f.Normal=0]="Normal",f[f.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function d(f){f.enableProposedApi||g(f)}e.checkProposedApiEnabled=d;function g(f){throw new Error(`[${f.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${f.identifier.value}`)}e.throwProposedApiError=g;function o(f){return{type:f.isBuiltin?0:1,isBuiltin:f.isBuiltin||f.isUserBuiltin,identifier:{id:(0,_.getGalleryExtensionId)(f.publisher,f.name),uuid:f.uuid},manifest:f,location:f.extensionLocation}}e.toExtension=o;function a(f){return Object.assign(Object.assign({identifier:new T.ExtensionIdentifier(f.identifier.id),isBuiltin:f.type===0,isUserBuiltin:f.type===1&&f.isBuiltin,isUnderDevelopment:!1,extensionLocation:f.location},f.manifest),{uuid:f.identifier.uuid})}e.toExtensionDescription=a;class w{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(y){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(y){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(y){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(y){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(y,l){return Promise.resolve()}_onWillActivateExtension(y){}_onDidActivateExtension(y,l,m,h,t){}_onDidActivateExtensionError(y,l){}_onExtensionRuntimeError(y,l){}_onExtensionHostExit(y){}}e.NullExtensionService=w}),define(be[186],_e([0,1,26,32,17]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const T=Promise.resolve(void 0);class _{constructor(o,a,w,f){this.startup=o,this.codeLoadingTime=a,this.activateCallTime=w,this.activateResolvedTime=f}}e.ExtensionActivationTimes=_,_.NONE=new _(!1,-1,-1,-1);class S{constructor(o){this._startup=o,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(o,a){return o===-1||a===-1?-1:a-o}build(){return new _(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=S;class E{constructor(o,a,w,f,y,l){this.activationFailed=o,this.activationFailedError=a,this.activationTimes=w,this.module=f,this.exports=y,this.subscriptions=l}}e.ActivatedExtension=E;class k extends E{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class i extends E{constructor(){super(!1,null,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=i;class I extends E{constructor(o){super(!0,o,_.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let d=class{constructor(o,a,w,f,y){this._logService=y,this._registry=o,this._resolvedExtensionsSet=new Set,a.forEach(l=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,w.forEach(l=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(l),l)),this._host=f,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(o){const a=p.ExtensionIdentifier.toKey(o);return this._activatedExtensions.has(a)}getActivatedExtension(o){const a=p.ExtensionIdentifier.toKey(o),w=this._activatedExtensions.get(a);if(!w)throw new Error("Extension `"+o.value+"` is not known or not activated");return w}activateByEvent(o,a){if(this._alreadyActivatedEvents[o])return T;const w=this._registry.getExtensionDescriptionsForActivationEvent(o);return this._activateExtensions(w.map(f=>({id:f.identifier,reason:{startup:a,extensionId:f.identifier,activationEvent:o}}))).then(()=>{this._alreadyActivatedEvents[o]=!0})}activateById(o,a){const w=this._registry.getExtensionDescription(o);if(!w)throw new Error("Extension `"+o+"` is not known");return this._activateExtensions([{id:w.identifier,reason:a}])}_handleActivateRequest(o,a,w){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(o.id))){a[p.ExtensionIdentifier.toKey(o.id)]=o;return}const f=this._registry.getExtensionDescription(o.id);if(!f){const m=new Error(`Cannot activate unknown extension '${o.id.value}'`);this._host.onExtensionActivationError(o.id,m,new R.MissingExtensionDependency(o.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(o.id),new I(m));return}const y=typeof f.extensionDependencies=="undefined"?[]:f.extensionDependencies;let l=!0;for(let m=0,h=y.length;m<h;m++){const t=y[m];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const n=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(n&&!n.activationFailed)continue;if(n&&n.activationFailed){const v=f.displayName||f.identifier.value,b=this._registry.getExtensionDescription(t),P=b&&b.displayName||t,C=new Error(`Cannot activate the '${v}' extension because its dependency '${P}' failed to activate`);C.detail=n.activationFailedError,this._host.onExtensionActivationError(f.identifier,C,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(f.identifier),new I(C));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){l=!1,a[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:o.reason};continue}const r=this._registry.getExtensionDescription(t);if(r){l=!1,a[p.ExtensionIdentifier.toKey(t)]={id:r.identifier,reason:o.reason};continue}const s=f.displayName||f.identifier.value,u=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(f.identifier,u,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(f.identifier),new I(u));return}l?a[p.ExtensionIdentifier.toKey(f.identifier)]=o:w.push(o)}_activateExtensions(o){if(o.length===0||(o=o.filter(y=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(y.id))),o.length===0))return Promise.resolve(void 0);const a=Object.create(null),w=[];for(let y=0,l=o.length;y<l;y++)this._handleActivateRequest(o[y],a,w);for(let y=0,l=w.length;y<l;y++){const m=p.ExtensionIdentifier.toKey(w[y].id);a[m]&&delete a[m]}const f=Object.keys(a).map(y=>a[y]);return w.length===0?Promise.all(f.map(y=>this._activateExtension(y.id,y.reason))).then(y=>{}):this._activateExtensions(f).then(y=>this._activateExtensions(w))}_activateExtension(o,a){const w=p.ExtensionIdentifier.toKey(o);if(this._activatedExtensions.has(w))return Promise.resolve(void 0);const f=this._activatingExtensions.get(w);if(f)return f;const y=this._host.actualActivateExtension(o,a).then(void 0,l=>{const m=new Error;return l&&l.name&&(m.name=l.name),l&&l.message?m.message=`Activating extension '${o.value}' failed: ${l.message}.`:m.message=`Activating extension '${o.value}' failed: ${l}.`,l&&l.stack&&(m.stack=l.stack),this._host.onExtensionActivationError(o,m,null),this._logService.error(`Activating extension ${o.value} failed due to an error:`),this._logService.error(l),new I(l)}).then(l=>{this._activatedExtensions.set(w,l),this._activatingExtensions.delete(w)});return this._activatingExtensions.set(w,y),y}};d=ze([je(4,D.ILogService)],d),e.ExtensionsActivator=d}),define(be[187],_e([0,1,13]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((T,_)=>{this._actualOk=T,this._actualErr=_,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(T){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=T,this._actual&&this._actualOk(T))}resolveErr(T){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=T,this._actual?this._actualErr(T):(0,p.onUnexpectedError)(T))}then(T,_){return this._ensureActual().then(T,_)}catch(T){return this._ensureActual().then(void 0,T)}finally(T){return this._ensureActual().finally(T)}}e.LazyPromise=R}),define(be[100],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(E,k){this.isMain=E,this.sid=k,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const R=[];function D(S){const E=new p(!0,S);return R[E.nid]=E,E}e.createMainContextProxyIdentifier=D;function T(S){const E=new p(!1,S);return R[E.nid]=E,E}e.createExtHostContextProxyIdentifier=T;function _(S){return R[S].sid}e.getStringIdentifierForProxy=_}),define(be[5],_e([0,1,58,2,100]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var T;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(T=e.UIKind||(e.UIKind={}));var _;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(_=e.TextEditorRevealType||(e.TextEditorRevealType={}));var S;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var i;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(l){l.name="$ident";function m(t,n){return Object.defineProperty(t,l.name,{value:n,enumerable:!0}),t}l.mixin=m;function h(t){return t[l.name]}l.of=h})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class g{static mixin(m){return m._id=g._n++,m}}e.IdObject=g,g._n=0;var o;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(o=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var a;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(a=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var w;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(w=e.WorkspaceEditType||(e.WorkspaceEditType={}));function f(l){if(l&&l.edits)for(const m of l.edits)typeof m.resource=="object"?m.resource=R.URI.revive(m.resource):(m.newUri=R.URI.revive(m.newUri),m.oldUri=R.URI.revive(m.oldUri)),m.metadata&&m.metadata.iconPath&&(m.metadata=(0,p.revive)(m.metadata));return l}e.reviveWorkspaceEditDto=f;var y;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(y=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,D.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,D.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,D.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,D.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,D.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,D.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,D.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,D.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,D.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,D.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,D.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,D.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,D.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,D.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,D.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,D.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,D.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,D.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,D.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,D.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,D.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,D.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,D.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,D.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,D.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,D.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,D.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,D.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,D.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,D.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,D.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,D.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,D.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,D.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,D.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,D.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,D.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,D.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,D.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,D.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,D.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,D.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,D.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,D.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,D.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadTheming:(0,D.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,D.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,D.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,D.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,D.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,D.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,D.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,D.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,D.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,D.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,D.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,D.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,D.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,D.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,D.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,D.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,D.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,D.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,D.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,D.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,D.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,D.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,D.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,D.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,D.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,D.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,D.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,D.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,D.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,D.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,D.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,D.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,D.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookKernels:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,D.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostTheming:(0,D.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,D.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,D.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,D.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,D.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,D.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[74],_e([0,1,5,3,4]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class T{constructor(S){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=S.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(S){this._onDidChangePassword.fire(S)}get(S,E){return this._proxy.$getPassword(S,E)}store(S,E,k){return this._proxy.$setPassword(S,E,k)}delete(S,E){return this._proxy.$deletePassword(S,E)}}e.ExtHostSecretState=T,e.IExtHostSecretState=(0,D.createDecorator)("IExtHostSecretState")}),define(be[75],_e([0,1,4,17,5,16]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,p.createDecorator)("IExtHostApiDeprecationService");let _=class{constructor(E,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(D.MainContext.MainThreadTelemetry)}report(E,k,i){const I=this.getUsageKey(E,k);this._reportedUsages.has(I)||(this._reportedUsages.add(I),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:E}))}getUsageKey(E,k){return`${E}-${k.identifier.value}`}};_=ze([je(0,T.IExtHostRpcService),je(1,R.ILogService)],_),e.ExtHostApiDeprecationService=_,e.NullApiDeprecationService=Object.freeze(new class{report(S,E,k){}})}),define(be[188],_e([0,1,3,5,7,26]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class _{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new p.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(E,k,i,I={}){const d=T.ExtensionIdentifier.toKey(E.identifier),g=this._inFlightRequests.get(d)||[],o=[...i].sort().join(" ");let a=g.find(w=>w.scopes===o);if(a)return a.result;{const w=this._getSession(E,d,k,i,I);a={scopes:o,result:w},g.push(a),this._inFlightRequests.set(d,g);try{await w}finally{const f=g.findIndex(y=>y.scopes===o);f>-1&&(g.splice(f),this._inFlightRequests.set(d,g))}return w}}async _getSession(E,k,i,I,d={}){await this._proxy.$ensureProvider(i);const g=E.displayName||E.name;return this._proxy.$getSession(i,I,k,g,d)}async removeSession(E,k){const i=this._authenticationProviders.get(E);return i?i.provider.removeSession(k):this._proxy.$removeSession(E,k)}registerAuthenticationProvider(E,k,i,I){var d;if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:k,provider:i,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(o=>o.id===E)||this._providers.push({id:E,label:k});const g=i.onDidChangeSessions(o=>{var a,w,f;this._proxy.$sendDidChangeSessions(E,{added:(a=o.added)!==null&&a!==void 0?a:[],changed:(w=o.changed)!==null&&w!==void 0?w:[],removed:(f=o.removed)!==null&&f!==void 0?f:[]})});return this._proxy.$registerAuthenticationProvider(E,k,(d=I==null?void 0:I.supportsMultipleAccounts)!==null&&d!==void 0?d:!1),new D.Disposable(()=>{g.dispose(),this._authenticationProviders.delete(E);const o=this._providers.findIndex(a=>a.id===E);o>-1&&this._providers.splice(o),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,k){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,k){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,k){const i=this._authenticationProviders.get(E);if(i)return Promise.resolve(i.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,k){return this._onDidChangeSessions.fire({provider:{id:E,label:k}}),Promise.resolve()}$onDidChangeAuthenticationProviders(E,k){return E.forEach(i=>{this._providers.some(I=>I.id===i.id)||this._providers.push(i)}),k.forEach(i=>{const I=this._providers.findIndex(d=>d.id===i.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:E,removed:k}),Promise.resolve()}}e.ExtHostAuthentication=_}),define(be[189],_e([0,1,5,16,10]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let T=class{constructor(S,E){this._extHostDocumentsAndEditors=E,this._proxy=S.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(S){const E=D.WorkspaceEdit.from(S,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(E)}};T=ze([je(0,R.IExtHostRpcService)],T),e.ExtHostBulkEdits=T}),define(be[190],_e([0,1,5]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(T){const _=T.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return _.$readText()},writeText(S){return _.$writeText(S)}})}}e.ExtHostClipboard=R}),define(be[76],_e([0,1,9,7,10,23,5,14,17,58,31,38,2,6,4,16]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let w=class{constructor(t,n){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(_.MainContext.MainThreadCommands),this._logService=n,this.converter=new f(this,r=>{const s=this._apiCommands.get(r);return(s==null?void 0:s.result)===l.Void?s:void 0},n),this._argumentProcessors=[{processArgument(r){return(0,k.revive)(r)}},{processArgument(r){return(0,T.cloneAndChange)(r,function(s){if(i.Range.isIRange(s))return D.Range.to(s);if(I.Position.isIPosition(s))return D.Position.to(s);if(i.Range.isIRange(s.range)&&d.URI.isUri(s.uri))return D.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const n=this.registerCommand(!1,t.id,async(...r)=>{const s=t.args.map((v,b)=>{if(!v.validate(r[b]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${r[b]}`);return v.convert(r[b])}),u=await this.executeCommand(t.internalId,...s);return t.result.convert(u,r,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{n.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,n,r,s,u){if(this._logService.trace("ExtHostCommands#registerCommand",n),!n.trim().length)throw new Error("invalid id");if(this._commands.has(n))throw new Error(`command '${n}' already exists`);return this._commands.set(n,{callback:r,thisArg:s,description:u}),t&&this._proxy.$registerCommand(n),new R.Disposable(()=>{this._commands.delete(n)&&t&&this._proxy.$unregisterCommand(n)})}executeCommand(t,...n){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,n,!0)}async _doExecuteCommand(t,n,r){if(this._commands.has(t))return this._executeContributedCommand(t,n);{const s=(0,T.cloneAndChange)(n,function(u){if(u instanceof R.Position)return D.Position.from(u);if(u instanceof R.Range)return D.Range.from(u);if(u instanceof R.Location)return D.location.from(u);if(R.NotebookRange.isNotebookRange(u))return D.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,s,r);return(0,k.revive)(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,n,!1);throw u}}}async _executeContributedCommand(t,n){const r=this._commands.get(t);if(!r)throw new Error("Unknown command");let{callback:s,thisArg:u,description:v}=r;if(v)for(let b=0;b<v.args.length;b++)try{(0,p.validateConstraint)(n[b],v.args[b].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[b].name}' - ${v.args[b].description}`)}try{return await s.apply(u,n)}catch(b){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...n);P&&(t=P.command)}throw this._logService.error(b,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...n){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(n=n.map(r=>this._argumentProcessors.reduce((s,u)=>u.processArgument(s),r)),this._executeContributedCommand(t,n)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(n=>(t&&(n=n.filter(r=>r[0]!=="_")),n))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[n,r]of this._commands){let{description:s}=r;s&&(t[n]=s)}return Promise.resolve(t)}};w=ze([je(0,a.IExtHostRpcService),je(1,E.ILogService)],w),e.ExtHostCommands=w,e.IExtHostCommands=(0,o.createDecorator)("IExtHostCommands");class f{constructor(t,n,r){this._commands=t,this._lookupApiCommand=n,this._logService=r,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,n){if(!t)return;const r={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return r;const s=this._lookupApiCommand(t.command);if(s)r.id=s.internalId,r.arguments=s.args.map((u,v)=>u.convert(t.arguments&&t.arguments[v]));else if((0,S.isNonEmptyArray)(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),n.add((0,g.toDisposable)(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),r.$ident=u,r.id=this.delegatingCommandId,r.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return r}fromInternal(t){const n=_.ObjectIdentifier.of(t);return typeof n=="number"?this._cache.get(n):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const n=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],n?n.command:"MISSING"),n?this._commands.executeCommand(n.command,...n.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=f;class y{constructor(t,n,r,s){this.name=t,this.description=n,this.validate=r,this.convert=s}optional(){return new y(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,n){return new y(t??this.name,n??this.description,this.validate,this.convert)}}e.ApiCommandArgument=y,y.Uri=new y("uri","Uri of a text document",h=>d.URI.isUri(h),h=>h),y.Position=new y("position","A position in a text document",h=>R.Position.isPosition(h),D.Position.from),y.Range=new y("range","A range in a text document",h=>R.Range.isRange(h),D.Range.from),y.Selection=new y("selection","A selection in a text document",h=>R.Selection.isSelection(h),D.Selection.from),y.Number=new y("number","",h=>typeof h=="number",h=>h),y.String=new y("string","",h=>typeof h=="string",h=>h),y.CallHierarchyItem=new y("item","A call hierarchy item",h=>h instanceof R.CallHierarchyItem,D.CallHierarchyItem.to);class l{constructor(t,n){this.description=t,this.convert=n}}e.ApiCommandResult=l,l.Void=new l("no result",h=>h);class m{constructor(t,n,r,s,u){this.id=t,this.internalId=n,this.description=r,this.args=s,this.result=u}}e.ApiCommand=m}),define(be[191],_e([0,1,6,10,7,63,76,170,14,87]),function(X,e,p,R,D,T,_,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const i=[new _.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",d(R.DocumentHighlight.to))),new _.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,a)=>{if((0,E.isFalsyOrEmpty)(o))return;class w extends D.SymbolInformation{static to(y){const l=new w(y.name,R.SymbolKind.to(y.kind),y.containerName||"",new D.Location(a[0],R.Range.to(y.range)));return l.detail=y.detail,l.range=l.location.range,l.selectionRange=R.Range.to(y.selectionRange),l.children=y.children?y.children.map(w.to):[],l}}return o.map(w.to)})),new _.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new _.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range,new _.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new _.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,new _.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new _.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new _.ApiCommandResult("A promise that resolves to an array of TextEdits.",d(R.TextEdit.to))),new _.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",g)),new _.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Location-instances.",d(R.location.to))),new _.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A promise that resolves to an array of Hover-instances.",d(R.Hover.to))),new _.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(a=>D.Position.isPosition(a)),o=>o.map(R.Position.from))],new _.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(a=>{let w;for(const f of a.reverse())w=new D.SelectionRange(R.Range.to(f),w);return w}))),new _.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[_.ApiCommandArgument.String.with("query","Search string")],new _.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const a=[];if(Array.isArray(o))for(let w of o)a.push(...w[1].map(R.WorkspaceSymbol.to));return a})),new _.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position],new _.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(R.CallHierarchyItem.to))),new _.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(R.CallHierarchyIncomingCall.to))),new _.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[_.ApiCommandArgument.CallHierarchyItem],new _.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(R.CallHierarchyOutgoingCall.to))),new _.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("newName","The new symbol name")],new _.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return R.WorkspaceEdit.to(o)}})),new _.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new _.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(R.DocumentLink.to))),new _.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new D.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const a=(0,k.decodeSemanticTokensDto)(o);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new D.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new _.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const a=(0,k.decodeSemanticTokensDto)(o);if(a.type==="full")return new D.SemanticTokens(a.data,void 0)})),new _.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new _.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,a,w)=>{if(!o)return new D.CompletionList([]);const f=o.suggestions.map(y=>R.CompletionItem.to(y,w));return new D.CompletionList(f,o.incomplete)})),new _.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Position,_.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new _.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return R.SignatureHelp.to(o)})),new _.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new _.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,a,w)=>d(f=>new D.CodeLens(R.Range.to(f.range),f.command&&w.fromInternal(f.command)))(o))),new _.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>D.Range.isRange(o),o=>D.Selection.isSelection(o)?R.Selection.from(o):R.Range.from(o)),_.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),_.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new _.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,a,w)=>d(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return w.fromInternal(f.command)}else{const y=new D.CodeAction(f.title,f.kind?new D.CodeActionKind(f.kind):void 0);return f.edit&&(y.edit=R.WorkspaceEdit.to(f.edit)),f.command&&(y.command=w.fromInternal(f.command)),y.isPreferred=f.isPreferred,y}})(o))),new _.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[_.ApiCommandArgument.Uri],new _.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(a=>new D.ColorInformation(R.Range.to(a.range),R.Color.to(a.color))):[])),new _.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new _.ApiCommandArgument("color","The color to show and insert",o=>o instanceof D.Color,R.Color.from),new _.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:R.Range.from(o.range)}))],new _.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(R.ColorPresentation.to):[])),new _.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inline hints provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(R.InlayHint.to))),new _.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new _.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",d(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(a=>R.NotebookExclusiveDocumentPattern.to(a))})))),new _.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[_.ApiCommandArgument.Uri,_.ApiCommandArgument.Range],new _.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(R.InlineValue.to))),new _.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[_.ApiCommandArgument.Uri,new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[R.ViewColumn.from(o.viewColumn),R.TextEditorOpenOptions.from(o)])).optional(),_.ApiCommandArgument.String.with("label","").optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[_.ApiCommandArgument.Uri.with("resource","Resource to open"),_.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[R.ViewColumn.from(o.viewColumn),R.TextEditorOpenOptions.from(o)])).optional()],_.ApiCommandResult.Void),new _.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[_.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),_.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),_.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new _.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[R.ViewColumn.from(o.viewColumn),R.TextEditorOpenOptions.from(o)]).optional()],_.ApiCommandResult.Void)];class I{constructor(a){this._disposables=new p.DisposableStore,this._commands=a}static register(a){return i.forEach(a.registerApiCommand,a),new I(a).registerCommands()}registerCommands(){const a=w=>(...f)=>w(this._commands,...f);this._register(S.RemoveFromRecentlyOpenedAPICommand.ID,a(S.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:w=>typeof w=="string"}]})}_register(a,w,f){const y=this._commands.registerCommand(!1,a,w,this,f);this._disposables.add(y)}}e.ExtHostApiCommands=I;function d(o){return a=>{if(Array.isArray(a))return a.map(o)}}function g(o){if(!Array.isArray(o))return;const a=[];for(const w of o)T.isLocationLink(w)?a.push(R.DefinitionLink.to(w)):a.push(R.location.to(w));return a}}),define(be[192],_e([0,1,11,53,3,6,2,63,26,10,7,5]),function(X,e,p,R,D,T,_,S,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class d{constructor(m,h,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=m.getProxy(I.MainContext.MainThreadComments),h.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===6){const r=this._commentControllers.get(n.handle);return r||n}else if(n&&n.$mid===7){const r=this._commentControllers.get(n.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.commentThreadHandle);return s||n}else if(n&&n.$mid===8){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.thread.commentThreadHandle);return s?{thread:s,text:n.text}:n}else if(n&&n.$mid===9){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.commentUniqueId,v=s.getCommentByUniqueId(u);return v||n}else if(n&&n.$mid===10){const r=this._commentControllers.get(n.thread.commentControlHandle);if(!r)return n;const s=r.getCommentThread(n.thread.commentThreadHandle);if(!s)return n;let u=n.text,v=n.commentUniqueId,b=s.getCommentByUniqueId(v);return b?(b.body=u,b):n}return n}})}createCommentController(m,h,t){const n=d.handlePool++,r=new o(m,n,this._proxy,h,t);this._commentControllers.set(r.handle,r);const s=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(m.identifier))||[];return s.push(r),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(m.identifier),s),r}$createCommentThreadTemplate(m,h,t){const n=this._commentControllers.get(m);!n||n.$createCommentThreadTemplate(h,t)}async $updateCommentThreadTemplate(m,h,t){const n=this._commentControllers.get(m);!n||n.$updateCommentThreadTemplate(h,t)}$deleteCommentThread(m,h){const t=this._commentControllers.get(m);t&&t.$deleteCommentThread(h)}$provideCommentingRanges(m,h,t){const n=this._commentControllers.get(m);if(!n||!n.commentingRangeProvider)return Promise.resolve(void 0);const r=this._documents.getDocument(_.URI.revive(h));return(0,p.asPromise)(()=>n.commentingRangeProvider.provideCommentingRanges(r,t)).then(s=>s?s.map(u=>k.Range.from(u)):void 0)}$toggleReaction(m,h,t,n,r){const s=this._commentControllers.get(m);return!s||!s.reactionHandler?Promise.resolve(void 0):(0,p.asPromise)(()=>{const u=s.getCommentThread(h);if(u){const v=u.getCommentByUniqueId(n.uniqueIdInThread);if(s!==void 0&&v&&s.reactionHandler)return s.reactionHandler(v,f(r))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=d,d.handlePool=0;class g{constructor(m,h,t,n,r,s,u){this._proxy=m,this._commentController=h,this._id=t,this._uri=n,this._range=r,this._comments=s,this.handle=g._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new D.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputDisposables.value=new T.DisposableStore,this._id===void 0&&(this._id=`${h.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,k.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=s}set threadId(m){this._id=m}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(m){m.isEqual(this._range)||(this._range=m,this.modifications.range=m,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(m){this._canReply!==m&&(this._canReply=m,this.modifications.canReply=m,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(m){this._label=m,this.modifications.label=m,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(m){this._contextValue=m,this.modifications.contextValue=m,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(m){this._comments=m,this.modifications.comments=m,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(m){this._collapseState=m,this.modifications.collapsibleState=m,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new T.DisposableStore);const m=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),h={};m("range")&&(h.range=k.Range.from(this._range)),m("label")&&(h.label=this.label),m("contextValue")&&(h.contextValue=this.contextValue),m("comments")&&(h.comments=this._comments.map(t=>a(this,this._commentController,t,this._commentsMap))),m("collapsibleState")&&(h.collapseState=y(this._collapseState)),m("canReply")&&(h.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,h)}getCommentByUniqueId(m){for(let h of this._commentsMap){let t=h[0],n=h[1];if(m===n)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(m=>m.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}g._handlePool=0,ze([(0,R.debounce)(100)],g.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=g;class o{constructor(m,h,t,n,r){this._extension=m,this._handle=h,this._proxy=t,this._id=n,this._label=r,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,r)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(m){this._reactionHandler=m,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!m})}get options(){return this._options}set options(m){this._options=m,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(m,h,t,n){if(typeof m=="string"){const r=new g(this._proxy,this,m,h,t,n,this._extension.identifier);return this._threads.set(r.handle,r),r}else{const r=new g(this._proxy,this,void 0,m,h,t,this._extension.identifier);return this._threads.set(r.handle,r),r}}$createCommentThreadTemplate(m,h){const t=new g(this._proxy,this,void 0,_.URI.revive(m),k.Range.to(h),[],this._extension.identifier);return t.collapsibleState=S.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(m,h){let t=this._threads.get(m);t&&(t.range=k.Range.to(h))}$deleteCommentThread(m){let h=this._threads.get(m);h&&h.dispose(),this._threads.delete(m)}getCommentThread(m){return this._threads.get(m)}dispose(){this._threads.forEach(m=>{m.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function a(l,m,h,t){let n=t.get(h);n||(n=++l.commentHandle,t.set(h,n));const r=h.author&&h.author.iconPath?h.author.iconPath.toString():void 0;return{mode:h.mode,contextValue:h.contextValue,uniqueIdInThread:n,body:k.MarkdownString.from(h.body),userName:h.author.name,userIconPath:r,label:h.label,commentReactions:h.reactions?h.reactions.map(s=>w(s)):void 0}}function w(l){return{label:l.label,iconPath:l.iconPath?k.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function f(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?_.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function y(l){if(l!==void 0)switch(l){case i.CommentThreadCollapsibleState.Expanded:return S.CommentThreadCollapsibleState.Expanded;case i.CommentThreadCollapsibleState.Collapsed:return S.CommentThreadCollapsibleState.Collapsed}return S.CommentThreadCollapsibleState.Collapsed}}),define(be[101],_e([0,1,2,5,7,4,16,17,14,8,12]),function(X,e,p,R,D,T,_,S,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class pn{constructor(g,o){this._logService=o,this._provider=new Map,this._proxy=g.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,o){const a=pn._handlePool++;this._provider.set(a,{provider:g,extensionId:o}),this._proxy.$registerDecorationProvider(a,o.value);const w=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(f=>{if(!f){this._proxy.$onDidChange(a,null);return}let y=(0,E.asArray)(f);if(y.length<=pn._maxEventSize){this._proxy.$onDidChange(a,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",o.value,y.length);const l=y.map(t=>({uri:t,rank:(0,k.count)(t.path,"/")})),m=(0,E.groupBy)(l,(t,n)=>t.rank-n.rank||(0,k.compare)(t.uri.path,n.uri.path));let h=[];e:for(let t of m){let n;for(let r of t){let s=(0,i.dirname)(r.uri.path);if(n!==s&&(n=s,h.push(r.uri)>=pn._maxEventSize))break e}}this._proxy.$onDidChange(a,h)});return new D.Disposable(()=>{w==null||w.dispose(),this._proxy.$unregisterDecorationProvider(a),this._provider.delete(a)})}async $provideDecorations(g,o,a){if(!this._provider.has(g))return Object.create(null);const w=Object.create(null),{provider:f,extensionId:y}=this._provider.get(g);return await Promise.all(o.map(async l=>{try{const{uri:m,id:h}=l,t=await Promise.resolve(f.provideFileDecoration(p.URI.revive(m),a));if(!t)return;try{D.FileDecoration.validate(t),w[h]=[t.propagate,t.tooltip,t.badge,t.color]}catch(n){this._logService.warn(`INVALID decoration from extension '${y.value}': ${n}`)}}catch(m){this._logService.error(m)}})),w}};I._handlePool=0,I._maxEventSize=250,I=ze([je(0,_.IExtHostRpcService),je(1,S.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=(0,T.createDecorator)("IExtHostDecorations")}),define(be[193],_e([0,1,133,90,2,5,7,10,3,17,22]),function(X,e,p,R,D,T,_,S,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(o,a,w,f,y){this._name=o,this._owner=a,this._maxDiagnosticsPerFile=w,this._proxy=f,this._onDidChangeDiagnostics=y,this._isDisposed=!1,this._data=new i.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(o,a){if(!o){this.clear();return}this._checkDisposed();let w=[];if(D.URI.isUri(o)){if(!a){this.delete(o);return}this._data.set(o,a.slice()),w=[o]}else if(Array.isArray(o)){w=[];let y;o=[...o].sort(I._compareIndexedTuplesByUri);for(const l of o){const[m,h]=l;if((!y||m.toString()!==y.toString())&&(y&&this._data.get(y).length===0&&this._data.delete(y),y=m,w.push(m),this._data.set(m,[])),h){const t=this._data.get(m);t&&t.push(...h)}else{const t=this._data.get(m);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(w),!this._proxy)return;const f=[];for(let y of w){let l=[];const m=this._data.get(y);if(m)if(m.length>this._maxDiagnosticsPerFile){l=[];const h=[_.DiagnosticSeverity.Error,_.DiagnosticSeverity.Warning,_.DiagnosticSeverity.Information,_.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let n of m)if(n.severity===h[t]&&l.push(S.Diagnostic.from(n))===this._maxDiagnosticsPerFile)break e;l.push({severity:R.MarkerSeverity.Info,message:(0,p.localize)(0,null,m.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=m.map(h=>S.Diagnostic.from(h));f.push([y,l])}this._proxy.$changeMany(this._owner,f)}delete(o){this._checkDisposed(),this._onDidChangeDiagnostics.fire([o]),this._data.delete(o),this._proxy&&this._proxy.$changeMany(this._owner,[[o,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(o,a){this._checkDisposed();for(let w of this._data.keys())o.apply(a,[w,this.get(w),this])}get(o){this._checkDisposed();const a=this._data.get(o);return Array.isArray(a)?Object.freeze(a.slice(0)):[]}has(o){return this._checkDisposed(),Array.isArray(this._data.get(o))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(o,a){return o[0].toString()<a[0].toString()?-1:o[0].toString()>a[0].toString()?1:0}}e.DiagnosticCollection=I;let d=class zt{constructor(o,a){this._logService=a,this._collections=new Map,this._onDidChangeDiagnostics=new E.Emitter,this.onDidChangeDiagnostics=E.Event.map(E.Event.debounce(this._onDidChangeDiagnostics.event,zt._debouncer,50),zt._mapper),this._proxy=o.getProxy(T.MainContext.MainThreadDiagnostics)}static _debouncer(o,a){return o?o.concat(a):a}static _mapper(o){const a=new i.ResourceMap;for(const w of o)a.set(w,w);return{uris:Object.freeze(Array.from(a.values()))}}createDiagnosticCollection(o,a){const{_collections:w,_proxy:f,_onDidChangeDiagnostics:y,_logService:l}=this,m=new class{$changeMany(n,r){f.$changeMany(n,r),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,n,r.length===0?"CLEARING":r)}$clear(n){f.$clear(n),l.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,n)}dispose(){f.dispose()}};let h;if(!a)a="_generated_diagnostic_collection_name_#"+zt._idPool++,h=a;else if(!w.has(a))h=a;else{this._logService.warn(`DiagnosticCollection with name '${a}' does already exist.`);do h=a+zt._idPool++;while(w.has(h))}return new class extends I{constructor(){super(a,h,zt._maxDiagnosticsPerFile,m,y);w.set(h,this)}dispose(){super.dispose(),w.delete(h)}}}getDiagnostics(o){if(o)return this._getDiagnostics(o);{const a=new Map,w=[];for(const f of this._collections.values())f.forEach((y,l)=>{let m=a.get(y.toString());typeof m=="undefined"&&(m=w.length,a.set(y.toString(),m),w.push([y,[]])),w[m][1]=w[m][1].concat(...l)});return w}}_getDiagnostics(o){let a=[];for(let w of this._collections.values())w.has(o)&&(a=a.concat(w.get(o)));return a}$acceptMarkersChange(o){if(!this._mirrorCollection){const a="_generated_mirror",w=new I(a,a,zt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(a,w),this._mirrorCollection=w}for(const[a,w]of o)this._mirrorCollection.set(D.URI.revive(a),w.map(S.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([je(1,k.ILogService)],d),e.ExtHostDiagnostics=d}),define(be[194],_e([0,1,2,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class D{constructor(_){this._proxy=_.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(_){return this._proxy.$showOpenDialog(_).then(S=>S?S.map(E=>p.URI.revive(E)):void 0)}showSaveDialog(_){return this._proxy.$showSaveDialog(_).then(S=>S?p.URI.revive(S):void 0)}}e.ExtHostDialogs=D}),define(be[195],_e([0,1,13,2,7,5,15,20,8]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(I,d,g){this._documentsAndEditors=d,this._logService=g,this._documentContentProviders=new Map,this._proxy=I.getProxy(T.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,d){if(Object.keys(_.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const g=k._handlePool++;this._documentContentProviders.set(g,d),this._proxy.$registerTextContentProvider(g,I);let o;return typeof d.onDidChange=="function"&&(o=d.onDidChange(a=>{if(a.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${a.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(a)&&this.$provideTextDocumentContent(g,a).then(w=>{if(!w&&typeof w!="string")return;const f=this._documentsAndEditors.getDocument(a);if(!f)return;const y=(0,E.splitLines)(w);if(!f.equalLines(y))return this._proxy.$onVirtualDocumentChange(a,w)},p.onUnexpectedError)})),new D.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),o&&(o.dispose(),o=void 0)})}$provideTextDocumentContent(I,d){const g=this._documentContentProviders.get(I);return g?Promise.resolve(g.provideTextDocumentContent(R.URI.revive(d),S.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[196],_e([0,1,3,6,2,5,96,10,9,23]),function(X,e,p,R,D,T,_,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class i{constructor(d,g){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(T.MainContext.MainThreadDocuments),this._documentsAndEditors=g,this._documentsAndEditors.onDidRemoveDocuments(o=>{for(const a of o)this._onDidRemoveDocument.fire(a.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(o=>{for(const a of o)this._onDidAddDocument.fire(a.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const g=this._documentsAndEditors.getDocument(d);if(g)return g}getDocument(d){const g=this.getDocumentData(d);if(!(g==null?void 0:g.document))throw new Error(`Unable to retrieve document from URI '${d}'`);return g.document}ensureDocumentData(d){const g=this._documentsAndEditors.getDocument(d);if(g)return Promise.resolve(g);let o=this._documentLoader.get(d.toString());return o||(o=this._proxy.$tryOpenDocument(d).then(a=>{this._documentLoader.delete(d.toString());const w=D.URI.revive(a);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(w))},a=>(this._documentLoader.delete(d.toString()),Promise.reject(a))),this._documentLoader.set(d.toString(),o)),o}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(g=>D.URI.revive(g))}$acceptModelModeChanged(d,g){const o=D.URI.revive(d),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");this._onDidRemoveDocument.fire(a.document),a._acceptLanguageId(g),this._onDidAddDocument.fire(a.document)}$acceptModelSaved(d){const g=D.URI.revive(d),o=this._documentsAndEditors.getDocument(g);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(o.document)}$acceptDirtyStateChanged(d,g){const o=D.URI.revive(d),a=this._documentsAndEditors.getDocument(o);if(!a)throw new Error("unknown document");a._acceptIsDirty(g),this._onDidChangeDocument.fire({document:a.document,contentChanges:[]})}$acceptModelChanged(d,g,o){const a=D.URI.revive(d),w=this._documentsAndEditors.getDocument(a);if(!w)throw new Error("unknown document");w._acceptIsDirty(o),w.onEvents(g),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:w.document,contentChanges:g.changes.map(f=>({range:S.Range.to(f.range),rangeOffset:f.rangeOffset,rangeLength:f.rangeLength,text:f.text}))}))}setWordDefinitionFor(d,g){(0,_.setWordDefinitionFor)(d,g)}}e.ExtHostDocuments=i}),define(be[39],_e([0,1,42,3,6,2,4,5,96,16,99,10,17,22,15,43,110]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class f{constructor(m){this.value=m,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(m,h){this._extHostRpc=m,this._logService=h,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(m){this.acceptDocumentsAndEditorsDelta(m)}acceptDocumentsAndEditorsDelta(m){const h=[],t=[],n=[];if(m.removedDocuments)for(const r of m.removedDocuments){const s=T.URI.revive(r),u=this._documents.get(s);(u==null?void 0:u.unref())&&(this._documents.delete(s),h.push(u.value))}if(m.addedDocuments)for(const r of m.addedDocuments){const s=T.URI.revive(r.uri);let u=this._documents.get(s);if(u&&s.scheme!==o.Schemas.vscodeNotebookCell)throw new Error(`document '${s} already exists!'`);u||(u=new f(new E.ExtHostDocumentData(this._extHostRpc.getProxy(S.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.modeId,r.isDirty,r.notebook)),this._documents.set(s,u),t.push(u.value)),u.ref()}if(m.removedEditors)for(const r of m.removedEditors){const s=this._editors.get(r);this._editors.delete(r),s&&n.push(s)}if(m.addedEditors)for(const r of m.addedEditors){const s=T.URI.revive(r.documentUri);p.ok(this._documents.has(s),`document '${s}' does not exist`),p.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const u=this._documents.get(s).value,v=new i.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(S.MainContext.MainThreadTextEditors),this._logService,new w.Lazy(()=>u.document),r.selections.map(I.Selection.to),r.options,r.visibleRanges.map(b=>I.Range.to(b)),typeof r.editorPosition=="number"?I.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,v)}m.newActiveEditor!==void 0&&(p.ok(m.newActiveEditor===null||this._editors.has(m.newActiveEditor),`active editor '${m.newActiveEditor}' does not exist`),this._activeEditorId=m.newActiveEditor),(0,D.dispose)(h),(0,D.dispose)(n),m.removedDocuments&&this._onDidRemoveDocuments.fire(h),m.addedDocuments&&this._onDidAddDocuments.fire(t),(m.removedEditors||m.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),m.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(m){var h;return(h=this._documents.get(m))===null||h===void 0?void 0:h.value}allDocuments(){return a.Iterable.map(this._documents.values(),m=>m.value)}getEditor(m){return this._editors.get(m)}activeEditor(m){if(!this._activeEditorId)return;const h=this._editors.get(this._activeEditorId);return m?h:h==null?void 0:h.value}allEditors(){return[...this._editors.values()]}};y=ze([je(0,k.IExtHostRpcService),je(1,d.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,_.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[197],_e([0,1,2,5,6,7,10,121,8,25]),function(X,e,p,R,D,T,_,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class i{constructor(){this._schemes=[]}add(g){this._stateMachine=void 0,this._schemes.push(g)}delete(g){const o=this._schemes.indexOf(g);o>=0&&(this._schemes.splice(o,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const g=this._schemes.sort(),o=[];let a,w,f=14,y=14;for(const l of g){let m=a?(0,E.commonPrefixLength)(a,l):0;for(m===0?w=1:w=y;m<l.length;m++)m+1===l.length?(f=y,y=9):y+=1,o.push([w,l.toUpperCase().charCodeAt(m),y]),o.push([w,l.toLowerCase().charCodeAt(m),y]),w=y;a=l,y=f}o.push([9,58,10]),o.push([10,47,12]),this._stateMachine=new S.StateMachine(o)}}provideDocumentLinks(g){this._initStateMachine();const o=[],a=S.LinkComputer.computeLinks({getLineContent(w){return g.lineAt(w-1).text},getLineCount(){return g.lineCount}},this._stateMachine);for(const w of a){const f=_.DocumentLink.to(w);f.target&&o.push(f)}return o}}class I{constructor(g,o){this._extHostLanguageFeatures=o,this._linkProvider=new i,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=g.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var g;(g=this._linkProviderRegistration)===null||g===void 0||g.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(g,o,a,w={},f){if(this._registeredSchemes.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const y=this._handlePool++;this._linkProvider.add(o),this._registeredSchemes.add(o),this._fsProvider.set(y,a),this._enableProposedApi.set(y,f??!1);let l=2;w.isCaseSensitive&&(l+=1024),w.isReadonly&&(l+=2048),typeof a.copy=="function"&&(l+=8),typeof a.open=="function"&&typeof a.close=="function"&&typeof a.read=="function"&&typeof a.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(y,o,l).catch(h=>{console.error(`FAILED to register filesystem provider of ${g.value}-extension for the scheme ${o}`),console.error(h)});const m=a.onDidChangeFile(h=>{const t=[];for(const n of h){let{uri:r,type:s}=n;if(r.scheme!==o)continue;let u;switch(s){case T.FileChangeType.Changed:u=0;break;case T.FileChangeType.Created:u=1;break;case T.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:u})}this._proxy.$onFileSystemChange(y,t)});return(0,D.toDisposable)(()=>{m.dispose(),this._linkProvider.delete(o),this._registeredSchemes.delete(o),this._fsProvider.delete(y),this._enableProposedApi.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(g,o){const{type:a,ctime:w,mtime:f,size:y,permissions:l}=g;return o?{type:a,ctime:w,mtime:f,size:y,permissions:l}:{type:a,ctime:w,mtime:f,size:y}}$stat(g,o){return Promise.resolve(this._getFsProvider(g).stat(p.URI.revive(o))).then(a=>{var w;return I._asIStat(a,(w=this._enableProposedApi.get(g))!==null&&w!==void 0?w:!1)})}$readdir(g,o){return Promise.resolve(this._getFsProvider(g).readDirectory(p.URI.revive(o)))}$readFile(g,o){return Promise.resolve(this._getFsProvider(g).readFile(p.URI.revive(o))).then(a=>k.VSBuffer.wrap(a))}$writeFile(g,o,a,w){return Promise.resolve(this._getFsProvider(g).writeFile(p.URI.revive(o),a.buffer,w))}$delete(g,o,a){return Promise.resolve(this._getFsProvider(g).delete(p.URI.revive(o),a))}$rename(g,o,a,w){return Promise.resolve(this._getFsProvider(g).rename(p.URI.revive(o),p.URI.revive(a),w))}$copy(g,o,a,w){const f=this._getFsProvider(g);if(!f.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(f.copy(p.URI.revive(o),p.URI.revive(a),w))}$mkdir(g,o){return Promise.resolve(this._getFsProvider(g).createDirectory(p.URI.revive(o)))}$watch(g,o,a,w){const f=this._getFsProvider(g).watch(p.URI.revive(a),w);this._watches.set(o,f)}$unwatch(g,o){const a=this._watches.get(o);a&&(a.dispose(),this._watches.delete(o))}$open(g,o,a){const w=this._getFsProvider(g);if(!w.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(w.open(p.URI.revive(o),a))}$close(g,o){const a=this._getFsProvider(g);if(!a.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(a.close(o))}$read(g,o,a,w){const f=this._getFsProvider(g);if(!f.read)throw new Error('FileSystemProvider does not implement "read"');const y=k.VSBuffer.alloc(w);return Promise.resolve(f.read(o,a,y.buffer,0,w)).then(l=>y.slice(0,l))}$write(g,o,a,w){const f=this._getFsProvider(g);if(!f.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(f.write(o,a,w.buffer,0,w.byteLength))}_getFsProvider(g){const o=this._fsProvider.get(g);if(!o){const a=new Error;throw a.name="ENOPRO",a.message="no provider",a}return o}}e.ExtHostFileSystem=I}),define(be[77],_e([0,1,5,65,7,25,4,16,49]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class Ut{constructor(I,d){const g=I.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(o){return g.$stat(o).catch(Ut._handleError)},readDirectory(o){return g.$readdir(o).catch(Ut._handleError)},createDirectory(o){return g.$mkdir(o).catch(Ut._handleError)},async readFile(o){return g.$readFile(o).then(a=>a.buffer).catch(Ut._handleError)},writeFile(o,a){return g.$writeFile(o,T.VSBuffer.wrap(a)).catch(Ut._handleError)},delete(o,a){return g.$delete(o,Object.assign({recursive:!1,useTrash:!1},a)).catch(Ut._handleError)},rename(o,a,w){return g.$rename(o,a,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},copy(o,a,w){return g.$copy(o,a,Object.assign({overwrite:!1},w)).catch(Ut._handleError)},isWritableFileSystem(o){const a=d.getCapabilities(o);if(typeof a=="number")return!(a&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new D.FileSystemError(String(I));if(I.name==="ENOPRO")throw D.FileSystemError.Unavailable(I.message);switch(I.name){case R.FileSystemProviderErrorCode.FileExists:throw D.FileSystemError.FileExists(I.message);case R.FileSystemProviderErrorCode.FileNotFound:throw D.FileSystemError.FileNotFound(I.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw D.FileSystemError.FileNotADirectory(I.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw D.FileSystemError.FileIsADirectory(I.message);case R.FileSystemProviderErrorCode.NoPermissions:throw D.FileSystemError.NoPermissions(I.message);case R.FileSystemProviderErrorCode.Unavailable:throw D.FileSystemError.Unavailable(I.message);default:throw new D.FileSystemError(I.message,I.name)}}};k=ze([je(0,S.IExtHostRpcService),je(1,E.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,_.createDecorator)("IExtHostConsumerFileSystem")}),define(be[198],_e([0,1,6,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class D{constructor(_){this._handlePool=0,this._proxy=_.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(_){const S=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(S,_),(0,p.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(S)})}}e.ExtHostLabelService=D}),define(be[199],_e([0,1,2,23,10,7,11,5,8,31,14,9,118,6,87,55,68,56,13,3]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class m{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentSymbols(H,Y){const ne=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideDocumentSymbols(ne,Y)).then(re=>{if(!(0,i.isFalsyOrEmpty)(re))return re[0]instanceof T.DocumentSymbol?re.map(D.DocumentSymbol.from):m._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree(H){var Y;H=H.slice(0).sort((G,se)=>{let fe=G.location.range.start.compareTo(se.location.range.start);return fe===0&&(fe=se.location.range.end.compareTo(G.location.range.end)),fe});const ne=[],re=[];for(const G of H){const se={name:G.name||"!!MISSING: name!!",kind:D.SymbolKind.from(G.kind),tags:((Y=G.tags)===null||Y===void 0?void 0:Y.map(D.SymbolTag.from))||[],detail:"",containerName:G.containerName,range:D.Range.from(G.location.range),selectionRange:D.Range.from(G.location.range),children:[]};for(;;){if(re.length===0){re.push(se),ne.push(se);break}const fe=re[re.length-1];if(k.Range.containsRange(fe.range,se.range)&&!k.Range.equalsRange(fe.range,se.range)){fe.children&&fe.children.push(se),re.push(se);break}re.pop()}}return ne}}class h{constructor(H,Y,ne){this._documents=H,this._commands=Y,this._provider=ne,this._cache=new w.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(H,Y){const ne=this._documents.getDocument(H),re=await this._provider.provideCodeLenses(ne,Y);if(!re||Y.isCancellationRequested)return;const G=this._cache.add(re),se=new g.DisposableStore;this._disposables.set(G,se);const fe={cacheId:G,lenses:[]};for(let Ae=0;Ae<re.length;Ae++)fe.lenses.push({cacheId:[G,Ae],range:D.Range.from(re[Ae].range),command:this._commands.toInternal(re[Ae].command,se)});return fe}async resolveCodeLens(H,Y){var ne;const re=H.cacheId&&this._cache.get(...H.cacheId);if(!re)return;let G;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?G=re:G=await this._provider.resolveCodeLens(re,Y),G||(G=re),Y.isCancellationRequested)return;const se=H.cacheId&&this._disposables.get(H.cacheId[0]);if(!!se)return H.command=this._commands.toInternal((ne=G.command)!==null&&ne!==void 0?ne:h._badCmd,se),H}releaseCodeLenses(H){var Y;(Y=this._disposables.get(H))===null||Y===void 0||Y.dispose(),this._disposables.delete(H),this._cache.delete(H)}}h._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ge){return Array.isArray(Ge)?Ge.map(D.DefinitionLink.from):Ge?[D.DefinitionLink.from(Ge)]:[]}class n{constructor(H,Y){this._documents=H,this._provider=Y}provideDefinition(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideDefinition(re,G,ne)).then(t)}}class r{constructor(H,Y){this._documents=H,this._provider=Y}provideDeclaration(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideDeclaration(re,G,ne)).then(t)}}class s{constructor(H,Y){this._documents=H,this._provider=Y}provideImplementation(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideImplementation(re,G,ne)).then(t)}}class u{constructor(H,Y){this._documents=H,this._provider=Y}provideTypeDefinition(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideTypeDefinition(re,G,ne)).then(t)}}class v{constructor(H,Y){this._documents=H,this._provider=Y}provideHover(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideHover(re,G,ne)).then(se=>{if(!(!se||(0,i.isFalsyOrEmpty)(se.contents)))return se.range||(se.range=re.getWordRangeAtPosition(G)),se.range||(se.range=new T.Range(G,G)),D.Hover.from(se)})}}class b{constructor(H,Y){this._documents=H,this._provider=Y}provideEvaluatableExpression(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideEvaluatableExpression(re,G,ne)).then(se=>{if(se)return D.EvaluatableExpression.from(se)})}}class P{constructor(H,Y){this._documents=H,this._provider=Y}provideInlineValues(H,Y,ne,re){const G=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideInlineValues(G,D.Range.to(Y),D.InlineValueContext.to(ne),re)).then(se=>{if(Array.isArray(se))return se.map(fe=>D.InlineValue.from(fe))})}}class C{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentHighlights(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideDocumentHighlights(re,G,ne)).then(se=>{if(Array.isArray(se))return se.map(D.DocumentHighlight.from)})}}class c{constructor(H,Y){this._documents=H,this._provider=Y}provideLinkedEditingRanges(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideLinkedEditingRanges(re,G,ne)).then(se=>{if(se&&Array.isArray(se.ranges))return{ranges:(0,i.coalesce)(se.ranges.map(D.Range.from)),wordPattern:se.wordPattern}})}}class F{constructor(H,Y){this._documents=H,this._provider=Y}provideReferences(H,Y,ne,re){const G=this._documents.getDocument(H),se=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideReferences(G,se,ne,re)).then(fe=>{if(Array.isArray(fe))return fe.map(D.location.from)})}}class N{constructor(H,Y,ne,re,G,se,fe){this._documents=H,this._commands=Y,this._diagnostics=ne,this._provider=re,this._logService=G,this._extension=se,this._apiDeprecation=fe,this._cache=new w.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(H,Y,ne,re){const G=this._documents.getDocument(H),se=d.Selection.isISelection(Y)?D.Selection.to(Y):D.Range.to(Y),fe=[];for(const ge of this._diagnostics.getDiagnostics(H))if(se.intersection(ge.range)&&fe.push(ge)>N._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:ne.only?new T.CodeActionKind(ne.only):void 0,triggerKind:D.CodeActionTriggerKind.to(ne.trigger)};return(0,_.asPromise)(()=>this._provider.provideCodeActions(G,se,Ae,re)).then(ge=>{var We;if(!(0,i.isNonEmptyArray)(ge)||re.isCancellationRequested)return;const V=this._cache.add(ge),te=new g.DisposableStore;this._disposables.set(V,te);const pe=[];for(let Me=0;Me<ge.length;Me++){const $e=ge[Me];!$e||(N._isCommand($e)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),pe.push({_isSynthetic:!0,title:$e.title,command:this._commands.toInternal($e,te)})):(Ae.only&&($e.kind?Ae.only.contains($e.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${$e.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),pe.push({cacheId:[V,Me],title:$e.title,command:$e.command&&this._commands.toInternal($e.command,te),diagnostics:$e.diagnostics&&$e.diagnostics.map(D.Diagnostic.from),edit:$e.edit&&D.WorkspaceEdit.from($e.edit),kind:$e.kind&&$e.kind.value,isPreferred:$e.isPreferred,disabled:(We=$e.disabled)===null||We===void 0?void 0:We.reason})))}return{cacheId:V,actions:pe}})}async resolveCodeAction(H,Y){var ne;const[re,G]=H,se=this._cache.get(re,G);if(!se||N._isCommand(se)||!this._provider.resolveCodeAction)return;const fe=(ne=await this._provider.resolveCodeAction(se,Y))!==null&&ne!==void 0?ne:se;return(fe==null?void 0:fe.edit)?D.WorkspaceEdit.from(fe.edit):void 0}releaseCodeActions(H){var Y;(Y=this._disposables.get(H))===null||Y===void 0||Y.dispose(),this._disposables.delete(H),this._cache.delete(H)}static _isCommand(H){return typeof H.command=="string"&&typeof H.title=="string"}}N._maxCodeActionsPerFile=1e3;class z{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentFormattingEdits(H,Y,ne){const re=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideDocumentFormattingEdits(re,Y,ne)).then(G=>{if(Array.isArray(G))return G.map(D.TextEdit.from)})}}class he{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentRangeFormattingEdits(H,Y,ne,re){const G=this._documents.getDocument(H),se=D.Range.to(Y);return(0,_.asPromise)(()=>this._provider.provideDocumentRangeFormattingEdits(G,se,ne,re)).then(fe=>{if(Array.isArray(fe))return fe.map(D.TextEdit.from)})}}class me{constructor(H,Y){this._documents=H,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(H,Y,ne,re,G){const se=this._documents.getDocument(H),fe=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideOnTypeFormattingEdits(se,fe,ne,re,G)).then(Ae=>{if(Array.isArray(Ae))return Ae.map(D.TextEdit.from)})}}class Q{constructor(H,Y){this._provider=H,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(H,Y){const ne=S.IdObject.mixin({symbols:[]});return(0,_.asPromise)(()=>this._provider.provideWorkspaceSymbols(H,Y)).then(re=>{if((0,i.isNonEmptyArray)(re))for(const G of re){if(!G)continue;if(!G.name){this._logService.warn("INVALID SymbolInformation, lacks name",G);continue}const se=S.IdObject.mixin(D.WorkspaceSymbol.from(G));this._symbolCache.set(se._id,G),ne.symbols.push(se)}}).then(()=>(ne.symbols.length>0&&this._resultCache.set(ne._id,[ne.symbols[0]._id,ne.symbols[ne.symbols.length-1]._id]),ne))}async resolveWorkspaceSymbol(H,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return H;const ne=this._symbolCache.get(H._id);if(ne){const re=await(0,_.asPromise)(()=>this._provider.resolveWorkspaceSymbol(ne,Y));return re&&(0,R.mixin)(H,D.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(H){const Y=this._resultCache.get(H);if(Y){for(let[ne,re]=Y;ne<=re;ne++)this._symbolCache.delete(ne);this._resultCache.delete(H)}}}class W{constructor(H,Y,ne){this._documents=H,this._provider=Y,this._logService=ne}static supportsResolving(H){return typeof H.prepareRename=="function"}provideRenameEdits(H,Y,ne,re){const G=this._documents.getDocument(H),se=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.provideRenameEdits(G,se,ne,re)).then(fe=>{if(!!fe)return D.WorkspaceEdit.from(fe)},fe=>{const Ae=W._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)})}resolveRenameLocation(H,Y,ne){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(H),G=D.Position.to(Y);return(0,_.asPromise)(()=>this._provider.prepareRename(re,G,ne)).then(se=>{let fe,Ae;if(T.Range.isRange(se)?(fe=se,Ae=re.getText(se)):(0,I.isObject)(se)&&(fe=se.range,Ae=se.placeholder),!!fe){if(fe.start.line>G.line||fe.end.line<G.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:D.Range.from(fe),text:Ae}}},se=>{const fe=W._asMessage(se);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(se)})}static _asMessage(H){return typeof H=="string"?H:H instanceof Error&&typeof H.message=="string"?H.message:void 0}}class x{constructor(H,Y){this.resultId=H,this.tokens=Y}}class A{constructor(H,Y){this._documents=H,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(H,Y,ne){const re=this._documents.getDocument(H),G=Y!==0?this._previousResults.get(Y):null;return(0,_.asPromise)(()=>G&&typeof G.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,G.resultId,ne):this._provider.provideDocumentSemanticTokens(re,ne)).then(se=>(G&&this._previousResults.delete(Y),se?(se=A._fixProvidedSemanticTokens(se),this._send(A._convertToEdits(G,se),se)):null))}async releaseDocumentSemanticColoring(H){this._previousResults.delete(H)}static _fixProvidedSemanticTokens(H){return A._isSemanticTokens(H)?A._isCorrectSemanticTokens(H)?H:new T.SemanticTokens(new Uint32Array(H.data),H.resultId):A._isSemanticTokensEdits(H)?A._isCorrectSemanticTokensEdits(H)?H:new T.SemanticTokensEdits(H.edits.map(Y=>new T.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),H.resultId):H}static _isSemanticTokens(H){return H&&!!H.data}static _isCorrectSemanticTokens(H){return H.data instanceof Uint32Array}static _isSemanticTokensEdits(H){return H&&Array.isArray(H.edits)}static _isCorrectSemanticTokensEdits(H){for(const Y of H.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(H,Y){if(!A._isSemanticTokens(Y)||!H||!H.tokens)return Y;const ne=H.tokens,re=ne.length,G=Y.data,se=G.length;let fe=0;const Ae=Math.min(re,se);for(;fe<Ae&&ne[fe]===G[fe];)fe++;if(fe===re&&fe===se)return new T.SemanticTokensEdits([],Y.resultId);let ge=0;const We=Ae-fe;for(;ge<We&&ne[re-ge-1]===G[se-ge-1];)ge++;return new T.SemanticTokensEdits([{start:fe,deleteCount:re-fe-ge,data:G.subarray(fe,se-ge)}],Y.resultId)}_send(H,Y){if(A._isSemanticTokens(H)){const ne=this._nextResultId++;return this._previousResults.set(ne,new x(H.resultId,H.data)),(0,o.encodeSemanticTokensDto)({id:ne,type:"full",data:H.data})}if(A._isSemanticTokensEdits(H)){const ne=this._nextResultId++;return A._isSemanticTokens(Y)?this._previousResults.set(ne,new x(Y.resultId,Y.data)):this._previousResults.set(ne,new x(H.resultId)),(0,o.encodeSemanticTokensDto)({id:ne,type:"delta",deltas:(H.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=A;class U{constructor(H,Y){this._documents=H,this._provider=Y}provideDocumentRangeSemanticTokens(H,Y,ne){const re=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideDocumentRangeSemanticTokens(re,D.Range.to(Y),ne)).then(G=>G?this._send(G):null)}_send(H){return(0,o.encodeSemanticTokensDto)({id:0,type:"full",data:H.data})}}e.DocumentRangeSemanticTokensAdapter=U;class M{constructor(H,Y,ne,re,G){this._documents=H,this._commands=Y,this._provider=ne,this._apiDeprecation=re,this._extension=G,this._cache=new w.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(H){return typeof H.resolveCompletionItem=="function"}async provideCompletionItems(H,Y,ne,re){const G=this._documents.getDocument(H),se=D.Position.to(Y),fe=G.getWordRangeAtPosition(se)||new T.Range(se,se),Ae=fe.with({end:se}),ge=new f.StopWatch(!0),We=await(0,_.asPromise)(()=>this._provider.provideCompletionItems(G,se,re,D.CompletionContext.to(ne)));if(!We||re.isCancellationRequested)return;const V=Array.isArray(We)?new T.CompletionList(We):We,te=M.supportsResolving(this._provider)?this._cache.add(V.items):this._cache.add([]),pe=new g.DisposableStore;this._disposables.set(te,pe);const Me=[],$e={x:te,b:Me,a:{replace:D.Range.from(fe),insert:D.Range.from(Ae)},c:V.isIncomplete||void 0,d:ge.elapsed()};for(let Be=0;Be<V.items.length;Be++){const Ye=V.items[Be],Se=this._convertCompletionItem(Ye,[te,Be],Ae,fe);Me.push(Se)}return $e}async resolveCompletionItem(H,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const ne=this._cache.get(...H);if(!ne)return;const re=await(0,_.asPromise)(()=>this._provider.resolveCompletionItem(ne,Y));if(!!re)return this._convertCompletionItem(re,H)}releaseCompletionItems(H){var Y;(Y=this._disposables.get(H))===null||Y===void 0||Y.dispose(),this._disposables.delete(H),this._cache.delete(H)}_convertCompletionItem(H,Y,ne,re){var G;const se=this._disposables.get(Y[0]);if(!se)throw Error("DisposableStore is missing...");const fe={x:Y,a:(G=H.label)!==null&&G!==void 0?G:"",o:H.label2,b:H.kind!==void 0?D.CompletionItemKind.from(H.kind):void 0,n:H.tags&&H.tags.map(D.CompletionItemTag.from),c:H.detail,d:typeof H.documentation=="undefined"?void 0:D.MarkdownString.fromStrict(H.documentation),e:H.sortText!==H.label?H.sortText:void 0,f:H.filterText!==H.label?H.filterText:void 0,g:H.preselect||void 0,i:H.keepWhitespace?1:0,k:H.commitCharacters,l:H.additionalTextEdits&&H.additionalTextEdits.map(D.TextEdit.from),m:this._commands.toInternal(H.command,se)};H.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),fe.h=H.textEdit.newText):typeof H.insertText=="string"?fe.h=H.insertText:H.insertText instanceof T.SnippetString&&(fe.h=H.insertText.value,fe.i|=4);let Ae;return H.textEdit?Ae=H.textEdit.range:H.range&&(Ae=H.range),T.Range.isRange(Ae)?fe.j=D.Range.from(Ae):Ae&&(!(ne==null?void 0:ne.isEqual(Ae.inserting))||!(re==null?void 0:re.isEqual(Ae.replacing)))&&(fe.j={insert:D.Range.from(Ae.inserting),replace:D.Range.from(Ae.replacing)}),fe}}class ${constructor(H,Y,ne){this._documents=H,this._provider=Y,this._commands=ne,this._cache=new w.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(H,Y,ne,re){const G=this._documents.getDocument(H),se=D.Position.to(Y),fe=await(0,_.asPromise)(()=>this._provider.provideInlineCompletionItems(G,se,ne,re));if(!fe||re.isCancellationRequested)return;const Ae=this._cache.add(fe.items);let ge;return{pid:Ae,items:fe.items.map((We,V)=>{let te;return We.command&&(ge||(ge=new g.DisposableStore,this._disposables.set(Ae,ge)),te=this._commands.toInternal(We.command,ge)),{text:We.text,range:We.range?D.Range.from(We.range):void 0,command:te,idx:V}})}}disposeCompletions(H){this._cache.delete(H);const Y=this._disposables.get(H);Y&&Y.clear(),this._disposables.delete(H)}handleDidShowCompletionItem(H,Y){const ne=this._cache.get(H,Y);ne&&K.get(this._provider).fireOnDidShowCompletionItem({completionItem:ne})}}class K{constructor(){this._onDidShowCompletionItemEmitter=new l.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(H){let Y=K.map.get(H);return Y||(Y=new K,K.map.set(H,Y)),Y}fireOnDidShowCompletionItem(H){this._onDidShowCompletionItemEmitter.fire(H)}}e.InlineCompletionController=K,K.map=new WeakMap;class j{constructor(H,Y){this._documents=H,this._provider=Y,this._cache=new w.Cache("SignatureHelp")}provideSignatureHelp(H,Y,ne,re){const G=this._documents.getDocument(H),se=D.Position.to(Y),fe=this.reviveContext(ne);return(0,_.asPromise)(()=>this._provider.provideSignatureHelp(G,se,re,fe)).then(Ae=>{if(Ae){const ge=this._cache.add([Ae]);return Object.assign(Object.assign({},D.SignatureHelp.from(Ae)),{id:ge})}})}reviveContext(H){let Y;if(H.activeSignatureHelp){const ne=D.SignatureHelp.to(H.activeSignatureHelp),re=this._cache.get(H.activeSignatureHelp.id,0);re?(Y=re,Y.activeSignature=ne.activeSignature,Y.activeParameter=ne.activeParameter):Y=ne}return Object.assign(Object.assign({},H),{activeSignatureHelp:Y})}releaseSignatureHelp(H){this._cache.delete(H)}}class ae{constructor(H,Y){this._documents=H,this._provider=Y}provideInlayHints(H,Y,ne){const re=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideInlayHints(re,D.Range.to(Y),ne)).then(G=>G?{hints:G.map(D.InlayHint.from)}:void 0)}}class we{constructor(H,Y){this._documents=H,this._provider=Y,this._cache=new w.Cache("DocumentLink")}provideLinks(H,Y){const ne=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideDocumentLinks(ne,Y)).then(re=>{if(!(!Array.isArray(re)||re.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.map(D.DocumentLink.from)};{const G=this._cache.add(re),se={links:[],id:G};for(let fe=0;fe<re.length;fe++){const Ae=D.DocumentLink.from(re[fe]);Ae.cacheId=[G,fe],se.links.push(Ae)}return se}}})}resolveLink(H,Y){if(typeof this._provider.resolveDocumentLink!="function")return Promise.resolve(void 0);const ne=this._cache.get(...H);return ne?(0,_.asPromise)(()=>this._provider.resolveDocumentLink(ne,Y)).then(re=>re&&D.DocumentLink.from(re)||void 0):Promise.resolve(void 0)}releaseLinks(H){this._cache.delete(H)}}class Re{constructor(H,Y){this._documents=H,this._provider=Y}provideColors(H,Y){const ne=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideDocumentColors(ne,Y)).then(re=>Array.isArray(re)?re.map(se=>({color:D.Color.from(se.color),range:D.Range.from(se.range)})):[])}provideColorPresentations(H,Y,ne){const re=this._documents.getDocument(H),G=D.Range.to(Y.range),se=D.Color.to(Y.color);return(0,_.asPromise)(()=>this._provider.provideColorPresentations(se,{document:re,range:G},ne)).then(fe=>{if(!!Array.isArray(fe))return fe.map(D.ColorPresentation.from)})}}class xe{constructor(H,Y){this._documents=H,this._provider=Y}provideFoldingRanges(H,Y,ne){const re=this._documents.getDocument(H);return(0,_.asPromise)(()=>this._provider.provideFoldingRanges(re,Y,ne)).then(G=>{if(!!Array.isArray(G))return G.map(D.FoldingRange.from)})}}class Le{constructor(H,Y,ne){this._documents=H,this._provider=Y,this._logService=ne}provideSelectionRanges(H,Y,ne){const re=this._documents.getDocument(H),G=Y.map(D.Position.to);return(0,_.asPromise)(()=>this._provider.provideSelectionRanges(re,G,ne)).then(se=>{if(!(0,i.isNonEmptyArray)(se))return[];if(se.length!==G.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<G.length;Ae++){const ge=[];fe.push(ge);let We=G[Ae],V=se[Ae];for(;;){if(!V.range.contains(We))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(D.SelectionRange.from(V)),!V.parent)break;We=V.range,V=V.parent}}return fe})}}class Ve{constructor(H,Y){this._documents=H,this._provider=Y,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(H,Y,ne){const re=this._documents.getDocument(H),G=D.Position.to(Y),se=await this._provider.prepareCallHierarchy(re,G,ne);if(!se)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(se)?se.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,se)]}async provideCallsTo(H,Y,ne){const re=this._itemFromCache(H,Y);if(!re)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyIncomingCalls(re,ne);if(!!G)return G.map(se=>({from:this._cacheAndConvertItem(H,se.from),fromRanges:se.fromRanges.map(fe=>D.Range.from(fe))}))}async provideCallsFrom(H,Y,ne){const re=this._itemFromCache(H,Y);if(!re)throw new Error("missing call hierarchy item");const G=await this._provider.provideCallHierarchyOutgoingCalls(re,ne);if(!!G)return G.map(se=>({to:this._cacheAndConvertItem(H,se.to),fromRanges:se.fromRanges.map(fe=>D.Range.from(fe))}))}releaseSession(H){this._cache.delete(H)}_cacheAndConvertItem(H,Y){var ne;const re=this._cache.get(H),G={_sessionId:H,_itemId:re.size.toString(36),name:Y.name,detail:Y.detail,kind:D.SymbolKind.from(Y.kind),uri:Y.uri,range:D.Range.from(Y.range),selectionRange:D.Range.from(Y.selectionRange),tags:(ne=Y.tags)===null||ne===void 0?void 0:ne.map(D.SymbolTag.from)};return re.set(G._itemId,Y),G}_itemFromCache(H,Y){const ne=this._cache.get(H);return ne==null?void 0:ne.get(Y)}}class Qe{constructor(H,Y){this.adapter=H,this.extension=Y}}class Ke{constructor(H,Y,ne,re,G,se,fe){this._adapter=new Map,this._uriTransformer=Y,this._proxy=H.getProxy(S.MainContext.MainThreadLanguageFeatures),this._documents=ne,this._commands=re,this._diagnostics=G,this._logService=se,this._apiDeprecation=fe}_transformDocumentSelector(H){return(0,i.coalesce)((0,i.asArray)(H).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(H){if(typeof H=="string")return{$serialized:!0,language:H};if(H)return{$serialized:!0,language:H.language,scheme:this._transformScheme(H.scheme),pattern:typeof H.pattern=="undefined"?void 0:D.GlobPattern.from(H.pattern),exclusive:H.exclusive}}_transformScheme(H){return this._uriTransformer&&typeof H=="string"?this._uriTransformer.transformOutgoingScheme(H):H}_createDisposable(H){return new T.Disposable(()=>{this._adapter.delete(H),this._proxy.$unregister(H)})}_nextHandle(){return Ke._handlePool++}_withAdapter(H,Y,ne,re,G=!1){const se=this._adapter.get(H);if(!se)return Promise.resolve(re);if(se.adapter instanceof Y){let fe;se.extension&&(fe=Date.now(),this._logService.trace(`[${se.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Ae=ne(se.adapter,se.extension),ge=se.extension;return ge&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${ge.identifier.value}] provider DONE after ${Date.now()-fe}ms`),We=>{G&&We instanceof y.CancellationError||(this._logService.error(`[${ge.identifier.value}] provider FAILED`),this._logService.error(We))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(H,Y){const ne=this._nextHandle();return this._adapter.set(ne,new Qe(H,Y)),ne}static _extLabel(H){return H.displayName||H.name}registerDocumentSymbolProvider(H,Y,ne,re){const G=this._addNewAdapter(new m(this._documents,ne),H),se=re&&re.label||Ke._extLabel(H);return this._proxy.$registerDocumentSymbolProvider(G,this._transformDocumentSelector(Y),se),this._createDisposable(G)}$provideDocumentSymbols(H,Y,ne){return this._withAdapter(H,m,re=>re.provideDocumentSymbols(p.URI.revive(Y),ne),void 0)}registerCodeLensProvider(H,Y,ne){const re=this._nextHandle(),G=typeof ne.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Qe(new h(this._documents,this._commands.converter,ne),H)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(Y),G);let se=this._createDisposable(re);if(G!==void 0){const fe=ne.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(G));se=T.Disposable.from(se,fe)}return se}$provideCodeLenses(H,Y,ne){return this._withAdapter(H,h,re=>re.provideCodeLenses(p.URI.revive(Y),ne),void 0)}$resolveCodeLens(H,Y,ne){return this._withAdapter(H,h,re=>re.resolveCodeLens(Y,ne),void 0)}$releaseCodeLenses(H,Y){this._withAdapter(H,h,ne=>Promise.resolve(ne.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(H,Y,ne){const re=this._addNewAdapter(new n(this._documents,ne),H);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDefinition(H,Y,ne,re){return this._withAdapter(H,n,G=>G.provideDefinition(p.URI.revive(Y),ne,re),[])}registerDeclarationProvider(H,Y,ne){const re=this._addNewAdapter(new r(this._documents,ne),H);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDeclaration(H,Y,ne,re){return this._withAdapter(H,r,G=>G.provideDeclaration(p.URI.revive(Y),ne,re),[])}registerImplementationProvider(H,Y,ne){const re=this._addNewAdapter(new s(this._documents,ne),H);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideImplementation(H,Y,ne,re){return this._withAdapter(H,s,G=>G.provideImplementation(p.URI.revive(Y),ne,re),[])}registerTypeDefinitionProvider(H,Y,ne){const re=this._addNewAdapter(new u(this._documents,ne),H);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideTypeDefinition(H,Y,ne,re){return this._withAdapter(H,u,G=>G.provideTypeDefinition(p.URI.revive(Y),ne,re),[])}registerHoverProvider(H,Y,ne,re){const G=this._addNewAdapter(new v(this._documents,ne),H);return this._proxy.$registerHoverProvider(G,this._transformDocumentSelector(Y)),this._createDisposable(G)}$provideHover(H,Y,ne,re){return this._withAdapter(H,v,G=>G.provideHover(p.URI.revive(Y),ne,re),void 0)}registerEvaluatableExpressionProvider(H,Y,ne,re){const G=this._addNewAdapter(new b(this._documents,ne),H);return this._proxy.$registerEvaluatableExpressionProvider(G,this._transformDocumentSelector(Y)),this._createDisposable(G)}$provideEvaluatableExpression(H,Y,ne,re){return this._withAdapter(H,b,G=>G.provideEvaluatableExpression(p.URI.revive(Y),ne,re),void 0)}registerInlineValuesProvider(H,Y,ne,re){const G=typeof ne.onDidChangeInlineValues=="function"?this._nextHandle():void 0,se=this._addNewAdapter(new P(this._documents,ne),H);this._proxy.$registerInlineValuesProvider(se,this._transformDocumentSelector(Y),G);let fe=this._createDisposable(se);if(G!==void 0){const Ae=ne.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(G));fe=T.Disposable.from(fe,Ae)}return fe}$provideInlineValues(H,Y,ne,re,G){return this._withAdapter(H,P,se=>se.provideInlineValues(p.URI.revive(Y),ne,re,G),void 0)}registerDocumentHighlightProvider(H,Y,ne){const re=this._addNewAdapter(new C(this._documents,ne),H);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDocumentHighlights(H,Y,ne,re){return this._withAdapter(H,C,G=>G.provideDocumentHighlights(p.URI.revive(Y),ne,re),void 0)}registerLinkedEditingRangeProvider(H,Y,ne){const re=this._addNewAdapter(new c(this._documents,ne),H);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideLinkedEditingRanges(H,Y,ne,re){return this._withAdapter(H,c,async G=>{const se=await G.provideLinkedEditingRanges(p.URI.revive(Y),ne,re);if(se)return{ranges:se.ranges,wordPattern:se.wordPattern?Ke._serializeRegExp(se.wordPattern):void 0}},void 0)}registerReferenceProvider(H,Y,ne){const re=this._addNewAdapter(new F(this._documents,ne),H);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideReferences(H,Y,ne,re,G){return this._withAdapter(H,F,se=>se.provideReferences(p.URI.revive(Y),ne,re,G),void 0)}registerCodeActionProvider(H,Y,ne,re){var G,se;const fe=new g.DisposableStore,Ae=this._addNewAdapter(new N(this._documents,this._commands.converter,this._diagnostics,ne,this._logService,H,this._apiDeprecation),H);return this._proxy.$registerQuickFixSupport(Ae,this._transformDocumentSelector(Y),{providedKinds:(G=re==null?void 0:re.providedCodeActionKinds)===null||G===void 0?void 0:G.map(ge=>ge.value),documentation:(se=re==null?void 0:re.documentation)===null||se===void 0?void 0:se.map(ge=>({kind:ge.kind.value,command:this._commands.converter.toInternal(ge.command,fe)}))},Ke._extLabel(H),Boolean(ne.resolveCodeAction)),fe.add(this._createDisposable(Ae)),fe}$provideCodeActions(H,Y,ne,re,G){return this._withAdapter(H,N,se=>se.provideCodeActions(p.URI.revive(Y),ne,re,G),void 0)}$resolveCodeAction(H,Y,ne){return this._withAdapter(H,N,re=>re.resolveCodeAction(Y,ne),void 0)}$releaseCodeActions(H,Y){this._withAdapter(H,N,ne=>Promise.resolve(ne.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(H,Y,ne){const re=this._addNewAdapter(new z(this._documents,ne),H);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(Y),H.identifier,H.displayName||H.name),this._createDisposable(re)}$provideDocumentFormattingEdits(H,Y,ne,re){return this._withAdapter(H,z,G=>G.provideDocumentFormattingEdits(p.URI.revive(Y),ne,re),void 0)}registerDocumentRangeFormattingEditProvider(H,Y,ne){const re=this._addNewAdapter(new he(this._documents,ne),H);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(Y),H.identifier,H.displayName||H.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(H,Y,ne,re,G){return this._withAdapter(H,he,se=>se.provideDocumentRangeFormattingEdits(p.URI.revive(Y),ne,re,G),void 0)}registerOnTypeFormattingEditProvider(H,Y,ne,re){const G=this._addNewAdapter(new me(this._documents,ne),H);return this._proxy.$registerOnTypeFormattingSupport(G,this._transformDocumentSelector(Y),re,H.identifier),this._createDisposable(G)}$provideOnTypeFormattingEdits(H,Y,ne,re,G,se){return this._withAdapter(H,me,fe=>fe.provideOnTypeFormattingEdits(p.URI.revive(Y),ne,re,G,se),void 0)}registerWorkspaceSymbolProvider(H,Y){const ne=this._addNewAdapter(new Q(Y,this._logService),H);return this._proxy.$registerNavigateTypeSupport(ne),this._createDisposable(ne)}$provideWorkspaceSymbols(H,Y,ne){return this._withAdapter(H,Q,re=>re.provideWorkspaceSymbols(Y,ne),{symbols:[]})}$resolveWorkspaceSymbol(H,Y,ne){return this._withAdapter(H,Q,re=>re.resolveWorkspaceSymbol(Y,ne),void 0)}$releaseWorkspaceSymbols(H,Y){this._withAdapter(H,Q,ne=>ne.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(H,Y,ne){const re=this._addNewAdapter(new W(this._documents,ne,this._logService),H);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(Y),W.supportsResolving(ne)),this._createDisposable(re)}$provideRenameEdits(H,Y,ne,re,G){return this._withAdapter(H,W,se=>se.provideRenameEdits(p.URI.revive(Y),ne,re,G),void 0)}$resolveRenameLocation(H,Y,ne,re){return this._withAdapter(H,W,G=>G.resolveRenameLocation(p.URI.revive(Y),ne,re),void 0)}registerDocumentSemanticTokensProvider(H,Y,ne,re){const G=this._nextHandle(),se=typeof ne.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(G,new Qe(new A(this._documents,ne),H)),this._proxy.$registerDocumentSemanticTokensProvider(G,this._transformDocumentSelector(Y),re,se);let fe=this._createDisposable(G);if(se){const Ae=ne.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(se));fe=T.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens(H,Y,ne,re){return this._withAdapter(H,A,G=>G.provideDocumentSemanticTokens(p.URI.revive(Y),ne,re),null,!0)}$releaseDocumentSemanticTokens(H,Y){this._withAdapter(H,A,ne=>ne.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(H,Y,ne,re){const G=this._addNewAdapter(new U(this._documents,ne),H);return this._proxy.$registerDocumentRangeSemanticTokensProvider(G,this._transformDocumentSelector(Y),re),this._createDisposable(G)}$provideDocumentRangeSemanticTokens(H,Y,ne,re){return this._withAdapter(H,U,G=>G.provideDocumentRangeSemanticTokens(p.URI.revive(Y),ne,re),null,!0)}registerCompletionItemProvider(H,Y,ne,re){const G=this._addNewAdapter(new M(this._documents,this._commands.converter,ne,this._apiDeprecation,H),H);return this._proxy.$registerSuggestSupport(G,this._transformDocumentSelector(Y),re,M.supportsResolving(ne),`${H.identifier.value}(${re.join("")})`),this._createDisposable(G)}$provideCompletionItems(H,Y,ne,re,G){return this._withAdapter(H,M,se=>se.provideCompletionItems(p.URI.revive(Y),ne,re,G),void 0)}$resolveCompletionItem(H,Y,ne){return this._withAdapter(H,M,re=>re.resolveCompletionItem(Y,ne),void 0)}$releaseCompletionItems(H,Y){this._withAdapter(H,M,ne=>ne.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(H,Y,ne){const re=this._addNewAdapter(new $(this._documents,ne,this._commands.converter),H);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideInlineCompletions(H,Y,ne,re,G){return this._withAdapter(H,$,se=>se.provideInlineCompletions(p.URI.revive(Y),ne,re,G),void 0)}$handleInlineCompletionDidShow(H,Y,ne){this._withAdapter(H,$,async re=>{re.handleDidShowCompletionItem(Y,ne)},void 0)}$freeInlineCompletionsList(H,Y){this._withAdapter(H,$,async ne=>{ne.disposeCompletions(Y)},void 0)}registerSignatureHelpProvider(H,Y,ne,re){const G=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,se=this._addNewAdapter(new j(this._documents,ne),H);return this._proxy.$registerSignatureHelpProvider(se,this._transformDocumentSelector(Y),G),this._createDisposable(se)}$provideSignatureHelp(H,Y,ne,re,G){return this._withAdapter(H,j,se=>se.provideSignatureHelp(p.URI.revive(Y),ne,re,G),void 0)}$releaseSignatureHelp(H,Y){this._withAdapter(H,j,ne=>ne.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(H,Y,ne){const re=typeof ne.onDidChangeInlayHints=="function"?this._nextHandle():void 0,G=this._addNewAdapter(new ae(this._documents,ne),H);this._proxy.$registerInlayHintsProvider(G,this._transformDocumentSelector(Y),re);let se=this._createDisposable(G);if(re!==void 0){const fe=ne.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(re));se=T.Disposable.from(se,fe)}return se}$provideInlayHints(H,Y,ne,re){return this._withAdapter(H,ae,G=>G.provideInlayHints(p.URI.revive(Y),ne,re),void 0)}registerDocumentLinkProvider(H,Y,ne){const re=this._addNewAdapter(new we(this._documents,ne),H);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(Y),typeof ne.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(H,Y,ne){return this._withAdapter(H,we,re=>re.provideLinks(p.URI.revive(Y),ne),void 0)}$resolveDocumentLink(H,Y,ne){return this._withAdapter(H,we,re=>re.resolveLink(Y,ne),void 0)}$releaseDocumentLinks(H,Y){this._withAdapter(H,we,ne=>ne.releaseLinks(Y),void 0)}registerColorProvider(H,Y,ne){const re=this._addNewAdapter(new Re(this._documents,ne),H);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDocumentColors(H,Y,ne){return this._withAdapter(H,Re,re=>re.provideColors(p.URI.revive(Y),ne),[])}$provideColorPresentations(H,Y,ne,re){return this._withAdapter(H,Re,G=>G.provideColorPresentations(p.URI.revive(Y),ne,re),void 0)}registerFoldingRangeProvider(H,Y,ne){const re=this._nextHandle(),G=typeof ne.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Qe(new xe(this._documents,ne),H)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(Y),G);let se=this._createDisposable(re);if(G!==void 0){const fe=ne.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(G));se=T.Disposable.from(se,fe)}return se}$provideFoldingRanges(H,Y,ne,re){return this._withAdapter(H,xe,G=>G.provideFoldingRanges(p.URI.revive(Y),ne,re),void 0)}registerSelectionRangeProvider(H,Y,ne){const re=this._addNewAdapter(new Le(this._documents,ne,this._logService),H);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideSelectionRanges(H,Y,ne,re){return this._withAdapter(H,Le,G=>G.provideSelectionRanges(p.URI.revive(Y),ne,re),[])}registerCallHierarchyProvider(H,Y,ne){const re=this._addNewAdapter(new Ve(this._documents,ne),H);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$prepareCallHierarchy(H,Y,ne,re){return this._withAdapter(H,Ve,G=>Promise.resolve(G.prepareSession(p.URI.revive(Y),ne,re)),void 0)}$provideCallHierarchyIncomingCalls(H,Y,ne,re){return this._withAdapter(H,Ve,G=>G.provideCallsTo(Y,ne,re),void 0)}$provideCallHierarchyOutgoingCalls(H,Y,ne,re){return this._withAdapter(H,Ve,G=>G.provideCallsFrom(Y,ne,re),void 0)}$releaseCallHierarchy(H,Y){this._withAdapter(H,Ve,ne=>Promise.resolve(ne.releaseSession(Y)),void 0)}static _serializeRegExp(H){return{pattern:H.source,flags:(0,E.regExpFlags)(H)}}static _serializeIndentationRule(H){return{decreaseIndentPattern:Ke._serializeRegExp(H.decreaseIndentPattern),increaseIndentPattern:Ke._serializeRegExp(H.increaseIndentPattern),indentNextLinePattern:H.indentNextLinePattern?Ke._serializeRegExp(H.indentNextLinePattern):void 0,unIndentedLinePattern:H.unIndentedLinePattern?Ke._serializeRegExp(H.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(H){return{beforeText:Ke._serializeRegExp(H.beforeText),afterText:H.afterText?Ke._serializeRegExp(H.afterText):void 0,previousLineText:H.previousLineText?Ke._serializeRegExp(H.previousLineText):void 0,action:H.action}}static _serializeOnEnterRules(H){return H.map(Ke._serializeOnEnterRule)}setLanguageConfiguration(H,Y,ne){let{wordPattern:re}=ne;if(re&&(0,E.regExpLeadsToEndlessLoop)(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(Y,re):this._documents.setWordDefinitionFor(Y,void 0),ne.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",H,"Do not use."),ne.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",H,"Do not use.");const G=this._nextHandle(),se={comments:ne.comments,brackets:ne.brackets,wordPattern:ne.wordPattern?Ke._serializeRegExp(ne.wordPattern):void 0,indentationRules:ne.indentationRules?Ke._serializeIndentationRule(ne.indentationRules):void 0,onEnterRules:ne.onEnterRules?Ke._serializeOnEnterRules(ne.onEnterRules):void 0,__electricCharacterSupport:ne.__electricCharacterSupport,__characterPairSupport:ne.__characterPairSupport};return this._proxy.$setLanguageConfiguration(G,Y,se),this._createDisposable(G)}$setWordDefinitions(H){for(const Y of H)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=Ke,Ke._handlePool=0}),define(be[200],_e([0,1,5,10,7]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class T{constructor(S,E){this._proxy=S.getProxy(p.MainContext.MainThreadLanguages),this._documents=E}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(S,E){await this._proxy.$changeLanguage(S,E);const k=this._documents.getDocumentData(S);if(!k)throw new Error(`document '${S.toString}' NOT found`);return k.document}async tokenAtPosition(S,E){var k;const i=S.version,I=R.Position.from(E),d=await this._proxy.$tokensAtPosition(S.uri,I),g={type:D.StandardTokenType.Other,range:(k=S.getWordRangeAtPosition(E))!==null&&k!==void 0?k:new D.Range(E.line,E.character,E.line,E.character)};if(!d)return g;const o={range:R.Range.to(d.range),type:R.TokenType.to(d.type)};return!o.range.contains(E)||i!==S.version?g:o}}e.ExtHostLanguages=T}),define(be[201],_e([0,1,5,17,32]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function T(S){return S&&S.title}let _=class{constructor(E,k){this._logService=k,this._proxy=E.getProxy(p.MainContext.MainThreadMessageService)}showMessage(E,k,i,I,d){const g={extension:E};let o;typeof I=="string"||T(I)?o=[I,...d]:(g.modal=I&&I.modal,g.useCustom=I&&I.useCustom,o=d),g.useCustom&&(0,D.checkProposedApiEnabled)(E);const a=[];for(let w=0;w<o.length;w++){const f=o[w];if(typeof f=="string")a.push({title:f,handle:w,isCloseAffordance:!1});else if(typeof f=="object"){let{title:y,isCloseAffordance:l}=f;a.push({title:y,isCloseAffordance:!!l,handle:w})}else this._logService.warn("Invalid message item:",f)}return this._proxy.$showMessage(k,i,g,a).then(w=>{if(typeof w=="number")return o[w]})}};_=ze([je(1,R.ILogService)],_),e.ExtHostMessageService=_}),define(be[202],_e([0,1,25,3,57,55,6,22,8,9,2,68,5,10,7,50,180,98]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=e.NotebookEditorDecorationType=void 0;class y{constructor(h,t){const n=y._Keys.nextId();h.$registerNotebookEditorDecorationType(n,g.NotebookDecorationRenderOptions.from(t)),this.value={key:n,dispose(){h.$removeNotebookEditorDecorationType(n)}}}}e.NotebookEditorDecorationType=y,y._Keys=new T.IdGenerator("NotebookEditorDecorationType");class l{constructor(h,t,n,r,s,u){this._textDocumentsAndEditors=n,this._textDocuments=r,this.logService=s,this._extensionStoragePaths=u,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new S.ResourceMap,this._editors=new Map,this._onDidChangeNotebookEditorSelection=new R.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this._onDidChangeNotebookEditorVisibleRanges=new R.Emitter,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event,this._onDidChangeNotebookDocumentMetadata=new R.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidSaveNotebookDocument=new R.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new I.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=h.getProxy(d.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=h.getProxy(d.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=h.getProxy(d.MainContext.MainThreadNotebookEditors),this._commandsConverter=t.converter,t.registerArgumentProcessor({processArgument:v=>{var b;if(v&&v.$mid===12){const P=(b=v.notebookEditor)===null||b===void 0?void 0:b.notebookUri,C=v.cell.handle,c=this._documents.get(P),F=c==null?void 0:c.getCell(C);if(F)return F.apiCell}return v}})}get activeNotebookEditor(){var h;return(h=this._activeNotebookEditor)===null||h===void 0?void 0:h.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(h=>h.apiEditor)}getEditorById(h){return this._editors.get(h)}getIdByEditor(h){for(const[t,n]of this._editors)if(n.apiEditor===h)return t}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(h,t){const n=this._documents.get(h);if(!n&&!t)throw new Error(`NO notebook document for '${h}'`);return n}_getProviderData(h){const t=this._notebookContentProviders.get(h);if(!t)throw new Error(`NO provider for '${h}'`);return t}registerNotebookContentProvider(h,t,n,r,s){if((0,E.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:h,provider:n});let u;return n.onDidChangeNotebookContentOptions&&(u=n.onDidChangeNotebookContentOptions(()=>{const v=g.NotebookDocumentContentOptions.from(n.options);this._notebookProxy.$updateNotebookProviderOptions(t,v)})),this._notebookProxy.$registerNotebookProvider({id:h.identifier,location:h.extensionLocation},t,g.NotebookDocumentContentOptions.from(r),l._convertNotebookRegistrationData(h,s)),new o.Disposable(()=>{u==null||u.dispose(),this._notebookContentProviders.delete(t),this._notebookProxy.$unregisterNotebookProvider(t)})}static _convertNotebookRegistrationData(h,t){if(!t)return;const n=t.filenamePattern.map(r=>g.NotebookExclusiveDocumentPattern.from(r)).filter(r=>r!==void 0);if(t.filenamePattern&&!n){console.warn(`Notebook content provider view options file name pattern is invalid ${t.filenamePattern}`);return}return{extension:h.identifier,providerDisplayName:h.displayName||h.name,displayName:t.displayName,filenamePattern:n,exclusive:t.exclusive||!1}}registerNotebookCellStatusBarItemProvider(h,t,n){const r=l._notebookStatusBarItemProviderHandlePool++,s=typeof n.onDidChangeCellStatusBarItems=="function"?l._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(r,n),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(r,s,t);let u;return s!==void 0&&(u=n.onDidChangeCellStatusBarItems(v=>this._notebookProxy.$emitCellStatusBarEvent(s))),new o.Disposable(()=>{this._notebookStatusBarItemProviders.delete(r),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(r,s),u&&u.dispose()})}createNotebookEditorDecorationType(h){return new y(this._notebookEditorsProxy,h).value}async createNotebookDocument(h){const t=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:h.viewType,content:h.content&&g.NotebookData.from(h.content)});return i.URI.revive(t)}async openNotebookDocument(h){const t=this._documents.get(h);if(t)return t.apiNotebook;const n=await this._notebookDocumentsProxy.$tryOpenNotebook(h),r=this._documents.get(i.URI.revive(n));return(0,k.assertIsDefined)(r==null?void 0:r.apiNotebook)}async showNotebookDocument(h,t){var n;i.URI.isUri(h)&&(h=await this.openNotebookDocument(h));let r;typeof t=="object"?r={position:g.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selections:t.selections&&t.selections.map(g.NotebookRange.from),pinned:typeof t.preview=="boolean"?!t.preview:void 0}:r={preserveFocus:!1};const s=await this._notebookEditorsProxy.$tryShowNotebookDocument(h.uri,h.viewType,r),u=s&&((n=this._editors.get(s))===null||n===void 0?void 0:n.apiEditor);if(u)return u;throw s?new Error(`Could NOT open editor for "${h.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${h.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(h,t,n,r){var s;const u=this._notebookStatusBarItemProviders.get(h),v=i.URI.revive(t),b=this._documents.get(v);if(!b||!u)return;const P=b.getCellFromIndex(n);if(!P)return;const C=await u.provideCellStatusBarItems(P.apiCell,r);if(!C)return;const c=new _.DisposableStore,F=this._statusBarCache.add([c]),N=(s=C&&C.map(z=>g.NotebookStatusBarItem.from(z,this._commandsConverter,c)))!==null&&s!==void 0?s:void 0;return{cacheId:F,items:N}}$releaseNotebookCellStatusBarItems(h){this._statusBarCache.delete(h)}registerNotebookSerializer(h,t,n,r,s){if((0,E.isFalsyOrWhitespace)(t))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,n),this._notebookProxy.$registerNotebookSerializer(u,{id:h.identifier,location:h.extensionLocation},t,g.NotebookDocumentContentOptions.from(r),l._convertNotebookRegistrationData(h,s)),(0,_.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(h,t,n){const r=this._notebookSerializer.get(h);if(!r)throw new Error("NO serializer found");const s=await r.deserializeNotebook(t.buffer,n);return g.NotebookData.from(s)}async $notebookToData(h,t,n){const r=this._notebookSerializer.get(h);if(!r)throw new Error("NO serializer found");const s=await r.serializeNotebook(g.NotebookData.to(t),n);return p.VSBuffer.wrap(s)}async $openNotebook(h,t,n,r,s){const{provider:u}=this._getProviderData(h),v=await u.openNotebook(i.URI.revive(t),{backupId:n,untitledDocumentData:r==null?void 0:r.buffer},s);return{metadata:g.NotebookDocumentMetadata.from(v.metadata),cells:v.cells.map(g.NotebookCellData.from)}}async $saveNotebook(h,t,n){const r=this.getNotebookDocument(i.URI.revive(t)),{provider:s}=this._getProviderData(h);return await s.saveNotebook(r.apiNotebook,n),!0}async $saveNotebookAs(h,t,n,r){const s=this.getNotebookDocument(i.URI.revive(t)),{provider:u}=this._getProviderData(h);return await u.saveNotebookAs(i.URI.revive(n),s.apiNotebook,r),!0}async $backupNotebook(h,t,n){var r;const s=this.getNotebookDocument(i.URI.revive(t)),u=this._getProviderData(h),v=(r=this._extensionStoragePaths.workspaceValue(u.extension))!==null&&r!==void 0?r:this._extensionStoragePaths.globalValue(u.extension),b=String((0,D.hash)([s.uri.toString(),this._backupIdPool++])),P=i.URI.joinPath(v,b),C=await u.provider.backupNotebook(s.apiNotebook,{destination:P},n);return s.updateBackup(C),C.id}$acceptModelChanged(h,t,n){this.getNotebookDocument(i.URI.revive(h)).acceptModelChanged(t,n)}$acceptDirtyStateChanged(h,t){const n=this.getNotebookDocument(i.URI.revive(h));n.acceptModelChanged({rawEvents:[],versionId:n.apiNotebook.version},t)}$acceptModelSaved(h){const t=this.getNotebookDocument(i.URI.revive(h));this._onDidSaveNotebookDocument.fire(t.apiNotebook)}$acceptEditorPropertiesChanged(h,t){this.logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",h,t);const n=this._editors.get(h);if(!n)throw new Error(`unknown text editor: ${h}. known editors: ${[...this._editors.keys()]} `);t.visibleRanges&&n._acceptVisibleRanges(t.visibleRanges.ranges.map(g.NotebookRange.to)),t.selections&&n._acceptSelections(t.selections.selections.map(g.NotebookRange.to)),t.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:n.apiEditor,visibleRanges:n.apiEditor.visibleRanges}),t.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:n.apiEditor,selections:n.apiEditor.selections}))}$acceptEditorViewColumns(h){for(const t in h){const n=this._editors.get(t);if(!n)throw new Error(`unknown text editor: ${t}. known editors: ${[...this._editors.keys()]} `);n._acceptViewColumn(g.ViewColumn.to(h[t]))}}$acceptDocumentPropertiesChanged(h,t){this.logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",h.path,t);const n=this.getNotebookDocument(i.URI.revive(h));n.acceptDocumentPropertiesChanged(t),t.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:n.apiNotebook})}_createExtHostEditor(h,t,n){if(this._editors.has(t))throw new Error(`editor with id ALREADY EXSIST: ${t}`);const r=new f.ExtHostNotebookEditor(t,this._notebookEditorsProxy,h,n.visibleRanges.map(g.NotebookRange.to),n.selections.map(g.NotebookRange.to),typeof n.viewColumn=="number"?g.ViewColumn.to(n.viewColumn):void 0);this._editors.set(t,r)}$acceptDocumentAndEditorsDelta(h){var t,n,r;if(h.removedDocuments)for(const u of h.removedDocuments){const v=i.URI.revive(u),b=this._documents.get(v);b&&(b.dispose(),this._documents.delete(v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(P=>P.document.uri)}),this._onDidCloseNotebookDocument.fire(b.apiNotebook));for(const P of this._editors.values())P.notebookData.uri.toString()===v.toString()&&this._editors.delete(P.id)}if(h.addedDocuments){const u=[];for(const v of h.addedDocuments){const b=i.URI.revive(v.uri),P=v.viewType;if(this._documents.has(b))throw new Error(`adding EXISTING notebook ${b} `);const C=this,c=new w.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(F){C._onDidChangeNotebookCells.fire(F)},emitCellOutputsChange(F){C._onDidChangeCellOutputs.fire(F)},emitCellMetadataChange(F){C._onDidChangeCellMetadata.fire(F)},emitCellExecutionStateChange(F){C._onDidChangeCellExecutionState.fire(F)}},P,v.metadata?g.NotebookDocumentMetadata.to(v.metadata):new o.NotebookDocumentMetadata,b);c.acceptModelChanged({versionId:v.versionId,rawEvents:[{kind:a.NotebookCellsChangeType.Initialize,changes:[[0,0,v.cells]]}]},!1),u.push(...v.cells.map(F=>w.ExtHostCell.asModelAddData(c.apiNotebook,F))),(t=this._documents.get(b))===null||t===void 0||t.dispose(),this._documents.set(b,c),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this._onDidOpenNotebookDocument.fire(c.apiNotebook)}}if(h.addedEditors)for(const u of h.addedEditors){if(this._editors.has(u.id))return;const v=i.URI.revive(u.documentUri),b=this._documents.get(v);b&&this._createExtHostEditor(b,u.id,u)}const s=[];if(h.removedEditors)for(const u of h.removedEditors){const v=this._editors.get(u);v&&(this._editors.delete(u),((n=this._activeNotebookEditor)===null||n===void 0?void 0:n.id)===v.id&&(this._activeNotebookEditor=void 0),s.push(v))}if(h.visibleEditors){this._visibleNotebookEditors=h.visibleEditors.map(v=>this._editors.get(v)).filter(v=>!!v);const u=new Set;this._visibleNotebookEditors.forEach(v=>u.add(v.id));for(const v of this._editors.values()){const b=u.has(v.id);v._acceptVisibility(b)}this._visibleNotebookEditors=[...this._editors.values()].map(v=>v).filter(v=>v.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}h.newActiveEditor===null?this._activeNotebookEditor=void 0:h.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(h.newActiveEditor)),h.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((r=this._activeNotebookEditor)===null||r===void 0?void 0:r.apiEditor)}}e.ExtHostNotebookController=l,l._notebookStatusBarItemProviderHandlePool=0}),define(be[203],_e([0,1,3,6,5,26,2,10,73,22,11,50,20,14,17,7]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let w=class{constructor(h,t,n,r){this._mainContext=h,this._initData=t,this._extHostNotebook=n,this._logService=r,this._activeExecutions=new k.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=h.getProxy(D.MainContext.MainThreadNotebookKernels)}createNotebookController(h,t,n,r,s,u){for(let U of this._kernelData.values())if(U.controller.id===t&&T.ExtensionIdentifier.equals(h.identifier,U.extensionId))throw new Error(`notebook controller with id '${t}' ALREADY exist`);const v=this._handlePool++,b=this;this._logService.trace(`NotebookController[${v}], CREATED by ${h.identifier.value}, ${t}`);const P=()=>console.warn(`NO execute handler from notebook controller '${z.id}' of extension: '${h.identifier}'`);let C=!1;const c=new R.DisposableStore,F=new p.Emitter,N=new p.Emitter,z={id:`${h.identifier.value}/${t}`,viewType:n,extensionId:h.identifier,extensionLocation:h.extensionLocation,label:r||h.identifier.value,preloads:u?u.map(S.NotebookRendererScript.from):[]};let he=s??P,me;this._proxy.$addKernel(v,z).catch(U=>{console.log(U),C=!0});let Q=0;const W=()=>{if(C)return;const U=++Q;Promise.resolve().then(()=>{U===Q&&this._proxy.$updateKernel(v,z)})},x=new k.ResourceMap,A={get id(){return t},get viewType(){return z.viewType},onDidChangeNotebookAssociation:F.event,get label(){return z.label},set label(U){var M;z.label=(M=U??h.displayName)!==null&&M!==void 0?M:h.name,W()},get detail(){var U;return(U=z.detail)!==null&&U!==void 0?U:""},set detail(U){z.detail=U,W()},get description(){var U;return(U=z.description)!==null&&U!==void 0?U:""},set description(U){z.description=U,W()},get supportedLanguages(){return z.supportedLanguages},set supportedLanguages(U){z.supportedLanguages=U,W()},get hasExecutionOrder(){var U;return(U=z.hasExecutionOrder)!==null&&U!==void 0?U:!1},set hasExecutionOrder(U){z.hasExecutionOrder=U,W()},get rendererScripts(){return z.preloads?z.preloads.map(S.NotebookRendererScript.to):[]},get executeHandler(){return he},set executeHandler(U){he=U??P},get interruptHandler(){return me},set interruptHandler(U){me=U,z.supportsInterrupt=Boolean(U),W()},createNotebookCellExecution(U){if(C)throw new Error("notebook controller is DISPOSED");if(!x.has(U.notebook.uri))throw b._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(x.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${U.notebook.uri.toString()}`);return b._createNotebookCellExecution(U)},dispose:()=>{C||(this._logService.trace(`NotebookController[${v}], DISPOSED`),C=!0,this._kernelData.delete(v),c.dispose(),F.dispose(),N.dispose(),this._proxy.$removeKernel(v))},onDidReceiveMessage:N.event,postMessage(U,M){return b._proxy.$postMessage(v,M&&b._extHostNotebook.getIdByEditor(M),U)},asWebviewUri(U){return(0,E.asWebviewUri)(U,b._initData.remote)},updateNotebookAffinity(U,M){b._proxy.$updateNotebookPriority(v,U.uri,M)}};return this._kernelData.set(v,{extensionId:h.identifier,controller:A,onDidReceiveMessage:N,onDidChangeSelection:F,associatedNotebooks:x}),A}$acceptNotebookAssociation(h,t,n){const r=this._kernelData.get(h);if(r){const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));n?r.associatedNotebooks.set(s.uri,!0):r.associatedNotebooks.delete(s.uri),this._logService.trace(`NotebookController[${h}] ASSOCIATE notebook`,s.uri.toString(),n),r.onDidChangeSelection.fire({selected:n,notebook:s.apiNotebook})}}async $executeCells(h,t,n){const r=this._kernelData.get(h);if(!r)return;const s=this._extHostNotebook.getNotebookDocument(_.URI.revive(t)),u=[];for(let v of n){const b=s.getCell(v);b&&u.push(b.apiCell)}try{this._logService.trace(`NotebookController[${h}] EXECUTE cells`,s.uri.toString(),u.length),await r.controller.executeHandler.call(r.controller,u,s.apiNotebook,r.controller)}catch(v){this._logService.error(`NotebookController[${h}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(h,t,n){var r;const s=this._kernelData.get(h);if(!s)return;const u=this._extHostNotebook.getNotebookDocument(_.URI.revive(t));if(s.controller.interruptHandler)await s.controller.interruptHandler.call(s.controller,u.apiNotebook);else for(let v of n){const b=u.getCell(v);b&&((r=this._activeExecutions.get(b.uri))===null||r===void 0||r.cancel())}}$acceptKernelMessageFromRenderer(h,t,n){const r=this._kernelData.get(h);if(!r)return;const s=this._extHostNotebook.getEditorById(t);if(!s)throw new Error(`send message for UNKNOWN editor: ${t}`);r.onDidReceiveMessage.fire(Object.freeze({editor:s.apiEditor,message:n}))}_createNotebookCellExecution(h){if(h.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const n=this._extHostNotebook.getNotebookDocument(h.notebook.uri).getCellFromApiCell(h);if(!n)throw new Error("invalid cell");if(this._activeExecutions.has(n.uri))throw new Error(`duplicate execution for ${n.uri}`);const r=new y(n.notebook,n,this._mainContext.getProxy(D.MainContext.MainThreadNotebookDocuments));this._activeExecutions.set(n.uri,r);const s=r.onDidChangeState(()=>{r.state===f.Resolved&&(r.dispose(),s.dispose(),this._activeExecutions.delete(n.uri))});return r.asApiObject()}};w=ze([je(3,o.ILogService)],w),e.ExtHostNotebookKernels=w;var f;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(f||(f={}));class y extends R.Disposable{constructor(h,t,n){super();this._document=h,this._cell=t,this._proxy=n,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=f.Init,this._tokenSource=this._register(new d.CancellationTokenSource),this._collector=new l(10,r=>this.applyEdits(r)),this._executionOrder=t.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(h){await this._collector.addItem(h)}async applyEdits(h){return this._proxy.$applyEdits(this._document.uri,h,!1)}verifyStateForOutput(){if(this._state===f.Init)throw new Error("Must call start before modifying cell output");if(this._state===f.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(h){const t={editType:9,handle:this._cell.handle,internalMetadata:h};this.applyEdits([t])}cellIndexToHandle(h){if(typeof h!="number")return this._cell.handle;const t=this._document.getCellFromIndex(h);if(!t)throw new Error("INVALID cell index");return t.handle}validateAndConvertOutputs(h){return h.map(t=>{const n=a.NotebookCellOutput.ensureUniqueMimeTypes(t.outputs,!0);return n===t.outputs?S.NotebookCellOutput.from(t):S.NotebookCellOutput.from({outputs:n,id:t.id,metadata:t.metadata})})}asApiObject(){const h=this;return Object.freeze({get token(){return h._tokenSource.token},get document(){return h._document.apiNotebook},get cell(){return h._cell.apiCell},get executionOrder(){return h._executionOrder},set executionOrder(t){h._executionOrder=t,h.mixinMetadata({executionOrder:t})},start(t){var n;if(h._state===f.Resolved||h._state===f.Started)throw new Error("Cannot call start again");h._state=f.Started,h._onDidChangeState.fire(),h.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:(n=t==null?void 0:t.startTime)!==null&&n!==void 0?n:null})},end(t){var n,r;if(h._state===f.Resolved)throw new Error("Cannot call resolve twice");h._state=f.Resolved,h._onDidChangeState.fire(),h.mixinMetadata({runState:null,lastRunSuccess:(n=t==null?void 0:t.success)!==null&&n!==void 0?n:null,runEndTime:(r=t==null?void 0:t.endTime)!==null&&r!==void 0?r:null})},clearOutput(t){return h.verifyStateForOutput(),this.replaceOutput([],t)},async appendOutput(t,n){h.verifyStateForOutput();const r=h.cellIndexToHandle(n),s=h.validateAndConvertOutputs((0,g.asArray)(t));return h.applyEditSoon({editType:2,handle:r,append:!0,outputs:s})},async replaceOutput(t,n){h.verifyStateForOutput();const r=h.cellIndexToHandle(n),s=h.validateAndConvertOutputs((0,g.asArray)(t));return h.applyEditSoon({editType:2,handle:r,outputs:s})},async appendOutputItems(t,n){return h.verifyStateForOutput(),t=a.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(t),!0),h.applyEditSoon({editType:7,append:!0,items:t.map(S.NotebookCellOutputItem.from),outputId:n})},async replaceOutputItems(t,n){return h.verifyStateForOutput(),t=a.NotebookCellOutput.ensureUniqueMimeTypes((0,g.asArray)(t),!0),h.applyEditSoon({editType:7,items:t.map(S.NotebookCellOutputItem.from),outputId:n})}})}}class l{constructor(h,t){this.delay=h,this.callback=t,this.batch=[]}addItem(h){return this.batch.push(h),this.waitPromise||(this.waitPromise=(0,i.timeout)(this.delay).then(()=>{this.waitPromise=void 0;const t=this.batch;return this.batch=[],this.callback(t)})),this.waitPromise}}}),define(be[204],_e([0,1,3,5,98]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class T{constructor(S,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=S.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(S,E,k){var i;const I=this._extHostNotebook.getEditorById(S);!I||(i=this._rendererMessageEmitters.get(E))===null||i===void 0||i.fire({editor:I.apiEditor,message:k})}createRendererMessaging(S){return{onDidReceiveMessage:(...k)=>this.getOrCreateEmitterFor(S).event(...k),postMessage:(k,i)=>{const I=D.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,S,i)}}}getOrCreateEmitterFor(S){let E=this._rendererMessageEmitters.get(S);return E||(E=new p.Emitter({onLastListenerRemove:()=>{E==null||E.dispose(),this._rendererMessageEmitters.delete(S)}}),this._rendererMessageEmitters.set(S,E),E)}}e.ExtHostNotebookRenderers=T}),define(be[102],_e([0,1,5,3,6,25,4,16]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class E extends D.Disposable{constructor(o,a,w,f){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=o,this._proxy=f,this._id=f.$register(this.name,a,w),this._disposed=!1,this._offset=0}get name(){return this._name}append(o){this.validate(),this._offset+=o?T.VSBuffer.fromString(o).byteLength:0}update(){this._id.then(o=>this._proxy.$update(o))}appendLine(o){this.validate(),this.append(o+`
`)}clear(){this.validate();const o=this._offset;this._id.then(a=>this._proxy.$clear(a,o))}show(o,a){this.validate(),this._id.then(w=>this._proxy.$reveal(w,!!(typeof o=="boolean"?o:a)))}hide(){this.validate(),this._id.then(o=>this._proxy.$close(o))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(o=>this._proxy.$dispose(o)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=E;class k extends E{constructor(o,a){super(o,!1,void 0,a)}append(o){super.append(o),this._id.then(a=>this._proxy.$append(a,o)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class i extends E{constructor(o,a,w){super(o,!0,a,w)}append(o){throw new Error("Not supported")}}class I{constructor(o,a){this.name=o,this._channel=a}append(o){this._channel.then(a=>a.append(o))}appendLine(o){this._channel.then(a=>a.appendLine(o))}clear(){this._channel.then(o=>o.clear())}show(o,a){this._channel.then(w=>w.show(o,a))}hide(){this._channel.then(o=>o.hide())}dispose(){this._channel.then(o=>o.dispose())}}e.LazyOutputChannel=I;let d=class{constructor(o){this._proxy=o.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(o){}createOutputChannel(o){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");return new k(o,this._proxy)}createOutputChannelFromLogFile(o,a){if(o=o.trim(),!o)throw new Error("illegal argument `name`. must not be falsy");if(!a)throw new Error("illegal argument `file`. must not be falsy");return new i(o,a,this._proxy)}};d=ze([je(0,S.IExtHostRpcService)],d),e.ExtHostOutputService=d,e.IExtHostOutputService=(0,_.createDecorator)("IExtHostOutputService")}),define(be[205],_e([0,1,11,20,3,6,5,2,7,13,14,47]),function(X,e,p,R,D,T,_,S,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(g,o,a){const w=g.getProxy(_.MainContext.MainThreadQuickOpen);class f{constructor(s,u){this._sessions=new Map,this._instances=0,this._workspace=s,this._commands=u}showQuickPick(s,u,v,b=R.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(s),C=++this._instances,c=w.$show(C,{title:v==null?void 0:v.title,placeHolder:v==null?void 0:v.placeHolder,matchOnDescription:v==null?void 0:v.matchOnDescription,matchOnDetail:v==null?void 0:v.matchOnDetail,ignoreFocusLost:v==null?void 0:v.ignoreFocusOut,canPickMany:v==null?void 0:v.canPickMany},b),F={},N=c.then(()=>F);return Promise.race([N,P]).then(z=>{if(z!==F)return P.then(he=>{const me=[];for(let Q=0;Q<he.length;Q++){const W=he[Q];let x,A,U,M,$;typeof W=="string"?x=W:(x=W.label,A=W.description,U=W.detail,M=W.picked,$=W.alwaysShow),me.push({label:x,description:A,handle:Q,detail:U,picked:M,alwaysShow:$})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=Q=>{v.onDidSelectItem(he[Q])}),w.$setItems(C,me),c.then(Q=>{if(typeof Q=="number")return he[Q];if(Array.isArray(Q))return Q.map(W=>he[W])})})}).then(void 0,z=>{if(!(0,k.isPromiseCanceledError)(z))return w.$setError(C,z),Promise.reject(z)})}$onItemSelected(s){this._onDidSelectItem&&this._onDidSelectItem(s)}showInput(s,u=R.CancellationToken.None){return this._validateInput=s?s.validateInput:void 0,w.$input(s,typeof this._validateInput=="function",u).then(void 0,v=>{if(!(0,k.isPromiseCanceledError)(v))return Promise.reject(v)})}$validateInput(s){return this._validateInput?(0,p.asPromise)(()=>this._validateInput(s)):Promise.resolve(void 0)}async showWorkspaceFolderPick(s,u=R.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[s]);if(!v)return;const b=await this._workspace.getWorkspaceFolders2();if(!!b)return b.find(P=>P.uri.toString()===v.uri.toString())}createQuickPick(s,u){const v=new t(s,u,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(s){const u=new n(s,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(s,u){const v=this._sessions.get(s);v&&v._fireDidChangeValue(u)}$onDidAccept(s){const u=this._sessions.get(s);u&&u._fireDidAccept()}$onDidChangeActive(s,u){const v=this._sessions.get(s);v instanceof t&&v._fireDidChangeActive(u)}$onDidChangeSelection(s,u){const v=this._sessions.get(s);v instanceof t&&v._fireDidChangeSelection(u)}$onDidTriggerButton(s,u){const v=this._sessions.get(s);v&&v._fireDidTriggerButton(u)}$onDidHide(s){const u=this._sessions.get(s);u&&u._fireDidHide()}}class y{constructor(s,u){this._extensionId=s,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new D.Emitter,this._onDidChangeValueEmitter=new D.Emitter,this._onDidTriggerButtonEmitter=new D.Emitter,this._onDidHideEmitter=new D.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(s){this._title=s,this.update({title:s})}get step(){return this._steps}set step(s){this._steps=s,this.update({step:s})}get totalSteps(){return this._totalSteps}set totalSteps(s){this._totalSteps=s,this.update({totalSteps:s})}get enabled(){return this._enabled}set enabled(s){this._enabled=s,this.update({enabled:s})}get busy(){return this._busy}set busy(s){this._busy=s,this.update({busy:s})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(s){this._ignoreFocusOut=s,this.update({ignoreFocusOut:s})}get value(){return this._value}set value(s){this._value=s,this.update({value:s})}get placeholder(){return this._placeholder}set placeholder(s){this._placeholder=s,this.update({placeholder:s})}get buttons(){return this._buttons}set buttons(s){this._buttons=s.slice(),this._handlesToButtons.clear(),s.forEach((u,v)=>{const b=u===E.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(b,u)}),this.update({buttons:s.map((u,v)=>({iconPath:l(u.iconPath),tooltip:u.tooltip,handle:u===E.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(s){this._value=s,this._onDidChangeValueEmitter.fire(s)}_fireDidTriggerButton(s){const u=this._handlesToButtons.get(s);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,T.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),w.$dispose(this._id))}update(s){if(!this._disposed){for(const u of Object.keys(s)){const v=s[u];this._pendingUpdate[u]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){w.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}y._nextId=1;function l(r){if(r instanceof E.ThemeIcon)return{id:r.id};const s=h(r),u=m(r);return{dark:typeof s=="string"?S.URI.file(s):s,light:typeof u=="string"?S.URI.file(u):u}}function m(r){return typeof r=="object"&&"light"in r?r.light:r}function h(r){return typeof r=="object"&&"dark"in r?r.dark:r}class t extends y{constructor(s,u,v){super(s,v);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new D.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new D.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(s){this._items=s.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),s.forEach((u,v)=>{this._handlesToItems.set(v,u),this._itemsToHandles.set(u,v)}),this.update({items:s.map((u,v)=>({label:u.label,description:u.description,handle:v,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(s){this._canSelectMany=s,this.update({canSelectMany:s})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(s){this._matchOnDescription=s,this.update({matchOnDescription:s})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(s){this._matchOnDetail=s,this.update({matchOnDetail:s})}get sortByLabel(){return this._sortByLabel}set sortByLabel(s){this._sortByLabel=s,this.update({sortByLabel:s})}get activeItems(){return this._activeItems}set activeItems(s){this._activeItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(s){this._selectedItems=s.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(s){const u=(0,i.coalesce)(s.map(v=>this._handlesToItems.get(v)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(s){const u=(0,i.coalesce)(s.map(v=>this._handlesToItems.get(v)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class n extends y{constructor(s,u){super(s,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(s){this._password=s,this.update({password:s})}get prompt(){return this._prompt}set prompt(s){this._prompt=s,this.update({prompt:s})}get validationMessage(){return this._validationMessage}set validationMessage(s){this._validationMessage=s,this.update({validationMessage:s,severity:s?I.default.Error:I.default.Ignore})}}return new f(o,a)}e.createExtHostQuickOpen=d}),define(be[206],_e([0,1,2,3,53,6,11,5,14,114,17,26,32]),function(X,e,p,R,D,T,_,S,E,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function g(s){if(s)return typeof s.iconPath=="string"?p.URI.file(s.iconPath):s.iconPath}function o(s,u){if(!s.iconPath&&!u.iconPath)return 0;if(s.iconPath){if(!u.iconPath)return 1}else return-1;const v=typeof s.iconPath=="string"?s.iconPath:s.iconPath.fsPath,b=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return(0,k.comparePaths)(v,b)}function a(s,u){let v=0;if(s.strikeThrough!==u.strikeThrough)return s.strikeThrough?1:-1;if(s.faded!==u.faded)return s.faded?1:-1;if(s.tooltip!==u.tooltip)return(s.tooltip||"").localeCompare(u.tooltip||"");if(v=o(s,u),v!==0)return v;if(s.light&&u.light)v=o(s.light,u.light);else{if(s.light)return 1;if(u.light)return-1}if(v!==0)return v;if(s.dark&&u.dark)v=o(s.dark,u.dark);else{if(s.dark)return 1;if(u.dark)return-1}return v}function w(s,u){if(s.command!==u.command)return s.command<u.command?-1:1;if(s.title!==u.title)return s.title<u.title?-1:1;if(s.tooltip!==u.tooltip){if(s.tooltip!==void 0&&u.tooltip!==void 0)return s.tooltip<u.tooltip?-1:1;if(s.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(s.arguments===u.arguments)return 0;if(s.arguments)if(u.arguments){if(s.arguments.length!==u.arguments.length)return s.arguments.length-u.arguments.length}else return 1;else return-1;for(let v=0;v<s.arguments.length;v++){const b=s.arguments[v],P=u.arguments[v];if(b!==P)return b<P?-1:1}return 0}function f(s,u){let v=(0,k.comparePaths)(s.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(v!==0)return v;if(s.command&&u.command)v=w(s.command,u.command);else{if(s.command)return 1;if(u.command)return-1}if(v!==0)return v;if(s.decorations&&u.decorations)v=a(s.decorations,u.decorations);else{if(s.decorations)return 1;if(u.decorations)return-1}return v}function y(s,u){for(let v=0;v<s.length;v++)if(s[v]!==u[v])return!1;return!0}function l(s,u){return s.command===u.command&&s.title===u.title&&s.tooltip===u.tooltip&&(s.arguments&&u.arguments?y(s.arguments,u.arguments):s.arguments===u.arguments)}function m(s,u){return(0,E.equals)(s,u,l)}class h{constructor(u,v,b){this._extension=u,this._proxy=v,this._sourceControlHandle=b,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return(0,d.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(u){if((0,d.checkProposedApiEnabled)(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){(0,d.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,v){(0,d.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,v)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=h;class t{constructor(u,v,b,P,C){this._proxy=u,this._commands=v,this._sourceControlHandle=b,this._id=P,this._label=C,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,v){const b=this._resourceStatesCommandsMap.get(u);return b?(0,_.asPromise)(()=>this._commands.executeCommand(b.command,...b.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const v=[...this._resourceStates].sort(f),P=(0,E.sortedDiff)(this._resourceSnapshot,v,f).map(F=>{const N=F.toInsert.map(z=>{const he=this._resourceHandlePool++;this._resourceStatesMap.set(he,z);const me=z.resourceUri,Q=g(z.decorations),W=z.decorations&&g(z.decorations.light)||Q,x=z.decorations&&g(z.decorations.dark)||Q,A=[];let U;if(z.command)if(z.command.command==="vscode.open"||z.command.command==="vscode.diff"){const we=new T.DisposableStore;U=this._commands.converter.toInternal(z.command,we),this._resourceStatesDisposablesMap.set(he,we)}else this._resourceStatesCommandsMap.set(he,z.command);W&&A.push(W),x&&x.toString()!==(W==null?void 0:W.toString())&&A.push(x);const M=z.decorations&&z.decorations.tooltip||"",$=z.decorations&&!!z.decorations.strikeThrough,K=z.decorations&&!!z.decorations.faded,j=z.contextValue||"";return{rawResource:[he,me,A,M,$,K,j,U],handle:he}});return{start:F.start,deleteCount:F.deleteCount,toInsert:N}}),C=P.map(({start:F,deleteCount:N,toInsert:z})=>[F,N,z.map(he=>he.rawResource)]),c=P.reverse();for(const{start:F,deleteCount:N,toInsert:z}of c){const he=z.map(Q=>Q.handle),me=this._handlesSnapshot.splice(F,N,...he);for(const Q of me)this._resourceStatesMap.delete(Q),this._resourceStatesCommandsMap.delete(Q),(u=this._resourceStatesDisposablesMap.get(Q))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(Q)}return this._resourceSnapshot=v,C}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class n{constructor(u,v,b,P,C,c){this._proxy=v,this._commands=b,this._id=P,this._label=C,this._rootUri=c,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new T.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new T.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=n._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new h(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,C,c)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new T.DisposableStore,this._acceptInputCommand=u;const v=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&m(this._statusBarCommands,u))return;this._statusBarDisposables.value=new T.DisposableStore,this._statusBarCommands=u;const v=(u||[]).map(b=>this._commands.converter.toInternal(b,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(u,v){const b=new t(this._proxy,this._commands,this.handle,u,v),P=R.Event.once(b.onDidDispose)(()=>this.createdResourceGroups.delete(b));return this.createdResourceGroups.set(b,P),this.eventuallyAddResourceGroups(),b}eventuallyAddResourceGroups(){const u=[],v=[];for(const[b,P]of this.createdResourceGroups){P.dispose();const C=b.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(b),this.eventuallyUpdateResourceStates()});R.Event.once(b.onDidDispose)(()=>{this.updatedResourceGroups.delete(b),C.dispose(),this._groups.delete(b.handle),this._proxy.$unregisterGroup(this.handle,b.handle)}),u.push([b.handle,b.id,b.label,b.features]);const c=b._takeResourceStateSnapshot();c.length>0&&v.push([b.handle,c]),this._groups.set(b.handle,b)}this._proxy.$registerGroups(this.handle,u,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(v=>{const b=v._takeResourceStateSnapshot();b.length!==0&&u.push([v.handle,b])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}n._handlePool=0,ze([(0,D.debounce)(100)],n.prototype,"eventuallyAddResourceGroups",null),ze([(0,D.debounce)(100)],n.prototype,"eventuallyUpdateResourceStates",null);let r=class Ln{constructor(u,v,b){this._commands=v,this.logService=b,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=u.getProxy(S.MainContext.MainThreadSCM),this._telemetry=u.getProxy(S.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const C=this._sourceControls.get(P.sourceControlHandle);if(!C)return P;const c=C.getResourceGroup(P.groupHandle);return c?c.getResourceState(P.handle):P}else if(P&&P.$mid===4){const C=this._sourceControls.get(P.sourceControlHandle);return C?C.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const C=this._sourceControls.get(P.handle);return C||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,v,b,P){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,v,b,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const C=Ln._handlePool++,c=new n(u,this._proxy,this._commands,v,b,P);this._sourceControls.set(C,c);const F=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return F.push(c),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),F),c}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const v=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),b=v&&v[v.length-1];return b&&b.inputBox}$provideOriginalResource(u,v,b){const P=p.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,P.toString());const C=this._sourceControls.get(u);return!C||!C.quickDiffProvider||!C.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,_.asPromise)(()=>C.quickDiffProvider.provideOriginalResource(P,b)).then(c=>c||null)}$onInputBoxValueChange(u,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const b=this._sourceControls.get(u);return b&&b.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(u,v,b,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,v,b);const C=this._sourceControls.get(u);if(!C)return Promise.resolve(void 0);const c=C.getResourceGroup(v);return c?c.$executeResourceCommand(b,P):Promise.resolve(void 0)}$validateInput(u,v,b){this.logService.trace("ExtHostSCM#$validateInput",u);const P=this._sourceControls.get(u);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):(0,_.asPromise)(()=>P.inputBox.validateInput(v,b)).then(C=>C?Promise.resolve([C.message,C.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var v,b;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((v=this._sourceControls.get(u))===null||v===void 0||v.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((b=this._sourceControls.get(this._selectedSourceControlHandle))===null||b===void 0||b.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};r._handlePool=0,r=ze([je(2,i.ILogService)],r),e.ExtHostSCM=r});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[207],_e([0,1,7,5,136,6]),function(X,e,p,R,D,T){"use strict";var _,S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class E{constructor(d,g,o,a,w=p.StatusBarAlignment.Left,f){_.set(this,void 0),S.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new T.DisposableStore,nt(this,_,d,"f"),nt(this,S,g,"f"),this._entryId=E.ID_GEN++,this._extension=o,this._id=a,this._alignment=w,this._priority=f}get id(){var d;return(d=this._id)!==null&&d!==void 0?d:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var d;return(d=this._command)===null||d===void 0?void 0:d.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!E.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){var g;((g=this._command)===null||g===void 0?void 0:g.fromApi)!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Ue(this,S,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Ue(this,S,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Ue(this,_,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var d;this._timeoutHandle=void 0;let g;this._extension?this._id?g=`${this._extension.identifier.value}.${this._id}`:g=this._extension.identifier.value:g=this._id;let o;this._name?o=this._name:o=(0,D.localize)(0,null,this._extension.displayName||this._extension.name);let a=this._color;this._backgroundColor&&(a=E.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id)),Ue(this,_,"f").$setEntry(this._entryId,g,o,this._text,this._tooltip,(d=this._command)===null||d===void 0?void 0:d.internal,a,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=E,_=new WeakMap,S=new WeakMap,E.ID_GEN=0,E.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class k{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,D.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const g={message:d};return this._messages.unshift(g),this._update(),new p.Disposable(()=>{const o=this._messages.indexOf(g);o>=0&&(this._messages.splice(o,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class i{constructor(d,g){this._proxy=d.getProxy(R.MainContext.MainThreadStatusBar),this._commands=g,this._statusMessage=new k(this)}createStatusBarEntry(d,g,o,a){return new E(this._proxy,this._commands,d,g,o,a)}setStatusBarMessage(d,g){const o=this._statusMessage.setMessage(d);let a;return typeof g=="number"?a=setTimeout(()=>o.dispose(),g):typeof g!="undefined"&&g.then(()=>o.dispose(),()=>o.dispose()),new p.Disposable(()=>{o.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=i}),define(be[78],_e([0,1,5,3,4]),function(X,e,p,R,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class T{constructor(S){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=S.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(S,E){this._proxy.$registerExtensionStorageKeysToSync(S,E)}getValue(S,E,k){return this._proxy.$getValue(S,E).then(i=>i||k)}setValue(S,E,k){return this._proxy.$setValue(S,E,k)}$acceptValue(S,E,k){this._onDidChangeStorage.fire({shared:S,key:E,value:k})}}e.ExtHostStorage=T,e.IExtHostStorage=(0,D.createDecorator)("IExtHostStorage")}),define(be[79],_e([0,1,4,28,17,77,2]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,p.createDecorator)("IExtensionStoragePaths");let S=class{constructor(k,i,I){var d;this._logService=i,this._extHostFileSystem=I,this._workspace=(d=k.workspace)!==null&&d!==void 0?d:void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(g=>this._value=g)}async _getOrCreateWorkspaceStoragePath(){var k;if(!this._workspace)return Promise.resolve(void 0);const i=this._workspace.id,I=_.URI.joinPath(this._environment.workspaceStorageHome,i);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(d){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(_.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(k=_.URI.revive(this._workspace.configuration))===null||k===void 0?void 0:k.toString(),name:this._workspace.name},void 0,2))),I}catch(d){this._logService.error("[ExtHostStorage]",d);return}}workspaceValue(k){if(this._value)return _.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return _.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}};S=ze([je(0,R.IExtHostInitDataService),je(1,D.ILogService),je(2,T.IExtHostConsumerFileSystem)],S),e.ExtensionStoragePaths=S}),define(be[40],_e([0,1,3,5,4,2,16,6,7,137,13,174,20,37,158,9]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,D.createDecorator)("IExtHostTerminalService");class w{constructor(n,r,s,u){this._proxy=n,this._id=r,this._creationOptions=s,this._name=u,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(b=>this._pidPromiseComplete=b);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},sendText(b,P=!0){v._checkDisposed(),v._proxy.$sendText(v._id,b,P)},show(b){v._checkDisposed(),v._proxy.$show(v._id,b)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:n.name,shellPath:(0,a.withNullAsUndefined)(n.shellPath),shellArgs:(0,a.withNullAsUndefined)(n.shellArgs),cwd:(0,a.withNullAsUndefined)(n.cwd),env:(0,a.withNullAsUndefined)(n.env),icon:(0,a.withNullAsUndefined)(n.iconPath),initialText:(0,a.withNullAsUndefined)(n.message),strictEnv:(0,a.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,a.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,a.withNullAsUndefined)(r==null?void 0:r.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,a.withNullAsUndefined)(r==null?void 0:r.useShellEnvironment),isSplitTerminal:(0,a.withNullAsUndefined)(r==null?void 0:r.isSplitTerminal)})}async createExtensionTerminal(n,r){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:r,isSplitTerminal:n}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(n){this._name=n}setExitCode(n){this._exitStatus=Object.freeze({code:n})}setDimensions(n,r){return n===this._cols&&r===this._rows||n===0||r===0?!1:(this._cols=n,this._rows=r,!0)}_setProcessId(n){this._pidPromiseComplete?(this._pidPromiseComplete(n),this._pidPromiseComplete=void 0):this._pidPromise.then(r=>{r!==n&&(this._pidPromise=Promise.resolve(n))})}}e.ExtHostTerminal=w;class f{constructor(n){this._pty=n,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(n){this._pty.handleInput&&this._pty.handleInput(n)}resize(n,r){this._pty.setDimensions&&this._pty.setDimensions({columns:n,rows:r})}async processBinary(n){}acknowledgeDataEvent(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this._pty.onDidWrite(r=>this._onProcessData.fire(r)),this._pty.onDidClose&&this._pty.onDidClose((r=void 0)=>{this._onProcessExit.fire(r===void 0?void 0:r)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r&&{cols:r.columns,rows:r.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(r=>this._onProcessTitleChanged.fire(r)),this._pty.open(n||void 0),this._pty.setDimensions&&n&&this._pty.setDimensions(n),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=f;let y=1,l=class extends S.Disposable{constructor(n,r){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=r.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new o.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(n),this._register({dispose:()=>{for(const[s,u]of this._terminalProcesses)u.shutdown(!0)}})}get activeTerminal(){var n;return(n=this._activeTerminal)===null||n===void 0?void 0:n.value}get terminals(){return this._terminals.map(n=>n.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(n){const r=n?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.path)||""}getDefaultShellArgs(n){const r=n?this._defaultAutomationProfile:this._defaultProfile;return(r==null?void 0:r.args)||[]}createExtensionTerminal(n,r){const s=new w(this._proxy,(0,g.generateUuid)(),n,n.name),u=new f(n.pty);return s.createExtensionTerminal(r==null?void 0:r.isSplitTerminal,n.iconPath).then(v=>{const b=this._setupExtHostProcessListeners(v,u);this._terminalProcessDisposables[v]=b}),this._terminals.push(s),s.value}attachPtyToTerminal(n,r){if(!this._getTerminalById(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const u=new f(r),v=this._setupExtHostProcessListeners(n,u);this._terminalProcessDisposables[n]=v}async $acceptActiveTerminalChanged(n){const r=this._activeTerminal;if(n===null){this._activeTerminal=void 0,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const s=this._getTerminalById(n);s&&(this._activeTerminal=s,r!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(n,r){const s=this._getTerminalById(n);s&&this._onDidWriteTerminalData.fire({terminal:s.value,data:r})}async $acceptTerminalDimensions(n,r,s){const u=this._getTerminalById(n);u&&u.setDimensions(r,s)&&this._onDidChangeTerminalDimensions.fire({terminal:u.value,dimensions:u.value.dimensions})}async $acceptTerminalMaximumDimensions(n,r,s){var u;(u=this._terminalProcesses.get(n))===null||u===void 0||u.resize(r,s)}async $acceptTerminalTitleChange(n,r){const s=this._getTerminalById(n);s&&(s.name=r)}async $acceptTerminalClosed(n,r){const s=this._getTerminalObjectIndexById(this._terminals,n);if(s!==null){const u=this._terminals.splice(s,1)[0];u.setExitCode(r),this._onDidCloseTerminal.fire(u.value)}}$acceptTerminalOpened(n,r,s,u){if(r){const P=this._getTerminalObjectIndexById(this._terminals,r);if(P!==null){this._terminals[P]._id=n,this._onDidOpenTerminal.fire(this.terminals[P]),this._terminals[P].isOpen=!0;return}}const v={name:u.name,shellPath:u.executable,shellArgs:u.args,cwd:typeof u.cwd=="string"?u.cwd:T.URI.revive(u.cwd),env:u.env,hideFromUser:u.hideFromUser},b=new w(this._proxy,n,v,s);this._terminals.push(b),this._onDidOpenTerminal.fire(b.value),b.isOpen=!0}async $acceptTerminalProcessId(n,r){const s=this._getTerminalById(n);s&&s._setProcessId(r)}async $startExtensionTerminal(n,r){const s=this._getTerminalById(n);if(!s)return{message:(0,k.localize)(0,null,n)};s.isOpen||await new Promise(v=>{const b=this.onDidOpenTerminal(async P=>{P===s.value&&(b.dispose(),v())})});const u=this._terminalProcesses.get(n);u?u.startSendingEvents(r):this._extensionTerminalAwaitingStart[n]={initialDimensions:r}}_setupExtHostProcessListeners(n,r){const s=new S.DisposableStore;s.add(r.onProcessReady(v=>this._proxy.$sendProcessReady(n,v.pid,v.cwd))),s.add(r.onProcessTitleChanged(v=>this._proxy.$sendProcessTitle(n,v))),this._bufferer.startBuffering(n,r.onProcessData),s.add(r.onProcessExit(v=>this._onProcessExit(n,v))),r.onProcessOverrideDimensions&&s.add(r.onProcessOverrideDimensions(v=>this._proxy.$sendOverrideDimensions(n,v))),this._terminalProcesses.set(n,r);const u=this._extensionTerminalAwaitingStart[n];return u&&r instanceof f&&(r.startSendingEvents(u.initialDimensions),delete this._extensionTerminalAwaitingStart[n]),s}$acceptProcessAckDataEvent(n,r){var s;(s=this._terminalProcesses.get(n))===null||s===void 0||s.acknowledgeDataEvent(r)}$acceptProcessInput(n,r){var s;(s=this._terminalProcesses.get(n))===null||s===void 0||s.input(r)}$acceptProcessResize(n,r,s){var u;try{(u=this._terminalProcesses.get(n))===null||u===void 0||u.resize(r,s)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(n,r){var s;(s=this._terminalProcesses.get(n))===null||s===void 0||s.shutdown(r)}$acceptProcessRequestInitialCwd(n){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.getInitialCwd().then(s=>this._proxy.$sendProcessInitialCwd(n,s))}$acceptProcessRequestCwd(n){var r;(r=this._terminalProcesses.get(n))===null||r===void 0||r.getCwd().then(s=>this._proxy.$sendProcessCwd(n,s))}$acceptProcessRequestLatency(n){return n}registerLinkProvider(n){return this._linkProviders.add(n),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(n),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(n,r){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,r),this._proxy.$registerProfileProvider(n),new E.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(n,r){var s;const u=new d.CancellationTokenSource().token,v=await((s=this._profileProviders.get(n))===null||s===void 0?void 0:s.provideProfileOptions(u));if(!u.isCancellationRequested){if(!v)throw new Error(`No terminal profile options provided for id "${n}"`);"pty"in v&&this.createExtensionTerminal(v,{isSplitTerminal:r}),this.createTerminalFromOptions(v,{isSplitTerminal:r})}}async $provideLinks(n,r){const s=this._getTerminalById(n);if(!s)return[];this._terminalLinkCache.delete(n);const u=this._terminalLinkCancellationSource.get(n);u&&u.dispose(!0);const v=new d.CancellationTokenSource;this._terminalLinkCancellationSource.set(n,v);const b=[],P={terminal:s.value,line:r},C=[];for(const N of this._linkProviders)C.push(new Promise(async z=>{v.token.onCancellationRequested(()=>z({provider:N,links:[]}));const he=await N.provideTerminalLinks(P,v.token)||[];v.token.isCancellationRequested||z({provider:N,links:he})}));const c=await Promise.all(C);if(v.token.isCancellationRequested)return[];const F=new Map;for(const N of c)N&&N.links.length>0&&b.push(...N.links.map(z=>{const he={id:y++,startIndex:z.startIndex,length:z.length,label:z.tooltip};return F.set(he.id,{provider:N.provider,link:z}),he}));return this._terminalLinkCache.set(n,F),b}$activateLink(n,r){var s;const u=(s=this._terminalLinkCache.get(n))===null||s===void 0?void 0:s.get(r);!u||u.provider.handleTerminalLink(u.link)}_onProcessExit(n,r){this._bufferer.stopBuffering(n),this._terminalProcesses.delete(n),delete this._extensionTerminalAwaitingStart[n];const s=this._terminalProcessDisposables[n];s&&(s.dispose(),delete this._terminalProcessDisposables[n]),this._proxy.$sendProcessExit(n,r)}_getTerminalById(n){return this._getTerminalObjectById(this._terminals,n)}_getTerminalObjectById(n,r){const s=this._getTerminalObjectIndexById(n,r);return s!==null?n[s]:null}_getTerminalObjectIndexById(n,r){let s=null;return n.some((u,v)=>u._id===r?(s=v,!0):!1),s}getEnvironmentVariableCollection(n){let r=this._environmentVariableCollections.get(n.identifier.value);return r||(r=new m,this._setEnvironmentVariableCollection(n.identifier.value,r)),r}_syncEnvironmentVariableCollection(n,r){const s=(0,I.serializeEnvironmentVariableCollection)(r.map);this._proxy.$setEnvironmentVariableCollection(n,r.persistent,s.length===0?void 0:s)}$initEnvironmentVariableCollections(n){n.forEach(r=>{const s=r[0],u=new m(r[1]);this._setEnvironmentVariableCollection(s,u)})}$acceptDefaultProfile(n,r){this._defaultProfile=n,this._defaultAutomationProfile=r}_setEnvironmentVariableCollection(n,r){this._environmentVariableCollections.set(n,r),r.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(n,r)})}};l=ze([je(1,_.IExtHostRpcService)],l),e.BaseExtHostTerminalService=l;class m{constructor(n){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(n)}get persistent(){return this._persistent}set persistent(n){this._persistent=n,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(n,r){this._setIfDiffers(n,{value:r,type:E.EnvironmentVariableMutatorType.Replace})}append(n,r){this._setIfDiffers(n,{value:r,type:E.EnvironmentVariableMutatorType.Append})}prepend(n,r){this._setIfDiffers(n,{value:r,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(n,r){const s=this.map.get(n);(!s||s.value!==r.value||s.type!==r.type)&&(this.map.set(n,r),this._onDidChangeCollection.fire())}get(n){return this.map.get(n)}forEach(n,r){this.map.forEach((s,u)=>n.call(r,u,s,this))}delete(n){this.map.delete(n),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=m;let h=class extends l{constructor(n){super(!1,n)}createTerminal(n,r,s){throw new i.NotSupportedError}createTerminalFromOptions(n,r){throw new i.NotSupportedError}};h=ze([je(0,_.IExtHostRpcService)],h),e.WorkerExtHostTerminalService=h}),define(be[208],_e([0,1,3,14,5,99,10,7]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(i,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=i.getProxy(D.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(d=>this._onDidChangeVisibleTextEditors.fire(d)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(d=>this._onDidChangeActiveTextEditor.fire(d))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(i){const I=this._extHostDocumentsAndEditors.allEditors();return i?I:I.map(d=>d.value)}async showTextDocument(i,I,d){let g;typeof I=="number"?g={position:_.ViewColumn.from(I),preserveFocus:d}:typeof I=="object"?g={position:_.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?_.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:g={preserveFocus:!1};const o=await this._proxy.$tryShowTextDocument(i.uri,g),a=o&&this._extHostDocumentsAndEditors.getEditor(o);if(a)return a.value;throw o?new Error(`Could NOT open editor for "${i.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${i.uri.toString()}".`)}createTextEditorDecorationType(i,I){return new T.TextEditorDecorationType(this._proxy,i,I).value}$acceptEditorPropertiesChanged(i,I){const d=this._extHostDocumentsAndEditors.getEditor(i);if(!d)throw new Error("unknown text editor");if(I.options&&d._acceptOptions(I.options),I.selections){const g=I.selections.selections.map(_.Selection.to);d._acceptSelections(g)}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(_.Range.to));d._acceptVisibleRanges(g)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:d.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:_.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const g=S.TextEditorSelectionChangeKind.fromValue(I.selections.source),o=I.selections.selections.map(_.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:d.value,selections:o,kind:g})}if(I.visibleRanges){const g=R.coalesce(I.visibleRanges.map(_.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:d.value,visibleRanges:g})}}$acceptEditorPositionData(i){for(const I in i){const d=this._extHostDocumentsAndEditors.getEditor(I);if(!d)throw new Error("Unknown text editor");const g=_.ViewColumn.to(i[I]);d.value.viewColumn!==g&&(d._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:d.value,viewColumn:g}))}}getDiffInformation(i){return Promise.resolve(this._proxy.$getDiffInformation(i))}}e.ExtHostEditors=E});var Kt=this&&this.__rest||function(X,e){var p={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(p[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,R=Object.getOwnPropertySymbols(X);D<R.length;D++)e.indexOf(R[D])<0&&Object.prototype.propertyIsEnumerable.call(X,R[D])&&(p[R[D]]=X[R[D]]);return p};define(be[209],_e([0,1,2,4,5,6,7]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class S{constructor(i,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=i.getProxy(D.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:d=>{var g,o;if(d&&d.$mid===11){const a=d.uri===void 0?void 0:p.URI.revive(d.uri);return(o=(g=this._itemsBySourceAndUriMap.get(d.source))===null||g===void 0?void 0:g.get(E(a)))===null||o===void 0?void 0:o.get(d.handle)}return d}})}async $getTimeline(i,I,d,g,o){const a=this._providers.get(i);return a==null?void 0:a.provideTimeline(p.URI.revive(I),d,g,o)}registerTimelineProvider(i,I,d,g){const o=new T.DisposableStore,a=this.convertTimelineItem(I.id,g,o).bind(this);let w;I.onDidChange&&(w=I.onDidChange(y=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},y),{id:I.id})),this));const f=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:i,onDidChange:void 0,async provideTimeline(y,l,m,h){var t;(h==null?void 0:h.resetCache)&&(o.clear(),(t=f.get(I.id))===null||t===void 0||t.clear());const n=await I.provideTimeline(y,l,m);if(n==null)return;const r=a(y,h);return Object.assign(Object.assign({},n),{source:I.id,items:n.items.map(r)})},dispose(){var y;for(const l of f.values())(y=l.get(I.id))===null||y===void 0||y.clear();w==null||w.dispose(),o.dispose()}}))}convertTimelineItem(i,I,d){return(g,o)=>{let a;if(o==null?void 0:o.cacheResults){let w=this._itemsBySourceAndUriMap.get(i);w===void 0&&(w=new Map,this._itemsBySourceAndUriMap.set(i,w));const f=E(g);a=w.get(f),a===void 0&&(a=new Map,w.set(f,a))}return w=>{var f,y;const{iconPath:l}=w,m=Kt(w,["iconPath"]),h=`${i}|${(f=w.id)!==null&&f!==void 0?f:w.timestamp}`;a==null||a.set(h,w);let t,n,r;return w.iconPath&&(l instanceof _.ThemeIcon?r={id:l.id}:p.URI.isUri(l)?(t=l,n=l):{light:t,dark:n}=l),Object.assign(Object.assign({},m),{id:(y=m.id)!==null&&y!==void 0?y:void 0,handle:h,source:i,command:w.command?I.toInternal(w.command,d):void 0,icon:t,iconDark:n,themeIcon:r,accessibilityInformation:w.accessibilityInformation})}}}registerTimelineProviderCore(i){if(this._providers.get(i.id))throw new Error(`Timeline Provider ${i.id} already exists.`);return this._proxy.$registerTimelineProvider({id:i.id,label:i.label,scheme:i.scheme}),this._providers.set(i.id,i),(0,T.toDisposable)(()=>{var d;for(const g of this._itemsBySourceAndUriMap.values())(d=g.get(i.id))===null||d===void 0||d.clear();this._providers.delete(i.id),this._proxy.$unregisterTimelineProvider(i.id),i.dispose()})}}e.ExtHostTimeline=S;function E(k){return k==null?void 0:k.toString()}}),define(be[210],_e([0,1,6,15,2,5]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class _{constructor(E){this._openers=new Map,this._proxy=E.getProxy(T.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,k,i,I){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const d=I.schemes.find(g=>!_.supportedSchemes.has(g));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,i),this._proxy.$registerUriOpener(k,I.schemes,E,I.label),(0,p.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(E,k,i){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener with id: ${E}`);const d=D.URI.revive(k);return I.canOpenExternalUri(d,i)}async $openUri(E,k,i){const I=this._openers.get(E);if(!I)throw new Error(`Unknown opener id: '${E}'`);return I.openExternalUri(D.URI.revive(k.resolvedUri),{sourceUri:D.URI.revive(k.sourceUri)},i)}}e.ExtHostUriOpeners=_,_.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(be[211],_e([0,1,5,2,6,13,26]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class S{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(k,i){if(this.handles.has(_.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const I=S.HandlePool++;return this.handles.add(_.ExtensionIdentifier.toKey(k)),this.handlers.set(I,i),this._proxy.$registerUriHandler(I,k),(0,D.toDisposable)(()=>{this.handles.delete(_.ExtensionIdentifier.toKey(k)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(k,i){const I=this.handlers.get(k);if(!I)return Promise.resolve(void 0);try{I.handleUri(R.URI.revive(i))}catch(d){(0,T.onUnexpectedError)(d)}return Promise.resolve(void 0)}async createAppUri(k){return R.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=S,S.HandlePool=0});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[51],_e([0,1,3,2,146,167,73,5]),function(X,e,p,R,D,T,_,S){"use strict";var E,k,i,I,d,g,o,a,w,f,y,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class m{constructor(b,P,C,c,F,N,z){E.set(this,void 0),k.set(this,void 0),i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),g.set(this,void 0),o.set(this,""),a.set(this,void 0),w.set(this,!1),f.set(this,!1),y.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new p.Emitter),this._onDidDispose=Ue(this,l,"f").event,nt(this,E,b,"f"),nt(this,k,P,"f"),nt(this,a,C,"f"),nt(this,I,c,"f"),nt(this,d,F,"f"),nt(this,g,N,"f"),nt(this,y,h(N),"f"),nt(this,i,z,"f")}dispose(){nt(this,w,!0,"f"),Ue(this,l,"f").fire(),Ue(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(b){return nt(this,f,!0,"f"),(0,_.asWebviewUri)(b,Ue(this,I,"f").remote)}get cspSource(){return _.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Ue(this,o,"f")}set html(b){this.assertNotDisposed(),Ue(this,o,"f")!==b&&(nt(this,o,b,"f"),!Ue(this,f,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(b)&&(nt(this,f,!0,"f"),Ue(this,i,"f").report("Webview vscode-resource: uris",Ue(this,g,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,k,"f").$setHtml(Ue(this,E,"f"),b))}get options(){return this.assertNotDisposed(),Ue(this,a,"f")}set options(b){this.assertNotDisposed(),Ue(this,k,"f").$setOptions(Ue(this,E,"f"),r(Ue(this,g,"f"),Ue(this,d,"f"),b)),nt(this,a,b,"f")}async postMessage(b){if(Ue(this,w,"f"))return!1;const P=(0,T.serializeWebviewMessage)(b,{serializeBuffersForPostMessage:Ue(this,y,"f")});return Ue(this,k,"f").$postMessage(Ue(this,E,"f"),P.message,...P.buffers)}assertNotDisposed(){if(Ue(this,w,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=m,E=new WeakMap,k=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,g=new WeakMap,o=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,y=new WeakMap,l=new WeakMap;function h(v){try{const b=(0,D.normalizeVersion)((0,D.parseVersion)(v.engines.vscode));return!!b&&b.majorBase>=1&&b.minorBase>=57}catch(b){return!1}}e.shouldSerializeBuffersForPostMessage=h;class t{constructor(b,P,C,c,F){this.initData=P,this.workspace=C,this._logService=c,this._deprecationService=F,this._webviews=new Map,this._webviewProxy=b.getProxy(S.MainContext.MainThreadWebviews)}$onMessage(b,P,...C){const c=this.getWebview(b);if(c){const{message:F}=(0,T.deserializeWebviewMessage)(P,C);c._onMessageEmitter.fire(F)}}$onMissingCsp(b,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(b,P,C){const c=new m(b,this._webviewProxy,s(P),this.initData,this.workspace,C,this._deprecationService);return this._webviews.set(b,c),c._onDidDispose(()=>{this._webviews.delete(b)}),c}deleteWebview(b){this._webviews.delete(b)}getWebview(b){return this._webviews.get(b)}}e.ExtHostWebviews=t;function n(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=n;function r(v,b,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||u(v,b)}}e.serializeWebviewOptions=r;function s(v){var b;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(b=v.localResourceRoots)===null||b===void 0?void 0:b.map(P=>R.URI.from(P))}}e.reviveOptions=s;function u(v,b){return[...((b==null?void 0:b.getWorkspaceFolders())||[]).map(P=>P.uri),v.extensionLocation]}}),define(be[212],_e([0,1,20,57,6,15,24,2,10,51,68,5,7]),function(X,e,p,R,D,T,_,S,E,k,i,I,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(t,n){this.document=t,this._storagePath=n,this._backupCounter=1,this._edits=new i.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,n){await this.getEdit(t).undo(),n||this.disposeBackup()}async redo(t,n){await this.getEdit(t).redo(),n||this.disposeBackup()}disposeEdits(t){for(const n of t)this._edits.delete(n)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=m(this.document.uri)+this._backupCounter++;return(0,_.joinPath)(this._storagePath,t)}updateBackup(t){var n;(n=this._backup)===null||n===void 0||n.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const n=this._edits.get(t,0);if(!n)throw new Error("No edit found");return n}}class o{constructor(){this._documents=new Map}get(t,n){return this._documents.get(this.key(t,n))}add(t,n,r){const s=this.key(t,n.uri);if(this._documents.has(s))throw new Error(`Document already exists for viewType:${t} resource:${n.uri}`);const u=new g(n,r);return this._documents.set(s,u),u}delete(t,n){const r=this.key(t,n.uri);this._documents.delete(r)}key(t,n){return`${t}@@@${n}`}}var a;(function(h){h[h.Text=0]="Text",h[h.Custom=1]="Custom"})(a||(a={}));class w{constructor(){this._providers=new Map}addTextProvider(t,n,r){return this.add(0,t,n,r)}addCustomProvider(t,n,r){return this.add(1,t,n,r)}get(t){return this._providers.get(t)}add(t,n,r,s){if(this._providers.has(n))throw new Error(`Provider for viewType:${n} already registered`);return this._providers.set(n,{type:t,extension:r,provider:s}),new d.Disposable(()=>this._providers.delete(n))}}class f{constructor(t,n,r,s,u){this._extHostDocuments=n,this._extensionStoragePaths=r,this._extHostWebview=s,this._extHostWebviewPanels=u,this._editorProviders=new w,this._documents=new o,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,n,r,s){const u=new D.DisposableStore;return y(r)?(u.add(this._editorProviders.addTextProvider(n,t,r)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(t),n,s.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(t))):(u.add(this._editorProviders.addCustomProvider(n,t,r)),this.supportEditing(r)&&u.add(r.onDidChangeCustomDocument(v=>{const b=this.getCustomDocumentEntry(n,v.document.uri);if(l(v)){const P=b.addEdit(v);this._proxy.$onDidEdit(v.document.uri,n,P,v.label)}else this._proxy.$onContentChange(v.document.uri,n)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(t),n,s.webviewOptions||{},!!s.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(t))),d.Disposable.from(u,new d.Disposable(()=>{this._proxy.$unregisterEditorProvider(n)}))}async $createCustomDocument(t,n,r,s,u){var v;const b=this._editorProviders.get(n);if(!b)throw new Error(`No provider found for '${n}'`);if(b.type!==1)throw new Error(`Invalid provide type for '${n}'`);const P=S.URI.revive(t),C=await b.provider.openCustomDocument(P,{backupId:r,untitledDocumentData:s==null?void 0:s.buffer},u);let c;return this.supportEditing(b.provider)&&this._extensionStoragePaths&&(c=(v=this._extensionStoragePaths.workspaceValue(b.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(b.extension)),this._documents.add(n,C,c),{editable:this.supportEditing(b.provider)}}async $disposeCustomDocument(t,n){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${n}'`);const s=S.URI.revive(t),{document:u}=this.getCustomDocumentEntry(n,s);this._documents.delete(n,u),u.dispose()}async $resolveWebviewEditor(t,n,r,s,u,v){const b=this._editorProviders.get(r);if(!b)throw new Error(`No provider found for '${r}'`);const P=E.ViewColumn.to(u),C=this._extHostWebview.createNewWebview(n,s.webviewOptions,b.extension),c=this._extHostWebviewPanels.createNewWebviewPanel(n,r,s.title,P,s.panelOptions,C),F=S.URI.revive(t);switch(b.type){case 1:{const{document:N}=this.getCustomDocumentEntry(r,F);return b.provider.resolveCustomEditor(N,c,v)}case 0:{const N=this._extHostDocuments.getDocument(F);return b.provider.resolveCustomTextEditor(N,c,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,n,r){this.getCustomDocumentEntry(n,t).disposeEdits(r)}async $onMoveCustomEditor(t,n,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(!s.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const v=S.URI.revive(n),b=this._extHostDocuments.getDocument(v);await s.provider.moveCustomTextEditor(b,u,p.CancellationToken.None)}async $undo(t,n,r,s){return this.getCustomDocumentEntry(n,t).undo(r,s)}async $redo(t,n,r,s){return this.getCustomDocumentEntry(n,t).redo(r,s)}async $revert(t,n,r){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).revertCustomDocument(s.document,r),s.disposeBackup()}async $onSave(t,n,r){const s=this.getCustomDocumentEntry(n,t);await this.getCustomEditorProvider(n).saveCustomDocument(s.document,r),s.disposeBackup()}async $onSaveAs(t,n,r,s){const u=this.getCustomDocumentEntry(n,t);return this.getCustomEditorProvider(n).saveCustomDocumentAs(u.document,S.URI.revive(r),s)}async $backup(t,n,r){const s=this.getCustomDocumentEntry(n,t),v=await this.getCustomEditorProvider(n).backupCustomDocument(s.document,{destination:s.getNewBackupUri()},r);return s.updateBackup(v),v.id}getCustomDocumentEntry(t,n){const r=this._documents.get(t,S.URI.revive(n));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(t){const n=this._editorProviders.get(t),r=n==null?void 0:n.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=f;function y(h){return typeof h.resolveCustomTextEditor=="function"}function l(h){return typeof h.undo=="function"&&typeof h.redo=="function"}function m(h){const t=h.scheme===T.Schemas.file||h.scheme===T.Schemas.untitled?h.fsPath:h.toString();return(0,R.hash)(t)+""}});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[213],_e([0,1,3,6,2,37,10,51,5,7]),function(X,e,p,R,D,T,_,S,E,k){"use strict";var i,I,d,g,o,a,w,f,y,l,m,h,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class n extends R.Disposable{constructor(v,b,P,C,c,F,N){super();i.set(this,void 0),I.set(this,void 0),d.set(this,void 0),g.set(this,void 0),o.set(this,void 0),a.set(this,void 0),w.set(this,void 0),f.set(this,void 0),y.set(this,!0),l.set(this,!0),m.set(this,!1),h.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,h,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=Ue(this,t,"f").event,nt(this,i,v,"f"),nt(this,I,b,"f"),nt(this,d,P,"f"),nt(this,o,F,"f"),nt(this,f,c,"f"),nt(this,a,C,"f"),nt(this,g,N,"f")}dispose(){Ue(this,m,"f")||(nt(this,m,!0,"f"),Ue(this,h,"f").fire(),Ue(this,I,"f").$disposeWebview(Ue(this,i,"f")),Ue(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Ue(this,g,"f")}get viewType(){return this.assertNotDisposed(),Ue(this,d,"f")}get title(){return this.assertNotDisposed(),Ue(this,a,"f")}set title(v){this.assertNotDisposed(),Ue(this,a,"f")!==v&&(nt(this,a,v,"f"),Ue(this,I,"f").$setTitle(Ue(this,i,"f"),v))}get iconPath(){return this.assertNotDisposed(),Ue(this,w,"f")}set iconPath(v){this.assertNotDisposed(),Ue(this,w,"f")!==v&&(nt(this,w,v,"f"),Ue(this,I,"f").$setIconPath(Ue(this,i,"f"),D.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return Ue(this,o,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Ue(this,f,"f")=="number"&&Ue(this,f,"f")<0))return Ue(this,f,"f")}get active(){return this.assertNotDisposed(),Ue(this,l,"f")}get visible(){return this.assertNotDisposed(),Ue(this,y,"f")}_updateViewState(v){Ue(this,m,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(nt(this,l,v.active,"f"),nt(this,y,v.visible,"f"),nt(this,f,v.viewColumn,"f"),Ue(this,t,"f").fire({webviewPanel:this}))}reveal(v,b){this.assertNotDisposed(),Ue(this,I,"f").$reveal(Ue(this,i,"f"),{viewColumn:v?_.ViewColumn.from(v):void 0,preserveFocus:!!b})}assertNotDisposed(){if(Ue(this,m,"f"))throw new Error("Webview is disposed")}}i=new WeakMap,I=new WeakMap,d=new WeakMap,g=new WeakMap,o=new WeakMap,a=new WeakMap,w=new WeakMap,f=new WeakMap,y=new WeakMap,l=new WeakMap,m=new WeakMap,h=new WeakMap,t=new WeakMap;class r{constructor(v,b,P){this.webviews=b,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,T.generateUuid)()}createWebviewPanel(v,b,P,C,c={}){const F=typeof C=="object"?C.viewColumn:C,N={viewColumn:_.ViewColumn.from(F),preserveFocus:typeof C=="object"&&!!C.preserveFocus},z=(0,S.shouldSerializeBuffersForPostMessage)(v),he=r.newHandle();this._proxy.$createWebviewPanel((0,S.toExtensionData)(v),he,b,{title:P,panelOptions:s(c),webviewOptions:(0,S.serializeWebviewOptions)(v,this.workspace,c),serializeBuffersForPostMessage:z},N);const me=this.webviews.createNewWebview(he,c,v);return this.createNewWebviewPanel(he,b,P,F,c,me)}$onDidChangeWebviewPanelViewStates(v){const b=Object.keys(v);b.sort((P,C)=>{const c=v[P],F=v[C];return c.active?1:F.active?-1:+c.visible-+F.visible});for(const P of b){const C=this.getWebviewPanel(P);if(!C)continue;const c=v[P];C._updateViewState({active:c.active,visible:c.visible,viewColumn:_.ViewColumn.to(c.position)})}}async $onDidDisposeWebviewPanel(v){const b=this.getWebviewPanel(v);b==null||b.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,b,P){if(this._serializers.has(b))throw new Error(`Serializer for '${b}' already registered`);return this._serializers.set(b,{serializer:P,extension:v}),this._proxy.$registerSerializer(b,{serializeBuffersForPostMessage:(0,S.shouldSerializeBuffersForPostMessage)(v)}),new k.Disposable(()=>{this._serializers.delete(b),this._proxy.$unregisterSerializer(b)})}async $deserializeWebviewPanel(v,b,P,C){const c=this._serializers.get(b);if(!c)throw new Error(`No serializer found for '${b}'`);const{serializer:F,extension:N}=c,z=this.webviews.createNewWebview(v,P.webviewOptions,N),he=this.createNewWebviewPanel(v,b,P.title,C,P.panelOptions,z);await F.deserializeWebviewPanel(he,P.state)}createNewWebviewPanel(v,b,P,C,c,F){const N=new n(v,this._proxy,b,P,C,c,F);return this._webviewPanels.set(v,N),N}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=r;function s(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[214],_e([0,1,3,6,51,5,7]),function(X,e,p,R,D,T,_){"use strict";var S,E,k,i,I,d,g,o,a,w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class f extends R.Disposable{constructor(m,h,t,n,r,s){super();S.set(this,void 0),E.set(this,void 0),k.set(this,void 0),i.set(this,void 0),I.set(this,!1),d.set(this,void 0),g.set(this,void 0),o.set(this,void 0),a.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=Ue(this,a,"f").event,w.set(this,this._register(new p.Emitter)),this.onDidDispose=Ue(this,w,"f").event,nt(this,k,t,"f"),nt(this,g,n,"f"),nt(this,S,m,"f"),nt(this,E,h,"f"),nt(this,i,r,"f"),nt(this,d,s,"f")}dispose(){Ue(this,I,"f")||(nt(this,I,!0,"f"),Ue(this,w,"f").fire(),Ue(this,i,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Ue(this,g,"f")}set title(m){this.assertNotDisposed(),Ue(this,g,"f")!==m&&(nt(this,g,m,"f"),Ue(this,E,"f").$setWebviewViewTitle(Ue(this,S,"f"),m))}get description(){return this.assertNotDisposed(),Ue(this,o,"f")}set description(m){this.assertNotDisposed(),Ue(this,o,"f")!==m&&(nt(this,o,m,"f"),Ue(this,E,"f").$setWebviewViewDescription(Ue(this,S,"f"),m))}get visible(){return Ue(this,d,"f")}get webview(){return Ue(this,i,"f")}get viewType(){return Ue(this,k,"f")}_setVisible(m){m===Ue(this,d,"f")||Ue(this,I,"f")||(nt(this,d,m,"f"),Ue(this,a,"f").fire())}show(m){this.assertNotDisposed(),Ue(this,E,"f").$show(Ue(this,S,"f"),!!m)}assertNotDisposed(){if(Ue(this,I,"f"))throw new Error("Webview is disposed")}}S=new WeakMap,E=new WeakMap,k=new WeakMap,i=new WeakMap,I=new WeakMap,d=new WeakMap,g=new WeakMap,o=new WeakMap,a=new WeakMap,w=new WeakMap;class y{constructor(m,h){this._extHostWebview=h,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=m.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(m,h,t,n){if(this._viewProviders.has(h))throw new Error(`View provider for '${h}' already registered`);return this._viewProviders.set(h,{provider:t,extension:m}),this._proxy.$registerWebviewViewProvider((0,D.toExtensionData)(m),h,{retainContextWhenHidden:n==null?void 0:n.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new _.Disposable(()=>{this._viewProviders.delete(h),this._proxy.$unregisterWebviewViewProvider(h)})}async $resolveWebviewView(m,h,t,n,r){const s=this._viewProviders.get(h);if(!s)throw new Error(`No view provider found for '${h}'`);const{provider:u,extension:v}=s,b=this._extHostWebview.createNewWebview(m,{},v),P=new f(m,this._proxy,h,t,b,!0);this._webviewViews.set(m,P),await u.resolveWebviewView(P,{state:n},r)}async $onDidChangeWebviewViewVisibility(m,h){this.getWebviewView(m)._setVisible(h)}async $disposeWebviewView(m){const h=this.getWebviewView(m);this._webviewViews.delete(m),h.dispose(),this._extHostWebview.deleteWebview(m)}getWebviewView(m){const h=this._webviewViews.get(m);if(!h)throw new Error("No webview found");return h}}e.ExtHostWebviewViews=y}),define(be[103],_e([0,1,3,5,2,15,8,4,16]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Nn{constructor(I){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Nn.InitialState,this._proxy=I.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(d=>this.$onDidChangeWindowFocus(d))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,d){let g;if(typeof I=="string"){g=I;try{I=D.URI.parse(I)}catch(o){return Promise.reject(`Invalid uri - '${I}'`)}}return(0,_.isFalsyOrWhitespace)(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===T.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,g,d)}async asExternalUri(I,d){if((0,_.isFalsyOrWhitespace)(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(I,d);return D.URI.from(g)}};k.InitialState={focused:!0},k=ze([je(0,E.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,S.createDecorator)("IExtHostWindow")}),define(be[215],_e([0,1,17,5,28,16]),function(X,e,p,R,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let _=class extends p.AbstractLogger{constructor(E,k){super();this._proxy=E.getProxy(R.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(E){this.setLevel(E)}trace(E,...k){this.getLevel()<=p.LogLevel.Trace&&this._proxy.$log(this._logFile,p.LogLevel.Trace,Array.from(arguments))}debug(E,...k){this.getLevel()<=p.LogLevel.Debug&&this._proxy.$log(this._logFile,p.LogLevel.Debug,Array.from(arguments))}info(E,...k){this.getLevel()<=p.LogLevel.Info&&this._proxy.$log(this._logFile,p.LogLevel.Info,Array.from(arguments))}warn(E,...k){this.getLevel()<=p.LogLevel.Warning&&this._proxy.$log(this._logFile,p.LogLevel.Warning,Array.from(arguments))}error(E,...k){this.getLevel()<=p.LogLevel.Error&&this._proxy.$log(this._logFile,p.LogLevel.Error,Array.from(arguments))}critical(E,...k){this.getLevel()<=p.LogLevel.Critical&&this._proxy.$log(this._logFile,p.LogLevel.Critical,Array.from(arguments))}flush(){}};_=ze([je(0,T.IExtHostRpcService),je(1,D.IExtHostInitDataService)],_),e.ExtHostLogService=_}),define(be[216],_e([0,1,11,20,13,3,6,116,187,100,25]),function(X,e,p,R,D,T,_,S,E,k,i){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function d(s,u){try{return JSON.stringify(s,u)}catch(v){return"null"}}function g(s,u){return JSON.stringify(s,u)}function o(s){return s?(u,v)=>v&&v.$mid===1?s.transformOutgoing(v):v:null}var a;(function(s){s[s.LocalSide=0]="LocalSide",s[s.OtherSide=1]="OtherSide"})(a=e.RequestInitiator||(e.RequestInitiator={}));var w;(function(s){s[s.Responsive=0]="Responsive",s[s.Unresponsive=1]="Unresponsive"})(w=e.ResponsiveState||(e.ResponsiveState={}));const f=()=>{},y=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class m extends _.Disposable{constructor(u,v=null,b=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new T.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=v,this._uriTransformer=b,this._uriReplacer=o(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,C=k.ProxyIdentifier.count;P<C;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(D.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+m.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?(0,S.transformIncomingURIs)(u,this._uriTransformer):u}getProxy(u){const{nid:v,sid:b}=u;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,b)),this._proxies[v]}_createProxy(u,v){let b={get:(P,C)=>(typeof C=="string"&&!P[C]&&C.charCodeAt(0)===36&&(P[C]=(...c)=>this._remoteCall(u,C,c)),C===l?v:P[C])};return new Proxy(Object.create(null),b)}set(u,v){return this._locals[u.nid]=v,v}assertRegistered(u){for(let v=0,b=u.length;v<b;v++){const P=u[v];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(u){if(this._isDisposed)return;const v=u.byteLength,b=h.read(u,0),P=b.readUInt8(),C=b.readUInt32();switch(P){case 1:case 2:{let{rpcId:c,method:F,args:N}=t.deserializeRequestJSONArgs(b);this._uriTransformer&&(N=(0,S.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(v,C,c,F,N,P===2);break}case 3:case 4:{let{rpcId:c,method:F,args:N}=t.deserializeRequestMixedArgs(b);this._uriTransformer&&(N=(0,S.transformIncomingURIs)(N,this._uriTransformer)),this._receiveRequest(v,C,c,F,N,P===4);break}case 5:{this._logger&&this._logger.logIncoming(v,C,0,"ack"),this._onDidReceiveAcknowledge(C);break}case 6:{this._receiveCancel(v,C);break}case 7:{this._receiveReply(v,C,void 0);break}case 9:{let c=t.deserializeReplyOKJSON(b);this._uriTransformer&&(c=(0,S.transformIncomingURIs)(c,this._uriTransformer)),this._receiveReply(v,C,c);break}case 8:{let c=t.deserializeReplyOKVSBuffer(b);this._receiveReply(v,C,c);break}case 10:{let c=t.deserializeReplyErrError(b);this._uriTransformer&&(c=(0,S.transformIncomingURIs)(c,this._uriTransformer)),this._receiveReplyErr(v,C,c);break}case 11:{this._receiveReplyErr(v,C,void 0);break}default:console.error("received unexpected message"),console.error(u)}}_receiveRequest(u,v,b,P,C,c){this._logger&&this._logger.logIncoming(u,v,1,`receiveRequest ${(0,k.getStringIdentifierForProxy)(b)}.${P}(`,C);const F=String(v);let N,z;if(c){const me=new R.CancellationTokenSource;C.push(me.token),N=this._invokeHandler(b,P,C),z=()=>me.cancel()}else N=this._invokeHandler(b,P,C),z=f;this._cancelInvokedHandlers[F]=z;const he=t.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(he.byteLength,v,1,"ack"),this._protocol.send(he),N.then(me=>{delete this._cancelInvokedHandlers[F];const Q=t.serializeReplyOK(v,me,this._uriReplacer);this._logger&&this._logger.logOutgoing(Q.byteLength,v,1,"reply:",me),this._protocol.send(Q)},me=>{delete this._cancelInvokedHandlers[F];const Q=t.serializeReplyErr(v,me);this._logger&&this._logger.logOutgoing(Q.byteLength,v,1,"replyErr:",me),this._protocol.send(Q)})}_receiveCancel(u,v){this._logger&&this._logger.logIncoming(u,v,1,"receiveCancel");const b=String(v);this._cancelInvokedHandlers[b]&&this._cancelInvokedHandlers[b]()}_receiveReply(u,v,b){this._logger&&this._logger.logIncoming(u,v,0,"receiveReply:",b);const P=String(v);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const C=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],C.resolveOk(b)}_receiveReplyErr(u,v,b){this._logger&&this._logger.logIncoming(u,v,0,"receiveReplyErr:",b);const P=String(v);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const C=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let c;b&&(b.$isError?(c=new Error,c.name=b.name,c.message=b.message,c.stack=b.stack):c=b),C.resolveErr(c)}_invokeHandler(u,v,b){try{return Promise.resolve(this._doInvokeHandler(u,v,b))}catch(P){return Promise.reject(P)}}_doInvokeHandler(u,v,b){const P=this._locals[u];if(!P)throw new Error("Unknown actor "+(0,k.getStringIdentifierForProxy)(u));let C=P[v];if(typeof C!="function")throw new Error("Unknown method "+v+" on actor "+(0,k.getStringIdentifierForProxy)(u));return C.apply(P,b)}_remoteCall(u,v,b){if(this._isDisposed)return Promise.reject(D.canceled());let P=null;if(b.length>0&&R.CancellationToken.isCancellationToken(b[b.length-1])&&(P=b.pop()),P&&P.isCancellationRequested)return Promise.reject(D.canceled());const C=t.serializeRequestArguments(b,this._uriReplacer),c=++this._lastMessageId,F=String(c),N=new E.LazyPromise;P&&P.onCancellationRequested(()=>{const he=t.serializeCancel(c);this._logger&&this._logger.logOutgoing(he.byteLength,c,0,"cancel"),this._protocol.send(t.serializeCancel(c))}),this._pendingRPCReplies[F]=N,this._onWillSendRequest(c);const z=t.serializeRequest(c,u,v,C,!!P);return this._logger&&this._logger.logOutgoing(z.byteLength,c,0,`request: ${(0,k.getStringIdentifierForProxy)(u)}.${v}(`,b),this._protocol.send(z),N}}e.RPCProtocol=m,I=y,m.UNRESPONSIVE_TIME=3*1e3;class h{constructor(u,v){this._buff=u,this._offset=v}static alloc(u,v,b){let P=new h(i.VSBuffer.alloc(b+1+4),0);return P.writeUInt8(u),P.writeUInt32(v),P}static read(u,v){return new h(u,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const b=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,b}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,v}static sizeMixedArray(u,v){let b=0;b+=1;for(let P=0,C=u.length;P<C;P++){const c=u[P],F=v[P];switch(b+=1,F){case 1:b+=this.sizeLongString(c);break;case 2:b+=this.sizeVSBuffer(c);break;case 3:break}}return b}writeMixedArray(u,v){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let b=0,P=u.length;b<P;b++){const C=u[b];switch(v[b]){case 1:this.writeUInt8(1),this.writeLongString(C);break;case 2:this.writeUInt8(2),this.writeVSBuffer(C);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(u);for(let b=0;b<u;b++)switch(this.readUInt8()){case 1:v[b]=this.readLongString();break;case 2:v[b]=this.readVSBuffer();break;case 3:v[b]=void 0;break}return v}}class t{static _arrayContainsBufferOrUndefined(u){for(let v=0,b=u.length;v<b;v++)if(u[v]instanceof i.VSBuffer||typeof u[v]=="undefined")return!0;return!1}static serializeRequestArguments(u,v){if(this._arrayContainsBufferOrUndefined(u)){let b=[],P=[];for(let C=0,c=u.length;C<c;C++){const F=u[C];F instanceof i.VSBuffer?(b[C]=F,P[C]=2):typeof F=="undefined"?(b[C]=i.VSBuffer.alloc(0),P[C]=3):(b[C]=i.VSBuffer.fromString(g(F,v)),P[C]=1)}return{type:"mixed",args:b,argsType:P}}return{type:"simple",args:g(u,v)}}static serializeRequest(u,v,b,P,C){return P.type==="mixed"?this._requestMixedArgs(u,v,b,P.args,P.argsType,C):this._requestJSONArgs(u,v,b,P.args,C)}static _requestJSONArgs(u,v,b,P,C){const c=i.VSBuffer.fromString(b),F=i.VSBuffer.fromString(P);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(c),N+=h.sizeLongString(F);let z=h.alloc(C?2:1,u,N);return z.writeUInt8(v),z.writeShortString(c),z.writeLongString(F),z.buffer}static deserializeRequestJSONArgs(u){const v=u.readUInt8(),b=u.readShortString(),P=u.readLongString();return{rpcId:v,method:b,args:JSON.parse(P)}}static _requestMixedArgs(u,v,b,P,C,c){const F=i.VSBuffer.fromString(b);let N=0;N+=h.sizeUInt8(),N+=h.sizeShortString(F),N+=h.sizeMixedArray(P,C);let z=h.alloc(c?4:3,u,N);return z.writeUInt8(v),z.writeShortString(F),z.writeMixedArray(P,C),z.buffer}static deserializeRequestMixedArgs(u){const v=u.readUInt8(),b=u.readShortString(),P=u.readMixedArray(),C=new Array(P.length);for(let c=0,F=P.length;c<F;c++){const N=P[c];typeof N=="string"?C[c]=JSON.parse(N):C[c]=N}return{rpcId:v,method:b,args:C}}static serializeAcknowledged(u){return h.alloc(5,u,0).buffer}static serializeCancel(u){return h.alloc(6,u,0).buffer}static serializeReplyOK(u,v,b){return typeof v=="undefined"?this._serializeReplyOKEmpty(u):v instanceof i.VSBuffer?this._serializeReplyOKVSBuffer(u,v):this._serializeReplyOKJSON(u,d(v,b))}static _serializeReplyOKEmpty(u){return h.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,v){let b=0;b+=h.sizeVSBuffer(v);let P=h.alloc(8,u,b);return P.writeVSBuffer(v),P.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,v){const b=i.VSBuffer.fromString(v);let P=0;P+=h.sizeLongString(b);let C=h.alloc(9,u,P);return C.writeLongString(b),C.buffer}static deserializeReplyOKJSON(u){const v=u.readLongString();return JSON.parse(v)}static serializeReplyErr(u,v){return v?this._serializeReplyErrEror(u,v):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,v){const b=i.VSBuffer.fromString(d(D.transformErrorForSerialization(v),null));let P=0;P+=h.sizeLongString(b);let C=h.alloc(10,u,P);return C.writeLongString(b),C.buffer}static deserializeReplyErrError(u){const v=u.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(u){return h.alloc(11,u,0).buffer}}var n;(function(s){s[s.RequestJSONArgs=1]="RequestJSONArgs",s[s.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",s[s.RequestMixedArgs=3]="RequestMixedArgs",s[s.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",s[s.Acknowledged=5]="Acknowledged",s[s.Cancel=6]="Cancel",s[s.ReplyOKEmpty=7]="ReplyOKEmpty",s[s.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",s[s.ReplyOKJSON=9]="ReplyOKJSON",s[s.ReplyErrError=10]="ReplyErrError",s[s.ReplyErrEmpty=11]="ReplyErrEmpty"})(n||(n={}));var r;(function(s){s[s.String=1]="String",s[s.VSBuffer=2]="VSBuffer",s[s.Undefined=3]="Undefined"})(r||(r={}))}),define(be[217],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const p=function(T){const _=S=>{self.removeEventListener("message",_);const E=S.data;Object.defineProperties(self,{postMessage:{value(k,i){E.postMessage(k,i)}},onmessage:{get(){return E.onmessage},set(k){E.onmessage=k}}}),E.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};self.addEventListener("message",_)}.toString();class R extends EventTarget{constructor(T,_,S){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${p})('${_}'))`,k=new Blob([E],{type:"application/javascript"}),i=URL.createObjectURL(k),I=new MessageChannel,d=i,g={type:"_newWorker",id:d,port:I.port2,url:i,options:S};T(g,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const o={type:"_terminateWorker",id:d};I.port1.postMessage(o),URL.revokeObjectURL(i),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(o){I.port1.onmessage=o}},onmessageerror:{get(){return I.port1.onmessageerror},set(o){I.port1.onmessageerror=o}}}),I.port1.addEventListener("messageerror",o=>{const a=new MessageEvent("messageerror",{data:o.data});this.dispatchEvent(a)}),I.port1.addEventListener("message",o=>{const a=new MessageEvent("message",{data:o.data});this.dispatchEvent(a)}),I.port1.start()}}e.NestedWorker=R}),define(be[218],_e([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,p.createDecorator)("remoteAgentService")}),define(be[219],_e([0,1,15,12,21,2,4,218]),function(X,e,p,R,D,T,_,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,_.createDecorator)("pathService");let E=class{constructor(i,I){this.localUserHome=i,this.remoteAgentService=I,this.resolveOS=(async()=>{const d=await this.remoteAgentService.getEnvironment();return(d==null?void 0:d.os)||D.OS})(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(d==null?void 0:d.userHome)||i})()}async userHome(i){return(i==null?void 0:i.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(i=>i===1?R.win32:R.posix)}async fileURI(i){let I="";if(await this.resolveOS===1&&(i=i.replace(/\\/g,"/")),i[0]==="/"&&i[1]==="/"){const g=i.indexOf("/",2);g===-1?(I=i.substring(2),i="/"):(I=i.substring(2,g),i=i.substring(g)||"/")}return T.URI.from({scheme:p.Schemas.file,authority:I,path:i,query:"",fragment:""})}};E=ze([je(1,S.IRemoteAgentService)],E),e.AbstractPathService=E}),define(be[104],_e([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(_,S){this.line=_,this.character=S}isBefore(_){return!1}isBeforeOrEqual(_){return!1}isAfter(_){return!1}isAfterOrEqual(_){return!1}isEqual(_){return!1}compareTo(_){return 0}translate(_,S){return new p(0,0)}with(_){return new p(0,0)}}e.Position=p;class R{constructor(_,S,E,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(_,S),this.end=new p(E,k)}contains(_){return!1}isEqual(_){return!1}intersection(_){}union(_){return new R(0,0,0,0)}with(_){return new R(0,0,0,0)}}e.Range=R;var D;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(D=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[41],_e([0,1,14,27,23,36,8,4,12,13,104]),function(X,e,p,R,D,T,_,S,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return i.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",d=" characters skipped \u27EB",g=(I.length+d.length+5)*2;e.ISearchService=(0,S.createDecorator)("searchService");var o;(function(A){A[A.file=0]="file",A[A.text=1]="text"})(o=e.SearchProviderType||(e.SearchProviderType={}));var a;(function(A){A[A.File=1]="File",A[A.Text=2]="Text"})(a=e.QueryType||(e.QueryType={}));function w(A){return!!A.preview}e.resultIsMatch=w;function f(A){return!!A.resource}e.isFileMatch=f;function y(A){return!!A.message}e.isProgressMessage=y;var l;(function(A){A[A.Normal=0]="Normal",A[A.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class m{constructor(U){this.resource=U,this.results=[]}}e.FileMatch=m;class h{constructor(U,M,$){this.ranges=M;const K=Array.isArray(M)?M:[M];if($&&$.matchLines===1&&t(K)){U=(0,_.getNLines)(U,$.matchLines);let j="",ae=0,we=0;const Re=Math.floor($.charsPerLine/5),xe=[];for(const Le of K){const Ve=Math.max(Le.startColumn-Re,0),Qe=Le.startColumn+$.charsPerLine;if(Ve>we+Re+g){const Ke=I+(Ve-we)+d;j+=Ke+U.slice(Ve,Qe),ae+=Ve-(we+Ke.length)}else j+=U.slice(we,Qe);xe.push(new r(0,Le.startColumn-ae,Le.endColumn-ae)),we=Qe}this.preview={text:j,matches:Array.isArray(this.ranges)?xe:xe[0]}}else{const j=Array.isArray(M)?M[0].startLineNumber:M.startLineNumber;this.preview={text:U,matches:(0,p.mapArrayOrNot)(M,ae=>new n(ae.startLineNumber-j,ae.startColumn,ae.endLineNumber-j,ae.endColumn))}}}}e.TextSearchMatch=h;function t(A){const U=A[0].startLineNumber;for(const M of A)if(M.startLineNumber!==U||M.endLineNumber!==U)return!1;return!0}class n{constructor(U,M,$,K){this.startLineNumber=U,this.startColumn=M,this.endLineNumber=$,this.endColumn=K}}e.SearchRange=n;class r extends n{constructor(U,M,$){super(U,M,U,$)}}e.OneLineRange=r;var s;(function(A){A.Default="default",A.FileNames="fileNames",A.Type="type",A.Modified="modified",A.CountDescending="countDescending",A.CountAscending="countAscending"})(s=e.SearchSortOrder||(e.SearchSortOrder={}));function u(A,U=!0){const M=A&&A.files&&A.files.exclude,$=U&&A&&A.search&&A.search.exclude;if(!M&&!$)return;if(!M||!$)return M||$;let K=Object.create(null);return K=D.mixin(K,D.deepClone(M)),K=D.mixin(K,D.deepClone($),!0),K}e.getExcludes=u;function v(A,U){return A.excludePattern&&R.match(A.excludePattern,U)?!1:A.includePattern||A.usingSearchPaths?A.includePattern&&R.match(A.includePattern,U)?!0:A.usingSearchPaths?!!A.folderQueries&&A.folderQueries.some(M=>{const $=M.folder.fsPath;if(T.isEqualOrParent(U,$)){const K=E.relative($,U);return!M.includePattern||!!R.match(M.includePattern,K)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var b;(function(A){A[A.unknownEncoding=1]="unknownEncoding",A[A.regexParseError=2]="regexParseError",A[A.globParseError=3]="globParseError",A[A.invalidLiteral=4]="invalidLiteral",A[A.rgProcessError=5]="rgProcessError",A[A.other=6]="other",A[A.canceled=7]="canceled"})(b=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(U,M){super(U);this.code=M}}e.SearchError=P;function C(A){const U=A.message;if((0,k.isPromiseCanceledError)(A))return new P(U,b.canceled);try{const M=JSON.parse(U);return new P(M.message,M.code)}catch(M){return new P(U,b.other)}}e.deserializeSearchError=C;function c(A){const U={message:A.message,code:A.code};return new Error(JSON.stringify(U))}e.serializeSearchError=c;function F(A){return A.type==="error"?!0:A.type==="success"}e.isSerializedSearchComplete=F;function N(A){return A.type==="success"}e.isSerializedSearchSuccess=N;function z(A){return!!A.path}e.isSerializedFileMatch=z;function he(A,U){const M=A.searchPath?A.searchPath:A.relativePath;return(0,_.fuzzyContains)(M,U)}e.isFilePatternMatch=he;class me{constructor(U){this.path=U,this.results=[]}addMatch(U){this.results.push(U)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=me;function Q(A,U){const M=Object.assign(Object.assign({},A||{}),U||{});return Object.keys(M).filter($=>{const K=M[$];return typeof K=="boolean"&&K})}e.resolvePatternsForProvider=Q;class W{constructor(U,M){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},U.excludePattern||{}),M.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let $=U.includePattern;M.includePattern&&($?$=Object.assign(Object.assign({},$),M.includePattern):$=M.includePattern),$&&(this._parsedIncludeExpression=R.parse($))}includedInQuerySync(U,M,$){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(U,M,$)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(U,M,$))}includedInQuery(U,M,$){return Promise.resolve(this._parsedExcludeExpression(U,M,$)).then(j=>!!j).then(j=>j?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(U,M,$)).then(ae=>!!ae):Promise.resolve(!0)).then(j=>j)}hasSiblingExcludeClauses(){return x(this._excludeExpression)}}e.QueryGlobTester=W;function x(A){for(const U in A)if(typeof A[U]!="boolean")return!0;return!1}}),define(be[30],_e([0,1,14,11,20,3,22,15,81,24,8,9,2,139,4,17,154,48,49,28,16,7,41,5]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l,m,h,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function r(F,N,z){return new k.ExtUri(he=>b(he,z)).isEqual(F,N)}function s(F,N,z){return r(F.uri,N.uri,z)?0:(0,i.compare)(F.uri.toString(),N.uri.toString())}function u(F,N,z){return F.index!==N.index?F.index<N.index?-1:1:r(F.uri,N.uri,z)?(0,i.compare)(F.name,N.name):(0,i.compare)(F.uri.toString(),N.uri.toString())}function v(F,N,z,he){const me=F.slice(0).sort((W,x)=>z(W,x,he)),Q=N.slice(0).sort((W,x)=>z(W,x,he));return(0,p.delta)(me,Q,(W,x)=>z(W,x,he))}function b(F,N){const z=N.getCapabilities(F.scheme);return!(z&&z&1024)}class P extends f.Workspace{constructor(N,z,he,me,Q,W){super(N,he.map(x=>new f.WorkspaceFolder(x)),me,W);this._name=z,this._isUntitled=Q,this._workspaceFolders=[],this._structure=_.TernarySearchTree.forUris(W),he.forEach(x=>{this._workspaceFolders.push(x),this._structure.set(x.uri,x)})}static toExtHostWorkspace(N,z,he,me){if(!N)return{workspace:null,added:[],removed:[]};const{id:Q,name:W,folders:x,configuration:A,isUntitled:U}=N,M=[],$=z;z?x.forEach((we,Re)=>{const xe=d.URI.revive(we.uri),Le=P._findFolder(he||z,xe,me);Le?(Le.name=we.name,Le.index=we.index,M.push(Le)):M.push({uri:xe,name:we.name,index:Re})}):M.push(...x.map(({uri:we,name:Re,index:xe})=>({uri:d.URI.revive(we),name:Re,index:xe}))),M.sort((we,Re)=>we.index<Re.index?-1:1);const K=new P(Q,W,M,A?d.URI.revive(A):null,!!U,we=>b(we,me)),{added:j,removed:ae}=v($?$.workspaceFolders:[],K.workspaceFolders,s,me);return{workspace:K,added:j,removed:ae}}static _findFolder(N,z,he){for(let me=0;me<N.folders.length;me++){const Q=N.workspaceFolders[me];if(r(Q.uri,z,he))return Q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(N,z){return z&&this._structure.get(N)&&(N=(0,k.dirname)(N)),this._structure.findSubstr(N)}resolveWorkspaceFolder(N){return this._structure.get(N)}}let C=class{constructor(N,z,he,me){this._onDidChangeWorkspace=new T.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new T.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=me,this._extHostFileSystemInfo=he,this._requestIdProvider=new E.Counter,this._barrier=new R.Barrier,this._proxy=N.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=N.getProxy(n.MainContext.MainThreadMessageService);const Q=z.workspace;this._confirmedWorkspace=Q?new P(Q.id,Q.name,[],Q.configuration?d.URI.revive(Q.configuration):null,!!Q.isUntitled,W=>b(W,he)):void 0}$initializeWorkspace(N,z){this._trusted=z,this.$acceptWorkspaceData(N),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?d.URI.from({scheme:S.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(N,z,he,...me){const Q=[];if(Array.isArray(me)&&me.forEach(M=>{d.URI.isUri(M.uri)&&!Q.some($=>r($.uri,M.uri,this._extHostFileSystemInfo))&&Q.push({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri)})}),this._unconfirmedWorkspace||[z,he].some(M=>typeof M!="number"||M<0)||he===0&&Q.length===0)return!1;const W=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(z+he>W.length)return!1;const x=W.slice(0);x.splice(z,he,...Q.map(M=>({uri:M.uri,name:M.name||(0,k.basenameOrAuthority)(M.uri),index:void 0})));for(let M=0;M<x.length;M++){const $=x[M];if(x.some((K,j)=>j!==M&&r($.uri,K.uri,this._extHostFileSystemInfo)))return!1}x.forEach((M,$)=>M.index=$);const{added:A,removed:U}=v(W,x,u,this._extHostFileSystemInfo);if(A.length===0&&U.length===0)return!1;if(this._proxy){const M=N.displayName||N.name;this._proxy.$updateWorkspaceFolders(M,z,he,Q).then(void 0,$=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(w.Severity.Error,(0,g.localize)(0,null,M,$.toString()),{extension:N},[])})}return this.trySetWorkspaceFolders(x),!0}getWorkspaceFolder(N,z){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async getWorkspaceFolder2(N,z){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(N,z)}async resolveWorkspaceFolder(N){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(N)}getPath(){if(!this._actualWorkspace)return;const{folders:N}=this._actualWorkspace;if(N.length!==0)return N[0].uri.fsPath}getRelativePath(N,z){let he,me="";if(typeof N=="string"?(he=d.URI.file(N),me=N):typeof N!="undefined"&&(he=N,me=N.fsPath),!he)return me;const Q=this.getWorkspaceFolder(he,!0);if(!Q)return me;typeof z=="undefined"&&this._actualWorkspace&&(z=this._actualWorkspace.folders.length>1);let W=(0,k.relativePath)(Q.uri,he);return z&&Q.name&&(W=`${Q.name}/${W}`),W}trySetWorkspaceFolders(N){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:N,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(N){const{workspace:z,added:he,removed:me}=P.toExtHostWorkspace(N,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=z||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:he,removed:me}))}findFiles(N,z,he,me,Q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${me.value}, entryPoint: findFiles`);let W;if(z===null?W=!1:z&&(typeof z=="string"?W=z:W=z.pattern),Q&&Q.isCancellationRequested)return Promise.resolve([]);const{includePattern:x,folder:A}=c(N);return this._proxy.$startFileSearch((0,I.withUndefinedAsNull)(x),(0,I.withUndefinedAsNull)(A),(0,I.withUndefinedAsNull)(W),(0,I.withUndefinedAsNull)(he),Q).then(U=>Array.isArray(U)?U.map(M=>d.URI.revive(M)):[])}async findTextInFiles(N,z,he,me,Q=D.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${me.value}, entryPoint: findTextInFiles`);const W=this._requestIdProvider.getNext(),x=typeof z.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:z.previewOptions,{includePattern:A,folder:U}=c(z.include),M=typeof z.exclude=="string"?z.exclude:z.exclude?z.exclude.pattern:void 0,$={ignoreSymlinks:typeof z.followSymlinks=="boolean"?!z.followSymlinks:void 0,disregardIgnoreFiles:typeof z.useIgnoreFiles=="boolean"?!z.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof z.useGlobalIgnoreFiles=="boolean"?!z.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof z.useDefaultExcludes=="boolean"?!z.useDefaultExcludes:!0,fileEncoding:z.encoding,maxResults:z.maxResults,previewOptions:x,afterContext:z.afterContext,beforeContext:z.beforeContext,includePattern:A,excludePattern:M},K=!1;if(this._activeSearchCallbacks[W]=j=>{if(K)return;const ae=d.URI.revive(j.resource);j.results.forEach(we=>{(0,t.resultIsMatch)(we)?he({uri:ae,preview:{text:we.preview.text,matches:(0,p.mapArrayOrNot)(we.preview.matches,Re=>new h.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))},ranges:(0,p.mapArrayOrNot)(we.ranges,Re=>new h.Range(Re.startLineNumber,Re.startColumn,Re.endLineNumber,Re.endColumn))}):he({uri:ae,text:we.text,lineNumber:we.lineNumber})})},Q.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(N,(0,I.withUndefinedAsNull)(U),$,W,Q);return delete this._activeSearchCallbacks[W],j||{}}catch(j){throw delete this._activeSearchCallbacks[W],j}}$handleTextSearchResult(N,z){this._activeSearchCallbacks[z]&&this._activeSearchCallbacks[z](N)}saveAll(N){return this._proxy.$saveAll(N)}resolveProxy(N){return this._proxy.$resolveProxy(N)}get trusted(){return this._trusted}requestWorkspaceTrust(N){return this._proxy.$requestWorkspaceTrust(N)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=ze([je(0,m.IExtHostRpcService),je(1,l.IExtHostInitDataService),je(2,y.IExtHostFileSystemInfo),je(3,a.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,o.createDecorator)("IExtHostWorkspace");function c(F){let N,z;return F&&(typeof F=="string"?N=F:(N=F.pattern,z=F.baseFolder||d.URI.file(F.base))),{includePattern:N,folder:z}}}),define(be[33],_e([0,1,23,3,30,5,7,157,67,9,11,4,16,17,2]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function a(n,r){if(r){const s=r.split(".");let u=n;for(let v=0;u&&v<s.length;v++)u=u[s[v]];return u}}function w(n){return n instanceof o.URI}function f(n){return n&&n.uri instanceof o.URI&&n.languageId&&typeof n.languageId=="string"}function y(n){return n&&!n.uri&&n.languageId&&typeof n.languageId=="string"}function l(n){return n&&n.uri instanceof o.URI&&(!n.name||typeof n.name=="string")&&(!n.index||typeof n.index=="number")}function m(n){if(w(n))return{resource:n};if(f(n))return{resource:n.uri,overrideIdentifier:n.languageId};if(y(n))return{overrideIdentifier:n.languageId};if(l(n))return{resource:n.uri};if(n===null)return{resource:null}}let h=class{constructor(r,s,u){this._proxy=r.getProxy(T.MainContext.MainThreadConfiguration),this._extHostWorkspace=s,this._logService=u,this._barrier=new i.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new t(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,s))}};h=ze([je(0,d.IExtHostRpcService),je(1,D.IExtHostWorkspace),je(2,g.ILogService)],h),e.ExtHostConfiguration=h;class t{constructor(r,s,u,v){this._onDidChangeConfiguration=new R.Emitter,this._proxy=r,this._logService=v,this._extHostWorkspace=s,this._configuration=S.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,s){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=S.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(s,u))}getConfiguration(r,s,u){const v=m(s)||{},b=this._toReadonlyValue(r?a(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,v,u==null?void 0:u.identifier);function P(c){if(c==null)return null;if(typeof c=="boolean")return c?1:4;switch(c){case _.ConfigurationTarget.Global:return 1;case _.ConfigurationTarget.Workspace:return 4;case _.ConfigurationTarget.WorkspaceFolder:return 5}}const C={has(c){return typeof a(b,c)!="undefined"},get:(c,F)=>{this._validateConfigurationAccess(r?`${r}.${c}`:c,v,u==null?void 0:u.identifier);let N=a(b,c);if(typeof N=="undefined")N=F;else{let z;const he=(me,Q)=>{let W;const x=()=>{z=z||(0,p.deepClone)(b),W=W||a(z,Q)};return(0,k.isObject)(me)?new Proxy(me,{get:(A,U)=>{if(typeof U=="string"&&U.toLowerCase()==="tojson")return x(),()=>W;if(z)return W=W||a(z,Q),W[U];const M=A[U];return typeof U=="string"?he(M,`${Q}.${U}`):M},set:(A,U,M)=>(x(),W&&(W[U]=M),!0),deleteProperty:(A,U)=>(x(),W&&delete W[U],!0),defineProperty:(A,U,M)=>(x(),W&&Object.defineProperty(W,U,M),!0)}):me};N=he(N,c)}return N},update:(c,F,N,z)=>{c=r?`${r}.${c}`:c;const he=P(N);return F!==void 0?this._proxy.$updateConfigurationOption(he,c,F,v,z):this._proxy.$removeConfigurationOption(he,c,v,z)},inspect:c=>{var F,N,z,he,me,Q,W,x;c=r?`${r}.${c}`:c;const A=(0,p.deepClone)(this._configuration.inspect(c,v,this._extHostWorkspace.workspace));if(A)return{key:c,defaultValue:(F=A.default)===null||F===void 0?void 0:F.value,globalValue:(N=A.user)===null||N===void 0?void 0:N.value,workspaceValue:(z=A.workspace)===null||z===void 0?void 0:z.value,workspaceFolderValue:(he=A.workspaceFolder)===null||he===void 0?void 0:he.value,defaultLanguageValue:(me=A.default)===null||me===void 0?void 0:me.override,globalLanguageValue:(Q=A.user)===null||Q===void 0?void 0:Q.override,workspaceLanguageValue:(W=A.workspace)===null||W===void 0?void 0:W.override,workspaceFolderLanguageValue:(x=A.workspaceFolder)===null||x===void 0?void 0:x.override,languageIds:A.overrideIdentifiers}}};return typeof b=="object"&&(0,p.mixin)(C,b,!1),Object.freeze(C)}_toReadonlyValue(r){const s=u=>(0,k.isObject)(u)?new Proxy(u,{get:(v,b)=>s(v[b]),set:(v,b,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(b)}' of object`)},deleteProperty:(v,b)=>{throw new Error(`TypeError: Cannot delete read only property '${String(b)}' of object`)},defineProperty:(v,b)=>{throw new Error(`TypeError: Cannot define property '${String(b)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return s(r)}_validateConfigurationAccess(r,s,u){const v=E.OVERRIDE_PROPERTY_PATTERN.test(r)?4:this._configurationScopes.get(r),b=u?`[${u.value}] `:"";if(v===4){typeof(s==null?void 0:s.resource)=="undefined"&&this._logService.warn(`${b}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){(s==null?void 0:s.resource)&&this._logService.warn(`${b}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,s){const u=new S.ConfigurationChangeEvent(r,s,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,b)=>u.affectsConfiguration(v,m(b))})}_toMap(r){return r.reduce((s,u)=>(s.set(u[0],u[1]),s),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,I.createDecorator)("IExtHostConfiguration")});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[105],_e([0,1,2,11,3,5,7,30,39,33,20,40,16,28,4,15,21,17,75,173,13]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l,m){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(me){function Q(x){if(x!=null)return x}me.from=Q;function W(x){if(x!=null)return x}me.to=W})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var n;(function(me){function Q(x){if(x!=null)return x}me.from=Q;function W(x){if(x!=null)return x}me.to=W})(n=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(me){function Q(x){if(x!=null)return x}me.from=Q;function W(x){if(x!=null)return x}me.to=W})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var s;(function(me){function Q(A){if(A){const U=A;return U&&!!U.process}else return!1}me.is=Q;function W(A){if(A==null)return;const U={process:A.process,args:A.args};return A.options&&(U.options=r.from(A.options)),U}me.from=W;function x(A){if(A!=null)return new _.ProcessExecution(A.process,A.args,A.options)}me.to=x})(s=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(me){function Q(x){if(x!=null)return x}me.from=Q;function W(x){if(x!=null)return x}me.to=W})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(me){function Q(A){if(A){const U=A;return U&&(!!U.commandLine||!!U.command)}else return!1}me.is=Q;function W(A){if(A==null)return;const U={};return A.commandLine!==void 0?U.commandLine=A.commandLine:(U.command=A.command,U.args=A.args),A.options&&(U.options=u.from(A.options)),U}me.from=W;function x(A){if(!(A==null||A.command===void 0&&A.commandLine===void 0))return A.commandLine?new _.ShellExecution(A.commandLine,A.options):new _.ShellExecution(A.command,A.args?A.args:[],A.options)}me.to=x})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var b;(function(me){function Q(A){if(A){let U=A;return U&&U.customExecution==="customExecution"}else return!1}me.is=Q;function W(A){return{customExecution:"customExecution"}}me.from=W;function x(A,U){return U.get(A)}me.to=x})(b=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(me){function Q(W,x){let A;return W.scope!==void 0&&typeof W.scope!="number"?A=W.scope.uri:W.scope!==void 0&&typeof W.scope=="number"&&(W.scope===_.TaskScope.Workspace&&x&&x.workspaceFile?A=x.workspaceFile:A=l.USER_TASKS_GROUP_KEY),{id:W._id,workspaceFolder:A}}me.from=Q})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var C;(function(me){function Q(A,U){if(A==null)return[];const M=[];for(let $ of A){const K=W($,U);K&&M.push(K)}return M}me.fromMany=Q;function W(A,U){if(A==null)return;let M;A.execution instanceof _.ProcessExecution?M=s.from(A.execution):A.execution instanceof _.ShellExecution?M=v.from(A.execution):A.execution&&A.execution instanceof _.CustomExecution&&(M=b.from(A.execution));const $=t.from(A.definition);let K;if(A.scope?typeof A.scope=="number"?K=A.scope:K=A.scope.uri:K=_.TaskScope.Workspace,!$||!K)return;const j=A.group?A.group.id:void 0;return{_id:A._id,definition:$,name:A.name,source:{extensionId:U.identifier.value,label:A.source,scope:K},execution:M,isBackground:A.isBackground,group:j,presentationOptions:n.from(A.presentationOptions),problemMatchers:A.problemMatchers,hasDefinedMatchers:A.hasDefinedMatchers,runOptions:A.runOptions?A.runOptions:{reevaluateOnRerun:!0},detail:A.detail}}me.from=W;async function x(A,U,M){if(A==null)return;let $;s.is(A.execution)?$=s.to(A.execution):v.is(A.execution)?$=v.to(A.execution):b.is(A.execution)&&($=b.to(A._id,M));const K=t.to(A.definition);let j;if(A.source&&(A.source.scope!==void 0?typeof A.source.scope=="number"?j=A.source.scope:j=await U.resolveWorkspaceFolder(p.URI.revive(A.source.scope)):j=_.TaskScope.Workspace),!K||!j)return;const ae=new _.Task(K,j,A.name,A.source.label,$,A.problemMatchers);return A.isBackground!==void 0&&(ae.isBackground=A.isBackground),A.group!==void 0&&(ae.group=_.TaskGroup.from(A.group)),A.presentationOptions&&(ae.presentationOptions=n.to(A.presentationOptions)),A._id&&(ae._id=A._id),A.detail&&(ae.detail=A.detail),ae}me.to=x})(C=e.TaskDTO||(e.TaskDTO={}));var c;(function(me){function Q(x){return x}me.from=Q;function W(x){if(!!x)return Object.assign(Object.create(null),x)}me.to=W})(c=e.TaskFilterDTO||(e.TaskFilterDTO={}));class F{constructor(Q,W,x){this._id=W,this._task=x,h.set(this,void 0),nt(this,h,Q,"f")}get task(){return this._task}terminate(){Ue(this,h,"f").terminateTask(this)}fireDidStartProcess(Q){}fireDidEndProcess(Q){}}h=new WeakMap;var N;(function(me){function Q(W){return{id:W._id,task:void 0}}me.from=Q})(N=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let z=class{constructor(Q,W,x,A,U,M,$,K){this._onDidExecuteTask=new D.Emitter,this._onDidTerminateTask=new D.Emitter,this._onDidTaskProcessStarted=new D.Emitter,this._onDidTaskProcessEnded=new D.Emitter,this._proxy=Q.getProxy(T.MainContext.MainThreadTask),this._workspaceProvider=x,this._editorService=A,this._configurationService=U,this._terminalService=M,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=$,this._deprecationService=K,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(Q,W,x){if(!x)return new _.Disposable(()=>{});const A=this.nextHandle();return this._handlers.set(A,{type:W,provider:x,extension:Q}),this._proxy.$registerTaskProvider(A,W),new _.Disposable(()=>{this._handlers.delete(A),this._proxy.$unregisterTaskProvider(A)})}registerTaskSystem(Q,W){this._proxy.$registerTaskSystem(Q,W)}fetchTasks(Q){return this._proxy.$fetchTasks(c.from(Q)).then(async W=>{const x=[];for(let A of W){const U=await C.to(A,this._workspaceProvider,this._providedCustomExecutions2);U&&x.push(U)}return x})}get taskExecutions(){const Q=[];return this._taskExecutions.forEach(W=>Q.push(W)),Q}terminateTask(Q){if(!(Q instanceof F))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(Q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(Q,W,x){const A=this._providedCustomExecutions2.get(Q.id);if(A){if(this._activeCustomExecutions2.get(Q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(Q.id,A),this._terminalService.attachPtyToTerminal(W,await A.callback(x))}this._lastStartedTask=Q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(Q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(Q){const W=await this.getTaskExecution(Q);this._taskExecutionPromises.delete(Q.id),this._taskExecutions.delete(Q.id),this.customExecutionComplete(Q),this._onDidTerminateTask.fire({execution:W})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(Q){const W=await this.getTaskExecution(Q.id);this._onDidTaskProcessStarted.fire({execution:W,processId:Q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(Q){const W=await this.getTaskExecution(Q.id);this._onDidTaskProcessEnded.fire({execution:W,exitCode:Q.exitCode})}$provideTasks(Q,W){const x=this._handlers.get(Q);if(!x)return Promise.reject(new Error("no handler found"));const A=[],U=(0,R.asPromise)(()=>x.provider.provideTasks(i.CancellationToken.None)).then(M=>this.provideTasksInternal(W,A,x,M));return new Promise(M=>{U.then($=>{Promise.all(A).then(()=>{M($)})})})}async $resolveTask(Q,W){const x=this._handlers.get(Q);if(!x)return Promise.reject(new Error("no handler found"));if(W.definition.type!==x.type)throw new Error(`Unexpected: Task of type [${W.definition.type}] cannot be resolved by provider of type [${x.type}].`);const A=await C.to(W,this._workspaceProvider,this._providedCustomExecutions2);if(!A)throw new Error("Unexpected: Task cannot be resolved.");const U=await x.provider.resolveTask(A,i.CancellationToken.None);if(!U)return;this.checkDeprecation(U,x);const M=C.from(U,x.extension);if(!M)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==A.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return b.is(M.execution)&&await this.addCustomExecution(M,U,!0),await this.resolveTaskInternal(M)}nextHandle(){return this._handleCounter++}async addCustomExecution(Q,W,x){const A=await this._proxy.$createTaskId(Q);!x&&!this._providedCustomExecutions2.has(A)&&this._notProvidedCustomExecutions.add(A),this._providedCustomExecutions2.set(A,W.execution)}async getTaskExecution(Q,W){if(typeof Q=="string"){const U=this._taskExecutionPromises.get(Q);if(!U)throw new Error("Unexpected: The specified task is missing an execution");return U}let x=this._taskExecutionPromises.get(Q.id);if(x)return x;const A=new Promise(async(U,M)=>{const $=W||await C.to(Q.task,this._workspaceProvider,this._providedCustomExecutions2);$?U(new F(this,Q.id,$)):M("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(Q.id,A),A.then(U=>(this._taskExecutions.set(Q.id,U),U),U=>Promise.reject(U))}checkDeprecation(Q,W){Q._deprecated&&this._deprecationService.report("Task.constructor",W.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(Q){this._activeCustomExecutions2.get(Q.id)&&this._activeCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.has(Q.id)&&this._lastStartedTask!==Q.id&&(this._providedCustomExecutions2.delete(Q.id),this._notProvidedCustomExecutions.delete(Q.id));let x=this._notProvidedCustomExecutions.values(),A=x.next();for(;!A.done;)!this._activeCustomExecutions2.has(A.value)&&this._lastStartedTask!==A.value&&(this._providedCustomExecutions2.delete(A.value),this._notProvidedCustomExecutions.delete(A.value)),A=x.next()}};z=ze([je(0,d.IExtHostRpcService),je(1,g.IExtHostInitDataService),je(2,S.IExtHostWorkspace),je(3,E.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,I.IExtHostTerminalService),je(6,f.ILogService),je(7,y.IExtHostApiDeprecationService)],z),e.ExtHostTaskBase=z;let he=class extends z{constructor(Q,W,x,A,U,M,$,K){super(Q,W,x,A,U,M,$,K);this.registerTaskSystem(a.Schemas.vscodeRemote,{scheme:a.Schemas.vscodeRemote,authority:"",platform:w.PlatformToString(0)})}async executeTask(Q,W){if(!W.execution)throw new Error("Tasks to execute must include an execution");const x=C.from(W,Q);if(x===void 0)throw new Error("Task is not valid");if(b.is(x.execution))await this.addCustomExecution(x,W,!1);else throw new m.NotSupportedError;const A=await this.getTaskExecution(await this._proxy.$getTaskExecution(x),W);return this._proxy.$executeTask(x).catch(U=>{throw new Error(U)}),A}provideTasksInternal(Q,W,x,A){const U=[];if(A)for(let M of A){this.checkDeprecation(M,x),(!M.definition||!Q[M.definition.type])&&this._logService.warn(`The task [${M.source}, ${M.name}] uses an undefined task type. The task will be ignored in the future.`);const $=C.from(M,x.extension);$&&b.is($.execution)?(U.push($),W.push(this.addCustomExecution($,M,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:U,extension:x.extension}}async resolveTaskInternal(Q){if(b.is(Q.execution))return Q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(Q,W){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(Q,W,x){}};he=ze([je(0,d.IExtHostRpcService),je(1,g.IExtHostInitDataService),je(2,S.IExtHostWorkspace),je(3,E.IExtHostDocumentsAndEditors),je(4,k.IExtHostConfiguration),je(5,I.IExtHostTerminalService),je(6,f.ILogService),je(7,y.IExtHostApiDeprecationService)],he),e.WorkerExtHostTask=he,e.IExtHostTask=(0,o.createDecorator)("IExtHostTask")});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)},Kt=this&&this.__rest||function(X,e){var p={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(p[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var D=0,R=Object.getOwnPropertySymbols(X);D<R.length;D++)e.indexOf(R[D])<0&&Object.prototype.propertyIsEnumerable.call(X,R[D])&&(p[R[D]]=X[R[D]]);return p};define(be[220],_e([0,1,14,11,25,20,3,54,43,6,23,9,2,37,5,39,16,70,10,7,30,183,97]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l,m,h,t){"use strict";var n,r,s,u;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.createDefaultDocumentTestRoot=e.ExtHostTesting=void 0;const v=(x,A)=>`${x}:${A.toString()}`;let b=class{constructor(A,U,M){this.documents=U,this.workspace=M,this.resultsChangedEmitter=new _.Emitter,this.controllers=new Map,this.ownedTests=new h.OwnedTestCollection,this.testControllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=A.getProxy(o.MainContext.MainThreadTesting),this.runQueue=new P(this.proxy),this.workspaceObservers=new Q(this.proxy),this.textDocumentObservers=new W(this.proxy,U)}registerTestController(A,U){const M=(0,g.generateUuid)();this.controllers.set(M,{instance:U,extensionId:A}),this.proxy.$registerTestController(M);const $=[...this.testControllers.keys()];return setTimeout(()=>{var K;for(const j of $)(K=this.testControllers.get(j))===null||K===void 0||K.subscribeFn(M,U)},0),new l.Disposable(()=>{this.controllers.delete(M),this.proxy.$unregisterTestController(M)})}createTextDocumentTestObserver(A){return this.textDocumentObservers.checkout(A.uri)}createWorkspaceTestObserver(A){return this.workspaceObservers.checkout(A.uri)}async runTests(A,U=T.CancellationToken.None){const M=$=>$.map(this.getInternalTestForReference,this).filter(I.isDefined).map(K=>({src:K.src,testId:K.item.extId}));await this.proxy.$runTests({exclude:A.exclude?M(A.exclude).map($=>$.testId):void 0,tests:M(A.tests),debug:A.debug},U)}createTestRun(A,U,M,$=!0){return this.runQueue.createTestRun(A,U,M,$)}$publishTestResults(A){this.results=Object.freeze(A.map(U=>(0,i.deepFreeze)(y.TestResults.to(U))).concat(this.results).sort((U,M)=>M.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(A,U){const M=d.URI.revive(U),$=v(A,M);if(this.testControllers.has($))return;const K=new T.CancellationTokenSource;let j;if(A===1){let Le=this.documents.getDocument(M);if(!Le){const Ve=new k.DisposableStore;Le=await new Promise(Qe=>{Ve.add((0,R.disposableTimeout)(()=>Qe(void 0),5e3)),Ve.add(this.documents.onDidAddDocuments(Ke=>{const Ge=Ke.find(H=>H.document.uri.toString()===M.toString());Ge&&Qe(Ge)}))}).finally(()=>Ve.dispose())}if(Le){const Ve=await this.workspace.getWorkspaceFolder2(M,!1);j=Qe=>Qe.createDocumentTestRoot?Qe.createDocumentTestRoot(Le.document,K.token):(0,e.createDefaultDocumentTestRoot)(Qe,Le.document,Ve,K.token)}}else{const Le=await this.workspace.getWorkspaceFolder2(M,!1);Le&&(j=Ve=>Ve.createWorkspaceTestRoot(Le,K.token))}if(!j)return;const ae=async(Le,Ve)=>{try{const Qe=await j(Ve);Qe&&Re.addRoot(Qe,Le)}catch(Qe){console.error(Qe)}},we=new k.DisposableStore,Re=we.add(this.ownedTests.createForHierarchy(Le=>this.proxy.$publishDiff(A,U,Le)));we.add((0,k.toDisposable)(()=>K.dispose(!0)));const xe=[];for(const[Le,Ve]of this.controllers)xe.push(ae(Le,Ve.instance));Promise.all(xe).then(()=>Re.pushDiff([3,-1])),this.testControllers.set($,{store:we,collection:Re,subscribeFn:ae})}async $expandTest(A,U){const M=(0,p.mapFind)(this.testControllers.values(),$=>$.collection.treeId===A.src.tree?$:void 0);await(M==null?void 0:M.collection.expand(A.testId,U<0?Infinity:U)),this.flushCollectionDiffs()}$unsubscribeFromTests(A,U){var M;const $=d.URI.revive(U),K=v(A,$);(M=this.testControllers.get(K))===null||M===void 0||M.store.dispose(),this.testControllers.delete(K)}$acceptDiff(A,U,M){A===1?this.textDocumentObservers.acceptDiff(d.URI.revive(U),M):this.workspaceObservers.acceptDiff(d.URI.revive(U),M)}async $runTestsForProvider(A,U){const M=this.controllers.get(A.tests[0].src.controller);if(!M)return;const $=A.tests.map(({testId:ae,src:we})=>this.ownedTests.getTestById(ae,we==null?void 0:we.tree)).filter(I.isDefined).map(([ae,we])=>we),K=A.excludeExtIds.map(ae=>this.ownedTests.getTestById(ae)).filter(I.isDefined).filter(([ae,we])=>$.some(Re=>ae.comparePositions(Re,we)===1));if(!$.length)return;const j={tests:$.map(ae=>N.unwrap(ae.actual)),exclude:K.map(([,ae])=>N.unwrap(ae.actual)),debug:A.debug};await this.runQueue.enqueueRun({dto:C.fromInternal(A),token:U,extensionId:M.extensionId,req:j,doRun:()=>M.instance.runTests(j,U)})}$lookupTest(A){const U=this.ownedTests.getTestById(A.testId);if(!U)return Promise.resolve(void 0);const M=U[1],{actual:$,discoverCts:K,expandLevels:j}=M,ae=Kt(M,["actual","discoverCts","expandLevels"]);return Promise.resolve(ae)}flushCollectionDiffs(){for(const{collection:A}of this.testControllers.values())A.flushDiff()}getInternalTestForReference(A){var U,M;return(M=(U=this.workspaceObservers.getMirroredTestDataByReference(A))!==null&&U!==void 0?U:(0,p.mapFind)(this.testControllers.values(),$=>$.collection.getTestByReference(A)))!==null&&M!==void 0?M:this.textDocumentObservers.getMirroredTestDataByReference(A)}};b=ze([je(0,w.IExtHostRpcService),je(1,a.IExtHostDocumentsAndEditors),je(2,m.IExtHostWorkspace)],b),e.ExtHostTesting=b;class P{constructor(A){this.proxy=A,this.state=new Map}enqueueRun(A){let U=this.state.get(A.extensionId);U||(U={queue:[],current:void 0},this.state.set(A.extensionId,U));const M=new R.DeferredPromise,$=()=>{const K=[],j=new Set;U.current={publicReq:A.req,factory:ae=>{const we=new c(ae,A.dto,j,this.proxy);return K.push(we),A.token.onCancellationRequested(()=>we.end()),we}},this.invokeRunner(A.extensionId,A.dto.id,A.doRun,K).finally(()=>M.complete())};return U.queue.push($),U.queue.length===1&&$(),M.p}createTestRun(A,U,M,$){var K,j;const ae=this.state.get(A);if((ae==null?void 0:ae.current.publicReq)===U)return ae.current.factory(M);const we=C.fromPublic(U),Re=new c(M,we,new Set,this.proxy);return this.proxy.$startedExtensionTestRun({debug:U.debug,exclude:(j=(K=U.exclude)===null||K===void 0?void 0:K.map(xe=>xe.id))!==null&&j!==void 0?j:[],id:we.id,tests:U.tests.map(xe=>xe.id),persist:$}),Re.onEnd.wait().then(()=>this.proxy.$finishedExtensionTestRun(we.id)),Re}invokeRunner(A,U,M,$){try{const K=M();return(0,R.isThenable)(K)?K.then(()=>this.handleInvokeResult(A,U,$,void 0)).catch(j=>this.handleInvokeResult(A,U,$,j)):this.handleInvokeResult(A,U,$,void 0)}catch(K){return this.handleInvokeResult(A,U,$,K)}}async handleInvokeResult(A,U,M,$){const K=this.state.get(A);!K||(K.queue.shift(),K.queue.length>0?K.queue[0]():this.state.delete(A),await Promise.all(M.map(j=>j.onEnd.wait())))}}class C{constructor(A,U,M){this.id=A,this.include=U,this.exclude=M}static fromPublic(A){var U,M;return new C((0,g.generateUuid)(),new Set(A.tests.map($=>$.id)),new Set((M=(U=A.exclude)===null||U===void 0?void 0:U.map($=>$.id))!==null&&M!==void 0?M:E.Iterable.empty()))}static fromInternal(A){return new C(A.runId,new Set(A.tests.map(U=>U.testId)),new Set(A.excludeExtIds))}isIncluded(A){for(let U=A;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!0}}class c{constructor(A,U,M,$){this.name=A,n.set(this,void 0),r.set(this,void 0),s.set(this,(0,g.generateUuid)()),u.set(this,void 0),this.onEnd=new R.Barrier,nt(this,n,$,"f"),nt(this,r,U,"f"),nt(this,u,M,"f"),$.$startedTestRunTask(U.id,{id:Ue(this,s,"f"),name:A,running:!0})}setState(A,U,M){Ue(this,r,"f").isIncluded(A)&&(this.ensureTestIsKnown(A),Ue(this,n,"f").$updateTestStateInRun(Ue(this,r,"f").id,Ue(this,s,"f"),A.id,U,M))}appendMessage(A,U){Ue(this,r,"f").isIncluded(A)&&(this.ensureTestIsKnown(A),Ue(this,n,"f").$appendTestMessageInRun(Ue(this,r,"f").id,Ue(this,s,"f"),A.id,y.TestMessage.from(U)))}appendOutput(A){Ue(this,n,"f").$appendOutputToRun(Ue(this,r,"f").id,Ue(this,s,"f"),D.VSBuffer.fromString(A))}end(){Ue(this,n,"f").$finishedTestRunTask(Ue(this,r,"f").id,Ue(this,s,"f")),this.onEnd.open()}ensureTestIsKnown(A){const U=Ue(this,u,"f");if(U.has(A.id))return;const M=[];for(;M.unshift(y.TestItem.from(A)),!(U.has(A.id)||(U.add(A.id),!A.parent));)A=A.parent;Ue(this,n,"f").$addTestsToRun(Ue(this,r,"f").id,M)}}n=new WeakMap,r=new WeakMap,s=new WeakMap,u=new WeakMap;const F=async(x,A,U,M)=>{if(!U)return;const $=await x.createWorkspaceTestRoot(U,M);if(!$)return;M.onCancellationRequested(()=>{N.removeFilter(A)});const K=N.getWrapperForTestItem($,A);return K.refreshMatch(),K};e.createDefaultDocumentTestRoot=F;class N extends l.TestItemImpl{constructor(A,U,M){super(A.id,A.label,A.uri,void 0);if(this.actual=A,this.filterDocument=U,this.actualParent=M,!(A instanceof l.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${A.id} did not`);this.debuggable=A.debuggable,this.runnable=A.runnable,this.description=A.description,this.error=A.error,this.status=A.status,this.range=A.range,this.resolveHandler=A.resolveHandler;const $=(0,f.getPrivateApiFor)(this);(0,f.getPrivateApiFor)(A).bus.event(j=>{switch(j[0]){case 3:this[j[1]]=j[2];break;case 0:const ae=N.getWrapperForTestItem(j[1],this.filterDocument,this);(0,f.getPrivateApiFor)(ae).parent=A,ae.refreshMatch();break;default:$.bus.fire(j)}})}static removeFilter(A){this.wrapperMap.delete(A)}static getWrapperForTestItem(A,U,M){let $=this.wrapperMap.get(U);if($==null?void 0:$.has(A))return $.get(A);$||($=new WeakMap,this.wrapperMap.set(U,$));const K=new N(A,U,M);return $.set(A,K),K}static unwrap(A){return A instanceof N?A.actual:A}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var A,U;const M=this._cachedMatchesFilter;for(const K of this.actual.children.values()){const j=N.getWrapperForTestItem(K,this.filterDocument,this);j.hasNodeMatchingFilter?this.children.has(j.id)||this.addChild(j):j.dispose()}const $=this.children.size>0||((A=this.actual.uri)===null||A===void 0?void 0:A.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=$,$!==M&&((U=this.actualParent)===null||U===void 0||U.refreshMatch()),this._cachedMatchesFilter}dispose(){this.actualParent&&(0,f.getPrivateApiFor)(this.actualParent).children.delete(this.id),(0,f.getPrivateApiFor)(this).bus.fire([1])}}e.TestItemFilteredWrapper=N,N.wrapperMap=new WeakMap;class z extends t.IncrementalChangeCollector{constructor(A){super();this.emitter=A,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(A){this.added.add(A)}update(A){Object.assign(A.revived,y.TestItem.toPlain(A.item)),this.added.has(A)||this.updated.add(A)}remove(A){if(this.added.has(A)){this.added.delete(A);return}if(this.updated.delete(A),A.parent&&this.alreadyRemoved.has(A.parent)){this.alreadyRemoved.add(A.item.extId);return}this.removed.add(A)}getChangeEvent(){const{added:A,updated:U,removed:M}=this;return{get added(){return[...A].map($=>$.revived)},get updated(){return[...U].map($=>$.revived)},get removed(){return[...M].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class he extends t.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new _.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(A){let U=[];for(const M of A){const $=this.items.get(M);$&&U.push($.revived)}return U}getMirroredTestDataById(A){return this.items.get(A)}getMirroredTestDataByReference(A){return this.items.get(A.id)}createItem(A,U){return Object.assign(Object.assign({},A),{revived:y.TestItem.toPlain(A.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new z(this.changeEmitter)}}e.MirroredTestCollection=he;class me{constructor(){this.resources=new Map}checkout(A){var U,M;const $=A.toString(),K=(U=this.resources.get($))!==null&&U!==void 0?U:this.createObserverData(A);return(M=K.pendingDeletion)===null||M===void 0||M.dispose(),K.observers++,{onDidChangeTest:K.tests.onDidChangeTests,onDidDiscoverInitialTests:new _.Emitter().event,get tests(){return K.tests.rootTestItems},dispose:(0,S.once)(()=>{--K.observers||(K.pendingDeletion=this.eventuallyDispose(A))})}}getMirroredTestDataByReference(A){for(const{tests:U}of this.resources.values()){const M=U.getMirroredTestDataByReference(A);if(M)return M}}eventuallyDispose(A){return(0,R.disposableTimeout)(()=>this.unlisten(A),10*1e3)}createObserverData(A){const U=new he,M=this.listen(A,K=>U.apply(K)),$={observers:0,tests:U,listener:M};return this.resources.set(A.toString(),$),$}unlisten(A){var U;const M=A.toString(),$=this.resources.get(M);$&&($.observers=-1,(U=$.pendingDeletion)===null||U===void 0||U.dispose(),$.listener.dispose(),this.resources.delete(M))}}class Q extends me{constructor(A){super();this.proxy=A,this.diffListeners=new Map}acceptDiff(A,U){var M;(M=this.diffListeners.get(A.toString()))===null||M===void 0||M(U)}listen(A,U){this.proxy.$subscribeToDiffs(0,A);const M=A.toString();return this.diffListeners.set(M,U),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(0,A),this.diffListeners.delete(M)})}}class W extends me{constructor(A,U){super();this.proxy=A,this.documents=U,this.diffListeners=new Map}acceptDiff(A,U){var M;(M=this.diffListeners.get(A.toString()))===null||M===void 0||M(U)}listen(A,U){if(!this.documents.getDocument(A))return new l.Disposable(()=>{});const $=A.toString();return this.diffListeners.set($,U),this.proxy.$subscribeToDiffs(1,A),new l.Disposable(()=>{this.proxy.$unsubscribeFromDiffs(1,A),this.diffListeners.delete($)})}}}),define(be[221],_e([0,1,14,52,27,59,22,15,12,24,8,9,2,119,142,92,48,176,219,41]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let m=class{constructor(P,C,c,F){this.configurationService=P,this.workspaceContextService=C,this.editorGroupsService=c,this.pathService=F}text(P,C,c={}){P=this.getContentPattern(P,c);const F=this.configurationService.getValue(),N=C&&C.some(he=>!this.configurationService.getValue({resource:he}).search.useRipgrep),z=this.commonQuery(C==null?void 0:C.map(w.toWorkspaceFolder),c);return Object.assign(Object.assign({},z),{type:2,contentPattern:P,previewOptions:c.previewOptions,maxFileSize:c.maxFileSize,usePCRE2:F.search.usePCRE2||N||!1,beforeContext:c.beforeContext,afterContext:c.afterContext,userDisabledExcludesAndIgnoreFiles:c.disregardExcludeSettings&&c.disregardIgnoreFiles})}getContentPattern(P,C){const c=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const F=Object.assign(Object.assign({},P),{wordSeparators:c.editor.wordSeparators});return this.isCaseSensitive(P,C)&&(F.isCaseSensitive=!0),this.isMultiline(P)&&(F.isMultiline=!0),F}file(P,C={}){const c=this.commonQuery(P,C);return Object.assign(Object.assign({},c),{type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey})}handleIncludeExclude(P,C){return P?(P=Array.isArray(P)?P.map(s):s(P),C?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],C={}){const c=this.handleIncludeExclude(C.includePattern,C.expandPatterns),F=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),N=P.length>1,z=(c.searchPaths&&c.searchPaths.length?c.searchPaths.map(Q=>this.getFolderQueryForSearchPath(Q,C,F)):P.map(Q=>this.getFolderQueryForRoot(Q,C,F,N))).filter(Q=>!!Q),he={_reason:C._reason,folderQueries:z,usingSearchPaths:!!(c.searchPaths&&c.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:F.pattern,includePattern:c.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const W=p.coalesce(p.flatten(this.editorGroupsService.groups.map(A=>A.editors.map(U=>U.resource)))).filter(A=>(0,l.pathIncludedInQuery)(he,A.fsPath)),x=this.commonQueryFromFileList(W);return Object.assign(Object.assign({},he),x)}const me=C.extraFileResources&&C.extraFileResources.filter(Q=>(0,l.pathIncludedInQuery)(he,Q.fsPath));return he.extraFileResources=me&&me.length?me:void 0,he}commonQueryFromFileList(P){const C=[],c=new _.ResourceMap,F={};let N=!1;return P.forEach(z=>{var he,me;if(z.scheme===S.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(z)){const W=(me=(he=this.workspaceContextService.getWorkspaceFolder(z))===null||he===void 0?void 0:he.uri)!==null&&me!==void 0?me:z.with({path:E.dirname(z.fsPath)});let x=c.get(W);x||(N=!0,x={folder:W,includePattern:{}},C.push(x),c.set(W,x));const A=E.relative(W.fsPath,z.fsPath);(0,I.assertIsDefined)(x.includePattern)[A.replace(/\\/g,"/")]=!0}else z.fsPath&&(N=!0,F[z.fsPath]=!0)}),{folderQueries:C,includePattern:F,usingSearchPaths:!0,excludePattern:N?void 0:{"**/*":!0}}}isCaseSensitive(P,C){if(C.isSmartCase){if(P.isRegExp){if(i.containsUppercaseCharacter(P.pattern,!0))return!0}else if(i.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&(0,g.isMultilineRegexSource)(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const C=x=>E.isAbsolute(x)||/^\.\.?([\/\\]|$)/.test(x),F=(Array.isArray(P)?P:n(P)).map(x=>{const A=this.pathService.resolvedUserHome;return A?(0,T.untildify)(x,A.scheme===S.Schemas.file?A.fsPath:A.path):x}),N=R.groupBy(F,x=>C(x)?"searchPaths":"exprSegments"),z=(N.exprSegments||[]).map(x=>i.rtrim(x,"/")).map(x=>i.rtrim(x,"\\")).map(x=>(x[0]==="."&&(x="*"+x),r(x))),he={},me=this.expandSearchPathPatterns(N.searchPaths||[]);me&&me.length&&(he.searchPaths=me);const Q=p.flatten(z),W=t(...Q);return W&&(he.pattern=W),he}getExcludesForFolder(P,C){return C.disregardExcludeSettings?void 0:(0,l.getExcludes)(P,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const C=p.flatten(P.map(F=>{let{pathPortion:N,globPortion:z}=h(F);z&&(z=u(z));const he=this.expandOneSearchPath(N);return p.flatten(he.map(me=>this.resolveOneSearchPathPattern(me,z)))})),c=new Map;return C.forEach(F=>{const N=F.searchPath.toString(),z=c.get(N);z?F.pattern&&(z.pattern=z.pattern||{},z.pattern[F.pattern]=!0):c.set(N,{searchPath:F.searchPath,pattern:F.pattern?t(F.pattern):void 0})}),Array.from(c.values())}expandOneSearchPath(P){if(E.isAbsolute(P)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==S.Schemas.file?[{searchPath:C[0].uri.with({path:P})}]:[{searchPath:d.URI.file(E.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=s(P),P.startsWith("../")||P===".."){const F=E.posix.resolve(C.path,P);return[{searchPath:C.with({path:F})}]}const c=u(P);return[{searchPath:C,pattern:c}]}else{if(P==="./"||P===".\\")return[];{const C=P.replace(/^\.[\/\\]/,""),F=this.workspaceContextService.getWorkspace().folders.map(N=>{const z=C.match(new RegExp(`^${N.name}(?:/(.*))?`));return z?{match:z,folder:N}:null}).filter(I.isDefined);if(F.length)return F.map(N=>{const z=N.match[1];return{searchPath:N.folder.uri,pattern:z&&u(z)}});{const N=P.match(/\.[\/\\](.+)[\/\\]?/),z=N?N[1]:P,he=o.localize(0,null,z);throw new Error(he)}}}}resolveOneSearchPathPattern(P,C){const c=P.pattern&&C?`${P.pattern}/${C}`:P.pattern||C,F=[{searchPath:P.searchPath,pattern:c}];return c&&!c.endsWith("**")&&F.push({searchPath:P.searchPath,pattern:c+"/**"}),F}getFolderQueryForSearchPath(P,C,c){const F=this.getFolderQueryForRoot((0,w.toWorkspaceFolder)(P.searchPath),C,c,!1);return F?Object.assign(Object.assign({},F),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,C,c,F){let N;const z=d.URI.isUri(P)?P:P.uri;if(c.searchPaths){const x=c.searchPaths.filter(A=>(0,k.isEqual)(A.searchPath,z))[0];if(x&&!x.pattern)return null;x&&(N=x.pattern)}const he=this.configurationService.getValue({resource:z}),me=this.getExcludesForFolder(he,C),Q=Object.assign(Object.assign({},me||{}),N||{}),W=d.URI.isUri(P)?(0,k.basename)(P):P.name;return{folder:z,folderName:F?W:void 0,excludePattern:Object.keys(Q).length>0?Q:void 0,fileEncoding:he.files&&he.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!he.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!he.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!he.search.followSymlinks}}};m=ze([je(0,a.IConfigurationService),je(1,w.IWorkspaceContextService),je(2,f.IEditorGroupsService),je(3,y.IPathService)],m),e.QueryBuilder=m;function h(b){const P=b.match(/[\*\{\}\(\)\[\]\?]/);if(P){const C=P.index,c=b.substr(0,C).match(/[/|\\][^/\\]*$/);if(c){let F=b.substr(0,c.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((c.index||0)+1)}}}return{pathPortion:b}}function t(...b){return b.length?b.reduce((P,C)=>(P[C]=!0,P),Object.create(null)):void 0}function n(b){return D.splitGlobAware(b,",").map(P=>P.trim()).filter(P=>!!P.length)}function r(b){return[`**/${b}/**`,`**/${b}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function s(b){return b.replace(/\\/g,"/")}function u(b){return s(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(b,P){b=p.distinct(b,F=>F.toString());const C=[],c=P.getWorkspace();return b&&b.forEach(F=>{let N;if(P.getWorkbenchState()===2)N=(0,k.relativePath)(c.folders[0].uri,F),N&&N!=="."&&(N="./"+N);else{const z=P.getWorkspaceFolder(F);if(z){const he=z.name;if(c.folders.filter(Q=>Q.name===he).length===1){const Q=(0,k.relativePath)(z.uri,F);Q===""?N=`./${z.name}`:N=`./${z.name}/${Q}`}else N=F.fsPath}}N&&C.push(N)}),C}e.resolveResourcesForSearchIncludes=v}),define(be[222],_e([0,1,24,2,20,13,4,221,41,48]),function(X,e,p,R,D,T,_,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const i=7e3;function I(a,w){const f=w.activationEvents;if(!f)return Promise.resolve(void 0);const y=[],l=[];for(const s of f)if(/^workspaceContains:/.test(s)){const u=s.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||a.forceUsingSearch?l.push(u):y.push(u)}if(y.length===0&&l.length===0)return Promise.resolve(void 0);let m;const h=new Promise((s,u)=>{m=s}),t=s=>m({activationEvent:s}),n=Promise.all(y.map(s=>d(a,s,t))).then(()=>{}),r=g(a,w.identifier,l,t);return Promise.all([n,r]).then(()=>{m(void 0)}),h}e.checkActivateWorkspaceContainsExtension=I;async function d(a,w,f){for(const y of a.folders)if(await a.exists(p.joinPath(R.URI.revive(y),w))){f(`workspaceContains:${w}`);return}}async function g(a,w,f,y){if(f.length===0)return Promise.resolve(void 0);const l=new D.CancellationTokenSource,m=a.checkExists(a.folders,f,l.token),h=setTimeout(async()=>{l.cancel(),y(`workspaceContainsTimeout:${f.join(",")}`)},i);let t=!1;try{t=await m}catch(n){T.isPromiseCanceledError(n)||T.onUnexpectedError(n)}l.dispose(),clearTimeout(h),t&&y(`workspaceContains:${f.join(",")}`)}function o(a,w,f,y){const l=a.get(_.IInstantiationService),m=a.get(E.ISearchService),t=l.createInstance(S.QueryBuilder).file(w.map(n=>(0,k.toWorkspaceFolder)(R.URI.revive(n))),{_reason:"checkExists",includePattern:f,exists:!0});return m.fileSearch(t,y).then(n=>!!n.limitHit,n=>T.isPromiseCanceledError(n)?!1:Promise.reject(n))}e.checkGlobFileExists=o});var nt=this&&this.__classPrivateFieldSet||function(X,e,p,R,D){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!D:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?D.call(X,p):D?D.value=p:e.set(X,p),p},Ue=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(be[34],_e([0,1,134,12,80,24,11,6,22,2,17,5,33,186,78,30,32,184,13,26,25,163,7,93,4,28,79,16,66,71,40,3,222,74,164]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l,m,h,t,n,r,s,u,v,b,P,C,c,F,N,z){"use strict";var he,me,Q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let W=class On extends S.Disposable{constructor(M,$,K,j,ae,we,Re,xe,Le,Ve){super();this._onDidChangeRemoteConnectionData=this._register(new c.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=$,this._extHostContext=K,this._initData=Re,this._extHostWorkspace=j,this._extHostConfiguration=ae,this._logService=we,this._extHostTunnelService=Le,this._extHostTerminalService=Ve,this._disposables=new S.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new _.Barrier,this._readyToStartExtensionHost=new _.Barrier,this._readyToRunExtensions=new _.Barrier,this._eagerExtensionsActivated=new _.Barrier,this._registry=new f.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new o.ExtHostStorage(this._extHostContext),this._secretState=new N.ExtHostSecretState(this._extHostContext),this._storagePath=xe,this._instaService=M.createChild(new b.ServiceCollection([o.IExtHostStorage,this._storage],[N.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(Ke=>Qe.add(l.ExtensionIdentifier.toKey(Ke))),this._activator=new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(Ke,Ge,H)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(Ke,y.transformErrorForSerialization(Ge),H)},actualActivateExtension:async(Ke,Ge)=>{if(Qe.has(l.ExtensionIdentifier.toKey(Ke)))return await this._mainThreadExtensionsProxy.$activateExtension(Ke,Ge),new g.HostExtension;const H=this._registry.getExtensionDescription(Ke);return this._activateExtension(H,Ge)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),D.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(M){y.onUnexpectedError(M)}}async deactivateAll(){let M=[];try{M=this._registry.getAllExtensionDescriptions().map(ae=>ae.identifier).filter(ae=>this.isActivated(ae)).map(ae=>this._deactivate(ae))}catch($){}await Promise.all(M)}isActivated(M){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(M):!1}_activateByEvent(M,$){return this._activator.activateByEvent(M,$)}_activateById(M,$){return this._activator.activateById(M,$)}activateByIdWithErrors(M,$){return this._activateById(M,$).then(()=>{const K=this._activator.getActivatedExtension(M);if(K.activationFailed)return Promise.reject(K.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(M=>this._registry)}getExtensionExports(M){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(M).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const M=E.TernarySearchTree.forPaths(),$=this._registry.getAllExtensionDescriptions().map(K=>{if(!!this._getEntryPoint(K))return this._hostUtils.realpath(K.extensionLocation.fsPath).then(j=>M.set(k.URI.file(j).fsPath,K))});this._extensionPathIndex=Promise.all($).then(()=>M)}return this._extensionPathIndex}_deactivate(M){let $=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(M))return $;const K=this._activator.getActivatedExtension(M);if(!K)return $;try{typeof K.module.deactivate=="function"&&($=Promise.resolve(K.module.deactivate()).then(void 0,j=>(this._logService.error(j),Promise.resolve(void 0))))}catch(j){this._logService.error(j)}try{(0,S.dispose)(K.subscriptions)}catch(j){this._logService.error(j)}return $}async _activateExtension(M,$){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(M.identifier),this._doActivateExtension(M,$).then(K=>{const j=K.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(M.identifier,j.codeLoadingTime,j.activateCallTime,j.activateResolvedTime,$),this._logExtensionActivationTimes(M,$,"success",j),K},K=>{throw this._logExtensionActivationTimes(M,$,"failure"),K})}_logExtensionActivationTimes(M,$,K,j){const ae=x(M,$);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},ae),j||{}),{outcome:K}))}_doActivateExtension(M,$){const K=x(M,$);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",K);const j=this._getEntryPoint(M);if(!j)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${M.identifier.value} ${JSON.stringify($)}`),this._logService.flush();const ae=new g.ExtensionActivationTimesBuilder($.startup);return Promise.all([this._loadCommonJSModule(M.identifier,(0,T.joinPath)(M.extensionLocation,j),ae),this._loadExtensionContext(M)]).then(we=>(D.mark(`code/extHost/willActivateExtension/${M.identifier.value}`),On._callActivate(this._logService,M.identifier,we[0],we[1],ae))).then(we=>(D.mark(`code/extHost/didActivateExtension/${M.identifier.value}`),we))}_loadExtensionContext(M){const $=new h.ExtensionGlobalMemento(M,this._storage),K=new h.ExtensionMemento(M.identifier.value,!1,this._storage),j=new z.ExtensionSecrets(M,this._secretState),ae=M.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,we=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${M.identifier.value}`),Promise.all([$.whenReady,K.whenReady,this._storagePath.whenReady]).then(()=>{const Re=this;let xe;return Object.freeze({globalState:$,workspaceState:K,secrets:j,subscriptions:[],get extensionUri(){return M.extensionLocation},get extensionPath(){return M.extensionLocation.fsPath},asAbsolutePath(Le){return R.join(M.extensionLocation.fsPath,Le)},get storagePath(){var Le;return(Le=Re._storagePath.workspaceValue(M))===null||Le===void 0?void 0:Le.fsPath},get globalStoragePath(){return Re._storagePath.globalValue(M).fsPath},get logPath(){return R.join(Re._initData.logsLocation.fsPath,M.identifier.value)},get logUri(){return k.URI.joinPath(Re._initData.logsLocation,M.identifier.value)},get storageUri(){return Re._storagePath.workspaceValue(M)},get globalStorageUri(){return Re._storagePath.globalValue(M)},get extensionMode(){return ae},get extension(){return xe===void 0&&(xe=new A(Re,M.identifier,M,we)),xe},get extensionRuntime(){return(0,w.checkProposedApiEnabled)(M),Re.extensionRuntime},get environmentVariableCollection(){return Re._extHostTerminalService.getEnvironmentVariableCollection(M)}})})}static _callActivate(M,$,K,j,ae){return K=K||{activate:void 0,deactivate:void 0},this._callActivateOptional(M,$,K,j,ae).then(we=>new g.ActivatedExtension(!1,null,ae.build(),K,we,j.subscriptions))}static _callActivateOptional(M,$,K,j,ae){if(typeof K.activate=="function")try{ae.activateCallStart(),M.trace(`ExtensionService#_callActivateOptional ${$.value}`);const we=typeof global=="object"?global:self,Re=K.activate.apply(we,[j]);return ae.activateCallStop(),ae.activateResolveStart(),Promise.resolve(Re).then(xe=>(ae.activateResolveStop(),xe))}catch(we){return Promise.reject(we)}else return Promise.resolve(K)}_activateOneStartupFinished(M,$){this._activateById(M.identifier,{startup:!1,extensionId:M.identifier,activationEvent:$}).then(void 0,K=>{this._logService.error(K)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(D.getMarks());for(const M of this._registry.getAllExtensionDescriptions())if(M.activationEvents)for(const $ of M.activationEvents)$==="onStartupFinished"&&this._activateOneStartupFinished(M,$)}_handleEagerExtensions(){const M=this._activateByEvent("*",!0).then(void 0,ae=>{this._logService.error(ae)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(ae=>this._handleWorkspaceContainsEagerExtensions(ae.added)));const $=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],K=this._handleWorkspaceContainsEagerExtensions($),j=Promise.all([M,K]).then(()=>{});return Promise.race([j,(0,_.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),j}_handleWorkspaceContainsEagerExtensions(M){return M.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map($=>this._handleWorkspaceContainsEagerExtension(M,$))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(M,$){if(this.isActivated($.identifier))return;const K=!this._initData.remote.isRemote&&!!this._initData.remote.authority,j={folders:M.map(we=>we.uri),forceUsingSearch:K,exists:we=>this._hostUtils.exists(we.fsPath),checkExists:(we,Re,xe)=>this._mainThreadWorkspaceProxy.$checkExists(we,Re,xe)},ae=await(0,F.checkActivateWorkspaceContainsExtension)(j,$);if(!!ae)return this._activateById($.identifier,{startup:!0,extensionId:$.identifier,activationEvent:ae.activationEvent}).then(void 0,we=>this._logService.error(we))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return this._doHandleExtensionTests()}catch(M){throw console.error(M),M}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:M,extensionTestsLocationURI:$}=this._initData.environment;if(!M||!$)throw new Error(p.localize(0,null));const K=await this._loadCommonJSModule(null,$,new g.ExtensionActivationTimesBuilder(!1));if(!K||typeof K.run!="function")throw new Error(p.localize(1,null,$.toString()));return new Promise((j,ae)=>{const we=(Le,Ve)=>{Le?ae(Le):j(typeof Ve=="number"&&Ve>0?1:0)},Re=(0,T.originalFSPath)($),xe=K.run(Re,we);xe&&xe.then&&xe.then(()=>{j(0)}).catch(Le=>{ae(Le.toString())})})}async $extensionTestsExit(M){this._logService.info(`extension host terminating: test runner requested exit with code ${M}`),this._logService.info(`exiting with code ${M}`),this._logService.flush(),this._hostUtils.exit(M)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(M,$){return this._resolvers[M]=$,(0,S.toDisposable)(()=>{delete this._resolvers[M]})}async _activateAndGetResolver(M){const $=M.indexOf("+");if($===-1)throw new Error("Not an authority that can be resolved!");const K=M.substr(0,$);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${K}`,!1),{authorityPrefix:K,resolver:this._resolvers[K]}}async $resolveAuthority(M,$){const{authorityPrefix:K,resolver:j}=await this._activateAndGetResolver(M);if(!j)return{type:"error",error:{code:n.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${K}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(j)),D.mark(`code/extHost/willResolveAuthority/${K}`);const ae=await j.resolve(M,{resolveAttempt:$});D.mark(`code/extHost/didResolveAuthorityOK/${K}`);const we={authority:M,host:ae.host,port:ae.port,connectionToken:ae.connectionToken},Re={extensionHostEnv:ae.extensionHostEnv,isTrusted:ae.isTrusted};return{type:"ok",value:{authority:we,options:Re,tunnelInformation:{environmentTunnels:ae.environmentTunnels}}}}catch(ae){if(D.mark(`code/extHost/didResolveAuthorityError/${K}`),ae instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ae._code,message:ae._message,detail:ae._detail}};throw ae}}async $getCanonicalURI(M,$){const{authorityPrefix:K,resolver:j}=await this._activateAndGetResolver(M);if(!j)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${K}`);const ae=k.URI.revive($);if(typeof j.getCanonicalURI=="undefined")return ae;const we=await(0,_.asPromise)(()=>j.getCanonicalURI(ae));return we||ae}$startExtensionHost(M){return this._registry.keepOnly(M),this._startExtensionHost()}$activateByEvent(M,$){return $===1?this._activateByEvent(M,!1):this._readyToRunExtensions.wait().then(K=>this._activateByEvent(M,!1))}async $activate(M,$){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(M)?(await this._activateById(M,$),!0):!1}async $deltaExtensions(M,$){M.forEach(j=>j.extensionLocation=k.URI.revive(j.extensionLocation));const K=await this.getExtensionPathIndex();return await Promise.all($.map(async j=>{const ae=this._registry.getExtensionDescription(j);if(!ae)return;const we=await this._hostUtils.realpath(ae.extensionLocation.fsPath);K.delete(k.URI.file(we).fsPath)})),await Promise.all(M.map(async j=>{const ae=await this._hostUtils.realpath(j.extensionLocation.fsPath);K.set(k.URI.file(ae).fsPath,j)})),this._registry.deltaExtensions(M,$),Promise.resolve(void 0)}async $test_latency(M){return M}async $test_up(M){return M.byteLength}async $test_down(M){let $=m.VSBuffer.alloc(M),K=Math.random()%256;for(let j=0;j<M;j++)$.writeUInt8(K,j);return $}async $updateRemoteConnectionData(M){this._remoteConnectionData=M,this._onDidChangeRemoteConnectionData.fire()}};W=ze([je(0,r.IInstantiationService),je(1,e.IHostUtils),je(2,v.IExtHostRpcService),je(3,a.IExtHostWorkspace),je(4,d.IExtHostConfiguration),je(5,i.ILogService),je(6,s.IExtHostInitDataService),je(7,u.IExtensionStoragePaths),je(8,P.IExtHostTunnelService),je(9,C.IExtHostTerminalService)],W),e.AbstractExtHostExtensionService=W;function x(U,M){return{id:U.identifier.value,name:U.name,extensionVersion:U.version,publisherDisplayName:U.publisher,activationEvents:U.activationEvents?U.activationEvents.join(","):null,isBuiltin:U.isBuiltin,reason:M.activationEvent,reasonId:M.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class A{constructor(M,$,K,j){he.set(this,void 0),me.set(this,void 0),Q.set(this,void 0),nt(this,he,M,"f"),nt(this,me,$,"f"),nt(this,Q,K.identifier,"f"),this.id=K.identifier.value,this.extensionUri=K.extensionLocation,this.extensionPath=R.normalize((0,T.originalFSPath)(K.extensionLocation)),this.packageJSON=K,this.extensionKind=j}get isActive(){return Ue(this,he,"f").isActivated(Ue(this,Q,"f"))}get exports(){if(this.packageJSON.api!=="none")return Ue(this,he,"f").getExtensionExports(Ue(this,Q,"f"))}activate(){return Ue(this,he,"f").activateByIdWithErrors(Ue(this,Q,"f"),{startup:!1,extensionId:Ue(this,me,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=A,he=new WeakMap,me=new WeakMap,Q=new WeakMap}),define(be[106],_e([0,1,12,2,3,11,5,7,171,30,34,39,175,33,172,16,4,9,46,69]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,w.createDecorator)("IExtHostDebugService");let m=class{constructor(b,P,C,c,F,N){this._workspaceService=P,this._extensionService=C,this._editorsService=c,this._configurationService=F,this._editorTabs=N,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new D.Emitter,this._onDidTerminateDebugSession=new D.Emitter,this._onDidChangeActiveDebugSession=new D.Emitter,this._onDidReceiveDebugSessionCustomEvent=new D.Emitter,this._debugServiceProxy=b.getProxy(_.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new D.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(z=>{z.onDidChange(he=>{this.registerAllDebugTypes(z)}),this.registerAllDebugTypes(z)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(b,P){const C=b;if(typeof C.sourceReference=="number"&&C.sourceReference>0){let c=`debug:${encodeURIComponent(C.path||"")}`,F="?";return P&&(c+=`${F}session=${encodeURIComponent(P.id)}`,F="&"),c+=`${F}ref=${C.sourceReference}`,R.URI.parse(c)}else{if(C.path)return R.URI.file(C.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(b){const P=[];for(const C of b.getAllExtensionDescriptions())if(C.contributes){const c=C.contributes.debuggers;if(c&&c.length>0)for(const F of c)(0,o.isDebuggerMainContribution)(F)&&P.push(F.type)}this._debugServiceProxy.$registerDebugTypes(P)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const b=[];return this._breakpoints.forEach(P=>b.push(P)),b}addBreakpoints(b){this.startBreakpoints();const P=b.filter(F=>{const N=F.id;return this._breakpoints.has(N)?!1:(this._breakpoints.set(N,F),!0)});this.fireBreakpointChanges(P,[],[]);const C=[],c=new Map;for(const F of P)if(F instanceof S.SourceBreakpoint){let N=c.get(F.location.uri.toString());N||(N={type:"sourceMulti",uri:F.location.uri,lines:[]},c.set(F.location.uri.toString(),N),C.push(N)),N.lines.push({id:F.id,enabled:F.enabled,condition:F.condition,hitCondition:F.hitCondition,logMessage:F.logMessage,line:F.location.range.start.line,character:F.location.range.start.character})}else F instanceof S.FunctionBreakpoint&&C.push({type:"function",id:F.id,enabled:F.enabled,hitCondition:F.hitCondition,logMessage:F.logMessage,condition:F.condition,functionName:F.functionName});return this._debugServiceProxy.$registerBreakpoints(C)}removeBreakpoints(b){this.startBreakpoints();const P=b.filter(N=>this._breakpoints.delete(N.id));this.fireBreakpointChanges([],P,[]);const C=P.filter(N=>N instanceof S.SourceBreakpoint).map(N=>N.id),c=P.filter(N=>N instanceof S.FunctionBreakpoint).map(N=>N.id),F=P.filter(N=>N instanceof S.DataBreakpoint).map(N=>N.id);return this._debugServiceProxy.$unregisterBreakpoints(C,c,F)}startDebugging(b,P,C){return this._debugServiceProxy.$startDebugging(b?b.uri:void 0,P,{parentSessionID:C.parentSession?C.parentSession.id:void 0,repl:C.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:C.noDebug,compact:C.compact})}stopDebugging(b){return this._debugServiceProxy.$stopDebugging(b?b.id:void 0)}registerDebugConfigurationProvider(b,P,C){if(!P)return new S.Disposable(()=>{});const c=this._configProviderHandleCounter++;return this._configProviders.push({type:b,handle:c,provider:P}),this._debugServiceProxy.$registerDebugConfigurationProvider(b,C,!!P.provideDebugConfigurations,!!P.resolveDebugConfiguration,!!P.resolveDebugConfigurationWithSubstitutedVariables,c),new S.Disposable(()=>{this._configProviders=this._configProviders.filter(F=>F.provider!==P),this._debugServiceProxy.$unregisterDebugConfigurationProvider(c)})}registerDebugAdapterDescriptorFactory(b,P,C){if(!C)return new S.Disposable(()=>{});if(!this.definesDebugType(b,P))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${P}' debugger.`);if(this.getAdapterDescriptorFactoryByType(P))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const c=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:P,handle:c,factory:C}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(P,c),new S.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(F=>F.factory!==C),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(c)})}registerDebugAdapterTrackerFactory(b,P){if(!P)return new S.Disposable(()=>{});const C=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:b,handle:C,factory:P}),new S.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(c=>c.factory!==P)})}async $runInTerminal(b,P){return Promise.resolve(void 0)}async $substituteVariables(b,P){if(!this._variableResolver){const[F,N]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(F||[],this._editorsService,N)}let C;const c=await this.getFolder(b);return c&&(C={uri:c.uri,name:c.name,index:c.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(C,P)}createDebugAdapter(b,P){if(b.type==="implementation")return new s(b.implementation)}createSignService(){}async $startDASession(b,P){const C=this,c=await this.getSession(P);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(c.type),c).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}' (extension might have failed to activate)`);const N=this.convertToDto(F),z=this.createDebugAdapter(N,c);if(!z)throw new Error(`Couldn't create a debug adapter for type '${c.type}'.`);const he=z;return this._debugAdapters.set(b,he),this.getDebugAdapterTrackers(c).then(me=>(me&&this._debugAdaptersTrackers.set(b,me),he.onMessage(async Q=>{if(Q.type==="request"&&Q.command==="handshake"){const W=Q,x={type:"response",seq:0,command:W.command,request_seq:W.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const A=await this._signService.sign(W.arguments.value);x.body={signature:A},he.sendResponse(x)}else throw new Error("no signer")}catch(A){x.success=!1,x.message=A.message,he.sendResponse(x)}}else me&&me.onDidSendMessage&&me.onDidSendMessage(Q),Q=(0,o.convertToVSCPaths)(Q,!0),C._debugServiceProxy.$acceptDAMessage(b,Q)}),he.onError(Q=>{me&&me.onError&&me.onError(Q),this._debugServiceProxy.$acceptDAError(b,Q.name,Q.message,Q.stack)}),he.onExit(Q=>{me&&me.onExit&&me.onExit((0,f.withNullAsUndefined)(Q),void 0),this._debugServiceProxy.$acceptDAExit(b,(0,f.withNullAsUndefined)(Q),void 0)}),me&&me.onWillStartSession&&me.onWillStartSession(),he.startSession()))})}$sendDAMessage(b,P){P=(0,o.convertToDAPaths)(P,!1);const C=this._debugAdaptersTrackers.get(b);C&&C.onWillReceiveMessage&&C.onWillReceiveMessage(P);const c=this._debugAdapters.get(b);c&&c.sendMessage(P)}$stopDASession(b){const P=this._debugAdaptersTrackers.get(b);this._debugAdaptersTrackers.delete(b),P&&P.onWillStopSession&&P.onWillStopSession();const C=this._debugAdapters.get(b);return this._debugAdapters.delete(b),C?C.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(b){const P=[],C=[],c=[];if(b.added)for(const F of b.added){const N=F.id;if(N&&!this._breakpoints.has(N)){let z;if(F.type==="function")z=new S.FunctionBreakpoint(F.functionName,F.enabled,F.condition,F.hitCondition,F.logMessage);else if(F.type==="data")z=new S.DataBreakpoint(F.label,F.dataId,F.canPersist,F.enabled,F.hitCondition,F.condition,F.logMessage);else{const he=R.URI.revive(F.uri);z=new S.SourceBreakpoint(new S.Location(he,new S.Position(F.line,F.character)),F.enabled,F.condition,F.hitCondition,F.logMessage)}z._id=N,this._breakpoints.set(N,z),P.push(z)}}if(b.removed)for(const F of b.removed){const N=this._breakpoints.get(F);N&&(this._breakpoints.delete(F),C.push(N))}if(b.changed){for(const F of b.changed)if(F.id){const N=this._breakpoints.get(F.id);if(N){if(N instanceof S.FunctionBreakpoint&&F.type==="function"){const z=N;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.functionName=F.functionName}else if(N instanceof S.SourceBreakpoint&&F.type==="source"){const z=N;z.enabled=F.enabled,z.condition=F.condition,z.hitCondition=F.hitCondition,z.logMessage=F.logMessage,z.location=new S.Location(R.URI.revive(F.uri),new S.Position(F.line,F.character))}c.push(N)}}}this.fireBreakpointChanges(P,C,c)}$provideDebugConfigurations(b,P,C){return(0,T.asPromise)(async()=>{const c=this.getConfigProviderByHandle(b);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const F=await this.getFolder(P);return c.provideDebugConfigurations(F,C)}).then(c=>{if(!c)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return c})}$resolveDebugConfiguration(b,P,C,c){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const N=await this.getFolder(P);return F.resolveDebugConfiguration(N,C,c)})}$resolveDebugConfigurationWithSubstitutedVariables(b,P,C,c){return(0,T.asPromise)(async()=>{const F=this.getConfigProviderByHandle(b);if(!F)throw new Error("no DebugConfigurationProvider found");if(!F.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const N=await this.getFolder(P);return F.resolveDebugConfigurationWithSubstitutedVariables(N,C,c)})}async $provideDebugAdapter(b,P){const C=this.getAdapterDescriptorFactoryByHandle(b);if(!C)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const c=await this.getSession(P);return this.getAdapterDescriptor(C,c).then(F=>{if(!F)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${c.type}'`);return this.convertToDto(F)})}async $acceptDebugSessionStarted(b){const P=await this.getSession(b);this._onDidStartDebugSession.fire(P)}async $acceptDebugSessionTerminated(b){const P=await this.getSession(b);P&&(this._onDidTerminateDebugSession.fire(P),this._debugSessions.delete(P.id))}async $acceptDebugSessionActiveChanged(b){this._activeDebugSession=b?await this.getSession(b):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(b,P){const C=await this.getSession(b);C&&C._acceptNameChanged(P)}async $acceptDebugSessionCustomEvent(b,P){const c={session:await this.getSession(b),event:P.event,body:P.body};this._onDidReceiveDebugSessionCustomEvent.fire(c)}convertToDto(b){if(b instanceof S.DebugAdapterExecutable)return{type:"executable",command:b.command,args:b.args,options:b.options};if(b instanceof S.DebugAdapterServer)return{type:"server",port:b.port,host:b.host};if(b instanceof S.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:b.path};if(b instanceof S.DebugAdapterInlineImplementation)return{type:"implementation",implementation:b.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(b){const P=this._adapterFactories.filter(C=>C.type===b);if(P.length>0)return P[0].factory}getAdapterDescriptorFactoryByHandle(b){const P=this._adapterFactories.filter(C=>C.handle===b);if(P.length>0)return P[0].factory}getConfigProviderByHandle(b){const P=this._configProviders.filter(C=>C.handle===b);if(P.length>0)return P[0].provider}definesDebugType(b,P){if(b.contributes){const C=b.contributes.debuggers;if(C&&C.length>0){for(const c of C)if(c.label&&c.type&&c.type===P)return!0}}return!1}getDebugAdapterTrackers(b){const C=b.configuration.type,c=this._trackerFactories.filter(F=>F.type===C||F.type==="*").map(F=>(0,T.asPromise)(()=>F.factory.createDebugAdapterTracker(b)).then(N=>N,N=>null));return Promise.race([Promise.all(c).then(F=>{const N=F.filter(z=>!!z);if(N.length>0)return new r(N)}),new Promise((F,N)=>{const z=setTimeout(()=>{clearTimeout(z),N(new Error("timeout"))},1e3)})]).catch(F=>{})}async getAdapterDescriptor(b,P){const C=P.configuration.debugServer;if(typeof C=="number")return Promise.resolve(new S.DebugAdapterServer(C));if(b){const F=await this._extensionService.getExtensionRegistry();return(0,T.asPromise)(()=>b.createDebugAdapterDescriptor(P,this.daExecutableFromPackage(P,F))).then(N=>{if(N)return N})}const c=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(P,c))}daExecutableFromPackage(b,P){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(b,P,C){(b.length>0||P.length>0||C.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:b,removed:P,changed:C}))}async getSession(b){if(b)if(typeof b=="string"){const P=this._debugSessions.get(b);if(P)return P}else{let P=this._debugSessions.get(b.id);if(!P){const C=await this.getFolder(b.folderUri),c=b.parent?this._debugSessions.get(b.parent):void 0;P=new h(this._debugServiceProxy,b.id,b.type,b.name,C,b.configuration,c),this._debugSessions.set(P.id,P),this._debugServiceProxy.$sessionCached(P.id)}return P}throw new Error("cannot find session")}getFolder(b){if(b){const P=R.URI.revive(b);return this._workspaceService.resolveWorkspaceFolder(P)}return Promise.resolve(void 0)}};m=ze([je(0,a.IExtHostRpcService),je(1,k.IExtHostWorkspace),je(2,i.IExtHostExtensionService),je(3,I.IExtHostDocumentsAndEditors),je(4,g.IExtHostConfiguration),je(5,l.IExtHostEditorTabs)],m),e.ExtHostDebugServiceBase=m;class h{constructor(b,P,C,c,F,N,z){this._debugServiceProxy=b,this._id=P,this._type=C,this._name=c,this._workspaceFolder=F,this._configuration=N,this._parentSession=z}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(b){this._name=b,this._debugServiceProxy.$setDebugSessionName(this._id,b)}get parentSession(){return this._parentSession}_acceptNameChanged(b){this._name=b}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(b,P){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,b,P)}getDebugProtocolBreakpoint(b){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,b.id)}}e.ExtHostDebugSession=h;class t{constructor(b){this.value=Object.freeze({append(P){b.$appendDebugConsole(P)},appendLine(P){this.append(P+`
`)}})}}e.ExtHostDebugConsole=t;class n extends d.AbstractVariableResolverService{constructor(b,P,C,c,F){function N(){if(P){const z=P.activeEditor();if(z)return z.document.uri;const he=c.tabs.filter(me=>me.isActive);if(he.length>0)return he[0].resource}}super({getFolderUri:z=>{const he=b.filter(me=>me.name===z);if(he&&he.length>0)return he[0].uri},getWorkspaceFolderCount:()=>b.length,getConfigurationValue:(z,he)=>C.getConfiguration(void 0,z).get(he),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const z=N();if(z)return p.normalize(z.fsPath)},getWorkspaceFolderPathForFile:()=>{if(F){const z=N();if(z){const he=F.getWorkspaceFolder(z);if(he)return p.normalize(he.uri.fsPath)}}},getSelectedText:()=>{if(P){const z=P.activeEditor();if(z&&!z.selection.isEmpty)return z.document.getText(z.selection)}},getLineNumber:()=>{if(P){const z=P.activeEditor();if(z)return String(z.selection.end.line+1)}}},void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=n;class r{constructor(b){this.trackers=b}onWillStartSession(){this.trackers.forEach(b=>b.onWillStartSession?b.onWillStartSession():void 0)}onWillReceiveMessage(b){this.trackers.forEach(P=>P.onWillReceiveMessage?P.onWillReceiveMessage(b):void 0)}onDidSendMessage(b){this.trackers.forEach(P=>P.onDidSendMessage?P.onDidSendMessage(b):void 0)}onWillStopSession(){this.trackers.forEach(b=>b.onWillStopSession?b.onWillStopSession():void 0)}onError(b){this.trackers.forEach(P=>P.onError?P.onError(b):void 0)}onExit(b,P){this.trackers.forEach(C=>C.onExit?C.onExit(b,P):void 0)}}class s extends E.AbstractDebugAdapter{constructor(b){super();this.implementation=b,b.onDidSendMessage(P=>{this.acceptMessage(P)})}startSession(){return Promise.resolve(void 0)}sendMessage(b){this.implementation.handleMessage(b)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends m{constructor(b,P,C,c,F,N){super(b,P,C,c,F,N)}createVariableResolver(b,P,C){return new n(b,P,C,this._editorTabs)}};u=ze([je(0,a.IExtHostRpcService),je(1,k.IExtHostWorkspace),je(2,i.IExtHostExtensionService),je(3,I.IExtHostDocumentsAndEditors),je(4,g.IExtHostConfiguration),je(5,l.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(be[223],_e([0,1,80,2,5,33,32,26,16,28,4,34,46,17]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let o=class{constructor(l,m,h,t,n,r,s){this._apiFactory=l,this._extensionRegistry=m,this._instaService=h,this._extHostConfiguration=t,this._extHostExtensionService=n,this._initData=r,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const m=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,m,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(w)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(f,m,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let m of l.nodeModuleName)this._factories.set(m,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(m=>l.alternativeModuleName(m))}};o=ze([je(2,i.IInstantiationService),je(3,T.IExtHostConfiguration),je(4,I.IExtHostExtensionService),je(5,k.IExtHostInitDataService),je(6,g.ILogService)],o),e.RequireInterceptor=o;class a{constructor(l,m,h,t,n){this._apiFactory=l,this._extensionPaths=m,this._extensionRegistry=h,this._configProvider=t,this._logService=n,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,m){const h=this._extensionPaths.findSubstr(m.fsPath);if(h){let t=this._extApiImpl.get(S.ExtensionIdentifier.toKey(h.identifier));return t||(t=this._apiFactory(h,this._extensionRegistry,this._configProvider),this._extApiImpl.set(S.ExtensionIdentifier.toKey(h.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((n,r)=>t+=`	${r} -> ${n.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${m.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(_.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let w=class{constructor(l,m){this.nodeModuleName="keytar";const{environment:h}=m,t=l.getProxy(D.MainContext.MainThreadKeytar);if(h.appRoot){let n=h.appRoot.fsPath;d.platform==="win32"&&(n=n.replace(/\\/g,"/")),n[n.length-1]==="/"&&(n=n.substr(0,n.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${n}/node_modules.asar/keytar`),this.alternativeNames.add(`${n}/node_modules/keytar`)}this._impl={getPassword:(n,r)=>t.$getPassword(n,r),setPassword:(n,r,s)=>t.$setPassword(n,r,s),deletePassword:(n,r)=>t.$deletePassword(n,r),findPassword:n=>t.$findPassword(n),findCredentials(n){return t.$findCredentials(n)}}}load(l,m){return this._impl}alternativeModuleName(l){const m=l.length;if(m<=7||!this.alternativeNames)return;const h=m-7;if((l.charAt(h)==="/"||l.charAt(h)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};w=ze([je(0,E.IExtHostRpcService),je(1,k.IExtHostInitDataService)],w);let f=class{constructor(l,m,h){this._extensionPaths=l,this._appUriScheme=m,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=h.getProxy(D.MainContext.MainThreadTelemetry);const t=h.getProxy(D.MainContext.MainThreadWindow);this._impl=(n,r)=>{const s=R.URI.parse(n);return r?this.callOriginal(n,r):s.scheme==="http"||s.scheme==="https"?t.$openUri(s,n,{allowTunneling:!0}):s.scheme==="mailto"||s.scheme===this._appUriScheme?t.$openUri(s,n,{}):this.callOriginal(n,r)}}load(l,m,h){const t=this._extensionPaths.findSubstr(m.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=h(l),this._impl}callOriginal(l,m){return this.sendNoForwardTelemetry(),this._original(l,m)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};f=ze([je(2,E.IExtHostRpcService)],f)}),define(be[224],_e([0,1,11,13,80,6,2,5,216,17,62,66,28,153,16,72,34,40]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(m,h,t,n){this._disposables=new T.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new E.RPCProtocol(m,null,n),h=y._transform(h,this._rpcProtocol);const r=new I.ServiceCollection(...(0,i.getSingletonServiceDescriptors)());r.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},h)),r.set(o.IExtHostRpcService,new o.ExtHostRpcService(this._rpcProtocol)),r.set(a.IURITransformerService,new a.URITransformerService(n)),r.set(w.IHostUtils,t);const s=new g.InstantiationService(r,!0),u=s.invokeFunction(C=>C.get(f.IExtHostTerminalService));this._disposables.add(u),this._logService=s.invokeFunction(C=>C.get(k.ILogService)),D.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",h),this._extensionService=s.invokeFunction(C=>C.get(w.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(C=>{Error.prepareStackTrace=(c,F)=>{let N="",z,he;for(const me of F)N+=`
	at ${me.toString()}`,he=me.getFileName(),!z&&he&&(z=C.findSubstr(he));return v.set(c,z),`${c.name||"Error"}: ${c.message||""}${N}`}});const b=this._rpcProtocol.getProxy(S.MainContext.MainThreadExtensionService),P=this._rpcProtocol.getProxy(S.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(C=>{const c=R.transformErrorForSerialization(C),F=v.get(C);F?b.$onExtensionRuntimeError(F.identifier,c):P.$onUnexpectedError(c)})}terminate(m){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${m}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const h=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,p.timeout)(4e3),h]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(m,h){m.extensions.forEach(n=>n.extensionLocation=_.URI.revive(h.transformIncomingURIs(n.extensionLocation))),m.environment.appRoot=_.URI.revive(h.transformIncomingURIs(m.environment.appRoot));const t=m.environment.extensionDevelopmentLocationURI;return t&&(m.environment.extensionDevelopmentLocationURI=t.map(n=>_.URI.revive(h.transformIncomingURIs(n)))),m.environment.extensionTestsLocationURI=_.URI.revive(h.transformIncomingURIs(m.environment.extensionTestsLocationURI)),m.environment.globalStorageHome=_.URI.revive(h.transformIncomingURIs(m.environment.globalStorageHome)),m.environment.workspaceStorageHome=_.URI.revive(h.transformIncomingURIs(m.environment.workspaceStorageHome)),m.logsLocation=_.URI.revive(h.transformIncomingURIs(m.logsLocation)),m.logFile=_.URI.revive(h.transformIncomingURIs(m.logFile)),m.workspace=h.transformIncomingURIs(m.workspace),m}}e.ExtensionHostMain=y}),define(be[225],_e([0,1,12,20,61,27,24,56,41]),function(X,e,p,R,D,T,_,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(d,g,o){this.config=d,this.provider=g,this.sessionToken=o,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=d.filePattern,this.includePattern=d.includePattern&&T.parse(d.includePattern),this.maxResults=d.maxResults||void 0,this.exists=d.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=d.excludePattern&&T.parse(d.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(d=>d.cancel()),this.activeCancellationTokens=new Set}search(d){const g=this.config.folderQueries||[];return new Promise((o,a)=>{const w=f=>{this.resultCount++,d(f)};if(this.isCanceled)return o({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(f=>{const y=f.toString(),l=p.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,l)||this.matchFile(w,{base:f,basename:l})}),Promise.all(g.map(f=>this.searchInFolder(f,w))).then(f=>{o({limitHit:this.isLimitHit,stats:f[0]||void 0})},f=>{a(new Error((0,D.toErrorMessage)(f)))})})}async searchInFolder(d,g){const o=new R.CancellationTokenSource,a=this.getSearchOptionsForFolder(d),w=this.initDirectoryTree(),f=new E.QueryGlobTester(this.config,d),y=!f.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(o),l=S.StopWatch.create();const m=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},a,o.token),h=l.elapsed(),t=S.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(m&&m.forEach(n=>{const r=p.posix.relative(d.folder.path,n.path);if(y){const s=p.basename(n.path);this.matchFile(g,{base:d.folder,relativePath:r,basename:s});return}this.addDirectoryEntries(w,d.folder,r,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(w,f,g),{providerTime:h,postProcessTime:t.elapsed()})}finally{o.dispose(),this.activeCancellationTokens.delete(o)}}getSearchOptionsForFolder(d){const g=(0,E.resolvePatternsForProvider)(this.config.includePattern,d.includePattern),o=(0,E.resolvePatternsForProvider)(this.config.excludePattern,d.excludePattern);return{folder:d.folder,excludes:o,includes:g,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}addDirectoryEntries({pathToEntries:d},g,o,a){if(o===this.filePattern){const f=p.basename(this.filePattern);this.matchFile(a,{base:g,relativePath:this.filePattern,basename:f})}function w(f){const y=p.basename(f),l=p.dirname(f);let m=d[l];m||(m=d[l]=[],w(l)),m.push({base:g,relativePath:f,basename:y})}w(o)}matchDirectoryTree({rootEntries:d,pathToEntries:g},o,a){const w=this,f=this.filePattern;function y(l){const m=T.hasSiblingFn(()=>l.map(h=>h.basename));for(let h=0,t=l.length;h<t;h++){const n=l[h],{relativePath:r,basename:s}=n;if(!o.includedInQuerySync(r,s,f!==s?m:void 0))continue;const u=g[r];if(u)y(u);else{if(r===f)continue;w.matchFile(a,n)}if(w.isLimitHit)break}}y(d)}matchFile(d,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||d(g))}}class i{constructor(){this.sessions=new Map}fileSearch(d,g,o,a){const w=this.getSessionTokenSource(d.cacheKey),f=new k(d,g,w&&w.token);let y=0;const l=m=>{y+=m.length,o(m.map(h=>this.rawMatchToSearchItem(h)))};return this.doSearch(f,i.BATCH_SIZE,l,a).then(m=>({limitHit:m.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:m.stats}}))}clearCache(d){const g=this.getSessionTokenSource(d);g&&g.cancel()}getSessionTokenSource(d){if(!!d)return this.sessions.has(d)||this.sessions.set(d,new R.CancellationTokenSource),this.sessions.get(d)}rawMatchToSearchItem(d){return d.relativePath?{resource:_.joinPath(d.base,d.relativePath)}:{resource:d.base}}doSearch(d,g,o,a){a.onCancellationRequested(()=>{d.cancel()});const w=y=>{y&&(f.push(y),g>0&&f.length>=g&&(o(f),f=[]))};let f=[];return d.search(w).then(y=>(f.length&&o(f),y),y=>(f.length&&o(f),Promise.reject(y)))}}e.FileSearchManager=i,i.BATCH_SIZE=512}),define(be[226],_e([0,1,12,14,20,61,24,27,2,41,15,9]),function(X,e,p,R,D,T,_,S,E,k,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class d{constructor(l,m,h){this.query=l,this.provider=m,this.fileUtils=h,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,m){const h=this.query.folderQueries||[],t=new D.CancellationTokenSource;return m.onCancellationRequested(()=>t.cancel()),new Promise((n,r)=>{this.collector=new o(l);let s=!1;const u=(v,b)=>{if(!s&&!this.isLimitHit){const P=this.resultSize(v);w(v)&&typeof this.query.maxResults=="number"&&this.resultCount+P>this.query.maxResults&&(this.isLimitHit=!0,s=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const C=this.resultSize(v);this.resultCount+=C,(C>0||!w(v))&&this.collector.add(v,b)}};Promise.all(h.map((v,b)=>this.searchInFolder(v,P=>u(P,b),t.token))).then(v=>{t.dispose(),this.collector.flush();const b=v.some(P=>!!P&&!!P.limitHit);n({limitHit:this.isLimitHit||b,messages:(0,R.flatten)(v.map(P=>(P==null?void 0:P.message)?(0,I.isArray)(P.message)?P.message:[P.message]:[])),stats:{type:"textSearchProvider"}})},v=>{t.dispose();const b=(0,T.toErrorMessage)(v);r(new Error(b))})})}resultSize(l){return w(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,m){const h=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:h.slice(0,m),preview:{matches:t.slice(0,m),text:l.preview.text},uri:l.uri}}async searchInFolder(l,m,h){const t=new k.QueryGlobTester(this.query,l),n=[],r={report:v=>{if(!this.validateProviderResult(v))return;const b=l.folder.scheme===i.Schemas.file?S.hasSiblingPromiseFn(()=>this.fileUtils.readdir(_.dirname(v.uri))):void 0,P=_.relativePath(l.folder,v.uri);P&&n.push(t.includedInQuery(P,p.basename(P),b).then(C=>{C&&m(v)}))}},s=this.getSearchOptionsForFolder(l),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),s,r,h);return await Promise.all(n),u}validateProviderResult(l){if(w(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const m=(0,k.resolvePatternsForProvider)(this.query.includePattern,l.includePattern),h=(0,k.resolvePatternsForProvider)(this.query.excludePattern,l.excludePattern),t={folder:E.URI.from(l.folder),excludes:h,includes:m,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=d;function g(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class o{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new f(512,m=>this.sendItems(m))}add(l,m){this._currentFileMatch&&(this._currentFolderIdx!==m||!_.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=m,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(a(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=o;function a(y){return w(y)?{preview:{matches:(0,R.mapArrayOrNot)(y.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:y.preview.text},ranges:(0,R.mapArrayOrNot)(y.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function w(y){return!!y.preview}e.extensionResultIsMatch=w;class f{constructor(l,m){this.maxBatchSize=l,this.cb=m,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,m){!l||this.addItemToBatch(l,m)}addItems(l,m){!l||this.addItemsToBatch(l,m)}addItemToBatch(l,m){this.batch.push(l),this.batchSize+=m,this.onUpdate()}addItemsToBatch(l,m){this.batch=this.batch.concat(l),this.batchSize+=m,this.onUpdate()}onUpdate(){this.totalNumberCompleted<f.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},f.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=f,f.TIMEOUT=4e3,f.START_BATCH_AFTER_COUNT=50}),define(be[107],_e([0,1,6,5,4,225,16,72,17,2,226]),function(X,e,p,R,D,T,_,S,E,k,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,D.createDecorator)("IExtHostSearch");let I=class{constructor(a,w,f){this.extHostRpc=a,this._uriTransformer=w,this._logService=f,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new T.FileSearchManager}_transformScheme(a){return this._uriTransformer.transformOutgoingScheme(a)}registerTextSearchProvider(a,w){if(this._textSearchUsedSchemes.has(a))throw new Error(`a text search provider for the scheme '${a}' is already registered`);this._textSearchUsedSchemes.add(a);const f=this._handlePool++;return this._textSearchProvider.set(f,w),this._proxy.$registerTextSearchProvider(f,this._transformScheme(a)),(0,p.toDisposable)(()=>{this._textSearchUsedSchemes.delete(a),this._textSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}registerFileSearchProvider(a,w){if(this._fileSearchUsedSchemes.has(a))throw new Error(`a file search provider for the scheme '${a}' is already registered`);this._fileSearchUsedSchemes.add(a);const f=this._handlePool++;return this._fileSearchProvider.set(f,w),this._proxy.$registerFileSearchProvider(f,this._transformScheme(a)),(0,p.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(a),this._fileSearchProvider.delete(f),this._proxy.$unregisterProvider(f)})}$provideFileSearchResults(a,w,f,y){const l=d(f),m=this._fileSearchProvider.get(a);if(m)return this._fileSearchManager.fileSearch(l,m,h=>{this._proxy.$handleFileMatch(a,w,h.map(t=>t.resource))},y);throw new Error("unknown provider: "+a)}$clearCache(a){return this._fileSearchManager.clearCache(a),Promise.resolve(void 0)}$provideTextSearchResults(a,w,f,y){const l=this._textSearchProvider.get(a);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${a}`);const m=d(f);return this.createTextSearchManager(m,l).search(t=>this._proxy.$handleTextMatch(a,w,t),y)}createTextSearchManager(a,w){return new i.TextSearchManager(a,w,{readdir:f=>Promise.resolve([]),toCanonicalName:f=>f})}};I=ze([je(0,_.IExtHostRpcService),je(1,S.IURITransformerService),je(2,E.ILogService)],I),e.ExtHostSearch=I;function d(o){return Object.assign(Object.assign({},o),{folderQueries:o.folderQueries&&o.folderQueries.map(g),extraFileResources:o.extraFileResources&&o.extraFileResources.map(a=>k.URI.revive(a))})}e.reviveQuery=d;function g(o){return Object.assign(Object.assign({},o),{folder:k.URI.revive(o.folder)})}}),define(be[227],_e([0,1,20,13,3,47,2,126,85,120,60,65,5,191,190,76,192,33,193,194,195,178,196,39,34,197,179,199,200,201,102,181,205,206,207,78,40,208,182,10,7,211,51,103,30,32,52,168,198,94,101,105,106,107,17,72,16,28,202,166,71,75,188,209,165,79,77,214,212,213,189,49,220,210,74,69,95,203,104,204,15,155]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l,m,h,t,n,r,s,u,v,b,P,C,c,F,N,z,he,me,Q,W,x,A,U,M,$,K,j,ae,we,Re,xe,Le,Ve,Qe,Ke,Ge,H,Y,ne,re,G,se,fe,Ae,ge,We,V,te,pe,Me,$e,Be,Ye,Se,ye,De,ie,ue,O,J,oe,Ce,ke){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Ne(Oe){const qe=Oe.get(ne.IExtHostInitDataService),rt=Oe.get(Ye.IExtHostFileSystemInfo),tt=Oe.get(te.IExtHostConsumerFileSystem),Je=Oe.get(r.IExtHostExtensionService),ot=Oe.get(K.IExtHostWorkspace),_t=Oe.get(ue.IExtHostTelemetry),bt=Oe.get(f.IExtHostConfiguration),ve=Oe.get(H.IURITransformerService),ce=Oe.get(Y.IExtHostRpcService),le=Oe.get(he.IExtHostStorage),q=Oe.get(V.IExtensionStoragePaths),Fe=Oe.get(Ge.ILogService),Pe=Oe.get(se.IExtHostTunnelService),Ze=Oe.get(fe.IExtHostApiDeprecationService),et=Oe.get($.IExtHostWindow),ft=Oe.get(De.IExtHostSecretState),ut=Oe.get(ie.IExtHostEditorTabs);ce.set(d.ExtHostContext.ExtHostFileSystemInfo,rt),ce.set(d.ExtHostContext.ExtHostLogService,Fe),ce.set(d.ExtHostContext.ExtHostWorkspace,ot),ce.set(d.ExtHostContext.ExtHostConfiguration,bt),ce.set(d.ExtHostContext.ExtHostExtensionService,Je),ce.set(d.ExtHostContext.ExtHostStorage,le),ce.set(d.ExtHostContext.ExtHostTunnelService,Pe),ce.set(d.ExtHostContext.ExtHostWindow,et),ce.set(d.ExtHostContext.ExtHostSecretState,ft),ce.set(d.ExtHostContext.ExtHostTelemetry,_t),ce.set(d.ExtHostContext.ExtHostEditorTabs,ut);const it=ce.set(d.ExtHostContext.ExtHostDecorations,Oe.get(Le.IExtHostDecorations)),vt=ce.set(d.ExtHostContext.ExtHostDocumentsAndEditors,Oe.get(n.IExtHostDocumentsAndEditors)),ht=ce.set(d.ExtHostContext.ExtHostCommands,Oe.get(a.IExtHostCommands)),lt=ce.set(d.ExtHostContext.ExtHostTerminalService,Oe.get(me.IExtHostTerminalService)),mt=ce.set(d.ExtHostContext.ExtHostDebugService,Oe.get(Qe.IExtHostDebugService)),Pt=ce.set(d.ExtHostContext.ExtHostSearch,Oe.get(Ke.IExtHostSearch)),Ct=ce.set(d.ExtHostContext.ExtHostTask,Oe.get(Ve.IExtHostTask)),At=ce.set(d.ExtHostContext.ExtHostOutputService,Oe.get(C.IExtHostOutputService)),Rt=ce.set(d.ExtHostContext.ExtHostUrls,new U.ExtHostUrls(ce)),yt=ce.set(d.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(ce,vt)),Gt=ce.set(d.ExtHostContext.ExtHostDocumentContentProviders,new m.ExtHostDocumentContentProvider(ce,vt,Fe)),Qt=ce.set(d.ExtHostContext.ExtHostDocumentSaveParticipant,new h.ExtHostDocumentSaveParticipant(Fe,yt,ce.getProxy(d.MainContext.MainThreadBulkEdits))),gt=ce.set(d.ExtHostContext.ExtHostNotebook,new re.ExtHostNotebookController(ce,ht,vt,yt,Fe,q)),Yt=ce.set(d.ExtHostContext.ExtHostNotebookKernels,new O.ExtHostNotebookKernels(ce,qe,gt,Fe)),Jt=ce.set(d.ExtHostContext.ExtHostNotebookRenderers,new oe.ExtHostNotebookRenderers(ce,gt)),Dt=ce.set(d.ExtHostContext.ExtHostEditors,new Q.ExtHostEditors(ce,vt)),cn=ce.set(d.ExtHostContext.ExtHostTreeViews,new W.ExtHostTreeViews(ce.getProxy(d.MainContext.MainThreadTreeViews),ht,Fe)),Xt=ce.set(d.ExtHostContext.ExtHostEditorInsets,new we.ExtHostEditorInsets(ce.getProxy(d.MainContext.MainThreadEditorInsets),Dt,qe)),$t=ce.set(d.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(ce,Fe)),ct=ce.set(d.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(ce,ve,yt,ht,$t,Fe,Ze)),Zt=ce.set(d.ExtHostContext.ExtHostFileSystem,new s.ExtHostFileSystem(ce,ct)),Mt=ce.set(d.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(ce,Fe,vt)),Lt=ce.set(d.ExtHostContext.ExtHostQuickOpen,(0,F.createExtHostQuickOpen)(ce,ot,ht)),Vt=ce.set(d.ExtHostContext.ExtHostSCM,new N.ExtHostSCM(ce,ht,Fe)),vn=ce.set(d.ExtHostContext.ExtHostComments,new w.ExtHostComments(ce,ht,yt)),dn=ce.set(d.ExtHostContext.ExtHostProgress,new c.ExtHostProgress(ce.getProxy(d.MainContext.MainThreadProgress))),wn=ce.set(d.ExtHostContext.ExtHosLabelService,new Re.ExtHostLabelService(ce)),hn=ce.set(d.ExtHostContext.ExtHostTheming,new G.ExtHostTheming(ce)),Bt=ce.set(d.ExtHostContext.ExtHostAuthentication,new Ae.ExtHostAuthentication(ce)),en=ce.set(d.ExtHostContext.ExtHostTimeline,new ge.ExtHostTimeline(ce,ht)),Ht=ce.set(d.ExtHostContext.ExtHostWebviews,new M.ExtHostWebviews(ce,{remote:qe.remote},ot,Fe,Ze)),tn=ce.set(d.ExtHostContext.ExtHostWebviewPanels,new $e.ExtHostWebviewPanels(ce,Ht,ot)),bn=ce.set(d.ExtHostContext.ExtHostCustomEditors,new Me.ExtHostCustomEditors(ce,yt,q,Ht,tn)),_n=ce.set(d.ExtHostContext.ExtHostWebviewViews,new pe.ExtHostWebviewViews(ce,Ht)),Nt=ce.set(d.ExtHostContext.ExtHostTesting,new Se.ExtHostTesting(ce,vt,ot)),jt=ce.set(d.ExtHostContext.ExtHostUriOpeners,new ye.ExtHostUriOpeners(ce)),En=(0,ae.values)(d.ExtHostContext);ce.assertRegistered(En);const yn=new Be.ExtHostBulkEdits(ce,vt),nn=new o.ExtHostClipboard(ce),rn=new P.ExtHostMessageService(ce,Fe),xt=new l.ExtHostDialogs(ce),qt=new z.ExtHostStatusBar(ce,ht.converter),Wt=new b.ExtHostLanguages(ce,yt);return g.ExtHostApiCommands.register(ht),function(Te,sn,It){const pt=function(){let Z=!Te.isUnderDevelopment;function de(Ie){Z||(Fe.info(`Extension '${Te.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),Z=!0)}return function Ie(st){if(Array.isArray(st))st.forEach(Ie);else if(typeof st=="string")de(st);else{const wt=st;typeof wt.scheme=="undefined"&&de(st),!Te.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,j.throwProposedApiError)(Te)}return st}}(),Sn={getSession(Z,de,Ie){return Bt.getSession(Te,Z,de,Ie)},get onDidChangeSessions(){return Bt.onDidChangeSessions},registerAuthenticationProvider(Z,de,Ie,st){return Bt.registerAuthenticationProvider(Z,de,Ie,st)},get onDidChangeAuthenticationProviders(){return(0,j.checkProposedApiEnabled)(Te),Bt.onDidChangeAuthenticationProviders},get providers(){return(0,j.checkProposedApiEnabled)(Te),Bt.providers},logout(Z,de){return(0,j.checkProposedApiEnabled)(Te),Bt.removeSession(Z,de)}},Dn={registerCommand(Z,de,Ie){return ht.registerCommand(!0,Z,de,Ie)},registerTextEditorCommand(Z,de,Ie){return ht.registerCommand(!0,Z,(...st)=>{const wt=Dt.getActiveTextEditor();if(!wt){Fe.warn("Cannot execute "+Z+" because there is no active text editor.");return}return wt.edit(Et=>{de.apply(Ie,[wt,Et,...st])}).then(Et=>{Et||Fe.warn("Edits from command "+Z+" were not applied.")},Et=>{Fe.warn("An error occurred while running command "+Z,Et)})})},registerDiffInformationCommand:(Z,de,Ie)=>((0,j.checkProposedApiEnabled)(Te),ht.registerCommand(!0,Z,async(...st)=>{const wt=vt.activeEditor(!0);if(!wt){Fe.warn("Cannot execute "+Z+" because there is no active text editor.");return}const Et=await Dt.getDiffInformation(wt.id);de.apply(Ie,[Et,...st])})),executeCommand(Z,...de){return ht.executeCommand(Z,...de)},getCommands(Z=!1){return ht.getCommands(Z)}},fn={get machineId(){return qe.telemetryInfo.machineId},get sessionId(){return qe.telemetryInfo.sessionId},get language(){return qe.environment.appLanguage},get appName(){return qe.environment.appName},get appRoot(){var Z,de;return(de=(Z=qe.environment.appRoot)===null||Z===void 0?void 0:Z.fsPath)!==null&&de!==void 0?de:""},get uriScheme(){return qe.environment.appUriScheme},get clipboard(){return nn.value},get shell(){return lt.getDefaultShell(!1)},get isTelemetryEnabled(){return _t.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return _t.onDidChangeTelemetryEnabled},get isNewAppInstall(){const Z=Date.now()-new Date(qe.telemetryInfo.firstSessionDate).getTime();return isNaN(Z)?!1:Z<1e3*60*60*24},openExternal(Z,de){return et.openUri(Z,{allowTunneling:!!qe.remote.authority,allowContributedOpeners:de==null?void 0:de.allowContributedOpeners})},async asExternalUri(Z){if(Z.scheme===qe.environment.appUriScheme)return Rt.createAppUri(Z);!(0,ke.matchesScheme)(Z,Ce.Schemas.http)&&!(0,ke.matchesScheme)(Z,Ce.Schemas.https)&&(0,j.checkProposedApiEnabled)(Te);try{return await et.asExternalUri(Z,{allowTunneling:!!qe.remote.authority})}catch(de){return Z}},get remoteName(){return(0,xe.getRemoteName)(qe.remote.authority)},get uiKind(){return qe.uiKind}};qe.environment.extensionTestsLocationURI||Object.freeze(fn);const mn=qe.remote.isRemote?A.ExtensionKind.Workspace:A.ExtensionKind.UI,on={registerTestController(Z){return(0,j.checkProposedApiEnabled)(Te),Nt.registerTestController(Te.identifier.value,Z)},createDocumentTestObserver(Z){return(0,j.checkProposedApiEnabled)(Te),Nt.createTextDocumentTestObserver(Z)},createWorkspaceTestObserver(Z){return(0,j.checkProposedApiEnabled)(Te),Nt.createWorkspaceTestObserver(Z)},runTests(Z){return(0,j.checkProposedApiEnabled)(Te),Nt.runTests(Z)},createTestItem(Z,de){return new A.TestItemImpl(Z.id,Z.label,Z.uri,de)},createTestRun(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),Nt.createTestRun(Te.identifier.value,Z,de,Ie)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Te),Nt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Te),Nt.results}};on.createTestRunTask=on.createTestRun;const Cn={getExtension(Z){const de=sn.getExtensionDescription(Z);if(de)return new r.Extension(Je,Te.identifier,de,mn)},get all(){return sn.getAllExtensionDescriptions().map(Z=>new r.Extension(Je,Te.identifier,Z,mn))},get onDidChange(){return sn.onDidChange}},kn={createDiagnosticCollection(Z){return $t.createDiagnosticCollection(Te.identifier,Z)},get onDidChangeDiagnostics(){return $t.onDidChangeDiagnostics},getDiagnostics:Z=>$t.getDiagnostics(Z),getLanguages(){return Wt.getLanguages()},setTextDocumentLanguage(Z,de){return Wt.changeLanguage(Z.uri,de)},match(Z,de){return(0,i.score)(x.LanguageSelector.from(Z),de.uri,de.languageId,!0)},registerCodeActionsProvider(Z,de,Ie){return ct.registerCodeActionProvider(Te,pt(Z),de,Ie)},registerCodeLensProvider(Z,de){return ct.registerCodeLensProvider(Te,pt(Z),de)},registerDefinitionProvider(Z,de){return ct.registerDefinitionProvider(Te,pt(Z),de)},registerDeclarationProvider(Z,de){return ct.registerDeclarationProvider(Te,pt(Z),de)},registerImplementationProvider(Z,de){return ct.registerImplementationProvider(Te,pt(Z),de)},registerTypeDefinitionProvider(Z,de){return ct.registerTypeDefinitionProvider(Te,pt(Z),de)},registerHoverProvider(Z,de){return ct.registerHoverProvider(Te,pt(Z),de,Te.identifier)},registerEvaluatableExpressionProvider(Z,de){return ct.registerEvaluatableExpressionProvider(Te,pt(Z),de,Te.identifier)},registerInlineValuesProvider(Z,de){return ct.registerInlineValuesProvider(Te,pt(Z),de,Te.identifier)},registerDocumentHighlightProvider(Z,de){return ct.registerDocumentHighlightProvider(Te,pt(Z),de)},registerLinkedEditingRangeProvider(Z,de){return ct.registerLinkedEditingRangeProvider(Te,pt(Z),de)},registerReferenceProvider(Z,de){return ct.registerReferenceProvider(Te,pt(Z),de)},registerRenameProvider(Z,de){return ct.registerRenameProvider(Te,pt(Z),de)},registerDocumentSymbolProvider(Z,de,Ie){return ct.registerDocumentSymbolProvider(Te,pt(Z),de,Ie)},registerWorkspaceSymbolProvider(Z){return ct.registerWorkspaceSymbolProvider(Te,Z)},registerDocumentFormattingEditProvider(Z,de){return ct.registerDocumentFormattingEditProvider(Te,pt(Z),de)},registerDocumentRangeFormattingEditProvider(Z,de){return ct.registerDocumentRangeFormattingEditProvider(Te,pt(Z),de)},registerOnTypeFormattingEditProvider(Z,de,Ie,...st){return ct.registerOnTypeFormattingEditProvider(Te,pt(Z),de,[Ie].concat(st))},registerDocumentSemanticTokensProvider(Z,de,Ie){return ct.registerDocumentSemanticTokensProvider(Te,pt(Z),de,Ie)},registerDocumentRangeSemanticTokensProvider(Z,de,Ie){return ct.registerDocumentRangeSemanticTokensProvider(Te,pt(Z),de,Ie)},registerSignatureHelpProvider(Z,de,Ie,...st){return typeof Ie=="object"?ct.registerSignatureHelpProvider(Te,pt(Z),de,Ie):ct.registerSignatureHelpProvider(Te,pt(Z),de,typeof Ie=="undefined"?[]:[Ie,...st])},registerCompletionItemProvider(Z,de,...Ie){return ct.registerCompletionItemProvider(Te,pt(Z),de,Ie)},registerInlineCompletionItemProvider(Z,de){return(0,j.checkProposedApiEnabled)(Te),ct.registerInlineCompletionsProvider(Te,pt(Z),de)},registerDocumentLinkProvider(Z,de){return ct.registerDocumentLinkProvider(Te,pt(Z),de)},registerColorProvider(Z,de){return ct.registerColorProvider(Te,pt(Z),de)},registerFoldingRangeProvider(Z,de){return ct.registerFoldingRangeProvider(Te,pt(Z),de)},registerSelectionRangeProvider(Z,de){return ct.registerSelectionRangeProvider(Te,Z,de)},registerCallHierarchyProvider(Z,de){return ct.registerCallHierarchyProvider(Te,Z,de)},setLanguageConfiguration:(Z,de)=>ct.setLanguageConfiguration(Te,Z,de),getTokenInformationAtPosition(Z,de){return(0,j.checkProposedApiEnabled)(Te),Wt.tokenAtPosition(Z,de)},registerInlayHintsProvider(Z,de){return(0,j.checkProposedApiEnabled)(Te),ct.registerInlayHintsProvider(Te,Z,de)}},an={get activeTextEditor(){return Dt.getActiveTextEditor()},get visibleTextEditors(){return Dt.getVisibleTextEditors()},get activeTerminal(){return lt.activeTerminal},get terminals(){return lt.terminals},async showTextDocument(Z,de,Ie){const st=await(_.URI.isUri(Z)?Promise.resolve(gn.openTextDocument(Z)):Promise.resolve(Z));return Dt.showTextDocument(st,de,Ie)},createTextEditorDecorationType(Z){return Dt.createTextEditorDecorationType(Te,Z)},onDidChangeActiveTextEditor(Z,de,Ie){return Dt.onDidChangeActiveTextEditor(Z,de,Ie)},onDidChangeVisibleTextEditors(Z,de,Ie){return Dt.onDidChangeVisibleTextEditors(Z,de,Ie)},onDidChangeTextEditorSelection(Z,de,Ie){return Dt.onDidChangeTextEditorSelection(Z,de,Ie)},onDidChangeTextEditorOptions(Z,de,Ie){return Dt.onDidChangeTextEditorOptions(Z,de,Ie)},onDidChangeTextEditorVisibleRanges(Z,de,Ie){return Dt.onDidChangeTextEditorVisibleRanges(Z,de,Ie)},onDidChangeTextEditorViewColumn(Z,de,Ie){return Dt.onDidChangeTextEditorViewColumn(Z,de,Ie)},onDidCloseTerminal(Z,de,Ie){return lt.onDidCloseTerminal(Z,de,Ie)},onDidOpenTerminal(Z,de,Ie){return lt.onDidOpenTerminal(Z,de,Ie)},onDidChangeActiveTerminal(Z,de,Ie){return lt.onDidChangeActiveTerminal(Z,de,Ie)},onDidChangeTerminalDimensions(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),lt.onDidChangeTerminalDimensions(Z,de,Ie)},onDidWriteTerminalData(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),lt.onDidWriteTerminalData(Z,de,Ie)},get state(){return et.state},onDidChangeWindowState(Z,de,Ie){return et.onDidChangeWindowState(Z,de,Ie)},showInformationMessage(Z,...de){return rn.showMessage(Te,T.default.Info,Z,de[0],de.slice(1))},showWarningMessage(Z,...de){return rn.showMessage(Te,T.default.Warning,Z,de[0],de.slice(1))},showErrorMessage(Z,...de){return rn.showMessage(Te,T.default.Error,Z,de[0],de.slice(1))},showQuickPick(Z,de,Ie){return Lt.showQuickPick(Z,!!Te.enableProposedApi,de,Ie)},showWorkspaceFolderPick(Z){return Lt.showWorkspaceFolderPick(Z)},showInputBox(Z,de){return Lt.showInput(Z,de)},showOpenDialog(Z){return xt.showOpenDialog(Z)},showSaveDialog(Z){return xt.showSaveDialog(Z)},createStatusBarItem(Z,de,Ie){let st,wt,Et;return typeof Z=="string"?(st=Z,wt=de,Et=Ie):(wt=Z,Et=de),qt.createStatusBarEntry(Te,st,wt,Et)},setStatusBarMessage(Z,de){return qt.setStatusBarMessage(Z,de)},withScmProgress(Z){return Ze.report("window.withScmProgress",Te,"Use 'withProgress' instead."),dn.withProgress(Te,{location:A.ProgressLocation.SourceControl},(de,Ie)=>Z({report(st){}}))},withProgress(Z,de){return dn.withProgress(Te,Z,de)},createOutputChannel(Z){return At.createOutputChannel(Z)},createWebviewPanel(Z,de,Ie,st){return tn.createWebviewPanel(Te,Z,de,Ie,st)},createWebviewTextEditorInset(Z,de,Ie,st){return(0,j.checkProposedApiEnabled)(Te),Xt.createWebviewEditorInset(Z,de,Ie,st,Te)},createTerminal(Z,de,Ie){return typeof Z=="object"?"pty"in Z?lt.createExtensionTerminal(Z):(Z.iconPath&&(0,j.checkProposedApiEnabled)(Te),lt.createTerminalFromOptions(Z)):lt.createTerminal(Z,de,Ie)},registerTerminalLinkProvider(Z){return lt.registerLinkProvider(Z)},registerTerminalProfileProvider(Z,de){return lt.registerProfileProvider(Z,de)},registerTreeDataProvider(Z,de){return cn.registerTreeDataProvider(Z,de,Te)},createTreeView(Z,de){return cn.createTreeView(Z,de,Te)},registerWebviewPanelSerializer:(Z,de)=>tn.registerWebviewPanelSerializer(Te,Z,de),registerCustomEditorProvider:(Z,de,Ie={})=>bn.registerCustomEditorProvider(Te,Z,de,Ie),registerFileDecorationProvider(Z){return it.registerFileDecorationProvider(Z,Te.identifier)},registerUriHandler(Z){return Rt.registerUriHandler(Te.identifier,Z)},createQuickPick(){return Lt.createQuickPick(Te.identifier,!!Te.enableProposedApi)},createInputBox(){return Lt.createInputBox(Te.identifier)},get activeColorTheme(){return hn.activeColorTheme},onDidChangeActiveColorTheme(Z,de,Ie){return hn.onDidChangeActiveColorTheme(Z,de,Ie)},registerWebviewViewProvider(Z,de,Ie){return _n.registerWebviewViewProvider(Te,Z,de,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Te),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeActiveNotebookEditor(Z,de,Ie)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookEditorSelection(Z,de,Ie)},onDidChangeNotebookEditorVisibleRanges(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookEditorVisibleRanges(Z,de,Ie)},showNotebookDocument(Z,de){return(0,j.checkProposedApiEnabled)(Te),gt.showNotebookDocument(Z,de)},registerExternalUriOpener(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),jt.registerExternalUriOpener(Te.identifier,Z,de,Ie)},get openEditors(){return(0,j.checkProposedApiEnabled)(Te),ut.tabs},get onDidChangeOpenEditors(){return(0,j.checkProposedApiEnabled)(Te),ut.onDidChangeTabs},getInlineCompletionItemController(Z){return(0,j.checkProposedApiEnabled)(Te),v.InlineCompletionController.get(Z)}},gn={get rootPath(){return Ze.report("workspace.rootPath",Te,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ot.getPath()},set rootPath(Z){throw R.readonly()},getWorkspaceFolder(Z){return ot.getWorkspaceFolder(Z)},get workspaceFolders(){return ot.getWorkspaceFolders()},get name(){return ot.name},set name(Z){throw R.readonly()},get workspaceFile(){return ot.workspaceFile},set workspaceFile(Z){throw R.readonly()},updateWorkspaceFolders:(Z,de,...Ie)=>ot.updateWorkspaceFolders(Te,Z,de||0,...Ie),onDidChangeWorkspaceFolders:function(Z,de,Ie){return ot.onDidChangeWorkspace(Z,de,Ie)},asRelativePath:(Z,de)=>ot.getRelativePath(Z,de),findFiles:(Z,de,Ie,st)=>ot.findFiles(x.GlobPattern.from(Z),x.GlobPattern.from(de),Ie,Te.identifier,st),findTextInFiles:(Z,de,Ie,st)=>{let wt,Et;return typeof de=="object"?(wt=de,Et=Ie):(wt={},Et=de,st=Ie),ot.findTextInFiles(Z,wt||{},Et,Te.identifier,st)},saveAll:Z=>ot.saveAll(Z),applyEdit(Z){return yn.applyWorkspaceEdit(Z)},createFileSystemWatcher:(Z,de,Ie,st)=>Mt.createFileSystemWatcher(x.GlobPattern.from(Z),de,Ie,st),get textDocuments(){return yt.getAllDocumentData().map(Z=>Z.document)},set textDocuments(Z){throw R.readonly()},openTextDocument(Z){let de;const Ie=Z;if(typeof Z=="string")de=Promise.resolve(_.URI.file(Z));else if(_.URI.isUri(Z))de=Promise.resolve(Z);else if(!Ie||typeof Ie=="object")de=yt.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(st=>yt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(Z,de,Ie)=>yt.onDidAddDocument(Z,de,Ie),onDidCloseTextDocument:(Z,de,Ie)=>yt.onDidRemoveDocument(Z,de,Ie),onDidChangeTextDocument:(Z,de,Ie)=>yt.onDidChangeDocument(Z,de,Ie),onDidSaveTextDocument:(Z,de,Ie)=>yt.onDidSaveDocument(Z,de,Ie),onWillSaveTextDocument:(Z,de,Ie)=>Qt.getOnWillSaveTextDocumentEvent(Te)(Z,de,Ie),onDidChangeConfiguration:(Z,de,Ie)=>It.onDidChangeConfiguration(Z,de,Ie),getConfiguration(Z,de){return de=arguments.length===1?void 0:de,It.getConfiguration(Z,de,Te)},registerTextDocumentContentProvider(Z,de){return Gt.registerTextDocumentContentProvider(Z,de)},registerTaskProvider:(Z,de)=>(Ze.report("window.registerTaskProvider",Te,"Use the corresponding function on the 'tasks' namespace instead"),Ct.registerTaskProvider(Te,Z,de)),registerFileSystemProvider(Z,de,Ie){return Zt.registerFileSystemProvider(Te.identifier,Z,de,Ie,Te.enableProposedApi)},get fs(){return tt.value},registerFileSearchProvider:(Z,de)=>((0,j.checkProposedApiEnabled)(Te),Pt.registerFileSearchProvider(Z,de)),registerTextSearchProvider:(Z,de)=>((0,j.checkProposedApiEnabled)(Te),Pt.registerTextSearchProvider(Z,de)),registerRemoteAuthorityResolver:(Z,de)=>((0,j.checkProposedApiEnabled)(Te),Je.registerRemoteAuthorityResolver(Z,de)),registerResourceLabelFormatter:Z=>((0,j.checkProposedApiEnabled)(Te),wn.$registerResourceLabelFormatter(Z)),onDidCreateFiles:(Z,de,Ie)=>Mt.onDidCreateFile(Z,de,Ie),onDidDeleteFiles:(Z,de,Ie)=>Mt.onDidDeleteFile(Z,de,Ie),onDidRenameFiles:(Z,de,Ie)=>Mt.onDidRenameFile(Z,de,Ie),onWillCreateFiles:(Z,de,Ie)=>Mt.getOnWillCreateFileEvent(Te)(Z,de,Ie),onWillDeleteFiles:(Z,de,Ie)=>Mt.getOnWillDeleteFileEvent(Te)(Z,de,Ie),onWillRenameFiles:(Z,de,Ie)=>Mt.getOnWillRenameFileEvent(Te)(Z,de,Ie),openTunnel:Z=>((0,j.checkProposedApiEnabled)(Te),Pe.openTunnel(Te,Z).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,j.checkProposedApiEnabled)(Te),Pe.getTunnels()},onDidChangeTunnels:(Z,de,Ie)=>((0,j.checkProposedApiEnabled)(Te),Pe.onDidChangeTunnels(Z,de,Ie)),registerPortAttributesProvider:(Z,de)=>((0,j.checkProposedApiEnabled)(Te),Pe.registerPortsAttributesProvider(Z,de)),registerTimelineProvider:(Z,de)=>((0,j.checkProposedApiEnabled)(Te),en.registerTimelineProvider(Z,de,Te.identifier,ht.converter)),get isTrusted(){return ot.trusted},requestWorkspaceTrust:Z=>((0,j.checkProposedApiEnabled)(Te),ot.requestWorkspaceTrust(Z)),onDidGrantWorkspaceTrust:(Z,de,Ie)=>ot.onDidGrantWorkspaceTrust(Z,de,Ie)},In={get inputBox(){return Ze.report("scm.inputBox",Te,"Use 'SourceControl.inputBox' instead"),Vt.getLastInputBox(Te)},createSourceControl(Z,de,Ie){return Vt.createSourceControl(Te,Z,de,Ie)}},Pn={createCommentController(Z,de){return vn.createCommentController(Te,Z,de)}},An={get activeDebugSession(){return mt.activeDebugSession},get activeDebugConsole(){return mt.activeDebugConsole},get breakpoints(){return mt.breakpoints},onDidStartDebugSession(Z,de,Ie){return mt.onDidStartDebugSession(Z,de,Ie)},onDidTerminateDebugSession(Z,de,Ie){return mt.onDidTerminateDebugSession(Z,de,Ie)},onDidChangeActiveDebugSession(Z,de,Ie){return mt.onDidChangeActiveDebugSession(Z,de,Ie)},onDidReceiveDebugSessionCustomEvent(Z,de,Ie){return mt.onDidReceiveDebugSessionCustomEvent(Z,de,Ie)},onDidChangeBreakpoints(Z,de,Ie){return mt.onDidChangeBreakpoints(Z,de,Ie)},registerDebugConfigurationProvider(Z,de,Ie){return mt.registerDebugConfigurationProvider(Z,de,Ie||A.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(Z,de){return mt.registerDebugAdapterDescriptorFactory(Te,Z,de)},registerDebugAdapterTrackerFactory(Z,de){return mt.registerDebugAdapterTrackerFactory(Z,de)},startDebugging(Z,de,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?mt.startDebugging(Z,de,{parentSession:Ie}):mt.startDebugging(Z,de,Ie||{})},stopDebugging(Z){return mt.stopDebugging(Z)},addBreakpoints(Z){return mt.addBreakpoints(Z)},removeBreakpoints(Z){return mt.removeBreakpoints(Z)},asDebugSourceUri(Z,de){return mt.asDebugSourceUri(Z,de)}},Tn={registerTaskProvider:(Z,de)=>Ct.registerTaskProvider(Te,Z,de),fetchTasks:Z=>Ct.fetchTasks(Z),executeTask:Z=>Ct.executeTask(Te,Z),get taskExecutions(){return Ct.taskExecutions},onDidStartTask:(Z,de,Ie)=>Ct.onDidStartTask(Z,de,Ie),onDidEndTask:(Z,de,Ie)=>Ct.onDidEndTask(Z,de,Ie),onDidStartTaskProcess:(Z,de,Ie)=>Ct.onDidStartTaskProcess(Z,de,Ie),onDidEndTaskProcess:(Z,de,Ie)=>Ct.onDidEndTaskProcess(Z,de,Ie)},Rn={async openNotebookDocument(Z,de){(0,j.checkProposedApiEnabled)(Te);let Ie;if(_.URI.isUri(Z))Ie=Z,await gt.openNotebookDocument(Z);else if(typeof Z=="string")Ie=_.URI.revive(await gt.createNotebookDocument({viewType:Z,content:de}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return(0,j.checkProposedApiEnabled)(Te),gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return(0,j.checkProposedApiEnabled)(Te),gt.onDidCloseNotebookDocument},get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Te),gt.onDidSaveNotebookDocument},get notebookDocuments(){return(0,j.checkProposedApiEnabled)(Te),gt.notebookDocuments.map(Z=>Z.apiNotebook)},registerNotebookSerializer(Z,de,Ie,st){return(0,j.checkProposedApiEnabled)(Te),gt.registerNotebookSerializer(Te,Z,de,Ie,Te.enableProposedApi?st:void 0)},registerNotebookContentProvider:(Z,de,Ie,st)=>((0,j.checkProposedApiEnabled)(Te),gt.registerNotebookContentProvider(Te,Z,de,Ie,Te.enableProposedApi?st:void 0)),registerNotebookCellStatusBarItemProvider:(Z,de)=>((0,j.checkProposedApiEnabled)(Te),gt.registerNotebookCellStatusBarItemProvider(Te,Z,de)),createNotebookEditorDecorationType(Z){return(0,j.checkProposedApiEnabled)(Te),gt.createNotebookEditorDecorationType(Z)},createRendererMessaging(Z){return(0,j.checkProposedApiEnabled)(Te),Jt.createRendererMessaging(Z)},onDidChangeNotebookDocumentMetadata(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookDocumentMetadata(Z,de,Ie)},onDidChangeNotebookCells(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookCells(Z,de,Ie)},onDidChangeNotebookCellExecutionState(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeNotebookCellExecutionState(Z,de,Ie)},onDidChangeCellOutputs(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeCellOutputs(Z,de,Ie)},onDidChangeCellMetadata(Z,de,Ie){return(0,j.checkProposedApiEnabled)(Te),gt.onDidChangeCellMetadata(Z,de,Ie)},createConcatTextDocument(Z,de){return(0,j.checkProposedApiEnabled)(Te),new We.ExtHostNotebookConcatDocument(gt,yt,Z,de)},createNotebookController(Z,de,Ie,st,wt){return(0,j.checkProposedApiEnabled)(Te),Yt.createNotebookController(Te,Z,de,Ie,st,wt)}};return{version:qe.version,authentication:Sn,commands:Dn,comments:Pn,debug:An,env:fn,extensions:Cn,languages:kn,notebook:Rn,scm:In,tasks:Tn,test:on,window:an,workspace:gn,Breakpoint:A.Breakpoint,CallHierarchyIncomingCall:A.CallHierarchyIncomingCall,CallHierarchyItem:A.CallHierarchyItem,CallHierarchyOutgoingCall:A.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:d.CandidatePortSource,CodeAction:A.CodeAction,CodeActionKind:A.CodeActionKind,CodeActionTriggerKind:A.CodeActionTriggerKind,CodeLens:A.CodeLens,Color:A.Color,ColorInformation:A.ColorInformation,ColorPresentation:A.ColorPresentation,ColorThemeKind:A.ColorThemeKind,CommentMode:A.CommentMode,CommentThreadCollapsibleState:A.CommentThreadCollapsibleState,CompletionItem:A.CompletionItem,CompletionItemKind:A.CompletionItemKind,CompletionItemTag:A.CompletionItemTag,CompletionList:A.CompletionList,CompletionTriggerKind:A.CompletionTriggerKind,ConfigurationTarget:A.ConfigurationTarget,CustomExecution:A.CustomExecution,DebugAdapterExecutable:A.DebugAdapterExecutable,DebugAdapterInlineImplementation:A.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:A.DebugAdapterNamedPipeServer,DebugAdapterServer:A.DebugAdapterServer,DebugConfigurationProviderTriggerKind:A.DebugConfigurationProviderTriggerKind,DebugConsoleMode:A.DebugConsoleMode,DecorationRangeBehavior:A.DecorationRangeBehavior,Diagnostic:A.Diagnostic,DiagnosticRelatedInformation:A.DiagnosticRelatedInformation,DiagnosticSeverity:A.DiagnosticSeverity,DiagnosticTag:A.DiagnosticTag,Disposable:A.Disposable,DocumentHighlight:A.DocumentHighlight,DocumentHighlightKind:A.DocumentHighlightKind,DocumentLink:A.DocumentLink,DocumentSymbol:A.DocumentSymbol,EndOfLine:A.EndOfLine,EnvironmentVariableMutatorType:A.EnvironmentVariableMutatorType,EvaluatableExpression:A.EvaluatableExpression,InlineValueText:A.InlineValueText,InlineValueVariableLookup:A.InlineValueVariableLookup,InlineValueEvaluatableExpression:A.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:A.InlineCompletionTriggerKind,EventEmitter:D.Emitter,ExtensionKind:A.ExtensionKind,ExtensionMode:A.ExtensionMode,ExternalUriOpenerPriority:A.ExternalUriOpenerPriority,FileChangeType:A.FileChangeType,FileDecoration:A.FileDecoration,FileSystemError:A.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:A.FoldingRange,FoldingRangeKind:A.FoldingRangeKind,FunctionBreakpoint:A.FunctionBreakpoint,InlineCompletionItem:A.InlineSuggestion,InlineCompletionList:A.InlineSuggestions,Hover:A.Hover,IndentAction:k.IndentAction,Location:A.Location,MarkdownString:A.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:A.ParameterInformation,PortAutoForwardAction:A.PortAutoForwardAction,Position:A.Position,ProcessExecution:A.ProcessExecution,ProgressLocation:A.ProgressLocation,QuickInputButtons:A.QuickInputButtons,Range:A.Range,RelativePattern:A.RelativePattern,Selection:A.Selection,SelectionRange:A.SelectionRange,SemanticTokens:A.SemanticTokens,SemanticTokensBuilder:A.SemanticTokensBuilder,SemanticTokensEdit:A.SemanticTokensEdit,SemanticTokensEdits:A.SemanticTokensEdits,SemanticTokensLegend:A.SemanticTokensLegend,ShellExecution:A.ShellExecution,ShellQuoting:A.ShellQuoting,SignatureHelp:A.SignatureHelp,SignatureHelpTriggerKind:A.SignatureHelpTriggerKind,SignatureInformation:A.SignatureInformation,SnippetString:A.SnippetString,SourceBreakpoint:A.SourceBreakpoint,StandardTokenType:A.StandardTokenType,StatusBarAlignment:A.StatusBarAlignment,SymbolInformation:A.SymbolInformation,SymbolKind:A.SymbolKind,SymbolTag:A.SymbolTag,Task:A.Task,TaskGroup:A.TaskGroup,TaskPanelKind:A.TaskPanelKind,TaskRevealKind:A.TaskRevealKind,TaskScope:A.TaskScope,TextDocumentSaveReason:A.TextDocumentSaveReason,TextEdit:A.TextEdit,TextEditorCursorStyle:S.TextEditorCursorStyle,TextEditorLineNumbersStyle:A.TextEditorLineNumbersStyle,TextEditorRevealType:A.TextEditorRevealType,TextEditorSelectionChangeKind:A.TextEditorSelectionChangeKind,ThemeColor:A.ThemeColor,ThemeIcon:A.ThemeIcon,TreeItem:A.TreeItem,TreeItemCollapsibleState:A.TreeItemCollapsibleState,UIKind:d.UIKind,Uri:_.URI,ViewColumn:A.ViewColumn,WorkspaceEdit:A.WorkspaceEdit,InlayHint:A.InlayHint,InlayHintKind:A.InlayHintKind,RemoteAuthorityResolverError:A.RemoteAuthorityResolverError,ResolvedAuthority:A.ResolvedAuthority,SourceControlInputBoxValidationType:A.SourceControlInputBoxValidationType,ExtensionRuntime:A.ExtensionRuntime,TimelineItem:A.TimelineItem,NotebookRange:A.NotebookRange,NotebookCellKind:A.NotebookCellKind,NotebookCellExecutionState:A.NotebookCellExecutionState,NotebookDocumentMetadata:A.NotebookDocumentMetadata,NotebookCellMetadata:A.NotebookCellMetadata,NotebookCellData:A.NotebookCellData,NotebookData:A.NotebookData,NotebookRendererScript:A.NotebookRendererScript,NotebookCellStatusBarAlignment:A.NotebookCellStatusBarAlignment,NotebookEditorRevealType:A.NotebookEditorRevealType,NotebookCellOutput:A.NotebookCellOutput,NotebookCellOutputItem:A.NotebookCellOutputItem,NotebookCellStatusBarItem:A.NotebookCellStatusBarItem,NotebookControllerAffinity:A.NotebookControllerAffinity,PortAttributes:A.PortAttributes,LinkedEditingRanges:A.LinkedEditingRanges,TestItemStatus:A.TestItemStatus,TestResultState:A.TestResultState,TestMessage:A.TestMessage,TextSearchCompleteMessageType:J.TextSearchCompleteMessageType,TestMessageSeverity:A.TestMessageSeverity,WorkspaceTrustState:A.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=Ne}),define(be[228],_e([0,1,62,102,30,101,33,76,39,40,105,106,107,79,78,71,75,103,77,49,74,95,69]),function(X,e,p,R,D,T,_,S,E,k,i,I,d,g,o,a,w,f,y,l,m,h,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(g.IExtensionStoragePaths,g.ExtensionStoragePaths),(0,p.registerSingleton)(w.IExtHostApiDeprecationService,w.ExtHostApiDeprecationService),(0,p.registerSingleton)(S.IExtHostCommands,S.ExtHostCommands),(0,p.registerSingleton)(_.IExtHostConfiguration,_.ExtHostConfiguration),(0,p.registerSingleton)(y.IExtHostConsumerFileSystem,y.ExtHostConsumerFileSystem),(0,p.registerSingleton)(I.IExtHostDebugService,I.WorkerExtHostDebugService),(0,p.registerSingleton)(T.IExtHostDecorations,T.ExtHostDecorations),(0,p.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,p.registerSingleton)(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo),(0,p.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService),(0,p.registerSingleton)(d.IExtHostSearch,d.ExtHostSearch),(0,p.registerSingleton)(o.IExtHostStorage,o.ExtHostStorage),(0,p.registerSingleton)(i.IExtHostTask,i.WorkerExtHostTask),(0,p.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,p.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,p.registerSingleton)(f.IExtHostWindow,f.ExtHostWindow),(0,p.registerSingleton)(D.IExtHostWorkspace,D.ExtHostWorkspace),(0,p.registerSingleton)(m.IExtHostSecretState,m.ExtHostSecretState),(0,p.registerSingleton)(h.IExtHostTelemetry,h.ExtHostTelemetry),(0,p.registerSingleton)(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(be[229],_e([0,1,227,34,223,7,11,5]),function(X,e,p,R,D,T,_,S){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(o){var a;const w=(a=self.trustedTypes)===null||a===void 0?void 0:a.createPolicy("TrustedFunctionWorkaround",{createScript:(y,...l)=>{l.forEach(n=>{var r;if(!((r=self.trustedTypes)===null||r===void 0?void 0:r.isScript(n)))throw new Error("TrustedScripts only, please")});const m=l.slice(0,-1).join(","),h=l.pop().toString();return`(function anonymous(${m}) {
${h}
})`}});function f(...y){return w?self.eval(w.createScript("",...y)):new Function(...y)}o.create=f})(k||(k={}));class i extends D.RequireInterceptor{_installInterceptor(){}getModule(a,w){for(let f of this._alternatives){let y=f(a);if(y){a=y;break}}if(this._factories.has(a))return this._factories.get(a).load(a,w,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends R.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=T.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const a=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);g(a,this._initData.environment.isExtensionDevelopmentDebug);const w=this._instaService.invokeFunction(p.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(i,w,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(a){return a.browser}async _loadCommonJSModule(a,w,f){var y,l,m,h,t,n,r,s;w=w.with({path:d(w.path,".js")}),a&&performance.mark(`code/extHost/willFetchExtensionCode/${a.value}`);const u=await fetch(w.toString(!0));if(a&&performance.mark(`code/extHost/didFetchExtensionCode/${a.value}`),u.status!==200)throw new Error(u.statusText);const v=await u.text(),b=`${w.toString(!0)}#vscode-extension`,P=`${v}
//# sourceURL=${b}`;let C;try{C=k.create((l=(y=I._ttpExtensionScripts)===null||y===void 0?void 0:y.createScript("module"))!==null&&l!==void 0?l:"module",(h=(m=I._ttpExtensionScripts)===null||m===void 0?void 0:m.createScript("exports"))!==null&&h!==void 0?h:"exports",(n=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&n!==void 0?n:"require",(s=(r=I._ttpExtensionScripts)===null||r===void 0?void 0:r.createScript(P))!==null&&s!==void 0?s:P)}catch(z){throw console.error(a?`Loading code for extension ${a.value} failed: ${z.message}`:`Loading code failed: ${z.message}`),console.error(`${w.toString(!0)}${typeof z.line=="number"?` line ${z.line}`:""}${typeof z.column=="number"?` column ${z.column}`:""}`),console.error(z),z}const c={},F={exports:c},N=z=>{const he=this._fakeModules.getModule(z,w);if(he===void 0)throw new Error(`Cannot load module '${z}'`);return he};try{return f.codeLoadingStart(),a&&performance.mark(`code/extHost/willLoadExtensionCode/${a.value}`),C(F,c,N),F.exports!==c?F.exports:c}finally{a&&performance.mark(`code/extHost/didLoadExtensionCode/${a.value}`),f.codeLoadingStop()}}async $setRemoteEnvironment(a){throw new Error("Not supported")}async _waitForDebuggerAttachment(a=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const w=Date.now()+a;for(;Date.now()<w&&!("__jsDebugIsReady"in globalThis);)await(0,_.timeout)(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(E=self.trustedTypes)===null||E===void 0?void 0:E.createPolicy("ExtensionScripts",{createScript:o=>o});function d(o,a){return o.endsWith(a)?o:o+a}function g(o,a){w("info","log"),w("log","log"),w("warn","warn"),w("error","error");function w(l,m){const h=console[l];console[l]=function(){o.$logExtensionHostMessage({type:"__$console",severity:m,arguments:y(arguments)}),a&&h.apply(console,arguments)}}const f=1e5;function y(l){const m=[],h=[];if(l.length)for(let t=0;t<l.length;t++){if(typeof l[t]=="undefined")l[t]="undefined";else if(l[t]instanceof Error){const n=l[t];n.stack?l[t]=n.stack:l[t]=n.toString()}h.push(l[t])}try{const t=JSON.stringify(h,function(n,r){if(r&&typeof r=="object"){if(m.indexOf(r)!==-1)return"[Circular]";m.push(r)}return r});return t.length>f?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(be[230],_e([0,1,62,17,34,229,215]),function(X,e,p,R,D,T,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,p.registerSingleton)(D.IExtHostExtensionService,T.ExtHostExtensionService),(0,p.registerSingleton)(R.ILogService,_.ExtHostLogService)}),define(be[232],_e([0,1,25,3,185,224,217,12,80,228,230]),function(X,e,p,R,D,T,_,S,E){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0});const i=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const w=(k=self.trustedTypes)===null||k===void 0?void 0:k.createPolicy("extensionHostWorker",{createScriptURL:y=>y}),f=self.Worker;Worker=function(y,l){const m=`importScripts('${y}');`;l=l||{},l.name=l.name||S.basename(y.toString());const h=new Blob([m],{type:"application/javascript"}),t=URL.createObjectURL(h);return new f(w?w.createScriptURL(t):t,l)}}else self.Worker=class extends _.NestedWorker{constructor(w,f){super(I,w,Object.assign({name:S.basename(w.toString())},f))}};const d=new class{exit(w){i()}async exists(w){return!0}async realpath(w){return w}};class g{constructor(){const f=new MessageChannel,y=new R.Emitter;let l=!1;I(f.port2,[f.port2]),f.port1.onmessage=m=>{const{data:h}=m;if(!(h instanceof ArrayBuffer)){console.warn("UNKNOWN data received",h);return}const t=p.VSBuffer.wrap(new Uint8Array(h,0,h.byteLength));if((0,D.isMessageOfType)(t,2)){l=!0,a("received terminate message from renderer");return}y.fire(t)},this.protocol={onMessage:y.event,send:m=>{if(!l){const h=m.buffer.buffer.slice(m.buffer.byteOffset,m.buffer.byteOffset+m.buffer.byteLength);f.port1.postMessage(h,[h])}}}}}function o(w){return new Promise(f=>{const y=w.onMessage(l=>{y.dispose();const m=JSON.parse(l.toString());w.send((0,D.createMessageOfType)(0)),f({protocol:w,initData:m})});w.send((0,D.createMessageOfType)(1))})}let a=w=>i();(function(){const f=new g;E.mark("code/extHost/willConnectToRenderer"),o(f.protocol).then(y=>{E.mark("code/extHost/didWaitForInitData");const l=new T.ExtensionHostMain(y.protocol,y.initData,d,null);a=m=>l.terminate(m)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/541a5d4fa70ab3095f23b28b88914e1f6a8f65c4/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
